/*
FROM: BalticOI 1995 day 1
PROB: cur (currency table)
KEYW: floid
*/

#include <cstdio>

const int MAXN = 1 << 5;
const double EPS = 1e-6;
int N;
double ma3x[MAXN][MAXN];

int main () {
	scanf ("%d", &N);

	int i, j, k;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			scanf ("%lf", ma3x[i] + j);

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			if (i == j) ma3x[i][i] = 1;
			else if (ma3x[i][j] > EPS && ma3x[j][i] < EPS)
				ma3x[j][i] = 1. / ma3x[i][j];

	for (k = 0; k < N; ++k)
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j)
				if (ma3x[i][j] < EPS && ma3x[i][k] * ma3x[k][j] > EPS)
					ma3x[i][j] = ma3x[i][k] * ma3x[k][j];

	for (i = 0; i < N; ++i) {
		printf ("%.2lf", ma3x[i][0]);
		for (j = 1; j < N; ++j)
			printf (" %.2lf", ma3x[i][j]);
		printf ("\n");
	}

	return 0;
}
