/*
FROM: BalticOI 1995 day 1
PROB: expr
KEYW: expression calculation
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cctype>
#include <climits>

#include <vector>
#include <utility>

std::vector <std::pair <int, std::vector <int> > > terms;

const int MAXLEN = 1 << 6;
const int MAXVAR = 8;
char line[MAXLEN];
int var[MAXVAR];

void push (std::pair <int, std::vector <int> > &a) {
	unsigned i;
	for (i = 0; i < terms.size () && terms[i].second != a.second; ++i);
	if (i < terms.size ())
		terms[i].first += a.first;
	else
		terms.push_back (a);
}

int main () {
	gets (line);
	for (int i = 0; i < MAXVAR; ++i) var[i] = INT_MAX;
	char _var;
	int val;
	while (scanf ("%c=%d\n", &_var, &val) == 2)
		if (_var >= 'a' && _var <= 'h') {
			var[_var - 'a'] = val;
//			printf ("scanned %c=%d\n", _var, val);
		}

	std::pair <int, std::vector <int> > cterm (line[0] == '-' ? -1 : 1, std::vector <int> (26, 0));
	bool dst = 0;
	int dig = 0;
	for (int i = (line[0] == '+' || line[0] == '-'); line[i]; ++i) {
		if (isdigit (line[i])) {
			if (dst) {
				dig *= 10;
				dig += line[i] - '0';
			} else {
				dst = 1;
				dig = line[i] - '0';
			}
		} else if (isalpha (line[i])) {
			if (dst) {
				cterm.first *= dig;
				dst = 0;
			}
			if (var[line[i] - 'a'] != INT_MAX) {
				cterm.first *= var[line[i] - 'a'];
			} else {
				++cterm.second[line[i] - 'a'];
			}
		} else {
//			if (line[i] != '+' && line[i] != '-') continue;
			assert (line[i] == '+' || line[i] == '-');
			if (dst) {cterm.first *= dig; dst = 0;}
			push (cterm);
//			printf ("char # %d --- %d\n", i, crnt);
			cterm = std::make_pair (line[i] == '+' ? 1 : -1, std::vector <int> (26, 0));
//			printf ("now sum == %d\n", sum);
		}
	}
	if (dst == 1) cterm.first *= dig;
	push (cterm);
	int res = 0;
	for (unsigned i = 0; i < terms.size (); ++i)
		if (terms[i].first != 0) {
			if (terms[i].second != std::vector <int> (26, 0)) {
				printf ("UNDEFINED\n");
				exit (0);
			} else {
				//assert (res == INT_MAX);
				res = terms[i].first;
			}
		}

//	printf ("crnt == %d\n", crnt);
	printf ("%d\n", res);

	return 0;
}
