/*
FROM: BalticOI 1995 day 2
PROB: ite
KEYW: full exhaustion, dfs, parcing input
*/

#include <cstdio>
#include <cstring>

#include <iostream>
#include <string>
#include <algorithm>

const int MAXLEN = 1 << 7;
const int MAXLINES = 1 << 5;
const int MAXVAR = 1 << 5;

struct el {
	int ln;
	int a, b;
	int p, q;
	el () {}
	el (int a) : ln (a) {}
	bool operator < (const el &a) const {return ln < a.ln;}
};

int L;
el code[MAXLINES];
int ic[MAXLINES], ica;
int iref[MAXLINES];
bool used[MAXLINES];
int arc;
int ar[MAXLINES];
//char line[MAXLEN];

bool used_var[MAXVAR];
int val[MAXVAR];
int gr[MAXVAR][MAXVAR];
int cc;//current 'colour'

void dfs (int a) {
	val[a] = cc;
//	printf ("dfs %d(%d)\n", a, cc);
	for (int i = 1; i <= gr[a][0]; ++i)
		if (!val[gr[a][i]])
			dfs (gr[a][i]);
}

int __cntr;
bool test (int a) {
	++__cntr;
//	printf ("test %d\n", a);
	int i;
	//reset
	memset (val, 0, sizeof (val));
	for (i = 0; i < MAXVAR; ++i) gr[i][0] = 0;
	cc = 1;
	for (i = 0; i < ica; ++i) {
		if ((1 << i) & a) {
			gr[code[iref[i]].a][++gr[code[iref[i]].a][0]] = code[iref[i]].b;
			gr[code[iref[i]].b][++gr[code[iref[i]].b][0]] = code[iref[i]].a;
		}
	}
/*
	for (i = 0; i < MAXVAR; ++i) {
		if (!gr[i][0]) continue;
		printf ("%c ->", i + 'a');
		for (int j = 1; j <= gr[i][0]; ++j)
			printf (" %c", gr[i][j] + 'a');
		printf ("\n");
	}
*/
	for (i = 0; i < MAXVAR; ++i)
		if (used_var[i] && !val[i]) {
			dfs (i);
			++cc;
		}

	for (i = 0; i < ica; ++i)
		if (!((1 << i) & a)) {
//			printf ("check on if %d --", i);
//			printf ("%d %d\n", val[code[iref[i]].a], val[code[iref[i]].b]);
			if (val[code[iref[i]].a] == val[code[iref[i]].b]) {
//				printf ("return 0!!\n");
				return 0;
			}
		}
//	printf ("return 1\n");
	return 1;
}

void prnt () {
	int i;
	for (i = 0; i < MAXVAR && !used_var[i]; ++i);
	if (i == MAXVAR) {printf ("no variables\n"); return;}
	printf ("%c=%d", i + 'a', val[i]);
	for (++i; i < MAXVAR; ++i)
		if (used_var[i])
			printf (",%c=%d", i + 'a', val[i]);
	printf ("\n");
}

void show (std::string s) {
	for (int i = 0; i < (int)s.size (); ++i)
		printf (" <%c(%d)> ", s[i], (int)s[i]);
	printf("\n");
}

int main () {
	int i, j;
	char t1, t2;
	std::string str;
	for (i = 0;; ++i) {
		std::getline (std::cin, str);
//		std::cout << '*' << str << '*' << '\n';
//		show (str);
//		str = str.substr (0, str.size () - 1);
//		show (str);
		if (str == "") break;
		if (str[str.size () - 1] == ')') {//return
			sscanf (str.c_str (), "%d RETURN(%d)", &code[i].ln, &code[i].a);
			code[i].b = -1;//this means return
		} else {
			sscanf (str.c_str (), "%d IF %c=%c THEN %d ELSE %d", &code[i].ln, &t1, &t2, &code[i].p, &code[i].q);
			code[i].a = t1 - 'a'; used_var[code[i].a] = 1;
			code[i].b = t2 - 'a'; used_var[code[i].b] = 1;
		}
	}
	L = i;

	std::sort (code, code + L);

	for (i = 0; i < L; ++i) {
		if (code[i].b == -1) continue;
		code[i].p = std::lower_bound (code, code + L, el (code[i].p)) - code;
		code[i].q = std::lower_bound (code, code + L, el (code[i].q)) - code;
		ic[i] = ica;
		iref[ica++] = i;
	}
/*
	for (i = 0; i < L; ++i) {
		printf ("%d - %d %d %d %d", code[i].ln, code[i].a, code[i].b, code[i].p, code[i].q);
		if (code[i].b != -1) printf ("(%d)", ic[i]);
		printf ("\n");
	}
*/
	int ub = 1 << ica;
	bool in_cycle = 0;
	for (i = 0; i < ub; ++i) {
//		printf ("i == %d(%d)\n", i, ub);
		memset (used, 0, sizeof (used));
		int cl = 0;
		while (!used[cl] && code[cl].b != -1) {
			used[cl] = 1;
			cl = (1 << ic[cl]) & i ? code[cl].p : code[cl].q;
		}
		if (used[cl] == 1) {
			if (!in_cycle) {
				if (test (i)) {
					in_cycle = 1;
					prnt ();
				}
			}
			continue;
		}

		for (j = 0; j < arc && ar[j] != code[cl].a; ++j);
		if (j != arc) continue;
		if (test (i)) {
			ar[arc++] = code[cl].a;
			printf ("%d:\n", code[cl].a);
			prnt ();
		}
	}
//	fprintf (stderr, "test -- %d, ub -- %d(%d)\n", __cntr, ub, ica);

	return 0;
}
