/*
FROM: BalticOI 1995 day 1
PROB: prim (double prime numbers)
KEYW: eratosten grid, prime numbers
*/

#include <cstdio>

const int MAXN = 1 << 20;
const int MAXPR = 1 << 17;
bool grid[MAXN];
int pp;
int pr[MAXPR];
int bp;
long long b[MAXPR / 2];
int cp;
long long c[1 << 8];

bool is_prime (long long a) {
	for (int i = 0; (long long)pr[i] * pr[i] <= a; ++i)
		if (a % pr[i] == 0) return 0;
	return 1;
}

long long glue (int a, int b) {
//	printf ("glue %d %d -- ", a, b);
	int bb = b;
	long long res = a;
	while (b) {
		res *= 10;
		b /= 10;
	}
	res += bb;
//	printf ("%Ld\n", res);
//	getchar ();
	return res;
}

int main () {
	int i, j;
	for (i = 2; i < 1000; ++i)
		if (!grid[i]) {
			pr[pp++] = i;
			for (j = i * i; j < MAXN; j += i)
				grid[j] = 1;
		}

	for (; i < MAXN; ++i)
		if (!grid[i])
			pr[pp++] = i;

/*	printf ("%d\n", pp);
	for (i = 0; i < 20; ++i)
		printf ("%d -> %d\n", i, pr[i]);
*/
	for (i = 0; i < (pp >> 1); ++i)
		b[i] = glue (pr[i<<1], pr[(i<<1)+1]);

	int bp = (pp >> 1);
	for (i = 0; i < bp && cp < 151; ++i)
		if ((b[i] < MAXN && !grid[b[i]]) || is_prime (b[i])) {
			c[cp++] = b[i];
//			printf ("%d %Ld\n", cp-1, b[i]);
		}

//	printf ("%d %Ld\n", cp, c[cp-1]);
	int id;
	scanf ("%d", &id);
	printf ("%Ld\n", c[id-1]);

	return 0;
}
