/*
FROM: BalticOI 1996 day 2
PROB: barr (the filling of barrels)
KEYW: dfs
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cmath>

const int MAXN = 1 << 7;
const int MAXLEN = 1 << 7;
const double CAPACITY = 100.;
const double EPS = 1e-9;

int N;
bool ma3x[MAXN][MAXN];
bool used[MAXN];
double bar[MAXN];
int vis[MAXN], vp;

void dfs (int a) {
	used[a] = 1;
	vis[vp++] = a;
//	printf ("dfs %d\n", a);
	for (int i = 0; i < N; ++i)
		if (ma3x[a][i] && !used[i])
			dfs (i);
}

int main () {
	int K;
	scanf ("%d %d\n", &N, &K);

	int i;
	int a, b, t1;
	double each;
	static char line[MAXLEN];
	for (i = 0; i < K; ++i) {
		gets (line);
		if (line[0] == 'V') {
			sscanf (line + 2, "%d %d", &a, &b);
			--a; --b;
//			printf ("V %d %d!!\n", a, b);
			if (!ma3x[a][b] && fabs (bar[a] - bar[b]) > EPS) {
				vp = 0;
				//memset (used, 0, sizeof (used));
				for (int j = 0; j < N; ++j) used[j] = 0;
				dfs (a);
				t1 = vp;
				assert (!used[b]);
				dfs (b);
				each = (t1 * bar[a] + (vp - t1) * bar[b]) / vp;

//				for (int j = 0; j < vp; ++j) printf (" %d", vis[j]); printf (" -- %.2lf\n", each);
				for (int j = 0; j < vp; ++j) bar[vis[j]] = each;
			}
			ma3x[a][b] = ma3x[b][a] = !ma3x[a][b];//swich the value
//			printf ("ma3x[a][b] == ma3x[b][a] == %d %d\n", ma3x[a][b], ma3x[b][a]);
		} else {//line[0] == 'P'
			sscanf (line + 2, "%d %d", &a, &b);
			--a;
//			printf ("P %d %d!!\n", a, b);
			vp = 0;
			//memset (used, 0, sizeof (used));
			for (int j = 0; j < N; ++j) used[j] = 0;
			dfs (a);

//			for (int j = 0; j < vp; ++j) printf (" %d", vis[j]); printf ("\n");
//			printf ("%d / %d\n", b, vp);
			each = (double)b / (double)vp;
			if (each + bar[a] > CAPACITY + EPS) {
				printf ("OVERFLOW %d\n", i + 1);
				exit (0);
			}
			for (int j = 0; j < vp; ++j) bar[vis[j]] += each;
		}
	}

	double minbr = CAPACITY + EPS, maxbr = -1;
	for (i = 0; i < N; ++i) {
		minbr <?= bar[i];
		maxbr >?= bar[i];
	}

	printf ("OK %.2lf %.2lf\n", minbr, maxbr);

	return 0;
}
