/*
FROM: BalticOI 1996 day 2
PROB: journ (a fast journey)
KEYW: modyfied dijikstra with stl heap
*/

#include <cstdio>
#include <queue>

const int MAXN = 1 << 7;
const int MAXM = 1 << 11;

inline int op (int a) {return a ^ 1;}

struct el {
	int to;
	int dst;
	int next;
	el () {}
	el (int _to, int _dst, int _next) : to (_to), dst (_dst), next (_next) {}
};

struct heap {
	int aid;
	int time;
	bool rm;
	heap () {}
	heap (int _aid, int _time, bool _rm) : aid (_aid), time (_time), rm (_rm) {}
	bool operator < (const heap &a) const {return time > a.time;}
};

int start, finish;
int N, M;
int vec[MAXN];
el buf[MAXM];

std::priority_queue <heap> h;
int prev[MAXN];
//int bt[MAXN];

int dijkstra () {
	h.push (heap (M*2, 0, 1));

	heap crnt;
	int to;
	while (!h.empty ()) {
		crnt = h.top (); h.pop ();
//		printf ("%d(%d) %d(%d %d) %d\n", crnt.aid, buf[crnt.aid].to, crnt.time, crnt.time >> 4, crnt.time & 15, crnt.rm);
		to = buf[crnt.aid].to;
		if (prev[to] == -1) {
//			printf ("new!\n");
			prev[to] = crnt.aid;
//			bt[to] = crnt.time;
			if (to == finish) {
//				printf ("time %d\n", crnt.time);
				return crnt.time;
			}

			h.push (heap (crnt.aid, (((crnt.time >> 4) + 1) << 4), 0));
			h.push (heap (crnt.aid, (((crnt.time >> 4) + 2) << 4), 0));
		} else if (crnt.rm)//this is obsolete
			continue;

//		printf ("gogogo!\n");

		for (int i = vec[to]; i != -1; i = buf[i].next) {
			if (((crnt.time >> 4) & 1) == (i & 1) && prev[buf[i].to] == -1 && (crnt.time & 15) + buf[i].dst <= 12) {
//				printf ("push in %d(%d) %d(%d %d) %d\n", i, buf[i].to, ((crnt.time >> 4) << 4) | ((crnt.time & 15) + buf[i].dst), crnt.time >> 4, ((crnt.time & 15) + buf[i].dst), 1);
				h.push (heap (i, ((crnt.time >> 4) << 4) | ((crnt.time & 15) + buf[i].dst), 1));
			}
		}
	}
	return -1;
}

int main () {
	scanf ("%d %d", &start, &finish);
	--start, --finish;
	scanf ("%d %d", &N, &M);

	int i;
	int a, b, d;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", &a, &b, &d);
		--a; --b;

		buf[i*2] = el (b, d, vec[a]);
		vec[a] = i*2;

		buf[i*2+1] = el (a, d, vec[b]);
		vec[b] = i*2+1;
	}

	buf[M*2] = el (start, 0, -1);

	for (i = 0; i < N; ++i) prev[i] = -1;

	int cday = dijkstra (); if (cday == -1) {printf ("NO WAY\n"); exit (0);}
	int ch = cday & 15; cday >>= 4;
	int cpos = finish;

	static char ans[MAXN][1 <<10];
	int ap = 0;
	while (cpos != start) {
		if ((cday & 1) != (prev[cpos] & 1)) {
			--cday;
			ch = 12;
		} else if (buf[prev[cpos]].dst > ch) {
			cday -= 2;
			ch = 12;
		}
		sprintf (ans[ap++], "%d %d %d %d\n", buf[op (prev[cpos])].to + 1, cpos + 1, cday + 1, buf[prev[cpos]].dst);
		ch -= buf[prev[cpos]].dst;
		cpos = buf[op (prev[cpos])].to;
	}

	for (i = ap-1; i >= 0; --i)
		printf ("%s", ans[i]);

	return 0;
}
