/*
FROM: BalticOI 1996 day 2
PROB: nbg (a number game)
KEYW: acyclic game
*/

#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cassert>

const int MAXM = 20;
const int MAXLEN = 1 << 4;
const int MAXS = 1 << MAXM;

int N, M, S;
bool dp[MAXS];
bool done[MAXS];

bool dpf (int a) {
	if (done[a]) return dp[a];
	int n = N;
	int i;
	for (i = 0; i < M; ++i)
		if (a & (1 << i))
			n -= i + 1;
	for (i = 0; i < (M <? n); ++i) {
		if (a & (1 << i)) continue;
		if (!dpf (a | (1 << i)))
			dp[a] = 1;
	}

	done[a] = 1;
	return dp[a];
}

char *dowin (int a) {
	static char line[MAXLEN];
	sprintf (line, "%d winning\n", a);
	return line;
}

int main (int argc, char *argv[]) {
	assert (argc == 4);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
//	FILE *sol = fopen (argv[3], "r");

	assert (in);
	if (!out) {
		printf ("0\nMissing output file!\n");
		exit (0);
	}

	fscanf (in, "%d %d", &N, &M);
	if (M > N) M = N;
	S = 1 << M;

	dpf (0);

	int i;
	int a, b;
	int len;
	char line[MAXLEN];
	fgets (line, MAXLEN, out);
	len = strlen (line);
	if (line[len-1] != '\n') {printf ("0\nSth wrong with the first line (too long)\n"); exit (0);}
	if (strcmp (line + 1, " wins\n") != 0) {printf ("0\nwrong syntax of first line (\"A/B wins\")\n"); exit (0);}
	if (line[0] != 'B' - dp[0]) {printf ("0\nWrong win person - should be %c\n", 'B' - dp[0]); exit (0);}

	for (i = 1; i <= M; ++i) {
		fgets (line, MAXLEN, out);
		len = strlen (line);
		if (line[len-1] != '\n') {printf ("0\nline %d too long!\n", i + 1); exit (0);}
		if (sscanf (line, "%d", &a) != 1) {printf ("0\nSth wrong on line %d\n", i + 1); exit (0);}
		if (a != i) {printf ("0\nOn line %d expected %d move - got %d\n", i + 1, i, a); exit (0);}
		if (dp[(1 << (i-1))]) {//B wins
			if (sscanf (line, "%d %d", &a, &b) != 2) {printf ("0\nSth wrong on line %d\n", i + 1); exit (0);}
			if (b > N - a || b > M || b < 1 || b == a) {printf ("0\nIllegal move of B's side - line %d\n", i + 1); exit (0);}
			if (dp[(1 << (a-1)) | (1 << (b-1))]) {printf ("0\nB does not win after his 'winning' move - line %d\n", i + 1); exit (0);}
		} else {//A wins
			if (strcmp (line, dowin (i)) != 0) {printf ("0\nSth wrong on line %d\n", i + 1); exit (0);}
		}
	}

	printf ("10\nCorrect\n");

	return 0;
}
