/*
FROM: BalticOI 1996 day 1
PROB: square
KEYW: writing
*/

#include <cstdio>
#include <cassert>
#include <cmath>

const double EPS = 1e-9;

double xx1, yy1, xx2, yy2;
double r;

double g (double b) {
	double a = sqrt (r * r - b * b);
//	printf ("a, b   %lf %lf, rr %lf, atan2 %lf, ab/2 %lf, all = %lf\n", a, b, r * r, atan2 (a, b), a * b / 4, r * r * atan2 (a, b) / 2. - a * b / 2.);
	return (r * r * atan2 (a, b) - a * b) / 2.;
}

void mark_in (double xx1, double yy1, double xx2, double yy2, bool *m) {
	m[0] = xx1 > EPS && yy1 > EPS && hypot (xx1, yy1) < r + EPS;
	m[1] = xx1 > EPS && yy2 > EPS && hypot (xx1, yy2) < r + EPS;
	m[2] = xx2 > EPS && yy2 > EPS && hypot (xx2, yy2) < r + EPS;
	m[3] = xx2 > EPS && yy1 > EPS && hypot (xx2, yy1) < r + EPS;
}

int main () {
	double a, b, c, d;
	scanf ("%lf%lf%lf%lf", &a, &b, &c, &d);

	if (a < c)
		xx1 = a, xx2 = c;
	else
		xx1 = c, xx2 = a;

	if (b < d)
		yy1 = b, yy2 = d;
	else
		yy1 = d, yy2 = b;

	scanf ("%lf%lf%lf", &a, &b, &r);
	xx1 -= a; xx2 -= a;
	yy1 -= b; yy2 -= b;

//	printf ("%lf %lf %lf %lf\n", xx1, yy1, xx2, yy2);
//	printf ("%lf\n", r);

//	printf ("----%lf %lf\n", g (0), g (r));

	double sum = 0;
	double _sum = 0;
	bool m[4];
	int cnt;
	double all = r * r * M_PI / 4.;
	for (int i = 0; i < 4; ++i) {
		sum = 0;
//		printf ("%lf %lf %lf %lf\n", xx1, xx2, yy1, yy2);

		mark_in (xx1, yy1, xx2, yy2, m);
		cnt = 0;
		for (int j = 0; j < 4; ++j) cnt += m[j];
//		printf ("cnt == %d\n", cnt);
		if (cnt == 4) {
			sum += (xx2 - xx1) * (yy2 - yy1);
		} else if (cnt == 3) {
			assert (!m[2]);
			double p1 = g (yy2);
			double p2 = g (xx2);
			sum += all - p1 - p2 - xx2 * yy1 - (yy2 - yy1) * xx1;
		} else if (cnt == 2) {
			if (m[1] && m[2]) {
				sum += yy2 * (xx2 - xx1);
			} else if (m[2] && m[3]) {
				sum += xx2 * (yy2 - yy1);
			} else if (m[0] && m[1]) {
				sum += g (yy1) - g (yy2) - xx1 * (yy2 - yy1);
			} else {//m[0] && m[3]
				assert (m[0] && m[3]);
				sum += g (xx1) - g (xx2) - yy1 * (xx2 - xx1);
			}
		} else if (cnt == 1) {
			if (m[0]) {
				sum += g (xx1) + g (yy1) + xx1 * yy1 - all;
			} else if (m[1]) {
				sum += all - g (yy2) - xx1 * yy2 - g (r <? xx2);
			} else if (m[2]) {
				sum += xx2 * yy2;
			} else {//m[3]
				sum += all - g (xx2) - xx2 * yy1 - g (r <? yy2);
			}
		} else {
			if (xx1 < EPS && yy1 < EPS) {
				if (xx2 > 0 && yy2 > 0) {
					sum = all;
					sum -= g (r <? xx2);
					sum -= g (r <? yy2);
				}
			} else if (xx1 < EPS && yy1 > 0) {
				sum += g (r <? yy1) - g (r <? yy2);
			} else if (xx1 > 0 && yy1 < EPS) {
				sum += g (r <? xx1) - g (r <? xx2);
			}
		}

	//	printf ("sum == %lf\n", sum);
		_sum += sum;
		///turn 90 grad
		a = yy1; b = yy2; c = -xx2; d = -xx1;
		xx1 = a; xx2 = b; yy1 = c; yy2 = d;

//		puts ("");
	}


	sum = _sum;
	printf ("%.2lf\n", sum);

	return 0;
}
