/*
FROM: BalticOI 1997 day 2
PROB: age (ancient chronicles)
KEYW: bfs
*/

#include <cstdio>
#include <vector>

const int MAXN = 1 << 10;

struct el {
	int to;
	char type;
	el () {}
	el (int _to, char _type) : to (_to), type (_type) {}
};

const int N = 26 * 26;
int M;

std::vector <el> vec[MAXN];

char bfs (int a, int b) {
	static el queue[MAXN], c;
	static bool used[MAXN];
	static int p3;
	static int i;
	static unsigned j;

	memset (used, 0, sizeof (used));
	p3 = 0;
	queue[p3++] = el (a, 0);
	used[a] = 1;

//	printf ("bfs %d %d\n", a, b);
	for (i = 0; i < p3; ++i) {
		c = queue[i];
//		printf ("popped %d %d\n", c.to, (int)c.type);
		if (c.to == b) return !c.type ? '=' : c.type == 1 ? '<' : '>';
		if (c.type) {
			for (j = 0; j < vec[c.to].size (); ++j) {
//				printf ("! -- go to %d (%d)\n", vec[c.to][j].to, (int)vec[c.to][j].type);
				if (!used[vec[c.to][j].to] && vec[c.to][j].type != 3 - c.type) {
					used[vec[c.to][j].to] = 1;
					queue[p3++] = el (vec[c.to][j].to, c.type);
				}
			}
		} else {
			for (j = 0; j < vec[c.to].size (); ++j) {
//				printf ("!! -- go to %d (%d)\n", vec[c.to][j].to, (int)vec[c.to][j].type);
				if (!used[vec[c.to][j].to]) {
					used[vec[c.to][j].to] = 1;
					queue[p3++] = el (vec[c.to][j].to, vec[c.to][j].type);
				}
			}
		}
	}

	return '?';
}

int main () {
	scanf ("%d\n", &M);
	int i;
	int a, b, t;
	static char line[8];
	for (i = 0; i < M; ++i) {
		fgets (line, 8, stdin);
		a = (line[0] - 'A') * 26 + line[1] - 'A';
//		printf ("%c%c -- %d\n", line[0], line[1], a);
		b = (line[3] - 'A') * 26 + line[4] - 'A';
//		printf ("%c%c -- %d\n", line[3], line[4], b);
		t = line[2] == '=' ? 0 : line[2] == '<' ? 1 : 2;
		vec[a].push_back (el (b, t));
		vec[b].push_back (el (a, t ? 3 - t : 0));
	}

	int qc;
	scanf ("%d\n", &qc);
	for (i = 0; i < qc; ++i) {
		fgets (line, 8, stdin);
		a = (line[0] - 'A') * 26 + line[1] - 'A';
//		printf ("%c%c -- %d\n", line[0], line[1], a);
		b = (line[3] - 'A') * 26 + line[4] - 'A';
//		printf ("%c%c -- %d\n", line[3], line[4], b);
		line[2] = bfs (a, b);
		printf ("%s", line);//it has a \n
	}

	return 0;
}
