/*
FROM: BalticOI 1998 day 2
PROB: floor
KEYW: euler cycles
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 1 << 7;
const int MAXM = 1 << 9;
const int MAXE = 1 << 6;

int N, M, E;
int ma3x[MAXN][MAXN];
int exits[MAXE];
bool is_exit[MAXN];
int odd[MAXN], op;
int deg[MAXN];

int stk2[MAXM + MAXN], stk2p;

void euler (int s) {
	static int stk[MAXM + MAXN], stkp;

	stk[stkp++] = s;

	int i, c;
	while (stkp) {
		c = stk[stkp-1];
		for (i = 0; i < N; ++i)
			if (ma3x[c][i]) {
				--ma3x[c][i];
				--ma3x[i][c];
				stk[stkp++] = i;
				break;
			}
		if (i == N) stk2[stk2p++] = stk[--stkp];
	}
}

int main () {
	scanf ("%d %d %d", &N, &M, &E);

	int i;
	int a, b;
	for (i = 0; i < E; ++i) {
		scanf ("%d", &a);
		exits[i] = --a;
		is_exit[a] = 1;
	}

	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		++deg[a];
		++deg[b];
		++ma3x[a][b];
		++ma3x[b][a];
	}

	for (i = 0; i < N; ++i)
		if (deg[i] & 1)
			if (is_exit[i])
				odd[op++] = i;
			else {
				printf ("NO\n");
				exit (0);
			}

	if (op & 1) {
		printf ("NO\n");
		exit (0);
	}

	for (i = 2; i < op; i += 2) {
		++ma3x[odd[i]][odd[i+1]];
		++ma3x[odd[i+1]][odd[i]];
	}

	if (op)
		euler (odd[0]);
	else
		euler (exits[0]);

	for (i = 0; i < stk2p; ++i) printf ("%d\n", stk2[i] + 1);

	return 0;
}
