/*
FROM: BalticOI 1998 day 1
PROB: match
KEYW: full exhaustion with optimizations
*/

#include <cstdio>
#include <cassert>
#include <cstring>
#include <cstdlib>
#include <algorithm>

using std::random_shuffle;

const int MAXN = 1 << 3, MAXM = 32, MAXCOLPNTS = 1 << 10;

const int N = 5, M = 20;

int w[MAXN], l[MAXN], pf[MAXN], pt[MAXN];
int pnts[MAXM];

int brd[MAXN][MAXN];
const int ltoc[][2] = {{0, 1}, {0, 2}, {1, 0}, {1, 2}, {2, 0}, {2, 1}};
const int ltoc2[][4] = {{0, 3, 0, 4}, {1, 3, 1, 4}, {3, 0, 4, 0}};

bool used[MAXM];
int ref[MAXCOLPNTS];

bool fused (int p, int &id) {
	if (p >= 0 && p < MAXCOLPNTS && ref[p] != -1)
		return used[id = ref[p]];
	return 1;
}

inline void put (const int &i, const int &x, const int &y) {
	used[i] = 1;
	brd[x][y] = pnts[i];
	pf[x] -= pnts[i];
	pt[y] -= pnts[i];
}

inline void unput (const int &i, const int &x, const int &y) {
	used[i] = 0;
	pf[x] += pnts[i];
	pt[y] += pnts[i];
}

void prnt () {
	static int i, j;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			printf ("%4d", brd[i][j]);
		printf ("\n");
	}
}
void check () {
	static int i, j, ws;
	for (i = 0; i < N; ++i) {
		for (j = ws = 0; j < N; ++j)
			ws += brd[i][j] > brd[j][i];
		if (ws != w[i]) return;
	}
	prnt ();
	exit (0);
}

void rec (int);
void f (int l) {
	int id;
	for (int i = 0; i < M; ++i) {
		if (used[i] || fused ((ltoc2[l][0] == ltoc2[l][2] ? pf[ltoc2[l][0]] : pt[ltoc2[l][1]]) - pnts[i], id) || id == i) continue;
		if (pf[ltoc2[l][0]] < pnts[i] 	|| pt[ltoc2[l][1]] < pnts[i]
		 || pf[ltoc2[l][2]] < pnts[id] 	|| pt[ltoc2[l][3]] < pnts[id]) continue;
		put (i, ltoc2[l][0], ltoc2[l][1]);
		put (id, ltoc2[l][2], ltoc2[l][3]);
		rec (l + 7);
		unput (i, ltoc2[l][0], ltoc2[l][1]);
		unput (id, ltoc2[l][2], ltoc2[l][3]);
	}
}

void rec (int level) {
	if (level < 6) {
		for (int i = 0; i < M; ++i) {
			if (used[i]) continue;
			if (pf[ltoc[level][0]] < pnts[i] || pt[ltoc[level][1]] < pnts[i]) continue;
			put (i, ltoc[level][0], ltoc[level][1]);
			rec (level + 1);
			unput (i, ltoc[level][0], ltoc[level][1]);
		}
	} else if (level < 9) {
		return f (level - 6);
	} else if (level == 9) {
		int id, id2;
		for (int i = 0; i < M; ++i) {
			if (used[i] || fused (pf[2] - pnts[i], id) || fused (pt[4] - pnts[id], id2) || i == id || i == id2 || id == id2) continue;
			if (pf[2] < pnts[i] 	|| pt[3] < pnts[i]
			 || pf[2] < pnts[id] 	|| pt[4] < pnts[id]
			 || pf[3] < pnts[id2] 	|| pt[4] < pnts[id2]) continue;
			put (i, 2, 3);
			put (id, 2, 4);
			put (id2, 3, 4);
			rec (level + 1);
			unput (i, 2, 3);
			unput (id, 2, 4);
			unput (id2, 3, 4);
		}
	} else if (level == 10) {
		int ws = 0;
		for (int i = 1; i < N; ++i) if (brd[0][i] > brd[i][0]) ++ws;
		if (ws != w[0]) {
			return;
		}

		int id, id2, id3, id4;
		for (int i = 0; i < M; ++i) {
			if (used[i] || fused (pt[1] - pnts[i], id) || fused (pf[3] - pnts[i], id2) || fused (pt[2] - pnts[id2], id3)
			 || fused (pf[4] - pnts[id] - pnts[id3], id4)
			 || id == id2 || id == id3 || id == id4 || id2 == id3 || id2 == id4 || id3 == id4) continue;

			if (pf[3] < pnts[i] 	|| pt[1] < pnts[i]
			 || pf[4] < pnts[id] 	|| pt[1] < pnts[id]
			 || pf[3] < pnts[id2] 	|| pt[2] < pnts[id2]
			 || pf[4] < pnts[id3] 	|| pt[2] < pnts[id3]
			 || pf[4] < pnts[id4] 	|| pt[3] < pnts[id4]) continue;
			put (i, 3, 1);
			put (id, 4, 1);
			put (id2, 3, 2);
			put (id3, 4, 2);
			put (id4, 4, 3);
			check ();
			unput (i, 3, 1);
			unput (id, 4, 1);
			unput (id2, 3, 2);
			unput (id3, 4, 2);
			unput (id4, 4, 3);
		}
	}
}

int main () {
	int i;
//	FILE *in = fopen ("match.in", "r");
	FILE *in = stdin;
	for (i = 0; i < N; ++i)
		fscanf (in, "%d %d %d %d", w + i, l + i, pf + i, pt + i);

	for (i = 0; i < MAXCOLPNTS; ++i) ref[i] = -1;
	for (i = 0; i < M; ++i) {
		fscanf (in, "%d", pnts + i);
		ref[pnts[i]] = i;
	}

	random_shuffle (pnts, pnts + M);
	for (i = 0; i < M; ++i)
		ref[pnts[i]] = i;

	memset (brd, 0, sizeof (brd));

	rec (0);

	return 0;
}
