/*
FROM: BalticOI 1999 day 1
PROB: match (string matching)
KEYW: bfs, string
*/

#include <cstdio>
#include <string>
#include <utility>
#include <queue>
#include <iostream>
#include <algorithm>

using std::string;
using std::pair;
using std::make_pair;
using std::priority_queue;

const int MAXN = 1 << 7;
const int MAXL = 1 << 6;

typedef unsigned char uchar;

struct q_el {
	uchar n, p;
	int l;
	uchar nn, pp, ii;
	q_el () {}
	q_el (uchar _n, uchar _p, int _l, uchar _nn, uchar _pp, uchar _ii) : n (_n), p (_p), l (_l), nn (_nn), pp (_pp), ii (_ii) {}
	bool operator < (const q_el &a) const {return l < a.l;}
};

int N, M;
string A[MAXN], B[MAXN];

bool cmp (const string &a, const string &b) {
	return (a.size () <  b.size () && a == b.substr (0, a.size ())
		 || b.size () <= a.size () && b == a.substr (0, b.size ())
		 ? 0 : a < b);
}

bool popped[MAXN * 2][MAXL];
pair <pair <uchar, uchar>, uchar> prev[MAXN * 2][MAXL];
int __len;

uchar bfs () {
	static priority_queue<q_el> q;
	for (int i = 0; i < N; ++i) {
		q.push (q_el (i, 0, 0, 255, 255, 255));
//		used[i][0] = 1;
		prev[i][0] = make_pair (make_pair (255, 255), 255);
	}

	q_el c;
	pair <string*, string*> x;
	while (!q.empty ()) {
		c = q.top (); q.pop ();
		if (popped[c.n][c.p]) continue;
		popped[c.n][c.p] = 1;
		prev[c.n][c.p] = make_pair (make_pair (c.nn, c.pp), c.ii);
//		printf ("in %d %d %d (%d %d %d)\n", c.n, c.p, c.l, c.nn, c.pp, c.ii);

		if (c.n < N) {
			if (A[c.n].size () == c.p) return __len = c.l, c.n;
			x = std::equal_range (B, B + M, A[c.n].substr (c.p), cmp);
			if (x.first == x.second) continue;

			for (string *ii = x.first; ii != x.second; ++ii) {
				if (ii->size () <= A[c.n].size () - c.p) {
					if (!popped[c.n][c.p + ii->size ()]) {
						q.push (q_el (c.n, c.p + ii->size (), c.l + ii->size (), c.n, c.p, ii - B + N));
					}
				} else {
//					printf ("case 1.2 -- (%d, %d - %d, %d))", ii - B+N, ii->size (), (A[c.n].size () - c.p), c.l + A[c.n].size () - c.p);
					if (!popped[ii-B+N][A[c.n].size () - c.p]) {
						q.push (q_el (ii-B+N, A[c.n].size () - c.p, c.l + A[c.n].size () - c.p, c.n, c.p, ii - B + N));
					}
				}
			}
		} else {
			c.n -= N;
			if (B[c.n].size () == c.p) return __len = c.l, c.n + N;
			x = std::equal_range (A, A + N, B[c.n].substr (c.p), cmp);
			if (x.first == x.second) continue;

			for (string *ii = x.first; ii != x.second; ++ii) {
				if (ii->size () <= B[c.n].size () - c.p) {
					if (!popped[c.n+N][c.p + ii->size ()]) {
						q.push (q_el (c.n+N, c.p + ii->size (), c.l + ii->size (), c.n+N, c.p, ii - B));
					}
				} else {
					if (!popped[ii-A][B[c.n].size () - c.p]) {
						q.push (q_el (ii-A, B[c.n].size () - c.p, c.l + B[c.n].size () - c.p, c.n + N, c.p, ii - A));
					}
				}
			}
		}
	}

	return 255;
}

int main () {
	int i;
	for (i = 0, std::cin >> N; i < N; ++i)
		std::cin >> A[i];
	for (i = 0, std::cin >> M; i < M; ++i)
		std::cin >> B[i];

	std::sort (A, A + N);
	std::sort (B, B + M);

	uchar res = bfs ();

	if (res == 255) {printf ("0\n"); exit (0);}
	pair <pair <uchar, uchar>, uchar> x = prev[res][res < N ? A[res].size () : B[res-N].size ()];

	int aa[MAXN], bb[MAXN], ap=0, bp=0;
	while (x.second != 255) {
//		printf ("%d %d %d\n", x.first.first, x.first.second, x.second);
		if (x.second < N)
			aa[ap++] = x.second;
		else
			bb[bp++] = x.second - N;
		if (prev[x.first.first][x.first.second].second == 255) {
			aa[ap++] = x.first.first;
			break;
		} else
			x = prev[x.first.first][x.first.second];
	}

	printf ("%d\n", __len);
	printf ("%s", A[aa[--ap]].c_str ());
	for (i = ap-1; i >= 0; --i)
		printf ("+%s", A[aa[i]].c_str ());

	printf ("\n%s", B[bb[--bp]].c_str ());
	for (i = bp-1; i >= 0; --i)
		printf ("+%s", B[bb[i]].c_str ());
	printf ("\n");

	return 0;
}
