/*
FROM: BalticOI 2000 day 1
PROB: honeycomb
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXNN = 1 << 8;
const int INF = 1 << 20;

int N;
int max[MAXNN];
int lb[MAXNN], rb[MAXNN];
int brd[MAXNN][MAXNN];
int dp[2][MAXNN][MAXNN];

int main () {
	scanf ("%d", &N);

	int i, j;
	int tmp;
	for (i = 0; i < N; ++i) {
		lb[i] = 0;
		for (j = 0; j < N + i; ++j) {
			scanf ("%d", &tmp);
			brd[i][j] = tmp;
			max[i] >?= tmp;
		}
		rb[i] = i + N;
	}

	for (i = 1; i < N; ++i) {
		lb[N-1+i] = i;
		for (j = i; j < 2 * N - 1; ++j) {
			scanf ("%d", &tmp);
			brd[N-1+i][j] = tmp;
			max[N-1+i] >?= tmp;
		}
		rb[N-1+i] = 2 * N - 1;
	}

	for (i = 0; i < 2 * N - 1; ++i) {
		for (j = 0; j < lb[i]; ++j)
			dp[0][i][j] = dp[1][i][j] = -INF;
		for (j = rb[i]; j < 2 * N; ++j)
			dp[0][i][j] = dp[1][i][j] = -INF;
	}
	for (i = N * 2 - 1, j = lb[i]; j < rb[i]; ++j) {
		dp[0][i][j] = brd[i][j];
		dp[1][i][j] = max[i];
	}
	
	for (i = N * 2 - 2; i >= 0; --i) {
		for (j = lb[i]; j < rb[i]; ++j) {
			dp[0][i][j] = brd[i][j] + (dp[0][i+1][j] >? dp[0][i+1][j+1]);
			dp[1][i][j] = (brd[i][j] + (dp[1][i+1][j] >? dp[1][i+1][j+1]))
						>? (max[i] + (dp[0][i+1][j] >? dp[0][i+1][j+1]));
		}
	}
	int res = 0;
	for (i = 0, j = lb[i]; j < rb[i]; ++j)
		res >?= dp[1][i][j];

	printf ("%d\n", res);

	return 0;
}
