/*
FROM: BalticOI 2000 day 1
PROB: stickers
KEYW: binary search, mathematical
*/

#include <cstdio>
#include <cassert>
#include <cstring>

const int MAX = 1 << 7;
char coef[10] = {9, 9, 9, 9, 9, 9, 9, 9, 9, 9};

struct num {
	char m[MAX];
	num () {memset (m, 0, sizeof (m));}

	num& operator = (const num &a) {memcpy (m, a.m, sizeof (m)); return *this;}
	void average (const num &a, const num &b) {
		int i, pr = 0;
		for (i = 0; i < MAX; ++i) {
			m[i] = a.m[i] + b.m[i] + pr;
			pr = m[i] / 10;
			m[i] %= 10;
		}
		assert (pr == 0);
		for (i = MAX-1; i >= 0; --i) {
			int res = (pr * 10 + m[i]) / 2;
			pr = m[i] & 1;
			m[i] = res;
		}
	}
	num& p10 (int a) {for (int i = MAX-1; i - a >= 0; --i) m[i] = m[i-a]; for (int i = a-1; i >= 0; --i) m[i] = 0; return *this;}
	num& add (int a) {for (int i = 0; i < MAX; ++i) {m[i] += a; a = m[i] / 10; m[i] %= 10;} return *this;}
	num& add (const num &a) {int i, pr = 0; for (i = 0; i < MAX; ++i) {m[i] += a.m[i] + pr; pr = m[i] / 10; m[i] %= 10;} return *this;}
	num mul (int a) const {int pr = 0; num ret; for (int i = 0; i < MAX; ++i) {ret.m[i] = m[i] * a + pr; pr = ret.m[i] / 10; ret.m[i] %= 10;} assert (pr == 0); return ret;}
	num trnk (int a) const {num ret; for (int i = 0; i < a; ++i) ret.m[i] = m[i]; return ret;}
	num& take1 () {int i; for (i = 0; i < MAX && m[i] == 0; ++i) m[i] = 9; --m[i]; return *this;}

	bool operator < (const num &a) const {int i; for (i = MAX-1; i > 0 && m[i] == a.m[i]; --i); return m[i] < a.m[i];}

	bool ok_dig (int a) const {
		num res, tmp, tmp2;
		if (a) {
			for (int i = MAX-1; i >= 0; --i) {
				if (m[i] < a) {
					tmp2 = tmp;
					tmp2.p10 (i);

					res.add (tmp2);
//					printf ("!adding -- ");
//					tmp2.prnt (); puts ("");
				} else if (m[i] == a) {
					tmp2 = tmp;
					tmp2.p10 (i);

					res.add (tmp2).add (trnk (i).add (1));
//					printf ("!!adding -- ");
//					tmp2.prnt (); puts ("");
//					trnk (i).add (1).prnt (); puts ("---");
				} else {
					tmp2 = tmp;
					tmp2.add (1);
					tmp2.p10 (i);

					res.add (tmp2);
//					printf ("!!!adding -- ");
//					tmp2.prnt (); puts ("");
				}
				tmp.p10 (1);
				tmp.add (m[i]);
			}
		} else {//zero
//			assert (0);
			int i;
			for (i = MAX-1; i >= 0 && !m[i]; --i);
			tmp.add (m[i]);
			for (--i; i >= 0; --i) {
				if (m[i] == a) {
					tmp2 = tmp;
					tmp2.take1 ();
					tmp2.p10 (i);

					res.add (tmp2).add (trnk (i).add (1));
//					printf ("!!adding -- ");
//					tmp2.prnt (); puts ("");
//					trnk (i).add (1).prnt (); puts ("---");
				} else {//m[i] > a
					tmp2 = tmp;
					tmp2.p10 (i);

					res.add (tmp2);
					printf ("!!!adding -- ");
					tmp2.prnt (); puts ("");
				}
				tmp.p10 (1);
				tmp.add (m[i]);
			}
		}
		printf ("ok_dig (%d) -- ", a);
		res.prnt (); puts ("");
		return !(mul (coef [a]) < res);
	}
	bool ok_all () const {
		for (int a = 0; a < 10; ++a)
			if (!ok_dig (a)) return 0;
		return 1;
	}

	void prnt () {int i; for (i = MAX-1; i && !m[i]; --i); for (; i >= 0; --i) printf ("%d", (int)m[i]);}
};

bool close (num a, const num &b) {
	return a < b && !(a.add (1) < b);
}

int main () {
/*	for (int i = 0; i < 10; ++i) {int tmp; scanf ("%d", &tmp); coef[i] = tmp;}
	num a, b, m;
	a.m[90] = 1;

	while (!close (b, a)) {
		m.average (a, b);
		m.prnt (); puts (" this is m");
		a.prnt (); puts (" this is a");
		b.prnt (); puts (" this is b");
		puts ("-------\n");
		fflush (stdout);
		if (m.ok_all ())
			b = m;
		else
			a = m;
	}
	a.prnt (); puts (" this was a");
	b.prnt (); puts (" this was b");
*/

	num a;
	int tmp;
	scanf ("%d", &tmp);
	for (int i = 0; tmp; ++i) {
		a.m[i] = tmp % 10;
		tmp /= 10;
	}

	a.ok_all ();

	return 0;
}
