/*
FROM: BalticOI 2001 day 0
PROB: excursion
KEYW: ?? theory, bfs
*/

#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <utility>

#define id first
#define type second

using std::pair;
using std::make_pair;

const int MAXN = 1 << 13;//count of cities
const int MAXM = 1 << 15;//count of travelers

struct el {
	pair <int, bool> to;
	int next;
	el () {}
	el (int _to_id, bool _to_type, int _next) : to (_to_id, _to_type), next (_next) {}
};

int N, M;
int vec[MAXN][2];
el buf[MAXM * 2];

char type[MAXN];

bool bfs (int _id, bool _type) {
//	printf ("-> bfs from %d %d\n", _id, _type);
	static pair <int, bool> queue[MAXN];
	static int i, j, p3;

	p3 = 0;
	queue[p3++] = make_pair (_id, _type);
	type[_id] = _type;
	for (i = 0; i < p3; ++i) {
		for (j = vec[queue[i].id][queue[i].type]; j != -1; j = buf[j].next) {
			if (type[buf[j].to.id] == -1) {
//				printf (" (%d %d)", buf[j].to.id, buf[j].to.type);
				type[buf[j].to.id] = buf[j].to.type;
				queue[p3++] = buf[j].to;
			} else if (type[buf[j].to.id] != buf[j].to.type) {
				for (j = 0; j < p3; ++j) type[queue[j].id] = -1;
//				printf ("\nfailed!! %d %d %d %d\n", type[0], type[1], type[2], type[3]);
				return 1;
			}
		}
	}

//	printf ("\npassed %d %d %d %d\n", type[0], type[1], type[2], type[3]);
	return 0;
}

int main () {
	scanf ("%d %d", &M, &N);

	int i;
	int a, b;
	int bp = 0;
	pair <int, bool> ax, bx;
	for (i = 0; i < N; ++i) vec[i][0] = vec[i][1] = type[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);

		ax = make_pair (abs (a) - 1, a < 0);
		bx = make_pair (abs (b) - 1, b < 0);

		buf[bp] = el (bx.id, bx.type, vec[ax.id][!ax.type]);
		vec[ax.id][!ax.type] = bp++;

		buf[bp] = el (ax.id, ax.type, vec[bx.id][!bx.type]);
		vec[bx.id][!bx.type] = bp++;
	}
/*
	for (i = 0; i < N; ++i) {
		for (int k = 0; k < 2; ++k) {
			printf ("%d %d ->", i, k);
			for (int j = vec[i][k]; j != -1; j = buf[j].next)
				printf (" (%d %d)", buf[j].to.id, buf[j].to.type);
			printf ("\n");
		}
	}
*/
	static int idx[MAXN];
	for (i = 0; i < N; ++i) idx[i] = i;
	std::random_shuffle (idx, idx + N);

	for (i = 0; i < N; ++i)
		if (type[idx[i]] == -1 && bfs (idx[i], 0) && bfs (idx[i], 1)) {
			printf ("NO\n");
			exit (0);
		}
	
	static int ans[MAXN], ap;
	for (i = 0; i < N; ++i) if (!type[i]) ans[ap++] = i + 1;

	printf ("%d\n", ap);
	if (ap != 0) printf ("%d", ans[0]);
	for (i = 1; i < ap; ++i) printf (" %d", ans[i]);
	printf ("\n");

	return 0;
}
