/*
FROM: BalticOI 2002 day 1
PROB: tennis
KEYW: building graph given the degree of every vertex
*/

#include <cstdio>
#include <utility>
#include <vector>
#include <algorithm>

const int MAXN = 1 << 10;

int N;
int deg[MAXN];
int idx[MAXN];
std::vector <int> play[MAXN];

bool cmp (int a, int b) {
	return deg[a] > deg[b];
}

int main () {
	scanf ("%d", &N);
	int i, ii;
	int oddc = 0;
	for (i = 0; i < N; ++i) {
		scanf ("%d", deg + i);
		idx[i] = i;
	}

	std::sort (idx, idx + N, cmp);

	std::pair <int*, int*> range;
	for (i = 0; deg[idx[i]]; ++i) {
		if (i + deg[idx[i]] >= N || deg[idx[i + deg[idx[i]]]] == 0) {printf ("NO SCHEDULE\n"); exit (0);}
		range = std::equal_range (idx + i, idx + N, idx[i + deg[idx[i]]], cmp);
//		printf ("hay!\n");
//		for (ii = 0; ii < N; ++ii) printf (" %d", deg[idx[ii]]); printf ("\n");
//		printf ("range for %d(%d) --> %d %d\n", i, idx[i], range.first - idx, range.second - idx);
		for (ii = i + 1; ii < range.first - idx; ++ii) {
			--deg[idx[ii]];
			play[idx[i]].push_back (idx[ii]);
			play[idx[ii]].push_back (idx[i]);
			--deg[idx[i]];
		}
		for (ii = range.second - idx - 1; deg[idx[i]]; --ii) {
			--deg[idx[ii]];
			play[idx[i]].push_back (idx[ii]);
			play[idx[ii]].push_back (idx[i]);
			--deg[idx[i]];
		}
	}

	printf ("SCHEDULE\n");
	for (i = 0; i < N; ++i) {
		std::sort (play[i].begin (), play[i].end ());
		for (ii = 1, printf ("%d", play[i][0] + 1); ii < (int)play[i].size (); ++ii)
			printf (" %d", play[i][ii] + 1);
		printf ("\n");
	}

	return 0;
}
