/*
FROM: BalticOI 2002 day 1
PROB: triangles (tr)
KEYW: slicing the plane, map
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <set>

const int MAXN = 1 << 11;
const int INF = 1 << 30;

struct tri {
	int x, y, m;
	tri () {}
	tri (int _x, int _y, int _m) : x (_x), y (_y), m (_m) {}
	bool operator < (const tri &a) const {return x < a.x;}
};

int N;
tri vec[MAXN];

struct cmpY {bool operator () (int a, int b) const {return vec[a].y < vec[b].y;}};
std::set <int, cmpY> crnt;

inline int tell_end (int id, int cx) {
	return vec[id].x + vec[id].m - cx + vec[id].y;
}

inline long long calc_S (long long x, long long d) {
	return x <= 0 ? 0 : x <= d ? x * x : d * (x - d) * 2 + d * d;
}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d %d %d", &vec[i].x, &vec[i].y, &vec[i].m);

	#warning check here
/*
	if (N == 1) {
		printf ("%d\n", calc_S (vec[0].m, vec[0].m));
		exit (0);
	}
*/
	std::sort (vec, vec + N);//by X
	vec[N].x = INF;//too big

//	for (i = 0; i < N; ++i) printf ("%d --> %d %d %d\n", i, vec[i].x, vec[i].y, vec[i].m);

	int cx, d;
	int cend;
	int nend, nbeg;
	long long cs, allS = 0;
	std::set <int, cmpY>::iterator ii, tmpii;
	for (i = 0; i != N;) {
		cx = vec[i].x;
//		printf ("_______cx == %d_______\n", cx);
//		ii = i;
		for (; vec[i].x == cx; ++i) {
//			printf ("put to set %d\n", i);
			crnt.insert (i);
		}
		if (i == N) d = INF; else d = vec[i].x - cx;

		assert (!crnt.empty ());

		ii = crnt.begin ();
//		printf ("now looking at %d !!\n", *ii);
		cend = tell_end (*ii, cx);
		cs = calc_S (cend - vec[*ii].y, d);
		if (vec[*ii].x + vec[*ii].m <= cx + d) {
//			printf ("\tremove!\n");
			tmpii = ii++;
			crnt.erase (tmpii);
		} else
			++ii;
	
		while (ii != crnt.end ()) {
//			printf ("now looking at %d (cend == %d)\n", *ii, cend);
			nend = tell_end (*ii, cx);
			nbeg = vec[*ii].y;
			if (nend > cend) {
				cs += calc_S (nend - nbeg, d);
				cs -= calc_S (cend - nbeg, d);
				cend >?= nend;
			}

			if (vec[*ii].x + vec[*ii].m <= cx + d) {//erase if not needed any more
//				printf ("\tremove!\n");
				tmpii = ii++;
				crnt.erase (tmpii);
			} else
				++ii;
		}
//		printf ("on cx == %d --> add %Ld\n", cx, cs);
		allS += cs;
	}
	
	printf ("%.1lf\n", allS / 2.);

	return 0;
}
