/*
FROM: BalticOI 2003 day 1
PROB: barrel
KEYW: binary search, phisics
*/

#include <cstdio>

const int MAXN = 1 << 10;
const double EPS = 1e-7;//just for sure (1e-4 is sufficient)

double S, H, V;
int N;
double sz[MAXN];
double dns[MAXN];

bool more (double h) {
//	printf ("__%lf (%lf) --", h, h * S);
	static double sub_vol = 0;//total submerged volume
	static double sh;
	static int i;
	for (sub_vol = i = 0; i < N; ++i) {
		sh = dns[i] * sz[i];
		if (sh > h) sh = h;//we hit the bottom
		if (h + (sz[i] - sh) > H) sh = sz[i] + h - H;//we hit the lid
		sub_vol += sh * sz[i] * sz[i];
//		printf ("%d --> %lf (%lf)\n", i, sh, sh * sz[i] * sz[i]);
	}
//	printf ("%lf + %lf == %lf\n", sub_vol, V, sub_vol + V);
	return sub_vol + V > h * S;//we need more if the added (submerged) volume + water volume is less than expected water volume
}

int main () {
	scanf ("%lf %lf %lf", &S, &H, &V);

	scanf ("%d", &N);
	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%lf %lf", sz + i, dns + i);
		dns[i] <?= 1.;
	}

	double l = V / S, r = H, m;
	while (r - l > EPS) {
		m = (l + r) / 2.;
		if (more (m))
			l = m;
		else
			r = m;
	}

	printf ("%.7lf\n", (l + r) / 2.);

	return 0;
}
