/*
FROM: BalticOI 2003 day 2
PROB: gangs
KEYW: bfs
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 10;
const int MAXE = 5010;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N, M;
int vec[MAXN];
el buf[MAXE * 2];

bool ma3x[MAXN][MAXN];
int q[MAXN], used[MAXN], p3;

void bfs (int s) {
	static int i, j;
	q[p3 = 0, p3++] = s;
	used[s] = -1;
	for (i = 0; i < p3; ++i) {
//		printf ("pop %d\n", q[i]);
		for (j = 0; j < N; ++j)
			if (ma3x[q[i]][j] && used[j] != -1) {
				used[j] = -1;
				q[p3++] = j;
			}
	}
//	printf ("---\n");
}

int main () {
	scanf ("%d\n%d\n", &N, &M);

	int i, j, k;
	int a, b, bp = 0;
	char t;
	memset (vec, -1, sizeof (vec));
	for (i = 0; i < M; ++i) {
		scanf ("%c %d %d\n", &t, &a, &b);

		--a; --b;
		if (t == 'F')
			ma3x[a][b] = ma3x[b][a] = 1;
		else {
			buf[bp] = el (b, vec[a]);
			vec[a] = bp++;
			buf[bp] = el (a, vec[b]);
			vec[b] = bp++;
		}
	}

	for (i = 0; i < N; ++i) {
		p3 = 0;
		used[i] = i + 1;
		for (j = vec[i]; j != -1; j =  buf[j].next) {
			q[p3++] = buf[j].to;
			used[buf[j].to] = i + 1;
		}
		for (k = 0; k < p3; ++k) {
			for (j = vec[q[k]]; j != -1; j =  buf[j].next)
				if (used[buf[j].to] != i + 1) {
					used[buf[j].to] = i + 1;
//					printf ("make F - %d %d\n", i, buf[j].to);
					ma3x[i][buf[j].to] = 1;
				}
		}
	}

//	for (i = 0; i < N; ++i) {for (j = 0; j < N; ++j) printf ("%d ", ma3x[i][j]); printf ("\n");}

	int res = 0;
	for (i = 0; i < N; ++i)
		if (used[i] != -1) {
			bfs (i);
			++res;
		}

	printf ("%d\n", res);

	return 0;
}
