/*
FROM: BalticOI 2003 day 1
PROB: gems
KEYW: dynamical programming on tree
*/

#include <cstdio>
#include <cstring>
#include <utility>

using std::make_pair;

const int MAXN = 1 << 14;
const int MAXP = 1 << 5;
const int P = 25;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N;
int prev[MAXN];
int dp[MAXN][MAXP];
std::pair <int, int> best[MAXN];

int vec[MAXN];
el buf[MAXN * 2];

void f (int a) {
	if (buf[vec[a]].next == -1 && a) {
		for (int j = 1; j < P; ++j) dp[a][j] = j;
		best[a] = std::make_pair (1, 2);
		return;
	}

	for (int j = 1; j < P; ++j) dp[a][j] = j;//initial value - the root value
	for (int i = vec[a]; i != -1; i = buf[i].next) {
		if (buf[i].to == prev[a]) continue;
		prev[buf[i].to] = a;
		f (buf[i].to);
		for (int j = 1; j < P; ++j)
			if (j == best[buf[i].to].first) dp[a][j] += dp[buf[i].to][best[buf[i].to].second];
			else							dp[a][j] += dp[buf[i].to][best[buf[i].to].first];
	}

	if (dp[a][1] < dp[a][2]) best[a] = make_pair (1, 2);
	else 					 best[a] = make_pair (2, 1);

	for (int j = 3; j < P; ++j)
		if (dp[a][j] < dp[a][best[a].first])
			best[a] = make_pair (j, best[a].first);
		else if (dp[a][j] < dp[a][best[a].second])
			best[a].second = j;
}

int main () {
	scanf ("%d", &N);

	if (N == 1) {printf ("1\n"); return 0;}

	int i;
	int a, b, bp = 0;
	memset (vec, -1, sizeof (vec));
	for (i = 1; i < N; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		buf[bp] = el (b, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, vec[b]);
		vec[b] = bp++;
	}

	prev[0] = -1;
	f (0);

	printf ("%d\n", dp[0][best[0].first]);

	return 0;
}
