/*
FROM: BalticOI 2003 day 0
PROB: linker
KEYW: bfs, hash map
*/

#include <cstdio>
#include <cstring>
#include <utility>
#include <ext/hash_map>

using std::make_pair;
using namespace __gnu_cxx;

const int MAXN = 1 << 7;
const int MAXS = 1 << 14;
const int MAXI = 1 << 7;
const int MAXL = 1 << 5;

int N;
char names[MAXN][MAXL];
int inpl[MAXN][MAXI], inplp[MAXN];
bool in[MAXN][MAXS];
bool ex[MAXN][MAXS];
int SC;
char symbols[MAXS][MAXL];

struct eqstr {bool operator()(const char* s1, const char* s2) const {return strcmp(s1, s2) == 0;}};
hash_map <const char *, int, hash <const char *>, eqstr> symbol_db;

char bad[MAXS];
int q[MAXN], p3;

void bfs () {
	static int i, j, k, l, oldp3;
	static int c;
	static bool used[MAXN];
//	in[N][0] = 1;//needs entry point
	inpl[N][inplp[N]++] = 0;//needs entry point
	q[p3++] = N;//put superficial node which wants only the entry point

	for (i = 0; i < p3; ++i) {
		c = q[i];
//		printf ("pop %d\n", c);
		for (j = 0; j < inplp[c]; ++j) {
			oldp3 = p3;
			for (k = 0; k < N; ++k) {
				if (used[k]) continue;
				if (ex[k][inpl[c][j]]) {
					used[k] = 1;
					q[p3++] = k;
				}
			}
		}
	}
}

int main () {
	gets (symbols[SC]);
	symbol_db.insert (make_pair (symbols[SC], SC));
	++SC;

	scanf ("%d\n", &N);

	int i, j;
	int k;
	hash_map <const char *, int, hash <const char*>, eqstr> :: iterator ii;
	for (i = 0; i < N; ++i) {
		gets (names[i]);
		
		scanf ("%d\n", &k);
		for (j = 0; j < k; ++j) {
			gets (symbols[SC]);
			if ((ii = symbol_db.find (symbols[SC])) != symbol_db.end ()) {
				ex[i][ii->second] = 1;
			} else {
				symbol_db.insert (make_pair (symbols[SC], SC));
				ex[i][SC] = 1;
				++SC;
			}
		}

		scanf ("%d\n", &k);
		for (j = 0; j < k; ++j) {
			gets (symbols[SC]);
			if ((ii = symbol_db.find (symbols[SC])) != symbol_db.end ()) {
				in[i][ii->second] = 1;
				inpl[i][inplp[i]++] = ii->second;
			} else {
				symbol_db.insert (make_pair (symbols[SC], SC));
				in[i][SC] = 1;
				inpl[i][inplp[i]++] = SC;
				++SC;
			}
		}
		
	}
/*
	for (i = 0; i < N; ++i) {
		printf ("%s --> ", names[i]);
		for (j = 0; j < SC; ++j) printf (" %d", in[i][j]);
		for (j = 0; j < SC; ++j) printf (" %d", ex[i][j]);
		printf ("("); for (j = 0; j < inplp[i]; ++j) printf (" %d", inpl[i][j]); printf (" )");
		printf ("\n");
	}

	for (i = 0; i < SC; ++i)
		printf ("%d - %s\n", i, symbols[i]);
*/
	bfs ();
	for (i = 1; i < p3; ++i)
		for (j = 0; j < SC; ++j) {
			if (in[q[i]][j] && !bad[j])
				bad[j] = 1;//it is wanted
			if (ex[q[i]][j])
				if (bad[j] <= 1) bad[j] = 2;//it is normal
				else if (bad[j] == 2) bad[j] = 3;//it appears at least twice
		}

	printf ("%d\n", p3 - 1);
	for (i = 1; i < p3; ++i)
		puts (names[q[i]]);

	static int badex[MAXS], badexp = 0, badin[MAXS], badinp = 0;

	for (i = 0; i < SC; ++i) {
		if (bad[i] == 3)
			badex[badexp++] = i;
		else if (bad[i] == 1)
			badin[badinp++] = i;
	}

	printf ("%d\n", badexp);
	for (i = 0; i < badexp; ++i) puts (symbols[badex[i]]);
	printf ("%d\n", badinp);
	for (i = 0; i < badinp; ++i) puts (symbols[badin[i]]);

	return 0;
}
