/*
FROM: Baltic Olympiad in Informatics (BaOI) 2004 day 1
PROB: ships
KEYW: bfs
*/

#include <cstdio>
#include <vector>
#include <utility>
#include <functional>
#include <algorithm>

const int MAXLINELEN = 1 << 20;
const int MAXT = 1 << 10;
const int MAXP = 1 << 20;//max parts

int L;
std::vector <std::pair <short, short> > vec;
std::vector <std::vector <int> > gr;

std::vector <int> data;
bool used[MAXP];

void bfs (int s) {
	static int q[MAXT], p3, c;
	static int i;
	static size_t j;
	int ton = 0;
	q[p3 = 0, p3++] = s;
	used[s] = 1;

	for (i = 0; i < p3; ++i) {
		c = q[i];
		ton += vec[c].second - vec[c].first + 1;
		for (j = 0; j < gr[c].size (); ++j) {
			if (!used[gr[c][j]]) {
				used[gr[c][j]] = 1;
				q[p3++] = gr[c][j];
			}
		}
	}
//	printf (" %d", ton);
	data.push_back (ton);
}

int main () {
	scanf ("%d\n", &L);

	static char line[MAXLINELEN];
	int i;
	int prp = 0, crp = 0;
	short cd1, cd2;
	int n;
	std::pair <short, short> crnt;
	for (i = 0; i < L; ++i) {
//		printf ("row %d : ", i);
		gets (line);
		char *lp = line;
		if (*lp == ';') ++lp;
		while (*lp) {
			sscanf (lp, "%hd%n", &cd1, &n);
			lp += n;
			if (*lp == '-') {
				++lp;
				sscanf (lp, "%hd%*c%n", &cd2, &n);//%*c - ignore , or ;
				lp += n;
				crnt = std::make_pair (cd1, cd2);
			} else {
				crnt = std::make_pair (cd1, cd1);
				++lp;//ignore , or ;
			}
			//now processing crnt
		
			gr.push_back (std::vector <int> ());
			bool flag = 0;
			for (; prp < crp && vec[prp].second < crnt.first; ++prp);
			for (; prp < crp && vec[prp].first <= crnt.second; ++prp) {
				flag = 1;
				gr.back ().push_back (prp);
				gr[prp].push_back (vec.size ());
			}
			if (flag) --prp;
//			printf (" (%hd %hd)", crnt.first, crnt.second);
			vec.push_back (crnt);
		}
//		puts ("");
		prp = crp;
		crp = vec.size ();
	}

	for (i = 0; i < (int)vec.size (); ++i)
		if (!used[i])
			bfs (i);

//	puts ("");
	std::sort (data.begin (), data.end (), std::greater <int> ());

	int cc = 1;
	for (i = 1; i < (int)data.size (); ++i) {
		if (data[i] != data[i-1]) {
			printf ("%d %d\n", data[i-1], cc);
			cc = 0;
		}
		++cc;
	}

	if (data.size ()) printf ("%d %d\n", data.back (), cc);

	return 0;
}
/*
	for (i = 0; i < (int)vec.size (); ++i) {
		printf ("%d -- (%hd %hd) -->", i, vec[i].first, vec[i].second);
		for (size_t j = 0; j < gr[i].size (); ++j)
			printf (" %d_(%hd %hd)", gr[i][j], vec[gr[i][j]].first, vec[gr[i][j]].second);
		puts ("");
	}
*/
