/*
TASK: bitwise
LANG: C++

FROM: BaOI 2006 day 1
PROB: bitwise
KEYW: ad-hoc
*/

#include <cstdio>
#include <vector>
#include <algorithm>

const int MAXN = 1 << 7;

int A, N;
std::vector <int> db[MAXN];
int cnstp[MAXN];

void prnt_db () {
	int i, j;
	for (i = 0; i < N; ++i) {
		printf ("%d (%d) -->", i, cnstp[i]);
		for (j = 0; j < (int)db[i].size (); ++j)
			printf ("%d ", db[i][j]);
		printf ("\n");
	}
}

int get_const (std::pair <int, int> &a) {
	static int i, ret;
	for (i = 30; i >= 0 && (a.first & (1 << i)) == (a.second & (1 << i)); --i);
	ret = ((a.first >> (i + 1)) << (i + 1));
//	printf ("from %d %d -- ", a.first, a.second);
	a.first &= (1 << (i + 1)) - 1;
	a.second &= (1 << (i + 1)) - 1;
//	printf ("%d %d   %d\n", a.first, a.second, ret);
	return ret;
}

bool cmp (int a, int b) {
	return a > b;
}

bool ask (int id, int bit) {
	return ((cnstp[id] & (1 << bit)) || (db[id][0] >= (1 << bit)));
}

void take (int id, int bit) {
	if (cnstp[id] & (1 << bit)) return;
	if (db[id][0] >= (1 << (bit + 1)))
		cnstp[id] |= (1 << (bit + 1)) - 1;//no more problems, no need to change db
	else {
		db[id][0] &= (1 << bit) - 1;//remove the first bit
		std::sort (db[id].begin (), db[id].end (), cmp);
	}
}

int main () {
	scanf ("%d %d", &A, &N);

	int i, tmp;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &tmp);
		db[i].resize (tmp);
	}

	int ii = 0, jj = 0;
	std::pair <int, int> b;
	for (i = 0; i < A; ++i) {
		scanf ("%d %d", &b.second, &b.first);
		cnstp[ii] |= get_const (b);
		db[ii][jj++] = b.first;
		if (jj == (int)db[ii].size ()) {std::sort (db[ii].begin (), db[ii].end (), cmp); jj = 0; ++ii;}
	}

//	prnt_db ();

	int ans = 0;
	for (ii = 30; ii >= 0; --ii) {
		for (i = 0; i < N && ask (i, ii); ++i);
//		printf ("-->%d %d\n", ii, i);
		if (i != N) continue;
		ans |= 1 << ii;
//		printf ("new ans == %d\n", ans);
		for (i = 0; i < N && (take (i, ii), 1); ++i);
//		prnt_db ();
	}

	printf ("%d\n", ans);

	return 0;
}
