/*
TASK: city
LANG: C++

FROM: BaOI 2006 day 2
PROB: city
KEYW: heap, optimizations, greedy
*/

#include <cstdio>
#include <cstdlib>

#include <algorithm>
#include <vector>
#include <queue>

const int MAXK = 1 << 15;

long long N, T;
int K;
int c[MAXK];
int line[MAXK];

struct cmp {
	bool operator () (int a, int b) {return c[a] + line[a] * T != c[b] + line[b] * T ? c[a] + line[a] * T > c[b] + line[b] * T : a < b;}
};

std::priority_queue <int, std::vector <int>, cmp> q;

int main () {
	scanf ("%Ld %Ld %d", &N, &T, &K);

	int i;
	for (i = 0; i < K; ++i)
		scanf ("%d", c + i);

	for (i = 0; i < K; ++i) line[i] = -1;

	line[0] = 0;
	q.push (0);

	long long res = 0;
	int crnt;
	while (N > 0) {
		crnt = q.top (); q.pop ();

		printf ("%d %d(%Ld) -- (%Ld)\n", crnt, line[crnt], N, (line[crnt] + 1) * 4ll);
		if (N > (line[crnt] + 1) * 4ll) {
			N -= (line[crnt] + 1) * 4ll;
			res += (line[crnt] + 1) * 4ll * (T * line[crnt] + c[crnt]);
		} else {
			res += N * (T * line[crnt] + c[crnt]);
			N = 0;
			break;
		}

		++line[crnt]; q.push (crnt);
		if (crnt == K-1) {
			break;
		} else if (line[crnt+1] == -1) {
			++line[crnt+1];
			q.push (crnt+1);
		}
	}
	printf ("N == %Ld\n", N);
	if (N == 0) {printf ("%Ld\n", res); exit (0);}

	for (i = 0; i < K; ++i) printf ("%d ", line[i]); printf ("\n");
	printf ("res == %Ld, N == %Ld\n", res, N);

	long long Sp = 0, Sc = 0, Str = 0;
	long long SA = 0;
	for (i = 0; i < K; ++i) {
		Sp += (line[i] + 1) * 4;
		Sc += c[i];
		Str += line[i] * T;
		SA += (line[i] + 1) * 4ll * (c[i] + line[i] * T);
	}

	printf ("%Ld %Ld %Ld -- %Ld\n", Sc, Sp, Str, SA);

	int diff = 0;
	while (N >= Sp) {
		N -= Sp;
		res += SA;
		SA += 4ll * Sc + Sp + Str + 1;
		Sp += 4ll * K;
		Str += K * T;
		++diff;
	}

	printf ("%Ld %Ld %Ld -- %Ld\n", Sc, Sp, Str, SA);

	printf ("diff == %d\n", diff);

	while (N > 0) {
		crnt = q.top (); q.pop ();

		if (N > (line[crnt] + 1 + diff) * 4ll) {
			N -= (line[crnt] + 1 + diff) * 4ll;
			res += (line[crnt] + 1 + diff) * 4ll * (T * line[crnt] + c[crnt] + diff);
		} else {
			res += N * (T * line[crnt] + diff + c[crnt]);
			N = 0;
			break;
		}

		++line[crnt]; q.push (crnt);
	}

	printf ("%Ld\n", res);

	return 0;
}
