/*
TASK: countries
LANG: C++

FROM: BaOI 2006 day 1
PROB: countries
KEYW: full exhaustion
*/

#include <cstdio>

const int MAXN = 1000;//short in memory;

struct drob {
	long long a, b;
	drob () {}
	drob (long long _a, long long _b) : a (_a), b (_b) {}
	drob (const drob &x) : a (x.a), b (x.b) {}
	long long cmp (const drob &x) {return a * x.b - b * x.a;}
};

int N;
int x[MAXN];
int y[MAXN];
int s[MAXN];
int p[MAXN];
bool isD[MAXN];

int dst (int a, int b) {
	return (x[a] - x[b]) * (x[a] - x[b]) + (y[a] - y[b]) * (y[a] - y[b]);
}

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i)
		scanf ("%d %d %d", x + i, y + i, s + i);

	for (i = 0; i < N; ++i) p[i] = i;

	drob max_infl, tmp;
	long long tcmp;
	bool two;
	for (i = 0; i < N; ++i) {
		max_infl = drob (0, 1);//no influence
		two = 0;
		for (j = 0; j < N; ++j) {
			if (i == j) continue;

			tmp = drob (s[j], dst (i, j));
			tcmp = tmp.cmp (max_infl);
			if (!tcmp)
				two = 1;
			else if (tcmp > 0) {
				max_infl = tmp;
				p[i] = j;
				two = 0;
			}
		}

		if (max_infl.cmp (drob (s[i], 1)) > 0) {
			if (two) {
				p[i] = i;
				isD[i] = 1;
			}
		} else
			p[i] = i;
	}
//	printf ("!!\n");
//	for (i = 0; i < N; ++i) printf ("%d ", p[i]); printf ("\n");

	for (i = 0; i < N; ++i)
		for (; p[i] != p[p[i]]; p[i] = p[p[i]]);
	for (i = 0; i < N; ++i)
		if (isD[i])
			printf ("D\n");
		else if (p[i] == i)
			printf ("K\n");
		else
			printf ("%d\n", p[i] + 1);

	return 0;
}
