#include <cstdio>
#include <cassert>
#include <cctype>
#include <climits>
#include <vector>

const int MAXN = 4000;
const int MAXL = 512;
const int MAXMOD = 16;

int N;
int funk[MAXN][MAXL], fs[MAXN];
int A[MAXN];
int mod[MAXN];
enum {PLUS = INT_MAX-5, MINUS = INT_MAX-4, MUL = INT_MAX-3, LB = INT_MAX-2, X = INT_MAX-1, Y = INT_MAX};

std::vector <int> gr[MAXN];

int _nod (int a, int b) {return b ? _nod (b, a % b) : a;}
int nod (int a, int b) {return a > b ? _nod (a, b) : _nod (b, a);}

void gen_funk (int id, char *line) {
	static int stk[MAXL], sp;
	static int fp;
	int cdig = 0, ds = 0;
	sp = fp = 0;

	stk[sp++] = LB;
	for (int i = 0; line[i]; ++i) {
		if (isdigit (line[i])) {
			if (!ds) {ds = 1; cdig = 0;}
			cdig *= 10;
			cdig += line[i] - '0';
			continue;
		} else if (ds) {
			ds = 0;
//			printf ("added %d\n", cdig);
			funk[id][fp++] = cdig % mod[id];
		}
//		printf ("in here %c\n", line[i]);
		switch (line[i]) {
			case 'x': funk[id][fp++] = X; break;
			case 'y': funk[id][fp++] = Y; break;
			case '(': stk[sp++] = LB; break;
			case '+': while (stk[sp-1] != LB) funk[id][fp++] = stk[--sp]; stk[sp++] = PLUS; break;
			case '-': while (stk[sp-1] != LB) funk[id][fp++] = stk[--sp]; stk[sp++] = MINUS; break;
			case '*': while (stk[sp-1] != LB && stk[sp-1] == MUL) funk[id][fp++] = stk[--sp]; stk[sp++] = MUL; break;
			case ')': while (stk[sp-1] != LB) funk[id][fp++] = stk[--sp]; --sp; break;//remove LB
		}
	}
	if (ds) funk[id][fp++] = cdig % mod[id];
	while (stk[sp-1] != LB) funk[id][fp++] = stk[--sp];
	fs[id] = fp;
/*
	for (int i = 0; i < fp; ++i) {
		if (funk[id][i] >= PLUS) {
			switch (funk[id][i]) {
				case PLUS: printf (" +"); break;
				case MINUS: printf (" -"); break;
				case MUL: printf (" *"); break;
				case X: printf (" x"); break;
				case Y: printf (" y"); break;
				default: printf ("WOW! %d\n", funk[id][i]); break;
			}
		} else printf (" %d", funk[id][i]);
	}
	printf ("\n");*/
}

int calc (int id, int x, int y) {
	static int stk[MAXL], sp;
	x %= mod[id]; y %= mod[id];
	sp = 0;

	for (int i = 0; i < fs[id]; ++i) {
		if (funk[id][i] >= PLUS) {
			switch (funk[id][i]) {
				case PLUS: stk[sp-2] += stk[sp-1]; stk[sp-2] %= mod[id]; --sp; break;
				case MINUS: stk[sp-2] -= stk[sp-1]; stk[sp-2] %= mod[id]; --sp; break;
				case MUL: stk[sp-2] *= stk[sp-1]; stk[sp-2] %= mod[id]; --sp; break;
				case X: stk[sp++] = x; break;
				case Y: stk[sp++] = y; break;
				default: assert (0);
			}
		} else
			stk[sp++] = funk[id][i];//a number
	}
	assert (sp == 1 && stk[0] < mod[id]);
	return stk[0];
}

char used[MAXMOD][MAXMOD];
int id1, id2;
int cub;
bool _try (int s1, int s2) {
//	printf ("%d %d\n", s1, s2);
	if (used[s1][s2]) return 1;//everything ok
	used[s1][s2] = 1;

	int a1, a2;
	for (int i = 0; i < cub; ++i) {
		a1 = calc (id1, s1, i);
		a2 = calc (id2, s2, i);
//		printf ("%d %d -%d-> %d %d\n", s1, s2, i, a1, a2);
		if (a1 == 0 && a2 != 0 || a1 != 0 && a2 == 0) return 0;//it is different
		if (!_try (a1, a2)) return 0;//it si different in the future
	}
	return 1;
}

int main () {
//	freopen ("out", "w", stderr);
/*
	char line[1000];
	gets (line);
	mod[0] = 100;
	gen_funk (0, line);
	int a, b;
	scanf ("%d %d\n", &a, &b);
	printf ("f(%d, %d) == %d\n", a, b, calc (0, a, b));*/

	static char line[MAXL];
	scanf ("%d\n", &N);
	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d\n", A + i, mod + i);
		assert (mod[i] < MAXMOD);
		A[i] %= mod[i];
		gets (line);
		gen_funk (i, line);
	}

	for (id1 = 0; id1 < N; ++id1)
		for (id2 = id1 + 1; id2 < N; ++id2) {
			cub = mod[id1] * mod[id2] / nod (mod[id1], mod[id2]);
			memset (used, 0, sizeof (used));
//			printf ("____%d %d_____\n", id1, id2);
			if (_try (A[id1], A[id2]))
				gr[id1].push_back (id2);
		}

	static bool used2[MAXN];
	for (i = 0; i < N; ++i) {
		if (used2[i]) continue;
		printf ("%d", i + 1);
		for (unsigned j = 0; j < gr[i].size (); ++j) {
			used2[gr[i][j]] = 1;
			printf (" %d", gr[i][j] + 1);
		}
		printf ("\n");
	}
	return 0;
}
