#include <cstdio>
#include <cassert>
#include <utility>
#include <algorithm>
#include <climits>

#define time first
#define pos second

const int MAXL = 1 << 9;

int L, D, M;
int crnt, old;
int dp[2][MAXL];

void gen (int tm) {
	static std::pair <int, int> q[MAXL];
	int p1 = 0, p3 = 0;

	int i;
	old = crnt; crnt = !crnt;
	
	q[p3++] = std::make_pair (dp[old][0], 0);
	for (i = 1; i <= ((tm) <? (L - D)); ++i) {
		q[p3++] = std::make_pair (dp[old][i], i);
		while (p3 - p1 > 1 && q[p3-1].first >= q[p3-2].first) {q[p3-2] = q[p3-1]; --p3;}
//		printf ("%d![", i); for (int j = p1; j < p3; ++j) printf ("(%d,%d)", q[j].first, q[j].second); printf ("]\n");
	}

	dp[crnt][0] = q[p1].first;

//	printf ("i + tm == %d, L-D == %d", 1 + tm, L - D);
	for (i = 1; i + tm <= L - D; ++i) {
//		printf ("here!\n");
		q[p3++] = std::make_pair (dp[old][i+tm], i + tm);
		while (p3 > p1 + 1 && q[p3-1].first >= q[p3-2].first) {q[p3-2] = q[p3-1]; --p3;}
//		printf ("q[p1].second == %d (%d)\n", q[p1].second, i - tm);
		if (q[p1].second < i - tm) {
			++p1;
			assert (p1 < p3);
		}
//		printf ("%d[", i+tm); for (int j = p1; j < p3; ++j) printf ("(%d,%d)", q[j].first, q[j].second); printf ("]\n");
		dp[crnt][i] = q[p1].first;
	}

	for (; i <= L - D; ++i) {
		if (q[p1].second < i - tm) ++p1;
//		printf ("%d[", i+tm); for (int j = p1; j < p3; ++j) printf ("(%d,%d)", q[j].first, q[j].second); printf ("]\n");
		dp[crnt][i] = q[p1].first;
	}
/*
	printf ("after time %d\n", tm);
	for (i = 0; i + D <= L; ++i) printf (" %d", dp[old][i]); printf ("\n");
	for (i = 0; i + D <= L; ++i) printf (" %d", dp[crnt][i]); printf ("\n");*/
}

void inc (int pos) {
	for (int i = (pos - D + 1) >? 0; i <= pos <? (L - D); ++i) {
//		printf ("increased %d\n", i);
		++dp[crnt][i];
	}
}

int main () {
	scanf ("%d %d %d", &L, &D, &M);

//	memset (dp[0], -1, sizeof (dp) / 2);
	for (int i = 0; i + D <= L; ++i) dp[crnt][i] = dp[old][i] = INT_MIN;
	dp[crnt][0] = 0;
	int ctime = 0;
	crnt = 0, old = 1;
	int i;
	std::pair <int, int> c;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &c.time, &c.pos);
//		printf ("now %d %d\n", c.time, c.pos);
		if (c.time != ctime) {
			gen (c.time - ctime);
			ctime = c.time;
		}
		inc (c.pos);
	}

	int res = 0;
	for (i = 0; i + D < L; ++i) {
		res >?= dp[crnt][i];
	}

	printf ("%d\n", res);

	return 0;
}
