/*
*/
#include <cstdio>
#include <cassert>
#include <utility>

const int MOD = 1000000000;

typedef std::pair <int, int> big;

big sq (big a) {
	big res (0,0);

	res.second = ((long long)a.second * (long long)a.second) % MOD;
	res.first = ((long long)a.second * (long long)a.second) / MOD;
	res.first += (2ll * ((long long)a.first * (long long)a.second)) % MOD;
	res.first %= MOD;

	assert (a.first < MOD);
	assert (a.second < MOD);
	assert (a.first >= 0 && a.second >= 0);

	return res;
}

big mul (big a, int k) {
//	printf ("%Ld %Ld(%Ld)\n", ((long long)a.first * k) % MOD + (a.second * k) / MOD, ((long long)a.second * k) % MOD, (long long)a.second * k);

	a.first = ((long long)a.first * (long long)k) % MOD + ((long long)a.second * (long long)k) / MOD;
	a.second = ((long long)a.second * (long long)k) % MOD;

	assert (a.first < MOD && a.second < MOD);
	assert (a.first >= 0 && a.second >= 0);

	return a;
}

big add (big a, const big &b) {
	a.second += b.second;
	a.first += a.second / MOD;
	a.second %= MOD;
	a.first += b.first;
	a.first %= MOD;
	assert (a.first < MOD && a.second < MOD);
	assert (a.first >= 0 && a.second >= 0);
	return a;
}

big fast_st (int bs, int st) {
	if (st == 1)
		return std::pair <int, int> (0, bs);
	else
		return (st & 1 ? mul (fast_st (bs, st-1), bs) : sq (fast_st (bs, st / 2)));
}

int main () {
	big res (0, 0);
	for (int i = 1; i <= 1000; ++i) {
		printf ("\r%d", i);
		res = add (res, fast_st (i, i));
		if (res.first < 0) {printf ("%d --\n", i); break;}
//		printf ("%d%9d\n", fast_st (i, i).first, fast_st (i, i).second);
	}

	printf ("%d %d\n", res.first, res.second);

	return 0;
}
