#include <cstdio>
#include <climits>
#include <algorithm>

const int MAXN = 1 << 10;

struct el {
	int beg;
	int end;
	el () {}
	el (int _beg, int _end) : beg (_beg), end (_end) {}
	bool operator < (const el &a) const {return beg < a.beg;}

	int len () const {return end - beg;}
};

int N, L, V, D1, R, D2;
el vecx[MAXN];
int NN;
el vec[MAXN];

void mytry (int &res, int beg, int len) {
	if (len <= V * R && res > beg + len)
		res = beg + len;
}

int main () {
	freopen ("vhs.in", "r", stdin);
	freopen ("vhs.out", "w", stdout);
	scanf ("%d %d %d %d %d %d\n", &N, &L, &V, &D1, &R, &D2);

	int i, j;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &vecx[i].beg, &vecx[i].end);

	vecx[N] = el (-1, 0);
	vecx[N+1] = el (L, L+1);
	N += 2;

	std::sort (vecx, vecx + N);

	for (i = 1; i < N; ++i) {
		if (vecx[i-1].end != vecx[i].beg)
			vec[NN++] = el (vecx[i-1].end, vecx[i].beg);
	}

	int res = INT_MAX;
	for (i = 0; i < NN; ++i) {
		if (vec[i].len () < D1) continue;
		if (vec[i].len () >= D1 + D2) {
			res = std::min (res, vec[i].beg);
			continue;
		}
		for (j = 0; j < NN; ++j) {
			if (j == i) continue;
			if (j < i)
				mytry (res, vec[i].beg, vec[i].beg - vec[j].end + D1 + D2);
			else
				mytry (res, vec[i].end - D1, vec[j].beg - vec[i].end);
		}
	}

	if (res == INT_MAX)
		printf ("IMPOSSIBLE\n");
	else
		printf ("%.6lf\n", (double)res / V);

	return 0;
}
