#define NDEBUG

#include <cstdio>
#include <vector>
#include <utility>
#include <cstring>
#include <algorithm>
#include <cassert>
// #include <map>

#define MAXN 1024
#define MAXK 128

using namespace std;

typedef pair<int, int> PII;

int gcd(int a, int b)
{
	while (b)
	{
		int tmp = a % b;
		a = b;
		b = tmp;
	}
	return a;
}

const int PRIMES = 168;
int primes[PRIMES];
struct Num
{
	//map<int, int> p;
	vector<pair<int, int> > p;
	Num() {}

	Num(int x) {
		for (int i = 0; primes[i] * primes[i] <= x; ++i)
		{
			int c = 0;
			while (x % primes[i] == 0)
			{
				c++;
				x /= primes[i];
			}
			if (c > 0)
			{
				p.push_back(PII(primes[i], c));
				// p[lower_bound(primes, primes + PRIMES, i) - primes] = c;
			}
		}
		if (x != 1) {
			// p[lower_bound(primes, primes + PRIMES, x) - primes] = 1;
			p.push_back(PII(x, 1));
			assert(binary_search(primes, primes + PRIMES, x));
		}
	}

	bool divisible(const Num& x)
	{
	/*
		for (map<int, int>::const_iterator it = x.p.begin(); it != x.p.end(); it++)
		{
			map<int, int>::const_iterator it2 = p.find(it->first);
			if (it2 == p.end() || it2->second < it->second)
			{
				return false;
			}
		}
		return true;
	*/
	/*
		printf("in divisible : ");
		this->prnt();
		x.prnt();*/
		int id1 = 0;
		for (int id2 = 0; id2 < (int) x.p.size(); ++id2) {
			while (id1 < (int) p.size() && p[id1].first < x.p[id2].first)
				++id1;
			//printf("--- %d %d\n", id1, id2);
/*			if (id1 == (int) p.size() && p[id1].first != x.p[id2].first) {
				printf("WOOOOW %d %d\n", id1, id2);
				this->prnt();
				x.prnt();
				assert(id1 == (int) p.size() || p[id1].first == x.p[id2].first);
			}*/

			if (id1 == (int) p.size()
				|| p[id1].first != x.p[id2].first
				|| p[id1].second < x.p[id2].second) {
					//printf("FALSE\n");
					return false;
			}
			++id1;
		}
		//printf("TRUE!\n");
		return true;
	}

	void multiply(const Num& x)
	{
/*		for (map<int, int>::const_iterator it = x.p.begin(); it != x.p.end(); it++)
		{
			p[it->first] += it->second;
		}
*//*
		for (int i = 0; i < PRIMES; ++i)
			p[i] += x.p[i];*/
		vector<pair<int, int> > vn;
		int id1 = 0, id2 = 0;
		while (id1 < (int) p.size() && id2 < (int) x.p.size()) {
			if (p[id1].first == x.p[id2].first) {
				vn.push_back(PII(p[id1].first, p[id1].second + x.p[id2].second));
				++ id1;
				++ id2;
			} else if (p[id1].first < x.p[id2].first) {
				vn.push_back(p[id1++]);
			} else {
				vn.push_back(x.p[id2++]);
			}
		}
		vn.insert(vn.end(), p.begin() + id1, p.end());
		vn.insert(vn.end(), x.p.begin() + id2, x.p.end());
		p = vn;
	}

	void divide(const Num& x)
	{
	/*
		for (map<int, int>::const_iterator it = x.p.begin(); it != x.p.end(); ++it)
		{
			map<int, int>::iterator it2 = p.find(it->first);
			it2->second -= it->second;
			if (it2->second == 0)
			{
				p.erase(it2);
			}
		}
	*/
		int readp = 0, writep = 0;
		for (int id2 = 0; id2 < (int) x.p.size(); ++id2) {
			while (p[readp].first < x.p[id2].first) {
				p[writep++] = p[readp++];
			}
			if (x.p[id2].second != p[readp].second) {
				p[writep++] = PII(x.p[id2].first, p[readp++].second - x.p[id2].second);
			}
		}
		p.resize(writep);
	}

	int powerOfTwo()
	{
		if (p.size() != 1 || p[0].first != 2)
			return -1;
		return p[0].second;
	}

	void prnt() const {
		if (p.size() == 0)
			printf(" 1");
		for (int i = 0; i < (int) p.size(); ++i)
			printf(" %d^%d", p[i].first, p[i].second);
		puts("");
	}
};

Num a[MAXN], b[MAXN];

int main()
{
	static bool erat[1000];
	int prp = 0;
	int i;
	for (i = 2; i * i <= 1000; ++i) {
		if (erat[i]) continue;
		primes[prp++] = i;
		for (int j = i * i; j <= 1000; j += i)
			erat[j] = 1;
	}
	for (; i < 1000; ++i)
		if (!erat[i])
			primes[prp++] = i;
	assert(prp == PRIMES);
/*
	for (int i = 0; i < PRIMES; ++i)
		printf(" %d", primes[i]);
	puts("");
*/
	//freopen("H.in", "r", stdin);
	int n, m, k;
	while(1)
	{
		scanf("%d", &m);
		if (m == 0)
			break;
		scanf("%d", &n);
		scanf("%d", &k);
		for (int i = 0; i < k; i++)
		{
			int at, bt;
			scanf("%d%d", &at, &bt);
			int g = gcd(at, bt);
			at /= g;
			bt /= g;
			a[i] = Num(at);// a[i].prnt();
			b[i] = Num(bt);// b[i].prnt();
		}
		//printf("done input\n");

		Num x = Num(n);
		//puts("start with!!");
		//x.prnt();
		int cnt = 0;
		while (cnt < m)
		{
			//printf("this step!\n");
			//x.prnt();
			int tmp = x.powerOfTwo();
			if (tmp >= 0)
			{
				if (cnt > 0)
					printf(" ");
				printf("%d", tmp);
				cnt++;
				if (cnt == m) break;;
			}
			int i;
			for (i = 0; i < k; i++)
			{
				if (x.divisible(b[i]))
				{
					//printf("use %d!!\n", i);
					x.divide(b[i]);
					x.multiply(a[i]);
					break;
				}
			}
			assert(i != k);
			//printf("leave it??\n");
		}
		printf("\n");
	}
	return 0;
}
