/*
TASK: d
LANG: C++
*/

#include <cstdio>
#include <cassert>
#include <cstring>

int pr[128], pc;
const int MAX = 32;
const int BASE = 1000000;

struct long_sum {
	int m[MAX];
	long_sum () {memset (m, 0, sizeof (m));}
	long_sum& operator *= (int a) {
		static int i, pr;
		
		for (i = pr = 0; i < MAX; ++i) {
			m[i] *= a;
			m[i] += pr;
			pr = m[i] / BASE;
			m[i] %= BASE;
		}
		assert (pr==0);
		return *this;
	}
	long_sum& operator += (const long_sum &a) {
		static int i, pr;
		for (i = pr = 0; i < MAX; ++i) {
			m[i] += a.m[i];
			m[i] += pr;
			pr = m[i] / BASE;
			m[i] %= BASE;
		}
		assert (pr==0);
		return *this;
	}
	void prnt () const {
		static int i;
		for (i = MAX-1; i && !m[i]; --i);
		printf ("%d", m[i]);
		for (--i; i >= 0; --i) printf ("%06d", m[i]);
	}
};

struct long_mul {
	int st[MAX];
	long_mul () {memset (st, 0, sizeof (st));}
	long_mul& operator = (const long_mul &a) {memcpy (st, a.st, sizeof (st)); return *this;}
	long_mul& operator /= (const long_mul &a) {
		static int i;
		for (i = 0; i < pc;	++i)
			st[i] -= a.st[i];
		return *this;
	}
	long_sum convert () {
		static int i, j;
		static long_sum res;
		memset (res.m, 0, sizeof (res.m));
		res.m[0] = 1;
		for (i = 0; i < pc; ++i)
			for (j = 0; j < st[i]; ++j)
				res *= pr[i];
		return res;
	}
};

long_mul perm[128];

int main () {
	int N;
	scanf ("%d", &N);

	int i, j;
	for (i = 2; i < 64; ++i) {
		for (j = 2; j < i; ++j)
			if (!(i % j))
				break;
		if (j == i)
			pr[pc++] = i;
	}
	
	perm[2].st[0] = 1;
	for (i = 3; i <= 64; ++i) {
		perm[i] = perm[i-1];
		int ii = i;
		for (j = 0; j < pc; ++j)
			if (ii % pr[j] == 0) {
				ii /= pr[j];
				++perm[i].st[j];
				--j;
			}
	}
	long_mul tmp;
	long_sum sum;
	for (i = 0; i <= N; i += 2) {
		for (j = 0; i + j <= N; j += 2) {
			tmp = perm[N];
			tmp /= perm[i];
			tmp /= perm[j];
			tmp /= perm[N-i-j];
			sum += tmp.convert ();
		}
	}

	for (i = 0; i < N; ++i)
		sum *= 2;

	sum.prnt (); puts ("");

	return 0;
}
/*
	for (i = 0; i < 10; ++i) {
		printf ("%d ->", i);	
		for (j = 0; j < 10; ++j)
			printf (" %d", perm[i].st[j]);
		printf ("\n");
	}
*/
/*	printf ("WTF!!\n"); fflush (stdout);
	long_sum tmp;
	for (i = 0; i < 20; ++i) {
		printf ("%d -- ", i); perm[i].convert ().prnt (); puts ("-----------------------");
	}
*/
