/*
TASK: e
LANG: C++
*/

#include <cstdio>
#include <cstdlib>
#include <queue>

const double EPS = 1e-9;
const int MAXN = 1 << 5;

struct pnt_int {
	int x, y;
	pnt_int () {}
	pnt_int (int _x, int _y) : x (_x), y (_y) {}
	pnt_int operator - (const pnt_int &a) const {return pnt_int (x - a.x, y - a.y);}
};

long long _nod (long long a, long long b) {return b ? _nod (b, a % b) : a;}
long long nod (long long a, long long b) {return a > b ? _nod (a, b) : _nod (b, a);}
struct dr {
	long long x, y;
	dr () {}
	dr (const long long &_x, const long long &_y) : x (_x), y (_y) {skr ();}
	dr& ass (const long long &_x, const long long &_y) {x = _x; y = _y; skr (); return *this;}
	dr operator - (const dr &a) const {
		return dr (x * a.y - y * a.x, y * a.y);
	}
	dr& operator *= (const dr &a) {
		x *= a.x;
		y *= a.y;
		skr ();
		return *this;
	}
	dr& operator += (const dr &a) {
		return ass (x * a.y + y * a.x, y * a.y);	
	}
	void skr () {
		static long long k;
		k = nod (llabs (x), llabs (y));
		x /= k;
		y /= k;
		if (y < 0) {y = -y; x = -x;}
	}
	void prnt () const {
		printf ("%Ld/%Ld", x, y);
	}
};

struct pnt_dr {
	dr x, y;
	pnt_dr () {}
	pnt_dr (dr _x, dr _y) : x (_x), y (_y) {}
	pnt_dr operator - (const pnt_dr &a) const {return pnt_dr (x - a.x, y - a.y);}
	pnt_dr& operator *= (const dr &a) {x *= a; y *= a; return *this;}
	pnt_dr& operator += (const pnt_dr &a) {x += a.x; y += a.y; return *this;}
	void prnt () const {x.prnt (); putchar (' '); y.prnt ();}
};

struct el {
	pnt_dr p;
	int w;
	el () {}
	el (const pnt_dr &_p, int _w) : p (_p), w (_w) {}
};

int N;
pnt_int vec[MAXN][2];
pnt_dr vec2[MAXN * MAXN];
std::queue <el> q;

int v2p;

int S (const pnt_int &a, const pnt_int &b, const pnt_int &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

pnt_dr _int_p;
bool intersect (const pnt_int &a1, const pnt_int &a2, const pnt_int &b1, const pnt_int &b2) {
	static int S1, S2;
	static pnt_int rv;
	
	S1 = S (a1, b1, b2);
	S2 = S (b1, a2, b2);
//	printf ("%d %d  %d %d  %d %d  %d %d -- %d %d\n", a1.x, a1.y, a2.x, a2.y, b1.x, b1.y, b2.x, b2.y, S1, S2);

	if (S (a1, a2, b1) * S (a1, a2, b2) < 0 && S1 + S2 && S1 * (S1 + S2) > 0 && abs (S1) < abs (S1 + S2)) {
//		printf ("%d %d  %d %d  %d %d  %d %d -- %d %d\n", a1.x, a1.y, a2.x, a2.y, b1.x, b1.y, b2.x, b2.y, S1, S2);
		rv = (a2 - a1);
//		printf ("%d %d\n", rv.x, rv.y);
		_int_p.x = dr (S1 * rv.x + (S1 + S2) * a1.x, S1 + S2);
		_int_p.y = dr (S1 * rv.y + (S1 + S2) * a1.y, S1 + S2);
//		printf ("%d/%d  %d/%d\n", _int_p.x.x, _int_p.x.y, _int_p.y.x, _int_p.y.y);
		return 1;
	}

	return 0;
}

pnt_dr ff (const el &a, const el &b) {
	static pnt_dr rv;
	rv = b.p - a.p;
//	printf ("rv %Ld/%Ld %Ld/%Ld\n", rv.x.x, rv.x.y, rv.y.x, rv.y.y);
	rv *= dr (b.w, a.w + b.w);
//	printf ("after %Ld/%Ld %Ld/%Ld\n", rv.x.x, rv.x.y, rv.y.x, rv.y.y);
	rv += a.p;
	return rv;
}

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i)
		scanf ("%d %d %d %d", &vec[i][0].x, &vec[i][0].y, &vec[i][1].x, &vec[i][1].y);

	for (i = 0; i < N; ++i)
		for (j = i + 1; j < N; ++j)
			if (intersect (vec[i][0], vec[i][1], vec[j][0], vec[j][1]))
				vec2[v2p++] = _int_p;
/*
	for (i = 0; i < v2p; ++i)
		vec2[i].prnt (), puts ("");
*/
	for (i = 0; i < v2p; ++i)
		q.push (el (vec2[i], 1));

	el c1, c2;
	pnt_dr c3;
	while (q.size () > 1) {
		c1 = q.front (); q.pop ();
		c2 = q.front (); q.pop ();
		c3 = ff (c1, c2);
//		c1.p.prnt (); putchar ('|'); c2.p.prnt (); putchar ('*'); c3.prnt (); putchar ('\n');
		q.push (el (c3, c1.w + c2.w));
	}

	q.front ().p.prnt (); puts ("");

	return 0;
}

/*	int x, y;
	scanf ("%d %d", &x, &y);

	double d = 1;
	double bi = 0;
	double mmin = 1e100;
	for (double i = 0; i < d; i += 1e-6) {
		if (mmin > i * i * x + (d - i) * (d - i) * y) {
			mmin = i * i * x + (d - i) * (d - i) * y;
			bi = i;
		}
	}

	printf ("%.6lf <> %.6lf(%lf(%lf))\n", (double)x / y, (d - bi) / bi,  bi, mmin);
*/
