/*
TASK: f
LANG: C++
*/

#include <cstdio>
#include <climits>
#include <vector>

const int MAXN = 1 << 8;
const int MAXM = 1 << 15;

int N, rN, M;
std::vector <int> vec[MAXN];
std::vector <int> vec2[MAXN];
int D[MAXN];
int start[MAXN];

void bfs (int s) {
	static int q[MAXN];
	static int i, j, p3;

	for (i = 0; i < rN; ++i) D[i] = INT_MAX;
	for (i = 0; i < N; ++i) start[i] = -1;

	D[q[p3++] = s] = 0;
	for (i = 0; i < p3; ++i) {
//		printf ("%d - %d\n", q[i], D[q[i]]);
		if (q[i] < N) {
			start[D[q[i]]] = q[i];
			D[q[i]+N] = D[q[i]] + 1;
			q[p3++] = q[i] + N;
		} else {
			for (j = 0; j < (int)vec[q[i]].size (); ++j) {
				if (D[vec[q[i]][j]] == INT_MAX) {
					D[vec[q[i]][j]] = D[q[i]];
					q[p3++] = vec[q[i]][j];
				}
			}
		}
	}
}

bool used[MAXN];
int _cnt, _ctime;

void dfs (int a) {
	used[a] = 1;
	++_cnt;
	for (unsigned i = 0; i < vec2[a].size (); ++i)
		if (!used[vec2[a][i]] && D[vec2[a][i] + N] > _ctime) dfs (vec2[a][i]);
}

int main () {
	scanf ("%d %d", &N, &M);
	rN = N + N;

	int i;
	int a, b;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		vec[a+N].push_back (b);
		vec[b+N].push_back (a);
		vec2[a].push_back (b);
		vec2[b].push_back (a);
	}
	for (i = 0; i < N; ++i) vec[i].push_back (i + N);

	scanf ("%d", &a);
	--a;

	bfs (a);
/*
	for (i = 0; i < N; ++i)
		printf ("%d ", D[i+N]);
	printf ("\n");
*/
	int expected[MAXN] = {0};
	for (i = 1; i < N; ++i) {
		for (int j = 0; j < N; ++j)
			expected[i] += (D[j+N] > i);
//		printf ("ex %d %d\n", i, expected[i]);
	}

	for (_ctime = 1; _ctime < N; ++_ctime) {
		if (start[_ctime] == -1) continue;
		memset (used, 0, sizeof (used));
		_cnt = 0;
//		dfs (start[_ctime]);
//		printf ("%d -start-> %d\n", _ctime, start[_ctime]);
//		printf ("%d --> %d\n", _ctime, _cnt);
		if (dfs (start[_ctime]), _cnt < expected[_ctime]) {printf ("%d\n", _ctime); break;}
	}

	if (_ctime == N) printf ("-1\n");

	return 0;
}
