/*
FROM: acm.timus.ru
PROB: 1002 (Phone numbers)
*/

#include <cstdio>
#include <cstring>
#include <utility>

#define x first
#define y second

typedef unsigned uint;
typedef std::pair <uint, uint> pii;

const int MAX_STR_LEN = 128;
const int MAX_WORDS = 1 << 16;
const int MAX_WORD_LEN = 64;

const pii BASE (13, 17);

pii operator + (const pii &a, const pii &b) {return pii (a.x + b.x, a.y + b.y);}
pii operator - (const pii &a, const pii &b) {return pii (a.x - b.x, a.y - b.y);}
pii operator * (const pii &a, const pii &b) {return pii (a.x * b.x, a.y * b.y);}

//			 a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w, x, y, z
int ref[] = {2, 2, 2, 3, 3, 3, 4, 4, 1, 1, 5, 5, 6, 6, 0, 7, 0, 7, 7, 8, 8, 8, 9, 9, 9, 0};

int L;
char str[MAX_STR_LEN];
pii _hash[MAX_STR_LEN];
pii hasht[MAX_STR_LEN][MAX_STR_LEN];

pii powb[MAX_STR_LEN];

int W;
char words[MAX_WORDS][MAX_WORD_LEN];
int wlen[MAX_WORDS];
pii _whash[MAX_WORDS];

pii hash (int pos, int len) {
	return _hash[pos + len] - _hash[pos] * powb[len];
}

pii cdup (int c) {
	return pii (c + 1, c + 2);
}

pii dup (uint c) {
	return pii (c, c);
}

uint dp[MAX_STR_LEN];
int prev[MAX_STR_LEN];

uint min (uint a, uint b) {
	return a < b ? a : b;
}

int main () {
	while (gets (str + 1), str[1] != '-') {
//		gets (str + 1);
		L = strlen (str + 1);

		powb[0] = dup (1);
		int i, j;
		for (i = 1; i <= L; ++i) {
			_hash[i] = _hash[i-1] * BASE + cdup (str[i] - '0');
			powb[i] = powb[i-1] * BASE;
		}

		scanf ("%d\n", &W);
		for (i = 0; i < W; ++i) {
			gets (words[i]);
			_whash[i] = dup (0);
			for (j = 0; words[i][j] != '\0'; ++j)
				_whash[i] = _whash[i] * BASE + cdup (ref[words[i][j] - 'a']);
			wlen[i] = j;
		}

/*		printf ("words!!\n");
		for (i = 0; i < W; ++i) {
			for (j = 0; words[i][j] != '\0'; ++j)
				printf ("%d ", ref[words[i][j]-'a']);
			printf ("%u %u\n", _whash[i].x, _whash[i].y);
			puts ("");
		}
*/

		for (j = 1; j <= L; ++j) {
			for (i = 0; i + j <= L; ++i)
				hasht[i][j] = hash (i, j);
		}

		memset (dp, -1, sizeof (dp));//inf
		dp[0] = 0;
		for (i = 0; i < L; ++i) {
			if (dp[i] == (uint)-1) continue;
			for (j = 0; j < W; ++j)
				if (hasht[i][wlen[j]] == _whash[j])
					if (dp[i] + 1 < dp[i + wlen[j]]) {
						dp[i + wlen[j]] = dp[i] + 1;
						prev[i + wlen[j]] = j;
					}
		}
		if (dp[L] == (uint)-1) {
			printf ("No solution.\n");
		} else {
			static int ans[1 << 20], ap;
			ap = 0;
			for (i = L; i != 0; i -= wlen[prev[i]])
				ans[ap++] = prev[i];
			printf ("%s", words[ans[--ap]]);
			for (--ap; ap >= 0; --ap)
				printf (" %s", words[ans[ap]]);
			puts ("");
		}
	}


	return 0;
}
