#include <cstdio>
#include <cstring>
#include <algorithm>
#include <utility>
using namespace std;

typedef pair<int,bool> PIB;

const int MAX_M = 5000+5;

int n, m;
struct tt { int a, b; bool c; } A[MAX_M];      // queries
int C[2*MAX_M];    // compressed
PIB prev[2*MAX_M]; // prev in the tree

void input ()
{
	int i;
	char c[10];
	
	for (i=0; i<m; i++) {
		scanf ("%d%d%s", &A[i].a, &A[i].b, c);
		A[i].c = ( strcmp(c,"odd")==0 );
		
		A[i].b ++;
		
		C[2*i  ] = A[i].a;
		C[2*i+1] = A[i].b;
	}
	
	sort (C,C+2*m);
	n = unique(C,C+2*m) - C;
}

bool find_root (int p, int &root)
{
	bool cond=0;
	
	for (; prev[p].first != p; p=prev[p].first)
		cond ^= prev[p].second;
		
	root = p;
		
	return cond;
}

void solve ()
{
	int i;
	int a, b, c;
	int cond_a, cond_b;
	int root_a, root_b;
	
	for (i=0; i<n; i++) prev[i] = PIB(i,0);
	
	for (i=0; i<m; i++) {
		a = lower_bound (C,C+n,A[i].a) - C;
		b = lower_bound (C,C+n,A[i].b) - C;
		c = A[i].c;
		
		cond_a = find_root (a, root_a);
		cond_b = find_root (b, root_b);
		
		if ( root_a == root_b) {
			if ( cond_a != c ^ cond_b )	{
				printf ("%d\n", i);
				return; 
			}
		}
		else {
			prev[a] = PIB (b, cond_b ^ c);
		}
	}	
	
	printf ("%d\n", m);
}

int main ()
{
	while ( scanf("%d%d", &n, &m) != 2 ) {
		input ();
		solve ();
	}

	return 0;
}