/*
FROM: acm.timus.ru
PROB: 1004 (Sightseeing trip)
KEYW: find shortest cycle (dijkstra N ^ 2)
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 7;
const int INF = 0x7f7f7f7f;
const int INF2 = 500 * MAXN;

int N, M;
int ma3x[MAXN][MAXN];

int res;
int prev[MAXN];
int path[MAXN], pp;

int min (int a, int b) {
	return a < b ? a : b;
}

int dijkstra (int s, int f) {
	static int d[MAXN];
	static bool used[MAXN];
	memset (d, 0x7f, sizeof (d));
	memset (used, 0, sizeof (used));
	d[s] = 0;
	prev[s] = -1;
	
	for (;;) {
		int i, j;
		int min = INF2, mini = -1;
		for (i = 0; i < N; ++i) {
			if (!used[i] && d[i] < min) {
				min = d[i];
				mini = i;
			}
		}
		if (mini == -1) return INF2;//no way
		if (mini == f) return d[mini];
		used[mini] = 1;
		for (j = 0; j < N; ++j) {
			if (ma3x[mini][j] == INF) continue;
			if (d[j] > d[mini] + ma3x[mini][j]) {
				d[j] = d[mini] + ma3x[mini][j];
				prev[j] = mini;
			}
		}
	}
}

int main () {
	while (scanf ("%d %d", &N, &M) == 2) {
		memset (ma3x, 0x7f, sizeof (ma3x));
		int i, j;
		int a, b, c;
		for (i = 0; i < M; ++i) {
			scanf ("%d %d %d", &a, &b, &c);
			--a; --b;
			ma3x[b][a] = ma3x[a][b] = min (ma3x[a][b], c);
		}

		int len, tmp;
		res = INF2;
		for (i = 0; i < N; ++i)
			for (j = i + 1; j < N; ++j) {
				if (ma3x[i][j] == INF) continue;
				tmp = ma3x[i][j];
				ma3x[i][j] = ma3x[j][i] = INF;
				if ((len = dijkstra (i, j)) + tmp < res) {
					res = len + tmp;
					pp = 0;
					for (int ii = j; ii != -1; ii = prev[ii])
						path[pp++] = ii;
				}
			}
		if (res != INF2) {
			printf ("%d", path[0] + 1);
			for (i = 1; i < pp; ++i)
				printf (" %d", path[i] + 1);
			puts ("");
		} else
			printf ("No solution.\n");
	}

	return 0;
}
