/*
FROM: acm.timus.ru
PROB: 1006 (Square frames)
KEYW: full exhaustion
*/

#include <cstdio>
#include <vector>
#include <cstring>
//#include <cassert>

void assert(bool cond) {
	while(!cond) ;
}

struct sqr {
	int x, y;
	int l;
	sqr() {}
	sqr(int _x, int _y, int _l) : x(_x), y(_y), l(_l) {}
};

typedef unsigned char uchar;

const int MAXR = 32;
const int MAXC = 64;

const int N = 20;
const int M = 50;

const int dx[] = {-1,  0,  1,  0,   -1,  0,  1,  0, };
const int dy[] = { 0,  1,  0, -1,    0,  1,  0, -1, };

#ifdef ONLINE_JUDGE
const uchar C[] = {218, 191, 217, 192};
const uchar S[] = {179, 196};
#else
const uchar C[] = {'/', '\\', ';', ':'};
const uchar S[] = {'|', '-'};
#endif
const uchar E = '.';
const uchar U = '*';

uchar brd[MAXR][MAXC];

std::vector <sqr> ans;

void pbrd(const char *s =NULL) {
	if (s) fputs(s, stderr);
	fputc('\n', stderr);
	for (int i = 0; i < N; ++i)
		fputs((char *) brd[i], stderr);
}

int cor_id(uchar c) {
	static int i;
	for (i = 0; i < 4 && C[i] != c; ++i) ;
	return i;
}

sqr give_sqr(int x, int y, int cid, int l) {
	switch(cid) {
	case 0: return sqr(x, y, l);
	case 1: return sqr(x, y-l, l);
	case 2: return sqr(x-l, y-l, l);
	case 3: return sqr(x-l, y, l);
	default: assert(0); return sqr();
	}
}

bool check(sqr s) {
#define SU(A, B) ((A) == S[B] || (A) == U)
#define CU(A, B) ((A) == C[B] || (A) == U)
#define MUST(A) if (!(A)) return false

	for (int i = 1; i < s.l; ++i) {
		MUST(SU(brd[s.x + i][s.y], 0) && SU(brd[s.x +   i][s.y + s.l], 0));
		MUST(SU(brd[s.x][s.y + i], 1) && SU(brd[s.x + s.l][s.y +   i], 1));
	}

	MUST(CU(brd[s.x    ][s.y    ], 0));
	MUST(CU(brd[s.x    ][s.y+s.l], 1));
	MUST(CU(brd[s.x+s.l][s.y+s.l], 2));
	MUST(CU(brd[s.x+s.l][s.y    ], 3));

	return true;
}

void mark(sqr s) {
	for (int i = 0; i <= s.l; ++i) {
		brd[s.x + i][s.y] = brd[s.x + i][s.y + s.l] = U;
		brd[s.x][s.y + i] = brd[s.x + s.l][s.y + i] = U;
	}
}

void draw(sqr s) {
	for (int i = 1; i < s.l; ++i) {
		brd[s.x + i][s.y] = brd[s.x + i][s.y + s.l] = S[0];
		brd[s.x][s.y + i] = brd[s.x + s.l][s.y + i] = S[1];
	}
	brd[s.x][s.y] = C[0];
	brd[s.x][s.y+s.l] = C[1];
	brd[s.x+s.l][s.y+s.l] = C[2];
	brd[s.x+s.l][s.y] = C[3];
}

#define CMPB \
	if (check(s)) {\
		mark(s);\
		ans.push_back(s);\
		/*fprintf(stderr, "%d %d %d\n", s.x, s.y, s.l);*/\
		/*pbrd("afeter erase");*/\
		goto again;\
	}

bool bad(sqr s) {
	return s.x < 0
		|| s.y < 0
		|| s.x + s.l >= N
		|| s.y + s.l >= M;
}

void stage1() {
	int cid;
	again:;
	for (int i = 0; i < N; ++i)
		for (int j = 0; j < M; ++j) {
			if ((cid = cor_id(brd[i][j])) == 4) continue;

			for (int l = 1;; ++l) {
				sqr s = give_sqr(i, j, cid, l);
				if (bad(s)) break;
				CMPB
			}
		}
}

void stage2() {
	again:;
	for (int i = 0; i < N; ++i)
		for (int j = 0; j < M; ++j) {
			if (brd[i][j] == S[0]) {
				for (int k = i - 1; k >= 0; --k) {
					if (brd[k][j] == E || brd[k][j] == S[1]) break;
					for (int cc = 0; cc < 2; ++cc) {
						for (int l = i-k+1;; ++l) {
							sqr s = give_sqr(k, j, cc, l);
							if (bad(s)) break;
							CMPB
						}
					}
				}
			} else
			if (brd[i][j] == S[1]) {
				for (int k = j - 1; k >= 0; --k) {
					if (brd[i][k] == E || brd[i][k] == S[0]) break;
					for (int cc = 0; cc != -1; cc = (cc == 0 ? 3 : -1)) {
						for (int l = j-k+1;; ++l) {
							sqr s = give_sqr(i, k, cc, l);
							if (bad(s)) break;
							CMPB
						}
					}
				}
			}
		}
}

uchar backup[MAXR][MAXC];

int main() {
	for (int i = 0; i < N; ++i) {
		fgets((char *) brd[i], MAXC, stdin);
	}

	memcpy(backup, brd, sizeof(brd));

	for (int i = 0; i < N; ++i)
		for (int j = 0; j < M; ++j)
			assert(brd[i][j] == C[0] || brd[i][j] == C[1]
				|| brd[i][j] == C[2] || brd[i][j] == C[3]
				|| brd[i][j] == S[0] || brd[i][j] == S[1]
				|| brd[i][j] == E);

	//pbrd("begining");
	stage1();
	//fprintf(stderr, "stage1 finished\n");
	stage2();

	printf("%d\n", (int) ans.size());
	for (std::vector<sqr> :: reverse_iterator it = ans.rbegin(); it != ans.rend(); ++it) {
		printf("%d %d %d\n", it->y, it->x, it->l + 1);
	}

	for (int i = 0; i < N; ++i)
		for (int j = 0; j < M; ++j)
			assert(brd[i][j] == E || brd[i][j] == U);

	for (std::vector<sqr> :: reverse_iterator it = ans.rbegin(); it != ans.rend(); ++it) {
		draw(*it);
	}

	assert(memcmp(backup, brd, sizeof(brd)) == 0);

	return 0;
}
