/*
FROM: acm.timus.ru
PROB: 1013 (K-based numbers. Version 3)
KEYW: dynamical programming, long numbers with adding and integer multiplication
NOTE: also serves as solution to problem 1012 - K-based numbers. Version 2
*/

#include <cstdio>
#include <cstring>

const int MAX = 1 << 10;
const int BASE = 1000000000;

struct big {
	int m[MAX];
	big (int a = 0) {memset (m, 0, sizeof (m)); m[0] = a;}
	big (const big &a) {memcpy (m, a.m, sizeof (m));}

	big & operator = (const big &a) {
		memcpy (m, a.m, sizeof (m));
		return *this;
	}
	big & operator += (const big &a) {
		static int pr, i;
		for (i = pr = 0; i < MAX; ++i) {
			m[i] += a.m[i];
			m[i] += pr;
			pr = m[i] / BASE;
			m[i] %= BASE;
		}
		return *this;
	}
	big & operator *= (int x) {
		static int pr, i;
		static long long tmp;
		for (i = pr = 0; i < MAX; ++i) {
			tmp = (long long)m[i] * x + pr;
			pr = tmp / BASE;
			m[i] = tmp % BASE;
		}
		return *this;
	}
	void prnt () const {
		static int i;
		for (i = MAX - 1; i && !m[i]; --i);
		printf ("%d", m[i]);
		for (--i; i >= 0; --i) printf ("%09d", m[i]);
		puts ("");
	}
};

int N, K;
big dp[2][2];

int main () {
	scanf ("%d %d", &N, &K);

	dp[0][0] = 1;
	dp[0][1] = 1;

	int c = 1, o = 0;
	int i;
	for (i = 1; i <= N; ++i) {
		dp[o][1] *= K - 1;
		dp[c][0] = dp[o][1];
		dp[c][1] = dp[o][1];
		dp[c][1] += dp[o][0];
/*		
		printf ("___%d\n", i);
		dp[c][0].prnt ();
		dp[c][1].prnt ();
	*/	
		c = o;
		o = !o;
	}

	dp[o][0].prnt ();

	return 0;
}
