/*
FROM: acm.timus.ru
PROB: 1015 (Test the Difference!)
KEYW: dice rotation, adding permutations
*/

#include <cstdio>
#include <cstring>
#include <cassert>
#include <vector>
#include <algorithm>

struct perm {
	int m[6];
	perm () {for (int i = 0; i < 6; ++i) m[i] = i;}
	perm (int _a, int _b, int _c, int _d, int _e, int _f) {
		m[0] = _a; m[1] = _b; m[2] = _c; m[3] = _d; m[4] = _e; m[5] = _f;
	}
	perm (int a[6]) {memcpy (m, a, sizeof (m));}
	perm (const perm &a) {memcpy (m, a.m, sizeof (m));}

	perm & operator = (const perm &a) {
		memcpy (m, a.m, sizeof (m));
		return *this;
	}

	perm & operator += (const perm &a) {
		int m2[6];
		for (int i = 0; i < 6; ++i)
			m2[a.m[i]] = m[i];
		memcpy (m, m2, sizeof (m));
		return *this;
	}
	
	bool operator == (const perm &a) {
		int i;
		for (i = 0; i < 6 && m[i] == a.m[i]; ++i);
		return i == 6;
	}
	
	perm next () const {
		perm ret (*this);
		std::next_permutation (ret.m, ret.m + 6);
		return ret;
	}
	
	bool operator != (const perm &a) {
		return !(*this == a);
	}
	void prnt (char end) {
		for (int i = 0; i < 6; ++i) printf (" %d", m[i]);
		putchar (end);
	}

	bool operator < (const perm &a) const {
		int i;
		for (i = 0; i < 5 && m[i] == a.m[i]; ++i);
		return m[i] < a.m[i];
	}
};

perm
  X (0, 1, 5, 2, 3, 4)
, Y (3, 5, 2, 1, 4, 0)
, Z (2, 4, 1, 3, 0, 5);

int pp;
perm all[64];

void generate () {
	perm base1, base2, base3, res;
	int i, j, k, tt;
	for (i = 0; i < 4; ++i) {
		for (j = 0; j < 4; ++j) {
			for (k = 0; k < 4; ++k) {
				res = base1;
				res += base2;
				res += base3;
				for (tt = 0; tt < pp && res != all[tt]; ++tt);
				if (tt == pp) all[pp++] = res;
				base3 += Z;
			}
			base2 += Y;
		}
		base1 += X;
	}
	std::sort (all, all + pp);
	for (i = 0; i < pp; ++i) all[i].prnt ('\n');
}

int N;
perm xall[1 << 10];
int grp[1 << 10];

int main () {
	generate ();
	return 0;

	int i, j;
	for (i = 1; i < 720; ++i) {
		xall[i] = xall[i-1].next ();
//		xall[i-1].prnt ('-'); xall[i].prnt ('\n');
	}

	memset (grp, -1, sizeof (grp));
	int cgrp = 0;
	perm tmp;
	for (i = 0; i < 720; ++i) {
		if (grp[i] != -1) continue;
		for (j = 0; j < pp; ++j) {
			tmp = xall[i];
			tmp += all[j];
			grp[std::lower_bound (xall, xall + 720, tmp) - xall] = cgrp;
		}
		++cgrp;
	}

	assert (cgrp == 30);

	scanf ("%d\n", &N);
	int m[6];
	perm crnt;
	bool used[32] = {0};
	static int gref[1 << 17];
	std::vector <int> gvec[32];
	int all_gr_cnt = 0;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < 6; ++j) {
			scanf ("%d", m + j);
			--m[j];
		}
		crnt = perm (m);
		gref[i] = grp[std::lower_bound (xall, xall + 720, crnt) - xall];
		all_gr_cnt += gvec[gref[i]].empty ();
		gvec[gref[i]].push_back (i);
	}

	printf ("%d\n", all_gr_cnt);
	for (i = 0; i < N; ++i) {
		if (used[gref[i]]) continue;
		used[gref[i]] = 1;
		printf ("%d", gvec[gref[i]].front () + 1);
		for (j = 1; j < gvec[gref[i]].size (); ++j) {
			printf (" %d", gvec[gref[i]][j] + 1);
		}
		puts ("");
	}

	return 0;
}
