/*
FROM: acm.timus.ru
PROB: 1016 (A Cube on the Walk)
KEYW: dice rotation, adding permutations
*/

#include <cstdio>
#include <cassert>
#include <algorithm>
#include <queue>
#include <vector>
#include <utility>

struct perm {
	int m[6];
	perm () {for (int i = 0; i < 6; ++i) m[i] = i;}
	perm (int _a, int _b, int _c, int _d, int _e, int _f) {
		m[0] = _a; m[1] = _b; m[2] = _c; m[3] = _d; m[4] = _e; m[5] = _f;
	}
	perm (int a[6]) {memcpy (m, a, sizeof (m));}
	perm (const perm &a) {memcpy (m, a.m, sizeof (m));}

	perm & operator = (const perm &a) {
		memcpy (m, a.m, sizeof (m));
		return *this;
	}

	perm & operator += (const perm &a) {
		int m2[6];
		for (int i = 0; i < 6; ++i)
			m2[a.m[i]] = m[i];
		memcpy (m, m2, sizeof (m));
		return *this;
	}
	
	perm operator + (const perm &a) const {
		perm ret (*this);
		ret += a;
		return ret;
	}
	
	perm & operator -= (const perm &a) {
		int i;
		for (i = 0; i < 6; ++i)
			m[i] = a.m[m[i]];
		return *this;
	}
	
	
	perm operator - (const perm &a) const {
		perm ret (*this);
		ret -= a;
		return ret;
	}
	
	bool operator == (const perm &a) {
		int i;
		for (i = 0; i < 6 && m[i] == a.m[i]; ++i);
		return i == 6;
	}
	
	perm next () const {
		perm ret (*this);
		std::next_permutation (ret.m, ret.m + 6);
		return ret;
	}
	
	bool operator != (const perm &a) {
		return !(*this == a);
	}
	void prnt (char end = '\n') {
		for (int i = 0; i < 6; ++i) printf (" %d", m[i]);
		putchar (end);
	}

	bool operator < (const perm &a) const {
		int i;
		for (i = 0; i < 5 && m[i] == a.m[i]; ++i);
		return m[i] < a.m[i];
	}
};

perm
  X (0, 1, 5, 2, 3, 4)
, Y (3, 5, 2, 1, 4, 0)
, Z (2, 4, 1, 3, 0, 5);

int pp;
perm all[32];//24

void generate () {
	perm base1, base2, base3, res;
	int i, j, k, tt;
	for (i = 0; i < 4; ++i) {
		for (j = 0; j < 4; ++j) {
			for (k = 0; k < 4; ++k) {
				res = base1;
				res += base2;
				res += base3;
				for (tt = 0; tt < pp && res != all[tt]; ++tt);
				if (tt == pp) all[pp++] = res;
				base3 += Z;
			}
			base2 += Y;
		}
		base1 += X;
	}
	std::sort (all, all + pp);
//	for (i = 0; i < pp; ++i) all[i].prnt ('\n');
}

perm norm (3, 5, 2, 1, 4, 0);

//			   up right down left
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};

perm dp[4];
perm cube;

struct state {
	int x, y;
	int pid;
	int len;
	state () {}
	state (int _x, int _y, int _pid, int _len) : x (_x), y (_y), pid (_pid), len (_len) {}
	bool operator < (const state &a) const {//inverted
		return len > a.len;	
	}
};

int len[8][8][24];
state prev[8][8][24];

int fnd_bot (int pid) {
	int i;
	for (i = 0; i < 6 && all[pid].m[i] != 4; ++i);
	return cube.m[i];
}

void get_pos (int &x, int &y) {
	char buf[4];
	scanf ("%s", buf);
	y = buf[0] - 'a';
	x = 7 - (buf[1] - '1');
}

void put_pos (int x, int y) {
	printf (" %c%c", y + 'a', 7 - x + '1');
}

int dijkstra (const state &start, int fx, int fy) {
	std::priority_queue <state> q;
	q.push (start);

	state c;
	int i;
	int nid, nx, ny, nlen;
	len[start.x][start.y][start.pid] = start.len;
	prev[start.x][start.y][start.pid] = state (-1, -1, -1, -1);
	while (!q.empty ()) {
		c = q.top (); q.pop ();
		if (c.x == fx && c.y == fy) return c.pid;
		if (len[c.x][c.y][c.pid] < c.len) continue;//already popped
	
//		printf ("popped %d %d %d -- %d\n", c.x, c.y, c.pid, c.len);
	
		for (i = 0; i < 4; ++i) {
//			printf ("\tdir %d\n", i);
//			perm tt = all[c.pid];
//			tt.prnt ();
//			tt -= dp[i];
//			tt.prnt ();
			nid = std::lower_bound (all, all + pp,  all[c.pid] - dp[i]) - all;
//			(all[c.pid] - dp[i]).prnt ();
			nx = c.x + dx[i];
			ny = c.y + dy[i];
			if (nx < 0 || nx >= 8
			 || ny < 0 || ny >= 8) {
//				printf ("\t\tOUT!\n");
				continue;
			}
			nlen = c.len + fnd_bot (nid);
//			printf ("\t\t%d %d %d\n", nx, ny, nid);
//			printf ("\t\t"); all[nid].prnt ();
//			printf ("\t\tbot %d\n", fnd_bot (nid));
		
			if (len[nx][ny][nid] > nlen) {
				len[nx][ny][nid] = nlen;
				prev[nx][ny][nid] = c;
				q.push (state (nx, ny, nid, nlen));
//				printf ("\t\tPUSH %d %d %d -- %d\n", nx, ny, nid, nlen);
			}
		}
	}
	assert (0);
	return -1;
}

int main () {
	generate ();
	dp[0] = X;
	dp[1] = Z;
	dp[2] = X + X + X;
	dp[3] = Z + Z + Z;

	int sx, sy, fx, fy;
	get_pos (sx, sy);
	get_pos (fx, fy);
//	printf ("%d %d %d %d\n", sx, sy, fx, fy);
	for (int i = 0; i < 6; ++i) scanf ("%d", cube.m + i);
	cube += norm;//now everything is like normal ;)

//	cube.prnt ();

	memset (len, 0x7f, sizeof (len));
	memset (prev, -1, sizeof (prev));
	int pid = dijkstra (state (sx, sy, 0, cube.m[4]), fx, fy);

	printf ("%d", len[fx][fy][pid]);

	std::vector <std::pair <int, int> > ans;
	while (fx != sx || fy != sy) {
		ans.push_back (std::make_pair (fx, fy));
		state xx = prev[fx][fy][pid];
		fx = xx.x;
		fy = xx.y;
		pid = xx.pid;
	}
	ans.push_back (std::make_pair (fx, fy));

	for (int i = ans.size () - 1; i >= 0; --i)
		put_pos (ans[i].first, ans[i].second);
	puts ("");

	return 0;
}
