/*
FROM: acm.timus.ru
PROB: 1018 (A Binary Apple Tree)
KEYW: dynamical programming on tree, tele style
*/

#include <cstdio>
#include <cstring>
#include <cassert>

const int MAXN = 1 << 7;

struct el {
	int to;
	int cnt;
	int next;
	el () {}
	el (int _to, int _cnt, int _next) : to (_to), cnt (_cnt), next (_next) {}
};

int N, Q;
int dp[MAXN][MAXN];
int sz[MAXN];
int kids[MAXN][2];
int branch[MAXN];

int vec[MAXN];
el buf[MAXN * 2];

int q[MAXN];

void bfs () {
	int p3 = 0, i, j;
	q[p3++] = 0;

	int kp;
	for (i = 0; i < p3; ++i) {
		sz[q[i]] = -1;
		kp = 0;
		for (j = vec[q[i]]; j != -1; j = buf[j].next) {
			if (sz[buf[j].to] == -1) continue;
			kids[q[i]][kp++] = buf[j].to;
			branch[buf[j].to] = buf[j].cnt;
			q[p3++] = buf[j].to;
		}
		assert (kp == 2 || kp == 0);
		if (kp == 0) sz[q[i]] = 0;
	}
}

int main () {
	scanf ("%d %d", &N, &Q);

	int i, j;
	int a, b, c, bp = 0;
	memset (vec, -1, sizeof (vec));
	for (i = 1; i < N; ++i) {
		scanf ("%d %d %d", &a, &b, &c);
		--a; --b;

		buf[bp] = el (b, c, vec[a]);
		vec[a] = bp++;
		buf[bp] = el (a, c, vec[b]);
		vec[b] = bp++;
	}

	bfs ();
	for (c = N-1; c >= 0; --c) {
		if (sz[c] == 0) continue;
		sz[c] = sz[kids[c][0]] + sz[kids[c][1]] + 2;
		
		for (i = 0; i <= sz[kids[c][0]]; ++i)
			if (dp[c][i + sz[kids[c][1]] + 1] < dp[kids[c][0]][i] + branch[kids[c][0]])
				dp[c][i + sz[kids[c][1]] + 1] = dp[kids[c][0]][i] + branch[kids[c][0]];
	
		for (i = 0; i <= sz[kids[c][1]]; ++i)
			if (dp[c][i + sz[kids[c][0]] + 1] < dp[kids[c][1]][i] + branch[kids[c][1]])
				dp[c][i + sz[kids[c][0]] + 1] = dp[kids[c][1]][i] + branch[kids[c][1]];
	
		for (i = 0; i <= sz[kids[c][0]]; ++i)
			for (j = 0; j <= sz[kids[c][1]]; ++j)
				if (dp[c][i + j] < dp[kids[c][0]][i] + dp[kids[c][1]][j] + branch[kids[c][0]] + branch[kids[c][1]])
					dp[c][i + j] = dp[kids[c][0]][i] + dp[kids[c][1]][j] + branch[kids[c][0]] + branch[kids[c][1]];
	}

	if (Q == N) --Q;
	printf ("%d\n", dp[0][N-1-Q]);

	return 0;
}
