/*
FROM: acm.timus.ru
PROB: 1022 (Genealogical tree)
KEYW: topological sort
*/

#include <cstdio>
#include <cstring>

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

const int MAXN = 1 << 7;

int N;
int vec[MAXN];
el buf[MAXN * MAXN];
bool nstart[MAXN];
bool used[MAXN];

int ans[MAXN], ap;

void dfs (int a) {
	if (used[a]) return;
	used[a] = 1;
	for (int i = vec[a]; i != -1; i = buf[i].next)
		dfs (buf[i].to);
	ans[ap++] = a;
}

int main () {
	scanf ("%d", &N);

	memset (vec, -1, sizeof (vec));
	int i;
	int x, bp = 0;
	for (i = 0; i < N; ++i) {
		while (scanf ("%d", &x), x) {
			buf[bp] = el (--x, vec[i]);
			vec[i] = bp++;
			nstart[x] = 1;
		}
	}

	for (i = 0; i < N; ++i)
		if (!nstart[i])
			dfs (i);

	printf ("%d", ans[ap-1] + 1);
	for (i = ap-2; i >= 0; --i) printf (" %d", ans[i] + 1); puts ("");

	return 0;
}
