/*
FROM: acm.timus.ru
PROB: 1029 (Ministry)
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 7;//floors
const int MAXM = 1 << 9;//rooms per floor

int N, M;
long long dp[MAXN][MAXM];
int cost[MAXN][MAXM];
int prev[MAXN][MAXM];

int main () {
	scanf ("%d %d", &N, &M);

	int i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < M; ++j)
			scanf ("%d", cost[i] + j);

	for (j = 0; j < M; ++j) dp[0][j] = cost[0][j];
	for (i = 1; i < N; ++i) {
		for (j = 0; j < M; ++j) {
			dp[i][j] = dp[i-1][j] + cost[i][j];
			prev[i][j] = j;
		}
		for (j = 1; j < M; ++j)
			if (dp[i][j] > dp[i][j-1] + cost[i][j]) {
				dp[i][j] = dp[i][j-1] + cost[i][j];
				prev[i][j] = j-1;
			}
		for (j = M - 2; j >= 0; --j)
			if (dp[i][j] > dp[i][j+1] + cost[i][j]) {
				dp[i][j] = dp[i][j+1] + cost[i][j];
				prev[i][j] = j+1;
			}
	}

	int bj = 0;
	for (j = 1; j < M; ++j)
		if (dp[N-1][bj] > dp[N-1][j]) {
			bj = j;
		}
#ifndef ONLINE_JUDGE
	printf ("%Ld\n", dp[N-1][bj]);
#endif

	i = N-1, j = bj;
	static int ans[MAXN * MAXM], ap;
	while (i) {
		ans[ap++] = j;
		if (prev[i][j] == j) --i;
		else j = prev[i][j];
	}

	printf ("%d", ans[ap-1] + 1);
	for (i = ap-1; i >= 0; --i) printf (" %d", ans[i] + 1); puts ("");

	return 0;
}
