/*
FROM: acm.timus.ru
PROB: 1030 (Titanic)
KEYW: geometry 3D, given geographical positions (on earth) find the shortest distance on the surface
*/

#include <cmath>
#include <cstdio>
#include <cstring>

//#define ONLINE_JUDGE

#ifdef ONLINE_JUDGE
#define PI /*(2*acos (0.))*/ 3.14159265358979323846264338327950288419716939937510582097
#else
#define PI M_PI
#endif

const double EPS = 1e-6;

struct pnt {
	double x, y, z;
	pnt () {}
	pnt (const pnt &a) : x (a.x), y (a.y), z (a.z) {}
	pnt (double _x, double _y, double _z) : x (_x), y (_y), z (_z) {}

	pnt operator + (const pnt &a) const {return pnt (x + a.x, y + a.y, z + a.z);}
	pnt operator * (double a) const {return pnt (x * a, y * a, z * a);}
	double operator * (const pnt &a) const {return x * a.x + y * a.y + z * a.z;}
	double len () const {return sqrt (x * x + y * y + z * z);}
};

const double R = 6875. / 2.;

void myassert (bool how) {
	while (!how);
}

double grad2rad (double ang) {
	return ang / 180. * PI;
}

double rad2grad (double ang) {
	return ang / PI * 180.;
}

pnt get_coor (double ang1, double ang2) {
/*	pnt cen (0., 0., -0.001);
	pnt rig (0.001, 0., 0.);
	pnt top (0., 0.001, 0.);*/
	pnt cen (0., 0., -R);
	pnt rig (R, 0., 0.);
	pnt top (0., R, 0.);

	pnt rot1 = cen * cos (ang1) + rig * sin (ang1);
	pnt rot2 = rot1 * cos (ang2) + top * sin (ang2);
	return rot2;
}

void write (double dst) {
	printf ("The distance to the iceberg: %.2lf miles.\n", dst);
	if (dst < 99.995) printf ("DANGER!\n");
}

double read_ang () {
	int _a, _m, _s;
	double a;//, m, s;
	char l;
	scanf (" %d^%d\'%d\" %c%*c ", &_a, &_m, &_s, &l);
//	m += s / 60;
	a = _a / 1. + _m / 60. + _s / 3600.;
	if (l == 'W' || l == 'S') a *= -1;
//	printf ("%c -- %lf\n", l, a);
/*	switch (l) {
		case 'E': myassert (-EPS < a && a < 180. + EPS); break;
		case 'W': myassert (-180. - EPS < a && a < EPS); break;
		case 'N': myassert (-EPS < a && a < 90. + EPS); break;
		case 'S': myassert (-90. - EPS < a && a < EPS); break;
	}*/
//	printf ("scanned %lf\n", a);
	return a;
}

//char temp[1000];
void read_all (double &alpha1, double &beta1, double &alpha2, double &beta2) {
//	if (feof (stdin)) return 0;
	scanf (	" Message #%*d.\n"\
			"Received at %*d:%*d:%*d.\n"\
			"Current ship%*cs coordinates are\n");
//	gets (temp);\
	gets (temp);\
	gets (temp);
	beta1 = grad2rad (read_ang ());
	scanf (" and ");
	alpha1 = grad2rad (read_ang ());
	scanf (	" .\n"\
			"An iceberg was noticed at\n");
//	gets (temp);\
	gets (temp);
	beta2 = grad2rad (read_ang ());
	scanf (" and ");
	alpha2 = grad2rad (read_ang ());
	scanf ( " .\n"\
			"===\n");
//	gets (temp);\
	gets (temp);
//	return 1;
}

double myacos (double ang) {
	return acos (ang);
	double l = 0, r = PI, m;
	for (int k = 0; k < 200; ++k) {
		m = (l + r) / 2;
//		printf ("%lf -- %lf (< %lf)\n", m, cos (m), ang);
		if (cos (m) < ang)
			r = m;
		else
			l = m;
	}
//	myassert (cos (l) == ang);
//	printf ("<<cos(%lf) == %lf  cos (%lf) == %lf>>\n", -PI, cos (-PI), 0., cos (0));
//	printf ("\n\n%.20lf %lf -- %.20lf %.20lf %.20lf\n%.20lf %.20lf %.20lf\n", ang, rad2grad (ang), acos (ang), l, r, cos (l), cos (r), cos (acos (ang)));
	return l;
}

#define MY_SOLUTION

int main () {
#ifndef ONLINE_JUDGE
#warning probably repeat everything (for multiple messages)
#endif

	double alpha1, beta1, alpha2, beta2;
	read_all (alpha1, beta1, alpha2, beta2);

#ifdef MY_SOLUTION
#ifndef ONLINE_JUDGE
	printf ("%lf %lf %lf %lf\n", alpha1, beta1, alpha2, beta2);
#endif
	pnt ship = get_coor (alpha1, beta1);
	pnt ice = get_coor (alpha2, beta2);

#ifndef ONLINE_JUDGE
	printf ("SHIP %lf %lf %lf\nICE  %lf %lf %lf\n", ship.x, ship.y, ship.z, ice.x, ice.y, ice.z);
	printf ("%lf %lf\n", ship.len (), ice.len ());
#endif

	double cos_ang = (ship * ice) / (ship.len () * ice.len ());
	double ang = myacos (cos_ang);

#ifndef ONLINE_JUDGE
	printf ("%lf %lf %.10lf\n", cos_ang, rad2grad (ang) / 2., ang);
#endif

#else /* MY_SOLUTION -> the wiki solution follows*/
	double ang = acos (sin (beta1) * sin (beta2) + cos (beta1) * cos (beta2) * cos (alpha1 - alpha2));
#endif /* MY_SOLUTION */
//	if (ang < 0) ang += PI;

	double dst = ang * R;
	if (fabs (dst) < EPS) dst = +0.;

	write (dst);

	return 0;
}
