/*
FROM: acm.timus.ru
PROB: 1031 (Railway tickets)
KEYW: dynamical programming binary search
*/

#include <cstdio>
#include <cstring>
#include <cassert>
#include <algorithm>

const int MAXN = 1 << 14;

long long l1, l2, l3;
long long c1, c2, c3;

int N;
long long dp[MAXN];
long long pos[MAXN];
int S, F;

void myassert (int a) {
	while (!a);
}

void do_job (int i, long long l, long long c) {
	int p = std::upper_bound (pos + i, pos + F, pos[i] + l) - pos - 1;
	if (p <= i) return;
	myassert (pos[p] - pos[i] <= l);

//	printf ("from %d with l == %Ld (%Ld) -- %d _%Ld_(%Ld)\n", i, l, c, p, pos[p], dp[p]);
	if (!dp[p] || dp[p] > dp[i] + c)
		dp[p] = dp[i] + c;
//	printf ("=>%Ld\n", dp[p]);
}

int main () {
	int i;
#ifdef ONLINE_JUDGE
	scanf ("%I64d%I64d%I64d %I64d%I64d%I64d\n", &l1, &l2, &l3, &c1, &c2, &c3);
	scanf ("%d\n", &N);
	scanf ("%d %d\n", &S, &F);
	for (i = 1; i < N; ++i) scanf ("%I64d", pos + i);
#else
	scanf ("%Ld%Ld%Ld %Ld%Ld%Ld\n", &l1, &l2, &l3, &c1, &c2, &c3);
	scanf ("%d\n", &N);
	scanf ("%d %d\n", &S, &F);
	for (i = 1; i < N; ++i) scanf ("%Ld", pos + i);
#endif

	if (S > F) std::swap (S, F); --S;

//	for (i = 0; i < N; ++i) printf ("%d - %Ld\n", i, pos[i]);

	for (i = S; i < F; ++i) {
		if (i != S && dp[i] == 0) continue;
		do_job (i, l1, c1);
		do_job (i, l2, c2);
		do_job (i, l3, c3);
	}

#ifdef ONLINE_JUDGE
	printf ("%I64d\n", dp[--F]);
#else
	printf ("%Ld\n", dp[--F]);
#endif

	return 0;
}
