/*
FROM: acm.timus.ru
PROB: 1033 (Labyrinth)
KEYW: lab, bfs
*/

#include <cstdio>
#include <cstring>
#include <utility>

#define x first
#define y second

const int MAXN = 64;

const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};

int N;
char map[MAXN][MAXN];
bool used[MAXN][MAXN];

int ans;

void bfs (int x1, int y1, int x2, int y2) {
	static std::pair <int, int> q[MAXN * MAXN];
	int p3 = 0, i, j;
	int nx, ny;
	
	q[p3++] = std::make_pair (x1, y1);
	q[p3++] = std::make_pair (x2, y2);
	used[x1][y1] = 1;
	used[x2][y2] = 1;

	for (i = 0; i < p3; ++i) {
		for (j = 0; j < 4; ++j) {
			nx = q[i].x + dx[j];
			ny = q[i].y + dy[j];
			if (map[nx][ny] == '.'
			 && !used[nx][ny]) {
				used[nx][ny] = 1;
				q[p3++] = std::make_pair (nx, ny);
			}
		}
	}
}

void check (int x1, int y1, int x2, int y2) {
	ans += map[x1][y1] == '#' && map[x2][y2] == '.' && used[x2][y2] == 1
		|| map[x2][y2] == '#' && map[x1][y1] == '.' && used[x1][y1] == 1;
}

int main () {
	scanf ("%d\n", &N);

	int i, j;
	memset (map, '#', sizeof (map));
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= N; ++j) {
			map[i][j] = getchar ();
		}
		getchar ();
	}

	bfs (1, 1, N, N);
	map[0][0] = map[0][1] = map[1][0] = '.';
	map[N+1][N+1] = map[N+1][N] = map[N][N+1] = '.';

	for (i = 0; i <= N; ++i)
		for (j = 0; j <= N; ++j) {
			check (i, j, i + 1, j);
			check (i, j, i, j + 1);
		}

	printf ("%d\n", ans * 9);

	return 0;
}
