/*
FROM: acm.timus.ru
PROB: 1034 (Queens in peaceful positions)
KEYW: placing queens on chess board, combinations
*/

#include <cstdio>
//#include <cassert>

struct pos {
	int x, y;
	pos () {}
	pos (int _x, int _y) : x (_x), y (_y) {}
};

const int MAXN = 1 << 6;

int N, N1;
pos vec[MAXN];
int umd[MAXN * 2];
int usd[MAXN * 2];

int ids[4];
int ans;
bool prnt;

#ifndef assert
void assert (bool a) {
	while (!a);
}
#endif

inline bool okmd (int a, int b, int c) {
//	if (prnt)\
		printf ("OKMD %d %d %d  %d %d %d\n"\
		, a, b, c\
		, umd[a], umd[b], umd[c]);

	if (umd[a]) return 0;
	umd[a] = 1;
	if (umd[b]) {
		umd[a] = 0;
		return 0;
	}
	umd[b] = 1;
	if (umd[c]) {
		umd[a] = 0;
		umd[b] = 0;		
		return 0;
	}
	umd[a] = 0;
	umd[b] = 0;
	return 1;
}

inline bool oksd (int a, int b, int c) {
//	if (prnt)\
		printf ("OKSD %d %d %d  %d %d %d\n"\
		, a, b, c\
		, usd[a], usd[b], usd[c]);
	if (usd[a]) return 0;
	usd[a] = 1;
	if (usd[b]) {
		usd[a] = 0;
		return 0;
	}
	usd[b] = 1;
	if (usd[c]) {
		usd[a] = 0;
		usd[b] = 0;
		return 0;
	}
	usd[a] = 0;
	usd[b] = 0;
	return 1;
}

void do_job () {
	static int x[4];
	static int y[4];
	static int i;
//	printf ("%d %d %d\n", ids[0], ids[1], ids[2]);

	for (i = 0; i < 3; ++i) {
		x[i] = vec[ids[i]].x;
		y[i] = vec[ids[i]].y;
	}

//	if (ids[0] == 0 && ids[1] == 2 && ids[2] == 3\
	 || ids[0] == 1 && ids[1] == 3 && ids[2] == 4) {\
		printf ("YEP\n");\
		for (i = 0; i < 2 * N; ++i) printf ("%d -- %d %d\n", i, umd[i], usd[i]);\
		printf ("%d %d %d %d %d %d\n", x[0], y[0], x[1], y[1], x[2], y[2]);\
		prnt = 1;\
		printf ("%d %d  %d %d  %d %d\n", x[0], y[1], x[1], y[2], x[2], y[0]);\
		printf ("%d %d  %d %d  %d %d\n", x[0], y[2], x[1], y[0], x[2], y[1]);\
	}

	//y1 y2 y0
	if (okmd (x[0] - y[1] + N1, x[1] - y[2] + N1, x[2] - y[0] + N1)
	 && oksd (x[0] + y[1], x[1] + y[2], x[2] + y[0]))
		++ans;
	//y2 y0 y1
	if (okmd (x[0] - y[2] + N1, x[1] - y[0] + N1, x[2] - y[1] + N1)
	 && oksd (x[0] + y[2], x[1] + y[0], x[2] + y[1]))
		++ans;

//	if (ids[0] == 0 && ids[1] == 2 && ids[2] == 3\
	 || ids[0] == 1 && ids[1] == 3 && ids[2] == 4)\
		prnt = 0;
}

void myget (int id) {
//	if (prnt) printf ("myget %d -- %d %d\n", id, vec[id].x - vec[id].y + N1, vec[id].x + vec[id].y);
	assert (!umd[vec[id].x - vec[id].y + N1] && !usd[vec[id].x + vec[id].y]);
	umd[vec[id].x - vec[id].y + N1] = 1;
	usd[vec[id].x + vec[id].y] = 1;
}
void myfree (int id) {
//	if (prnt) printf ("myfree %d -- %d %d\n", id, vec[id].x - vec[id].y + N1, vec[id].x + vec[id].y);
	assert (umd[vec[id].x - vec[id].y + N1] && usd[vec[id].x + vec[id].y]);
	umd[vec[id].x - vec[id].y + N1] = 0;
	usd[vec[id].x + vec[id].y] = 0;
}

void get3 (int pos, int left) {
	if (!left) {
		do_job ();
		return;
	}
	if (N - pos == left) {
		ids[3 - left] = pos;
		myfree (pos);
		get3 (pos + 1, left - 1);
		myget (pos);
		return;
	}
	get3 (pos + 1, left);
	ids[3 - left] = pos;
	myfree (pos);
	get3 (pos + 1, left - 1);
	myget (pos);
}

int ur[MAXN];
int uc[MAXN];
int main () {
	scanf ("%d", &N);
	N1 = N - 1;

	int i;
//	prnt = 1;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &vec[i].x, &vec[i].y);
		--vec[i].x; --vec[i].y;
		myget (i);
		++ur[vec[i].x];
		++uc[vec[i].y];
	}
	for (i = 0; i < N; ++i) assert (ur[i] && uc[i]);
//	prnt = 0;

	if (N < 3) {printf ("0\n"); return 0;}

	get3 (0, 3);
	printf ("%d\n", ans);

	return 0;
}
