/*
FROM: acm.timus.ru
PROB: 1035 (Cross-stitch)
KEYW: minimum number of paths covering a graph, input/output degree counting

NOTE: works for 0.015 / 1565 KB
*/

#include <cstdio>
//#include <cassert>
#include <cctype>
#include <algorithm>
//#include <vector>
#include <cstring>

void assert(bool x) {
	while(!x) ;
}

const int MAXR = 1 << 8;
const int MAXC = 1 << 8;

const int MAXN = MAXR * MAXC;

int gr[MAXN][4];
char deg[MAXN][2];
int used[MAXN];

int encode(int x, int y) {
	return (x << 8) + y;
}

void decode(int code, int &x, int &y) {
	y = code & 255; code >>= 8;
	x = code;
}

void add_edge(int x, int y, int x2, int y2, int side) {
	int e1 = encode(x, y);
	int e2 = encode(x2, y2);
	int i;
	++deg[e1][side];
	++deg[e2][side];
	for (i = 0; i < 4 && gr[e1][i] != -1 && gr[e1][i] != e2; ++i) ;
	if (i == 4 || gr[e1][i] == e2) return;
	gr[e1][i] = e2;

	for (i = 0; i < 4 && gr[e2][i] != -1 && gr[e2][i] != e1; ++i) ;
	if (i == 4 || gr[e2][i] == e1) return;
	gr[e2][i] = e1;
}

int ans;
void mark(int x, int y) {
	static int q[MAXN];
	int crnt = encode(x, y);
	int p3 = 0;

	if (used[crnt] || gr[crnt][0] == -1)
		return;
	q[p3++] = crnt;
	used[crnt] = 1;
	int bad = 0;
	for (int i = 0; i < p3; ++i) {
		crnt = q[i];

		//decode(crnt, x, y);
		//fprintf(stderr, "popped %d %d\n", x, y);

		bad += abs(deg[crnt][0] - deg[crnt][1]);
		for (int j = 0; j < 4 && gr[crnt][j] != -1; ++j) {
			if (!used[gr[crnt][j]]) {
				used[gr[crnt][j]] = 1;
				q[p3++] = gr[crnt][j];
			}
		}
	}

	ans += std::max(bad / 2, 1);
}

int main () {
	int r, c;
	scanf("%d %d\n", &r, &c);

	static char buf[MAXC];
	memset(gr, -1, sizeof(gr));
	for (int k = 0; k < 2; ++k) {
		for (int i = 0; i < r; ++i) {
			fgets(buf, MAXC, stdin);
			for (int j = 0; j < c; ++j) {
				bool md = 0, sd = 0;
				switch (buf[j]) {
				case '\\': md = 1; break;
				case '/': sd = 1; break;
				case 'X': md = sd = 1; break;
				}

				if (md) {
					add_edge(i, j, i+1, j+1, k);
				}
				if (sd) {
					add_edge(i, j+1, i+1, j, k);
				}
			}
		}
	}

	for (int i = 0; i < r; ++i)
		for (int j = 0; j < c; ++j)
			mark(i, j);
	mark(r-1, c);

	printf("%d\n", ans);

	return 0;
}
