/*
FROM: acm.timus.ru
PROB: 1035 (Cross-stitch)
KEYW: minimum number of paths covering a graph, input/output degree counting

NOTE: works for 0.015 / 1565 KB
*/

#include <cstdio>
//#include <cassert>
#include <cctype>
#include <algorithm>
//#include <vector>
#include <cstring>

struct el {
	int to;
	int next;
	el() {}
	el (int _to, int _next) : to(_to), next(_next) {}
};

void assert(bool x) {
	while(!x) ;
}

const int MAXR = 1 << 8;
const int MAXC = 1 << 8;

const int MAXN = MAXR * MAXC;

int gr[MAXN];
el buf[MAXN * 4];
char deg[MAXN][2];
int used[MAXN];

int encode(int x, int y) {
	return (x << 8) + y;
}

void decode(int code, int &x, int &y) {
	y = code & 255; code >>= 8;
	x = code;
}

void add_edge(int e1, int e2) {
	static int bp = 0;
	buf[bp] = el (e2, gr[e1]);
	gr[e1] = bp++;

	buf[bp] = el (e1, gr[e2]);
	gr[e2] = bp++;
}

int ans;
void mark(int x, int y) {
	static int q[MAXN];
	int crnt = encode(x, y);
	int p3 = 0;

	if (used[crnt] || gr[crnt] == -1)
		return;
	q[p3++] = crnt;
	used[crnt] = 1;
	int bad = 0;
	for (int i = 0; i < p3; ++i) {
		crnt = q[i];

		//decode(crnt, x, y);
		//fprintf(stderr, "popped %d %d\n", x, y);

		bad += abs(deg[crnt][0] - deg[crnt][1]);
		for (int j = gr[crnt]; j != -1; j = buf[j].next) {
			if (!used[buf[j].to]) {
				used[buf[j].to] = 1;
				q[p3++] = buf[j].to;
			}
		}
	}

	ans += std::max(bad / 2, 1);
}

int main () {
	int r, c;
	scanf("%d %d\n", &r, &c);

	static char all_inp[MAXR*2][MAXC];
	memset(gr, -1, sizeof(gr));
	for (int k = 0; k < 2; ++k) {
		for (int i = 0; i < r; ++i) {
			fgets(all_inp[i + r * k], MAXC, stdin);
		}
	}

	for (int i = 0; i < r; ++i)
		for (int j = 0; j < c; ++j) {
			bool md = 0, sd = 0;
			int a = 0, b = 0;
			switch (all_inp[i][j]) {
			case '\\': md = 1; ++a; break;
			case '/': sd = 1; ++b; break;
			case 'X': md = sd = 1; ++a; ++b; break;
			}
			switch (all_inp[i+r][j]) {
			case '\\': md = 1; --a; break;
			case '/': sd = 1; --b; break;
			case 'X': md = sd = 1; --a; --b; break;
			}

			int e1 = encode(i, j)
			  , e2 = encode(i, j+1)
			  , e3 = encode(i+1, j)
			  , e4 = encode(i+1, j+1);

			if (md) {
				add_edge(e1, e4);
			}
			if (sd) {
				add_edge(e2, e3);
			}
			deg[e1][0] += a;
			deg[e2][0] += b;
			deg[e3][0] += b;
			deg[e4][0] += a;
		}


	for (int i = 0; i < r; ++i)
		for (int j = 0; j < c; ++j)
			mark(i, j);
	mark(r-1, c);

	printf("%d\n", ans);

	return 0;
}
