/*
FROM: acm.timus.ru
PROB: 1036 (Lucky tickets)
KEYW: dynamical programming, long numbers multiplication
*/

#include <cstdio>
#include <cstring>
#include <cassert>

const int MAX = 1 << 7;
const int BASE = 1000000000;
const int MAXS = 1 << 9;//1000 / 2

long long tmp[MAX * 2];
struct big {
	int m[MAX];
	big (int a = 0) {memset (m, 0, sizeof (m)); m[0] = a;}
	big (const big &a) {memcpy (m, a.m, sizeof (m));}

	big & operator = (const big &a) {memcpy (m, a.m, sizeof (m)); return *this;}

	big & operator += (const big &a) {
		int pr = 0, i;
		for (i = 0; i < MAX; ++i) {
			m[i] += a.m[i] + pr;
			pr = m[i] / BASE;
			m[i] %= BASE;
		}
		return *this;
	}
	
	bool is_zero () const {
		int i;
		for (i = 0; i < MAX && !m[i]; ++i);
		return i == MAX;
	}

	void prnt (char end = '\n') const {
		int i;
		for (i = MAX-1; i && !m[i]; --i);
		printf ("%d", m[i]);
		for (--i; i >= 0; --i)
			printf ("%09d", m[i]);
		putchar (end);
	}

	big & operator *= (const big &a) {
		memset (tmp, 0, sizeof (tmp));
		int i, j;
		long long res;
		for (i = 0; i < MAX; ++i)
			for (j = 0; j < MAX; ++j) {
				res = (long long)m[i] * (long long)a.m[j];
				tmp[i+j] += res % BASE;
				tmp[i+j+1] += tmp[i+j] / BASE;
				tmp[i+j] %= BASE;
				tmp[i+j+1] += res / BASE;
			}
		for (i = 0; i < MAX * 2; ++i) {
			if (tmp[i] >= BASE)
				assert (i != MAX * 2 - 1);
				tmp[i+1] += tmp[i] / BASE;
				tmp[i] %= BASE;
			}
		for (i = 0; i < MAX; ++i)
			m[i] = (int)tmp[i];
		for (i = MAX; i < MAX * 2; ++i) assert (!tmp[i]);
		return *this;
	}
};

int N, S;
big dp[MAXS];

int main () {
	scanf ("%d %d", &N, &S);
	if (S & 1) {printf ("0\n"); return 0;}
	S /= 2;
	dp[0] = big (1);

	int i, j;
	for (int k = 0; k < N; ++k)
		for (i = S-1; i >= 0; --i) {
			if (dp[i].is_zero ()) continue;
			for (j = 1; j < 10 && i + j <= S; ++j) {
//				printf ("%d  %d <- %d  ", k, i+j, i);\
				dp[i].prnt ();
				dp[i+j] += dp[i];
			}
		}

//	dp[S].prnt ();
	dp[S] *= dp[S];
	dp[S].prnt ();

	return 0;
}
