/*
FROM: acm.timus.ru
PROB: 1039 (Anniversary party)
KEYW: dynamical programming on tree
*/

#include <cstdio>
#include <vector>

const int MAXN = 1 << 13;

int N;
int rating[MAXN];
bool no_root[MAXN];

int dp[MAXN][2];

std::vector <int> kids[MAXN];

int max (int a, int b) {
	return a > b ? a : b;
}

void dfs (int a) {
	dp[a][1] += rating[a];
	for (size_t i = 0; i < kids[a].size (); ++i) {
		dfs (kids[a][i]);
		dp[a][1] += dp[kids[a][i]][0];
		dp[a][0] += max (dp[kids[a][i]][0], dp[kids[a][i]][1]);
	}
}

int main () {
	scanf ("%d", &N);
	int i;
	for (i = 0; i < N; ++i) scanf ("%d", rating + i);
	
	int a, b;
	for (i = 1; i < N; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		kids[b].push_back (a);
		no_root[a] = 1;
	}

	for (i = 0; i < N && no_root[i]; ++i);
	dfs (i);

	printf ("%d\n", max (dp[i][0], dp[i][1]));

	return 0;
}
