/*
FROM: acm.timus.ru
PROB: 1040 (Airline company)
KEYW: graph, dividing to paths
*/

#include <cstdio>
//#include <cassert>
#include <vector>

#define ONLINE_JUDGE

#ifndef assert
void assert (bool a) {
//	while (!a);
}
void Xassert (int a) {
	while (!a);
}
#endif

const int MAXN = 1 << 6;
const int MAXM = 1 << 12;

int N, M;
int in[MAXN];
int ma3x[MAXN][MAXN];
int ans[MAXM];
int start[MAXN], sp;
bool used[MAXN];
std::vector <int> nums[MAXN];
bool dont_set;

int cp = 1;

int gcd (int a, int b) {
	return b ? gcd (b, a % b) : a;
}

void my_try () {
	for (int i = 0; i < N; ++i)
		for (int j = 0; j < N; ++j)
			if (ma3x[i][j])
				Xassert (ma3x[j][i] == ma3x[i][j]);
	for (int i = 0; i < N; ++i) {
		int tmp = 0;
		for (int j = 0; j < N; ++j)
			if (ma3x[i][j])
				++tmp;
		Xassert (tmp == in[i]);
	}
}

void dfs (int a) {
//	printf ("dfs %d\n", a);
	if (!in[a]) {
//		printf ("no cont!\n");
		return;
	}
//	my_try ();
	if (dont_set != a && !used[a]) {
		used[a] = 1;
		start[sp++] = a;
	}

	for (int i = 0; i < N; ++i) {
		if (ma3x[a][i]) {
			Xassert (a != i);
//			printf ("%d -- %d\n", ma3x[a][i], cp);
			nums[a].push_back (cp);
			nums[i].push_back (cp);
			ans[ma3x[a][i]] = cp++;
			--in[a];
			--in[i];
			ma3x[a][i] = ma3x[i][a] = 0;
//			my_try ();
			return dfs (i);
		}
	}
//	my_try ();
	printf ("!!!!!!!%d -- %d\n", a, in[a]);
	Xassert (0);
}

int main () {
	scanf ("%d %d", &N, &M);

	int i;
	int a, b;
	memset (ma3x, 0, sizeof (ma3x));
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		Xassert (a != b);
		Xassert (!ma3x[a][b] && !ma3x[b][a]);
		ma3x[a][b] = ma3x[b][a] = i+1;
		++in[a];
		++in[b];
		for (int j = 0; j < N; ++j) {
			if (ma3x[j][j]) printf ("%d %d\n", j, i);
			Xassert (!ma3x[j][j]);
		}
	}
#ifndef ONLINE_JUDGE
	for (i = 0; i < N; ++i) {
		printf ("%d     ", in[i]);
		for (int j = 0; j < N; ++j)
			printf ("%d ", ma3x[i][j]);
		puts ("");
	}
#endif
//	my_try ();
	for (i = 0; i < N; ++i) Xassert (!ma3x[i][i]);

//	my_try ();
	for (i = 0; i < N; ++i)
		if (in[i] == 1) {
			dont_set = i;
			dfs (i);
		}

	for (i = 0; cp < M + 1; ++i, i %= sp)
		dfs (start[i]);

//	my_try ();
/*	for (i = 0; i < N; ++i)
		if (in[i] % 2 == 1) {
			dont_set;
			dfs (i);
		}

//	my_try ();
	for (i = 0; i < N; ++i)
		Xassert (in[i] % 2 == 0);

//	my_try ();
	for (i = 0; cp < M + 1; ++i, i %= N)
		dfs (i);
*/
//	my_try ();
	for (i = 0; i < N; ++i) {
		if (nums[i].size () < 2) continue;
		int cgcd = nums[i][0];
		for (size_t j = 1; j < nums[i].size (); ++j)
			cgcd = gcd (cgcd, nums[i][j]);
		Xassert (cgcd == 1);
	}

	printf ("YES\n%d", ans[1]);
	for (i = 2; i <= M; ++i)
		printf (" %d", ans[i]);
	puts ("");

	return 0;
}
