#include <cstdio>
//#include <cassert>
#include <algorithm>
#include <cmath>
#include <utility>

using std::pair;
typedef long long ll;

const pair<int, int> MOD(29573, 29573/*29581*/);

pair<int, int> operator * (const pair<int, int> &p1, const pair<int, int> &p2) {
	return pair<int, int> (((ll)p1.first * p2.first) % MOD.first
						, ((ll)p1.second * p2.second) % MOD.second);
}

pair<int, int> &operator -= (pair<int, int> &p1, const pair<int, int> &p2) {
	p1.first += MOD.first;
	p1.first -= p2.first;
	p1.first %= MOD.first;

	p1.second += MOD.second;
	p1.second -= p2.second;
	p1.second %= MOD.second;
	return p1;
}

int _mod;
int fast_pow(int base, int pow) {
	if (pow == 0) return 1;
	return (pow & 1 ?
				fast_pow(base, pow-1) * base :
				fast_pow((base * base) % _mod, pow / 2)) % _mod;
}

pair<int, int> inv(const pair<int, int> &x) {
	pair<int, int> ret;
	//printf("-->in\n");
	_mod = MOD.first;
	ret.first = fast_pow(x.first, MOD.first - 2);
	_mod = MOD.second;
	ret.second = fast_pow(x.second, MOD.second - 2);
	//printf("-->out\n");
	return ret;
}

void assert(bool x) {
	while(!x) ;
}

const int MAXN = 1 << 11;
const int MAXM = 1 << 6;

int n, m;
pair<int, int> t[MAXN][MAXM];
int price[MAXN];
int id[MAXN];

bool cmp(int a, int b) {
	return price[a] < price[b];
}

int main() {
	scanf("%d %d", &n, &m);

	int sum = 0;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int xx;
			scanf("%d", &xx);
			t[i][j] = pair<int, int> ((xx + MOD.first) % MOD.first, (xx + MOD.second) % MOD.second);
		}
	}

	for (int i = 0; i < n; i++) {
		scanf("%d", price + i);
	}

	for (int i = 0; i < n; i++) {
		id[i] = i;
	}

	std::stable_sort(id, id + n, cmp);

	//for (int i = 0; i < n; ++i) printf(" %d", id[i]); puts("");

	//long double EPS = 1e-6;

	for (int x = 0; x < m; x++) {
		//printf("x, m %d %d\n", x, m);
		bool found = false;
		for (int i = x; i < n; i++) {
			if (t[id[i]][x] != pair<int, int>(0, 0)) {
				int tmp = id[i];
				for (int j = i; j > x; j--) {
					id[j] = id[j - 1];
				}
				id[x] = tmp;
				sum += price[id[x]];
				found = true;
				break;
			}
		}
		if (found == false) {
			printf("0\n");
			return 0;
		}

		for (int i = x + 1; i < n; i++) {
			//printf("%d  %d\n", i, n);
			if (t[id[i]][x] == pair<int, int>(0, 0)) continue;
			pair<int, int> c = t[id[i]][x];
			c = c * inv(t[id[x]][x]);
			for (int j = x; j < m; j++) {
				//printf("j, m %d %d\n", j, m);
				t[id[i]][j] -= c * t[id[x]][j];
			}
			//printf("after for!\n");
			//printf("-- %d %d\n", t[id[i]][x].first, t[id[i]][x].second);
			assert (t[id[i]][x] == pair<int, int>(0, 0));
		}
	}

	//printf("----\n");

	printf("%d\n", sum);
	std::sort(id, id + m);
	for (int i = 0; i < m; i++) {
		printf("%d\n", id[i] + 1);
	}

	return 0;
}