/*
FROM: acm.timus.ru
PROB: 1045 (A funny game)
KEYW: game theory, tree, recursive
*/

#include <cstdio>
#include <vector>

const int MAXN = 1 << 10;

int N, K;
std::vector <int> gr[MAXN];
bool g[MAXN];
int prev[MAXN];

void f (int a, int pred) {
	g[a] = 0;
	prev[a] = MAXN;
	for (size_t i = 0; i < gr[a].size (); ++i) {
		if (gr[a][i] == pred) continue;
		f (gr[a][i], a);
		if (!g[gr[a][i]]) {
			g[a] = 1;
			if (prev[a] > gr[a][i])
				prev[a] = gr[a][i];
		}
	}
}

int main () {
	scanf ("%d %d", &N, &K);
	--K;

	int i, a, b;
	for (i = 1; i < N; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		gr[a].push_back (b);
		gr[b].push_back (a);
	}

	f (K, -1);
	if (g[K] == 1)
		printf ("First player wins flying to airport %d\n", prev[K] + 1);
	else
		printf ("First player loses\n");

	return 0;
}
