/*
FROM: acm.timus.ru
PROB: 1049 (Brave balloonists)
KEYW: euler totient function
*/

#include <cstdio>
#include <algorithm>

const int MAXP = 1 << 14;
const int MAX = 10000;
const int N = 10;

int P;
int pr[MAXP];
int pw[MAXP];
bool erat[MAXP];

int sq (int a) {return a * a;}

int log_pow (int base, int pow) {
	if (!pow) return 1;
	if (pow & 1) return base * log_pow (base, pow - 1) % 10;
	else return sq (log_pow (base, pow / 2)) % 10;
}

int main () {
	int i, j;
	for (i = 2; i * i <= MAX; ++i) {
		if (!erat[i]) {
			pr[P++] = i;
			for (j = i * i; j <= MAX; j += i)
				erat[j] = 1;
		}
	}
	for (; i <= MAX; ++i)
		if (!erat[i])
			pr[P++] = i;
//	for (i = 0; i < P; ++i) printf ("%d ", pr[i]);

	int a;
	for (i = 0; i < 10; ++i) {
		scanf ("%d", &a);
//		printf ("got %d\n", a);
		for (j = 0; pr[j] * pr[j] <= a; ++j)
			while (a % pr[j] == 0) {
//				printf ("++pw[%d] (%d)\n", j, pr[j]);
				a /= pr[j];
				++pw[j];
			}
		if (a > 1) {
//			printf ("%d is prime!\n", a);
			++pw[std::lower_bound (pr, pr + P, a) - pr];
		}
	}

	int res = 1;
	for (i = 0; i < P; ++i)
		if (pw[i]) {
			res *= pw[i] + 1;
			res %= 10;
/*			printf ("%d %d -- %d %d\n", pr[i], pw[i], (pr[i] - 1) % 10, log_pow (pr[i], pw[i] - 1));
			res *= (pr[i] - 1) % 10;
			res *= log_pow (pr[i], pw[i] - 1);
			res %= 10;
*/
		}

	printf ("%d\n", res);
	return 0;
}
