/*
FROM: acm.timus.ru
PROB: 1050 (Preparing an article)
KEYW: text processing
*/

#include <cstdio>
#include <cassert>
#include <cstring>
#include <cctype>

const int MAX_LINES = 256;
const int MAX_LINE_L = 128;

const int OPEN = 1;
const int CLOSE = 2;
const int REMOVE = 3;

int L;
char text[MAX_LINES][MAX_LINE_L];
char info[MAX_LINES][MAX_LINE_L];

int px, py;
int cs;
void do_par () {
//	fprintf (stderr, "__do par\n");
	if (cs == 1) info[px][py] = REMOVE;
	cs = 0;
}

int _j;
int read_command (int i, int j) {
	_j = j;
	char com[100], *cp = com;
	*cp++ = text[i][++_j];
	while (isalpha (text[i][++_j])) *cp++ = text[i][_j];
	*cp = '\0';
//	fprintf (stderr, "__%s__  %c\n", com, text[i][_j]);
	if (strcmp (com, "endinput") == 0)
		return 1;
	else if (strcmp (com, "par") == 0)
		return 2;
	return 3;
}

int main () {
	while (gets (text[L++]));
	--L;

	int i, j;
/*	for (i = 0; i < L; ++i)
		puts (text[i]);
*/
	bool is_end = 0;
	for (i = 0; i < L; ++i) {
		if (text[i][0] == '\0')
			do_par ();
		for (j = 0; text[i][j] != '\0'; ++j) {
			switch (text[i][j]) {
				case '\\':
					switch (read_command (i, j)) {
						case 1: /*end of input*/
								/*do the same as paragraph*/
								is_end = 1;
						case 2: /*par*/
								do_par ();
					}
//					fprintf (stderr, "moved %d %d -- %d %d\n", i, j, i, _j - 1);
					j = _j - 1;
					break;
				case '"':
//					fprintf (stderr, "found %d %d -- %d\n", i, j, cs);
					switch (cs) {
						case 0: info[i][j] = OPEN; px = i; py = j; cs = 1; break;
						case 1: info[i][j] = CLOSE; cs = 0; break;
						default: assert (0);
					}
			}
		}
	}

	for (i = 0; i < L; ++i) {
		for (j = 0; text[i][j] != '\0'; ++j) {
			if (info[i][j] == OPEN)
				printf ("``");
			else if (info[i][j] == CLOSE)
				printf ("''");
			else if (info[i][j] != REMOVE)
				putchar (text[i][j]);
		}
		puts ("");
	}

	return 0;
}
