/*
FROM: acm.timus.ru
PROB: 1052 (Rabbit hunt)
KEYW: geometry, vectors
*/

#include <cstdio>
#include <algorithm>
#include <map>

const int MAXN = 1 << 8;

int gcd (int a, int b) {
	return b ? gcd (b, a % b) : a;
}

struct pnt {
	int x, y;
	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}

	pnt operator + (const pnt &a) const {return pnt (x + a.x, y + a.y);}
	pnt operator - (const pnt &a) const {return pnt (x - a.x, y - a.y);}
	bool operator < (const pnt &a) const {return x != a.x ? x < a.x : y < a.y;}
	void norm () {if (x < 0 || x == 0 && y < 0) x *= -1, y *= -1; int k = gcd (x, y); x /= k; y /= k;}
};

int N;
pnt vec[MAXN];

int main () {
	scanf ("%d", &N);
	
	int i, j;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &vec[i].x, &vec[i].y);

	int ans = 0;
	std::map <pnt, int> db;
	for (i = 0; i < N; ++i) {
		db = std::map <pnt, int> ();
		for (j = 0; j < N; ++j) {
			if (i == j) continue;
			pnt cvec = vec[j] - vec[i];
			cvec.norm ();
			ans = std::max (ans, ++db[cvec]);
		}
	}

	printf ("%d\n", ans + 1);

	return 0;
}
