/*
FROM: acm.timus.ru
PROB: 1055 (Combinations)
KEYW: prime factors, long number multiplication / division using prime numbers
*/

#include <cstdio>
#include <map>
#include <algorithm>

const int MAXP = 1 << 14;
const int MAX = 1 << 16;
int P;
int N, M;
int pr[MAXP];
bool erat[MAX];

int main () {
	pr[P++] = 2;
	int i, j;
	for (i = 3; i * i < MAX; i += 2)
		if (!erat[i]) {
			pr[P++] = i;
			for (j = i * i; j < MAX; j += i)
				erat[j] = 1;
		}
	for (; i < MAX; ++i)
		if (!erat[i])
			pr[P++] = i;

//	printf ("%d\n", P);

	scanf ("%d %d", &N, &M);
	if (M > N - M) M = N - M;

	std::map <int, int> db;
	int a, aa;
	for (aa = N-M+1; aa <= N; ++aa) {
		a = aa;
		for (i = 0; pr[i] * pr[i] <= a; ++i) {
			while (a % pr[i] == 0) {
				a /= pr[i];
				++db[i];
			}
		}
		if (a != 1)
			++db[std::lower_bound (pr, pr + P, a) - pr];
	}
	for (aa = 1; aa <= M; ++aa) {
		a = aa;
		for (i = 0; pr[i] * pr[i] <= a; ++i) {
			while (a % pr[i] == 0) {
				a /= pr[i];
				--db[i];
			}
		}

		if (a != 1)
			--db[std::lower_bound (pr, pr + P, a) - pr];
	}

	int ans = 0;
	for (std::map <int, int> :: iterator it = db.begin (); it != db.end (); ++it) {
		if (it->second)
			++ans;
	}

	printf ("%d\n", ans);

	return 0;
}
