/*
FROM: acm.timus.ru
PROB: 1056 (Computer net)
KEYW: find the center of a tree (2 diameters)
*/

#include <cstdio>
#include <cstring>
#include <algorithm>

const int MAXN = 1 << 14;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N;
int vec[MAXN];
el buf[MAXN * 2];

int _q[MAXN];
int _prev[MAXN];
int _d[MAXN];

int bfs (int start) {
	int p3 = 0;
	memset (_prev, -1, sizeof (_prev));
	_q[p3++] = start;
	_prev[start] = -2;
	_d[start] = 0;

	int i, j;
	for (i = 0; i < p3; ++i) {
//		printf ("popped %d %d %d\n", _q[i], _d[_q[i]], _prev[_q[i]]);
		for (j = vec[_q[i]]; j != -1; j = buf[j].next) {
			if (_prev[buf[j].to] == -1) {
//				printf ("push %d %d\n", buf[j].to, _prev[buf[j].to]);
				_prev[buf[j].to] = _q[i];
				_q[p3++] = buf[j].to;
				_d[buf[j].to] = _d[_q[i]] + 1;
			}
		}
	}

	return _q[p3-1];
}

int main () {
	scanf ("%d", &N);

	int i, j;
	int a;
	int bp = 0;
	memset (vec, -1, sizeof (vec));
	for (i = 1; i < N; ++i) {
		scanf ("%d", &a);
		--a;
//		printf ("%d %d\n", a, i);
		buf[bp] = el (a, vec[i]);
		vec[i] = bp++;
		buf[bp] = el (i, vec[a]);
		vec[a] = bp++;
	}
/*
	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (j = vec[i]; j != -1; j = buf[j].next)
			printf (" %d", buf[j].to);
		puts ("");
	}
*/
	int md = bfs (0);
//	for (i = 0; i < N; ++i) printf ("%d ", _d[i]); puts ("");
	int md2 = bfs (md);
//	for (i = 0; i < N; ++i) printf ("%d ", _d[i]); puts ("");

	int cnt = _d[md2] / 2;
	int p2 = _d[md2] & 1;
	while (cnt--) md2 = _prev[md2];
	if (!p2)
		printf ("%d\n", md2 + 1);
	else
		printf ("%d %d\n", std::min (_prev[md2], md2) + 1, std::max (_prev[md2], md2) + 1);

	return 0;
}
