/*
FROM: acm.timus.ru
PROB: 1057 (Amount of degrees)
KEYW: coding / decoding combinations, binary search
*/

#include <cstdio>

const int MAXC = 1 << 5;

long long C[MAXC][MAXC];

void init () {
	C[0][0] = 1;
	int i, j;
	for (i = 1; i < MAXC; ++i) {
		C[i][0] = 1;
		for (j = 1; j <= i; ++j)
			C[i][j] = C[i-1][j-1] + C[i-1][j];
	}
}

int N, M;
void decode (long long code, int comb[]) {
	for (int i = 0, p = 0; p != M; ++i) {
		if ((code -= C[N-i-1][M-p-1]) < 0) {
			code += C[N-i-1][M-p-1];
			comb[p++] = i;
		}
	}
}

long long X, Y;
int K, B;
long long powB[MAXC];

long long calc (long long id) {
	int comb[MAXC];
	id = C[N][M] - id - 1;
	decode (id, comb);
	long long res = 0;
	for (int i = 0; i < K; ++i)
		res += powB[N-1-comb[i]];
	return res;
}

long long bsrch (long long a) {
	long long l = -1, r = C[N][M], m;
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (calc (m) > a)
			r = m;
		else
			l = m;
	}
	return l;
}

int main () {
#ifdef ONLINE_JUDGE
	scanf ("%I64d %I64d %d %d", &X, &Y, &K, &B);
#else
	scanf ("%Ld %Ld %d %d", &X, &Y, &K, &B);
#endif
	--X;
	init ();

	powB[0] = 1;
	int i;
	for (i = 1;; ++i) {
		powB[i] = powB[i-1] * B;
		if (powB[i] > Y)
			break;
	}
	N = i;
	M = K;
/*
	int comb[MAXC];
	for (i = 0; i < 20; ++i) {
		printf ("%d ->", i);
		printf ("%Ld\n", calc (i));
//		for (int j = 0; j < M; ++j)\
			printf (" %d", comb[j]);\
		puts ("");
	}
*/

	long long p1 = bsrch (X);
	long long p2 = bsrch (Y);
	
#ifdef ONLINE_JUDGE
	printf ("%I64d\n", p2 - p1);
#else
	printf ("%Ld\n", p2 - p1);
#endif

	return 0;
}
