/*
FROM: acm.timus.ru
PROB: 1058 (Chocolate)
KEYW: binary search, ternary search, geometry, absolute shit
*/

#include <cstdio>
#include <algorithm>
#include <cmath>

const int MAXN = 1 << 6;
const double EPS = 1e-6;
const int TSC = 100;
const int BSC = 100;

struct pnt {
	double x, y;
	pnt () {}
	pnt (double _x, double _y) : x (_x), y (_y) {}

	pnt operator + (const pnt &a) const {return pnt (x + a.x, y + a.y);}
	pnt operator - (const pnt &a) const {return pnt (x - a.x, y - a.y);}

	pnt operator * (double a) const {return pnt (x * a, y * a);}
	pnt operator / (double a) const {return pnt (x / a, y / a);}

	double sq () const {return x * x + y * y;}
};

double S (const pnt &a, const pnt &b, const pnt &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

int N;
pnt vec[MAXN];
double halfs;
double ans = 1e99;

double SS (int si, int ei, const pnt &a, const pnt &b) {
	int i;
	double res = 0;
	for (i = si; i < ei; ++i) {
		res += vec[i].x * vec[i+1].y;
		res -= vec[i].y * vec[i+1].x;
	}
	res += vec[ei].x * a.y;
	res -= vec[ei].y * a.x;
	res += a.x * b.y;
	res -= a.y * b.x;
	res += b.x * vec[si].y;
	res -= b.y * vec[si].x;
	return fabs (res);
}

double fnd1b (const pnt &sp, const pnt &p1, const pnt &p2, int pi1, int pi2) {
	pnt v = p2 - p1;
	pnt pp;
	double l = 0., r = 1., m;
	for (int k = 0; k < BSC; ++k) {
		m = (l + r) / 2.;
		pp = v * m + p1;
		if (SS (pi1, pi2, sp, pp) < halfs)
			r = m;
		else
			l = m;
	}
	return l;
}

double clen (const pnt &sp, const pnt &p1, const pnt &p2, int pi1, int pi2) {
	pnt v = p2 - p1;
	pnt pp;
	double l = 0., r = 1., m;
	for (int k = 0; k < BSC; ++k) {
		m = (l + r) / 2.;
		pp = v * m + p1;
		if (SS (pi1, pi2, pp, sp) < halfs)
			l = m;
		else
			r = m;
	}
	pp = v * l + p1;
	return (pp - sp).sq ();
}

void fm (int id1, int id2) {
//	printf ("fm %d %d\n", id1, id2);

	pnt v = vec[id1+1] - vec[id1];
	pnt s = vec[id1];
	double l, r, m1, m2;
	l = fnd1b (vec[id2  ], vec[id1], vec[id1+1], id1 + 1, id2);
	r = fnd1b (vec[id2+1], vec[id1], vec[id1+1], id1 + 1, id2);
	
	for (int k = 0; k < TSC; ++k) {
		m1 = (r - l) / 3. + l;
		m2 = (m1 + r) / 2.;
		if (clen (v * m1 + s, vec[id2], vec[id2+1], id1+1, id2)
		  > clen (v * m2 + s, vec[id2], vec[id2+1], id1+1, id2))
			l = m1;
		else
			r = m2;
	}
	ans = std::min (ans, clen (v * l + s, vec[id2], vec[id2+1], id1+1, id2));
}

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i) {
		scanf ("%lf %lf", &vec[i].x, &vec[i].y);
	}
	vec[N] = vec[0];

	halfs = SS (1, N-2, vec[N-1], vec[0]) / 2;
//	printf ("%lf\n", halfs / 2.);

	for (i = 0; i + 1 < N; ++i) {
		for (j = i + 1; j < N; ++j) {
			if (SS (i+1, j, vec[j+1], vec[i]) > halfs - EPS
			 && SS (i+1, j, vec[j], vec[i+1]) < halfs + EPS) {
				fm (i, j);
			}
		}
	}

	printf ("%.10lf\n", sqrt (ans));

	return 0;
}
