/*
FROM: acm.timus.ru
PROB: 1060 (Flip Game)
KEYW: bfs with mask
*/

#include <cstdio>
#include <cstring>

typedef unsigned short brd_t;
const int MAXBRD = 1 << 16;

const int POS = 16;
const int MAXM = 8;//[3;5]

const int dx[] = {-1, 0, 1,  0, 0};
const int dy[] = { 0, 1, 0, -1, 0};

int mc[POS];
int m[POS][MAXM];

brd_t apply (brd_t x, int pos) {
	for (int k = 0; k < mc[pos]; ++k)
		x ^= 1 << m[pos][k];
	return x;
}

void init () {
	int ids[4][4];
	int cid = 0;
	int i, j, k;
	for (i = 3; i >= 0; --i)
		for (j = 3; j >= 0; --j)
			ids[i][j] = cid++;

	int ii, jj;
	for (i = 0; i < 4; ++i)
		for (j = 0; j < 4; ++j) {
			for (k = 0; k < 5; ++k) {
				ii = i + dx[k];
				jj = j + dy[k];
				if (ii >= 0 && ii < 4
				 && jj >= 0 && jj < 4)
					m[ids[i][j]][mc[ids[i][j]]++] = ids[ii][jj];
			}
		}
}

int bfs (brd_t start) {
	static brd_t q[MAXBRD];
	static int d[MAXBRD];
	int p3, i, j;

	memset (d, -1, sizeof (d));
	q[p3 = 0, p3++] = start;
	d[start] = 0;
	for (i = 0; i < p3; ++i) {
		if (q[i] == 0 || q[i] == 0xffff)
			return d[q[i]];
		for (j = 0; j < 16; ++j) {
			brd_t go = apply (q[i], j);
			if (d[go] == -1) {
				d[go] = d[q[i]] + 1;
				q[p3++] = go;
			}
		}
	}
	return -1;
}

int main () {
	init ();

	int i;
	char c;
	brd_t start = 0;
	for (i = 0; i < POS; ++i) {
		scanf (" %c", &c);
		start <<= 1;
		if (c == 'w')
			start |= 1;
	}
//	printf ("%x\n", (unsigned)start);

/*	int j, k, id;
	for (i = 0; i < 4; ++i)
		for (j = 0; j < 4; ++j) {
			id = 15 - (i * 4 + j);
			printf ("%d ->", id);
			for (k = 0; k < mc[id]; ++k)
				printf (" %d", m[id][k]);
			puts ("");
		}
*/
	int ans = bfs (start);
	if (ans == -1)
		printf ("Impossible\n");
	else
		printf ("%d\n", ans);

	return 0;
}
