/*
FROM: acm.timus.ru
PROB: 1063 (Domino Puzzle)
KEYW: full exhaustion
*/

#include <cstdio>
#include <cstring>
#include <algorithm>

const int MAXDEPTH = 6;

int ans = 1000;
bool used[6];

inline void app (char *prev, int i, int j) {
	static char p, q;
	for (p = prev[i]; prev[p] != p; p = prev[p]) prev[p] = prev[prev[p]];
	for (q = prev[j]; prev[q] != q; q = prev[q]) prev[q] = prev[prev[q]];
	if (p == q) return;
	prev[p] = q;
}

inline bool chk (char *prev, unsigned char odd) {
	static char i, j, rt;

	rt = -1;
	for (i = 0; i < 6; ++i) {
		if (!used[i]) continue;
		if (rt == -1) {
			for (j = prev[i]; j != prev[j]; j = prev[j]) prev[j] = prev[prev[j]];
			rt = j;
			continue;
		}
		for (j = prev[i]; j != prev[j]; j = prev[j]) prev[j] = prev[prev[j]];
		if (rt != j) return 0;
	}
	if (!odd) return 1;//it is a cycle
	odd &= odd - 1;
	odd &= odd - 1;
	return !odd;//there are exactly 2 odd degree edges
}

int arh[6][2];
int barh[6][2], bd;

void rec (char depth, char *prev, unsigned char odd, unsigned char price) {
	if (price >= ans) return;
	if (chk (prev, odd)) {
		ans = price;
		bd = depth;
		memcpy (barh, arh, sizeof (barh));
		return;
	}

	if (depth == MAXDEPTH) return;

	char i, j;
	char nprev[6];
	char nodd;
	for (i = 0; i < 5; ++i) {
		if (!used[i]) continue;
		for (j = i+1; j < 6; ++j) {
			if (!used[j]) continue;
			arh[depth][0] = i;
			arh[depth][1] = j;
			memcpy (nprev, prev, sizeof (nprev));
			app (nprev, i, j);
			nodd = odd ^ (1 << i) ^ (1 << j);
			rec (depth + 1, nprev, nodd, price + i + j + 2);
		}
	}
}

int main () {
	int N;
	scanf ("%d\n", &N);
	int i;
	int a, b;
	char prev[6] = {0};
	unsigned char odd = 0;
//	int iu = 7;
	for (i = 0; i < 6; ++i) prev[i] = i;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
	
		used[a] = 1;
		used[b] = 1;
//		iu = std::min (iu, std::min (a, b));
		if (a == b) continue;
		app (prev, a, b);
		odd ^= (1 << a) ^ (1 << b);
	}
//	for (i = 0; i < 6; ++i) if (!used[i]) app (prev, i, iu);//link it

	rec (0, prev, odd, 0);
	printf ("%d\n", ans);
	printf ("%d\n", bd);
	for (i = 0; i < bd; ++i)
		printf ("%d %d\n", barh[i][0] + 1, barh[i][1] + 1);

	return 0;
}
