/*
FROM: acm.timus.ru
PROB: 1065 (Frontier)
KEYW: dynamical programming, computational geometry
*/

#include <cstdio>
#include <cmath>
#include <vector>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 6;
const int MAXM = 1 << 10;
const double INF = 1e99;

struct pnt {
	int x, y;
	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}
};

int S (const pnt &a, const pnt &b, const pnt &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

int N, M;
pnt vec[MAXN * 2];
pnt mon[MAXM];
std::vector <std::pair <int, double> > gr[MAXN * 2];

double dst (const pnt &a, const pnt &b) {
	return hypot (a.x - b.x, a.y - b.y);
}

int main () {
	scanf ("%d %d", &N, &M);

	int i, j, k, l;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &vec[i].x, &vec[i].y);
		vec[i+N] = vec[i];
	}

	for (i = 0; i < M; ++i)
		scanf ("%d %d", &mon[i].x, &mon[i].y);

	double ans = 0;
	for (i = 0; i < N; ++i) {
		for (j = i + 1; j < i + N; ++j) {
			for (k = 0; k < M; ++k)
				if (S (vec[i], vec[j], mon[k]) >= 0)
					goto nxti;
			gr[i].push_back (std::make_pair (j, dst (vec[i], vec[j])));
			if (j + N < 2 * N) gr[i+N].push_back (std::make_pair (j+N, dst (vec[i], vec[j])));
//			printf ("%d %d %lf\n", i, j, dst (vec[i], vec[j]));
		}
		nxti:;
		ans += dst (vec[i], vec[i+1]);
	}

	static double dp[MAXN * 2][2];
	for (i = 0; i < N; ++i) {
		for (j = 0; j < MAXN * 2; ++j) dp[j][0] = dp[j][1] = INF;
		dp[i][0] = 0;
//		printf ("now in i == %d (%d)\n", i, gr[i].size ());

		for (j = i; j < i + N; ++j) {
			for (l = 0; l < 2; ++l) {
				if (dp[j][l] == INF) continue;
//				printf ("[%d][%d] == %lf\n", j, l, dp[j][l]);
				for (size_t k = 0; k < gr[j].size (); ++k) {
					if (gr[j][k].first > i + N) break;
					if (l == 0 && gr[j][k].first == i + N) continue;
					bool go_t = l || j != i && S (vec[i], vec[j], vec[gr[j][k].first]);
//					if (gr[j][k].first == i + N) printf ("!!!\n");
//					printf ("\ttry upd %d %d -- %lf\n", gr[j][k].first, 1, dp[j][l] + gr[j][k].second);
//					if (dp[gr[j][k].first][go_t] > dp[j][l] + gr[j][k].second)\
						dp[gr[j][k].first][go_t] = dp[j][l] + gr[j][k].second;
					dp[gr[j][k].first][go_t] = std::min (dp[gr[j][k].first][go_t], dp[j][l] + gr[j][k].second);
				}
			}
		}
//		printf ("%lf\n", dp[i+N][1]);
//		if (ans > dp[i+N][1])\
			ans = dp[i+N][1];
		ans = std::min (ans, dp[i+N][1]);
	}

	printf ("%.2lf\n", ans);

	return 0;
}
