/*
FROM: acm.timus.ru
PROB: 1069 (The Prufer code)
KEYW: tree, coding, heap
*/

#include <cstdio>
#include <vector>
#include <queue>
#include <algorithm>

const int MAXN = 1 << 13;

std::priority_queue <int, std::vector <int>, std::greater <int> > heap;

int N;
int row[MAXN];
int cir[MAXN];

std::vector <int> gr[MAXN];

int main () {
	int i = 0;
	while (scanf ("%d", row + i) == 1) {
		++cir[--row[i]];
		++i;
	}
	N = i+1;
	for (i = 0; i < N; ++i)
		if (!cir[i])
			heap.push (i);
	
	int c;
	for (i = 0; i + 1 < N; ++i) {
		c = heap.top (); heap.pop ();
		gr[c].push_back (row[i]);
		gr[row[i]].push_back (c);
		if (!(--cir[row[i]]))
			heap.push (row[i]);
	}

	for (i = 0; i < N; ++i) {
		printf ("%d:", i + 1);
		std::sort (gr[i].begin (), gr[i].end ());
		for (size_t j = 0; j < gr[i].size (); ++j)
			printf (" %d", gr[i][j] + 1);
		puts ("");
	}

	return 0;
}
