/*
FROM: acm.timus.ru
PROB: 1072 (Routing)
KEYW: bfs
*/

#include <cstdio>
#include <cstring>
#include <utility>
#include <vector>

const int MAXN = 1 << 7;

typedef unsigned net;

int N;
std::vector <std::pair <net, net> > data[MAXN];

net read_net () {
	unsigned a, b, c, d;
	scanf ("%u.%u.%u.%u", &a, &b, &c, &d);
	return a << 24 | b << 16 | c << 8 | d;
}

void bfs (int s, int f) {
	static int q[MAXN];
	static int prev[MAXN];
	int p3, i, j;
	std::vector <std::pair <net, net> >::iterator k1, k2;
	memset (prev, -1, sizeof (prev));
	q[p3 = 0, p3++] = s;
	prev[s] = -2;

	for (i = 0; i < p3; ++i) {
//		printf ("!! %d %d %d %d	\n", i, s, q[i], p3);
//		printf ("popped %d\n", q[i]);
		if (q[i] == f) break;
		for (j = 0; j < N; ++j) {
//			printf ("j == %d\n", j);
			if (prev[j] != -1) continue;
			for (k1 = data[q[i]].begin (); k1 != data[q[i]].end (); ++k1)
				for (k2 = data[j].begin (); k2 != data[j].end (); ++k2) {
//					printf ("%d %d -- %u %u  %u %u  %u %u\n", k1, k2\
					, data[q[i]][k1].first, data[q[i]][k1].second\
					, data[j][k2].first, data[j][k2].second\
					, data[q[i]][k1].first | data[q[i]][k1].second\
					, data[j][k2].first | data[j][k2].second);

					if ((k1->first & k1->second)
					 == (k2->first & k2->second)) {
//					 	printf ("push! %d\n", j);
						q[p3++] = j;
						prev[j] = q[i];
						goto nxtj;
					}
				}
			nxtj:;
		}
	}

	if (q[i] == f) {
		static int ans[MAXN], ap;
		ap = 0;
		for (j = f; j != s; j = prev[j]) ans[ap++] = j;
		printf ("Yes\n%d", s + 1);
		for (j = ap-1; j >= 0; --j)
			printf (" %d", ans[j] + 1);
		puts ("");
	} else
		printf ("No\n");
}

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &j);
		while (j--)
			data[i].push_back (std::make_pair (read_net (), read_net ()));
	}
/*
	for (i = 0; i < N; ++i) {
		for (size_t j = 0; j < data[i].size (); ++j)
			printf ("%u %u\n", data[i][j].first, data[i][j].second);
		printf ("\n");
	}
*/
	int s, f;
	scanf ("%d %d", &s, &f);
	--s; --f;
	bfs (s, f);

	return 0;
}
