/*
FROM: acm.timus.ru
PROB: 1076 (Trash)
KEYW: hungarian algorithm
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <algorithm>

const int MAXN = 152;

int N;
int trash[MAXN][MAXN];
//int shift[MAXN][MAXN][MAXN];

////////////////////
int data[MAXN][MAXN];

//const int MAXN = 1 << 8;
const int INF = 1 << 30;

//int N;
//int data[MAXN][MAXN];
int ma3x[MAXN][MAXN];//working version
bool match[MAXN][MAXN];//result

bool r_cov[MAXN], c_cov[MAXN];
/*
void prnt_ma3x (char *msg, bool disp = 0) {
	printf ("%s\n", msg);
	if (disp) {
		printf ("   ");
		for (int j = 0; j < N; ++j)
			if (c_cov[j])
				printf ("  W ");
			else
				printf ("    ");
		puts ("");
	}
	for (int i = 0; i < N; ++i) {
		if (disp) {
			if (r_cov[i])
				printf ("-> ");
			else
				printf ("   ");
		}
		for (int j = 0; j < N; ++j)
			printf ("%3d ", ma3x[i][j]);
		puts ("");
	}

	puts ("");
}
*/
//BEGIN dinitz
const int MAXM = 2 * MAXN * (MAXN + 2);
struct el {
	int to;
	int rd;
	int next;
	el () {}
	el (int _to, int _rd, int _next) : to (_to), rd (_rd), next (_next) {}
};

int vec[MAXN * 2];
el buf[MAXM]; int M;
int source, sink;

int D[MAXN * 2];//use only this (without used for the dfs -- fastest and most hardcore :) )

int __save_source_d;
bool bfs () {
	static int q[MAXN * 2], p3;
	static int i, j;

	memset (D, -1, sizeof (D));
	D[sink] = 0;
	q[p3 = 0, p3++] = sink;

	for (i = 0; i < p3; ++i) {
		for (j = vec[q[i]]; j != -1; j = buf[j].next)
			if (D[buf[j].to] == -1 && buf[j^1].rd) {
				D[buf[j].to] = D[q[i]] + 1;
				q[p3++] = buf[j].to;
			}
	}
	return (__save_source_d = D[source]) != -1;
}

bool dfs (int a) {
	if (a == sink) {
//		printf ("<-sink-\n");
		return 1;
	}

	for (int i = vec[a]; i != -1; i = buf[i].next)
		if (D[buf[i].to] == D[a] - 1 && buf[i].rd
		 && dfs (buf[i].to)) {
//		 	printf ("<-%d-\n", a);
		 	buf[i].rd = 0;
		 	buf[i^1].rd = 1;
			D[a] = -2;//unusable;
			return 1;
		}

	D[a] = -2;//unusable
	return 0;
}

//int __flow;
int dinitz () {
	static int flow;
	flow = 0;
//	printf ("NEW dinitz!\n");
	while (bfs ())
		while (D[source] = __save_source_d, dfs (source)) {
			++flow;
//			printf ("--\n");
		}

//	__flow = flow;
	return flow;
}
//END dinitz

void gen_match_graph () {
	static int bp, i, j;
	memset (vec, -1, sizeof (vec));

	bp = 0;
	sink = (source = 2 * N) + 1;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			if (!ma3x[i][j]) {
				buf[bp] = el (j + N, 1, vec[i]);
				vec[i] = bp++;
				buf[bp] = el (i, 0, vec[j+N]);
				vec[j+N] = bp++;
			}

	for (i = 0; i < N; ++i) {
		buf[bp] = el (i, 1, vec[source]);
		vec[source] = bp++;
		buf[bp] = el (source, 0, vec[i]);
		vec[i] = bp++;

		buf[bp] = el (sink, 1, vec[i+N]);
		vec[i+N] = bp++;
		buf[bp] = el (i+N, 0, vec[sink]);
		vec[sink] = bp++;
	}
	M = bp;
}

void do_cut () {
	static int i;
	memset (r_cov, 0, sizeof (r_cov));
	memset (c_cov, 0, sizeof (c_cov));
	for (i = 0; i < M; i += 2)
		if (D[buf[i  ].to] != -1
		 && D[buf[i^1].to] == -1) {
			if (buf[i^1].to == source) {
				r_cov[buf[i].to] = 1;
			} else if (buf[i].to == sink) {
				c_cov[buf[i^1].to-N] = 1;
			} else {
				assert (buf[i^1].to < N);
				r_cov[buf[i^1].to] = 1;
			}
		}
}

void hung () {
	static int mc[MAXN];//minimum element in each column (calculated when finding minimum in each row)
	memcpy (ma3x, data, sizeof (ma3x));//save data -> work in ma3x

	int i, j;
	for (j = 0; j < N; ++j) mc[j] = INF;
	for (i = 0; i < N; ++i) {
		int cmin = ma3x[i][0];
		for (j = 1; j < N; ++j) {
//			printf ("j, cmin, ma3x[i][j] %d %d %d\n", j, cmin, ma3x[i][j]);
			cmin = std::min (cmin, ma3x[i][j]);
		}
//		printf ("row %d -- %d\n", i, cmin);
		for (j = 0; j < N; ++j) {
			ma3x[i][j] -= cmin;
			mc[j] = std::min (mc[j], ma3x[i][j]);
		}
	}

//	prnt_ma3x ("after 0st stage");

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			ma3x[i][j] -= mc[j];

//	prnt_ma3x ("after 1st stage");

	while (gen_match_graph (), dinitz () != N) {
//		printf ("__flow == %d\n", __flow);
		do_cut ();//fill in r_cov, c_cov
//		prnt_ma3x ("before sth", 1);
		int cmin = INF;
		for (i = 0; i < N; ++i) {
			if (r_cov[i]) continue;
			for (j = 0; j < N; ++j) {
				if (c_cov[j]) continue;
				cmin = std::min (cmin, ma3x[i][j]);
			}
		}
		assert (cmin);
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j) {
				int sval = r_cov[i] + c_cov[j] - 1;//-1 0 1
				ma3x[i][j] += sval * cmin;
			}
//		prnt_ma3x ("after sth");
//		for (int k = 0; k < 100000000; ++k);
	}

	for (i = 0; i < N; ++i) {
		for (j = vec[i]; j != -1; j = buf[j].next)
			if (buf[j].to != source && !buf[j].rd) {
//				printf ("add edge %d %d\n", i, buf[j].to-N);
				match[i][buf[j].to-N] = 1;
				break;
			}
		assert (j != -1);//we have breaked
	}
	//we are done!
}
/////////////////////

int main () {
	scanf ("%d", &N);

	int i, j, k;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			scanf ("%d", trash[i] + j);
/*
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			shift[i][j][j] = 0;
			for (k = j+1; k < N; ++k)
				shift[i][j][k] = shift[i][j][k-1] + trash[k][i] * (k - j);
			for (k = j-1; k >= 0; --k)
				shift[i][j][k] = shift[i][j][k+1] + trash[k][i] * (j - k);
		}
*/
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			for (k = 0; k < N; ++k) {
//				printf ("data[i][j] += %d * abs (%d - %d)\n",trash[k][i], k, j);
				data[i][j] += trash[k][i] * (!!abs (k - j));
			}
//			printf ("%d %d -- %d\n", i, j, data[i][j]);
		}
/*
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			printf (" %3d", data[i][j]);
		puts ("");
	}
*/
	hung ();

	int sum = 0;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			if (match[i][j]) {
//				printf ("%d %d %d\n", i, j, data[i][j]);
				sum += data[i][j];
				break;
			}

	printf ("%d\n", sum);

	return 0;
}
