/*
FROM: acm.timus.ru
PROB: 1077 (Travelling tours)
KEYW: spanning tree
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 8;//256
const int MAXM = MAXN * MAXN;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N, M;
int vec[MAXN];
el buf[MAXM];

int lvl[MAXN];
int prev[MAXN];

int ct;
int ans[MAXN * MAXN][MAXN];
int ts[MAXN * MAXN];

void dfs (int a) {
//	printf ("dfs %d (%d %d)\n", a, prev[a], lvl[a]);
	for (int i = vec[a]; i != -1; i = buf[i].next) {
		if (lvl[buf[i].to] == -1) {
			lvl[buf[i].to] = lvl[a] + 1;
			prev[buf[i].to] = a;
			dfs (buf[i].to);
		} else if (lvl[buf[i].to] > lvl[a]) {
//			printf ("path from %d - %d\n", buf[i].to, a);
			for (int j = buf[i].to; j != prev[a]; j = prev[j]) {
//				printf ("bs %d\n", j);
				ans[ct][ts[ct]++] = j;
			}
//			printf ("--\n");
			++ct;
		}
	}
}

int main () {
	scanf ("%d %d", &N, &M);

	int i, j;
	int a, b;
	int bp = 0;
	memset (vec, -1, sizeof (vec));
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
	
		buf[bp] = el (b, vec[a]);
		vec[a] = bp++;
		buf[bp] = el (a, vec[b]);
		vec[b] = bp++;
	}

	memset (lvl, -1, sizeof (lvl));
	for (i = 0; i < N; ++i)
		if (lvl[i] == -1) {
			prev[i] = -2;
			lvl[i] = 0;
			dfs (i);
		}

	printf ("%d\n", ct);
	for (i = 0; i < ct; ++i) {
		printf ("%d", ts[i]);
		for (j = 0; j < ts[i]; ++j)
			printf (" %d", ans[i][j] + 1);
		puts ("");
	}

	return 0;
}
