/*
FROM: acm.timus.ru (Winter 2001 A)
PROB: 1078 (Segments)
KEYW: dynamical programming
*/

#include <cstdio>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 9;

int N;
std::pair <int, int> vec[MAXN];
int idx[MAXN];
int prev[MAXN];
int max_depth[MAXN];

bool cmp (int a, int b) {
	return vec[a].second - vec[a].first > vec[b].second - vec[b].first;
}

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &vec[i].first, &vec[i].second);
		if (vec[i].first > vec[i].second)
			std::swap (vec[i].first, vec[i].second);
		idx[i] = i;
		prev[i] = -1;
	}

	std::sort (idx, idx + N, cmp);

	for (i = 0; i < N; ++i) {
		for (j = i+1; j < N; ++j) {
			if (vec[idx[j]].first > vec[idx[i]].first
			 && vec[idx[j]].second < vec[idx[i]].second) {
				if (max_depth[idx[j]] < max_depth[idx[i]] + 1) {
					max_depth[idx[j]] = max_depth[idx[i]] + 1;
					prev[idx[j]] = idx[i];
				}
			}
		}
	}

	int mdi = 0;
	for (i = 1; i < N; ++i)
		if (max_depth[i] > max_depth[mdi])
			mdi = i;

	printf ("%d\n", max_depth[mdi] + 1);
	for (i = mdi; i != -1; i = prev[i]) {
		if (i != mdi) putchar (' ');
		printf ("%d", i + 1);
	}
	puts ("");

	return 0;
}
