/*
FROM: acm.timus.ru (Winter 2001 A)
PROB: 1080 (Map colouring)
KEYW: dfs
*/

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>

const int MAXN = 1 << 7;

int N;
std::vector <int> gr[MAXN];

char col[MAXN];

void dfs (int a) {
	for (size_t i = 0; i < gr[a].size (); ++i) {
		if (!col[gr[a][i]]) {
			col[gr[a][i]] = 3 - col[a];
			dfs (gr[a][i]);
		} else if (col[gr[a][i]] != 3 - col[a]) {
			printf ("-1\n");
			exit (0);
		}
	}
}

int main () {
	scanf ("%d", &N);

	int i;
	int a;
	for (i = 0; i < N; ++i)
		while (scanf ("%d", &a), a) {
			gr[i].push_back (--a);
			gr[a].push_back (i);
		}
	for (i = 0; i < N; ++i) {
		std::sort (gr[i].begin (), gr[i].end ());
		gr[i].resize (std::unique (gr[i].begin (), gr[i].end ()) - gr[i].begin ());
	}

	col[0] = 1;
	dfs (0);

	for (i = 0; i < N; ++i)
		printf ("%d", (int)(col[i] - 1));
	puts ("");

	return 0;
}
