
/*
FROM: acm.timus.ru
PROB: 1085 (Meeting)
KEYW: bfs
*/

#include <cstdio>
#include <cstring>
#include <vector>
#include <cassert>
#include <deque>

const int MAXN = 1 << 7;
const int MAXT = 1 << 7;
const int MAXK = 1 << 7;

int N, T;
//bool stops[MAXT][MAXN];
std::vector <int> gr[MAXN + MAXT];
int D[MAXT + MAXN];

int K;
int money[MAXK], ss[MAXK];
int is_free[MAXK];

void bfs (int start) {
	std::deque <int> q;
	q.push_back (start);
	D[start] = 0;

	while (!q.empty ()) {
		int c = q.front (); q.pop_front ();
		for (size_t i = 0; i < gr[c].size (); ++i) {
			if (D[gr[c][i]] != -1) continue;
			if (gr[c][i] > c) {//to a line -> costs
				assert (gr[c][i] >= N
				 && c < N);
				D[gr[c][i]] = D[c] + 1;
				q.push_back (gr[c][i]);
			} else {
				assert (gr[c][i] < N
				 && c >= N);
				D[gr[c][i]] = D[c];
				q.push_front (gr[c][i]);
			}
		}
	}
}

int main () {
	scanf ("%d %d", &N, &T);

	int i, j;
	for (i = 0; i < T; ++i) {
		int n, a;
		scanf ("%d", &n);
		while (n--) {
			scanf ("%d", &a);
			--a;
//			stops[i][--a] = 1;
			gr[a].push_back (i + N);
			gr[i + N].push_back (a);
		}
	}

	scanf ("%d", &K);
	for (i = 0; i < K; ++i) {
		scanf ("%d %d %d", money + i, ss + i, is_free + i);
		--ss[i];
	}

	int bsum = 1000000000, bstop = 0;
	for (i = 0; i < N; ++i) {
		memset (D, -1, sizeof (D));
		bfs (i);
		int csum = 0;
		for (j = 0; j < K; ++j) {
			if (D[ss[j]] == -1) break;
			if (is_free[j]) continue;
			if (D[ss[j]] * 4 > money[j]) break;
			csum += D[ss[j]] * 4;
		}
		if (j != K) continue;
		if (bsum > csum) {
			bsum = csum;
			bstop = i + 1;
		}
	}

	if (bstop)
		printf ("%d %d\n", bstop, bsum);
	else
		printf ("0\n");

	return 0;
}
