/*
FROM: acm.timus.ru
PROB: 1089 (A verification with a vocabulary)
KEYW: text processing
*/

#include <cstdio>
#include <cassert>
#include <cctype>
#include <cstring>

const int MAXLEN = 1 << 20;//2000 just in case
const int MAXW = 1 << 8;
const int MAXWL = 16;//8 is enough but + 1 for '\0'

int W, T;
char text[MAXLEN];
char words[MAXW][MAXWL];
int ws[MAXW];

int main () {
	while (gets (words[W])) {
		if (words[W][0] == '#') break;//this is not a word
		ws[W] = strlen (words[W]);
		++W;
	}

	char *tp = text;
	while (fgets (tp, text + MAXLEN - tp, stdin))
		tp += strlen (tp);
	T = tp - text;

	int i;
/*	for (i = 0; i < T; ++i)
		printf ("%c<%d>", text[i], (int)text[i]);
*/
	static char cw[MAXLEN];
	int cwp = 0;
	int ch;
	int __wc = 0;
	int err_cnt = 0;
	for (i = 0; i < T; ++i) {
		if (isalpha (text[i]))
			cw[cwp++] = text[i];
		else if (cwp) {
			++__wc;
			cw[cwp] = '\0';
//			printf ("go %s\n", cw);
			for (int j = 0; j < W; ++j) {
				if (ws[j] != cwp) continue;
				ch = 0;
				for (int k = 0; k < cwp && ch < 2; ++k)
					ch += (words[j][k] != cw[k]);

				if (ch == 1) {
					++err_cnt;
					for (int k = i - cwp; k < i; ++k)
						text[k] = words[j][k-i+cwp];
//					strncpy (text + i - cwp, words[j], cwp);
					break;
				}
			}
			cwp = 0;
		}
	}
	assert (cwp == 0);
	text[T] = 0;

//	printf ("%d\n", T);
//	printf ("%d\n", __wc);
	fputs (text, stdout);
	printf ("%d\n", err_cnt);

	return 0;
}
