/*
FROM: acm.timus.ru
PROB: 1096 (Get the right route plate!)
KEYW: bfs
*/

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <utility>

const int MAXR = 1 << 11;//2000
const int MAXN = 1 << 10;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int K;
int vec[MAXR];//for every road - one vertex
el buf[MAXN];//for every driver - 1 edge
std::pair <int, int> prev[MAXR];//number of edge and previous vertex

void bfs (int s1, int s2, int t) {
	static int q[MAXR], p3;
	p3 = 0;
	q[p3++] = s1; prev[s1] = std::make_pair (-2, -2);
	q[p3++] = s2; prev[s2] = std::make_pair (-2, -2);

	int i;
	for (i = 0; i < p3; ++i) {
		if (q[i] == t) break;
		for (int j = vec[q[i]]; j != -1; j = buf[j].next) {
			if (prev[buf[j].to].first == -1) {
				prev[buf[j].to] = std::make_pair (j, q[i]);
				q[p3++] = buf[j].to;
			}
		}
	}
	if (i == p3) {
		printf ("IMPOSSIBLE\n");
		exit (0);
	}
}

int main () {
	scanf ("%d", &K);

	int i;
	memset (vec, -1, sizeof (vec));
	memset (prev, -1, sizeof (prev));
	int a, b;
	for (i = 0; i < K; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		buf[i] = el (b, vec[a]);
		vec[a] = i;
	}

	int t, s1, s2;
	scanf ("%d %d %d", &t, &s1, &s2);
	--s1; --s2; --t;

	bfs (s1, s2, t);

	static int ans[MAXR], ap;
	for (i = t; prev[i].first != -2; i = prev[i].second)
		ans[ap++] = prev[i].first;

	printf ("%d\n", ap);
	for (i = ap-1; i >= 0; --i) printf ("%d\n", ans[i] + 1);

	return 0;
}
