/*
FROM: acm.timus.ru
PROB: 1098 (Questions)
KEYW: text processing
*/

#include <cstdio>
#include <cstring>

const int MAXT = 1 << 15;
const int N = 1999;

int T;
char text[MAXT];

int idt[MAXT];

void add (int pos, int val) {
	for (; pos <= T; pos += pos & -pos) idt[pos] += val;
}

int srch (int pos) {
	static int res;
	for (res = 0; pos; pos &= pos - 1) res += idt[pos];
	return res;
}

int mmod (int a, int b) {
	return a % b ? a % b : b;
}

int fnd (int start, int n) {
//	printf ("in fnd %d %d\n", start, n);
	int l = start, r = T, m;
	int base = srch (start);
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (srch (m) - base < n)
			l = m;
		else
			r = m;
	}
//	printf ("-- %d\n", r);
	return r;
}

int main () {
	char *tp = text + 1;
	while (gets (tp)) tp += strlen (tp);
	T = tp - text - 1;
//	printf ("%d\n", T);

	for (int i = 1; i <= T; ++i) add (i, 1);


	add (mmod (N, T), -1);
	int cpos = mmod (N, T);
	int ccnt = T - 1;
//	printf ("%d(%c %d)\n", cpos, text[cpos], ccnt);

	int rem;
	while (ccnt > 1) {
		rem = srch (T) - srch (cpos);
		if (rem >= N) {
			cpos = fnd (cpos, N);
		} else {
			int nn = N - rem;
			cpos = 0;//search from beg
			cpos = fnd (cpos, mmod (nn, ccnt));
		}
		add (cpos, -1);
		--ccnt;
//		printf ("%d(%c %d)\n", cpos, text[cpos], ccnt);
	}

	int x = fnd (0, 1);
//	printf ("%c (%d)\n", text[x], (int)text[x]);
//	putchar (text[x]);
	printf ("%s\n", text[x] == '?' ? "Yes" : text[x] == ' ' ? "No" : "No comments");

	return 0;
}
