#include <cstdio>
#include <cstdlib>
#include <algorithm>

using namespace std;

#define N (1 << 11)

int n, m;
int dist[N][N];
int e;
pair <int, pair <int, int> > edges[N * N];
char used[N][N];
int parent[N];
int x[N], y[N];
int ord[N * N], o;
int group[N][N];
int gn[N];

int root(int v)
{
	if (v == parent[v]) return v;
	else return (parent[v] = root(parent[v]));
}

void newRoot(int v, int nr)
{
	if (v != parent[v]) newRoot(parent[v], nr);
	parent[v] = nr;
}

int unite(int v1, int v2)
{
	used[v1][v2] = used[v2][v1] = 1;
	int r1 = root(v1), r2 = root(v2);
	if (r1 == r2) return dist[v1][v2];
	if (gn[r1] < gn[r2])
	{
		swap(r1, r2);
		swap(v1, v2);
	}
	newRoot(v2, r1);
	int mx = 0;
	int n1, n2;
	for (int i = 0; i < gn[r1]; ++ i)
		for (int j = 0; j < gn[r2]; ++ j)
		{
			n1 = group[r1][i];
			n2 = group[r2][j];
			used[n1][n2] = used[n2][n1] = 1;
			mx = max(mx, dist[n1][n2]);
		}
	for (int i = 0; i < gn[r2]; ++ i)
		group[r1][gn[r1] + i] = group[r2][i];
	gn[r1] += gn[r2];
	gn[r2] = 0;
	-- m;
	return mx;
}

int main()
{
	while (scanf("%d", &n), n)
	{
		memset(used, 0, sizeof(used));
		for (int i = 0; i < n; ++ i)
		{
			parent[i] = i;
			group[i][0] = i;
			gn[i] = 1;
			scanf("%d %d", x + i, y + i);
		}
		e = 0;
		for (int i = 0; i < n; ++ i)
		{
			for (int j = 0; j < i; ++ j)
			{
				dist[i][j] = (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]);	
				dist[j][i] = dist[i][j];
			//	printf("%d ", dist[i][j]);
				edges[e ++] = make_pair(dist[i][j], make_pair(i, j));
			}
		//		printf("\n");
		}
		sort(edges, edges + e);
		o = 0; m = n;
		int mx = 0, n1, n2;
		ord[o ++] = m;
		for (int i = 0; i < e; ++ i)
		{
			if (edges[i].first > mx)
			{
				if (m <= 0) m/=0;
				ord[o ++] = m;
				mx = edges[i].first;
			}
			n1 = edges[i].second.first;
			n2 = edges[i].second.second;
			if (!used[n1][n2]) mx = max(mx, unite(n1, n2));
		}
		ord[o ++] = 1;
		sort(ord, ord + o);
		o = unique(ord, ord + o) - ord;
		int c = 1;
		for (int i = 0; i < o; ++ i)
		{
			//printf("%d\n", ord[i]);
			for(; c < ord[i]; ++ c)
				printf("0");
			printf("1");
			++ c;
		}
		printf("\n");
	}
	return 0;
}
