/*
FROM: acm.timus.ru
PROB: 1504
KEYW: computational geometry
*/

#include <cstdio>
#include <cstdlib>
//#include <cassert>
#include <cmath>

#include <utility>
#include <algorithm>

void assert (int x) {
	if (!x) while (1);
}


/*
#ifndef M_PI
#define M_PI 3.14159265358979323846264338327950288419716939937510582097l
#endif
*/
const double MM_PI = 3.14159265358979323846264338327950288419716939937510582097;
const int MAXN = 1 << 10;
const double EPS_LEN = 1e-9;
const double EPS_ANG = 1e-14;

struct pnt {
	double x, y;
	pnt () {}
	pnt (double _x, double _y) : x (_x), y (_y) {}

	pnt operator + (const pnt &a) const {return pnt (x + a.x, y + a.y);}
	pnt operator - (const pnt &a) const {return pnt (x - a.x, y - a.y);}
	pnt operator * (double a) const {return pnt (x * a, y * a);}
	pnt operator / (double a) const {return pnt (x / a, y / a);}

	double len () const {return hypot (x, y);}
	double dst () const {return x * x + y * y;}
	pnt rot () const {return pnt (-y, x);}
};

double R;
int N;
pnt vec[MAXN];
int w[MAXN];

int bsp;
std::pair <double, double> bsegs[MAXN * 2];

bool cmp1 (int a, int b) {
	return w[a] > w[b];
}

void ans (double ang1, double ang2, int targ) {
/*	if (ang1 != ang2) {
		ans (ang1, ang1, targ);
		ans (ang2, ang2, targ);
	}*/
	double mid = (ang1 + ang2) / 2.;
	double x = cos (mid) * R;
	double y = sin (mid) * R;
/*
	double cdst = 1e99;
	int ci = -1;
	for (int i = 0; i < N; ++i) {
		if ((pnt (x, y) - vec[i]).dst () + EPS_LEN < cdst) {
			cdst = (pnt (x, y) - vec[i]).dst ();
			ci = i;
		}
	}
	if (targ < ci) return;
	assert (targ >= ci);
*/
	printf ("%.15lf %.15lf\n", x, y);
	exit (0);
}

bool out (const pnt &a) {
	return a.dst () > R * R;
}

void find_inter_ang (const pnt &a, const pnt &b, double &ang1, double &ang2) {
	pnt p1 = (a + b) / 2;
	pnt p2 = (b - a).rot ();
	pnt px, pm;

	while (!out (p1 + p2)) p2 = p2 * 2;
	px = p2;
	while (out (p1 + px)) px = px / 2;
	for (int kk = 0; kk < 100; ++kk) {
		pm = (px + p2) / 2.;
		if (out (p1 + pm))
			p2 = pm;
		else
			px = pm;
	}
	assert (!out (p1 + px));
	assert (out (p1 + p2));
//	assert ((p1 + px).dst () == R * R);
	ang2 = atan2 (px.y, px.x);

	p2 = (a - b).rot ();
	while (!out (p1 + p2)) p2 = p2 * 2;
	px = p2;
	while (out (p1 + px)) px = px / 2;
	for (int kk = 0; kk < 100; ++kk) {
		pm = (px + p2) / 2.;
		if (out (p1 + pm))
			p2 = pm;
		else
			px = pm;
	}

	assert (!out (p1 + px));
	assert (out (p1 + p2));
//	assert ((p1 + px).dst () == R * R);
	ang1 = atan2 (px.y, px.x);
}

double grad (double rad) {
	return rad / MM_PI * 180;
}

int main () {
	static int idx[MAXN];
	static pnt _vec[MAXN];


	scanf ("%lf %d", &R, &N);

	int i, j;
	for (i = 0; i < N; ++i) {
		scanf ("%lf %lf %d", &_vec[i].x, &_vec[i].y, w + i);
		idx[i] = i;
	}

	std::sort (idx, idx + N, cmp1);

	for (i = 0; i < N; ++i) vec[i] = _vec[idx[i]];

	double ang1, ang2;
	for (i = 0; i < N; ++i) {//try to get the i'th piece
		bsp = 0;
		for (j = i + 1; j < N; ++j) {
			find_inter_ang (vec[i], vec[j], ang1, ang2);
//			printf ("%lf %lf -- %lf %lf\n", vec[j].x, vec[j].y, grad (ang1), grad (ang2));
			if (ang1 < ang2) {
//				ans (ang1, ang1, i);
//				ans (ang2, ang2, i);
				bsegs[bsp++] = std::make_pair (ang1, ang2);
			} else {
//				#warning check here -> possible EPS add
//				ans (ang1, ang1, i);
//				ans (ang2, ang2, i);
				bsegs[bsp++] = std::make_pair (ang1, MM_PI + 5);
				bsegs[bsp++] = std::make_pair (-MM_PI - 5, ang2);
			}
		}
//		bsegs[bsp++] = std::make_pair (0 - EPS_ANG, M_PI);
//		std::sort (bsegs, bsegs + bsp);
/*		
		printf ("i == %d -- %lf %lf\n", i, vec[i].x, vec[i].y);
		for (j = 0; j < bsp; ++j)
			printf ("%lf %lf\n", grad (bsegs[j].first), grad (bsegs[j].second));
*/

		double cend = -MM_PI;
 		for (j = 0; j < bsp; ++j)
			if (bsegs[j].first > cend) {
//				printf ("%lf\n", grad ((cend + bsegs[j].first) / 2.));
				ans (cend, bsegs[j].first, i);
				cend = std::max (cend, bsegs[j].second);
			} else
				cend = std::max (cend, bsegs[j].second);
		if (cend - EPS_ANG < MM_PI)
			ans (cend, MM_PI, i);

	}

	return 0;
}
