/*
FROM: acm.timus.ru
PROB: 1566 (Triangular postcards)
KEYW: computational geometry
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <cmath>

#define PI 3.14159265358979323846264338327950288419

void myassert (bool a) {
	while (!a);
}

const double EPS = 1e-9;

double sq (double a) {return a * a;}

/*
struct pnt {
	double x, y;
	pnt () {}
	pnt (double _x, double _y) : x (_y), y (_y) {}

	pnt operator + (const pnt &a) const {return pnt (x + a.x, y + a.y);}
	pnt operator - (const pnt &a) const {return pnt (x - a.x, y - a.y);}

	pnt operator * (double a) const {return pnt (x * a, y * a);}
	pnt operator / (double a) const {return pnt (x / a, y / a);}

	double dst2 (const pnt &a) const {return sq (x - a.x) + sq (y - a.y);}
	double dst (const pnt &a) const {return sqrt (dst2 (a));}
};


double S (const pnt &a, const pnt &b, const pnt &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}
*/

int E[3];
int P[3];

double heron (double a, double b, double c) {
	double p = (a + b + c) / 2.;
	return sqrt (p * (p - a) * (p - b) * (p - c));
}

double rad2grad (double a) {
	return a / PI * 180.;
}

double f (double cose, double cosp, double h) {
	double sine = sqrt (1 - cose * cose);
	double sinp = sqrt (1 - cosp * cosp);

	double l1 = h * (cose / sine);
	double l2 = h * (cosp / sinp);

//	printf ("%lf %lf (%lf %lf) %lf %lf  %lf\n", cose, cosp, rad2grad (acos (cose)), rad2grad (acos (cosp)), l1, l2, l1 - l2);
	assert (l1 - l2 + EPS > 0);
	return l1 - l2;
}

double fcos (int e1, int e2, int e3) {
	return (double)(e1 * e1 + e2 * e2 - e3 * e3) / (2 * e1 * e2);
}

void mytry (int e1, int e2, int e3, int p1, int p2, int p3) {
	double he = 2 * heron (e1, e2, e3) / e1, hp = 2 * heron (p1, p2, p3) / p1;
	if (hp - EPS > he) return;//does not fit

	double cos_e, cos_p;
	double to_add = 0;
	//
	cos_e = fcos (e1, e2, e3);
	cos_p = fcos (p1, p2, p3);
	
	if (cos_e - EPS < cos_p) goto part2;
	to_add += f (cos_e, cos_p, hp);

	//
	part2:;
	cos_e = fcos (e1, e3, e2);
	cos_p = fcos (p1, p3, p2);

	if (cos_e - EPS < cos_p) goto part3;
	to_add += f (cos_e, cos_p, hp);

	//
	part3:;
	if (to_add + p1 - EPS < e1) {
		printf ("YES\n");
		exit (0);
	}
}

int main () {
	scanf ("%d %d %d", E, E + 1, E + 2);
	scanf ("%d %d %d", P, P + 1, P + 2);

	int prm1[3] = {0, 1, 2}, prm2[3] = {0, 1, 2};
	std::sort (E, E + 3);
	std::sort (P, P + 3);
	if (P[0] + P[1] < P[2]) myassert (0);
	if (E[0] + E[1] < E[2]) myassert (0);
	if (P[0] + P[1] == P[2]) {
//		printf ("NO\n");
//		return 0;

		if (P[2] <= E[2]) {
			printf ("YES\n");
		} else {
			printf ("NO\n");
		}
		return 0;
	} else if (E[0] + E[1] == E[2]) {
		printf ("NO\n");
		return 0;
	}

	do {
		do {
			mytry (
			E[prm1[0]], E[prm1[1]], E[prm1[2]],
			P[prm2[0]], P[prm2[1]], P[prm2[2]]);
		} while (std::next_permutation (prm2, prm2 + 3));
	} while (std::next_permutation (prm1, prm1 + 3));

	printf ("NO\n");

	return 0;
}
