/*
FROM: acm.timus.ru
PROB: 1570 (Eating High)
KEYW: dynamical programming
*/

#include <cstdio>
#include <cstring>
#include <utility>
#include <cmath>

void myassert (bool a) {
	while (!a);
}

const int INF = 0x7f7f7f7f;

const int MAXD = 1 << 7;
const int MAXDNC = 32;
const int MAXDP = 1 << 15;//30 000

int N, M;
char dn[MAXD][MAXDNC];
int price[MAXD];
int filling[MAXD];
int dcnt[MAXD];

int dp[MAXDP];
int lci[MAXDP];
int nd[MAXDP];
int test[MAXDP];
int save[MAXDP];
std::pair <int, int> prev[MAXDP];

int get_double_mul_1000 () {
	double x;
	scanf ("%lf", &x);
//	printf ("%lf %d\n", x, (int)(x * 1000 + 0.5));
	return (int)floor (x * 1000 + 0.5);
}

int main () {
	scanf ("%d %d", &N, &M);

	int i, j;
	for (i = 0; i < N; ++i) {
		scanf ("%s %d", dn[i], price + i);
		filling[i] = get_double_mul_1000 ();
	}

	memset (dp, 0x7f, sizeof (dp));
	dp[0] = 0;
	nd[0] = 0;
	lci[0] = -1;

	int MM = M * 1000;
	int __tt = 0;
	int k;
	for (i = 0; i < N; ++i) {
//		printf ("%s %d %d\n", dn[i], price[i], filling[i]);
		for (j = 0; j < MM; ++j) {
			if (dp[j] == INF || lci[j] == i) continue;
			for (k = 1; j + k * filling[i] < MAXDP; ++k) {
				int npos = j + k * filling[i];
				int nprice = dp[j] + price[i] * k;
				if (dp[npos] > nprice
				 || dp[npos] == nprice
				 && nd[npos] < nd[j] + 1) {
					dp[npos] = nprice;
					nd[npos] = nd[j] + 1;
					lci[npos] = i;
					prev[npos] = std::make_pair (j, i);
					//
//					save[npos] = test[j];
//					test[npos] = ++__tt;
//					printf ("set prev %d to %d %d\n", j + filling[i], j, i);
				}
			}
		}
	}

	int best_index = -1, best_price = INF, max_dishes = -1;
	for (i = MM; i < MAXDP; ++i)
		if (dp[i] < best_price
		 || dp[i] == best_price
		 && nd[i] > max_dishes) {
			best_price = dp[i];
			max_dishes = nd[i];
			best_index = i;
		}

	printf ("%d\n", best_price);
	for (i = best_index; i != 0; i = prev[i].first) {
//		printf ("%d -- %d %d\n", i, prev[i].first, prev[i].second);
//		myassert (save[i] == test[prev[i].first]);
		dcnt[prev[i].second] += (i - prev[i].first) / filling[prev[i].second];
	}

	for (i = 0; i < N; ++i)
		if (dcnt[i])
			printf ("%s %d\n", dn[i], dcnt[i]);

	return 0;
}
