/*
FROM: acm.timus.ru
PROB: 1682 (Crazy Professor)
KEYW: connections, map
*/

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>

const int MAXN = 300010;

typedef std::map<int, std::vector<int> > db;

int K;
db p1, p2;
std::vector<int> a;
std::vector<int> sz;

std::set<std::pair<int, int> > added;

void xadd(int ax, int bx) {
	std::pair<int, int> aa(std::min(ax, bx), std::max(ax, bx));
	if (added.find(aa) != added.end()) return;
	//printf("in xadd %d %d\n", ax, bx);
	int ai, bi;
	for (ai = ax; a[ai] != ai; ai = a[ai]) {
		//printf("ai = %d\n", ai);
		a[ai] = a[a[ai]];
	}
	for (bi = bx; a[bi] != bi; bi = a[bi]) {
		//printf("bi = %d %d %d\n", bi, a[bi], a[a[bi]]);
		//getchar();
		a[bi] = a[a[bi]];
	}
	//printf("ai bi %d %d\n", ai, bi);
	if (ai == bi) {
		// we have a cycle gentleman
		printf("%d\n", ax);
		exit(0);
	} else {
		if (sz[ai] < sz[bi]) {
			a[ai] = bi;
			sz[bi] += sz[ai];
		} else {
			a[bi] = ai;
			sz[ai] += sz[bi];
		}
	}
	//printf("after add!\n");
	added.insert(aa);
}

int main() {
	scanf("%d", &K);

	a.push_back(-1);
	sz.push_back(-1);

	a.push_back(1);
	sz.push_back(1);
	p1[1%K].push_back(1);
	p2[1%K].push_back(1);
	for (int i = 2;; ++i) {
		a.push_back(i);
		sz.push_back(1);
		added.clear();
		//printf("i = %d\n", i);
		int sq = ((long long) i * i) % K;
		std::vector<int> &p1x = p1[(K - sq) % K];
		for (int j = 0; j < (int) p1x.size(); ++j)
			xadd(i, p1x[j]);
		std::vector<int> &p2x = p2[(K - i % K) % K];
		for (int j = 0; j < (int) p2x.size(); ++j)
			xadd(i, p2x[j]);

		//printf("pre add!\n");
		p1[i%K].push_back(i);
		p2[sq].push_back(i);
		//printf("post add!\n");
	}

	for (;;) ;

	return 0;
}
