#include<cstdio>
#include<queue>
#include<algorithm>

using namespace std;

int adj[128][128], prev[128], ans[128][128], n, mx, mxdist;
bool u[128];

void dfs(int v, int dist)
{
	u[v] = 1;
	if(dist > mxdist)
	{
		mxdist = dist;
		mx = v;
	}
	for(int i = 1; i <= n; i++)
	{
		if(!u[i] && ans[v][i])
		{
			dfs(i, dist + 1);
		}
	}
}

int bfs(int v)
{
	queue<int> q;
	memset(u, 0, sizeof(u));
	memset(ans, 0, sizeof(ans));
	prev[v] = 0;
	u[v] = 1;
	q.push(v);
	while(q.size() > 0)
	{
		v = q.front();
		q.pop();
		for(int i = 1; i <= n; i++)
		{
			if(!u[i] && adj[v][i])
			{
				q.push(i);
				u[i] = 1;
				prev[i] = v;
				ans[i][v] = ans[v][i] = 1;
			}
		}
	}
	memset(u, 0, sizeof(u));
	mx = 0; mxdist = 0;
	dfs(1, 0);
	memset(u, 0, sizeof(u));
	mxdist = 0;
	dfs(mx, 0);
	return mxdist;
}

int main()
{
	int m, l, r;
	scanf("%d%d", &n, &m);
	for(int i = 0; i < m; i++)
	{
		scanf("%d%d", &l, &r);
		adj[l][r] = adj[r][l] = 1;
	}
	int res = bfs(1), ri = 1;
	for(int i = 2; i <= n; i++)
	{
		int tmp = bfs(i);
		if(tmp < res)
		{
			res = tmp;
			ri = i;
		}
	}
	bfs(ri);
	for(int i = 1; i <= n; i++)
	{
		if(prev[i] != 0)
		{
			printf("%d %d\n", i, prev[i]);
		}
	}
	return 0;
}
