#include <cstdio>
#include <string>
#include <algorithm>
#include <map>

using namespace std;

struct prob {
	double a, b, c;
	prob () {}
	prob (double _a, double _b, double _c) : a (_a), b (_b), c (_c) {}

	prob operator * (double x) const {
		return prob (a * x, b * x, c * x);
	}
	prob operator + (const prob &x) const {
		return prob (a + x.a, b + x.b, c + x.c);
	}
};

double a, b, c;
map <string, prob> B;

const double EPS = 1e-9;

int main () {
	scanf ("%lf %lf %lf", &a, &b, &c);
	bool is_swap = 0;
	if (b < c) {
		swap (b, c);
		is_swap = 1;
	}

	B["AB"] = prob (1, 0, 0);
	B["BA"] = prob (1-b, b, 0);
	B["AC"] = prob (1, 0, 0);
	B["CA"] = prob (1-c, 0, c);

	double tmp;
	prob cprob (0, 0, 0);
	//calc BC
	tmp = 1;
	for (int i = 0; i < 10000; ++i) {
		cprob.b += tmp * b; tmp *= (1 - b);
		cprob.c += tmp * c; tmp *= (1 - c);
	}
	B["BC"] = cprob;
	
	//calc CB
	cprob = prob (0, 0, 0);
	tmp = 1;
	for (int i = 0; i < 10000; ++i) {
		cprob.c += tmp * c; tmp *= (1 - c);
		cprob.b += tmp * b; tmp *= (1 - b);
	}
	B["CB"] = cprob;

	B["ABC"] = B["CA"];
	B["ACB"] = B["CA"];

	prob p1, p2, p3;

	//calc BAC
	p1 = B["ACB"];//dont shoot
	p2 = B["CB"] * b + B["ACB"] * (1 - b);//shoot A
	p3 = B["AB"] * b + B["ACB"] * (1 - b);//shoot C

	if (p2.b + EPS > p1.b && p2.b + EPS > p3.b) 		B["BAC"] = p2;
	else if (p3.b + EPS > p1.b && p3.b + EPS > p2.b) 	B["BAC"] = p3;
	else 												B["BAC"] = p1;

	//calc CAB
	p1 = B["ABC"];//dont shoot
	p2 = B["BC"] * c + B["ABC"] * (1 - c);//shoot A
	p3 = B["AC"] * c + B["ABC"] * (1 - c);//shoot B

	if (p2.c + EPS > p1.c && p2.c + EPS > p3.c) 		B["CAB"] = p2;
	else if (p3.c + EPS > p1.c && p3.c + EPS > p2.c) 	B["CAB"] = p3;
	else 												B["CAB"] = p1;

	//calc CBA
	p1 = B["BAC"];//dont shoot
	p2 = B["BC"] * c + B["BAC"] * (1 - c);//shoot A
	p3 = B["AC"] * c + B["BAC"] * (1 - c);//shoot B

	if (p2.c + EPS > p1.c && p2.c + EPS > p3.c) 		B["CBA"] = p2;
	else if (p3.c + EPS > p1.c && p3.c + EPS > p2.c) 	B["CBA"] = p3;
	else 												B["CBA"] = p1;
	
	//calc BCA
	p1 = B["CAB"];//dont shoot
	p2 = B["CB"] * b + B["CAB"] * (1 - b);//shoot A
	p3 = B["AB"] * b + B["CAB"] * (1 - b);//shoot C

	if (p2.b + EPS > p1.b && p2.b + EPS > p3.b) 		B["BCA"] = p2;
	else if (p3.b + EPS > p1.b && p3.b + EPS > p2.b) 	B["BCA"] = p3;
	else 												B["BCA"] = p1;

	prob fin =
	   B["ABC"] * (1. / 6.)
	 + B["ACB"] * (1. / 6.)
	 + B["BCA"] * (1. / 6.)
	 + B["BAC"] * (1. / 6.)
	 + B["CAB"] * (1. / 6.)
	 + B["CBA"] * (1. / 6.);

	if (is_swap) swap (fin.b, fin.c);
	printf ("%lf %lf %lf\n", fin.a, fin.b, fin.c);

	return 0;
}
