
/*
FROM: acm.timus.ru
PROB: 1504
KEYW: computational geometry
NOTE: does not work
*/

#include <cstdlib>
#include <cmath>
#include <cassert>

#include <utility>
#include <iostream>
#include <algorithm>

using std::make_pair;

typedef long double DD;
const int MAXN = 1 << 10;
const DD EPS = 1e-9;

//const DD MM_PI = acosl (1);
const DD MM_PI = 3.14159265358979323846264338327950288419716939937510582097l;

struct pnt {
	DD x, y;
	pnt () {}
	pnt (DD _x, DD _y) : x (_x), y (_y) {}
	pnt operator - (const pnt &a) const {return pnt (x - a.x, y - a.y);}
	pnt operator + (const pnt &a) const {return pnt (x + a.x, y + a.y);}
	pnt operator * (const DD &a) const {return pnt (x * a, y * a);}
	pnt& operator += (const pnt &a) {x += a.x; y += a.y; return *this;}
	pnt rot () const {return pnt (-y, x);}
};

DD R;
int N;
pnt _vec[MAXN];
pnt vec[MAXN];
int w[MAXN];
int idx[MAXN];
int sp;
std::pair <DD, DD> segs[MAXN * 2];

bool cmp (int a, int b) {
	return w[a] > w[b];
}

void ans (DD a, DD b) {
	a = (a + b) / 2;
	DD x = R * cosl (a);
	DD y = R * sinl (a);
	printf ("%.11Lf %.11Lf\n", x, y);
//	std::cout << x << ' ' << y << std::endl;
	exit (0);
}

void solve_sq_eq (DD A, DD B, DD C, DD &x1, DD &x2) {
	DD D = B * B - A * C;
//	assert (D >= 0);
	x1 = (-B + sqrtl (D)) / A;
	x2 = (-B - sqrtl (D)) / A;
}

void make_all (const pnt &a, const pnt &b, DD &ang1, DD &ang2) {
	static pnt dif, d, p1, p2;
//	printf ("\tmake_all %Lf %Lf, %Lf %Lf\n", a.x, a.y, b.x, b.y);
	dif = b - a;
	d = dif.rot ();
	dif.x /= 2; dif.y /= 2;
	dif += a;
	static DD K1, K2;
//	printf ("\t%Lf %Lf, %Lf %Lf\n", dif.x, dif.y, d.x, d.y);
	solve_sq_eq (d.x * d.x + d.y * d.y, dif.x * d.x + dif.y * d.y, dif.x * dif.x + dif.y * dif.y - R * R, K1, K2);
	assert (K1 >= 0);
	assert (K2 <= 0);
	p1 = d * K1 + dif;
	p2 = d * K2 + dif;
//	printf ("\t%Lf %Lf, %Lf %Lf\n", p1.x, p1.y, p2.x, p2.y);
	ang1 = atan2l (p1.y, p1.x);
	ang2 = atan2l (p2.y, p2.x);
}

DD myabs (DD a) {
	if (a < 0) return -a;
	else return a;
}

int main () {
	printf ("%Lf\n", MM_PI);
	int i, j;
	std::cin >> R >> N;
	for (i = 0; i < N; ++i)
		std::cin >> _vec[i].x >> _vec[i].y >> w[i];

	for (i = 0; i < N; ++i)
		idx[i] = i;

	std::sort (idx, idx + N, cmp);
	for (i = 0; i < N; ++i)
		vec[i] = _vec[idx[i]];
/*
	for (i = 0; i < N; ++i)
		printf ("%Lf %Lf\n", vec[i].x, vec[i].y);
*/
	DD ang1, ang2;
	for (i = 0; i < N; ++i) {
		sp = 0;
//		printf ("\ni == %d\n", i);
		for (j = 0; j < N; ++j) {
			if (j == i) continue;
//			printf ("\tj = %d\n", j);
/*			if (myabs (vec[j].x - vec[i].x) < EPS
			 && myabs (vec[j].y - vec[i].y) < EPS) {//this poin is too close
//			 	printf ("\t\ttoo close!\n");
				continue;
			}*/

			make_all (vec[i], vec[j], ang1, ang2);
/*			#define grad(A) ((A)/M_PI*180)
			printf ("\t%Lf %Lf(%Lf %Lf)\n", ang1, ang2, grad (ang1), grad (ang2));
			#undef grad*/
			std::swap (ang1, ang2);
			if (ang1 > ang2) {
				segs[sp++] = make_pair (ang1, MM_PI + EPS + EPS);
				segs[sp++] = make_pair (-MM_PI - EPS - EPS, ang2);
			} else {
				segs[sp++] = make_pair (ang1, ang2);
			}
		}
//		printf ("--\n");
		std::sort (segs, segs + sp);
		DD cend = -MM_PI;
		segs[sp++] = make_pair (MM_PI, MM_PI + 100);
		for (i = 0; i < sp; ++i) {
//			printf ("segment is %Lf %Lf(%Lf)\n", segs[i].first, segs[i].second, cend);
			if (segs[i].first > cend - EPS) {
				ans (segs[i].first, cend);
			} else
				cend = cend > segs[i].second ? cend : segs[i].second;
		}
	}

	return 0;
}
