#include <cstdio>
#include <cstring>
#include <utility>

using std::make_pair;

const int MAXN = 1 << 6;
const int ALPHA = 1 << 5;

const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};

int N, M;
char a[MAXN][MAXN];
int used[MAXN][MAXN];
int ord[ALPHA];
int score;

int csz;
int _cgc;

void bfs (int sx, int sy) {
	static std::pair <int, int> q[MAXN * MAXN], c;
	static int p3, nx, ny;
	static int i, k;
	q[p3 = 0, p3++] = make_pair (sx, sy);
	used[sx][sy] = _cgc;

	for (i = 0; i < p3; ++i) {
		c = q[i];
		for (k = 0; k < 4; ++k) {
			nx = c.first + dx[k];
			ny = c.second + dy[k];
			if (nx >= 0 && nx < N
			 && ny >= 0 && ny < M
			 && a[nx][ny] == a[sx][sy]
			 && !used[nx][ny]) {
				used[nx][ny] = _cgc;
				q[p3++] = make_pair (nx, ny);
			}
		}
	}
	csz = p3;
	++_cgc;
}

bool do_step () {
	int i, j;
	int bi = -1, bg = -1, bsz = -1, cg;
	memset (used, 0, sizeof (used));
	_cgc = 1;
	for (i = N-1; i >= 0; --i)
		for (j = 0; j < M; ++j) {
			if (used[i][j] != 0 || a[i][j] == '#') continue;
			bfs (i, j);
			cg = a[i][j] - 'A';

			if (csz == 1) continue;
			if (bi == -1) {bi = used[i][j]; bg = cg; bsz = csz; continue;}

			if (ord[cg] < ord[bg]) {bi = used[i][j]; bg = cg; bsz = csz; continue;}
			else if (ord[cg] > ord[bg]) continue;

			if (csz > bsz) {bi = used[i][j]; bg = cg; bsz = csz; continue;}
			else if (csz == bsz) continue;
		}

	if (bi == -1) return 0;

	int wx, wy = 0;
	for (j = 0; j < M; ++j) {
		wx = N-1;
		for (i = N-1; i >= 0; --i) {
			if (a[i][j] == '#') break;
			if (used[i][j] != bi) {
				a[wx--][wy] = a[i][j];
			}
		}
		for (i = wx; i >= 0; --i) a[i][wy] = '#';
		if (wx != N-1) ++wy;
	}

	for (j = wy; j < M; ++j)
		for (i = 0; i < N; ++i)
			a[i][j] = '#';
	score += bsz * (bsz - 1) / 2;
	return a[i][j] != '#';
}

int main () {
	char _ord[ALPHA];
	int i, j;
	for (;;) {
		N = 0;
		if (!gets (a[N++])) break;
		for (;; ++N) {
			gets (a[N]);
			if (a[N][0] == '-') break;
		}
		M = strlen (a[0]);

		gets (_ord);
		for (i = 0; _ord[i]; ++i) ord[_ord[i]-'A'] = i;

		score = 0;
		while (do_step ());
		if (a[N-1][0] == '#') score *= 4;
		printf ("%d\n", score);
	}

	return 0;
}
