/*
NAME: Stacking Boxes
ID: 103
SITE: acm.uva.es
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 32;
const int MAXD = 16;

int N, D;
int **data;
int *sums;
int *index;
int *opt, *prev;

bool nest (int a, int b) {
	a = index[a];
	b = index[b];
	for (int i = 0; i < D; ++i)
		if (data[a][i] >= data[b][i])
			return 0;

	return 1;
}

void prntsol (int id) {
	printf ("%d\n", opt[id]);
	printf ("%d", index[id] + 1);
	id = prev[id];
	while (id != -1) {
		printf (" %d", index[id] + 1);
		id = prev[id];
	}
	printf ("\n");
}

int cmp (const void *a, const void *b) {
	return (*(const int*)(a) - *(const int*)(b));
}

int cmp2 (const void *a, const void *b) {
	return (sums[*(const int*)(a)] - sums[*(const int*)(b)]);
}

int main () {
	data = new int* [MAXN];
	for (int i = 0; i < MAXN; ++i)
		data[i] = new int [MAXD];
	sums = new int [MAXN];
	index = new int [MAXN];
	opt = new int [MAXN];
	prev = new int [MAXN];

	int i, j;
	int maxi;
	while (scanf ("%d %d", &N, &D) != -1) {
		for (i = 0; i < N; ++i)
			for (j = 0; j < D; ++j)
				scanf ("%d", &data[i][j]);
		for (i = 0; i < N; ++i)
			qsort (data[i], D, sizeof (int), cmp);

		for (i = 0; i < N; ++i) {
			sums[i] = 0;
			index[i] = i;
			for (j = 0; j < D; ++j)
				sums[i] += data[i][j];
		}

		qsort (index, N, sizeof (int), cmp2);

		for (i = N-1; i >= 0; --i) {
			opt[i] = 1;
			prev[i] = -1;
			for (j = i+1; j < N; ++j)
				if (nest(i,j) && opt[i] < opt[j] + 1) {
					opt[i] = opt[j] + 1;
					prev[i] = j;
				}
		}
		maxi = 0;
		for (i = 0; i < N; ++i)
			if (opt[i] > opt[maxi])
				maxi = i;

		prntsol (maxi);
	}

	return 0;
}
