/*
NAME: Arbitrage
ID: 104
SITE: acm.uva.es
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 32;//20

int N;
double ma3x[MAXN][MAXN];

void input () {
	int i, j;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < i; ++j)
			scanf ("%lf", &ma3x[i][j]);
		ma3x[i][i] = 1.0;
		for (j = i + 1; j < N; ++j)
			scanf ("%lf", &ma3x[i][j]);
	}
}

int best[MAXN];
int blen;

void clear (double *vec) {
	for (int i = 0; i < N; ++i) vec[i] = 0;
}

void solve () {
	double *vec1 = new double [N], *_old = vec1;
	double *vec2 = new double [N], *_new = vec2;
	
	int **prev = new int* [N+1];
	for (int i = 0; i <= N; ++i) prev[i] = new int [N];
	
	int i, ii, jj, kk;
	blen = N + 2;
	for (i = 0; i < N; ++i) {//starting currency
		clear (_old);
		clear (_new);
		_old[i] = 1;
		prev[0][i] = -1;
		
		for (ii = 1; ii <= N; ++ii) {//number of transactions made
			for (jj = 0; jj < N; ++jj)
				for (kk = 0; kk < N; ++kk)
					if (_new[kk] < _old[jj] * ma3x[jj][kk]) {
						_new[kk] = _old[jj] * ma3x[jj][kk];
						prev[ii][kk] = jj;
					}	
			std::swap (_old, _new);
			clear (_new);
			if (_old[i] > 1.01) {
				if (ii + 1 < blen) {
//					printf ("here - %d %d\n", i, ii);
					blen = ii + 1;
	
					for (jj = i; jj != -1; jj = prev[ii--][jj]) {
//						printf ("ii = %d, jj = %d(best[ii] = jj)\n", ii, jj);
						best[ii] = jj;
					}
				}
				break;
			}
		}
	}
}

void prnt_best () {
	if (blen == N + 2) {
		printf ("no arbitrage sequence exists\n");
		return;
	}
	
	printf ("%d", best[0] + 1);
	for (int i = 1; i < blen; ++i)
		printf (" %d", best[i] + 1);
	printf ("\n");
}

int main () {
	while (scanf ("%d", &N) != -1) {
		input ();
		solve ();
		prnt_best ();
	}

	return 0;
}
