/*
NAME: Fermat vs. Pythagoras
ID: 106
SITE: acm.uva.es
*/

#include <cstdio>
#include <algorithm>

const int MAXTR = 1 << 20;

struct triple {
	int a, b, c;
	triple () {}
	triple (int aa, int bb, int cc) : a (aa), b (bb), c (cc) {}
	bool operator < (const triple &xx) const {return c < xx.c;}
};

triple triples[MAXTR];
int trp;

int N;

long long _nod (long a, long b) {
	if (!b) return a;
	else return _nod (b, a % b);
}

long long nod (long long a, long long b) {
	return (a < b ? _nod (b, a) : _nod (a, b));
}

int main () {
	int i;
	for (i = 3; i < 1415; i += 2)
		triples[trp++] = triple (i, (i * i - 1) / 2, (i * i - 1) / 2 + 1);
	i -= 2;
//	printf ("%d %d %d\n", i, (i * i - 1) / 2, (i * i - 1) / 2 + 1);
	for (i = 8; i < 2000; i += 4)
		triples[trp++] = triple (i, (i * i - 4) / 4, (i * i - 4) / 4 + 2);
	i -= 4;
//	printf ("%d %d %d\n", i, (i * i - 4) / 4, (i * i - 4) / 4 + 2);

//	printf ("%d\n", trp);

//	printf ("here!\n");

	long long b, tmp;
	for (long long i = 2; i < 1000000; ++i) {
		for (long long j = 2; j < i; ++j)
			if (i % j && !((i * i) % j))
				if (!((i * i - j * j) % (2 * j))) {
					b = (i * i - j * j) / (2 * j);
					if (i > b) break;	
					if (b + j > 1000000) continue;
					if ((tmp = nod (nod (i, b), b + j)) != 1) continue;
					triples[trp++] = triple (i, b, b + j);
//					printf ("%d %d %d\n", i, b, b + j);
//					printf ("%d\r", trp);
				}
	}
	printf ("%d\n", trp);

	std::sort (triples, triples + trp);

	for (i = 0; i < 16; ++i)
		printf ("%d\t%d\t%d\n", triples[i].a, triples[i].b, triples[i].c);


	while (scanf ("%d", &N) != EOF) {
		triple *p = std::upper_bound (triples, triples + trp, triple (0, 0, N));
		printf ("%ld ", p - triples);
		printf ("\n");
	}

	return 0;
}
