/*
NAME: Fermat vs. Pythagoras
ID: 106
SITE: acm.uva.es
*/

#include <cstdio>
#include <algorithm>

const int MAXTR = 1 << 18;
const int MAXN = 1 << 20;

struct triple {
	int a, b, c;
	triple () {}
	triple (int aa, int bb, int cc) : a (aa), b (bb), c (cc) {}
	bool operator < (const triple &xx) const {return (c == xx.c ? b < xx.b : c < xx.c);}
};

triple triples[MAXTR];
int trp;

int N;

int _nod (int a, int b) {
	return (b ? _nod (b, a % b) : a);
}

void find_tr () {
	int p, q;
	for (p = 1; p <= 1000; ++p)
		for (q = 1; q < p && (triples[trp].c = p * p + q * q) < 1000000; ++q) {
			triples[trp].a = 2 * p * q;
			triples[trp].b = p * p - q * q;
			if (triples[trp].a > triples[trp].b) std::swap (triples[trp].a, triples[trp].b);
			if (_nod (_nod (triples[trp].a, triples[trp].b), triples[trp].c) == 1) ++trp;
//			printf ("%d %d %d\n", triples[trp-1].a, triples[trp-1].b, triples[trp-1].c);		
		}
	std::sort (triples, triples + trp);
/*
//	printf ("%d\n", trp);
	for (int i = 0; i < 20; ++i)
		printf ("%d %d %d\n", triples[i].a, triples[i].b, triples[i].c);
	printf ("**********\n");
*/
}

void solve () {
	static bool used[MAXN];
	memset (used + 1, 0, sizeof (bool) * N);
	int i, j;
//	printf ("******unused %d ->\n", a);
	for (i = 0; triples[i].c <= N; ++i)
		for (j = 1; triples[i].c * j <= N; ++j) {
//			printf ("%d %d %d\n",  triples[i].a * j, triples[i].b * j, triples[i].c * j);
			used[triples[i].a * j] = 1;
			used[triples[i].b * j] = 1;
			used[triples[i].c * j] = 1;
		}
//	printf ("******\n");
	int cnt =0;
	for (j = 1; j <= N; ++j)
		if (!used[j]) ++cnt;
	
	printf ("%d %d\n", i, cnt);
}

int main () {
	find_tr ();
	while (scanf ("%d", &N) != EOF)
		solve ();

	return 0;
}
