/*
NAME: The Cat in the Hat
ID: 107
SITE: acm.uva.es
*/

#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <cmath>

#define unsigned unsigned long long

const int MAXP = 1 << 4;
const int MAXPOW = 1 << 5;

struct _2 {
	unsigned n;
	unsigned p;
	_2 () {}
	_2 (unsigned nn, unsigned pp) : n (nn), p (pp) {}
};

unsigned p[2][MAXP];
unsigned s[2][MAXP];
int c[2];

unsigned a[2];

_2 vec[2][MAXPOW];
int vecc[2];

unsigned _nod (unsigned a, unsigned b) {//a MUST be > b
	return (b ? _nod (b, a % b) : a);
}

unsigned nod (unsigned a, unsigned b) {// a <> b
	return (a < b ? _nod (b, a) : _nod (a, b));
}

void razl () {
	unsigned k, i;
	for (k = 0; k < 2; ++k) {
		c[k] = 0;
		for (i = 2; a[k] != 1 && i * i < a[k]; ++i)
			if (!(a[k] % i)) {
				p[k][c[k]] = i;
				s[k][c[k]] = 1;
				a[k] /= i;
				while (!(a[k] % i)) {
					++s[k][c[k]];
					a[k] /= i;
				}
				c[k]++;
			}
		if (a[k] != 1) {
			p[k][c[k]] = a[k];
			s[k][c[k]++] = 1;
		}
	}
/*
	for (int k = 0; k < 2; ++k) {
		for (int i = 0; i < c[k]; ++i)
			printf ("%d ^ %d ", p[k][i], s[k][i]);
		printf ("\n");
	}
*/
}

unsigned my_pow (unsigned a, unsigned b) {
	return (b ? my_pow (a, b - 1) * a : 1);
}

unsigned tell (unsigned k, unsigned pp) {
	unsigned ret = 1;
	for (int i = 0; i < c[k]; ++i)
		ret *= my_pow (p[k][i], s[k][i] / pp);
	return ret;
}

void init_vec () {
	int __nod;
	int i, k;
	for (k = 0; k < 2; ++k) {
		vecc[k] = 0;
		__nod = s[k][0];
		for (i = 1; i < c[k]; ++i)
			__nod = nod (s[k][i], __nod);

		for (i = 1; i <= __nod; ++i)
			if (!(__nod % i))
				vec[k][vecc[k]++] = _2 (tell (k, i), i);
	}
/*
	for (k = 0; k < 2; ++k) {
		for (i = 0; i < vecc[k]; ++i)
			printf ("%u %u\n", vec[k][i].n, vec[k][i].p);
		printf ("******\n");
	}
*/
}

unsigned N;
int P;

void find_N_P () {
	int i, j;
//	printf ("%d %d\n", vecc[0], vecc[1]);
	for (i = 0; i < vecc[0]; ++i)
		for (j = 0; j < vecc[1]; ++j)
			if (vec[0][i].p == vec[1][j].p && vec[0][i].n - 1 == vec[1][j].n)
				goto endfor;
	assert (0);
endfor:;
	if (i == vecc[0] && j == vecc[1]) {exit (-1); printf ("wrong!!\n");}
	N = vec[1][j].n;
	P = vec[0][i].p;
//	printf ("%u %u(%d %d)\n", N, P, i, j);
}

void calc_prnt () {
	unsigned f =0;
	for (int i = 0; i < P; ++i) {
		f *= N;
		++f;
	}
	printf ("%Lu ", f);

	unsigned s =0;
	unsigned p1 = my_pow (N+1, P);
	unsigned p2 = 1;
	for (int i = 0; i <= P; ++i) {
		s += (unsigned)(p1) * p2;
		p1 /= N+1;
		p2 *= N;
	}
	printf ("%Lu\n", s);
}

int main () {
	while (scanf ("%Lu %Lu", &a[0], &a[1]), !(a[0] == 0 && a[1] == 0)) {
		razl ();
		init_vec ();
		find_N_P ();
		calc_prnt ();
	}

	return 0;
}
