/*
NAME: The Cat in the Hat
ID: 107
SITE: acm.uva.es
*/

#include <cstdio>
#include <vector>

const int MAXPR = 1 << 15;
const int MAXMN = 1 << 6;

typedef unsigned long long type;

std::vector <bool> er;
type pr[MAXPR];
unsigned prc;

type d[2];
std::pair <type, type> mn[2][MAXMN];
unsigned mnc[2];
type nods[2];
type Dnod;

void fnd_prime () {
	er.resize (100000);
	unsigned i;
	for (i = 2; i * i < er.size (); ++i) {
		if (er[i]) continue;
		pr[prc++] = i;
		for (unsigned j = i * i; j < er.size (); j += i) er[j] = 1;
	}
	for (; i < er.size (); ++i) if (!er[i]) pr[prc++] = i;
//	for (int i = 0; i < 20; ++i) printf ("%d ", pr[i]); printf ("\n");
//	printf ("prc == %d\n", prc);
}

void razl () {
	unsigned i;
	for (int k = 0; k < 2; ++k) {
		mnc[k] = 0;
		for (i = 0; d[k] > 1 && pr[i] * pr[i] <= d[k]; ++i) {
			if (d[k] % pr[i]) continue;
			d[k] /= pr[i];
			mn[k][mnc[k]] = std::make_pair(pr[i], 1);
//			printf ("- %u\n", pr[i]);
			while (!(d[k] % pr[i])) {
				d[k] /= pr[i];
				++mn[k][mnc[k]].second;
			}
			++mnc[k];
		}
//		printf ("d[%d] == %u\n", k, d[k]);
		if (d[k] > 1) mn[k][mnc[k]++] = std::make_pair (d[k], 1);
	}
}

type _nod (type a, type b) {
	return a ? _nod (b % a, a) : b;
}

type nod (type a, type b) {
	return a < b ? _nod (a, b) : _nod (b, a);
}

void fnd_nods () {
	for (int k = 0; k < 2; ++k) {
		nods[k] = mn[k][0].second;
		for (unsigned i = 1; i < mnc[k]; ++i)
			nods[k] = nod (nods[k], mn[k][i].second);
	}

	Dnod = nod (nods[0], nods[1]);
}

type mypow (type a, type s) {
	type ret = 1;
	for (type i = 0; i < s; ++i)
		ret *= a;
	return ret;
}

type fnd_N (int k, int st) {
	type ret = 1;
	for (unsigned i = 0; i < mnc[k]; ++i)
		ret *= mypow (mn[k][i].first, mn[k][i].second / st);
	return ret;
}

void calc_prnt (type N, type K) {
//	printf ("%u %u\n", N, K);

	type i;
	type tmp = 1, sum1 = 0, sum2 = 0;
	for (i = 0; i < K; ++i) {
		sum1 += tmp;
		sum2 += tmp * mypow (N + 1, K - i);
		tmp *= N;
	}
	sum2 += tmp;
	printf ("%Lu %Lu\n", sum1, sum2);
}

void try_all () {
	type i;
	for (i = Dnod; i; --i) {
		if (Dnod % i) continue;

		type N1 = fnd_N (0, i), N2 = fnd_N (1, i);
//		printf ("%u %u %u\n", N1, N2, i);
		if (N1 == N2 + 1) {calc_prnt (N2, i); break;}
	}

	if (!i) assert (0);
}

int main () {
	fnd_prime ();

	while (scanf ("%Lu %Lu", &d[0], &d[1]), d[0] * d[1]) {
		if (d[0] == 1) {assert (d[1] == 1); printf ("0 1\n"); continue;}
		razl ();
		fnd_nods ();
/*		for (int k = 0; k < 2; ++k) {
			for (unsigned i = 0; i < mnc[k]; ++i)
				printf ("(%u %u)", mn[k][i].first, mn[k][i].second);
			printf ("\n");
		}

		printf ("%u %u\n", nods[0], nods[1]);
*/		try_all ();
	}
	return 0;
}
