/*
NAME: Meta-Loopless Sorts
ID: 110
SITE: acm.uva.es
*/

#include <cstdio>
#include <cstring>

int N;

void floid (bool m[8][8]) {
	for (int k = 0; k < N; ++k)
		for (int i = 0; i < N; ++i)
			for (int j = 0; j < N; ++j)
				if (m[i][k] && m[k][j])
					m[i][j] = 1;
}

int idnt;
void ident () {for (int i = 0; i < idnt; ++i) printf ("  ");}

bool used[8];
int st[8], sp;

void init_dfs () {
	memset (used, 0, sizeof (used));
	sp = 0;
}


void fls () {
	ident (); printf ("writeln(%c", st[sp-1] + 'a'); for (int i = sp-2; i >= 0; --i) printf (",%c", st[i] + 'a'); printf (")\n");
}

struct ma3x {
	bool m[8][8];
	ma3x () {memset (m, 0, sizeof (m));}
	ma3x (const ma3x &a) {for (int i = 0; i < N; ++i) for (int j = 0; j < N; ++j) m[i][j] = a.m[i][j];}
	ma3x (const ma3x &a, int x, int y) {for (int i = 0; i < N; ++i) for (int j = 0; j < N; ++j) m[i][j] = a.m[i][j]; m[x][y] = 1;}
	void wput (int &x, int &y) const {
		ma3x tmp (*this);
		floid (tmp.m);
		for (int i = 0; i < N; ++i)
			for (int j = i + 1; j < N; ++j)
				if (!tmp.m[i][j] && !tmp.m[j][i]) {
					x = i;
					y = j;
					return;
				}
		x = y = -1;
	}
	void topsort () {
		static int i, j;
		for (j = 0; j < N; ++j) {
			for (i = 0; i < N && !m[i][j]; ++i);
			if (i == N) {init_dfs (); dfs (j); fls ();}
		}
	}
	void dfs (int a) {
		used[a] = 1;
		for (int i = 0; i < N; ++i)
			if (m[a][i] && !used[i]) dfs (i);
		st[sp++] = a;
	}
};

void solve (ma3x a) {
	++idnt;
	int p, q;
	a.wput (p, q);
	if (p == -1) {a.topsort (); --idnt; return;}
	ident (); printf ("if %c < %c then\n", p + 'a', q + 'a');
	solve (ma3x (a, p, q));
	ident (); printf ("else\n");
	solve (ma3x (a, q, p));
	--idnt;
}

void init () {
	printf ("program sort(input,output);\n"
			"var\n");
	printf ("a"); for (int i = 1; i < N; ++i) printf (",%c", i + 'a');
	printf (" : integer;\n");
	printf ("begin\n"
			"  readln(");
	printf ("a"); for (int i = 1; i < N; ++i) printf (",%c", i + 'a');
	printf (");\n");
}

void fin () {
	printf ("end.\n");
}


int main () {
	int Ntc;
	scanf ("%d", &Ntc);

	for (int i = 0; i < Ntc; ++i) {
		if (i) printf ("\n");
		scanf ("%d", &N);
		init ();
		solve (ma3x ());
		fin ();
	}

	return 0;
}
