#include <cstdio>
#include <vector>
#include <utility>
#include <algorithm>
#include <queue>

#ifdef ONLINE_JUDGE
void assert (bool a) {
	while (!a);
}
#else
#include <cassert>
#endif

const int MAXN = 1 << 7;
const int MAXT = 50000;

struct mon_q {
	int id;
	int left;
	int rest;
	mon_q () {}
	mon_q (int _id, int _left, int _rest) : id (_id), left (_left), rest (_rest) {}
	bool operator < (const mon_q &a) const {return rest > a.rest;}//inversed
};

struct mon {
	int a, b;
	int drink;
	mon () {}
	mon (int _a, int _b, int _drink) : a (_a), b (_b), drink (_drink) {}
};

int N, M;
mon vec[MAXN];
int idx[MAXN];
std::priority_queue <mon_q> db;

bool cmp (int a, int b) {
	return vec[a].a < vec[b].a;
}

std::vector <std::pair <int, int> > ans[MAXN];

void app (int id, int t) {
	if (!ans[id].empty () && ans[id].back ().second == t)
		++ans[id].back ().second;
	else
		ans[id].push_back (std::make_pair (t, t + 1));
}

int main () {
	int tc = 0;
	std::vector <mon_q> to_push;
	while (scanf ("%d %d", &N, &M) == 2) {
		for (int i = 0; i < N; ++i) {
			scanf ("%d %d %d", &vec[i].drink, &vec[i].a, &vec[i].b);
//			++vec[i].b;
			idx[i] = i;
			assert (ans[i].empty ());//this seems ok!
		}
		std::sort (idx, idx + N, cmp);
//		for (i = 0; i < N; ++i) printf ("%d  %d %d %d\n", idx[i], vec[idx[i]].a, vec[idx[i]].b, vec[idx[i]].drink);

		int cp = 0;
		int crnt_off = 0;
		assert (db.empty ());
		for (int t = 0; t <= MAXT; ++t) {
//			printf ("t is %d\n", t);
			if (cp == N && db.empty ()) {
//				printf ("we are done!\n");
				break;//done
			}
		
			while (vec[idx[cp]].a == t) {
//				printf ("adding monkey %d %d %d\n"\
				, idx[cp]\
				, vec[idx[cp]].drink\
				, vec[idx[cp]].b - vec[idx[cp]].a - vec[idx[cp]].drink + crnt_off);

				db.push (mon_q (idx[cp], vec[idx[cp]].drink, vec[idx[cp]].b - vec[idx[cp]].a - vec[idx[cp]].drink + crnt_off));
				++cp;
			}

			int dn = M;
			assert (to_push.empty ());
			while (!db.empty () && dn--) {
				mon_q crnt = db.top (); db.pop ();
//				printf ("popped %d %d %d\n", crnt.id, crnt.left, crnt.rest);
				if (crnt.rest - crnt_off < 0) {
					to_push.clear ();
					goto very_bad;
				}
				app (crnt.id, t);
				if (--crnt.left) {//if it is zero -> we don't need to process it any more
					++crnt.rest;
//					printf ("adding %d %d %d\n", crnt.id, crnt.left, crnt.rest);
					to_push.push_back (crnt);
//					db.push (crnt);
				}
			}
			while (!to_push.empty ()) {
//				printf ("real add %d %d %d\n", to_push.back ().id, to_push.back ().left, to_push.back ().rest);
				db.push (to_push.back ());
				to_push.pop_back ();
			}
			++crnt_off;
		}

		if (!db.empty ()) {
//			db = std::priority_queue <mon_q> ();
			goto very_bad;//there is no solution
		}

		printf ("Case %d: Yes\n", ++tc);
		for (int i = 0; i < N; ++i) {
			printf ("%u", (unsigned)ans[i].size ());
			for (size_t j = 0; j < ans[i].size (); ++j)
				printf (" (%d,%d)", ans[i][j].first, ans[i][j].second);
			puts ("");
			ans[i].clear ();//free mem
		}

		continue;
		very_bad:
		db = std::priority_queue <mon_q> ();
		for (int i = 0; i < N; ++i)
			ans[i].clear ();
		printf ("Case %d: No\n", ++tc);
	}

	

	return 0;
}
