#include <cstdio>
#include <cstring>
#include <cassert>
#include <map>

const unsigned MAX = 1 << 15;

int T;
int coef[4];
double ch[MAX];
int C[16][16];

unsigned _base;
double cadd;

int box[] = {10, 20, 50, 100, 200, 500, 1000, 2000, 5000, 10000, 20000, 50000, 100000, 200000, 500000};

void rec (int pos, int left = 3) {
//	printf ("%d %d (%x)\n", pos, left, _base);
	if (left == 0) {
//		printf ("ch[%d %x] += %lf\n", _base, _base, cadd);
		ch[_base] += cadd;
		return;
	}

	assert (pos < 15);
	
	if (15 - pos != left) {//can skip
		rec (pos + 1, left);
	}
	if (!((_base >> pos) & 1)) {
		_base |= 1 << pos;
		rec (pos + 1, left - 1);
		_base ^= 1 << pos;//remove
	}
//	printf ("<-- %d %d (%x)\n", pos, left, _base);
}

double prob_win;
double aver_win;

std::map <double, int> pr_win;
std::map <double, int> av_win;

bool upd (int payment, double chance, bool force = 0) {
	if (payment >= T) {
//		++pr_win[chance];
//		av_win[chance] += payment;
		prob_win += chance;
		aver_win += chance * payment;
		return 1;
	}
	if (force) {
		aver_win += chance * payment;
	}
	return 0;
}

int deal (unsigned boxes, int pc) {
//	if (pc == 13) printf ("!!\n");
	int tot = 0;
	for (int i = 0; i < 15; ++i)
		if (!((boxes >> i) & 1)) {
//			printf ("get %d\n", box[i]);
			tot += box[i];
		}

//	printf ("deal %x (%d -- %d)\n", boxes, pc, coef[(pc / 3) - 1]);
//	printf ("%d * %d  / %d * %d\n", tot, coef[(pc / 3) - 1], 100, 15 - pc);
//	printf ("%d\n", (tot * coef[(pc / 3) - 1]) / (100 * (15 - pc)));
	return (tot * coef[(pc / 3) - 1]) / (100 * (15 - pc));
}

int main () {
	C[0][0] = 1;
	for (int i = 1; i < 16; ++i) {
		C[i][0] = 1;
		for (int j = 1; j <= i; ++j)
			C[i][j] = C[i-1][j-1] + C[i-1][j];
	}
	while (scanf ("%d", &T), T) {
		memset (ch, 0, sizeof (ch));
		scanf ("%d %d %d %d", coef, coef + 1, coef + 2, coef + 3);

		ch[0] = 1;
		cadd = 1. / C[15][4];
//		printf ("\ngenerating for i == %u(%x) -- cadd %e\n", 0, 0, cadd);
		aver_win = prob_win = 0;
		_base = 0;
		rec (0, 4);//
//		return 0;
		int bi[2], bp;
		for (unsigned i = 1; i < MAX; ++i) {
			int pc = __builtin_popcount (i);
			if (pc % 3 != 1 || pc == 1) continue;

			if (upd (deal (i, pc), ch[i])) continue;
//			if (pc == 13) printf ("yee\n");
			if (pc == 13) {//they are 2 left
				bp = 0;

				for (int j = 0; j < 15; ++j)
					if (!((i >> j) & 1))
						bi[bp++] = j;
				assert (bp == 2);

//				printf ("%x --- %d %d\n", i, box[bi[0]], box[bi[1]]);
//				upd ((box[bi[0]] + box[bi[1]]) / 2., ch[i]);
				upd (box[bi[0]], ch[i] / 2., 1);
				upd (box[bi[1]], ch[i] / 2., 1);
			} else {
				cadd = ch[i] / C[15 - pc][3];
//				printf ("\ngenerating for i == %u(%x) -- cadd %e\n", i, i, cadd);
				_base = i;
				rec (0);
			}
		}
/*		prob_win = aver_win = 0;
		for (std::map <double, int> :: iterator it1 = pr_win.begin (), it2 = av_win.begin (); it1 != pr_win.end (); ++it1, ++it2) {
			prob_win += it1->first * it1->second;
			aver_win += it2->first * it2->second;
		}
*/
		printf ("%lf %lf\n", prob_win, aver_win);
	}

	return 0;
}
