#include<cstdio>
#include<vector>
#include<algorithm>

using namespace std;

vector<long long> mult(const vector<long long> &a)
{
	vector<long long> res = a;
	res.insert(res.begin(), 0);
	return res;
}

vector<long long> add(const vector<long long> &a, const vector<long long> &b)
{
	vector<long long> res(max(a.size(), b.size()));
	for(unsigned i = 0; i < res.size(); i++)
	{
		res[i] = 0;
		if(i < a.size()) res[i] += a[i];
		if(i < b.size()) res[i] += b[i];
	}
	return res;
}

vector<long long> sub(const vector<long long> &a, const vector<long long> &b)
{
	vector<long long> res(max(a.size(), b.size()));
	for(unsigned i = 0; i < res.size(); i++)
	{
		res[i] = 0;
		if(i < a.size()) res[i] += a[i];
		if(i < b.size()) res[i] -= b[i];
	}
	return res;
}

void print(const vector<long long> &a)
{
	bool flag = false;
	for(int i = a.size() - 1; i >= 1; i--)
	{
		if(a[i] != 0)
		{
			if(a[i] > 0)
			{
				if(flag) printf("+");
			}
			else printf("-");
			if(abs(a[i]) != 1) printf("%lld", abs(a[i]));
			printf("Cos");
			if(i > 1) printf("^%d", i);
			printf("(A)");
			flag = true;
		}
	}
	if(a[0] != 0)
	{
		if(a[0] > 0) printf("+");
		printf("%lld", a[0]);
	}
	printf("\n");
}

vector<long long> f[64], g[64];

int main()
{
	f[1].push_back(0);
	f[1].push_back(1);
	g[1].push_back(1);
	vector<long long> g0, g1, g2, f0, f1;
	for(int i = 2; i <= 50; i++)
	{
		g0 = g[i - 1];
		g1 = mult(g0);
		g2 = mult(g1);
		f0 = f[i - 1];
		f1 = mult(f0);
		f[i] = sub(add(g2, f1), g0);
		g[i] = add(g1, f0);
	}
	while(true)
	{
		int n;
		scanf("%d", &n);
		if(n == 0) break;
		print(f[n]);
	}
	return 0;
}
