#include <cstdio>
#include <utility>
#include <vector>

using namespace std;

const int MOD = 1000000007;

typedef long long ll;

pair <int, int> gcd_ext (int a, int b) {
	static pair <int, int> tmp;
	return b ? tmp = gcd_ext (b, a % b), make_pair (tmp.second, tmp.first - tmp.second * (a / b)) : make_pair (1, 0);
}

int mod_div22 (int x, int y, int z) {
	int m_inv_y = gcd_ext (MOD, y).second;
	int m_inv_z = gcd_ext (MOD, z).second;
	return ((((ll)x * (ll)m_inv_y) % MOD) * ((ll)m_inv_z)) % MOD;
}

int divi(int x, int y)
{
	int m_inv_y = gcd_ext (MOD, y).second;
	return (((ll)x * (ll)m_inv_y) % MOD);
}

int mod_div2(int x, int y, int z)
{
	return divi(divi(x, y), z);
}

int wrap(int x, int y, int z)
{
	int a = mod_div2(x, y, z);
	if (a < 0) a += MOD;
	return a;
}

#define N (1 << 16)
int mas[N];
int sum[N];
int val[N];
int x;
vector <vector <int> > child;
vector <int> usd;

void dfs(int v)
{
	if (!child[v].size())
	{
		sum[v] = 1;
		val[v] = 1;
	}
	else
	{
		dfs(child[v][0]);
		val[v] = val[child[v][0]];
		sum[v] = sum[child[v][0]];
		for (int i = 1; i < (int) child[v].size(); ++ i)
		{
			dfs(child[v][i]);
			//printf("> %d v = %d s = %d\n", v, val[v], sum[v]);
			x = wrap(mas[sum[v] + sum[child[v][i]]], mas[sum[v]], mas[sum[child[v][i]]]);
			val[v] = (((((ll) val[v]) * ((ll) val[child[v][i]])) % MOD));
			//printf("> %d v = %d s = %d\n", v, val[v], sum[v]);
			val[v] = (((ll) val[v]) * ((ll) x)) % MOD;
			sum[v] += sum[child[v][i]];
		}
		sum[v] ++;
	}
	//printf("%d v = %d s = %d\n", v, val[v], sum[v]);
}

int main ()
{
	int it;
	scanf("%d", &it);
	mas[0] = 1;
	for (int i = 1; i < N; ++ i)
		mas[i] = ((ll)i * (ll)mas[i - 1]) % MOD;
	for (; it; -- it)
	{
		int n, m;
		scanf("%d %d", &n, &m);
		usd.resize(n + 1, 0);
		child.resize(n + 1);
		int a, b;
		for (int i = 0; i < m; ++ i)
		{
			scanf("%d %d", &a, &b);
			child[b].push_back(a);
			usd[a] ++;
		}
		for (int i = 1; i <= n; ++ i)
			if (!usd[i])
			{
				usd[i] ++;
				child[0].push_back(i);
			}
		dfs(0);
		printf("%d\n", val[0]);
		usd.clear();
		child.clear();
	}
	return 0;
}
