/*
NAME: Power of Cryptography
ID: 113
SITE: acm.uva.es
*/

#include <cstdio>
#include <cstring>
#include <cassert>

const int MAXLEN = 1 << 7;
const int MAX = 1 << 4;
const int BASE = 1000000000;

struct big {
	int m[MAX];
	big () {for (int i = 1; i < MAX; ++i) m[i] = 0; m[0] = 1;}
	big (const char *s) {
		int i;
		for (i = 0; i < MAX; ++i) m[i] = 0;
		int len = strlen (s);
		int tmp = 0;
		for (i = 0; i < len; ++i) {
			if (!((len - i) % 9)) {
				m[(len - i) / 9] = tmp;
				tmp = 0;
			}
			tmp *= 10;
			tmp += s[i] - '0';
		}
		m[0] = tmp;
	}
	big &operator = (const big &a) {for (int i = 0; i < MAX; ++i) m[i] = a.m[i]; return *this;}
	big &operator *= (long long x) {
		if (m[MAX-1] == 999999999) return *this;
		static long long tmp;
		static long long pr;
		static int i;
		pr = 0;
		for (i = 0; i < MAX-1; ++i) {
			tmp = m[i] * x + pr;
			pr = tmp / BASE;

			m[i] = tmp % BASE;
		}
		m[MAX-1] = pr;
		if (pr) m[MAX-1] = 999999999;
		return *this;
	}
	bool operator == (const big &a) const {
		static int i;
		for (i = 0; i < MAX && m[i] == a.m[i]; ++i);
		return i == MAX;
	}
	bool operator < (const big &a) const {
		static int i;
		for (i = MAX-1; i && m[i] == a.m[i]; --i);
		return m[i] < a.m[i];
	}
	void prnt () const {
		static int i;
		for (i = MAX-1; i && !m[i]; --i);
		printf ("%d", m[i]);
		for (--i; i >= 0; --i) printf ("%09d", m[i]);
		printf ("\n");
	}
};

char p[MAXLEN];
int n;
big targ;

big pow (int x) {
//	printf ("pow %d %d\n", x, n);
	big res;
	for (int i = 0; i < n; ++i) {
		res *= x;
//		printf ("%d -->", i); res.prnt ();
	}
//	res.prnt ();
	return res;
}

int bsrch () {
	int l = 0, r = BASE, m;
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (pow (m) < p)
			l = m;
		else
			r = m;
	}
	assert (pow (r) == p);
	return r;
}

int main () {
	while (scanf ("%d\n", &n) == 1) {
		gets (p);
		targ = big (p);
//		printf ("NOW n == %d\n", n);
//		printf ("targ == "); targ.prnt ();
//		#warning chech if p is 1000...00  .. or not :)
		int res = bsrch ();
		printf ("%d\n", res);
	}

	return 0;
}
