/*
NAME: Climbing Trees
ID: 115
SITE: acm.uva.es
*/

#include <cstdio>
#include <cstdlib>

#include <map>
#include <queue>
#include <vector>
#include <string>
#include <utility>
#include <iostream>

const int MAXN = 1 << 9;
const int MAXRMQ = 1 << 10;
const int MAXLOG = 1 << 4;

int pre[MAXN];
std::vector <int> kids[MAXN];
std::map <std::string, int> ref;
int lvl[MAXN];
int boss[MAXN];

void bfs (int start) {
	std::queue <int> q;
	q.push (start);
	lvl[start] = 0;

//	printf ("bfs %d\n", start);
	while (!q.empty ()) {
		boss[q.front ()] = start;
//		printf ("pop %d - %d\n", q.front (), lvl[q.front ()]);
		for (unsigned i = 0; i < kids[q.front ()].size (); ++i) {
			q.push (kids[q.front ()][i]);
			lvl[kids[q.front ()][i]] = lvl[q.front ()] + 1;
		}
		q.pop ();
	}
}

void prnt_pc (std::string w, int dif) {
	for (int i = 0; i < dif-2; ++i)
		std::cout << "great ";
	if (dif > 1) std::cout << "grand ";
	std::cout << w << std::endl;
//	std::cout << w << ' ' << dif << std::endl;
}

void prnt_cs (int i, int j) {
	{
		int ii = std::min (i, j), jj = abs (i - j);
		i = ii; j = jj;
	}
	if (i == 1 && j == 0)
		std::cout << "sibling" << std::endl;
	else {
		std::cout << i-1 << " cousin";
		if (j != 0)
			std::cout << " removed " << j;
		std::cout << std::endl;
	}
//	std::cout << "cousins " << std::min (i, j) << ' ' << abs (i - j) << std::endl;
}

//BEGIN LCA / RMQ
int cp;
int RMQ_val[MAXRMQ];
int RMQ_mem[MAXRMQ][MAXLOG];

int LCA_ref[MAXRMQ];
int LCA_FO[MAXN];

void RMQ_init () {
	int i, j;
	for (i = 0; i < cp; ++i) RMQ_mem[i][0] = i;
	for (j = 1; (1 << j) <= cp; ++j) {
		for (i = 0; i + (1 << j) <= cp; ++i)
			RMQ_mem[i][j] = RMQ_val[RMQ_mem[i][j-1]] < RMQ_val[RMQ_mem[i+(1<<j-1)][j-1]] ?
							RMQ_mem[i][j-1] : RMQ_mem[i+(1<<j-1)][j-1];
	}
}

int highest_bit (int a) {
	static int i;
	for (i = 30; i > 0 && !(a & (1 << i)); --i);
	return i;
}

int RMQ_query (int l, int r) {
	if (l > r) std::swap (l, r);
	++r;
	int j = highest_bit (r - l);
//	printf ("query %d %d --> mem[%d][%d] , mem[%d][%d]\n", l, r, l, j, r-(1<<j), j);
	return RMQ_val[RMQ_mem[l][j]] < RMQ_val[RMQ_mem[r-(1<<j)][j]] ?
			RMQ_mem[l][j] : RMQ_mem[r-(1<<j)][j];
}

int find_lca (int a, int b) {
	return LCA_ref[RMQ_query (LCA_FO[a], LCA_FO[b])];
}

//END LCA / RMQ

void write (int s) {
	if (LCA_FO[s] == -1) LCA_FO[s] = cp;
	RMQ_val[cp] = lvl[s];
	LCA_ref[cp++] = s;
}

void euler (int s) {
	write (s);
	for (unsigned i = 0; i < kids[s].size (); ++i) {
		euler (kids[s][i]);
		write (s);
	}
}

/*
int find_lca (int i, int j) {
	while (i != j)
		if (lvl[i] > lvl[j]) i = pre[i];
		else if (lvl[j] > lvl[i]) j = pre[j];
		else {i = pre[i]; j = pre[j];}

	return i;
}
*/
int main () {
	std::string n1, n2;
	std::map <std::string, int>::iterator i1, i2;
	int N = 0;
	for (int i = 0; i < MAXN; ++i) pre[i] = -1, LCA_FO[i] = -1;
	while (std::cin >> n1 >> n2, n1 != std::string ("no.child")) {
		if ((i1 = ref.find (n1)) == ref.end ()) i1 = ref.insert (std::make_pair (n1, N++)).first;
		if ((i2 = ref.find (n2)) == ref.end ()) i2 = ref.insert (std::make_pair (n2, N++)).first;

//		printf ("%s - %d | %s - %d\n", i1->first.c_str (), i1->second, i2->first.c_str (), i2->second);
		pre[i1->second] = i2->second;
		kids[i2->second].push_back (i1->second);
	}
/*
	for (int i = 0; i < N; ++i) {
		printf ("%d(%d)->", i, pre[i]);
		for (unsigned j = 0; j < kids[i].size (); ++j)
			printf (" %d", kids[i][j]);
		printf ("\n");
	}
*/
	for (int i = 0; i < N; ++i) if (pre[i] == -1) bfs (i), euler (i);
	RMQ_init ();

/*	for (int i = 0; i < cp; ++i)
		printf ("(%d %d) ", RMQ_val[i], LCA_ref[i]);
	printf ("\n");
	for (int i = 0; i < N; ++i) printf ("%d ", LCA_FO[i]); printf ("\n");
*/
/*	for (std::map <std::string, int>::iterator i = ref.begin (); i != ref.end (); ++i)
		printf ("%s %d\n", i->first.c_str (), i->second);

	for (int i = 0; i < N; ++i)
		printf ("%d - %d %d\n", i, lvl[i], boss[i]);
*/
	int lca;
	while (std::cin >> n1 >> n2) {
		if ((i1 = ref.find (n1)) == ref.end ()
		 || (i2 = ref.find (n2)) == ref.end ()
		 || boss[i1->second] != boss[i2->second]) {std::cout << "no relation" << std::endl; continue;}

		lca = find_lca (i1->second, i2->second);
//		printf ("lca %d %d - %d\n", i1->second, i2->second, lca);
		if (lca == i1->second)
			prnt_pc ("parent", lvl[i2->second] - lvl[i1->second]);
		else if (lca == i2->second)
			prnt_pc ("child", lvl[i1->second] - lvl[i2->second]);
		else
			prnt_cs (lvl[i1->second] - lvl[lca], lvl[i2->second] - lvl[lca]);
	}

	return 0;
}
