/*
NAME: Unidirectional TSP
ID: 115
SITE: acm.uva.es
*/

#include <cstdio>

int N, M;
int ma3x[10][100];
int prev[10][100];

inline int pr (int j) {if (j == 0) return N - 1; return j - 1;}
inline int nx (int j) {if (j == N-1) return 0; return j + 1;}

inline int fnd_min (int i, int j) {
	static int mini;
	mini = i;
	if (ma3x[pr (i)][j] < ma3x[mini][j] || ma3x[pr (i)][j] == ma3x[mini][j] && pr (i) < mini)
		mini = pr (i);
	if (ma3x[nx (i)][j] < ma3x[mini][j] || ma3x[nx (i)][j] == ma3x[mini][j] && nx (i) < mini)
		mini = nx (i);
	return mini;
}

int main () {
	register int i, j;
	int mini, crnt;
	while (scanf ("%d %d", &N, &M) == 2) {
		for (i = 0; i < N; ++i)
			for (j = 0; j < M; ++j)
				scanf ("%d", ma3x[i] + j);

		for (j = M-2; j >= 0; --j)
			for (i = 0; i < N; ++i) {
				prev[i][j] = fnd_min (i, j + 1);
				ma3x[i][j] += ma3x[prev[i][j]][j+1];
			}

		mini = 0;
		for (i = 1; i < N; ++i)
			if (ma3x[i][0] < ma3x[mini][0])
				mini = i;

		printf ("%d", mini + 1);
		crnt = prev[mini][0];
		for (j = 1; j < M; ++j) {
			printf (" %d", crnt + 1);
			crnt = prev[crnt][j];
		}

		printf ("\n%d\n", ma3x[mini][0]);
	}


	return 0;
}
