/*
NAME: The Postal Worker Rings Once
ID: 117
SITE: acm.uva.es
*/

#include <cstdio>
#include <iostream>
#include <string>

const int MAXLEN = 1 << 10;
const int ALPHA = 26;
const int N = ALPHA;

unsigned ma3x[ALPHA][ALPHA];
std::string s;
unsigned all;
int in[ALPHA];

unsigned clean_up (unsigned ret) {
	static int i, j;
	all = 0;
	for (i = 0; i < N; ++i) {
		in[i] = 0;
		for (j = 0; j < N; ++j)
			ma3x[i][j] = 500000000;
	}
	return ret;
}

unsigned solve () {
	static int i, j, k;
	for (k = 0; k < N; ++k)
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j)
				if (ma3x[i][j] > ma3x[i][k] + ma3x[k][j])
					ma3x[i][j] = ma3x[i][k] + ma3x[k][j];

	for (i = 0; i < N && !(in[i] & 1); ++i);
	if (i == N) return clean_up (all);

	for (j = i + 1; j < N && !(in[j] & 1); ++j);

	return clean_up (ma3x[i][j] + all);
}

int main () {
	while (std::cin >> s)
		if (s == std::string ("deadend"))
			printf ("%u\n", solve ());
		else {
			ma3x[s[0] - 'a'][*(s.end() - 1) - 'a'] = ma3x[*(s.end() - 1) - 'a'][s[0] - 'a'] = s.size ();
			all += s.size ();
			++in[s[0] - 'a'];
			++in[*(s.end() - 1) - 'a'];
		}

	return 0;
}
