/*
NAME: Pipe Fitters
ID: 121
SITE: acm.uva.es
*/

#include <cstdio>
#include <cmath>

const double epsilon = 1e-10;
const double new_h = 0.8660254037844386467637231708;

int to_int (double x) {
	if (ceil (x) - x > epsilon) return (int)floor (x); return (int)ceil (x);
}

int calc_skew (double x, double y) {
	if (x < 1 - epsilon || y < 1 - epsilon) return 0;
	--y;
	int rows = to_int (y / new_h);
	return ((rows + 1) >> 1) * (to_int (x) + to_int (x - 0.5)) + to_int (x) * ((rows + 1) & 1);
}

int main () {
	double x, y;
	while (scanf ("%lf %lf", &x, &y) == 2) {
		int grid = to_int (x) * to_int (y);
		int skew = calc_skew (x, y) >? calc_skew (y, x);
		printf ("%d %s\n", grid >? skew, grid == (grid >? skew) ? "grid" : "skew");
	}
	return 0;
}
