/*
NAME: Searching Quickly
ID: 123
SITE: acm.uva.es
*/

#include <cstdio>
#include <cctype>
#include <cassert>

#include <vector>
#include <string>
#include <set>
#include <iostream>
#include <sstream>
//#include <fstream>
#include <utility>
#include <algorithm>

std::set <std::string> ignore;
std::vector <std::vector <std::string> > sent;
std::vector <std::pair <int, int> > to_sort;

std::string & to_lower (std::string &a) {
	for (unsigned i = 0; i < a.size (); ++i) a[i] = tolower (a[i]);
	return a;
}

std::string to_upper (const std::string &a) {
	std::string ret = a;
	for (unsigned i = 0; i < a.size (); ++i) ret[i] = toupper (ret[i]);
	return ret;
}

bool cmps (const std::pair <int, int> &a, const std::pair <int, int> &b) {
	return	sent[a.first][a.second] != sent[b.first][b.second] ?
				sent[a.first][a.second] < sent[b.first][b.second] :
				a.first != b.first ?
					a.first < b.first :
					a.second < b.second;
}

void prnt_str (const std::vector <std::string> &a, unsigned	 id) {
	for (unsigned i = 0; i < a.size (); ++i) {
		if (i) printf (" ");
		printf ("%s", (i == id ? to_upper (a[i]) : a[i]).c_str ());
	}
	printf ("\n");
}

int main () {
	std::string tmp;
	while (std::cin >> tmp && tmp != "::")
		ignore.insert (tmp);
	std::cin.get ();//eats new line after "::"

//	printf ("!!!!!!!!!!! %d\n", ignore.find ("a") == ignore.end ());

	int s, i;//s - sentence
	sent.resize (200);
	std::string line;
	std::string word;
	for (s = 0; std::getline (std::cin, line), line.size (); ++s) {
		std::istringstream in (line);
		for (i = 0; in >> word; ++i) {
			to_lower (word);
			if (ignore.find (word) == ignore.end ()) {
//				printf ("adding word _%s_ %d %d\n", word.c_str (), s, i);
				to_sort.push_back (std::make_pair (s, i));
			}
			sent[s].push_back (word);
		}
	}

	std::sort (to_sort.begin (), to_sort.end (), cmps);
/*
	printf ("s == %d\n", s);
	for (i = 0; i < s; ++i) {
		for (unsigned j = 0; j < sent[i].size (); ++j)
			printf ("_%s_", sent[i][j].c_str ());
		printf ("\n");
	}
*/
	for (i = 0; i < (int)to_sort.size (); ++i) {
		prnt_str (sent[to_sort[i].first], to_sort[i].second);
//		printf ("%s(%d)\n", to_upper (sent[to_sort[i].first][to_sort[i].second]).c_str (), to_sort[i].first);
	}

	return 0;
}
