/*
NAME: Numbering Paths
ID: 125
SITE: acm.uva.es
*/

#include <cstdio>
#include <cassert>
#include <cstring>

#include <iostream>
#include <string>
#include <sstream>

const int MAXN = 1 << 5;
const int MAX = 2000000000;

int N;

struct ma3x {
	long long m[MAXN][MAXN];
	ma3x () {memset (m, 0, sizeof (m));}
	ma3x (const ma3x &x) {memcpy (m, x.m, sizeof (m));}
	ma3x & operator = (const ma3x &x) {memcpy (m, x.m, sizeof (m)); return *this;}

	ma3x& operator += (const ma3x &x) {
		static int i, j;
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j) {
				m[i][j] += x.m[i][j];
				m[i][j] <?= MAX;
			}
		return *this;
	}
	ma3x operator * (const ma3x &x) const {
		ma3x ret;
		static int i, j, k;
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j)
				for (k = 0; k < N; ++k) {
					ret.m[i][j] += m[i][k] * x.m[k][j];
					ret.m[i][j] <?= MAX;
				}
		return ret;
	}

	void prnt () const {for (int i = 0; i < N; ++i) {printf ("%Ld", m[i][0]); for (int j = 1; j < N; ++j) printf (" %Ld", m[i][j]); puts ("");}}
};

int M;
ma3x base;

int main () {
	int tc = 0;
	int i;
	int x, y;
	ma3x tmp;
	while (scanf ("%d", &M) == 1) {
		N = 0;
		base = ma3x ();
		for (i = 0; i < M; ++i) {
			scanf ("%d %d", &x, &y);

			++base.m[x][y];
			N >?= (x >? y) + 1;
		}
/*
		printf ("base ma3x case %d\n", tc);
		base.prnt ();
		printf ("lvl 1:\n");
		(base * base).prnt ();
*/
		ma3x acc (base);
		ma3x acc2;
		for (i = 2, tmp = base; i < N; ++i) {
			tmp = tmp * base;
			acc += tmp;
		}

		for (i = 0; i < N; ++i) {
			tmp = tmp * base;
			acc2 += tmp;
		}

		for (i = 0; i < N; ++i)
			for (int j = 0; j < N; ++j)
				if (acc2.m[i][j])
					acc.m[i][j] = -1;
/*
		for (i = 0; i < N; ++i) {
			if (acc.m[i][i]) {
				for (int j = 0; j < N; ++j) {
					if (acc.m[i][j]) acc.m[i][j] = acc.m[j][i] = -1;
					if (acc.m[j][i]) acc.m[j][i] = -1;
				}
			} else
				for (int j = 0; j < N; ++j)
					assert (acc.m[i][j] != MAX);
		}
*/
		printf ("matrix for city %d\n", tc + 1 - 1);
		acc.prnt ();
//		if (tc + 1 == 26) {printf ("--\n"); base.prnt (); printf ("--\n");}
		++tc;
	}

	return 0;
}
