#include <cstdio>
#include <climits>
#include <algorithm>
#include <vector>
#include <utility>
#include <cstring>

using namespace std;

typedef unsigned long long ull;
#define mp make_pair

long long dp[64][2];

long long f(ull num) {
	memset(dp, 0, sizeof(dp));
	dp[63][0] = 1;
	for (int i = 63; i > 0; --i) {
		int bit = (num >> i) & 1;

		dp[i-1][0] += dp[i][0];
		dp[i-1][1] += dp[i][1];
		if (bit) {
			dp[i-1][1] += dp[i][0];
		} else {
			dp[i-1][0] += dp[i][1];
		}
	}
	return dp[0][0] + (num & 1 ? 0 : dp[0][1]);
}

ull conv(int *v) {
	ull res = 0;
	for (int i = 63; i >= 0; --i) {
		res <<= 1;
		res |= v[i];
	}
	return res;
}

void prntvec(int *vec, FILE *out) {
	for (int i = 63; i >= 0; --i) fprintf(out, "%d", vec[i]);
}

ull next_mask(ull m) {
	static bool special = false;

	int vec[70] = {0};
	int nvec[70] = {0};
	int i;
	for (i = 63; i >= 0; --i)
		vec[i] = (m >> i) & 1;

	for (i = 63; i >= 0 && !vec[i]; --i) ;
	int fb = i;

	for (i = 0; i < 64; ++i)
		if (vec[i] == 1 && vec[i+1] == 0 && vec[i+2] == 0)
			break;


	if (i == fb) {
		if (fb == 63) return -1;
		//printf("\tfb == %d\n", fb);
		nvec[fb+1] = 1;
		for (int i = fb - 3; i > 0; i -= 2)
			nvec[i] = 1;
		if (fb >= 11 && fb % 2 == 1)
			special = true;
		return conv(nvec);
	} else {
		//printf("\tfb == %d, i == %d\n", fb, i);
		vec[i] = 0;
		vec[i+1] = 1;
		if (i == 2)
			vec[1] = 1;

		if (special) {
			special = false;
//			fprintf(stderr, "spec %d %d %d\n", vec[3], vec[2], vec[1]);
//			fprintf(stderr, "\t");
//			prntvec(vec, stderr);
			swap(vec[1], vec[2]);
//			fprintf(stderr, "spec %d %d %d\n", vec[3], vec[2], vec[1]);
//			fprintf(stderr, "\t");
//			prntvec(vec, stderr);
		}
		return conv(vec);
	}
}

void bitprnt(ull num) {
	int i;
	for (i = 63; i > 0 && !(num >> i & 1); --i) putchar('0');
	for (; i >= 0; --i) putchar((num >> i & 1) + '0');
}

int main() {
	vector<pair<ull, long long> > res;
	res.push_back(mp(0, 1));
	res.push_back(mp(2, 2));
	res.push_back(mp(4, 3));
	res.push_back(mp(8, 4));
	res.push_back(mp(10, 5));
	res.push_back(mp(18, 7));
	res.push_back(mp(20, 8));
	res.push_back(mp(34, 9));
	res.push_back(mp(36, 11));
	res.push_back(mp(42, 13));
	res.push_back(mp(68, 14));
	res.push_back(mp(72, 15));

	ull m = 74;
	for (int i = 0; i < 2000; ++i) {
		//printf("%lld -- %5llu ", f(m), m); bitprnt(m); puts("");
		if (f(m) > res.back().second)
			res.push_back(mp(m, f(m)));
		m = next_mask(m);
		if (m == -1) break;
	}
/*
	for (int i = 0; i < 144; ++i) {
		bitprnt(res[i].first);
		printf(" %llu %lld\n", res[i].first, res[i].second);
	}
*/

	ull n;
	int ctc = 0;
	while(scanf("%llu", &n) == 1 && n != 0) {
		printf("Case %d: ", ++ctc);
		int pos = std::upper_bound(res.begin(), res.end(), pair<ull, long long>(n, LONG_LONG_MAX)) - res.begin();
		--pos;
		//printf("pos: %d\n %llu %llu\n", pos, res[pos-1].first, res[pos+1].first);
		printf("%lld\n", res[pos].second);
	}

	return 0;
}
