#include <cstdio>
#include <cmath>

using namespace std;

struct point {
	double x, y;
};

double cross(point a, point b, point c) {
	return (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);
}

point intersect(point a1, point b1, point a2, point b2) {
	double t1 = cross(a1, b1, a2);
	double t2 = cross(a1, b1, b2);
	point res;
	res.x = a2.x + t1 / (t1 - t2) * (b2.x - a2.x);
	res.y = a2.y + t1 / (t1 - t2) * (b2.y - a2.y);
	return res;
}

int main() {
	int t;
	scanf("%d", &t);
	for (int ti = 0; ti < t; ti++) {
		point a, b, c, d, e, f, p, q, r;
		scanf("%lf%lf%lf%lf%lf%lf", &a.x, &a.y, &b.x, &b.y, &c.x, &c.y);
		d.x = (b.x + 2 * c.x) / 3;
		d.y = (b.y + 2 * c.y) / 3;
		e.x = (c.x + 2 * a.x) / 3;
		e.y = (c.y + 2 * a.y) / 3;
		f.x = (a.x + 2 * b.x) / 3;
		f.y = (a.y + 2 * b.y) / 3;
		q = intersect(b, e, c, f);
		p = intersect(b, e, a, d);
		r = intersect(a, d, c, f);
		printf("%.0lf\n", abs(cross(p, q, r)) / 2);
	}
	return 0;
}
