#include <cstdio>

using namespace std;

#define N (1 << 17)
#define M 1000000009ll
#define K 32

int n;
int q;
long long seq[N];
long long mas[K][N];
long long newton[K][K];

void precomp()
{
	for (int i = 0; i < n; ++ i)
		mas[0][i] = seq[i];
	for (int i = 1; i <= 20; ++ i)
	{
		for (int j = 0; j < n; ++ j)
		{
			mas[i][j] = (mas[i - 1][j] * (j + 1)) % M;
			//printf ("%lld ", mas[i][j]);
		}
		//printf ("\n");
	}
	for (int i = 0; i <= 20; ++ i)
		for (int j = 1; j < n; ++ j)
			mas[i][j] = (mas[i][j] + mas[i][j - 1]) % M;
	for (int i = 0; i < K; ++ i)
	{
		newton[i][0] = 1;
		for (int j = 1; j <= i; ++ j)
			newton[i][j] = newton[i - 1][j] + newton[i - 1][j - 1];
	}
}

long long g(int k, int a, int b)
{
	long long res = mas[k][b];
	if (a) res -= mas[k][a - 1];
	if (res < 0) res += M;
	//printf("g(%d, %d %d) = %lld\n", k, a, b, res);
	return res;
}

long long f(int k, int a, int b)
{
	long long res = 0;
	for (int i = 0; i <= k; ++ i)
		res = ((g(i, a, b) * newton[k][i]) - a * res) % M;
	if (res < 0) res += M;
	//printf("h(%d, %d %d) = %lld\n", k, a, b, res);
	return res;
}

int main()
{
	int tc;
	scanf("%d", &tc);
	for (int ct = 0; ct < tc; ++ ct)
	{
		scanf("%d", &n);
		for (int i = 0; i < n; ++ i)
			scanf("%lld", seq + i);
		precomp();
		scanf("%d", &q);
		int k, a, b;
		for (int i = 0; i < q; ++ i)
		{
			scanf("%d %d %d", &k, &a, &b);
			--a; --b;
			printf("%lld\n", f(k, a, b));
		}
	}
	return 0;
}

