#include <cstdio>
#include <cassert>
#include <cctype>
#include <cstring>

const int KK = 4;
const int A1 = 32;
const int A2 = 123;

const int MAXK = 6;
const int MM = 202;
const int MAXM = 1 << 8;
const int MAXN = 1 << 13;

const int MOD = 10007;

int N, M, K;
int edp[MAXK][MAXK][MAXM];
//int dp[MAXN][MAXM];
int nodes[MAXN][MAXK];
int leaf[MAXN];

int saved[MAXK][MAXM][MAXM];

int bp;
int cnode;
int tholes;
int go(int edge) {
	if (nodes[cnode][edge] == -1) {
		tholes += K - 1;
		nodes[cnode][edge] = bp++;
		memset(nodes[nodes[cnode][edge]], -1, sizeof(int) * K);
	}
	return cnode = nodes[cnode][edge];
}


void init() {
	for (int k = 2; k <= 5; ++k) {
		edp[k][k][0] = 0;
		edp[k][0][0] = 1;
		edp[k][k][1] = 1;
		edp[k][1][1] = 1;
		for (int j = 2; j <= MM; ++j) {
			for (int i = 2; i <= k; ++i)
				for (int s = 1; s < j; ++s) {
					edp[k][i][j] += edp[k][i-1][j-s] * edp[k][k][s];
					edp[k][i][j] %= MOD;
				}
			edp[k][1][j] = edp[k][k][j];
		}
	}


	for (int k = 2; k <= 5; ++k) {
		saved[k][0][0] = 1;
		for (int j = 0; j <= MM; ++j)
			saved[k][1][j] = edp[k][k][j];
		for (int i = 2; i < MAXM; ++i)
			for (int j = 2; j <= MM; ++j)
				for (int jj = 1; jj < j; ++jj) {
					saved[k][i][j] += saved[k][i-1][jj] * edp[k][k][j-jj];
					saved[k][i][j] %= MOD;
				}
	}

/*
	int tmp[MAXM] = {0};
	for (int j = 0; j <= MM; ++j) {
		for (int jj = 0; jj <= j; ++jj) {
			tmp[j] += saved[KK][A1][jj] * saved[KK][A2][j-jj];
			tmp[j] %= MOD;
		}
		assert(tmp[j] == saved[KK][A1+A2][j]);
	}
*/

	for (int k = 2; k <= 5; ++k) {
		printf("K == %d\n", k);
		printf("      ");
		for (int j = 0; j <= 21; ++j)
			printf(" %5d", j);
		puts("");
		for (int i = 0; i <= 13; ++i) {
			printf("%2d -->", i);
			for (int j = 0; j <= 21; ++j)
				printf(" %5d", saved[k][i][j]);
			puts("");
		}
	}

}

int count_holes(int start) {
	if (leaf[start]) return 0;
	if (start == -1) return 1;
	int res = 0;
	for (int i = 0; i < K; ++i)
		res += count_holes(nodes[start][i]);
	return res;
}

int main() {
	init();
	int tc;
	scanf("%d", &tc);

	int c, i;
	for (int ctc = 0; ctc < tc; ++ctc) {
		scanf("%d %d %d\n", &N, &M, &K);

		bp = 1;
		memset(nodes[0], -1, sizeof(nodes) / MAXN);
		memset(leaf, 0, sizeof(leaf));
		tholes = K;
		for (i = 0; i < N; ++i) {
			cnode = 0;
			while ((c = getchar()) != EOF && !isspace(c))
				go(c - '0');
			leaf[cnode] = 1;
			tholes -= K;
			while((c = getchar()) != EOF && isspace(c)) ;
			if (c != EOF) ungetc(c, stdin);
		}

		int holes = count_holes(0);
		assert(holes == tholes);
		int res = saved[K][holes][M];
		printf("Case #%d: %d\n", ctc + 1, res);
	}

	return 0;
}
