#include <cstdio>
#include <cctype>
#include <cstring>
#include <cassert>

typedef unsigned uint;
const int MAXN = 16;
const int MAXM = 32;
const int POS = 11;
const int MASK = 1 << 10;
int MM;

int c2i[128];
const int P = 7;
int dd[][2] = { {-1, 1}, {0, 1}, {0, 0}, {1, 0} };
uint chk[] = { 0xE, 0xC, 0x6, 0x7, 0x6, 0xC, 0x4 };
uint app[] = { 0xA, 0xC, 0x6, 0x3, 0x2, 0x8, 0x0 };

const int MOD = 50431;
uint bounds, ubounds;

int N, M;
int dp[POS][MASK];
int dpx[MASK];

char board[MAXN][MAXM];


inline uint bound(uint patt) { return (patt << 1) | bounds; }
inline uint ubound(uint patt) {return (patt >> 1) & ubounds; }

int y;
inline bool check(uint patt, uint mask, int pos, int tile) {
	// ++pos;
	//printf("\t\tcheck __%3x %3x %d__\n", patt, mask, pos);
	//printf("\t\t%3x %3x\n", patt, mask);
	if (patt & (mask << pos)) return false;
	int nx, ny;
	for (int i = 0; i < 4; ++i) {
		nx = pos + dd[i][0];
		ny = y + dd[i][1];
		if (!((mask >> i) & 1)) continue;
		if (nx < 0 || nx >= N
		 || ny < 0 || ny >= M) {
			//printf("FUCKING OUT %d  %d %d\n", i, nx, ny);
		 	return false;
		}
		if (board[nx][ny] == '#') return false;
		if (board[nx][ny] != '.' && c2i[(int) board[nx][ny]] != tile)
			return false;
	}
	if ((app[tile] >> 2) & 1) {
		nx = pos + 1;
		ny = y + 1;
		if (nx < 0 || nx >= N
		 || ny < 0 || ny >= M) return false;
		if (board[nx][ny] == '#') return false;
		if (board[nx][ny] != '.' && c2i[(int) board[nx][ny]] != tile)
			return false;
	}
	return true;
}

inline uint apply(uint patt, uint mask, int pos) {
	// ++pos;
	//patt &= ~(0xF << pos);
	return patt | (mask << pos);
}

inline void doj(uint msk, int p, int i, uint msk2) {
	if (check(msk, chk[p], i, p)) {
		uint nm = apply(msk, app[p], i);
		//printf("\tpost apply %3x\n", nm);
		nm = ubound(nm);
		//printf("\tgo %d %3x\n", p, nm);
		dp[i+1][nm] += dp[i][msk2];
		dp[i+1][nm] %= MOD;
	}
}


int main() {
	//freopen("g.in", "r", stdin);
	//freopen("g.out", "w", stdout);

	int tc;
	scanf("%d", &tc);

	memset(c2i, -1, sizeof(c2i));
	const char *str = "BRNGPWL";
	for (int i = 0; str[i]; ++i) c2i[(int) str[i]] = c2i[tolower(str[i])] = i;

	for (int tcc = 1; tcc <= tc; ++tcc) {
		printf("Case %d: ", tcc);
		scanf("%d %d", &N, &M);
		bounds = (1 << (N+2)) | 1;
		ubounds = ((1 << (N+1)) - 1);
		MM = 1 << (N + 1);
		for (int i = 0; i < N; ++i) {
			scanf(" ");
			fgets(board[i], MAXM, stdin);
		}
		memset(dpx, 0, sizeof(dpx));
		dpx[0] = 1;
		for (int j = 0; j < M; ++j) {
			y = j;
			//printf("j = %d\n", j);
			memset(dp, 0, sizeof(dp));
			memcpy(dp[0], dpx, sizeof(dpx));

			for (int i = 0; i < N; ++i) {
				for (uint m = 0; m < (uint) MM; ++m) {
					if (dp[i][m] == 0) continue;
					//printf("dp[%2d][%3x] = %d\n", i, m, dp[i][m]);
					uint msk = bound(m);
					//printf("bound: %3x\n", msk);
					if (board[i][j] == '#' || msk & (1 << (i + 2))) {
						// move here
						uint nm = msk & ~(1 << (i + 2));
						nm = ubound(nm);
						//printf("\tgo move %3x\n", nm);
						dp[i+1][nm] += dp[i][m];
						dp[i+1][nm] %= MOD;
					} else if (board[i][j] == '.') {
						for (int p = 0; p < P; ++p) {
							doj(msk, p, i, m);
						}
					} else if (board[i][j] != '#') {
						assert(c2i[(int) board[i][j]] != -1);
						doj(msk, c2i[(int) board[i][j]], i, m);
					}
				}
			}

			for (uint m = 0; m < (uint) MM / 2; ++m) {
//				if ((1 << N) & m) continue;
				dpx[m << 1] = dp[N][m];
			}
		}
		printf("%d\n", dpx[0]);
	}

	return 0;
}
