#include <cstdio>
#include <climits>
#include <cstring>

const int MAXLEN = 1 << 7;

int N;
char vec[MAXLEN];
int opt[MAXLEN][MAXLEN];

inline int min (int a, int b) {return a < b ? a : b;}

int grp (int b, int e) {
	static int bgs[MAXLEN];
	static int bp;
	bp = 0;
	int i;
	for (i = b + 1; i < e; ++i)
		if (vec[i] == vec[b] && !((e - b) % (i - b)))
			bgs[bp++] = i;

	int j, k;
	int res = INT_MAX;
	for (k = 0; k < bp; ++k) {
		i = b; j = bgs[k];
		while (j < e && vec[i] == vec[j]) {++i; ++j;}
		if (j == e)
			res = min (res, opt[b][bgs[k]]);
	}
	return res;
}

void make_dyn () {
	N = strlen (vec);

	int i, j, k;
//	for (i = 0; i <= N; ++i) for (j = 0; j <= N; ++j) opt[i][j] = INT_MAX;

	for (i = N-1; i >= 0; --i) {
		opt[i][i+1] = 1;
		for (j = i + 2; j <= N; ++j) {
			opt[i][j] = INT_MAX;
			for (k = i + 1; k < j; ++k)
				opt[i][j] = min (opt[i][j], opt[i][k] + opt[k][j]);
			opt[i][j] = min (opt[i][j], grp (i, j));
		}
	}
/*	printf ("-%s-\n", vec);
	for (i = 0; i < N; ++i) {
		for (j = 0; j <= i; ++j) printf ("  ");
		for (j = i+1; j <= N; ++j)
			printf ("%d ", opt[i][j]);
		printf ("\n");
	}
*/
}

int main () {
	while (scanf ("%s", vec) != EOF) {
		if (vec[1] == 0 && vec[0] == '*') break;
//		printf ("-%s-\n", vec);
		make_dyn ();
		printf ("%d\n", opt[0][N]);
	}

	return 0;
}
