#include<cstdio>
#include<sstream>
#include<map>
#include<vector>
#include<algorithm>
#include<queue>
#include<cassert>

#define MAXN 128
#define MAXT 64

using namespace std;

struct triple
{
	int a, b, v;
};

int n, m;
triple monkey[MAXN];
vector<int> list;
vector<int> res[MAXN];

void solve(int ti)
{
	int right = 0;
	multimap<int, int> beg;
	priority_queue<pair<int, int> > heap;
	for(int i = 0; i < n; i++)
	{
		if(monkey[i].b > right) right = monkey[i].b;
		beg.insert(make_pair(monkey[i].a, i));
		res[i].clear();
	}
	int b, v;
	for(int s = 0; s < right; s++)
	{
		pair<multimap<int, int>::iterator, multimap<int, int>::iterator> range = beg.equal_range(s);
		for(multimap<int, int>::iterator i = range.first; i != range.second; i++)
		{
			b = monkey[i->second].b;
			v = monkey[i->second].v;
			if(v != 0) heap.push(make_pair(-(b - v), i->second));
		}
		list.clear();
		for(int i = 0; i < m; i++)
		{
			if(heap.size() == 0) break;
			list.push_back(heap.top().second);
			heap.pop();
		}
		for(unsigned i = 0; i < list.size(); i++)
		{
			b = monkey[list[i]].b;
			v = monkey[list[i]].v;
			if(b - v - s < 0)
			{
				printf("Case %d: No\n", ti);
				return;
			}
			if(res[list[i]].size() > 0 && res[list[i]].back() == s) res[list[i]].pop_back();
			else res[list[i]].push_back(s);
			res[list[i]].push_back(s + 1);
			monkey[list[i]].v--;
			v--;
			if(v != 0) heap.push(make_pair(-(b - v), list[i]));
		}
	}
	if(heap.size() > 0)
	{
		printf("Case %d: No\n", ti);
		return;
	}
	printf("Case %d: Yes\n", ti);
	for(int i = 0; i < n; i++)
	{
		assert(res[i].size() % 2 == 0);
		printf("%d", (int)res[i].size() / 2);
		for(unsigned j = 0; j < res[i].size(); j += 2)
		{
			printf(" (%d,%d)", res[i][j], res[i][j + 1]);
		}
		printf("\n");
	}
}

int main()
{
	int t = 0;
	while(1)
	{
		scanf("%d", &n);
		if(n == 0) break;
		scanf("%d", &m);
		for(int i = 0; i < n; i++)
		{
			scanf("%d%d%d", &monkey[i].v, &monkey[i].a, &monkey[i].b);
		}
		solve(t + 1);
		t++;
	}
	return 0;
}
