#include<cstdio>
#include<algorithm>

using namespace std;

#define MAXN 512
#define INF 2000000000

int left[2*MAXN], right[2*MAXN];
int MIN[2*MAXN][2*MAXN], MAX[2*MAXN][2*MAXN];

void build(int i, int l, int r)
{
	int mid = (l + r) / 2;
	left[i] = l;
	right[i] = r;
	if(l != r)
	{
		build(2 * i, l, mid);
		build(2 * i + 1, mid + 1, r);
	}
}

int ask_max(int i, int j, int l1, int r1, int l2, int r2)
{
	int m1 = (left[i] + right[i]) / 2;
	int m2 = (left[j] + right[j]) / 2;
	int res = -INF;
	//fprintf(stderr, "%d %d\n", i, j);
	if(l1 == left[i] && r1 == right[i] && l2 == left[j] && r2 == right[j])
	{
		//fprintf(stderr, "%d %d %d\n", i, j, MAX[i][j]);
		return MAX[i][j];
	}
	if(l1 <= m1)
	{
		if(l2 <= m2) res = max(ask_max(2*i, 2*j, l1, min(m1, r1), l2, min(m2, r2)), res);
		if(r2 >= m2 + 1) res = max(ask_max(2*i, 2*j+1, l1, min(m1, r1), max(l2, m2+1), r2), res);
	}
	if(r1 >= m1 + 1)
	{
		if(l2 <= m2) res = max(ask_max(2*i+1, 2*j, max(l1, m1+1), r1, l2, min(m2, r2)), res);
		if(r2 >= m2 + 1) res = max(ask_max(2*i+1, 2*j+1, max(l1, m1+1), r1, max(l2, m2+1), r2), res); 
	}
	//fprintf(stderr, "%d %d %d %d %d %d %d\n", i, j, l1, r1, l2, r2, res);
	return res;
}

int ask_min(int i, int j, int l1, int r1, int l2, int r2)
{
	int m1 = (left[i] + right[i]) / 2;
	int m2 = (left[j] + right[j]) / 2;
	int res = INF;
	if(l1 == left[i] && r1 == right[i] && l2 == left[j] && r2 == right[j])
	{
		return MIN[i][j];
	}
	if(l1 <= m1)
	{
		if(l2 <= m2) res = min(ask_min(2*i, 2*j, l1, min(m1, r1), l2, min(m2, r2)), res);
		if(r2 >= m2 + 1) res = min(ask_min(2*i, 2*j+1, l1, min(m1, r1), max(l2, m2+1), r2), res);
	}
	if(r1 >= m1 + 1)
	{
		if(l2 <= m2) res = min(ask_min(2*i+1, 2*j, max(l1, m1+1), r1, l2, min(m2, r2)), res);
		if(r2 >= m2 + 1) res = min(ask_min(2*i+1, 2*j+1, max(l1, m1+1), r1, max(l2, m2+1), r2), res); 
	}
	return res;
}

void update(int i, int j, int v)
{
	i += MAXN;
	j += MAXN;
	MIN[i][j] = MAX[i][j] = v;
	while(i > 1 && j > 1)
	{
		i /= 2; j /= 2;
		int t1, t2;
		t1 = max(MAX[2*i][2*j], MAX[2*i][2*j+1]);
		t2 = max(MAX[2*i+1][2*j], MAX[2*i+1][2*j+1]);
		MAX[i][j] = max(t1, t2);
		t1 = min(MIN[2*i][2*j], MIN[2*i][2*j+1]);
		t2 = min(MIN[2*i+1][2*j], MIN[2*i+1][2*j+1]);
		MIN[i][j] = min(t1, t2);
	}
}

int main()
{
	int n, m;
	int v;
	build(1, 0, MAXN - 1);
	scanf("%d%d", &n, &m);
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < m; j++)
		{
			scanf("%d", &v);
			update(i + 1, j + 1, v);
		}
	}
	int q;
	scanf("%d", &q);
	char c;
	int l1, r1, l2, r2;
	for(int i = 0; i < q; i++)
	{
		scanf(" %c%d%d%d", &c, &l1, &r1, &l2);
		if(c == 'q')
		{
			scanf("%d", &r2);
			//fprintf(stderr, "%d %d %d %d\n", l1, r1, l2, r2);
			printf("%d %d\n", ask_max(1, 1, l1, l2, r1, r2), ask_min(1, 1, l1, l2, r1, r2));
		}
		else
		{
			update(l1, r1, l2);
		}
	}
	return 0;
}
