#include <cstdio>
#include <climits>
#include <cmath>

using namespace std;

typedef unsigned long long ull;

struct VeryLarge
{
	char x;
	ull y;
	VeryLarge(char _x, ull _y) : x(_x), y(_y) {}
	VeryLarge() : x(0), y(0) {}
	VeryLarge operator+(const VeryLarge & vl) const 
	{
		VeryLarge res;
		res.x = x + vl.x;
		res.y = y + vl.y;
		if (res.y < y) res.x ++;		
		return res;
	}
	VeryLarge operator-(const VeryLarge & vl) const 
	{
		VeryLarge res;
		res.x = x - vl.x;
		res.y = y - vl.y;
		if (res.y > y) res.x --;		
		return res;
	}
	VeryLarge neg()
	{
		return VeryLarge() - *this;
	}
	VeryLarge abs()
	{
		if (x >= 0) return *this;
		return neg();
	}
	bool operator<(const VeryLarge &m) const
	{
		if (x == vl.x) return y < m.y;
		return x < m.x;
	}
};

VeryLarge mean(const VeryLarge &vl1, const VeryLarge &vl2)
{
	ull rem;
	VeryLarge m = vl1 + vl2;
	bool b = m.x < 0;
	if (b) m = m.neg();
	rem = m.y % 2;
	if (m.x % 2) rem ++;
	rem /= 2;
	m.y /= 2;
	if (m.x % 2) m.y += UNSIGNED_LONG_LONG_MAX / 2;
	m.y += rem;
	m.x /= 2;
	if (b) m = m.neg();
	return m;
}

#define N (1 << 20)

int n;
VeryLarge mas[N], sum;

VeryLarge f(VeryLarge m)
{
	VeryLarge t, d(0, 0), x;
	for (int i = 1; i < n; ++ i)
	{
		d = d + m.abs();
		t = mas[i];
		t = t + m;
		m = sum - t;
	}
	d = d + m;
	return d;
}

int main()
{
	while (scanf("%d", &n) != EOF)
	{
		sum.y = 0;
		for (int i = 0; i < n; ++ i)
		{
			scanf("%llu", &mas[i].y);
			sum.y += mas[i].y;
		}
		sum.y /= n;
		VeryLarge l(-1, 0), r(0, -1), m, r1, r2;
		while (l < r)
		{
			m = mean(l, r);
			r1 = f(m);
			r2 = f(m + VeryLarge(0, 1));
			if (r1 < r2) r = m;
			else l = m + VeryLarge(0, 1);
		}
	}
	return 0;
}
