#include <cstdio>
#include <algorithm>
#include <cstring>
#include <vector>

const int MAXN = 1 << 14;
const int MAXX = 64;
const int MAXL = 1 << 20;
const int INF = 1000000000;

int N;
std::vector <int> gr[MAXN];
bool nroot[MAXN];

struct bst2 {
	int b, bi;
	int sb;
	bst2 () {b = sb = INF;}
	void upd (int val, int id) {
		if (val >= sb) return;
		if (val >= b) {
			sb = val;
			return;
		} else {
			sb = b;
			b = val;
			bi = id;
		}
	}
};

bst2 dp[MAXN];
void dfs (int a) {
	if (gr[a].size () == 0) {
		dp[a].b = 1;
		dp[a].bi = 0;
		dp[a].sb = 2;
//		printf ("dp %d -- %d %d %d\n", a, dp[a].b, dp[a].bi, dp[a].sb);
		return;
	}
//	printf ("<<!!dp %d -- %d %d %d\n", a, dp[a].b, dp[a].bi, dp[a].sb);
	for (size_t i = 0; i < gr[a].size (); ++i)
		dfs (gr[a][i]);
	for (int x = 0; x < MAXX; ++x) {
		int c = x + 1;
		for (size_t i = 0; i < gr[a].size (); ++i) {
			if (dp[gr[a][i]].bi != x)
				c += dp[gr[a][i]].b;
			else
				c += dp[gr[a][i]].sb;
		}
		dp[a].upd (c, x);
	}
//	printf ("!!dp %d -- %d %d %d\n", a, dp[a].b, dp[a].bi, dp[a].sb);
}

int main () {
	char line[MAXL];
	char *lp;
	int i;
	int r, cr, cn;
	while (scanf ("%d", &N), N) {
		memset (nroot, 0, sizeof (nroot));
		for (i = 0; i < N; ++i) {
			scanf ("%d:", &r);
			gr[r].clear ();
			gets (line);
			lp = line;
			while (sscanf (lp, "%d%n", &cn, &cr) == 1) {
				lp += cr;
				gr[r].push_back (cn);
				nroot[cn] = 1;
			}
		}
		for (i = 0; i < N; ++i) dp[i] = bst2 ();
		for (i = 0; i < N && nroot[i]; ++i);
//		_l[0] = _l[1] = 0;
		dfs (i);
//		if (_l[0] > _l[1])\
			std::swap (_l[0], _l[1]);
		printf ("%d\n", dp[i].b);
		/*
		for (i = 0; i < N; ++i) {
			printf ("%d ->", i);
			for (size_t j = 0; j < gr[i].size (); ++j)
				printf (" %d", gr[i][j]);
			puts ("");
		}*/
	}
	return 0;
}
