#include <cstdio>
#include <cmath>
#include <algorithm>

struct pnt {
	double x, y;
	pnt () {}
	pnt (double _x, double _y) : x (_x), y (_y) {}

	pnt operator - (const pnt &a) const {return pnt (x - a.x, y - a.y);}
	pnt rot () const {return pnt (-y, x);}
};

double S (const pnt &a, const pnt &b, const pnt &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

pnt A, B;

double clc (double y) {
	return hypot (B.x, B.y + y) + hypot (A.x, A.y - y);
}

int main () {
	int tc;
	scanf ("%d", &tc);
	while (tc--) {
		scanf ("%lf %lf %lf %lf", &A.x, &A.y, &B.x, &B.y);
		if (A.y < B.y) std::swap (A, B);	
	
		double l = 0, r = A.y, m1, m2;
		for (int k = 0; k < 100; ++k) {
			m1 = (r - l) / 3. + l;
			m2 = (m1 + r) / 2.;

			if (clc (m1) > clc (m2))
				l = m1;
			else
				r = m2;
		}
		printf ("%.3lf\n", clc (l) + hypot (A.x - B.x, A.y - B.y));
	}

	return 0;
}
