#include<cstdio>
#include<algorithm>
#include<vector>

#define MAXN 32768

using namespace std;

struct tree
{
	int l, r, c;
	pair<int, int> res;
};

struct interval
{
	int l, r, c, x;
};

vector<int> y;
tree t[4 * MAXN], ind[4 * MAXN];
vector<interval> list;

bool cmp(const interval &a, const interval &b)
{
	return a.x < b.x;
}

void build(int i, int l, int r)
{
	int mid = (l + r) / 2;
	t[i].l = l;
	t[i].r = r;
	if(l != r)
	{
		build(2 * i, l, mid);
		build(2 * i + 1, mid + 1, r);
	}
}

pair<int, int> ft(int l, int r)
{
	int a, b;
	a = (r - l) / 2 + 1;
	b = (r - l + 1) / 2;
	if(l % 2) swap(a, b);
	return make_pair(a, b);
}

pair<int, int> count(int i)
{
	if(t[i].c == 0)
	{
		if(t[i].l != t[i].r)
		{
			t[i].res.first = t[2 * i].res.first + t[2 * i + 1].res.first;
			t[i].res.second = t[2 * i].res.second + t[2 * i + 1].res.second;
		}
		else t[i].res = make_pair(0, 0);
	}
	else t[i].res = ft(y[t[i].l], y[t[i].r + 1] - 1);
	return t[i].res;
}

void add(int i, int l, int r, int c)
{
	int mid = (t[i].l + t[i].r) / 2;
	if(l == t[i].l && r == t[i].r)
	{
		t[i].c += c;
		t[i].res = count(i);
		return;
	}
	if(l <= mid) add(2 * i, l, min(r, mid), c);
	if(r >= mid + 1) add(2 * i + 1, max(l, mid + 1), r, c);
	t[i].res = count(i);
}

int main()
{
	int n, m, k, cx, cy, cr, tx, ty;
	build(1, 0, 2 * MAXN);
	while(1)
	{
		y.clear();
		list.clear();
		scanf("%d", &n);
		if(n == 0) break;
		scanf("%d%d", &m, &k);
		for(int i = 0; i < k; i++)
		{
			scanf("%d%d%d", &cx, &cy, &cr);
			tx = cx + cy;
			ty = cx - cy;
			interval tmp;
			tmp.x = tx - cr;
			tmp.l = ty - cr;
			tmp.r = ty + cr + 1;
			tmp.c = 1;
			list.push_back(tmp);
			tmp.x = tx + cr + 1;
			tmp.l = ty - cr;
			tmp.r = ty + cr + 1;
			tmp.c = -1;
			y.push_back(ty - cr);
			y.push_back(ty + cr + 1);
			list.push_back(tmp);
		}		
		sort(y.begin(), y.end());
		y.erase(unique(y.begin(), y.end()), y.end());
		sort(list.begin(), list.end(), cmp);
		long long res = 0;
		for(int i = 0; i < list.size(); i++)
		{
			if(i > 0)
			{
				int lx = list[i - 1].x;
				int rx = list[i].x - 1;
				pair<int, int> len = ft(lx, rx), tmp = count(1);
				res += (long long)len.first * tmp.first + (long long)len.second * tmp.second;
				printf("%d %d %d %d %d %d %lld\n", lx, rx, len.first, len.second, tmp.first, tmp.second, res);
			}
			int l = lower_bound(y.begin(), y.end(), list[i].l) - y.begin();
			int r = lower_bound(y.begin(), y.end(), list[i].r) - 1 - y.begin();
			printf("Add %d %d %d\n", list[i].x, l, r);
			add(1, l, r, list[i].c);
			printf("Query %d %d\n", count(1).first, count(1).second);
		}
		printf("%lld\n", res - k);
	}
	return 0;
}
