#include <cstdio>
#include <cmath>

using namespace std;

#define N (1 << 10)

typedef long double huge;

int primes[N], p;
huge plo[N * N];
huge gcd[N * N];
huge lcd[N * N];
huge mul[N * N];
huge mul2[N * N];
int muli[N * N];
int mul2i[N * N];
huge goog;

void compute()
{
	for (int i = 2; i < N; ++ i)
		if (!primes[i])
		{
			plo[p] = log((huge) i);
			primes[p ++] = i;
			for (int j = i * i; j < N; j += i)
				primes[j] = 1;
		}
}

void cmul()
{
	muli[1] = mul2i[1] = 1;
	for (int i = 2; i < N * N; ++ i)
	{
		mul2[i] = mul2[i - 1];
		mul2[i] += log((huge) i - 1);
		mul[i] = mul[i - 1];
		mul[i] += mul2[i] + (i - 1) * log((huge)i);
	}
}

void cgcd()
{
	int x, t, y;
	for (int i = 2; i < N * N; ++ i)
	{
		gcd[i] = gcd[i - 1];
		y = i;
		for (int j = 0; (y - 1) && j < p; ++ j)
			if (i % primes[j] == 0)
			{
				x = i - 1;
				while (y % primes[j] == 0)
				{
					t = x / primes[j];
					gcd[i] += plo[j] * t;
					x = t;
					y /= primes[j];
				}
			}
		gcd[i] += ((i - 1) / y) * log((huge) y);
	}
}

void clcd()
{
	for (int i = 2; i < N * N; ++ i) lcd[i] = mul[i] - gcd[i];
}

int main()
{
	compute();
	cmul();
	cgcd();
	clcd();
	goog = 100 * log(10.0);
	int n;
	int it = 1;
	while (scanf ("%d", &n), n)
	{
		printf("Case %d: %.0Lf %.0Lf\n", it, floor(gcd[n] / goog) + 1, floor(lcd[n] / goog) + 1);
		++ it;
	}
	return 0;
}
