#include <limits>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>

using namespace std;

struct point {
	int x, y;
};

int N;
int N2;

point st[1 << 6];
int V[1 << 6];
point en[1 << 6];
double dist[1<<6][1<<6];

int source, sink;

bool rd[1 << 7][1 << 7];
int D[1 << 7];
int used[1 << 7];

int vis[1 << 7];
int vp;

bool bfs () {
	int i, j;
	int crnt;
	for (i = 0; i < N2; ++i) {
		D[i] = -1;
		used[i] = 0;
	}
	used[source] = 1;

	int queue[1 << 6];
	int p1 =0, p2 =1, p3 =0, lvl =0;
	queue[p3++] = sink;
	D[sink] = lvl++;
	
	while (p1 != p2) {
		for (i = p1; i < p2; ++i) {
			crnt = queue[i];
//			printf ("popped %d\n", crnt);
			for (j = 0; j < N2; ++j)
				if (D[j] == -1 && rd[j][crnt]) {
//					printf ("pushed %d\n", j);
					D[j] = lvl;
					queue[p3++] = j;
				}
		}
		p1 = p2;
		p2 = p3;
		++lvl;
	}

	return D[source] != -1;
}

bool dfs (int v) {
//	printf ("dfs %d\n", v);
	if (v == sink) {
		used[sink] = 0;
		return 1;
	}

	for (int i = 0; i < N2; ++i)
		if (D[i] == D[v] - 1 && !used[i] && rd[v][i]) {
			used[i] = 1;
			vis[vp++] = i;
			if (dfs (i))
				return 1;
			--vp;
		}
//	printf ("<- %d\n", v);
	return 0;
}

bool dinitz () {
	N2 = 2 * (N + 1);//all + source & sink
	int cnt =0;
	vis[0] = source;
	while (bfs ()) {
		while (vp =1, dfs (source)) {
			++cnt;
			for (int i = 0; i < vp-1; ++i) {
//				printf ("path %d %d\n", vis[i])
				rd[vis[i]][vis[i+1]] = 0;
				rd[vis[i+1]][vis[i]] = 1;
			}
		}
	}
	printf ("%d\n", cnt);
	return (cnt == N);
}

void generate (double m) {
	int i, j;
	source = 2 * N;
	sink = 2 * N + 1;
	for (i = 0; i < 2 * N + 2; ++i)
		for (j = 0; j < 2 * N  + 2; ++j)
			rd[i][j] = 0;

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			rd[i][j+N] = (dist[i][j] <= m);
//			if (rd[i][j+N]) printf ("added %d %d\n", i, j);
//			rd[j+N][i] = 0;
		}

	for (i = 0; i < N; ++i) {
		rd[source][i] = 1;
//		rd[i][source] = 0;
		rd[i+N][sink] = 1;
//		rd[sink][i+N] = 0;
	}
}

class UnitsMoving {
	public:
	double bestTime (vector <string> start, vector <string> end) {
		N = start.size ();
		int i, j;
		for (i = 0; i < N; ++i) {
			sscanf (start[i].c_str (), "%d %d %d", &st[i].x, &st[i].y, &V[i]);
			sscanf (end[i].c_str (), "%d %d", &en[i].x, &en[i].y);
		}
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j)
				dist[i][j] = hypot (st[i].x - en[j].x, st[i].y - en[j].y) / V[i];
		
		for (i = 0; i < N; ++i)
			dist[i][i] = numeric_limits <double> :: max ();

		double l = 0, r = 1000000., m;
		while (r - l > 1e-10) {
			m = (l + r) / 2;
			generate (m);
			if (printf ("%lf ", m), dinitz ())
				r = m;
			else
				l = m;
		}
		return r;
	}
};