/*
KEYW: Dinitz implemented with neighbour ma3x
*/

#include <cstdio>
#include <limits>
#include <algorithm>

using std::min;

const int MAXN = 1 << 5;
const int MAXFLOW = std::numeric_limits <int>::max ();

int N;
int source, sink;

int cap[MAXN][MAXN];

int rd[MAXN][MAXN];//residual graph -> everything is done here, the capacity ma3x is to restore the flow afterwards

int D[MAXN];
bool used[MAXN];


bool bfs () {//returns true if there exist a path from source to sink
	int i, j;
	for (i = 0; i < N; ++i) {
		D[i] = -1;
		used[i] = 0;//get ready for the next dfs
	}
	
	int queue[MAXN];
	int p1 =0, p2 =1, p3 =0, lvl =0;
	int crnt;
	queue[p3++] = sink;
	D[sink] = lvl++;

	while (p1 != p2) {
		for (i = p1; i < p2; ++i) {
			crnt = queue[i];
			for (j = 0; j < N; ++j)
				if (D[j] == -1 && rd[j][crnt]) {//unused && there is a way from j to crnt (the reversed edje)
					queue[p3++] = j;
					D[j] = lvl;
				}
		}
		p1 = p2;
		p2 = p3;
		++lvl;
	}
	return D[source] != -1;
}

int vis[MAXN];
int vp;

int dfs (int v) {
	if (v == sink)
		return MAXFLOW;

	int tmp;
	for (int i = 0; i < N; ++i) {
		if (D[i] == D[v] - 1 && !used[i] && rd[v][i]) {
			used[i] = 1;
			vis[vp++] = i;
			if ((tmp = dfs (i)))
				return min (tmp, rd[v][i]);
			
			--vp;
		}
	}

	return 0;//couldn't find a path to the sink
}

int maxflow;
int dinitz () {
	int cflow;
	vis[0] = source;
	while (bfs ()) {
		while (vp = 1, (cflow = dfs (source))) {
			maxflow += cflow;
			printf ("\n");
			for (int i = 1; i < vp; ++i) {
				rd[vis[i-1]][vis[i]] -= cflow;
				rd[vis[i]][vis[i-1]] += cflow;
			}
			used[source] = used[sink] = 0;//unuse the source and sink
		}
	}
}

void input () {
	scanf ("%d %d %d", &N, &source, &sink);
	--source; --sink;

	int i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			scanf ("%d", &cap[i][j]);
	
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			rd[i][j] = cap[i][j];

	for (i = 0; i < N; ++i)
		rd[i][i] = 0;//just for sure
}

void output () {
	printf ("%d\n", maxflow);
}

int main () {
	input ();
	dinitz ();
	output ();
	return 0;
}
