#include <cstdio>
#include <string>
#include <cstring>

#define MAXVER (1 << 7)
#define MAXEDGE (1 << 14)
//const int MAXVER = 1 << 7;//100
//const int MAXEDGE = 1 << 14;//100 ^ 2

struct el {
	int to;
	bool rd;
	int next;
	el () {}
	el (int _to, bool _rd, int _next)
		:to (_to), rd (_rd), next (_next) {}
};

int N;
int rN;
int vec[MAXVER];
el buf[MAXEDGE * 2];
int _bp;
int source, sink;

void clear_graph () {
	_bp = 0;
	memset (vec, -1, sizeof (vec));
}

void add_edge (int fr, int to) {
	buf[_bp] = el (to, 1, vec[fr]);
	vec[fr] = _bp++;
	buf[_bp] = el (fr, 0, vec[to]);
	vec[to] = _bp++;
}

int elp;
int elist[MAXVER];
int D[MAXVER];
int __save_d_source;
bool bfs () {
	static int q[MAXVER];
	int p3;
	int i, j;
	int c;
	memset (D, -1, sizeof (D));

	q[p3 = 0, p3++] = sink;
	D[sink] = 0;
	for (i = 0; i < p3; ++i) {
		c = q[i];
//		printf ("BFS popped %d(%d)\n", c, D[c]);
		if (c == source) break;
		for (j = vec[c]; j != -1; j = buf[j].next) {
			if (D[buf[j].to] == -1 && buf[j ^ 1].rd) {
				D[buf[j].to] = D[c] + 1;
				q[p3++] = buf[j].to;
			}
		}
	}
//	printf ("leaving BFS!\n");
	return (__save_d_source = D[source]) != -1;
}

bool dfs (int a) {
//	printf ("in dfs %d\n", a);
	if (a == sink) {
		return 1;
	}

	for (int i = vec[a]; i != -1; i = buf[i].next) {
		if (D[buf[i].to] == D[a] - 1 && buf[i].rd) {
			elist[elp++] = i;
			if (dfs (buf[i].to)) {
//				printf ("using edge %d ---> %d\n", a, buf[i].to);
				D[a] = -2;//unusable
				return 1;
			}
			--elp;
		}
	}
	D[a] = -2;//unusable
	return 0;
}

int dinitz () {
	int i;
	int mf = 0;
	while (bfs ()) {
		while (elp = 0, D[source] = __save_d_source, dfs (source)) {
			++mf;
//			printf ("PATH:");
			for (i = 0; i < elp; ++i) {
//				printf (" (%d-%d)", buf[elist[i]^1].to, buf[elist[i]].to);
				buf[elist[i]    ].rd = 0;
				buf[elist[i] ^ 1].rd = 1;
			}
//			puts ("");
		}
	}
	return mf;
}

std::string names[32][32];

std::string &fix (std::string &a) {
	a[0] = toupper (a[0]);
	for (unsigned i = 1; i < a.size (); ++i)
		a[i] = tolower (a[i]);
	return a;
}

int main () {
	//freopen ("b.in", "r", stdin);

	int _tc;
	static char __buf[1024];
	scanf ("%d", &_tc);
	source = 26 + 26;
	sink = source + 1;
	rN = sink + 1;
	for (int tc = 1; tc <= _tc; ++tc) {
		scanf ("%d", &N);
//		printf ("SIZE %d\n", N);
		int n;
		clear_graph ();
		for (int i = 0; i < 26; ++i)
			for (int j = 0; j < 26; ++j)
				names[i][j] = std::string ();

		for (int i = 0; i < N; ++i) {
			scanf ("%d", &n);
//			printf ("\tssize %d\n", n);
			for (int j = 0; j < n; ++j) {
				scanf ("%s", __buf);
//				printf ("name __%s__ in names %d %d\n", __buf, i, tolower (__buf[0]) - 'a');
				names[i][tolower (__buf[0]) - 'a'] = fix (std::string (__buf));
				add_edge (i, tolower (__buf[0]) - 'a' + 26);
			}
		}
		for (int i = 0; i < N; ++i)
			add_edge (source, i);
		for (int i = 0; i < N; ++i)
			add_edge (i + 26, sink);
		int mf = dinitz ();
		printf ("Case #%d:\n", tc);
		for (int i = 0; i < N; ++i)
			for (int j = vec[i + 26]; j != -1; j = buf[j].next)
				if (buf[j].to < 26 && buf[j^1].rd == 0) {
					printf ("%s", names[buf[j].to][buf[j^1].to - 26].c_str());
//					printf (" %d", buf[j].to);
					puts ("");
				}
	}

	return 0;
}
