/*
NOTE: computes center of circle given 3 points on the circumference
(b + c) / 2 + bc.rot * ((ab . ac) / (2 * (ab x ac)))
*/
#include <cstdio>
#include <cmath>

struct pnt {
	double x, y;
	pnt () {}
	pnt (double _x, double _y) : x (_x), y (_y) {}
	
	pnt operator + (const pnt &a) const {return pnt (x + a.x, y + a.y);}
	pnt operator - (const pnt &a) const {return pnt (x - a.x, y - a.y);}
	pnt operator * (double a) const {return pnt (x * a, y * a);}
	pnt operator / (double a) const {return pnt (x / a, y / a);}

	double operator * (const pnt &a) const {return x * a.x + y * a.y;}
	double dst (const pnt &a) const {return hypot (x - a.x, y - a.y);}
	double dst2 (const pnt &a) const {return (a - *this) * (a - *this);}
	double cross (const pnt &a) const {return x * a.y - y * a.x;}
	pnt rot () const {return pnt (-y, x);}
};

int main () {
	pnt a, b, c;
	scanf ("%lf %lf %lf %lf %lf %lf", &a.x, &a.y, &b.x, &b.y, &c.x, &c.y);

//	pnt cen = (b + c) / 2. + (c - b).rot () * (((b - a) * (c - a)) / (b - a).cross (c - a)) / 2.;
	pnt cen = b + (c - b) / 2. + (c - b).rot () * ((2 * (a * (b - a)) + a.dst2 (b) - 2 * (b * (b - a)) - (c - b) * (b - a)) / (2 * ((b - a) * (b - c))));
	
	printf ("%lf %lf %lf\n", a.dst (cen), b.dst (cen), c.dst (cen));
	printf ("%lf %lf\n", cen.x, cen.y);

	return 0;
}
