/*
TASK: given a sequence of N (N < 100 000) positive integers return the maximum value of the
expression
			i < q       i < q
		   ___
		   \    a   *  min    a        for every value of 1 <= p, q <= N
		   /     i     i = p   i
		   ---
			i = p
*/

#include <cstdio>

const int MAXN = 1 << 17;

struct node {
	int num;
	int idx;
	node *left, *right, *prev;
	node () {}
	node (int _num, int _idx, node *_left, node *_right, node *_prev) : num (_num), idx (_idx), left (_left), right (_right), prev (_prev) {}
};

int N;

int seq[MAXN];
int sum[MAXN];

node *root;

void build_tree () {
	root = new node (0, -1, 0, 0, 0);//buffer node

	node *crnt = root;
	node *tmp;

	for (int i = 0; i < N; ++i) {
		if (seq[i] >= crnt->num) {
			tmp = new node (seq[i], i, 0, 0, crnt);
			crnt->right = tmp;
			crnt = tmp;
		} else {
			do crnt = crnt->prev; while (crnt->num > seq[i]);
			tmp = new node (seq[i], i, crnt->right, 0, crnt);
			crnt->right = tmp;
			crnt = tmp;
		}
	}
}

int _sum (int lb, int ub) {
	return sum[ub - 1] - (lb != -1 ? sum[lb] : 0);
}

int best = 0;
int blb, bub;

void dfs (node *v, int lb, int ub) {
	if (!v) return;
	if (best < _sum (lb, ub) * v->num) {
		best = _sum (lb, ub) * v->num;
		blb = lb;
		bub = ub;
	}

	dfs (v->left, lb, v->idx);
	dfs (v->right, v->idx, ub);
}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d", seq + i);

	sum[0] = seq[0];
	for (i = 1; i < N; ++i)
		sum[i] = sum[i - 1] + seq[i];

	build_tree ();

	dfs (root, -1, N);

	printf ("%d %d %d\n", best, blb, bub);

	return 0;
}
