/*
TASK: Find the biggest palindrome in a large string
*/
/*
checks: the maxn, mod, b
if the imput is too small - complications??
*/
#include <cstdio>

const int MAXN = 1 << 20;
const int MOD = 9999;
const int B = 26;//consider only lower case letters

int conv (char a) {//returns a unique value from 0 to B-1
	return a - 'a';//we said we will consider lowercase letters only. If different needed change this as well as B
}

int N;
int vec[MAXN];
int pre[MAXN];
int base;
int nh, rh;//normal/reversed hash
int nf, ns, rf, rs;//normal/reversec first/second

inline int mymod (int a) {
	if (a < 0)
		return MOD - (-a) % MOD;
	else
		return a % MOD;
}

void nmove () {
	nh *= B; nh = mymod (nh);
	nh -= vec[nf] * pre[base + ns - nf]; nh = mymod (nh);
	nh += vec[ns] * pre[base]; nh = mymod (nh);
	nh *= B; nh = mymod (nh);
	++nf; ++ns;
//	printf ("nm %d\n", nh);
}

void nadd () {
	nh *= B; nh = mymod (nh);
	nh += vec[ns] * pre[base]; nh = mymod (nh);
	++ns;
//	printf ("na %d\n", nh);
}

void rmove () {
	rh += vec[rf + 1] * pre[base + rf - rs] - vec[rs + 1] * pre[base]; rh = mymod (rh);
	++rf; ++rs;
//	printf ("rm %d\n", rh);
}

void radd () {
	rh *= B; rh = mymod (rh);
	rh += vec[rs] * pre[base]; rh = mymod (rh);
	--rs;
//	printf ("ra %d\n", rh);
}

int best =0;
int bstart;

void expand () {
//	printf ("expand %d %d\n", rs + 1, ns);
	while (ns < N && rs >= 0 && vec[ns] == vec[rs]) {
		nadd ();
		radd ();
	}
	if (best < ns - rs - 1) {
		best = ns - rs - 1;
		bstart = rs + 1;
	}
//	printf ("expand over %d %d\n", rs + 1, ns);
}

bool move () {
//	printf ("move %d %d\n", rs + 1, ns);
	while (ns < N) {
		nmove ();
		rmove ();
		if (nh == rh) {/*printf ("move over %d %d\n", rs + 1, ns); */return 1;}
		++base;
	}
//	printf ("move over %d %d\n", rs + 1, ns);
	return 0;
}

int main () {
	char buf[MAXN];
	fgets (buf, MAXN, stdin);//safer than gets

	int i;
	for (i = 0; buf[i] != '\n'; ++i)
		vec[i] = conv (buf[i]);
	N = i;

	pre[0] = 1;
	for (i = 1; i < N; ++i)
		pre[i] = mymod (pre[i - 1] * B);

	//now search for 2 equal consecutive numbers
	for (i = 1; i < N && vec[i] != vec[i - 1]; ++i);

	if (i != N) {
		nf = i;
		ns = i + 1;
		rf = i - 1;
		rs = i - 2;
		base = 0;
		nh = vec[i];
		rh = vec[i - 1];

		do
			expand ();
		while (move ());
	}

	for (i = 2; i < N && vec[i] != vec[i-2]; ++i);

	if (i != N) {
		nf = i;
		ns = i + 1;
		rf = i - 2;
		rs = i - 3;
		base = 0;
		nh = vec[i];
		rh = vec[i - 2];

		do
			expand ();
		while (move ());
	}

	printf ("%d %d\n", best, bstart);

	return 0;
}
