/*
FROM: IOI 2006 day 0
PROB: cutting
KEYW: dynamical programming with full optimization of the inner cycle using a queue
NOTE: see also batch, euro
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 13;
const int MAXM = 1 << 13;
const int MAXT = 1 << 10;//max turns
const int MAXB = 1 << 13;//max 'stairs' or black squares
const int INF = 1000000000;

int N, M, T;
bool grid[MAXN][MAXM];
bool dp2[MAXN][MAXM];
int dp[MAXT][MAXB];

int C;
int x[MAXN], y[MAXN];

int _lvl;
int f (int a, int b) {
	int ch = dp[_lvl][b] - dp[_lvl][a];
	int zn = y[b] - y[a];
	int pos = std::lower_bound (x, x + C, ch / zn) - x;
	if (x[pos] * zn < ch) ++pos;
	return pos;
}

int queue[MAXB], p1, p2;

int ans;

void solve () {
	static 	int i, j;
	for (i = 1; i <= N; ++i) for (j = 1; j <= M; ++j) dp2[i][j] = dp2[i-1][j] || dp2[i][j-1] || grid[i][j];
/*
	printf ("--grid--\n");
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= M; ++j) {
			putchar (grid[i][j] ? '#' : '.');
			putchar (' ');
		}
		putchar ('\n');
	}

	printf ("----dp2---\n");
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= M + 1; ++j) {
			putchar (dp2[i][j] ? '#' : ' ');
			putchar (' ');
		}
		putchar ('\n');
	}
	putchar ('\n');	putchar ('\n');
*/
	i = N, j = 1;
	C = 0;
	while (i)
		if (dp2[i][j]) --i;
		else if (dp2[i][++j]) {
			x[C] = i;
			y[C++] = j-1;
		}

//	for (i = 0; i < C; ++i) printf ("(%d %d)", x[i], y[i]); printf ("\n");
	for (i = 0; i <= T; ++i)
		for (j = 0; j < C; ++j)
			dp[i][j] = -INF;

	if (x[0] == N) {
		dp[0][0] = x[0] * y[0];
		dp[1][0] = -INF;
		ans >?= dp[0][0];
		if (T && y[C-1] == M) ans >?= dp[0][0] + (M - y[0]) * x[C-1];
	} else {
		dp[0][0] = -INF;
		dp[1][0] = x[0] * y[0];
		if (T) ans >?= dp[1][0];
		if (T >= 2 && y[C-1] == M) ans >?= dp[1][0] + (M - y[0]) * x [C-1];
	}

	for (i = 1; i < C; ++i) {
		dp[0][i] = -INF;
		dp[1][i] = x[i] * y[i];
		if (T) ans >?= dp[1][i];
		if (T >= 2 && y[C-1] == M) ans >?= dp[1][i] + (M - y[i]) * x [C-1];
	}

	for (_lvl = 0, i = 2; i <= T; ++_lvl, ++i) {
		p1 = p2 = 0;
//		printf ("i == %d\n", i);
		for (j = 0; dp[_lvl][j] == -INF && j < C; ++j); //printf ("dp[%d][%d] == -INF\n", _lvl, j);

		if (j == C) {/*printf ("now break\n");*/ continue;}//no more
		queue[p2++] = j;
		for (++j; j < C; ++j) {
			if (p2 - p1 >= 2 && f (queue[p1], queue[p1+1]) <= j) ++p1;
			if (dp[_lvl][queue[p1]] != -INF)
				dp[i][j] = dp[_lvl][queue[p1]] + (y[j] - y[queue[p1]]) * x[j];

			ans >?= dp[i][j];
			if (i < T && y[C-1] == M) ans >?= dp[i][j] + (M - y[j]) * x[C-1];

			queue[p2++] = j;
			while (p2 - p1 >= 3 && f (queue[p2-2], queue[p2-1]) >= f (queue[p2-3], queue[p2-2])) {
				queue[p2-2] = queue[p2-1];
				--p2;
			}
//			printf ("dp[%d][%d] == %d(tried from dp[%d][%d])\n", i, j, dp[i][j], _lvl, queue[p1]);
		}
	}
}

void swap_all () {
	int i, j;
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j) {
			if ((i-1) * M + (j-1) >= M * N / 2) return;
			std::swap (grid[i][j], grid[N+1-i][M+1-j]);
		}
}

int main () {
	scanf ("%d %d %d", &M, &N, &T);

	int i, j;
	int tmp;
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j) {
			scanf ("%d", &tmp);
			grid[i][j] = tmp;
		}

	for (i = 0; i <= N; ++i) dp2[i][M+1] = 1;//walls

	solve ();
//	printf ("--ans %d\n", ans);
//	#warning fix this!
	memset (dp2, 0, sizeof (dp2));
	swap_all ();
	for (i = 0; i <= N; ++i) dp2[i][M+1] = 1;//walls
	solve ();

	printf ("%d\n", ans);

	return 0;
}
