/*
FROM: IOI 2006 day 0
PROB: cutting
KEYW: dynamical programming with full optimization of the inner cycle using a queue
NOTE: see also batch, euro
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 13;
const int MAXM = 1 << 13;
const int MAXT = 1 << 10;//max turns
const int MAXB = 1 << 13;//max 'stairs' or black squares
const int INF = 1000000000;

int N, M, T;
bool grid[MAXN][MAXM];
bool dp2[MAXN][MAXM];
int dp[MAXT][MAXB];
int prev[MAXT][MAXB];

int C;
int x[MAXN], y[MAXN];

int _lvl;
int f (int a, int b) {
	int ch = dp[_lvl][b] - dp[_lvl][a];
	int zn = y[b] - y[a];
	int pos = std::lower_bound (x, x + C, ch / zn) - x;
	if (x[pos] * zn < ch) ++pos;
	return pos;
}

int queue[MAXB], p1, p2;

int ans;

void solve () {
	static 	int i, j;

	scanf ("%d %d %d %d", &N, &M, &T, &C);
	for (i = 0; i < C; ++i)
		scanf ("%d %d", x + i, y + i);

//	for (i = 0; i < C; ++i) printf ("(%d %d)", x[i], y[i]); printf ("\n");
	for (i = 0; i <= T; ++i)
		for (j = 0; j < C; ++j)
			dp[i][j] = -INF;

	if (x[0] == N) {
		dp[0][0] = x[0] * y[0];
		dp[1][0] = -INF;
		ans >?= dp[0][0];
		if (T && y[C-1] == M) ans >?= dp[0][0] + (M - y[0]) * x[C-1];
	} else {
		dp[0][0] = -INF;
		dp[1][0] = x[0] * y[0];
		if (T) ans >?= dp[1][0];
		if (T >= 2 && y[C-1] == M) ans >?= dp[1][0] + (M - y[0]) * x [C-1];
	}

	for (i = 1; i < C; ++i) {
		dp[0][i] = -INF;
		dp[1][i] = x[i] * y[i];
		if (T) ans >?= dp[1][i];
		if (T >= 2 && y[C-1] == M) ans >?= dp[1][i] + (M - y[i]) * x [C-1];
	}

	for (_lvl = 0, i = 2; i <= T; ++_lvl, ++i) {
		prev[i][0] = 0;
		for (j = 1; j < C; ++j) {
			for (int k = prev[i][j-1]; k < j; ++k)
				if (dp[_lvl][k] != -INF && dp[i][j] < dp[_lvl][k] + (y[j] - y[k]) * x[j]) {
					dp[i][j] = dp[_lvl][k] + (y[j] - y[k]) * x[j];
					prev[i][j] = k;
				}

//			if (dp[i][j] != -INF) printf ("dp[%d][%d] == %d, from dp[%d][%d]\n", i, j, dp[i][j], _lvl, prev[i][j]);
			ans >?= dp[i][j];
			if (i < T && y[C-1] == M) ans >?= dp[i][j] + (M - y[j]) * x[C-1];
		}
	}
}

void swap_all () {
	int i, j;
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j) {
			if ((i-1) * M + (j-1) >= M * N / 2) return;
			std::swap (grid[i][j], grid[N+1-i][M+1-j]);
		}
}

int main () {
	solve ();
	printf ("%d\n", ans);

	return 0;
}
