/*
FROM: IOI 2006 day 0
PROB: cutting
KEYW: dynamical programming with full optimization of the inner cycle using a queue and a precomputing to remove the log
NOTE: see also batch, euro
*/

#include <cstdio>
#include <cassert>
#include <algorithm>

const int MAXN = 1 << 13;
const int MAXM = 1 << 13;
const int MAXT = 1 << 10;//max turns
const int MAXB = 1 << 13;//max 'stairs' or black squares
const int INF = 1000000000;

int N, M, T;
bool grid[MAXN][MAXM];
bool dp2[MAXN][MAXM];
int dp[MAXT][MAXB];

int C;
int x[MAXB], y[MAXB];

int pre[MAXN];
int my_funk (int a) {
	if (a > N) return C;
	if (a < 0) return 0;
//	printf ("pre[%d] == %d\n", a, pre[a]);
	return pre[a];
}

int _lvl;
int f (int a, int b) {
	assert (a != b);
	int ch = dp[_lvl][b] - dp[_lvl][a];
	int zn = y[b] - y[a];
	if (ch < 0) return C;
	int pos = my_funk (ch / zn);
	return pos;
}

int queue[MAXB], p1, p2;
int ans;

void solve () {
	static int i, j;
	for (i = 1; i <= N; ++i) for (j = 1; j <= M; ++j) dp2[i][j] = dp2[i-1][j] || dp2[i][j-1] || grid[i][j];

	i = N, j = 1;
	C = 0;
	while (i)
		if (dp2[i][j]) --i;
		else if (dp2[i][++j]) {
			x[C] = i;
			y[C++] = j-1;
		}

	x[C] = 0;
	int cp = C;
	for (i = 0; i <= N && cp; ++i) {
		if (x[cp-1] == i) --cp;
		pre[i] = cp;
	}
	for (; i <= N; ++i) pre[i] = 0;

//	for (i = 0; i < C; ++i) printf ("(%d %d)", x[i], y[i]); printf ("\n");
	if (C == 0) return;
	for (i = 0; i <= T; ++i)
		for (j = 0; j < C; ++j)
			dp[i][j] = -INF;

	if (x[0] == N) {
		dp[0][0] = x[0] * y[0];
		dp[1][0] = -INF;
		ans >?= dp[0][0];
		if (T && y[C-1] == M) {
			ans >?= dp[0][0] + (M - y[0]) * x[C-1];
		}
	} else {
		dp[0][0] = -INF;
		dp[1][0] = x[0] * y[0];
		if (T) ans >?= dp[1][0];
		if (T >= 2 && y[C-1] == M) ans >?= dp[1][0] + (M - y[0]) * x [C-1];
	}

	for (i = 1; i < C; ++i) {
		dp[0][i] = -INF;
		dp[1][i] = x[i] * y[i];
		if (T) ans >?= dp[1][i];
		if (T >= 2 && y[C-1] == M) ans >?= dp[1][i] + (M - y[i]) * x [C-1];
	}

	for (_lvl = 0, i = 2; i <= T; ++_lvl, ++i) {
		p1 = p2 = 0;
		for (j = 0; dp[_lvl][j] == -INF && j < C; ++j);
		if (j == C) continue;
		queue[p2++] = j;
		for (++j; j < C; ++j) {
			if (p2 - p1 >= 2 && f (queue[p1], queue[p1+1]) <= j) ++p1;

			dp[i][j] = dp[_lvl][queue[p1]] + (y[j] - y[queue[p1]]) * x[j];

			ans >?= dp[i][j];
			if (i < T && y[C-1] == M) ans >?= dp[i][j] + (M - y[j]) * x[C-1];

			if (dp[_lvl][queue[p2-1]] < dp[_lvl][j]) {
				queue[p2++] = j;
				while (p2 - p1 >= 3 && f (queue[p2-3], queue[p2-2]) >= f (queue[p2-2], queue[p2-1])) {
					queue[p2-2] = queue[p2-1];
					--p2;
				}
			}
		}
	}
}
void swap_all () {
	int i, j;
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j) {
			if ((i-1) * M + (j-1) >= M * N / 2) return;
			std::swap (grid[i][j], grid[N+1-i][M+1-j]);
		}
}

int main () {
	scanf ("%d %d %d\n", &M, &N, &T);

	int i, j;
	int tmp;
	static char line[1 << 14];
	for (i = 1; i <= N; ++i) {
		gets (line);
		for (j = 0; j < M;) {
			tmp = line[(j<<1)];
			grid[i][++j] = tmp == '1';
		}
	}

	for (i = 0; i <= N; ++i) dp2[i][M+1] = 1;//walls

	solve ();
	memset (dp2, 0, sizeof (dp2));
	swap_all ();
	for (i = 0; i <= N; ++i) dp2[i][M+1] = 1;//walls
	solve ();

	printf ("%d\n", ans);

	return 0;
}
