/*
FROM: IOI 2006 day 0
PROB: cutting
KEYW: dynamical programming with full optimization of the inner cycle using a queue and a precomputing to remove the log
NOTE: this is a generator
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>

int N, M, T;
int pc;

int main (int argc, char *argv[]) {
	assert (argc == 6);
	FILE *out = fopen (argv[1], "w");
	assert (out);
	sscanf (argv[2], "%d", &N);
	sscanf (argv[3], "%d", &M);
	sscanf (argv[4], "%d", &T);
	sscanf (argv[5], "%d", &pc);

	assert (N <= 5000 && M <= 5000 && T <= 5000);
	assert (pc >= 0 && pc <= 100);

	srand (time (0));

	fprintf (out, "%d %d %d\n", M, N, T);
	for (int i = 0; i < N; ++i) {
		fprintf (out, "%d", rand () % ((M + N) * 100) < pc * i);
		for (int j = 1; j < M; ++j)
			fprintf (out, " %d", rand () % ((M + N) * 100) < pc * (i + j));
		fprintf (out, "\n");
	}
	fclose (out);

	return 0;
}
