/*
FROM: IOI 2006 day 0
PROB: cutting
KEYW: dynamical programming with full optimization of the inner cycle using a queue
NOTE: this is a generator
*/

#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <algorithm>

int N, M, T, S;

bool cmp (int a, int b) {return a > b;}

int main (int argc, char *argv[]) {
	assert (argc == 6);
	FILE *out = fopen (argv[1], "w");
	assert (out);

	sscanf (argv[2], "%d", &N);
	sscanf (argv[3], "%d", &M);
	sscanf (argv[4], "%d", &T);
	sscanf (argv[5], "%d", &S);

	assert (S <= N && S <= M);

	srand (time (0));
	static int tmp1[1 << 13], tmp2[1 << 13], i;
	for (i = 0; i < N; ++i) tmp1[i] = i + 1;
	for (i = 0; i < M; ++i) tmp2[i] = i + 1;
	std::random_shuffle (tmp1, tmp1 + N);
	std::sort (tmp1, tmp1 + S, cmp);
	std::random_shuffle (tmp2, tmp2 + M);
	std::sort (tmp2, tmp2 + S);

	fprintf (out, "%d %d %d %d\n", N, M, T, S);
	for (i = 0; i < S; ++i)
		fprintf (out, "%d %d\n", tmp1[i], tmp2[i]);
	fclose (out);

	return 0;
}
