/*
TASK: euro
LANG: C++

FROM: BOI 2003 day 2
PROB: euro
KEYW: dynamical programming with full optimization of the inner cycle using a queue
NOTE: see also Batch
*/

#include <cstdio>
#include <cassert>
#include <climits>
#include <algorithm>

const int MAXN = 1 << 16;

int N, T;
int inp[MAXN];
int a[MAXN];
int s[MAXN];
int c[MAXN];
int q[MAXN], p1, p2;
long long dp[MAXN];

int f (int a, int b) {
	long long ch = -(dp[b] - dp[a]);
	long long zn = -(s[b] - s[a]);
	long long srch = ch / zn;
	int p = std::lower_bound (c, c + N, srch) - c;
	if (c[p] * zn < ch) ++p;
	return p;
}

int main () {
	scanf ("%d %d", &N, &T);

	int i;
	for (i = 0; i < N; ++i) scanf ("%d", inp + i);

	int cp = 1;
	for (i = 0; i < N; ++i)
		if ((a[cp] += inp[i]) < 0)
			c[cp++] = i + 1;

	if (c[cp-1] == N)
		N = cp;
	else {
		c[cp] = N;
		N = ++cp;
	}

	for (s[0] = a[0], i = 1; i < N; ++i) s[i] = s[i-1] + a[i];

//	for (i = 1; i < N; ++i) printf ("(%d %d %d)", a[i], c[i], s[i]); printf ("\n");

	if (N == 2) {
		printf ("%Ld\n", (long long)c[N-1] * (long long)a[N-1] - (long long)T);
		return 0;
	}

	q[p2++] = 0;
	q[p2++] = 1;

	dp[0] = 0;
	dp[1] = (long long)a[1] * (long long)c[1] - (long long) T;
	for (i = 2; i < N-1; ++i) {
		assert (p2 - p1 >= 2);
		if (f (q[p1], q[p1+1]) <= i) ++p1;//pop from the begining

		dp[i] = dp[q[p1]] + (long long)(s[i] - s[q[p1]]) * (long long)c[i] - (long long)T;

		q[p2++] = i;
		while (p2 - p1 >= 3 && f (q[p2-2], q[p2-1]) <= f (q[p2-3], q[p2-2])) {//pop from the back
			q[p2-2] = q[p2-1];
			--p2;
		}
	}

	long long res = LONG_LONG_MIN;
	for (i = 1; i < N-1; ++i)
		res >?= dp[i] + (long long)(s[N-1] - s[i]) * (long long)c[N-1] - (long long)T;

	printf ("%Ld\n", res);

	return 0;
}
