/*
NOTE: this is a pure implementation of a suffix array
INPUT: string with len <= 1 000 000
*/

#include <cstdio>
#include <cstring>
#include <algorithm>

const int MAXLEN = 1 << 20;

int N;
char s[MAXLEN];
int a[MAXLEN];
int ref[MAXLEN];
int nref[MAXLEN];

bool cmp1 (int a, int b) {return s[a] < s[b];}

int dif;
bool cmp (int a, int b) {
	if (ref[a] != ref[b]) return ref[a] < ref[b];
	if (b + dif >= N) return 0;
	if (a + dif >= N) return 1;
	return ref[a+dif] < ref[b+dif];
}

int main () {
	gets (s);

	int i;
	for (N = 0; s[N]; ++N) a[N] = N;

	std::sort (a, a + N, cmp1);

	for (ref[a[0]] = 0, i = 1; i < N; ++i) ref[a[i]] = cmp1 (a[i-1], a[i]) + ref[a[i-1]];

	for (dif = 1; dif < N; dif *= 2) {
		std::sort (a, a + N, cmp);
		for (nref[a[0]] = 0, i = 1; i < N; ++i) nref[a[i]] = cmp (a[i-1], a[i]) + nref[a[i-1]];
		memcpy (ref, nref, sizeof (ref));
	}

	for (i = 0; i < N; ++i) puts (s + a[i]);
	return 0;
}
