/*
FROM: Balkan Olympiad in Informatics (BOI) 1997 day 2
PROB: street network
KEYW: euler cycle, dfs, matrix multiplication
*/

#include <cstdio>
#include <cstring>
#include <algorithm>

const int MAXN = 1 << 6;

int N, S;
int ma3x[MAXN][MAXN];
int cma3x[MAXN][MAXN];
int sumr[MAXN], sumc[MAXN];
bool used[MAXN];

void dfs (int a) {
	used[a] = 1;
	for (int i = 0; i < N; ++i)
		if (ma3x[a][i] && !used[i])
			dfs (i);
}

void ma3x_mul () {
	static int ma3x2[MAXN][MAXN];
	static int i, j, k;
	memcpy (ma3x2, cma3x, sizeof (ma3x2));
	memset (cma3x, 0, sizeof (cma3x));

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			for (k = 0; k < N; ++k)
				cma3x[i][j] += ma3x2[i][k] * ma3x[k][j];
}

int main () {
	scanf ("%d %d", &N, &S);

	int i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			scanf ("%d", &ma3x[i][j]);
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			sumr[i] += ma3x[i][j];
			sumc[j] += ma3x[i][j];
		}

	for (i = 0; i < N && !sumr[i]; ++i);
	if (i == N) {//no edges - 
		printf ("YES\n%d\n0", N);//we can traverse all edges from any given point (since there are no edges)
		for (i = 1; i < N; ++i) printf (" 0");
		puts ("");
	} else {
		dfs (i);
		int ucnt = 0;
		for (i = 0; i < N; ++i) {
			if (used[i])
				++ucnt;
			else if (sumr[i]) break;//answer NO to the first q
		}
		if (i != N) {//we have breaked
			printf ("NO\n");
		} else {
			int outc = 0, norm = 0, inc = 0;
			for (i = 0; i < N; ++i) {
				if (!used[i]) continue;
				switch (sumr[i] - sumc[i]) {
					case -1: ++outc; break;
					case 0: ++norm; break;
					case 1: ++inc; break;
					default: goto after_i;
				}
			}
			after_i:;
			if (i != N) printf ("NO\n");//the input/output degrees are not all correct
			else if (norm == ucnt)
				printf ("YES\n%d\n", ucnt);
			else if (outc == 1 && inc == 1)
				printf ("YES\n%d\n", 1);
			else printf ("NO\n");
		}
	}

	memcpy (cma3x, ma3x, sizeof (ma3x));
	for (i = 2; i <= S; ++i) {
		ma3x_mul ();
/*		for (int i = 0; i < N; ++i) {
			for (int j = 0; j < N; ++j)
				printf ("%d ", ma3x[i][j]);
			puts ("");
		}
		puts ("");*/
	}

	static int ans[MAXN];
	for (i = 0; i < N; ++i)
		ans[i] = cma3x[i][i];

	std::sort (ans, ans + N);
	printf ("%d", ans[0]);
	for (i = 1; i < N; ++i) printf (" %d", ans[i]);
	puts ("");

	return 0;
}
