/*
FROM: Balkan Olympiad in Informatics (BOI) 1997 day 1
PROB: tasks execution
KEYW: topological sort, dynamical programming, greedy, binary search
*/

#include <cstdio>
#include <cstring>
#include <algorithm>

const int MAXN = 1 << 8;

int N, M;
int ma3x[MAXN][MAXN];

int used[MAXN];
int ts[MAXN], tsp;
int lb[MAXN], ub[MAXN];
int min_time;

void dfs_ts (int a) {
	used[a] = 1;
	for (int i = 0; i < N; ++i)
		if (ma3x[a][i] && !used[i])
			dfs_ts (i);
	ts[tsp++] = a;
}

int idx[MAXN];
bool cmp (int a, int b) {
	return ub[a] == ub[b] ? lb[a] < lb[b] : ub[a] < ub[b];
}

bool can_do_it (int pc) {
//	printf ("------------- %d\n", pc);
	int i, j, kk, k, l;
	memset (used, -1, sizeof (used));
	for (i = 0; i <= min_time; ++i)
		for (j = 0; j < pc; ++j)
			for (kk = 0; kk < N; ++kk) {
				k = idx[kk];
				if (used[k] != -1) continue;
//				printf ("try to put %d %d %d to %d %d\n", k, lb[k], ub[k], i, j);
				for (l = 0; l < N; ++l)
					if (ma3x[k][l]
					 && (used[l] == -1
					  || used[l] == i))
						break;
//				printf ("l == %d\n", l);
				if (l == N) {
//					printf ("PUT!\n");
					used[k] = i;
					break;//increase j
				}
			}
	for (i = 0; i < N; ++i) if (used[i] == -1) return 0;
	return 1;
}

int main () {
	scanf ("%d %d", &N, &M);

	int i, j;
	int a, b;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		ma3x[b][a] = 1;
	}

	for (i = 0; i < N; ++i)
		if (!used[i]) dfs_ts (i);

	min_time = 0;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			if (ma3x[ts[i]][j])
				lb[ts[i]] >?= lb[j] + 1;
		min_time >?= lb[ts[i]];
	}

	for (i = 0; i < N; ++i) ub[i] = min_time;
	for (i = N-1; i >= 0; --i) {
		for (j = 0; j < N; ++j)
			if (ma3x[ts[i]][j])
				ub[j] <?= ub[ts[i]] - 1;
	}

//	for (i = 0; i < N; ++i) printf ("%d -- %d %d\n", i, lb[i], ub[i]);
/*	for (i = 0; i < N; ++i) idx[i] = i;
	std::sort (idx, idx + N, cmp);

	int l = 0, r = N, m;

	while (l + 1 < r) {
		m = (l + r) / 2;
		if (can_do_it (m))
			r = m;
		else
			l = m;
	}*/

	printf ("%d %d\n", min_time + 1, N / (min_time + 1) + !!(N % (min_time + 1)));

	return 0;
}
