/*
FROM: Balkan Olympiad in Informatics (BOI) 1998 day 2
PROB: evil eye (eye)
KEYW: bfs
*/

#include <cstdio>
#include <cstring>
#include <cassert>
#include <algorithm>

const int MAXN = 1 << 8;
const int MAXM = 1 << 16;
const int BASE = 1 << 20;

struct el {
	int to;
	int dist;
	int next;
	el () {}
	el (int _to, int _dist, int _next) : to (_to), dist (_dist), next (_next) {}
};

int N, M;
int vec[MAXN];
el buf[MAXM * 2];

int lvl[MAXN];

void bfs () {
	static int q[MAXN], p3;
	int i, j;
	memset (lvl, -1, sizeof (lvl));//not visited

	lvl[0] = BASE;
	q[p3++] = 0;
	for (i = 0; i < p3; ++i) {
		for (j = vec[q[i]]; j != -1; j = buf[j].next) {
			if (lvl[buf[j].to] == -1) {
				lvl[buf[j].to] = lvl[q[i]] + buf[j].dist;
				q[p3++] = buf[j].to;
			} else
				assert (lvl[buf[j].to] == lvl[q[i]] + buf[j].dist);
		}
	}
}

bool cmp (int a, int b) {
	return lvl[a] < lvl[b];
}

int main () {
	scanf ("%d", &M);

	memset (vec, -1, sizeof (vec));
	int i;
	int a, b, c;
	int bp = 0;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", &a, &b, &c);
		N >?= a; N >?= b;
		--a; --b;

		buf[bp] = el (b, c, vec[a]);
		vec[a] = bp++;
		buf[bp] = el (a, -c, vec[b]);
		vec[b] = bp++;
	}

	bfs ();

	static int idx[MAXN];
	for (int i = 0; i < N; ++i) idx[i] = i;
	std::sort (idx, idx + N, cmp);
	printf ("%d", idx[0] + 1);
	for (i = 1; i < N; ++i)
		printf ("%c%d", lvl[idx[i]] == lvl[idx[i-1]] ? ' ' : '\n', idx[i] + 1);
	puts ("");

//	for (i = 0; i < N; ++i) printf (" %d" , lvl[i] - BASE); puts ("");

	return 0;
}
