/*
FROM: Balkan Olympiad in Informatics (BOI) 1998 day 1
PROB: maximal-sum subsequence
KEYW: dynamical programming
*/

#include <cstdio>
#include <utility>

const int MAXN = 1 << 6;
const int INF = 100000000;

int N;
int ma3x[MAXN][MAXN];

int best = -INF;
std::pair <int, int> ans[MAXN];
int ap;

int line[MAXN];
int bss[MAXN], bss_c, bss_s;

void find_best () {
	static int min, max, minb, maxb, sum;
	static int best_min, best_max, best_minb, best_maxb, best_mine, best_maxe;
	static int i;
	sum = line[0];
	best_min = best_max = min = max = line[0];
	best_mine = best_maxe = best_minb = best_maxb = minb = maxb = 0;

	for (i = 1; i < N; ++i) {
		sum += line[i];
		if (max > 0) {
			max += line[i];
		} else {
			max = line[i];
			maxb = i;
		}
		if (min < 0) {
			min += line[i];
		} else {
			min = line[i];
			minb = i;
		}
		if (max > best_max) best_max = max, best_maxb = maxb, best_maxe = i;
		if (min < best_min) best_min = min, best_minb = minb, best_maxe = i;
	}

	if (max >= sum - min) {
		bss_c = 0;
		bss_s = max;
		for (i = best_maxb; i <= best_maxe; ++i)
			bss[bss_c++] = i;
	} else {
		bss_c = 0;
		bss_s = sum - min;
		for (i = 0; i < best_minb; ++i)
			bss[bss_c++] = i;
		for (i = best_mine + 1; i < N; ++i)
			bss[bss_c++] = i;
	}
}

int main () {
	scanf ("%d", &N);

	int i, j, k;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			scanf ("%d", &ma3x[i][j]);

	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			line[j] = ma3x[i][j];
		find_best ();
		if (best < bss_s) {
			best = bss_s;
			ap = bss_c;
			for (k = 0; k < ap; ++k)
				ans[k] = std::make_pair (i, bss[k]);
		}
	}

	for (j = 0; j < N; ++j) {
		for (i = 0; i < N; ++i)
			line[i] = ma3x[i][j];
		find_best ();
		if (best < bss_s) {
			best = bss_s;
			ap = bss_c;
			for (k = 0; k < ap; ++k)
				ans[k] = std::make_pair (bss[k], j);
		}
	}

	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			line[j] = ma3x[(i+j) % N][j];
		find_best ();
		if (best < bss_s) {
			best = bss_s;
			ap = bss_c;
			for (k = 0; k < ap; ++k)
				ans[k] = std::make_pair ((i + bss[k]) % N, bss[k]);
		}
	}

	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			line[j] = ma3x[(i - j + N) % N][j];
		find_best ();
		if (best < bss_s) {
			best = bss_s;
			ap = bss_c;
			for (k = 0; k < ap; ++k)
				ans[k] = std::make_pair ((i - bss[k] + N) % N, bss[k]);
		}
	}

	printf ("%d %d\n", ap, best);
	for (i = 0; i < ap; ++i)
		printf ("%d %d\n", ans[i].first + 1, ans[i].second + 1);

	return 0;
}
