/*
FROM: Balkan Olympiad in Informatics (BOI) 1998 day 1
PROB: tough nut to crack
KEYW: interactive, binary search, optimizations
*/

#include <cstdio>
#include <cstdlib>
#include <algorithm>

#include "module_tnc.h"

const int MAXK = 1 << 7;

int K;
int sum;
int vec[MAXK];
int idx[MAXK];

bool make_ask (int l, int r) {
	static int buf[MAXK];
	for (int i = l; i < r; ++i)
		buf[i-l] = idx[i];
	return ask (r - l, buf);
}

void make_ans (int x) {
	ans (idx[x]);
}

bool cmp (int a, int b) {
//	printf ("cmp %d %d  %d %d\n", a, b, vec[a], vec[b]);
	return vec[a] > vec[b];
}

int eval (int psum, int asum) {
	return abs (asum - 2 * psum);
}

int main () {
	scanf ("%d", &K);
	int i, k;
	sum = 0;
	for (i = 0; i < K; ++i) {
		scanf ("%d", vec + i);
		sum += vec[i];
	}

	init (K, vec, sum);
//	printf ("%d__!!!!!!!!1\n", sum);

	for (i = 0; i < K; ++i) idx[i] = i;
	int l, r, m;
	int psum, csum;
//	for (i = 0; i < K; ++i) printf ("%d ", vec[i]); puts ("");
	for (; sum; --sum) {
//		printf ("befor sort!\n");
		std::sort (idx, idx + K, cmp);
//		printf ("after sort!\n");

		for (i = 0; i < K && vec[idx[i]]; ++i);
		l = 0, r = i;
//		printf ("sum == _%d__\n", sum);
		psum = sum;
//		printf ("new bsrch!  %d\n", psum);
//		for (i = 0; i < r; ++i) printf (" %d", vec[idx[i]]); puts ("");

		while (l + 1 < r) {
//			printf ("interval %d %d (%d)\n", l, r, psum);
			csum = vec[idx[l]];
			for (k = l + 1; k < r; ++k)
				if (eval (csum, psum) < eval (csum + vec[idx[k]], psum)) break;
				else {
					csum += vec[idx[k]];
//					printf ("\tcsum == %d (%d)\n", csum, eval (csum, psum));
				}

			m = k;
//			printf ("cut is %d(%d / %d) (%d %d %d)\n", m, m - l, r - l, csum, psum, eval (csum, psum));
			if (make_ask (l, m)) {
//				printf ("YES!\n");
				r = m;
				psum = csum;
			} else {
//				printf ("NO\n");
				l = m;
				psum = psum - csum;
			}
		}

		--vec[idx[l]];
		make_ans (l);
	}

	return 0;
}
