/*
FROM: Balkan Olympiad in Informatics (BOI) 1999 day 2
PROB: crime statistics
KEYW: point in convex polygon in log time
*/

#include <cstdio>

const int MAXN = 1 << 10;

struct pnt {
	int x, y;
	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}
};

int N, M;
pnt vec[MAXN];

int S (const pnt &a, const pnt &b, const pnt &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &vec[i].x, &vec[i].y);

	scanf ("%d", &M);
	int l, r, m;
	int res = 0;
	int coef = S (vec[0], vec[1], vec[2]);
	pnt c;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &c.x, &c.y);

		if (S (vec[0], vec[1], c) * coef < 0
		 || S (vec[N-1], vec[0], c) * coef < 0) continue;
		l = 1, r = N-1;
		while (l + 1 < r) {
			m = (l + r) / 2;
			if (S (vec[0], vec[m], c) * coef > 0)
				l = m;
			else
				r = m;
		}
		if (S (vec[l], vec[r], c) * coef >= 0) ++res;
	}

	printf ("%d\n", res);

	return 0;
}
