/*
FROM: Balkan Olympiad in Informatics (BOI) 2001 day 1
PROB: mosaic
KEYW: full exhaustion
*/

#include <cstdio>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 7;
const int MAXALL = MAXN * MAXN;

const int dx[] = {0, 1, 1, 1};
const int dy[] = {1, 1, 0, -1};
const int DIRS = sizeof (dx) / sizeof (dx[0]);

int oN, oM;
bool orig[MAXN][MAXN];
bool is_m[MAXN][MAXN];
std::pair <int, int> m_list[MAXALL];
bool wc[MAXALL];
int mlp;
int cN, cM;
bool copy[MAXN][MAXN];

bool in_brd (int x, int y, int d, int t) {
	static int nx, ny;
	nx = x + dx[d] * t;
	ny = y + dy[d] * t;
	return nx >= 0 && nx < oN && ny >= 0 && ny < oM;
}

int main () {
	scanf ("%d %d", &oN, &oM);

	int i, j;
	int t;
	for (i = 0; i < oN; ++i)
		for (j = 0; j < oM; ++j) {
			scanf ("%d", &t);
			orig[i][j] = t;
		}

	scanf ("%d %d", &cN, &cM);
	for (i = 0; i < cN; ++i)
		for (j = 0; j < cM; ++j) {
			scanf ("%d", &t);
			copy[i][j] = t;
		}

	int minx = MAXN, miny = MAXN;
	int maxx = -1, maxy = -1;
	int k, l;
	int last;
	for (i = 0; i < oN; ++i)
		for (j = 0; j < oM; ++j) {
			if (!orig[i][j]) continue;
			minx <?= i; maxx >?= i;
			miny <?= j; maxy >?= j;
			for (k = 0; k < DIRS; ++k) {
				last = 0;
				for (l = 1; in_brd (i, j, k, l); ++l)
					if (orig[i+dx[k]*l][j+dy[k]*l]) last = l;
				for (l = 0; l <= last; ++l)
					if (!is_m[i+dx[k]*l][j+dy[k]*l]) {
						is_m[i+dx[k]*l][j+dy[k]*l] = 1;
						m_list[mlp++] = std::make_pair (i + dx[k]*l, j + dy[k]*l);
					}
			}
		}
	maxx -= minx;
	maxy -= miny;

	for (i = 0; i < mlp; ++i) {
		m_list[i].first -= minx;
		m_list[i].second -= miny;
	}
	std::sort (m_list, m_list + mlp);

	for (i = 0; i < mlp; ++i)
		wc[i] = orig[m_list[i].first + minx][m_list[i].second + miny];
/*
	for (i = 0; i < mlp; ++i)
		printf ("%d %d -- %d\n", m_list[i].first, m_list[i].second, wc[i]);

	for (i = 0; i < oN; ++i) {
		for (j = 0; j < oM; ++j)
			putchar (is_m[i][j] ? '#' : '.');
		puts ("");
	}

	for (i = 0; i < cN; ++i) {
		for (j = 0; j < cM; ++j)
			putchar (copy[i][j] ? '#' : '.');
		puts ("");
	}
*/
	int ii, jj;
	for (ii = 0; ii + maxx < cN; ++ii)
		for (jj = 0; jj + maxy < cM; ++jj) {
//			printf ("%d %d\n", m_list[0].first + ii + 1, m_list[0].second + jj + 1);
			for (i = 0; i < mlp; ++i)
				if (copy[m_list[i].first + ii][m_list[i].second + jj] != wc[i])
					break;
//			printf ("\tbreaked %d -- copy[%d][%d] == wc[]  %d %d\n", i, m_list[i].first + ii, m_list[i].second + jj, copy[m_list[i].first + ii][m_list[i].second + jj], wc[i]);
			if (i == mlp) {
				printf ("YES\n%d %d\n", m_list[0].first + ii + 1, m_list[0].second + jj + 1);
				return 0;
			}
		}
	printf ("NO\n");

	return 0;
}
