/*
FROM: Balkan Olympiad in Informatics (BOI) 2001 day 1
PROB: secret
KEYW: interative, full exhaustion, random, bikove i kravi
*/

#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>

#include "mod_secret.h"

const int MAX = 1 << 14;
const int DIGS = 16;

void tell (int real, int guess, int &kr, int &bk) {
	static int cnt[DIGS];
	memset (cnt, 0, sizeof (cnt));
	kr = bk = 0;

	++cnt[real % 10];
	++cnt[real / 10 % 10];
	++cnt[real / 100 % 10];
	++cnt[real / 1000];

	if (cnt[guess % 10]) --cnt[guess % 10], ++kr;
	if (cnt[guess / 10 % 10]) --cnt[guess / 10 % 10], ++kr;
	if (cnt[guess / 100 % 10]) --cnt[guess / 100 % 10], ++kr;
	if (cnt[guess / 1000]) --cnt[guess / 1000], ++kr;

	if (real % 10 == guess % 10) --kr, ++bk;
	if (real / 10 % 10 == guess / 10 % 10) --kr, ++bk;
	if (real / 100 % 10 == guess / 100 % 10) --kr, ++bk;
	if (real / 1000 == guess / 1000) --kr, ++bk;

//	printf ("%d %d -- %d %d\n", real, guess, kr, bk);
}

bool in_set[MAX];
int set_cnt;

int main () {
	int i, guess;
	for (i = 1000; i < 10000; ++i) in_set[i] = 1;
	set_cnt = 9000;

	srand (time (0));
	int kr, bk;
	int kr2, bk2;
	while (set_cnt > 1) {
		guess = rand () % set_cnt;
		for (i = 1000; guess != -1; ++i)
			guess -= in_set[i];
		guess = i-1;
		showfit (guess, &kr, &bk);
//		printf ("guessing %d -- %d %d\n", guess, kr, bk);
		for (i = 1000; i < 10000; ++i) {
			if (in_set[i] && (tell (i, guess, kr2, bk2), (kr2 != kr || bk2 != bk))) {
//				printf ("\t%d %d   %d %d\n", kr, bk, kr2, bk2);
				in_set[i] = 0;
				--set_cnt;
			}/* else if (in_set[i])
				printf ("stay!!\n");*/
		}

//		printf ("left %d\n", set_cnt);
	}

	for (i = 1000; !in_set[i]; ++i);
	ans (i);

	return 0;
}
