/*
FROM: Balkan Olympiad in Informatics (BOI) 2001 day 2
PROB: voting
KEYW: strongly connected components, shortest path, floid
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 6;
const int INF = 1 << 29;

int N;
int ma3x[MAXN][MAXN];

int postnum[MAXN];
int pnref[MAXN];
int cg = -1;
int group[MAXN];

void dfs1 (int a) {
	static int cpn = 0;
	postnum[a] = -2;//it is not set yet but is is not free
	for (int i = 0; i < N; ++i)
		if (ma3x[a][i] && postnum[i] == -1)
			dfs1 (i);

	pnref[cpn] = a;
	postnum[a] = cpn++;
}

void dfs2 (int a) {
	group[a] = cg;
	for (int i = 0; i < N; ++i)
		if (ma3x[i][a] && group[i] == -1)
			dfs2 (i);
}

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			scanf ("%d", &ma3x[i][j]);

	memset (postnum, -1, sizeof (postnum));
	memset (group, -1, sizeof (group));

	for (i = 0; i < N; ++i)
		if (postnum[i] == -1)
			dfs1 (i);

	int k;
	int bsum, csum, bj;
	for (i = N-1; i >= 0; --i)
		if (group[pnref[i]] == -1) {
			++cg;
			dfs2 (pnref[i]);
		}

	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			if (!ma3x[i][j])
				ma3x[i][j] = INF;
		ma3x[i][i] = 0;
	}

	for (k = 0; k < N; ++k)
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j)
				ma3x[i][j] <?= ma3x[i][k] + ma3x[k][j];

	for (i = 0; i <= cg; ++i) {
		bsum = INF, bj = -1;
		for (j = 0; j < N; ++j) {
			if (group[j] != i) continue;
			csum = 0;
			for (k = 0; k < N; ++k) {
				if (group[k] != i || k == j) continue;
				csum += ma3x[k][j];
			}
			if (bsum > csum) {
				bsum = csum;
				bj = j;
			}
		}
		printf ("%d %d\n", bj + 1, bsum);
	}

	return 0;
}
