/*
FROM: Balkan Olympiad in Informatics (BOI) 2002 day 1
PROB: tour
KEYW: checker
*/

#include <cstdio>
#include <cassert>

const int MAXN = 1 << 10;

int N, K;
bool ma3x[MAXN][MAXN];

int main (int argc, char *argv[]) {
	assert (argc == 3);

	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");

	assert (in && out);

	fscanf (in, "%d %d", &N, &K);

	int i;
	int a, b;
	for (i = 0; i < N * (N-1) / 2; ++i) {
		fscanf (in, "%d %d", &a, &b);
		ma3x[--a][--b] = 1;
	}

	int prev, crnt, fst;
	fscanf (out, "%d", &prev);
	fst = prev;
	for (i = 1; i < K; ++i) {
		fscanf (out, "%d", &crnt);
		assert (ma3x[prev][crnt]);
		prev = crnt;
	}
	assert (ma3x[prev][fst]);
	printf ("seems ok!\n");

	return 0;
}
