/*
FROM: Balkan Olympiad in Informatics (BOI) 2002 day 2
PROB: old map (oldmap)
KEYW: double connected edge list (dcel)
NOTE: There is a case where the polygon found is not simple, because there is a point occuring 2 times, but the edges are occuring only once. There isn't a 'bad' test-case for this case either :)
*/

#include <cstdio>
#include <cmath>
#include <cassert>
#include <cstring>
#include <algorithm>

const int MAXN = 1 << 10;
const int MAXM = 1 << 20;

struct el {
	int to;
	int next;
};

int N, M, K;
int vec[MAXN];
el buf[MAXM * 2];
int coor[MAXN][2];

int next[MAXM * 2];

int to[MAXM * 2], id[MAXM * 2], idx[MAXM * 2];
int base_id;
bool cmp (int a, int b) {
	return atan2 (coor[to[a]][1] - coor[base_id][1], coor[to[a]][0] - coor[base_id][0])
		<  atan2 (coor[to[b]][1] - coor[base_id][1], coor[to[b]][0] - coor[base_id][0]);
}

int op (int a) {return a ^ 1;}

int group[MAXM * 2], grc, cgs;

int main () {
	scanf ("%d", &N);

	memset (vec, -1, sizeof (vec));
	int i, j;
	int d, t;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &coor[i][0], &coor[i][1]);
		scanf ("%d", &d);
		for (j = 0; j < d; ++j) {
			scanf ("%d", &t);
			--t;
			if (t > i) {
				buf[M] = (el) {t, vec[i]};
				vec[i] = M++;
				buf[M] = (el) {i, vec[t]};
				vec[t] = M++;
			}
		}
	}
	fprintf (stderr, "%d\n", M);

/*	for (i = 0; i < N; ++i) {
		printf ("%d -->", i);
		for (j = vec[i]; j != -1; j = buf[j].next)
			printf (" %d_%d", buf[j].to, j);
		puts ("");
	}
*/
	int p;
	for (i = 0; i < N; ++i) idx[i] = i;
	for (i = 0; i < N; ++i) {
		p = 0;
		for (j = vec[i]; j != -1; j = buf[j].next) {
			to[p] = buf[j].to;
			id[p] = j;
			++p;
		}
		base_id = i;
		for (j = 0; j < p; ++j) idx[j] = j;
		std::sort (idx, idx + p, cmp);
		idx[p] = idx[0];
/*		for (j = 0; j < p; ++j) printf (" %d", to[j]); puts ("");
		for (j = 0; j < p; ++j) printf (" %d", id[j]); puts ("");
		for (j = 0; j < p; ++j) printf (" %d", idx[j]); puts ("");
		puts ("---");*/
		for (j = 1; j <= p; ++j) {
//			printf ("next[ %d ] == %d\n", op (id[idx[j]]), id[idx[j-1]]);
			next[op (id[idx[j]])] = id[idx[j-1]];
		}
	}
/*	for (i = 0; i < N; ++i) printf ("%d %d\n", i, _cnt[i]);

	for (i = 0; i < M; ++i)
		printf ("edge %d (%d - %d) -- %d\n", i, buf[op (i)].to + 1, buf[i].to + 1, next[i]);
	printf ("%d\n", M);
*/
	int res = 0;
	bool invalid;
	int cS;
	scanf ("%d", &K);
	for (i = 0; i < M; ++i) {
		if (group[i]) continue;
		++grc;

		j = i;
		cgs = 1;
		cS = 0;
		invalid = 0;
		group[j] = grc;
		for (j = next[j]; !group[j]; j = next[j]) {
			group[j] = grc;
			++cgs;
			if (group[op (j)] == grc) invalid = 1;
//			printf ("edge %d (%d %d)\n", j, buf[op (j)].to, buf[j].to);
			cS += coor[buf[op (j)].to][0] * coor[buf[j].to][1]
				- coor[buf[op (j)].to][1] * coor[buf[j].to][0];
		}
//		printf ("edge %d (%d %d)\n", j, buf[op (j)].to, buf[j].to);
		assert (i == j);
		cS += coor[buf[op (j)].to][0] * coor[buf[j].to][1]
			- coor[buf[op (j)].to][1] * coor[buf[j].to][0];
//		printf ("___%d %d %d\n", invalid, cS, cgs);
		if (invalid || cS < 0 || cgs != K) continue;
		++res;
	}

	printf ("%d\n", res);

	return 0;
}
