/*
FROM: Balkan Olympiad in Informatics (BOI) 2002 day 1
PROB: robot
KEYW: maximum with transverse (cross) minimum, floid
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 1 << 7;
const int MAXM = 1 << 14;
const int MAXB = 1 << 5;
const int INF = 1 << 29;

struct pnt {
	int x, y;
	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}
};

int N, M, B;
pnt obst[MAXN];
pnt brd[2][MAXB];

int ma3x[MAXN][MAXN];

int dst (const pnt &a, const pnt &b) {
	return abs (a.x - b.x) >? abs (a.y - b.y);
}

int main () {
	scanf ("%d", &B);

	int i, j, k;
	for (k = 0; k < 2; ++k)
		for (i = 0; i <= B; ++i)
			scanf ("%d %d", &brd[k][i].x, &brd[k][i].y);

	scanf ("%d", &N);
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &obst[i].x, &obst[i].y);

	for (i = 0; i < N; ++i)
		for (j = i + 1; j < N; ++j)
			ma3x[i][j] = ma3x[j][i] = dst (obst[i], obst[j]);

	for (k = 0; k < 2; ++k)
		for (i = 0; i < N; ++i) {
			ma3x[N+k][i] = dst (brd[k][0], obst[i]);
			for (j = 1; j <= B; ++j) {
				ma3x[N+k][i] <?= dst (brd[k][j], obst[i]);
				if (brd[k][j-1].x == brd[k][j].x && (brd[k][j-1].y - obst[i].y) * (brd[k][j].y - obst[i].y) <= 0)
					ma3x[N+k][i] <?= abs (brd[k][j].x - obst[i].x);
				if (brd[k][j-1].y == brd[k][j].y && (brd[k][j-1].x - obst[i].x) * (brd[k][j].x - obst[i].x) <= 0)
					ma3x[N+k][i] <?= abs (brd[k][j].y - obst[i].y);
			}
			ma3x[i][N+k] = ma3x[N+k][i];
		}
	ma3x[N][N+1] = ma3x[N+1][N] = INF;

	int NN = N + 2;//including source and sink
	for (k = 0; k < NN; ++k)
		for (i = 0; i < NN; ++i)
			for (j = 0; j < NN; ++j)
				ma3x[i][j] <?= ma3x[i][k] >? ma3x[k][j];

	printf ("%d\n", ma3x[N][N+1]);

	return 0;
}
