#include <cstdio>
#include <utility>
#include <ext/hash_map>

typedef std::pair <long long, long long> _16b_t;
typedef __gnu_cxx::hash_multimap <int, _16b_t> map_t;
typedef map_t::iterator it_map_t;

map_t map_fr, map_to;

template <typename RES, typename SRC>
RES crack_type (const SRC &x) {return *((RES*)&x);}

void remove_edges (map_t &cmap, int key, map_t &omap) {
	std::pair <it_map_t, it_map_t> range = cmap.equal_range (key);

	for (it_map_t it = range.first; it != range.second;) {
		omap.erase (crack_type <it_map_t> (it->second));
		it_map_t tmp = it++;
		cmap.erase (tmp);
	}
}

void add_edge (int fr, int to) {
	it_map_t fr_it = map_fr.insert (std::make_pair (fr, _16b_t ()));
	it_map_t to_it = map_to.insert (std::make_pair (to, _16b_t ()));
	fr_it -> second = crack_type <_16b_t> (to_it);
	to_it -> second = crack_type <_16b_t> (fr_it);
}

void print_all_edges () {
	printf ("list of all edges:\n");
	for (it_map_t it = map_fr.begin (); it != map_fr.end (); ++it)
		printf ("%d -> %d\n", it->first, (crack_type <it_map_t> (it->second))->first);
}

int main () {
	int a, b, c;
	for (;;) {
		printf ("<0> exit\n");
		printf ("<1> print\n");
		printf ("<2> add\n");
		printf ("<3> remove (x, *)\n");
		printf ("<4> remove (*, y)\n");
		scanf ("%d", &c);
		switch (c) {
			case 0: return 0;
			case 1: print_all_edges (); break;
			case 2: printf ("enter edge: "); scanf ("%d %d", &a, &b); add_edge (a, b); break;
			case 3: printf ("enter a: "); scanf ("%d", &a); remove_edges (map_fr, a, map_to); break;
			case 4: printf ("enter b: "); scanf ("%d", &b); remove_edges (map_to, b, map_fr); break;
			default: printf ("sth wrong!\n");
		}
	}

	return 0;
}
