/*
FROM: Balkan Olympiad in Informatics (BOI) 2002 day 2
PROB: tree
KEYW: special tree traversion, 3-enumeration (d-enumeration)
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 15;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N;
int vec[MAXN];
el buf[MAXN];

int row[MAXN], rp;
bool used[MAXN];

void trav (int r, bool root_first =1) {
	if (used[r]) return;
	used[r] = 1;
	if (root_first) row[rp++] = r;
	for (int i = vec[r]; i != -1; i = buf[i].next)
		trav (buf[i].to, !root_first);
	if (!root_first) row[rp++] = r;
}

int main () {
	scanf ("%d", &N);

	memset (vec, -1, sizeof (vec));
	int i;
	int a, b, bp = 0;
	for (i = 1; i < N; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		buf[bp] = el (b, vec[a]);
		vec[a] = bp++;
		buf[bp] = el (a, vec[b]);
		vec[b] = bp++;
	}

	trav (0);
	for (i = 0; i < rp; ++i)
		printf ("%d\n", row[i] + 1);

	return 0;
}
