/*
FROM: Balkan Olympiad in Informatics (BOI) 2003 day 2
PROB: euro
KEYW: dynamical programming with optimizations on the inner cycle using a deque with complexity of cmp function O (1). Overall complexity - O (N). Last implementation was with cmp complexity O (logN) and overall complexity (N log N).
*/

#include <cstdio>

#define DIVU(A,B) (((A)+(B)-1) / (B)) /*A / B round UP*/
#define PRNTQ		for (int ii = p1; ii < p3; ++ii) printf (" %d", q[ii]); puts ("")

const int MAXN = 35000;

int N, T;
int _vec[MAXN];//initial sequence
int vec[MAXN];//after compression
int time[MAXN];//last day in bunch i
//int time_ref[MAXN];//real time i leads to bunch time_ref[i] (ant time[time_ref[i]] >= i && time[time_ref[i]-1] < i for all i)
int sum[MAXN];//commulative sum
long long dp[MAXN];

long long cmp (int a, int b) {
//	printf ("cmp %d %d (%Ld %Ld %d) -- %Ld\n", a, b, dp[a], dp[b], sum[b] - sum[a], DIVU (dp[a] - dp[b], sum[a] - sum[b]));
	if (dp[a] <= dp[b]) return -10;
	return DIVU (dp[a] - dp[b], sum[a] - sum[b]);
} 

int main () {
	scanf ("%d %d", &N, &T);

	int i;
	for (i = 1; i <= N; ++i)
		scanf ("%d", _vec + i);

	int cvp = 1;
	for (i = 1; i < N; ++i) {
		vec[cvp] += _vec[i];
		if (vec[cvp] < 0) {
			time[cvp] = i;//last real day in compressed cvp
			++cvp;
		}
	}

	vec[cvp] += _vec[N];
	time[cvp] = N;
	++cvp;

	for (i = 1; i < cvp; ++i)
		sum[i] = sum[i-1] + vec[i];
/*
	int ctp = 1;
	for (i = 1; i <= N; ++i) {
		time_ref[i] = ctp;
		if (i == time[ctp])
			++ctp;
	}
*/
/*
	for (i = 1; i < cvp; ++i)
		printf ("%d %d\n", vec[i], time[i]);

	for (i = 1; i <= N; ++i)
		printf ("%d -> %d\n", i, time_ref[i]);
*/

	static int q[MAXN];
	int p1 = 0, p3 = 0;
	dp[1] = (long long)vec[1] * time[1] - T;
	q[p3++] = 0;//means that the next bach will be the first one
	q[p3++] = 1;//prev batch was the first one

	for (i = 2; i < cvp; ++i) {
		if (cmp (q[p1], q[p1+1]) <= time[i]) {
//			printf ("popped!\n");
			++p1;//pop the top because the second one already beated the first one
		}
//		PRNTQ;
		dp[i] = dp[q[p1]] + (long long)(sum[i] - sum[q[p1]]) * time[i] - T;
//		printf ("dp[%d] == %Ld\n", i, dp[i]);
		while (p3 - p1 > 1 && cmp (q[p3-2], q[p3-1]) >= cmp (q[p3-1], i)) --p3;
		q[p3++] = i;
//		PRNTQ;
	}

	printf ("%Ld\n", dp[cvp-1]);

	return 0;
}
