/*
FROM: BOI 2003 1st day
PROB: euro
KEYW: dynamical programming with optimization on the inner cycle
*/

#include <cstdio>
#include <cmath>
#include <climits>

const int MAXN = 35000;

int N, T;
int w[MAXN];
int vec[MAXN];
int ids[MAXN];
int sum[MAXN];

long long opt[MAXN];

int main () {
	scanf ("%d %d", &N, &T);
	int i, j;
	for (i = 0; i < N; ++i) scanf ("%d", w + i);

	int cN =1;
	for (i = 0; i < N; ++i)
		if ((vec[cN] += w[i]) < 0) {
			sum[cN] = sum[cN - 1] + vec[cN];
			ids[cN++] = i + 1;
		}

	if (ids[cN-1] != N) {
		sum[cN] = sum[cN - 1] + vec[cN];
		ids[cN++] = N;
	}

	int maxback = 2 * (int)sqrt (T) + 5;

	for (i = 1; i < cN; ++i) {
		opt[i] = LONG_LONG_MIN;
		for (j = i-1; j >= 0 && i - j < maxback; --j)
			opt[i] >?= opt[j] + (long long)(sum[i] - sum[j]) * ids[i];
		opt[i] -= T;
	}

	printf ("%Ld\n", opt[cN-1]);

	return 0;
}
