/*
FROM: BOI 2003 1st day
PROB: euro
KEYW: dynamical programming with optimization, heap, hash
*/

#include <cstdio>
#include <climits>

const int MAXN = 35000;

int N, T;
int w[MAXN];
int sum[MAXN];

long long opt[MAXN];

//////////////HEAP///////////////
const int MAXHEAPLEN = MAXN * 2;
int hlen;
int h[MAXHEAPLEN];
int idx[MAXN];
int INF_ID;

void prntHeap () {
	int ub = 2;
	int i = 1;
	for (; ub < 20;) {
		for (; i < ub; ++i)
			printf ("%d ", h[i]);
		ub *= 2;
		printf ("--\n");
	}
}

void initHeap () {
	INF_ID = N + 1;
	sum[N+1] = INT_MIN;
	sum[N+2] = INT_MAX;
	for (int i = 1; i < MAXHEAPLEN; ++i)
		h[i] = N + 1;
	h[0] = N + 2;
	hlen = 1;
/*
	for (int i = 0; i < N; ++i)
		idx[i] = -1;
*/
}

void popHeap () {
//	printf ("popheap\n");
	idx[1] = -1;
	int tomove_id = h[--hlen];
	h[hlen] = INF_ID;
	h[1] = tomove_id;
	idx[tomove_id] = 1;

	int p1 = 1, p2 = 2;

	for (;;) {
		if (sum[h[p2 + 1]] > sum[h[p2]])
			++p2;

		if (sum[tomove_id] < sum[h[p2]]) {
			h[p1] = h[p2];
			idx[h[p2]] = p1;

			p1 = p2;
			p2 *= 2;
		} else
			break;
	}

	h[p1] = tomove_id;
	idx[tomove_id] = p1;

//	prntHeap ();
}

void addHeap (int a) {
//	printf ("addHeap %d\n", a);
	h[hlen] = a;
//	idx[a] = hlen;

	int p1 = hlen++, p2 = p1 / 2;

	while (sum[h[p2]] < sum[a]) {
		h[p1] = h[p2];
		idx[h[p2]] = p1;

		p1 = p2;
		p2 /= 2;
	}
	idx[a] = p1;
	h[p1] = a;

//	prntHeap ();
}
//////////////END HEAP///////////

//////////////HASH///////////////
const int MAXHASHLEN = 1 << 20;

struct node {
	int id;
	node *next;
};

node *hash[MAXHASHLEN];

void initHash () {}

int hashf (int a) {
	return (a + MAXN * 1000) % (MAXHASHLEN);
}

void addHash (int add) {
//	printf ("add hash %d\n", add);
	int addline = hashf (sum[add]);
	for (node *i = hash[addline]; i; i = i->next) {
		if (sum[i->id] == sum[add]) {
			if (opt[i->id] < opt[add]) {//remove from heap 'i->id' and put in its place 'add'
//				printf ("XXX heap %d ", i->id);
				h[idx[i->id]] = add;
				idx[add] = idx[i->id];
//				printf ("%d\n", add);
				idx[i->id] = -1;
			}
			return;
		}
	}

	//add to hash & heap
	node *_new = new node;
	_new->id = add;
	_new->next = hash[addline];
	hash[addline] = _new;
	addHeap (add);
}
//////////////END HASH///////////

int main () {
	scanf ("%d %d", &N, &T);
	for (int i = 1; i <= N; ++i) {scanf ("%d", w + i); sum[i] = sum[i-1] + w[i];}

	opt[0] = 0;
	opt[1] = sum[1] - T;

	initHash (); initHeap ();
//	addHeap (0); if (sum[1] < 0) addHeap (1);
	addHash (0); if (sum[1] < 0) addHash (1);

	long long tmp;
	int uid = -1;
	for (int i = 2; i <= N; ++i) {
		opt[i] = LONG_LONG_MIN;
		for (int j = 1; j < hlen; ++j)
			if (opt[i] < (tmp = (opt[h[j]] + (long long)(sum[i] - sum[h[j]]) * i))) {

				opt[i] = tmp;
				uid = h[j];
			}
		opt[i] -= T;
//		printf ("i == %d, updated with %d, opt[] == %Ld --- %d\n", i, uid, opt[i], sum[i]);
		while (sum[h[1]] > sum[uid])
			popHeap ();

		if (sum[i] <= sum[uid]) {
//			addHeap (i);
			addHash (i);
		}
	}

	printf ("%Ld\n", opt[N]);
}
