/*
FROM: Balkan Olympiad in Informatics (BOI) 2003 day 1
PROB: farey sequence
KEYW: farey sequence, finding the K'th farey number in the farey sequence of order N
*/
#include <cstdio>
#include <cassert>

#include <vector>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 16;
#define DIVD(A,B) ((A) / (B))
#define DIVU(A,B) (((A)+(B)-1) / (B))

int N, K;

int cnt (int nom) {
	static int c[MAXN], ans;
	static int i, j;
	ans = 0;
	for (i = 2; i <= N; ++i) c[i] = DIVD (nom * i, N);
	for (i = 2; i < N; ++i) {
//		printf ("%d %d - %d\n", nom, i, c[i]);
		ans += c[i];
		for (j = i * 2; j <= N; j += i) c[j] -= c[i];
	}
//	printf ("cnt %d --> %d\n", nom, ans + c[N]);

	return ans + c[N];
}

bool cmp (const std::pair <int, int> &a, const std::pair <int, int> &b) {
	return a.first * b.second < a.second * b.first;
}

int main () {
	scanf ("%d %d", &N, &K);
	--K;//counting starts from 0 ;)

	int l = 0, r = N, m;
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (cnt (m) > K)
			r = m;
		else
			l = m;
	}

	assert (l != N-1);//there aren't any fare numbers in this interval ((N-1) / N , 1]

	std::vector <std::pair <int, int> > arr;
	int b1, b2;
	for (int i = 2; i <= N; ++i) {
		b1 = DIVD (l * i, N) + 1;
		b2 = DIVD ((l + 1) * i, N);
//		printf ("den %d -- %d %d (%d) (gcd %d)\n", i, b1, b2, (l + 1) * i / N, std::__gcd (b1, i));
		if (b1 == b2 && std::__gcd (b1, i) == 1)
			arr.push_back (std::make_pair (b1, i));
	}

	std::sort (arr.begin (), arr.end (), cmp);
/*	for (int i = 0; i < arr.size (); ++i)
		printf ("%d %d\n", arr[i].first, arr[i].second);
	puts ("");
*/
	int id = K - cnt (l);

	printf ("%d %d\n", arr[id].first, arr[id].second);

	return 0;
}
