#include <cstdio>
#include <cassert>
#include <cstring>

const int MAXN = 1 << 17;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N;
int vec[MAXN];
el buf[MAXN * 2];
FILE *nf;

void bfs (int start) {
	static int q[MAXN];
	static bool used[MAXN];
	int p3 = 0, i, j;
	int fsp = 0;
	memset (used, 0, sizeof (used));
	used[start] = 1;
	q[p3++] = start;
	
	if (nf) fprintf (nf, "%d\n", N);
	for (i = 0; i < p3; ++i) {
		for (j = vec[q[i]]; j != -1; j = buf[j].next) {
			if (!used[buf[j].to]) {
				used[buf[j].to] = 1;
				q[p3++] = buf[j].to;
				if (j & 1) ++fsp;//printf ("son -> father?? %d %d\n", q[i], buf[j].to);
				if (nf) fprintf (nf, "%d %d\n", q[i] + 1, buf[j].to + 1);
			}
		}
	}
	printf ("traversed starting from %d - %d (%d)\n", start, p3, fsp);
}

int main (int argc, char *argv[]) {
	if (argc == 2) {
		nf = fopen (argv[1], "w");
		assert (nf);
	}

	scanf ("%d", &N);

	memset (vec, -1, sizeof (vec));
	int i;
	int a, b, bp = 0;
	for (i = 0; i < N - 1; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		buf[bp] = el (b, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, vec[b]);
		vec[b] = bp++;
	}

	bfs (0);

	return 0;
}
