/*
FROM: Balkan Olympiad in Informatics (BOI) 2003 day 2
PROB: tribe council
KEYW: 2 phase dynamical programming on tree. O (N) solution
*/

#include <cstdio>
#include <cassert>
#include <vector>

const int MAXN = 1 << 17;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N;
int prev[MAXN];
int vec[MAXN];
el buf[MAXN];

int q[MAXN];//order of visit

int dp[MAXN];
int first_tight[MAXN];
std::vector <int> kinfo[MAXN];
int kk[MAXN];
int ans = 1;

void bfs () {
	int p3, i, j;
	q[p3 = 0, p3++] = 0;
	for (i = 0; i < p3; ++i)
		for (j = vec[q[i]]; j != -1; j = buf[j].next) {
			q[p3++] = buf[j].to;
			++kk[q[i]];
		}
	assert (p3 == N);
}

void upd (int v) {
	static int i, csum, exp;
	csum = exp = 0;
	for (i = kk[v]; i >= 0; --i) {
		++exp;
		csum += kinfo[v].at (i);
		if (csum < exp) exp = csum;
		if (csum == exp) first_tight[v] = i;
	}
	ans >?= (dp[v] = exp);
}

void stage1 (int v) {
	static int i;
	if (!kk[v]) return;

	kinfo[v].resize (kk[v] + 1, 0);
	for (i = vec[v]; i != -1; i = buf[i].next)
		++kinfo[v].at (dp[buf[i].to] <? kk[v]);

	upd (v);
}

void stage2 (int v) {
	if (!kk[v]) return;
	++kinfo[v].at ((dp[prev[v]] - (dp[v] >= first_tight[prev[v]])) <? ((int)kinfo[v].size () - 1));
	upd (v);
}

void prnt (int v) {
	printf ("%d -- %d %d :", v, dp[v], first_tight[v]);
	for (int i = 0; i < (int)kinfo[v].size (); ++i) printf (" %d", kinfo[v].at (i)); puts ("");
}

int main () {
	scanf ("%d", &N);

	memset (vec, -1, sizeof (vec));
	int i;
	int a, b;
	for (i = 0; i < N - 1; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		buf[i] = el (b, vec[a]);
		vec[a] = i;

		prev[b] = a;
	}

	bfs ();

	for (i = N-1; i >= 0; --i) stage1 (q[i]);//, printf ("%d -1> %d %d\n", q[i] + 1, dp[q[i]], first_tight[q[i]]);
	for (i = 1; i < N; ++i) stage2 (q[i]);//, prnt (q[i]);

	printf ("%d\n", ans + 1);

	return 0;
}
