/*
FROM: Balkan Olympiad in Informatics (BOI) 2003 day 2
PROB: spaceship (ship)
KEYW: dynamical programming
*/

#include <cstdio>
#include <vector>

const int MAXN = 1 << 6;
const int MAXS = 1 << 4;

const int BASE = 1000;

struct big {
	std::vector <int> m;
	big (int x = 0) {m.resize (1); m[0] = x;}
	big& operator = (int x) {m.resize (1); m[0] = x; return *this;}
	big& operator = (const big &a) {m = a.m; return *this;}
	big& operator += (const big &a) {
		int pr = 0, i;
		if (m.size () < a.m.size ()) m.resize (a.m.size (), 0);
		for (i = 0; i < (int)a.m.size (); ++i) {
			m[i] += a.m[i] + pr;
			pr = m[i] / BASE;
			m[i] %= BASE;
		}
		for (i = (int)a.m.size (); pr && i < (int)m.size (); ++i) {
			m[i] += pr;
			pr = m[i] / BASE;
			m[i] %= BASE;
		}
		if (pr) m.push_back (pr);
		return *this;
	}
	big operator * (int b) {
		int pr = 0, i;
		big res;
		res.m.resize (m.size (), 0);
		for (i = 0; i < (int)m.size (); ++i) {
			res.m[i] = m[i] * b + pr;
			pr = res.m[i] / BASE;
			res.m[i] %= BASE;
		}
		if (pr) res.m.push_back (pr);
		return res;
	}
	void prnt () {
		printf ("%d", m.back ());
		for (int i = (int)m.size () - 2; i >= 0; --i) printf ("%03d", m[i]);
	}
};

int N, S;
big dp[2][MAXN];
int C[MAXN];

int main () {
	scanf ("%d %d", &S, &N);

	int i, j, k;
	C[0] = 1;
	for (i = 1; i <= S; ++i)
		for (j = i; j; --j)
			C[j] += C[j-1];

	dp[0][0] = 1;
	for (i = 1; i <= N; ++i)
		for (j = i; j <= (N <? (i * S)); ++j) {
			dp[i & 1][j] = big ();
			for (k = 0; k <= (j <? S); ++k)
				if (j - k >= i - 1)
					dp[i & 1][j] += dp[(i-1) & 1][j-k] * C[k];
//			printf ("dp[%d][%d] == %d\n", i, j, dp[i][j]);
		}

//	printf ("%Ld\n", dp[N][N]);
	dp[N & 1][N].prnt (); puts ("");

	return 0;
}
