/*
FROM: Balkan Olympiad in Informatics (BOI) 2003 day 1
PROB: travers (traversal)
KEYW: lowest bit index tree with coordinate compression
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 17;
const int MOD = 9901;

int N, H, N1;
int coor[MAXN];
int srt[MAXN];
int idt[MAXN];

void add (int pos, int val) {
	for (; pos <= N1; pos += (pos & -pos)) {
		idt[pos] += val;
		idt[pos] %= MOD;
	}
}

int _srch (int pos) {
	static int ans;
	for (ans = 0; pos; pos &= pos - 1)
		ans += idt[pos];
	return ans % MOD;
}

int srch (int a, int b) {
//	printf ("%d %d\n", a, b);
	return (_srch (b) - _srch (a - 1) + MOD) % MOD;
}

int main () {
	scanf ("%d %d", &N, &H);
	N1 = N + 1;

	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d", coor + i);
		srt[i] = coor[i];
	}
	srt[N] = -1000000000;//the 0'th element in the index tree cannot be used

	std::sort (srt, srt + N1);

	add (std::lower_bound (srt, srt + N1, coor[N-1]) - srt, 1);
	int to_add, ans = 0;
	for (i = N - 2; i >= 0; --i) {
//		printf ("now -- %d\n", coor[i]);
		ans += to_add = srch (
			std::lower_bound (srt, srt + N1, coor[i] - H) - srt,
			std::upper_bound (srt, srt + N1, coor[i] + H) - srt - 1
		);
//		printf ("to add %d\n", to_add);
		add (std::lower_bound (srt, srt + N1, coor[i]) - srt, to_add + 1);//+1 if this is the only box (but not included directly in the answer)
	}

	ans %= MOD;
	printf ("%d\n", ans);

	return 0;
}
