/*
FROM: Balkan Olympiad in Informatics (BOI) 2004 day 2
PROB: race
KEYW: checker
*/

#include <cstdio>
#include <cassert>
#include <cstring>

const int MAXN = 1 << 11;

struct pos {
	int x, y;
};

int N, M;
pos coor[MAXN];
unsigned ma3x[MAXN][MAXN];

int sq (int a) {return a * a;}
int dst (int a, int b) {
	return sq (coor[a].x - coor[b].x) 
			+ sq (coor[a].y - coor[b].y);
}

int S (int a, int b, int c) {
	return (coor[b].x - coor[a].x) * (coor[c].y - coor[a].y)
		- (coor[b].y - coor[a].y) * (coor[c].x - coor[a].x);
}

void add_to (int &a, int b, int c) {
	assert (b >= 0 && b < N && c >= 0 && c < N);
	assert (ma3x[b][c] != (unsigned)-1);
	a <?= ma3x[b][c];
}

int main (int argc, char *argv[]) {
	assert (argc == 3);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
//	FILE *sol = fopen (argv[3], "r");
	assert (in && out/* && sol*/);

	fscanf (in, "%d %d", &N, &M);

	int i;
	for (i = 0; i < N; ++i)
		fscanf (in, "%d %d", &coor[i].x, &coor[i].y);

	memset (ma3x, -1, sizeof (ma3x));
	int a, b;
	for (i = 0; i < M; ++i) {
		fscanf (in, "%d %d", &a, &b);
		--a; --b;
		ma3x[a][b] = ma3x[b][a] = dst (a, b);
	}

	printf ("hre!\n");

	int pc, prev2, prev1, crnt;
	int pl = 1 << 29;
	fscanf (out, "%d %d %d", &pc, &prev2, &prev1);
	--prev2; --prev1;
	add_to (pl, prev2, prev1);
	assert (prev2 == 0);

	for (i = 2; i < pc; ++i) {
		fscanf (out, "%d", &crnt);
		--crnt;
		add_to (pl, prev1, crnt);
		assert (S (prev2, prev1, crnt) > 0
		|| S (prev2, prev1, crnt) == 0 && crnt != prev2);
		prev2 = prev1;
		prev1 = crnt;
/*
		assert (crnt >= 0 && crnt < N);
		assert (ma3x[prev][crnt] != (unsigned)-1);
		pl <?= ma3x[prev][crnt];
		prev = crnt;
*/
	}
	assert (crnt == 0);
/*
	int pl_sol = 1 << 29;
	fscanf (sol, "%d %d", &pc, &prev);
	--prev;	
	assert (prev == 0);
	for (i = 1; i < pc; ++i) {
		fscanf (sol, "%d", &crnt);
		--crnt;
		assert (crnt >= 0 && crnt < N);
		assert (ma3x[prev][crnt] != (unsigned)-1);
		pl_sol <?= ma3x[prev][crnt];
		prev = crnt;
	}
	assert (crnt == 0);
	printf ("%d %d\n", pl, pl_sol);
	assert (pl_sol == pl);
*/
	printf ("ok! pl ==  %d\n", pl);

	return 0;
}
