/*
FROM: Balkan Olympiad in Informatics (BOI) 2004 day 2
PROB: code
KEYW: output only, exhaustion
*/

#include <cstdio>
#include <cassert>
#include <csetjmp>


const int MAXX = 1 << 10;

typedef unsigned short type;

int N, K;

int X;
type MAXVAL;
type c[MAXX];

jmp_buf env;

int Dp (int i, int j) {
//	printf ("dp %d %d -- ", i, j);
	i -= j;
//	printf ("%d\n", i <? (X - i));
	return i <? (X - i);
}

int Dd (type a, type b) {
//	printf ("Dd %x %x - %d\n", (unsigned)a, (unsigned)b, __builtin_popcount (a ^ b));
	return __builtin_popcount (a ^ b);
}

void prnt_bin (type a) {
	int _printed = N;
	while (a) {
		--_printed;
		putchar ((a & 1) + '0');
		a >>= 1;
	}
	while (_printed) {
		putchar ('0');
		--_printed;
	}
	puts ("");
}

void gen (int pos) {
//	printf ("%d < %d\n", pos, X);
	if (pos == X) {
		longjmp (env, 0);
	}

	for (type i = 1; i <= MAXVAL; ++i) {
		int j;
//		printf ("try %x\n", (unsigned)i);
		for (j = 0; j < pos; ++j) {
//			printf ("pos %d\n", j);
			if (Dp (pos, j) <= K) {
//				printf ("1st case - Dd == %d (%d)\n", Dd (i, c[j]), Dp (pos, j));
//				getc (stdin);
				if (Dd (i, c[j]) != Dp (pos, j)) break;
			} else {
//				printf ("2st case - Dd == %d (%d)\n", Dd (i, c[j]), K);
//				getc (stdin);
				if (Dd (i, c[j]) <= K) break;
			}
		}
		if (j == pos) {
			c[pos] = i;
			gen (pos + 1);
		} else {
//			printf ("broken on pos %d\n", j);
		}
	}
}

int main () {
	scanf ("%d %d", &N, &K);
	MAXVAL = (1 << N) - 1;
	printf ("%x\n", MAXVAL);

	assert ((unsigned)(N + 7) / 8 <= sizeof (type));

	int i;
	for (i = 0; i <= K; ++i)
		c[i] = (1 << i) - 1;

	for (X = 2 * (K + 1); X <= MAXVAL; X += 2) {
		printf ("new X -- %d\n", X);
		if (!setjmp (env)) {
			gen (K + 1);
//			return 0;
			continue;//no solution here
		} else {
			printf ("%d\n", X);
			for (i = 0; i < X; ++i)
//				printf ("%x\n", (unsigned)c[i]);
				prnt_bin (c[i]);
			puts ("");
		}
	}

	return 0;
}
