/*
FROM: Balkan Olympiad in Informatics (BOI) 2004 day 2
PROB: game
KEYW: dynamical programming with optimizations on the inner cycle (to O (1))
*/

#include <cstdio>
#include <cassert>

const int MAXN = 1 << 11;
const int INF = 2000000000;

int N1, N2;
int v1[MAXN], v2[MAXN];
int sum1[MAXN], sum2[MAXN];
int dp[MAXN][MAXN];
int upd1[MAXN][MAXN];
int upd2[MAXN][MAXN];

int main () {
	scanf ("%d %d", &N1, &N2);

	int i, j;
	for (i = 1; i <= N1; ++i) {scanf ("%d", v1 + i); --v1[i]; sum1[i] = sum1[i-1] + v1[i];}
	for (i = 1; i <= N2; ++i) {scanf ("%d", v2 + i); --v2[i]; sum2[i] = sum2[i-1] + v2[i];}

	dp[0][0] = 0;
	for (i = j = 1; j < N2; ++j)
		dp[i][j] = v1[i] * sum2[j];
	for (j = i = 1; i < N1; ++i)
		dp[i][j] = v2[j] * sum1[i];

	for (i = 2; i <= N1; ++i)
		for (j = 2; j <= N2; ++j) {
			upd1[i][j] = upd2[i][j] = 1;
			if (j > 2) upd1[i][j] = upd1[i][j-1];
			if (i > 2) upd2[i][j] = upd2[i-1][j];
			assert (upd1[i][j] < j);
			assert (upd2[i][j] < i);
			if (dp[i-1][upd1[i][j]] + v1[i] * (sum2[j] - sum2[upd1[i][j]])
			  > dp[i-1][j-1] + v1[i] * v2[j])
				upd1[i][j] = j-1;
		
			if (dp[upd2[i][j]][j-1] + (sum1[i] - sum1[upd2[i][j]]) * v2[j]
			  > dp[i-1][j-1] + v1[i] * v2[j])
				upd2[i][j] = i-1;
			dp[i][j] = INF;
			dp[i][j] <?= dp[i-1][upd1[i][j]] + v1[i] * (sum2[j] - sum2[upd1[i][j]]);
			dp[i][j] <?= dp[upd2[i][j]][j-1] + (sum1[i] - sum1[upd2[i][j]]) * v2[j];
		}

	printf ("%d\n", dp[N1][N2]);

	return 0;
}
