/*
FROM: Balkan Olympiad in Informatics (BOI) 2004 day 2
PROB: race
KEYW: dijkstra with stl heap with graph expansion
*/

#include <cstdio>
#include <cassert>
#include <queue>

const int MAXN = 1 << 11;//2 000
const int MAXM = 1 << 16;//50 000 = 2 * real M (duplicate edges)

struct pos {
	int x, y;
};

struct heap {
	int edge_id;
	int val;//squared
	heap () {}
	heap (int _edge_id, int _val) : edge_id (_edge_id), val (_val) {}
	bool operator < (const heap &a) const {return val < a.val;}//the biggest should pop up first -> no need to invert
};

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N, M;
pos coor[MAXN];
int vec[MAXN];
el buf[MAXM];
int edge_len[MAXM];

int prev[MAXM];
int val[MAXM];

int bprev[MAXM];

bool good (int a, int b, int c) {
//	printf ("good %d %d %d -- %d\n", a, b, c, (coor[b].x - coor[a].x) * (coor[c].y - coor[a].y)\
		  - (coor[b].y - coor[a].y) * (coor[c].x - coor[a].x));
	return  (coor[b].x - coor[a].x) * (coor[c].y - coor[a].y)
		  - (coor[b].y - coor[a].y) * (coor[c].x - coor[a].x) >= 0;
}

int _last_edge_id;
int dijkstra (int first_edge_id) {
//	printf ("dij  %2d\n", first_edge_id);
	printf ("in dijkstra %d\n", first_edge_id);
	static std::priority_queue <heap> q;
	static heap crnt;
	q = std::priority_queue <heap> ();
	assert (q.empty ());
	int to_id, fr_id;
	int i;

	memset (val, -1, sizeof (val));//this is negative and therefore very bad!
	memset (prev, -1, sizeof (prev));
	prev[first_edge_id] = -1;
	val[first_edge_id] = edge_len[first_edge_id];
	q.push (heap (first_edge_id, edge_len[first_edge_id]));
	while (!q.empty ()) {
		crnt = q.top (); q.pop ();
//		printf ("popped %d %d\n", crnt.edge_id, crnt.val);
		to_id = buf[crnt.edge_id	].to;
		fr_id = buf[crnt.edge_id ^ 1].to;
	
		if (!to_id) {
			printf ("returning %d\n", crnt.val);
			_last_edge_id = crnt.edge_id;
			return crnt.val;
		}
		if (val[crnt.edge_id] != crnt.val) continue;//popped
	
		for (i = vec[to_id]; i != -1; i = buf[i].next) {
			if (good (fr_id, to_id, buf[i].to)
			 && buf[i].to != fr_id
			 && val[i] < (crnt.val <? edge_len[i])) {
				val[i] = (crnt.val <? edge_len[i]);
				prev[i] = crnt.edge_id;
				q.push (heap (i, val[i]));
//			 	printf ("\tpush %d %d\n", i, val[i]);
			} else {
//				printf ("\tfailed to push %d (%d %d %d)\n", i\
				, good (fr_id, to_id, buf[i].to)\
				, buf[i].to != fr_id\
				, val[i] < (crnt.val <? edge_len[i]));
			}
		}
	}
	printf ("returning -1 !!\n");
	return -1;//no way found
}

int sq (int a) {return a * a;}

int dst (int id1, int id2) {
	return sq (coor[id1].x - coor[id2].x) + sq (coor[id1].y - coor[id2].y);
}

int main () {
	scanf ("%d %d", &N, &M);
	
	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &coor[i].x, &coor[i].y);

	memset (vec, -1, sizeof (vec));
	int a, b, bp = 0;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		buf[bp] = el (b, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, vec[b]);
		vec[b] = bp++;
	
		edge_len[bp-2] = edge_len[bp-1] = dst (a, b);
	}
/*
	for (i = 0; i < bp; ++i)
		printf ("%2d | %2d -> %2d | %d\n", i, buf[i].to, buf[i^1].to, edge_len[i]);

	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (int j = vec[i]; j != -1; j = buf[j].next)
			printf (" (%d %d)", buf[j].to, j);
		puts ("");
	}
*/
	int bval = -1;
	int first_edge_id = -1;
	for (i = vec[0]; i != -1; i = buf[i].next) {
		printf ("pre dij!\n");
		int cval = dijkstra (i);
		printf ("post dij! %d\n", cval);
//		printf ("returned %d\n", cval);
		if (bval < cval) {
			first_edge_id = i;
			bval = cval;
			memcpy (bprev, prev, sizeof (prev));
		}
	}
	printf ("VVV\n");
	assert (first_edge_id != -1);
	static int ans[MAXM], ap;

	for (i = _last_edge_id; i != first_edge_id; i = bprev[i])
		ans[ap++] = buf[i ^ 1].to;

	printf ("%d\n", ap + 2);
	printf ("1");
	for (i = ap-1; i >= 0; --i) printf (" %d", ans[i] + 1);
	printf (" 1\n");

	return 0;
}
