/*
FROM: Balkan Olympiad in Informatics (BOI) 2004 day 1
PROB: team
KEYW: lowest bit index tree maintaining minimum (from begining)
*/

#include <cstdio>
#include <cstring>
#include <cassert>

const int MAXN = 1 << 19;
const int INF = 0x7f7f7f7f;

int N;
int ord[3][MAXN];
int ref[2][MAXN];
int idt[MAXN];

void add (int pos, int val) {
//	printf ("add %d %d\n", pos, val);
	for (; pos <= N; pos += pos & -pos)
		idt[pos] <?= val;
}

int srch (int pos) {
//	printf ("srch %d\n", pos);
//	assert (idt[pos] == INF);
	int res = INF;
	for (; pos; pos &= pos - 1)
		res <?= idt[pos];
//	printf ("<-- %d\n", res);
	return res;
}

int main () {
	scanf ("%d", &N);

	int i, k;
	for (k = 0; k < 3; ++k) {
		for (i = 0; i < N; ++i)
			scanf ("%d", ord[k] + i);
		if (k == 2) break;
		for (i = 0; i < N; ++i)
			ref[k][ord[k][i]] = i + 1;
	}

	int ans = 1;
	memset (idt, 0x7f, sizeof (idt));
	add (ref[0][ord[2][0]], ref[1][ord[2][0]]);
	for (i = 1; i < N; ++i) {
		if (srch (ref[0][ord[2][i]]) > ref[1][ord[2][i]])
			++ans;
		add (ref[0][ord[2][i]], ref[1][ord[2][i]]);
	}

	printf ("%d\n", ans);

	return 0;
}
