#include <cstdio>
#include <cassert>
#include <utility>
#include <vector>
#include <ext/hash_map>

#define x first
#define y second

typedef long long lli;
typedef std::pair <int, int> PI;
typedef std::pair <lli, lli> PL;

const int MAXN = 1 << 10;
/*try me ;) :-P :-P :-P*/
const PI BASE1 (131, 137);
const PI BASE2 (1859054383, 1859054359);
const PI MOD1 (1586465497, 1586465407);
const PI MOD2 (1923571253, 1923571271);
const int MOD3 = 2007835859;

struct PI_hash {
	size_t operator () (const PI &a) const {
		return ((lli)a.x * (lli)a.y + a.x + a.y) % MOD3;
	}
};

typedef __gnu_cxx::hash_map <PI, std::vector <PI>, PI_hash> hash_t;
typedef hash_t::iterator hash_it_t;

PL operator * (const PI &a, const PI &b) {return PL ((lli)a.x * b.x, (lli)a.y * b.y);}
PL operator + (const PL &a, const PL &b) {return PL (a.x + b.x, a.y + b.y);}
PL operator - (const PI &a, const PL &b) {return PL ((lli)a.x - b.x, (lli)a.y - b.y);}
PI operator % (const PL &a, const PI &b) {return PI (a.x % b.x, a.y % b.y);}
PI mydup (int a) {return PI (a, a);}
PL mydup (long long a) {return PL(a, a);}

int N, M;
int A, B;
int BN, BM;

char brd[MAXN][MAXN];
PI hash_row[MAXN][MAXN];
PI hash_col[MAXN][MAXN];
PI BaseA, BaseB;

void init_hash_row (int r) {
	static PL MOD1_SQ = MOD1 * MOD1;
	static int i;
	PI chash (0, 0);//, BaseA = mydup (1);
	for (i = 0; i < B; ++i) {
		chash = (chash * BASE1 + mydup (brd[r][i])) % MOD1;
//		BaseA = (BaseA * BASE1) % MOD1;
	}
	hash_row[r][0] = chash;
	for (i = B; i < M; ++i) {
		chash = (chash * BASE1 + mydup (brd[r][i])) % MOD1;
		chash = (chash - BaseA * mydup (brd[r][i-B]) + MOD1_SQ) % MOD1;
		assert (chash.x >= 0 && chash.y >= 0);
		hash_row[r][i-B+1] = chash;
	}
}

void init_hash_col (int c) {
	static PL MOD2_SQ = MOD2 * MOD2;
	static int i;
	PI chash (0, 0);//, BaseB = mydup (1);
	for (i = 0; i < A; ++i) {
		chash = (chash * BASE2 + hash_row[i][c]) % MOD2;
//		BaseB = (BaseB * BASE2) % MOD2;
//		printf ("(chash * Base2 + hash_row[%d][%d]) %% MOD2 -- %10d %10d\n", i, c, chash.x, chash.y);
	}
//	printf ("written to %d %d\n", 0, c);
	hash_col[0][c] = chash;
	for (i = A; i < N; ++i) {
		chash = (chash * BASE2 + hash_row[i][c]) % MOD2;
		chash = (chash - BaseB * hash_row[i-A][c] + MOD2_SQ) % MOD2;
		assert (chash.x >= 0 && chash.y >= 0);
		hash_col[i-A+1][c] = chash;
//		printf ("chash * base2 + hash_row[%d][%d] .. %d %d %% MOD2 -- %10d %10d --> to %d %d\n", i, c, i-B, c, chash.x, chash.y, i-B+1, c);
	}
}

int main () {
	freopen ("cipher.in", "r", stdin);
	freopen ("cipher.out", "w", stdout);

	scanf ("%d %d\n", &N, &M);

	int i, j;
	for (i = 0; i < N; ++i)
		gets (brd[i]);

	scanf ("%d %d", &A, &B);
	BN = N - A;
	BM = M - B;

	BaseA = mydup (1); for (i = 0; i < B; ++i) BaseA = BaseA * BASE1 % MOD1;
	BaseB = mydup (1); for (i = 0; i < A; ++i) BaseB = BaseB * BASE2 % MOD2;
	for (i = 0; i < N; ++i) {
		init_hash_row (i);
/*		for (j = 0; j <= BM; ++j)
			printf (" (%10d %10d)", hash_row[i][j].x, hash_row[i][j].y);
		puts ("");*/
	}

//	init_hash_col (1);
	for (j = 0; j <= BM; ++j)
		init_hash_col (j);
/*
	puts ("----------\n");
	for (i = 0; i <= BN; ++i) {
		for (j = 0; j <= BM; ++j)
			printf (" (%10d %10d)", hash_col[i][j].x, hash_col[i][j].y);
		puts ("");
	}
*/
	hash_t db;
	for (i = 0; i <= BN; ++i) {
		for (j = 0; j <= BM; ++j) {
			db[hash_col[i][j]].push_back (PI (i, j));
		}
	}

	size_t best = 0;
	hash_it_t it, best_it = db.end ();
	for (it = db.begin (); it != db.end (); ++it) {
		if (it->second.size () > best) {
			best = it->second.size ();
			best_it = it;
		}
	}
	
//	assert (best && best_it != db.end ());
	int sx = best_it->second[0].x, sy = best_it->second[0].y;
	printf ("%d %d\n", A, B);
	for (i = 0; i < A; ++i) {
		for (j = 0; j < B; ++j)
			putchar (brd[sx + i][sy + j]);
		putchar ('\n');
	}
	
	printf ("%d\n", best);
	for (i = 0; i < (int)best_it->second.size (); ++i)
		printf ("%d %d\n", best_it->second[i].x + 1, best_it->second[i].y + 1);

	return 0;
}
