#include <cstdio>
//#include <cassert>
#include <algorithm>
#include <ext/hash_map>

//#warning remove assert

const int MAXN = 1 << 10;
const int M = 30029;

struct pnt {
	int x, y, z;

	pnt () {}
	pnt (int _x, int _y, int _z) : x (_x), y (_y), z (_z) {}

	pnt operator - (const pnt &a) const {return pnt (x - a.x, y - a.y, z - a.z);}
	bool operator == (const pnt &a) const {return x == a.x && y == a.y && z == a.z;}
	void inv () {x = -x; y = -y; z = -z;}
	void norm () {
		int k = std::__gcd (std::__gcd (abs (x), abs (y)), abs (z));
//		printf ("after gcd %d %d %d -> %d\n", x, y, z, k);
//		assert (k);
		x /= k; y /= k; z /= k;
		if (x < 0) inv ();
		else if (x == 0 && y < 0) inv ();
		else if (x == 0 && y == 0 && z < 0) inv ();
//		assert (x > 0 || x == 0 && y > 0 || x == 0 && y == 0 && z > 0);
	}
};

struct pnt_hash {
	size_t operator () (const pnt &a) const {
		return (((((a.x + a.y + a.z + 5) * (a.x + 1)) % M * (a.y + 2))) % M * (a.z + 3)) % M;
	}
};

int N;
pnt vec[MAXN];
__gnu_cxx::hash_map <pnt, int, pnt_hash> db;
int lc[MAXN];
int tot;

int main () {
	freopen ("points.in", "r", stdin);
	freopen ("points.out", "w", stdout);

	scanf ("%d", &N);
	
	int i, j;
	for (i = 0; i < N; ++i)
		scanf ("%d %d %d", &vec[i].x, &vec[i].y, &vec[i].z);

	pnt to_hash;
	__gnu_cxx::hash_map <pnt, int, pnt_hash> :: iterator it;
	for (i = 0; i < N; ++i) {
		db = __gnu_cxx::hash_map <pnt, int, pnt_hash> ();
//		printf ("i == %d  %d %d %d\n", i, vec[i].x, vec[i].y, vec[i].z);
		for (j = 0; j < N; ++j) {
			if (i == j) continue;
			to_hash = vec[j] - vec[i];
			to_hash.norm ();
//			printf ("\tto_hash: %d %d %d\n", to_hash.x, to_hash.y, to_hash.z);
			if ((it = db.find (to_hash)) == db.end ()) {
//				printf ("\t\tnew!!\n");
				db[to_hash] = 2;
				++lc[2];
			} else {
//				printf ("\t\told -- was %d\n", it->second);
				--lc[it->second];
				++lc[++it->second];
/*				if (it->second == 3) {
					++tot;
					printf ("INC!!\n");
				}*/
			}
		}
	}

	for (i = 3; i <= N; ++i)
		tot += lc[i] / i;

	printf ("%d\n", tot);

	return 0;
}
