#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>

const int MAXI = 170010;
const int MAXC = 160010;
const int MAXSQRT = 410;
const int MAXADD = 160010;

struct inp_t {
	int x1, y1;
	int x2, y2;
	inp_t () {}
	inp_t (int x, int y, int A) : x1 (x), y1 (y), x2 (A), y2 (-1) {}
	inp_t (int _x1, int _y1, int _x2, int _y2) : x1 (_x1), y1 (_y1), x2 (_x2), y2 (_y2) {}
};

struct el {
	int x, y;
	int cnt;
	int next;
	el () {}
	el (int _x, int _y, int _cnt, int _next) : x (_x), y (_y), cnt (_cnt), next (_next) {}
};

int cx[MAXC], xc, xsqrt;
int cy[MAXC], yc, ysqrt;

int I;
inp_t inp[MAXI];

int bucket[MAXSQRT][MAXSQRT];
int dp;
el dat[MAXADD];

//BEGIN index tree
int idt[MAXSQRT][MAXSQRT];

void add (int x, int y, int val) {
	static int i, j;
	for (i = x; i <= xsqrt;  i += i & -i)
		for (j = y; j <= ysqrt; j += j & -j)
			idt[i][j] += val;
}

int _srch (int x, int y) {
	static int res, i, j;
	res = 0;
	for (i = x; i; i &= i - 1)
		for (j = y; j; j &= j - 1)
			res += idt[i][j];
	return res;
}

int srch (int x1, int y1, int x2, int y2) {
	--x1; --y1;
	return _srch (x2, y2) + _srch (x1, y1) - _srch (x1, y2) - _srch (x2, y1);
}
//END index tree

inline void fnd_c (int *coor, int cc, int sqrt, int alabala, int &compr, int &buck) {
	compr = std::lower_bound (coor, coor + cc, alabala) - coor;
	buck = compr / sqrt + 1;
}

//int _cntr, _times;
void add_to_bucket (int bx, int by, int xa, int ya, int val) {
//	#warning search the whole bucket and add only unique coordinates
	static int i;
	for (i = bucket[bx][by]; i != -1; i = dat[i].next) {
//		++_cntr;
		if (dat[i].x == xa && dat[i].y == ya) {
			dat[i].cnt += val;
			break;
		}
	}
	if (i == -1) {
		dat[dp] = el (xa, ya, val, bucket[bx][by]);
		bucket[bx][by] = dp++;
	}
//	++_times;
}

int cnt_in_bucket (int bx, int by, int id) {
	static int i, res;
	for (res = 0, i = bucket[bx][by]; i != -1; i = dat[i].next)
		if (inp[id].x1 <= dat[i].x && dat[i].x <= inp[id].x2
		 && inp[id].y1 <= dat[i].y && dat[i].y <= inp[id].y2) {
			res += dat[i].cnt;
		}

	return res;
}

int main () {
	FILE *in = fopen ("mokia.in", "r");
	FILE *out = fopen ("mokia.out", "w");
//	FILE *in = stdin;
//	FILE *out = stdout;

	fscanf (in, "0 %*d");
	int i;
	int ct;
	int x1, y1, x2, y2;
	for (i = 0;; ++i) {
		fscanf (in, "%d", &ct);
		switch (ct) {
			case 1:
				fscanf (in, "%d %d %d", &x1, &y1, &x2); inp[i] = inp_t (x1, y1, x2);
				cx[xc++] = x1;
				cy[yc++] = y1;
				break;
			case 2: fscanf (in, "%d %d %d %d", &x1, &y1, &x2, &y2); inp[i] = inp_t (x1, y1, x2, y2); break;
			case 3: goto end_for;
		}
	}
	end_for:;
	I = i;

	std::sort (cx, cx + xc); xc = std::unique (cx, cx + xc) - cx; xsqrt = (int)ceil (sqrt (xc));
	std::sort (cy, cy + yc); yc = std::unique (cy, cy + yc) - cy; ysqrt = (int)ceil (sqrt (yc));

//	printf ("%d %d\n", xsqrt, ysqrt);
/*	for (i = 0; i < xc; ++i) printf ("%d ", cx[i]); puts ("---");
	for (i = 0; i < yc; ++i) printf ("%d ", cy[i]); puts ("---");*/
	memset (bucket, -1, sizeof (bucket));

	int Xc, Yc, Xb, Yb;
	int Xc2, Yc2, Xb2, Yb2;
	int xb, yb;
	int res;
	for (i = 0; i < I; ++i) {
		if (inp[i].y2 == -1) {//add
			fnd_c (cx, xc, xsqrt, inp[i].x1, Xc, Xb);
			fnd_c (cy, yc, ysqrt, inp[i].y1, Yc, Yb);
//			Xc = std::lower_bound (cx, cx + xc, inp[i].x1);
//			Yc = std::lower_bound (cy, cy + yc, inp[i].y1);			
//			Xb = Xc / xsqrt + 1;//use buckets [1, MAXBUCK], not [0, MAXBUCK[
//			Yb = Yc / ysqrt + 1;
			add (Xb, Yb, inp[i].x2);
			add_to_bucket (Xb, Yb, inp[i].x1, inp[i].y1, inp[i].x2);
		} else {//search
			fnd_c (cx, xc, xsqrt, inp[i].x1, Xc, Xb);
			fnd_c (cx, xc, xsqrt, inp[i].x2, Xc2, Xb2);
			fnd_c (cy, yc, ysqrt, inp[i].y1, Yc, Yb);
			fnd_c (cy, yc, ysqrt, inp[i].y2, Yc2, Yb2);

			res = 0;
			if (Xb2 - Xb > 1 && Yb2 - Yb > 1)
				res += srch (Xb, Yb, Xb2, Yb2);
		
//BEGIN search upmost row and downmost row
			for (xb = Xb; xb <= Xb2; ++xb)
				res += cnt_in_bucket (xb, Yb, i);

			if (Yb2 != Yb)
				for (xb = Xb; xb <= Xb2; ++xb)
					res += cnt_in_bucket (xb, Yb2, i);
//END

//BEGIN search leftmost & rightmost
			for (yb = Yb + 1; yb < Yb2; ++yb)
				res += cnt_in_bucket (Xb, yb, i);
			if (Xb2 != Xb)
				for (yb = Yb + 1; yb < Yb2; ++yb)
					res += cnt_in_bucket (Xb2, yb, i);
//END
			fprintf (out, "%d\n", res);
		}
	}
	fclose (out);

//	fprintf (stderr, "%d %d\n", _cntr, _times);
	
	return 0;
}
