#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <utility>
#include <algorithm>

const int MAXW = 1 << 20;
const int MAXWLEN = 20010;

const int BASE = 131;
const int MOD = 1948593077;

int W;
char *w[MAXW];
int wl[MAXW];
int *hash[MAXW];
int idx[MAXW];
int lb[MAXW];

int find_cmn_pref (int id1, int id2) {
	static int l, r, m;
	l = -1, r = wl[id1] <? wl[id2];
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (hash[id1][m] == hash[id2][m])
			l = m;
		else
			r = m;
	}
	return r;
}

bool cmp_hash_str (int a, int b) {
	static int cmn_pref;
	return (cmn_pref = find_cmn_pref (a, b)), (w[a][cmn_pref] < w[b][cmn_pref]);
}

int main () {
	FILE *in = fopen ("toponyms.in", "r");

	fscanf (in, "%d\n", &W);

	int i, j;
	static char buf[MAXWLEN];
	for (i = 0; i < W; ++i) {
		fgets (buf, MAXWLEN, in);
		wl[i] = strlen (buf) - 1;
		w[i] = (char *)calloc (wl[i] + 1, sizeof (char));
		strncpy (w[i], buf, wl[i]);
		w[i][wl[i]] = 0;
		hash[i] = (int *)calloc (wl[i], sizeof (int));
		int chash = 0;
		for (j = 0; j < wl[i]; ++j) {
			chash = ((long long)chash * BASE + buf[j]) % MOD;
			hash[i][j] = chash;
		}
		idx[i] = i;
//		printf ("%s -- %d\n", w[i], wl[i]);
	}
	fclose (in);

	std::sort (idx, idx + W, cmp_hash_str);
/*	for (i = 0; i < W; ++i)
		puts (w[idx[i]]);*/

	static std::pair <int, int> stk[MAXWLEN];
	int sp = 0;
	stk[sp++] = std::make_pair (0, -1);
	int cmn_pref;

	for (i = 1; i < W; ++i) {
		cmn_pref = find_cmn_pref (idx[i-1], idx[i]);
		while (stk[sp-1].second >= cmn_pref) --sp;
		lb[i] = stk[sp-1].first;
		stk[sp++] = std::make_pair (i, cmn_pref);
	}

	long long ans = 0;
	sp = 0;
	stk[sp++] = std::make_pair (W, -1);
	for (i = W-1; i; --i) {
		cmn_pref = find_cmn_pref (idx[i-1], idx[i]);
		while (stk[sp-1].second >= cmn_pref) --sp;
//		printf ("%d -- %d %d %d\n", i, lb[i], stk[sp-1].first, cmn_pref);
		ans >?= (long long)(stk[sp-1].first - lb[i]) * cmn_pref;
		stk[sp++] = std::make_pair (i, cmn_pref);
	}

	FILE *out = fopen ("toponyms.out", "w");
	fprintf (out, "%Ld\n", ans);
	fclose (out);

	return 0;
}
