/*
FROM: Balkan Olympiad in Informatics (BOI) 2007 day 2
PROB: mokia
KEYW: test generator (random)
*/

#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cassert>

const int MAXADD = 10000;
int W, A, Q;

int main (int argc, char *argv[]) {
	srand (time (0));
	assert (argc == 5);

	FILE *out = fopen (argv[1], "w");
	sscanf (argv[2], "%d", &W);
	sscanf (argv[3], "%d", &A);
	sscanf (argv[4], "%d", &Q);
	assert (out);

	fprintf (out, "0 %d\n", W);
	while (A + Q) {
		if (rand () % (A + Q) < A) {//add
			int x = rand () % W + 1;
			int y = rand () % W + 1;
			int a = rand () % MAXADD + 1;
			fprintf (out, "1 %d %d %d\n", x, y, a);
			--A;
		} else {//query
			int x1 = rand () % W;
			int x2 = rand () % (W - x1) + x1;
			int y1 = rand () % W;
			int y2 = rand () % (W - y1) + y1;
			fprintf (out, "2 %d %d %d %d\n", x1 + 1, y1 + 1, x2 + 1, y2 + 1);
			--Q;
		}
	}

	fprintf (out, "3\n");
	fclose (out);

	return 0;
}
