/*
FROM: Balkan Olympiad in Informatics (BOI) 2007 day 2
PROB: mokia
KEYW: dynamical mars index tree (create cells on demand (so in fact it is not 'index' ;) ))
*/

#include <cstdio>
#include <cstring>

const int MAXNODES = 160000 * 21;
//#warning change
const int MAXC = 1 << 21;

struct node {
	int id[2][2];
	int cnt;
	node () {memset (id, -1, sizeof (id)); cnt = 0;}
};

int _cf;
node nodes[MAXNODES];

inline int tell_cnt (int id) {
//	printf ("\t\t%d\n", id != -1 ? nodes[id].cnt : 0);
	return id != -1 ? nodes[id].cnt : 0;
} 

inline void upd_cnt (int id) {
	nodes[id].cnt =   tell_cnt (nodes[id].id[0][0])
					+ tell_cnt (nodes[id].id[0][1])
					+ tell_cnt (nodes[id].id[1][0])
					+ tell_cnt (nodes[id].id[1][1]);
}

int _sz;
int _x, _y, _val;
void add (int u, int l, int &id) {
//	printf ("add -- %d %d %d (%d)\n", u, l, _sz, id);
	if ( !(u <= _x && _x < u + _sz
		&& l <= _y && _y < l + _sz))
		return;

	if (id == -1) {
//		printf ("allocated - %d\n", _cf);
		id = _cf++;
	}

	if (_sz == 1) {
		nodes[id].cnt += _val;
//		printf ("added!\n");
		return;
	}

	_sz /= 2;
	add (u, l, nodes[id].id[0][0]);
	add (u, l + _sz, nodes[id].id[0][1]);
	add (u + _sz, l, nodes[id].id[1][0]);
	add (u + _sz, l + _sz, nodes[id].id[1][1]);
	_sz *= 2;
	upd_cnt (id);

//	printf ("__%d %d %d --> %d\n", u, l, _sz, nodes[id].cnt);
}

int _x1, _y1, _x2, _y2;
int srch (int u, int l, int id) {
//	printf ("srch %d %d %d (%d)\n", u, l, _sz, id);
	if (id == -1
	 || u >= _x2 || u + _sz <= _x1
	 || l >= _y2 || l + _sz <= _y1) {
//	 	printf ("<- 0 -- %d  %d %d %d %d\n", id == -1, u >= _x2, u + _sz <= _x1, l >= _y2, l + _sz <= _y1);
		return 0;//no collision or unallocated cell
	}
	if (_x1 <= u && u + _sz <= _x2
	 && _y1 <= l && l + _sz <= _y2) {
//		printf ("whole! %d %d %d-- %d\n", u, l, _sz, nodes[id].cnt);
		return nodes[id].cnt;
	}

	_sz /= 2;
	int res = 0;
	res += srch (u, l, nodes[id].id[0][0]);
	res += srch (u, l + _sz, nodes[id].id[0][1]);
	res += srch (u + _sz, l, nodes[id].id[1][0]);
	res += srch (u + _sz, l + _sz, nodes[id].id[1][1]);

	_sz *= 2;
//	printf ("<- %d %d %d -- %d\n", u, l, _sz, res);
	return res;
}

int head = -1;

int main () {
	scanf ("0 %*d");//we dont care about W;

	int ct;
	int x, y, x2, y2;
	int a;
	int cnt;
	while (scanf ("%d", &ct), ct != 3) {
		switch (ct) {
			case 1: scanf ("%d %d %d", &x, &y, &a);
					_x = --x; _y = --y; _val = a; _sz = MAXC;
//					printf ("add %d %d %d\n", _x, _y, _val);
					add (0, 0, head);
					break;
			case 2: scanf ("%d %d %d %d", &x, &y, &x2, &y2);
					_x1 = --x; _y1 = --y; _x2 = x2; _y2 = y2; _sz = MAXC;
//					printf ("srch %d %d %d %d\n", _x1, _y1, _x2, _y2);
					cnt = srch (0, 0, head);
					printf ("%d\n", cnt);
					break;
		}
	}

	return 0;
}
