#include <cstdio>
#include <algorithm>

using namespace std;


const int maxn = 2010;
const int inf = 1000000000;


struct Point
{
	int x, y;
};


int n, m, sol, ans;
int a[maxn][maxn];
int c[maxn];
Point ps[maxn];


char *infile, *outfile, *solfile;


int main(int argc, char *argv[])
{
	int i, x, y;
	FILE *fin;

	int dist(int a, int b);
	int can_turn(int a, int b, int c);

	infile = argv[1];
	outfile = argv[2];
	solfile = argv[3];

	fin = fopen(infile, "r");
	fscanf(fin, "%d%d", &n, &m);
	for (i = 1; i <= n; i++)
		fscanf(fin, "%d%d", &ps[i].x, &ps[i].y);

	for (i = 0; i < m; i++)
	{
		fscanf(fin, "%d%d", &x, &y);
		a[x][y] = a[y][x] = 1;
	}
	fclose(fin);

	fin = fopen(solfile, "r");
	fscanf(fin, "%d", &x);
	for (i = 0; i < x; i++)
		fscanf(fin, "%d", c + i);
	fclose(fin);

	sol = inf;
	for (i = 1; i < x; i++)
		sol = min(sol, dist(c[i-1], c[i]));

	fin = fopen(outfile, "r");
	if (fin == NULL)
	{
		printf("0\nCannot open the output file\n");
		return 0;
	}
	if (fscanf(fin, "%d", &x) != 1)
	{
		printf("0\nCannot read a number from the output file\n");
		return 0;
	}
	for (i = 0; i < x; i++)
		if (fscanf(fin, "%d", c + i) != 1)
		{
			printf("0\nCannot read %d numbers from the output file\n", x);
			fclose(fin);
			return 0;
		}
	fclose(fin);

	ans = inf;
	for (i = 1; i < x; i++)
	{
		if (c[i-1] == c[i])
		{
			printf("0\nTwo consecutive junctions are equal.\n");
			return 0;
		}
		if (a[c[i-1]][c[i]] != 1)
		{
			printf("0\nUsing a non-existing edge.\n");
			return 0;
		}
		if (i < x - 1 && !can_turn(c[i], c[i+1], c[i-1]))
		{
			printf("0\nRight or 180 degrees turn.\n");
			return 0;
		}
		ans = min(ans, dist(c[i-1], c[i]));
	}

	if (ans != sol)
		printf("0\nNo optimal solution.\n");
	else
		printf("10\nCorrect.\n");

	return 0;
}

int can_turn(int a, int b, int c)
{
	int x;

	int crossp(int x0, int y0, int x1, int y1, int x2, int y2);
	bool between(int x, int a, int b);

	x = crossp(ps[c].x, ps[c].y, ps[a].x, ps[a].y, ps[b].x, ps[b].y);

	return (x > 0 || x == 0 && between(c, a, b));
}

int dist(int a, int b)
{
	int sqr(int x);

	return sqr(ps[a].x - ps[b].x) + sqr(ps[a].y - ps[b].y);
}

int sqr(int x)
{
	return x * x;
}

int crossp(int x0, int y0, int x1, int y1, int x2, int y2)
{
	return (x1 - x0) * (y2 - y0) - (x2 - x0) * (y1 - y0);
}

bool between(int x, int a, int b)
{
	int x0, y0, x1, y1, x2, y2;

	x0 = ps[x].x;
	y0 = ps[x].y;
	x1 = min(ps[a].x, ps[b].x);
	y1 = min(ps[a].y, ps[b].y);
	x2 = max(ps[a].x, ps[b].x);
	y2 = max(ps[a].y, ps[b].y);

	if (x0 == x1)
		return (y0 > y1 && y0 < y2);
	else
        return (x0 > x1 && x0 < x2);
}
