#include <iostream>
#define MOD 10000
#define BASE (long long)6561
using namespace std;

int gcd(int a, int b)
{
       return (b==0)?a:gcd(b, a%b);
}

int gcd1(int a, int b)
{
    if (a == 0) return b;
    if (b == 0) return a;
    return gcd(a, b);
}

struct point3D
{
       int x, y, z;
       point3D(int _x, int _y, int _z):x(_x), y(_y), z(_z){}
       point3D(){};
       point3D operator-(point3D p)
       {
               return point3D(x - p.x, y - p.y, z - p.z);
       }
       bool operator==(point3D p)
       {
            return (x == p.x) && (y == p.y) && (z == p.z);
       }
       void print()
       {
            cout << x << " " << y << " " << z << endl;
       }
};

point3D normal(point3D p)
{
      int GCD = gcd1(p.x, gcd1(p.y, p.z));
      if (GCD == 0) return p;
      p.x /= GCD;
      p.y /= GCD;
      p.z /= GCD;
      
      if (p.x != 0) 
      {
           if (p.x < 0)
           {
                   p.x *= -1;
                   p.y *= -1;
                   p.z *= -1;
           }
      } 
      else if (p.y != 0)
      {
           if (p.y < 0)
           {
                   p.y *= -1;
                   p.z *= -1;
           }
      }
      else if (p.z < 0) 
        p.z *= -1;
      
      return point3D(p.x + 10000, p.y + 10000, p.z + 10000); //trasnlirame zaradi otricatelnite
}

int hash(point3D p)
{
      return (BASE*BASE*p.x + BASE*p.y + p.z)%MOD;
}

int table[MOD];
struct HashArray
{
       point3D p;
       int next;
       int cnt;
} nodes[1000];
int cntn;

void insert(int hash, point3D p, int otherEnd)
{
     nodes[cntn].p = p;
     nodes[cntn].next = table[hash];
     nodes[cntn].cnt = 1;
     table[hash] = cntn++;
}

int find(int hash, point3D p)
{
     for (int v1 = table[hash]; v1 != -1; v1 = nodes[v1].next)
      if (p == nodes[v1].p) { nodes[v1].cnt++; return v1; }
     return -1;
}

int main()
{
      int n, total = 0;
      point3D P[1000];
      cin >> n;
      for (int i = 0; i < n; i++)
       cin >> P[i].x >> P[i].y >> P[i].z;
      
      for (int i = 0; i < n; i++)
      {
          cntn = 0;
          memset(table, -1, sizeof(table));
          for (int j = i + 1; j < n; j++)
          {
              point3D normalV = normal(P[i] - P[j]);
              int H = hash(normalV);
              
              int pos = find(H, normalV);
              if (pos == -1) { insert(H, normalV, j); }  
              else if (nodes[pos].cnt == 2) total++;  //**napravili sme prava
              else if (nodes[pos].cnt == 3) total--;  //**imame nai-malko 3 to4ki po napred 
                                                      //  koito shte povtorqt pravata
          }
      }
      
      cout << total << endl;
      return 0;
}
