/*
FROM: BOOI 4
TASK: garden
KEYW: mathematics, computational geometry
LANG: C++
*/

/*******************************8
	totry kogato sa na edna liniq v na4aloto
***********************************/

#include <cstdio>
#include <cmath>
#include <algorithm>

const int MAXVAL = 1 << 17;
const int MAXN = 1 << 14;

int D[MAXVAL];

inline int fd (int a) {
	int res =0, i;
	for (i =1; i * i <= a; ++i)
		if (a % i == 0)
			res += i + a / i;
	if ((i - 1) * (i - 1) == a) res -= i - 1;
	return res;
}

void calcD () {
	int i;
	for (i = 1; i < 100000; ++i)
		D[i] = fd (i);
/*
	for (i = 1; i < 20; ++i) printf ("%d ", D[i]); printf ("\n");
	for (i = 100000 - 1; i > 99980; --i) printf ("%d ", D[i]); printf ("\n");
*/
}

struct point {
	long long x, y;
	point () {}
	point (long long _x, long long _y) : x (_x), y (_y) {}
	point operator - (const point &a) const {return point (x - a.x, y - a.y);}
	long long sq () const {return x * x + y * y;}
};

int N, K;
point vec[MAXN];
int idx[MAXN];

int st[MAXN];
int stp;

point A;//base

long long S (const point &a, const point &b, const point &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

bool cmp (int a, int b) {
	static int tmp;
	return (tmp = S (A, vec[a], vec[b])) ?
			tmp > 0 :
			(vec[a] - A).sq () < (vec[b] - A).sq ();
}

inline long long sq (long long a) {
	return a * a;
}

double dist (const point &a, const point &b) {
	return sqrt (sq (a.x - b.x) + sq (a.y - b.y));
}

bool bad () {
/*	printf ("bad: %d", stp);
	if (stp > 1) printf (" %Ld", S (vec[st[stp-2]], vec[st[stp-1]], vec[st[stp]]));
	printf ("\n");
	*/
	return stp > 1 ? S (vec[st[stp-2]], vec[st[stp-1]], vec[st[stp]]) <= 0 : 0;
}

int main () {
	calcD ();

//	scanf ("%d %d", &N, &K);
	scanf ("%d", &N);

	int i;
	int a;
	for (i = 0; i < N ; ++i) {
//		scanf ("%d", &a);
//		vec[i] = point (a % K, D[a] % K);

		scanf ("%Ld %Ld", &vec[i].x, &vec[i].y);
	}
/*
	for (i = 0; i < N; ++i)
		printf ("%Ld %Ld\n", vec[i].x, vec[i].y);
	printf ("*******8\n");
*/

	int id = 0;
	for (int i = 1; i < N; ++i)
		if (vec[i].y < vec[id].y || vec[i].y == vec[id].y && vec[i].x > vec[id].x)
			id = i;

//	printf ("%Ld %Ld\n", vec[id].x, vec[id].y);
	A = vec[id];

	vec[id] = vec[--N];
	vec[N] = A;
	for (i = 0; i < N; ++i) idx[i] = i;

	std::sort (idx, idx + N, cmp);
/*
	for (i = 0; i < N; ++i)
		printf ("%Ld %Ld\n", vec[idx[i]].x, vec[idx[i]].y);
*/
	st[stp++] = N;
	st[stp++] = idx[0];

	for (i = 1; i < N; ++i) {
		st[stp] = idx[i];
//		printf ("try add %Ld %Ld\n", vec[idx[i]].x, vec[idx[i]].y);

		while (bad ()) {st[stp-1] = st[stp]; --stp; /*printf ("!")*/;}
//		printf ("\n end--");
		++stp;
//		for (int i = 0; i < stp; ++i) printf ("(%Ld %Ld) ", vec[st[i]].x, vec[st[i]].y); printf ("\n");
	}
/*
	printf ("******final*********\n");
	for (i = 0; i < stp; ++i) printf ("%Ld %Ld\n", vec[st[i]].x, vec[st[i]].y);
	*/
	double res =0;
	for (i = 1; i < stp; ++i) res += dist (vec[st[i]], vec[st[i-1]]);
	res += dist (vec[st[0]], vec[st[stp-1]]);

	long long aaa[20000];
	for (i = 0; i < 20000; ++i)
		aaa[i] = S (vec[0], vec[1], vec[2]);
	for (i = 1; i < 20000; ++i)
		aaa[i] += aaa[i-1];
	printf ("%Ld\n", aaa);

	printf ("%.9lf\n", res);
	printf ("%d\n", stp);

	return 0;
}
