/*
TASK:kingdom
LANG:C++
*/

#include <cstdio>
#include <queue>

const int MAXN = 110;
const int MAXM = 2200;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

struct pos {
	int a, b;
	pos () {}
	pos (int _a, int _b) : a (_a), b (_b) {}
};


int N, M;
int A1, A2, B1, B2;
int vec[MAXN];
el buf[MAXM];

int cost[MAXN][MAXN];
bool popped[MAXN][MAXN];
std::queue <pos> _q[3];
std::queue <pos> *c = _q, *p1 = _q + 1, *p2 = _q + 2;

void pop (int &a, int &b) {
	if (!c->empty ()) {a = c->front ().a; b = c->front ().b; c->pop ();}
	else {
		std::queue <pos> *tmp = c;
		c = p1;
		p1 = p2;
		p2 = tmp;
		pop (a, b);
	}
}

void push1 (const pos &a) {
	p1->push (a);
}

void push2 (const pos &a) {
	p2->push (a);
}

bool empty () {
	return _q[0].empty () && _q[1].empty () && _q[2].empty ();
}

int _cnt, _cnt2;

void bfs () {
//	static pos queue[MAXN * MAXN];
	static int i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			cost[i][j] = 1000000000;
	cost[A1][B1] = 0;
	push1 (pos (A1, B1));

	int a, b;
	while (!empty ()) {
		pop (a, b);
/*		a = queue[ii].a;
		b = queue[ii].b;*/
		if (popped [a][b]) {
			++_cnt2;
			continue;
		}
		++_cnt;
		popped[a][b] = 1;
//		printf ("popped %d %d -- %d\n", a, b, cost[a][b]);
		for (i = vec[a]; i != -1; i = buf[i].next)
			for (j = vec[b]; j != -1; j = buf[j].next) {
				if (cost[buf[i].to][buf[j].to] > cost[a][b] + (a != buf[i].to) + (b != buf[j].to)
				 && !(buf[i].to == b && buf[i].to == a)
				 && buf[i].to != buf[j].to) {
					cost[buf[i].to][buf[j].to] = cost[a][b] + (a != buf[i].to) + (b != buf[j].to);
//					queue[p3++] = pos (buf[i].to, buf[j].to);
					if ((a != buf[i].to) + (b != buf[j].to) == 1)
						push1 (pos (buf[i].to, buf[j].to));
					else
						push2 (pos (buf[i].to, buf[j].to));
				}
			}
	}
}

int main () {
	scanf ("%d %d %d %d %d %d", &N, &M, &A1, &B1, &A2, &B2);
	--A1, --B1, --A2, --B2;

	int i;
	int a, b, bp = 0;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		buf[bp] = el (b, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, vec[b]);
		vec[b] = bp++;
	}
	
	for (i = 0; i < N; ++i) {//put to sebe si
		buf[bp] = el (i, vec[i]);
		vec[i] = bp++;
	}

	bfs ();

	printf ("%d %d\n", _cnt, _cnt2);
	printf ("%d\n", cost[A2][B2]);

	return 0;
}
