/*
TASK:kingdom
LANG:C++
*/

#include <cstdio>
#include <queue>

const int MAXN = 110;
const int MAXM = 2200;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int cost[MAXN][MAXN];

struct pos {
	int a, b;
	pos () {}
	pos (int _a, int _b) : a (_a), b (_b) {}
	bool operator < (const pos &x) const {return cost[a][b] > cost[x.a][x.b];}
};


int N, M;
int A1, A2, B1, B2;
int vec[MAXN];
el buf[MAXM];

bool popped[MAXN][MAXN];

std::priority_queue <pos> q;

inline bool empty () {
	return q.empty ();
}

inline void push (const pos &a) {
	q.push (a);
}

inline void pop (int &a, int &b) {
	a = q.top ().a;
	b = q.top ().b;
	q.pop ();
}

int _cnt, _cnt2;

void bfs () {
//	static pos queue[MAXN * MAXN];
	static int i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			cost[i][j] = 1000000000;
	cost[A1][B1] = 0;
	push (pos (A1, B1));

	int a, b;
	register int aa, bb;
	while (!empty ()) {
		pop (a, b);
/*		a = queue[ii].a;
		b = queue[ii].b;*/
		if (popped [a][b]) {
			++_cnt2;
			continue;
		}
		++_cnt;
		popped[a][b] = 1;
//		printf ("popped %d %d -- %d\n", a, b, cost[a][b]);
		for (i = vec[a]; i != -1; i = buf[i].next)
			for (j = vec[b]; j != -1; j = buf[j].next) {
				aa = buf[i].to;
				bb = buf[j].to;
				if (cost[aa][bb] > cost[a][b] + (a != aa) + (b != bb)
				 && !(aa == b && bb == a)
				 && aa != bb) {
					cost[aa][bb] = cost[a][b] + (a != aa) + (b != bb);
//					queue[p3++] = pos (buf[i].to, buf[j].to);
					push (pos (aa, bb));
				}
			}
	}
}

int main () {
	scanf ("%d %d %d %d %d %d", &N, &M, &A1, &B1, &A2, &B2);
	--A1, --B1, --A2, --B2;

	int i;
	int a, b, bp = 0;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		buf[bp] = el (b, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, vec[b]);
		vec[b] = bp++;
	}
	
	for (i = 0; i < N; ++i) {//put to sebe si
		buf[bp] = el (i, vec[i]);
		vec[i] = bp++;
	}

	bfs ();

//	printf ("%d %d\n", _cnt, _cnt2);
	printf ("%d\n", cost[A2][B2]);

	return 0;
}
