/*
TASK:kingdom
LANG:C++
*/

#include <cstdio>
#include <queue>

const int MAXN = 1 << 7;

int cost[MAXN][MAXN];

struct pos {
	int a, b;
	pos () {}
	pos (int _a, int _b) : a (_a), b (_b) {}
	bool operator < (const pos &x) const {return cost[a][b] > cost[x.a][x.b];}
};


int N, M;
int A1, A2, B1, B2;

bool ma3x[MAXN][MAXN];
std::vector <int> vec[MAXN];

bool popped[MAXN][MAXN];
std::priority_queue <pos> q;

inline bool empty () {return q.empty ();}
inline void push (const pos &a) {q.push (a);}
inline void pop (int &a, int &b) {a = q.top ().a; b = q.top ().b; q.pop ();}

void bfs () {
	static unsigned i, j;
	for (i = 0; i < (unsigned)N; ++i)
		for (j = 0; j < (unsigned)N; ++j)
			cost[i][j] = 1000000000;

	cost[A1][B1] = 0;
	push (pos (A1, B1));

	int a, b;
	register int aa, bb;
	while (!empty ()) {
		pop (a, b);
		if (popped [a][b]) continue;
		popped[a][b] = 1;
		for (i = 0; i < vec[a].size (); ++i)
			for (j = 0; j < vec[b].size (); ++j) {
				aa = vec[a][i];
				bb = vec[b][j];
				if (ma3x[aa][bb] == 1
				 && cost[aa][bb] > cost[a][b] + (a != aa) + (b != bb)
				 && (aa != b || bb != a)
				 && aa != bb) {
					cost[aa][bb] = cost[a][b] + (a != aa) + (b != bb);
					push (pos (aa, bb));
				}
			}
	}
}

int main () {
	scanf ("%d %d %d %d %d %d", &N, &M, &A1, &B1, &A2, &B2);
	--A1, --B1, --A2, --B2;

	int i;
	int a, b;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		vec[a].push_back (b);
		vec[b].push_back (a);
		ma3x[a][b] = ma3x[b][a] = 1;
	}
	
	for (i = 0; i < N; ++i)//put to sebe si
		vec[i].push_back (i);

	bfs ();

//	printf ("%d %d\n", _cnt, _cnt2);
	printf ("%d\n", cost[A2][B2]);

	return 0;
}
