/*
FROM: BOOI 4
TASK: garden
KEYW: mathematics, computational geometry
LANG: C++
*/

#include <cstdio>
#include <cmath>
#include <algorithm>

const int MAXVAL = 1 << 17;
const int MAXN = 1 << 17;

int D[MAXVAL];

inline int fd (int a) {
	int res =0, i;
	for (i = 1; i * i < a; ++i)
		if (a % i == 0)
			res += i + a / i;
	if (i * i == a) res += i;
	return res;
}

void calcD () {
	D[0] = 0;
	for (int i = 1; i <= 100000; ++i)
		D[i] = fd (i);
}

struct point {
	long long x, y;
	point () {}
	point (long long _x, long long _y) : x (_x), y (_y) {}
	point operator - (const point &a) const {return point (x - a.x, y - a.y);}
	long long sq () const {return x * x + y * y;}
	bool operator == (const point &a) const {return x == a.x && y == a.y;}
};

int N, K;
point vec[MAXN];
int idx[MAXN];

int st[MAXN];
int stp =0;

point A;//base

long long S (const point &a, const point &b, const point &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

bool cmp (int a, int b) {
	static long long tmp;
	return (tmp = S (A, vec[a], vec[b])) ?
			tmp > 0 :
			(vec[a] - A).sq () < (vec[b] - A).sq ();
}

inline long long sq (long long a) {return a * a;}

long double dist (const point &a, const point &b) {
	return sqrtl ((long double)(sq (a.x - b.x) + sq (a.y - b.y)));
}

bool bad () {
	return stp > 1 ? (S (vec[st[stp-2]], vec[st[stp-1]], vec[st[stp]]) <= 0ll) : 0;
}

int main () {
	calcD ();

	scanf ("%d %d", &N, &K);

	int i;
	int a;
	for (i = 0; i < N ; ++i) {
		scanf ("%d", &a);
		vec[i] = point (a % K, D[a] % K);
	}
/*
	for (i = 0; i < N; ++i) printf ("(%Ld %Ld)\n", vec[i].x, vec[i].y);
	printf ("***\n");
*/
	int id = 0;
	for (i = 1; i < N; ++i)
		if (vec[i].y < vec[id].y || (vec[i].y == vec[id].y && vec[i].x > vec[id].x))
			id = i;

	A = vec[id];

	vec[id] = vec[--N];
	vec[N] = A;
	for (i = 0; i < N; ++i) idx[i] = i;

	std::sort (idx, idx + N, cmp);

	st[stp++] = N;//at N stays the Base (Also A)
	for (i = 0; i < N && vec[idx[i]] == A; ++i);
	if (i == N) {printf ("0.000000\n"); return 0;}
	st[stp++] = idx[i];

	for (++i; i < N; ++i) {
		st[stp] = idx[i];

		while (bad ()) {st[stp-1] = st[stp]; --stp;}
		++stp;
	}

	for (i = 0; i < stp; ++i) printf ("(%Ld %Ld)\n", vec[st[i]].x, vec[st[i]].y);

	long double res =0;
	for (i = 1; i < stp; ++i)
		res += dist (vec[st[i]], vec[st[i-1]]);
	res += dist (vec[st[0]], vec[st[stp-1]]);

	printf ("%.6Lf\n", res);

	return 0;
}
