/*
FROM: BOOI 4
TASK: sccdag
KEYW: iterative dfs
LANG: C++
*/

#include <cstdio>
#include <vector>
#include <stack>
#include <algorithm>
#include <queue>

const int MAXN = 1 << 14;


int N, M;
std::vector <std::vector <int> > vec;//prav
std::vector <std::vector <int> > vec2;//obraten

std::vector <std::vector <int> > vec3;//nov

int used[MAXN];
int postnum[MAXN];
int idx[MAXN];

int gr;

bool bfs (int start, int finish) {
	std::queue <int> q;

	bool vis[MAXN] = {0};
	vis[start] = 1;
	q.push (start);

	int crnt;
	while (!q.empty ()) {
		crnt = q.front (); q.pop ();
//		printf ("on top - %d\n", crnt);
		if (crnt == finish) return 1;

		for (int i = 0; i < (int)vec3[crnt].size (); ++i) {
//			printf ("try %d\n", vec3[crnt][i]);
			if (!vis[vec3[crnt][i]]) {
//				printf ("go %d\n", vec3[crnt][i]);
				vis[vec3[crnt][i]] = 1;
				q.push (vec3[crnt][i]);
			}
		}
//		printf ("**\n");
	}
//	printf ("**********000\n");
	return 0;
}

void dfs_rev (int start) {
	std::stack <int> st;

	used[start] = gr;
	st.push (start);

	int crnt;
	while (!st.empty ()) {
		crnt = st.top ();//we do NOT remove it now
//		printf ("on top - %d\n", crnt);

		for (int i = 0; i < (int)vec2[crnt].size (); ++i)
			if (used[vec2[crnt][i]] == -1) {
				used[vec2[crnt][i]] = gr;
				st.push (vec2[crnt][i]);
				goto nxt_while;
			}
	//there is no unused child
//		printf ("REMOVE!\n");
//		postnum[crnt] = PN++;
		st.pop ();//we finaly remove it

	//there IS a child
		nxt_while:;
	}
	++gr;
//	printf ("**********\n");
}

void dfs_postnum (int start) {
	static int PN = 0;
	std::stack <int> st;

	used[start] = 1;
	st.push (start);

	int crnt;
	while (!st.empty ()) {
		crnt = st.top ();//we do NOT remove it now
//		printf ("on top - %d\n", crnt);

		for (int i = 0; i < (int)vec[crnt].size (); ++i)
			if (!used[vec[crnt][i]]) {
				used[vec[crnt][i]] = 1;
				st.push (vec[crnt][i]);
				goto nxt_while;
			}
	//there is no unused child
//		printf ("REMOVE! --- %d\n", PN);
		postnum[crnt] = PN++;
		st.pop ();//we finaly remove it

	//there IS a child
		nxt_while:;
	}
//	printf ("***********88\n");
}

bool cmp (int a, int b) {
	return postnum[a] > postnum[b];
}

int main () {
	scanf ("%d %d", &N, &M);

	vec.resize (N);
	vec2.resize (N);
	int i;
	int a, b;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		vec[a].push_back (b);//pravo rebro
		vec2[b].push_back (a);//obratno rebro
	}
/*
	for (i = 0; i < N; ++i) {
		printf ("%d -> ", i);
		for (int j = 0; j < vec2[i].size (); ++j)
			printf ("%d ", vec2[i][j]);
		printf ("\n");
	}
*/

	for (i = 0; i < N; ++i)
		if (!used[i])
			dfs_postnum (i);

//	for (i = 0; i < N; ++i) printf ("%d ", postnum[i]); printf ("\n");

	for (i = 0; i < N; ++i) {used[i] = -1; idx[i] = i;}

	std::sort (idx, idx + N, cmp);

//	for (i = 0; i < N; ++i) printf ("%d(%d) ", postnum[idx[i]], idx[i]); printf ("\n");

	for (i = 0; i < N; ++i)
		if (used[idx[i]] == -1) dfs_rev (idx[i]);
/*
	printf ("groups:(%d)\n", gr);
	for (i = 0; i < N; ++i) printf ("%d ", used[i]); printf ("\n");
*/
	vec3.resize (gr);
	std::vector <std::vector <bool> > used_arc (gr);
	for (i = 0; i < gr; ++i) used_arc[i].resize (gr);
	int income[MAXN] = {0};

	for (i = 0; i < N; ++i)
		for (int j = 0; j < (int)vec[i].size (); ++j)
			if (used[vec[i][j]] != used[i]) {
//				printf ("%d --- %d (%d %d)\n", used[i], used[vec[i][j]], i, vec[i][j]);
				if(!used_arc[used[i]][used[vec[i][j]]]) {
//					printf ("yep\n");
					used_arc[used[i]][used[vec[i][j]]] = 1;
					vec3[used[i]].push_back (used[vec[i][j]]);
					++income[used[vec[i][j]]];
				}
			}
	printf ("***************\n*****************\n");

	for (i = 0; i < (int)vec3.size (); ++i) {
		printf ("%d -> ", i);
		for (int j = 0; j < (int)vec3[i].size (); ++j)
			printf ("%d ", vec3[i][j]);
		printf ("\n");
	}

	int cntr =0;
	for (i = 0; i < gr; ++i)
		if (!income[i])
			if (bfs (i, used[0]))
				++cntr;

	printf ("%d\n", cntr);

	return 0;
}
