/*
FROM: Central European Olympiad in Informatics (CEOI) 2000 day 1
PROB: caterpillar (caterp)
KEYW: checker
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <vector>
#include <algorithm>

const int MAXN = 1 << 14;

int N;
std::vector <std::vector <int> > gr;
int lbl[MAXN];
int used[MAXN];

int main (int argc, char *argv[]) {
	assert (argc == 4);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
	FILE *sol = fopen (argv[3], "r");

	fscanf (in, "%d", &N);
	gr.resize (N);

	int i, j;
	int a, b;
	for (i = 1; i < N; ++i) {
		fscanf (in, "%d %d", &a, &b);
		--a; --b;
		if (a > b) std::swap (a, b);
		gr[a].push_back (b);
//		gr[b].push_back (a);
	}

	for (i = 0; i < N; ++i) {
		if (fscanf (out, "%d", lbl + i) != 1) {
			printf ("0\nOutput is less than N\n");
			exit (0);
		}
		if (lbl[i] < 1 && lbl[i] > N) {
			printf ("0\nWrong label for vertex %d - %d\n", i + 1, lbl[i]);
			exit (0);
		}
	}

	for (i = 0; i < N; ++i)
		for (j = 0; j < (int)gr[i].size (); ++j) {
			int diff = abs (lbl[i] - lbl[gr[i][j]]);
			if (used[diff])
				printf ("0\nDifference %d used at least twice between %d %d\n", diff, i + 1, gr[i][j] + 1);
			else
				used[diff] = 1;
		}

	printf ("10\nCorrect  Solution\n");

	return 0;
}
