/*
FROM: Central European Olympiad in Informatics (CEOI) 2000 day 1
PROB: caterpillar (caterp)
KEYW: exponential to interval
*/

#include <cstdio>
#include <cassert>
#include <vector>

const int MAXN = 1 << 14;

int N;
std::vector <int> gr[MAXN];
int in[MAXN];
bool is_leaf[MAXN];
int lbl[MAXN];

int dir, lb, ub;
int nxt () {return dir ? lb++ : ub--;}

int main () {
	scanf ("%d", &N);

	int i;
	int a, b;
	for (i = 1; i < N; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		gr[a].push_back (b);
		gr[b].push_back (a);
	}

	for (i = 0; i < N; ++i)
		is_leaf[i] = !(in[i] = gr[i].size () - 1);

	int crnt = -1, prev = -1, aft = -1;
	for (i = 0; i < N; ++i)
		if (is_leaf[i] && !(--in[gr[i][0]])) {
			crnt = gr[i][0];
			break;
		}

	if (crnt == -1) {
		assert (i <= 2);
		printf ("1"); for (i = 2; i <= N; ++i) printf (" %d", i); puts ("");
		return 0;
	}

	lb = 1, ub = N;
	for (;;) {
		lbl[crnt] = nxt ();
		dir = !dir;
		for (i = 0; i < (int)gr[crnt].size (); ++i)
			if (is_leaf[gr[crnt][i]])
				lbl[gr[crnt][i]] = nxt ();
			else if (gr[crnt][i] != prev)
				aft = gr[crnt][i];
		if (aft == -1) break;
		prev = crnt;
		crnt = aft;
		aft = -1;
	}

	printf ("%d", lbl[0]);
	for (i = 1; i < N; ++i) printf (" %d", lbl[i]);
	puts ("");

	return 0;
}
