/*
FROM: Central European Olympiad in Informatics (CEOI) 2000 day 1
PROB: x-planet (x)
KEYW: checker
*/

#include <cstdio>
#include <cassert>
#include <vector>

const int MAXN = 1 << 10;

int N;
std::vector <std::vector <int> > gr;
bool init[MAXN];

int main (int argc, char *argv[]) {
	assert (argc == 4);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
	FILE *sol = fopen (argv[3], "r");

	assert (in && out && sol);

	fscanf (in, "%d", &N);
	gr.resize (N);

	int i;
	int a, b;
	for (i = 0; i < N * 2 - 3; ++i) {
		fscanf (in, "%d %d", &a, &b);
		--a; --b;
		gr[a].push_back (b);
		gr[b].push_back (a);
	}
	for (i = 0; i < N; ++i) gr[i].push_back (i);

	for (i = 0; i < N; ++i) {
		fscanf (in, "%d", &a);
		init[i] = a;
	}

	int is_zero;
	fscanf (sol, "%d", &is_zero);
	if (is_zero == 0) {//there is no solution
		fscanf (out, "%d", &is_zero);
		if (is_zero == 0) {
			printf ("10\nCorrect - no solution\n");
			exit (0);
		} else {
			printf ("0\nIncorrect - found solution in an unsolvable situation\n");
			exit (0);
		}
	}

	while (fscanf (out, "%d", &a) == 1) {
		if (a < 1 && a > N) {
			printf ("0\nincorrect swich (must be [1..N])\n");
			exit (0);
		}
		--a;
		for (i = 0; i < (int)gr[a].size (); ++i)
			init[gr[a][i]] = !init[gr[a][i]];//swap this
	}

	for (i = 0; i < N; ++i)
		if (!init[i]) {
			printf ("0\nbulb %d is off after switching\n", i + 1);
			exit (0);
		}

	printf ("10\nCorrect - found solution\n");

	return 0;
}
