/*
FROM: Central European Olympiad in Informatics (CEOI) 2000 day 1
PROB: x-planet
KEYW: linear equations mod 2
*/

#include <cstdio>
#include <cassert>
#include <cstring>

const int MAX = 64;
const int MAX2 = MAX / 2;
const int MAXN = 1 << 10;

unsigned tmp[MAX];
struct big {
	unsigned m[MAX];
	big () {memset (m, 0, sizeof (m));}
	big& operator ^= (const big &a) {
		for (int i = 0; i < MAX; ++i)
			m[i] ^= a.m[i];
		return *this;
	}
	bool operator != (const big &a) {
		int i;
		for (i = 0; i < MAX2 && m[i] == a.m[i]; ++i);
		return i != MAX2;
	}
	void swap (big &a) {
		memcpy (tmp, m, sizeof (tmp));
		memcpy (m, a.m, sizeof (tmp));
		memcpy (a.m, tmp, sizeof (tmp));
	}
	void set1 (unsigned pos) {m[pos >> 5] |= 1u << (pos & 0x1f);}
	void set2 (unsigned pos) {m[MAX2 + (pos >> 5)] |= 1u << (pos & 0x1f);}
	bool get1 (unsigned pos) {return (m[pos >> 5] >> (pos & 0x1f)) & 1;}
	bool get2 (unsigned pos) {return (m[MAX2 + (pos >> 5)] >> (pos & 0x1f)) & 1;}
};

int N;
big vec[MAXN];
int good_bit[MAXN];

int main () {
	scanf ("%d", &N);

	int i, j;
	unsigned a, b;
	for (i = 0; i < N * 2 - 3; ++i) {
		scanf ("%u %u", &a, &b);
		--a; --b;
		vec[a].set1 (b);
		vec[b].set1 (a);
	}
	for (i = 0; i < N; ++i) {
		vec[i].set1 (i);
		vec[i].set2 (i);
	}

	int crnt = 0;
	for (i = 0; i < N; ++i) {
		for (j = crnt; j < N && !vec[j].get1 (i); ++j);
		if (j == N) continue;//not good
		if (crnt != j) vec[crnt].swap (vec[j]);
		good_bit[crnt] = i;
		for (j = 0; j < crnt; ++j)
			if (vec[j].get1 (i))
				vec[j] ^= vec[crnt];
		for (j = crnt + 1; j < N; ++j)
			if (vec[j].get1 (i))
				vec[j] ^= vec[crnt];

		for (j = 0; j < N; ++j)
			assert (j == crnt || !vec[j].get1 (i));
		++crnt;
	}
/*
	for (j = 0; j < N; ++j)
		printf (" %d", j);
	printf (" |");
	for (j = 0; j < N; ++j)
		printf (" %d", j);
	puts ("\n---------------------------------------------");
	for (i = 0; i < N; ++i) {
		if (i == crnt)
			puts ("------------------------------------------------");
		for (j = 0; j < N; ++j)
			printf (" %d", vec[i].get1 (j));
		printf (" |");
		for (j = 0; j < N; ++j)
			printf (" %d", vec[i].get2 (j));
		printf ("\t%d\n", good_bit[i]);
		puts ("");
	}
*/
	big result;
	big targ;
	int cvp = 0;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &a);
		if (a) continue;
		targ.set1 (i);
		while (cvp < crnt && good_bit[cvp] < i) ++cvp;
		if (cvp < crnt && good_bit[cvp] == i) {
//			printf ("xor %d\n", cvp);
			result ^= vec[cvp];
			++cvp;
		}
	}

	if (result != targ) {
		printf ("0\n");
		return 0;
	}

	for (i = 0; i < N && !result.get2 (i); ++i);
	printf ("%d", i + 1);
	for (++i; i < N; ++i) if (result.get2 (i)) printf (" %d", i + 1);
	puts ("");

	return 0;
}
