/*
FROM: Central European Olympiad in Informatics (CEOI) 2001 day 1
PROB: chain
KEYW: reactive, ad hoc
*/

#include "chain_mod.h"

#include <cstdio>
#include <cassert>
#include <cstring>
#include <ctime>
#include <cstdlib>

#include <queue>
#include <utility>
#include <ext/numeric>

const int MAXN = 1 << 14;

int N;
int vec[MAXN * 2];
int ref[MAXN];
int min_id, max_id;

std::priority_queue <std::pair <int, int> > touched;

int ps;
int pool[MAXN];

int get_from_pool () {
	int ret_id = rand () % ps;
	int ret_val = pool[ret_id];
	pool[ret_id] = pool[--ps];

	return ret_val;
}

std::pair <int, int> get_from_touched () {
	assert (!touched.empty ());
	std::pair <int, int> to_ret = touched.top ();
	touched.pop ();
	return to_ret;
}

int lb () {return max_id - N + 1;}
int ub () {return min_id + N - 1;}

int myspan (int a, int b) {return Span (a + 1, b + 1);}
void myans (int a, int b) {
//	printf ("myand %d %d --> %d %d\n", a, b, a - lb () + 1, b + 1);
	Answer (a - lb () + 1,  b + 1);
}

int main () {
	srand (time (0));
	N = Size ();
	
	__gnu_cxx::iota (pool, pool + N, 0); ps = N;
	memset (vec, -1, sizeof (vec));

//	printf ("cp 0.5\n");

	std::pair <int, int> a, b;
	int c, d, d1, d2, d3, c1, c2;
	c = get_from_pool ();
	d = get_from_pool ();

	d1 = myspan (c, d);

//	printf ("cp 1\n");
	
	ref[c] = MAXN; vec[ref[c]] = c;
	ref[d] = ref[c] + d1; vec[ref[d]] = d;
	min_id = ref[c]; max_id = ref[d];

//	printf ("%d -> %d, %d -> %d\n", c, ref[c], d, ref[d]);

	touched.push (std::make_pair (2, c));
	touched.push (std::make_pair (2, d));

	int np;
	int pc1[2], pc2[2], pc1p, pc2p;
	std::pair <int, int> pc12[2];
	int ii, jj;
//	printf ("are we here??\n");
	while (ps > 1) {
		a = get_from_touched ();
		b = get_from_touched ();
		c = get_from_pool ();
		d = get_from_pool ();
	
//		printf ("got %d (%d)  %d (%d)  -- %d %d\n", a.second, a.first, b.second, b.first, c, d);
	
		d1 = myspan (a.second, c);
		d2 = myspan (b.second, d);
	
		pc1p = pc2p = 0;
		for (c1 = -1; c1 <= 1; c1 += 2) {
			np = ref[a.second] + c1 * d1;
			if (lb () <= np && np <= ub ()
			 && vec[np] == -1) {
				pc1[pc1p++] = np;
			}
		}
		for (c2 = -1; c2 <= 1; c2 += 2) {
			np = ref[b.second] + c2 * d2;
			if (lb () <= np && np <= ub ()
			 && vec[np] == -1) {
				pc2[pc2p++] = np;
			}
		}
		if (pc1p == 1 && pc2p == 1) {
			ref[c] = pc1[0]; vec[ref[c]] = c; min_id <?= ref[c]; max_id >?= ref[c];
			ref[d] = pc2[0]; vec[ref[d]] = d; min_id <?= ref[d]; max_id >?= ref[d];

//			printf ("more than easy found %d -> %d, %d -> %d\n", c, ref[c], d, ref[d]);

			touched.push (std::make_pair (a.first - 1, a.second));
			touched.push (std::make_pair (b.first - 1, b.second));
			touched.push (std::make_pair (2, c));
			touched.push (std::make_pair (2, d));
			continue;
		}
		d3 = myspan (c, d);
	
		int cntr = 0;
		int bii = -1;//, bjj = -1;
//		printf ("possible places : ");
		for (ii = 0; ii < pc1p; ++ii)
			for (jj = 0; jj < pc2p; ++jj)
				if (abs (pc1[ii] - pc2[jj]) == d3) {
					pc12[cntr++] = std::make_pair (ii, jj);
//					printf (" (%d<%d> %d<%d>)", ii, jj, pc1[ii], pc2[jj]);
/*					++cntr;
					bii = ii;
					bjj = jj;
*/
				}
//		puts ("");

		assert (cntr != 0);
		if (cntr == 1) {
			ref[c] = pc1[pc12[0].first ]; vec[ref[c]] = c; min_id <?= ref[c]; max_id >?= ref[c];
			ref[d] = pc2[pc12[0].second]; vec[ref[d]] = d; min_id <?= ref[d]; max_id >?= ref[d];

//			printf ("easy found %d -> %d, %d -> %d\n", c, ref[c], d, ref[d]);

			touched.push (std::make_pair (a.first - 1, a.second));
			touched.push (std::make_pair (b.first - 1, b.second));
			touched.push (std::make_pair (1, c));
			touched.push (std::make_pair (1, d));
		} else {
			if (touched.top ().first == 2
			 || a.first != 2) {
				assert (a.first - 1 < 2 && b.first - 1 < 2);
				touched.push (std::make_pair (a.first - 1, a.second));
				touched.push (std::make_pair (b.first - 1, b.second));
				
				a = get_from_touched ();
			} else {
				--a.first;
				touched.push (std::make_pair (b.first - 1, b.second));
			}

			d3 = myspan (a.second, d);
//			printf ("hardest case - using aux %d (%d) --> d3 == %d\n", a.second, a.first, d3);
			int cntr2 = 0;
			for (ii = 0; ii < cntr; ++ii)
				if (abs (pc2[pc12[ii].second] - ref[a.second]) == d3) {
					bii = ii;
					++cntr2;
				}
			assert (cntr2 == 1);
			touched.push (std::make_pair (a.first - 1, a.second));
			
			ref[c] = pc1[pc12[bii].first ]; vec[ref[c]] = c; min_id <?= ref[c]; max_id >?= ref[c];
			ref[d] = pc2[pc12[bii].second]; vec[ref[d]] = d; min_id <?= ref[d]; max_id >?= ref[d];
			
//			printf ("hardest case - found %d -> %d, %d -> %d\n", c, ref[c], d, ref[d]);
			
			touched.push (std::make_pair (1, c));
			touched.push (std::make_pair (1, d));
		}
	}

/*	printf ("touched:\n");
	while (!touched.empty ()) {
		printf ("%d (%d)\n", touched.top ().second, touched.top ().first);
		touched.pop ();
	}
*/
/*	printf ("i -> ref[i]\n");
	for (int i = 0; i < N; ++i)
		printf ("%d -> %d\n", i, ref[i]);
*/
	if (ps == 1) {
		a = get_from_touched ();
		c = get_from_pool ();
		assert (a.first >= 1);
		d1 = myspan (a.second, c);
		if (lb () <= ref[a.second] + d1 && ref[a.second] + d1 <= ub ()
		 && vec[ref[a.second] + d1] == -1) {
		 	
		 	ref[c] = ref[a.second] + d1; min_id <?= ref[c]; max_id >?= ref[c];
//		 	printf ("!!%d -> %d\n", c, ref[c]);
		 	vec[ref[c]] = c;
		} else {
			assert (lb () <= ref[a.second] - d1 && ref[a.second] - d1 <= ub ()
			 && vec[ref[a.second] - d1] == -1);

			ref[c] = ref[a.second] - d1; min_id <?= ref[c]; max_id >?= ref[c];
//			printf ("!!%d -> %d\n", c, ref[c]);
			vec[ref[c]] = c;
		}
	}
/*
	printf ("i -> ref[i]\n");
	for (int i = 0; i < N; ++i)
		printf ("%d -> %d\n", i, ref[i]);
*/

	for (int i = lb (); i <= ub (); ++i)
		myans (i, vec[i]);

	return 0;
}
