/*
FROM: Central European Olympiad in Informatics (CEOI) 2001 day 1
PROB: trip
KEYW: checker
*/

#include <cstdio>
#include <cstring>
#include <cassert>

const int MAXN = 1 << 10;//1 000
const int MAXM = 1 << 18;//250 000
const int MAX_LINE_LEN = 1 << 20;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int S, D;
int N, M;
int vec[MAXN];
el buf[MAXM];
unsigned emask[MAXM];

void app_mask (int fr, int to, unsigned mask) {
	int i;
	for (i = vec[fr]; i != -1 && buf[i].to != to; i = buf[i].next);
	assert (i != -1);
//	printf ("\tedge %d(%d)\n", i, i ^ 1);
	emask[i] |= mask;
	emask[i ^ 1] |= mask;
}

void read_line (FILE *fp, int _start, int _finish, unsigned mask) {
//	fprintf (stderr, "read line %d %d %d\n", _start, _finish, mask);
	static char line[MAX_LINE_LEN], *lp;
	fgets (line, MAX_LINE_LEN, fp);
	lp = line;
	int prev, crnt;
	int br;//bytes read
	sscanf (lp, "%d%n", &prev, &br);
	--prev; lp += br;
	assert (prev == _start);
//	fprintf (stderr, "before while!\n");
	while (sscanf (lp, "%d%n", &crnt, &br) == 1) {
		--crnt;
		app_mask (prev, crnt, mask);
		lp += br;
		prev = crnt;
//		fprintf (stderr, "\tprev is %d\n", prev);
	}
//	fprintf (stderr, "out of while!\n");
	assert (prev == _finish);
}

int main (int argc, char *argv[]) {
	assert (argc == 4);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
	FILE *sol = fopen (argv[3], "r");
	assert (in && out && sol);

	fscanf (in, "%d %d", &S, &D);
	--S; --D;
	fscanf (in, "%d %d", &N, &M);
	memset (vec, -1, sizeof (vec));
	int i;
	int a, b;
	int bp = 0;
	for (i = 0; i < M; ++i) {
		fscanf (in, "%d %d", &a, &b);
		--a; --b;

		buf[bp] = el (b, vec[a]);
		vec[a] = bp++;
		buf[bp] = el (a, vec[b]);
		vec[b] = bp++;
	}
	fclose (in);

	int dup_sol, dup_out;
	int r_dup_sol = 0, r_dup_out = 0;
	fscanf (sol, "%d\n", &dup_sol);
	if (dup_sol == -1) goto nxt;

	read_line (sol, S, D, 1);
	read_line (sol, D, S, 2);

	for (i = 0; i < bp; i += 2)
		if ((emask[i] & 0x3) == 0x3)
			++r_dup_sol;

	nxt:;
	fscanf (out, "%d\n", &dup_out);
	if (dup_out == -1) goto nxt2;

	read_line (out, S, D, 4);
	read_line (out, D, S, 8);

	for (i = 0; i < bp; i += 2)
		if ((emask[i] & 0xc) == 0xc)
			++r_dup_out;

	assert (r_dup_sol == dup_sol);
	assert (r_dup_out == dup_out);

	nxt2:;
	assert (dup_sol == dup_out);

	printf ("everything seems correct!\n");

	return 0;
}
