/*
FROM: Central European Olympiad in Informatics (CEOI) 2001 day 1
PROB: circuit
KEYW: minimal spanning tree
*/

#include <cstdio>
#include <cassert>
#include <utility>

const int MAXN = 1 << 7, MAXM = MAXN;
const int MAXNM = MAXN * MAXM;

const int dx [] = {1, 0};
const int dy [] = {0, 1};

int N, M;
int NM;

int a[MAXNM];
int sz[MAXNM];

bool connect (int x, int y) {
	static int p, q;
	for (p = x; p != a[p]; p = a[p]) a[p] = a[a[p]];
	for (q = y; q != a[q]; q = a[q]) a[q] = a[a[q]];
	printf ("con %d %d --> %d %d\n", x, y, p, q);
	if (p == q) return 0;
	if (sz[p] > sz[q]) {
		a[q] = p;
		sz[p] += sz[p];
	} else {
		a[p] = q;
		sz[q] += sz[p];
	}
	return 1;
}

inline int to_one (int x, int y) {
	return x * M + y;
}

int ans1, ans2, ap;
std::pair <std::pair <int, int>, int> ans3[MAXNM];

int main () {
	scanf ("%d %d", &N, &M);
	NM = N * M;

	int i, j, k;
	int t;
	for (i = 0; i < NM; ++i) {sz[i] = 1; a[i] = i;}
	for (i = 0; i < N; ++i)
		for (j = 0; j < M; ++j) {
			scanf ("%d", &t);
			for (k = 0; k < 2; ++k) {
				if (t & (1 << k)) {
					printf ("%d %d %d %d\n", i, j, k, t);
					printf ("-->%d %d\n", i + dx[k], j + dy[k]);
					assert (i + dx[k] < N && j + dy[k] < M);
					connect (to_one (i, j), to_one (i + dx[k], j + dy[k]));
				}
			}
		}

	for (k = 0; k < 2; ++k)
		for (i = 0; i < N - 1; ++i)
			for (j = 0; j < M; ++j)
				if (i + dx[k] < N
				 && j + dy[k] < M
				 && connect (to_one (i, j), to_one (i + dx[k], j + dy[k]))) {
					++ans1;
					ans2 += k + 1;
					ans3[ap++] = std::make_pair (std::make_pair (i, j), k + 1);
				}

	printf ("%d %d\n", ans1, ans2);
	for (i = 0; i < ap; ++i)
		printf ("%d %d %d\n", ans3[i].first.first + 1, ans3[i].first.second + 1, ans3[i].second);

	return 0;
}
