/*
FROM: Central European Olympiad in Informatics (CEOI) 2001 day 2
PROB: select
KEYW: powers of 2, interactive, stack
*/

#include "select_mod.h"

#include <cstdio>
#include <cstdlib>
#include <cassert>

const int MAXN = 1 << 15;
const int MAXG = MAXN / 2;

struct grp {
	int sz;
	int id;
	grp () {}
	grp (int _sz, int _id) : sz (_sz), id (_id) {}
};

int N;
int sp, cp;
grp stk[MAXG];

bool myask (int a, int b) {
	return Member (a + 1, b + 1);
}

void myans (int a) {
	Answer (a + 1);
	exit (0);
}

void stk_add (const grp &a) {
	stk[sp++] = a;
	
	while (sp >= 2 && stk[sp-1].sz == stk[sp-2].sz)
		if (myask (stk[sp-1].id, stk[sp-2].id)) {//same
			--sp;
			stk[sp-1].sz *= 2;//concatanate both groups
		} else {//different
			sp -= 2;//erase both
			break;
		}

	printf ("%d %d > %d <--\n", sp, stk[0].sz, N - cp - 2);
	if (sp == 1 && stk[0].sz > N - cp - 2)
		myans (stk[0].id);

	for (int i = 0; i < sp; ++i)
		printf ("grp %d %d\n", stk[i].sz, stk[i].id);
}

int main () {
	N = Size ();

	for (cp = 0; cp != N - 1; cp += 2)
		if (myask (cp, cp + 1))
			stk_add (grp (2, cp));

	printf ("sp last %d\n", sp);
	stk[sp++] = grp (1, N-1);
	printf ("%d %d\n", stk[0].sz, stk[0].id);

	myans (stk[0].id);

	return 0;
}
