/*
FROM: Central European Olympiad in Informatics (CEOI) 2001 day 1
PROB: trip (round trip)
KEYW: artic edges, bfs
*/

#include <cstdio>
#include <cstring>
#include <cassert>

const int MAXN = 1 << 10;
const int MAXM = 1 << 18;

struct el {
	int to;
	int cap;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), cap (1), next (_next) {}
};

int S, D;
int N, M;
int vec[MAXN];
el buf[MAXM];

int prenum[MAXN];
int lowest[MAXN];
int prev[MAXN];

void dfs (int v) {
	static int pn;
	lowest[v] = prenum[v] = ++pn;
	for (int i = vec[v]; i != -1; i = buf[i].next) {
		if (buf[i].to == prev[v]) continue;
		if (!prenum[buf[i].to]) {
			prev[buf[i].to] = v;
			dfs (buf[i].to);
			if (lowest[buf[i].to] > prenum[v]) {//this edge is artic
//				printf ("artic edge %d %d\n", v, buf[i].to);
				buf[i].cap = 2;
				buf[i^1].cap = 2;
			}
			lowest[v] <?= lowest[buf[i].to];
		} else
			lowest[v] <?= prenum[buf[i].to];
	}
}


void bfs (int s) {
	static int q[MAXN], p3, c;
	int i, j;
	memset (prev, -1, sizeof (prev));
	q[p3 = 0, p3++] = s;
	prev[s] = -2;
	for (i = 0; i < p3; ++i) {
		c = q[i];
//		printf ("popped %d\n", c);
		for (j = vec[c]; j != -1; j = buf[j].next) {
//			printf ("try %d -- %d %d\n", buf[j].to, prev[buf[j].to] != -1, !buf[j].cap);
			if (prev[buf[j].to] != -1 || !buf[j].cap) continue;
//			printf ("push %d -- %d\n", buf[j].to, j);
			prev[buf[j].to] = j;
			q[p3++] = buf[j].to;
		}
	}
}

int main () {
	scanf ("%d %d", &S, &D);
	--S, --D;
	scanf ("%d %d", &N, &M);

	int i;
	int a, b, bp = 0;
	memset (vec, -1, sizeof (vec));
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		buf[bp] = el (b, vec[a]);
		vec[a] = bp++;
		buf[bp] = el (a, vec[b]);
		vec[b] = bp++;
	}

	dfs (S);
	if (!prenum[D]) {
		printf ("-1\n");
		return 0;
	}

	static int ans[MAXN], ap;
	int dup = 0;
	bfs (S);

	for (i = D; i != S; i = buf[prev[i] ^ 1].to) {
		ans[ap++] = i;
		if (--buf[prev[i]].cap) {
//			printf ("edge %d %d\n", buf[prev[i]^1].to, buf[prev[i]].to);
			++dup;
		}
	}

	printf ("%d\n%d", dup, S + 1);
	for (i = ap - 1; i >= 0; --i)
		printf (" %d", ans[i] + 1);
	puts ("");
	bfs (S);
	for (i = D, ap = 0; i != S; i = buf[prev[i] ^ 1].to) {
		printf ("%d ", i + 1);
		assert (!(--buf[prev[i]].cap));
	}
	printf ("%d\n", S + 1);

	return 0;
}
