/*
FROM: Central European Olympiad in Informatics (CEOI) 2002 day 1
PROB: bugs
KEYW: dynamical programming with mask (base 3)
*/

#include <cstdio>
#include <cassert>
#include <cstring>

const int MAXN = 160;
const int MAXM = 16;//10
const int MAXMASK = 1 << 16;//3 ^ 10

const int dx1[] = { 0,  0,  0, -1, -1, -1};
const int dy1[] = { 0, -1, -2,  0, -1, -2};
const int dx2[] = { 0,  0, -1, -1, -2, -2};
const int dy2[] = { 0, -1,  0, -1,  0, -1};

int N, M;
bool bug[MAXN][MAXM];

int dp[MAXM][MAXMASK];
int vec[MAXM];

int encode () {
	static int res, i;
	for (i = M - 1, res = 0; i >= 0; --i) {
		res *= 3;
		res += vec[i];
	}
	return res;
}

int main () {
	int tc, bc;
	scanf ("%d", &tc);

	int r, c;
	int i;
	int m, k;//, mm;
	int x, y;
	int p;
//	int p1, p2 = -1, p3 = -1;
	int real_max_mask;
//	for (i = pow3[0] = 1; i < MAXM; ++i) pow3[i] = pow3[i-1] * 3;
	while (tc--) {
		scanf ("%d %d", &N, &M);
		for (i = 0, real_max_mask = 1; i < M; ++i) real_max_mask *= 3;
		memset (bug, 0, sizeof (bug));

		scanf ("%d", &bc);
		for (i = 0; i < bc; ++i) {
			scanf ("%d %d", &x, &y);
			--x; --y;
			bug[x][y] = 1;
		}
	
		memset (dp[M-1], 0, sizeof (int) * MAXMASK);
		p = M-1;
		for (r = 1; r < N; ++r) {
			for (c = 0; c < M; ++c) {
//				memset (vec, 0, sizeof (vec));
				for (m = 0; m < real_max_mask; ++m) {
//					for (i = 0; i < M; ++i) printf (" %d", vec[i]); printf ("  %d\n", m);

					x = vec[c];
					vec[c] = vec[c] == 2;
					dp[c][m] = dp[p][encode ()];
					vec[c] = x;

					if (r >= 1 && c >= 2
					 && !vec[c] && !vec[c-1] && !vec[c-2]) {
						for (k = 0; k < 6 && !bug[r + dx1[k]][c + dy1[k]]; ++k);
						if (k == 6) {
							vec[c] = vec[c-1] = vec[c-2] = 1;
							dp[c][m] >?= 1 + dp[c == 2 ? M - 1 : c - 3][encode ()];
							vec[c] = vec[c-1] = vec[c-2] = 0;
						}
					}

					if (r >= 2 && c >= 1
					 && !vec[c] && !vec[c-1]) {
						for (k = 0; k < 6 && !bug[r + dx2[k]][c + dy2[k]]; ++k);
						if (k == 6) {
							vec[c] = vec[c-1] = 2;
							dp[c][m] >?= 1 + dp[c == 1 ? M - 1 : c - 2][encode ()];
							vec[c] = vec[c-1] = 0;
						}
					}
					for (i = 0; i < M && vec[i] == 2; ++i) vec[i] = 0;
					if (i < M) ++vec[i];
				}
				p = c;
			}
		}

		printf ("%d\n", dp[M-1][0]);
	}

	return 0;
}
