/*
FROM: Central European Olympiad in Informatics (CEOI) 2002 day 1
PROB: bugs
KEYW: dynamical programming with mask (base 3)
*/

#include <cstdio>
#include <cstring>

const int MAXN = 150;
const int MAXM = 16;//10
const int MAXMASK = 1 << 16;//3 ^ 10

const int dx1[] = { 0,  0,  0, -1, -1, -1};
const int dy1[] = { 0, -1, -2,  0, -1, -2};
const int dx2[] = { 0,  0, -1, -1, -2, -2};
const int dy2[] = { 0, -1,  0, -1,  0, -1};

int N, M;
bool bug[MAXN][MAXM];

int dp[MAXM][MAXMASK];

void decode (int code, int *bo) {
	static int i;
	for (i = 0; i < M; ++i) {
		bo[i] = code % 3;
		code /= 3;
	}
}

int encode (int *bo, int type, int pos) {
	static int i, res;
	for (i = M-1, res = 0; i >= 0; --i) {
		res *= 3;
		if (i > pos)
			res += bo[i];
		else if (type == 0 && pos == i)
			res += bo[i] == 2;
		else if (type == 1 && i > pos - 3)
			res += 1;
		else if (type == 2 && i > pos - 2)
			res += 2;
		else
			res += bo[i];
	}
//	for (i = 0; i < M; ++i) printf (" %d", bo[i]); printf (" | %d %d -> %d\n", type, pos, res);
//	static int tmp[MAXM];
//	decode (res, tmp);
//	for (i = 0; i < M; ++i) printf (" %d", tmp[i]); printf (" | check!\n");
	return res;
}

int pow3[MAXM];

int main () {
	int tc, bc;
	scanf ("%d", &tc);


	int r, c;
	int i;
	int m, k;
	int x, y;
	int p;
	int real_max_mask;
	static int bo1[MAXM];//bad offset (returned by decode and argument to encode)
	for (i = pow3[0] = 1; i < MAXM; ++i) pow3[i] = pow3[i-1] * 3;
	while (tc--) {
		scanf ("%d %d", &N, &M);
		real_max_mask = pow3[M];
		memset (bug, 0, sizeof (bug));

		scanf ("%d", &bc);
		for (i = 0; i < bc; ++i) {
			scanf ("%d %d", &x, &y);
			--x; --y;
			bug[x][y] = 1;
		}
	
		memset (dp[M-1], 0, sizeof (int) * MAXMASK);
		p = M-1;
		for (r = 1; r < N; ++r) {
			for (c = 0; c < M; ++c) {
				for (m = 0; m < real_max_mask; ++m) {
					decode (m, bo1);
					dp[c][m] = dp[p][encode (bo1, 0, c)];
				
					if (r >= 1 && c >= 2
					 && !bo1[c]
					 && !bo1[c-1]
					 && !bo1[c-2]) {
						for (k = 0; k < 6 && !bug[r + dx1[k]][c + dy1[k]]; ++k);
						if (k == 6) {
//							printf ("<< %d %d %d --> checked:", r, c, m);\
							for (k = 0; k < 6; ++k) printf ("(%d %d _%d)", r + dx1[k], c + dy1[k], bug[r + dx1[k]][c + dy1[k]]); puts ("");
							dp[c][m] >?= 1 + dp[p][encode (bo1, 1, c)];
						}
					}

					if (r >= 2 && c >= 1
					 && !bo1[c]
					 && !bo1[c-1]) {
						for (k = 0; k < 6 && !bug[r + dx2[k]][c + dy2[k]]; ++k);
						if (k == 6) {
//							printf ("<< %d %d %d --> checked:", r, c, m);\
							for (k = 0; k < 6; ++k) printf ("(%d %d _%d)", r + dx2[k], c + dy2[k], bug[r + dx2[k]][c + dy2[k]]); puts ("");
							dp[c][m] >?= 1 + dp[p][encode (bo1, 2, c)];
						}
					}
//					for (i = 0; i < M; ++i) printf (" %d", bo1[i]); printf (" (%d) %d %d == %d <%d %d - %d>\n", m, r, c, dp[c][m], p, encode (bo1, 0, c), dp[p][encode (bo1, 0, c)]);
				}
				p = c;
			}
		}

		printf ("%d\n", dp[M-1][0]);
	}


	return 0;
}
