/*
FROM: Central European Olympiad in Informatics (CEOI) 2002 day 1
PROB: bugs
KEYW: dynamical programming with mask (base 3)
*/

#include <cstdio>
#include <cassert>
#include <cstring>

const int MAXN = 150;
const int MAXM = 16;//10
const int MAXMASK = 1 << 16;//3 ^ 10

const int dx1[] = { 0,  0,  0, -1, -1, -1};
const int dy1[] = { 0, -1, -2,  0, -1, -2};
const int dx2[] = { 0,  0, -1, -1, -2, -2};
const int dy2[] = { 0, -1,  0, -1,  0, -1};

int N, M;
bool bug[MAXN][MAXM];

int dp[MAXM][MAXMASK];

void decode (int code, int *bo) {
	static int i;
	for (i = 0; i < M; ++i) {
		bo[i] = code % 3;
		code /= 3;
	}
}

int encode (int code, int type, int pos) {
	static int bo[MAXM];
	decode (code, bo);

	static int i, res;
	for (i = M-1, res = 0; i >= 0; --i) {
		res *= 3;
		if (i > pos)
			res += bo[i];
		else if (type == 0 && pos == i)
			res += bo[i] == 2;
		else if (type == 1 && i > pos - 3)
			res += 1;
		else if (type == 2 && i > pos - 2)
			res += 2;
		else
			res += bo[i];
	}
/*
	for (i = 0; i < M; ++i) printf (" %d", bo[i]); printf (" | %d %d -> %d\n", type, pos, res);
	static int tmp[MAXM];
	decode (res, tmp);
	for (i = 0; i < M; ++i) printf (" %d", tmp[i]); printf (" | check!\n");*/
	return res;
}


int pow3[MAXM];
inline int get (int code, int pos) {
/*	if (pow3[pos] == 0) {
		printf ("pos == %d\n", pos);
		assert (0);
	}*/
	return code / pow3[pos] % 3;
}

#define SETX(code,pos,val,get) ((((val) - (get)) * pow3[(pos)]) + (code))
#define SET(code,pos,val) (val * pow3[pos] + code)

/*inline int set (int code, int pos, int val) {
	return (val - get (code, pos)) * pow3[pos] + code;
}
*/

int main () {
	int tc, bc;
	scanf ("%d", &tc);


	int r, c;
	int i;
	int m, k, mm;
	int x, y;
	int p;
	int p1, p2 = -1, p3 = -1;
	int real_max_mask;
//	static int bo1[MAXM];//bad offset (returned by decode and argument to encode)
	for (i = pow3[0] = 1; i < MAXM; ++i) pow3[i] = pow3[i-1] * 3;
	while (tc--) {
		scanf ("%d %d", &N, &M);
		real_max_mask = pow3[M];
		memset (bug, 0, sizeof (bug));

		scanf ("%d", &bc);
		for (i = 0; i < bc; ++i) {
			scanf ("%d %d", &x, &y);
			--x; --y;
			bug[x][y] = 1;
		}
	
		memset (dp[M-1], 0, sizeof (int) * MAXMASK);
		p = M-1;
		for (r = 1; r < N; ++r) {
			for (c = 0; c < M; ++c) {
				for (m = 0; m < real_max_mask; ++m) {
								p1 = get (m, c);
					if (c >= 1) p2 = get (m, c-1);
					if (c >= 2) p3 = get (m, c-2);

					assert (SETX (m, c, (p1 == 2), p1) == encode (m, 0, c));
					dp[c][m] = dp[p][SETX (m, c, (p1 == 2), p1)];

					if (r >= 1 && c >= 2
					 && !p1
					 && !p2
					 && !p3) {
						for (k = 0; k < 6 && !bug[r + dx1[k]][c + dy1[k]]; ++k);
						if (k == 6) {
//							printf ("<< %d %d %d --> checked:", r, c, m);\
							for (k = 0; k < 6; ++k) printf ("(%d %d _%d)", r + dx1[k], c + dy1[k], bug[r + dx1[k]][c + dy1[k]]); puts ("");
							mm = SET (m, c, 1);
//							assert (get (mm, c) == 1);

//							assert (get (mm, c-1) == p2);
							mm = SET (mm, c-1, 1);
//							assert (get (mm, c-1) == 1);

//							assert (get (mm, c-2) == p3);
							mm = SET (mm, c-2, 1);
//							assert (get (mm, c-2) == 1);

//							assert (mm == encode (m, 1, c));
							dp[c][m] >?= 1 + dp[p][mm];
						}
					}

					if (r >= 2 && c >= 1
					 && !p1
					 && !p2) {
						for (k = 0; k < 6 && !bug[r + dx2[k]][c + dy2[k]]; ++k);
						if (k == 6) {
//							printf ("<< %d %d %d --> checked:", r, c, m);\
							for (k = 0; k < 6; ++k) printf ("(%d %d _%d)", r + dx2[k], c + dy2[k], bug[r + dx2[k]][c + dy2[k]]); puts ("");
							mm = SET (m, c, 2);
//							assert (get (mm, c) == 2);

//							assert (get (mm, c-1) == p2);
							mm = SET (mm, c-1, 2);
//							assert (get (mm, c-1) == 2);

//							assert (mm == encode (m, 2, c));
							dp[c][m] >?= 1 + dp[p][mm];
						}
					}
//					for (i = 0; i < M; ++i) printf (" %d", bo1[i]); printf (" (%d) %d %d == %d <%d %d - %d>\n", m, r, c, dp[c][m], p, encode (bo1, 0, c), dp[p][encode (bo1, 0, c)]);
				}
				p = c;
			}
		}

		printf ("%d\n", dp[M-1][0]);
	}


	return 0;
}
