/*
FROM: Central European Olympiad in Informatics (CEOI) 2002 day 1
PROB: bugs
KEYW: dynamical programming with mask (base 3)
*/

#include <cstdio>
#include <cassert>
#include <cstring>

const int MAXN = 160;
const int MAXM = 16;//10
const int MAXMASK = 1 << 16;//3 ^ 10

const int dx1[] = { 0,  0,  0, -1, -1, -1};
const int dy1[] = { 0, -1, -2,  0, -1, -2};
const int dx2[] = { 0,  0, -1, -1, -2, -2};
const int dy2[] = { 0, -1,  0, -1,  0, -1};

int N, M;
bool bug[MAXN][MAXM];

int dp[MAXM][MAXMASK];

int pow3[MAXM];
inline int get (int code, int pos) {
	return code / pow3[pos] % 3;
}

#define SETX(code,pos,val,get) ((((val) - (get)) * pow3[(pos)]) + (code))
#define SET(code,pos,val) (val * pow3[pos] + code)

int main () {
	int tc, bc;
	scanf ("%d", &tc);


	int r, c;
	int i;
	int m, k, mm;
	int x, y;
	int p;
	int p1, p2 = -1, p3 = -1;
	int real_max_mask;
	for (i = pow3[0] = 1; i < MAXM; ++i) pow3[i] = pow3[i-1] * 3;
	while (tc--) {
		scanf ("%d %d", &N, &M);
		real_max_mask = pow3[M];
		memset (bug, 0, sizeof (bug));

		scanf ("%d", &bc);
		for (i = 0; i < bc; ++i) {
			scanf ("%d %d", &x, &y);
			--x; --y;
			bug[x][y] = 1;
		}
	
		memset (dp[M-1], 0, sizeof (int) * MAXMASK);
		p = M-1;
		for (r = 1; r < N; ++r) {
			for (c = 0; c < M; ++c) {
				for (m = 0; m < real_max_mask; ++m) {
								p1 = get (m, c);
					if (c >= 1) p2 = get (m, c-1);
					if (c >= 2) p3 = get (m, c-2);

					dp[c][m] = dp[p][SETX (m, c, (p1 == 2), p1)];

					if (r >= 1 && c >= 2
					 && !p1 && !p2 && !p3) {
						for (k = 0; k < 6 && !bug[r + dx1[k]][c + dy1[k]]; ++k);
						if (k == 6) {
							mm = SET (m, c, 1);
							mm = SET (mm, c-1, 1);
							mm = SET (mm, c-2, 1);
							dp[c][m] >?= 1 + dp[c == 2 ? M - 1 : c - 3][mm];
						}
					}

					if (r >= 2 && c >= 1
					 && !p1 && !p2) {
						for (k = 0; k < 6 && !bug[r + dx2[k]][c + dy2[k]]; ++k);
						if (k == 6) {
							mm = SET (m, c, 2);
							mm = SET (mm, c-1, 2);
							dp[c][m] >?= 1 + dp[c == 1 ? M - 1 : c - 2][mm];
						}
					}
				}
				p = c;
			}
		}

		printf ("%d\n", dp[M-1][0]);
	}


	return 0;
}
