/*
FROM: Central European Olympiad in Informatics (CEOI) 2002 day 1
PROB: conqueror
KEYW: reactive game, mathematics
*/

#include "conquer_mod.h"

#include <cstdio>
#include <cstring>
#include <cassert>

const int MAXN = 1 << 12;//4000

int N;
int _v1[MAXN], _v2[MAXN];
int *all = _v1, *sub = _v2;
int allc, subc;

void my_swap () {
	int *tmp = all;
	all = sub;
	sub = tmp;
	int tmpi = allc;
	allc = subc;
	subc = tmpi;
}

bool can_win () {
	int need = 2;
	for (int i = 2; i <= N; ++i) {
		if (need > allc) return 0;
		if (need <= all[i])
			return 1;
		else
			need -= all[i];
		need *= 2;
	}
	return 0;
}

void divide (int init, int mul) {
	int need = init;
	memset (sub, 0, sizeof (int) * MAXN / 2);
	subc = 0;
	for (int i = 2; i <= N; ++i) {
//		printf ("stair %d, need %d\n", i, need);
		assert (need <= allc);
		if (need <= all[i]) {
			all[i] -= need; allc -= need;
			sub[i]  = need; subc += need;
			return;//we are done
		} else {
			need -= all[i];
			sub[i]  = all[i]; subc += all[i];
			allc -= all[i]; all[i] = 0;
		}
		need *= mul;
	}
	assert (0);
}
/*
void half_divide () {
	int need = (allc + 1) / 2;
	sub[0] = sub[1] = 0;
	for (i = 2; i <= N; ++i) {
		if (need <= all[i]) {
			all[i] -= need; allc -= need;
			sub[i]  = need; subc += need;
			return;//we are done
		} else {
			need -= all[i];
			sub[i] = all[i]; subc += all[i];
			allc -= all[i]; all[i] = 0;
		}
	}
	assert (0);
}
*/
int main () {
	start (&N, all);

	int i;
	for (i = 1; i <= N; ++i) allc += all[i];

	bool win = can_win (); printf ("we win? -- %d\n", win);

//	for (i = 0; i <= N; ++i) printf (" %d", all[i]); puts ("");

	for (;;) {
		if (win) 	divide (1, 2);
		else		divide ((allc + 1) / 2, 1);

//		for (i = 0; i <= N; ++i) printf (" %d", sub[i]); printf ("sub (%d)\n", subc);

		if (step (sub) == 1)
			my_swap ();

		++all;
//		for (i = 0; i <= N; ++i) printf (" %d", all[i]); printf (" new (%d)\n", allc);
	}

	return 0;
}
