/*
FROM: Central Europen Olympiad in Informatics (CEOI) 2002 day 1
PROB: fence
KEYW: dynamical programming, decoding combinatorial objects
*/

#include <cstdio>
#include <vector>
#include <cassert>

#warning try with N == 1 and N == 2
#warning scan input with long long

const int MAXN = 32;
const int rMAXN = 20;

long long dp[MAXN][MAXN];

void fill_dp () {
	int i, j;
	dp[0][0] = 1;
	for (i = 1; i <= rMAXN; ++i) {
		dp[i][1] = dp[i-1][i-1];
		for (j = 2; j <= i; ++j)
			dp[i][j] = dp[i][j-1] + dp[i-1][i-j];
	}

/*	for (i = 0; i <= rMAXN; ++i) {
		for (j = 0; j <= i; ++j)
			printf (" %5Ld", dp[i][j]);
		puts ("");
	}
*/
}

int main () {
	fill_dp ();

	int K;
	scanf ("%d", &K);

	int N;
	long long C;
	int i, j, u = -1;
	bool flag;
	std::vector <int> rem_dig;
	while (K--) {
		scanf ("%d %Ld", &N, &C);
		--C;

		flag = 0;
		for (i = 0; i < N; ++i) {
			if ((C -= dp[N-1][i]) < 0) {
				C += dp[N-1][i];
				u = i;
				break;
			}
			if ((C -= dp[N-1][N-1-i]) < 0) {
				C += dp[N-1][N-1-i];
				u = N-1-i;
				flag = 1;
				break;
			}
		}
		assert (i != N);

//		printf ("u,f,C  %d %d %Ld\n", u, flag, C);

		rem_dig.clear ();
		for (j = 1; j <= N; ++j) rem_dig.push_back (j);
		printf ("%d", rem_dig[i]); rem_dig.erase (rem_dig.begin () + i);

		for (i = N-1; i > 0; --i) {
//			printf ("r,u,f %d %d %d\n", i, u, flag);
			if (flag) {//dec srch
				for (j = i - u; j < i && (C -= dp[i-1][j]) >= 0; ++j);
				C += dp[i-1][j];
				printf (" %d", rem_dig[j]); rem_dig.erase (rem_dig.begin () + j);
			} else {//inc srch
				for (j = i - 1; j >= i - u && (C -= dp[i-1][j]) >= 0; --j);
				C += dp[i-1][j];
				printf (" %d", rem_dig[i-j-1]); rem_dig.erase (rem_dig.end () - j - 1);
			}
			u = j;
			flag = !flag;
		}
		puts ("");
	}

	return 0;
}
