/*
FROM: Central European Olympiad in Informatics (CEOI) 2003 day 1
PROB: hanoi
KEYW: hanoi towers, dynamical programming
*/

#include <cstdio>
#include <cassert>

const int MAXN = 1 << 17;
const int MOD = 1000000;
const int INF = 4000000;

int N;
int pid[MAXN];

int main () {
	scanf("%d",&N);

	static int pc[3];
	int i, k;
	int a;
	scanf ("%d %d %d", pc, pc + 1, pc + 2);
	for (k = 0; k < 3; ++k)
		for (i = 0; i < pc[k]; ++i) {
			scanf ("%d", &a);
			pid[--a] = k;
		}

	static int dp[3], t[3];
	int mva = 1;
	dp[pid[0]] = 0;
	dp[(pid[0]+1)%3] = 1;
	dp[(pid[0]+2)%3] = 1;
//	set_dp (pid[0], mva);
	for (i = 1; i < N; ++i) {
		t[0] = t[1] = t[2] = INF;

		t[pid[i]] <?= dp[pid[i]];
//		t[pid[i]] <?= dp[(pid[i]+1)%3] + mva;
//		t[pid[i]] <?= dp[(pid[i]+2)%3] + mva;

//		t[(pid[i]+1)%3] <?= dp[pid[i]] + 2 * mva + 1;
//		t[(pid[i]+1)%3] <?= dp[(pid[i]+1)%3] + 2 * mva + 1;
		t[(pid[i]+1)%3] <?= dp[(pid[i]+2)%3] + mva + 1;

//		t[(pid[i]+2)%3] <?= dp[pid[i]] + 2 * mva + 1;
		t[(pid[i]+2)%3] <?= dp[(pid[i]+1)%3] + mva + 1;
//		t[(pid[i]+2)%3] <?= dp[(pid[i]+2)%3] + 2 * mva + 1;

		dp[0] = t[0] % MOD;
		dp[1] = t[1] % MOD;
		dp[2] = t[2] % MOD;

		mva = (mva * 2 + 1) % MOD;
	}

//	int min = dp[0] <? dp[1] <? dp[2];
//	int mini = (min == dp[0] ? 0 : min == dp[1] ? 1 : 2);
//	assert (mini == pid[N-1]);
	printf ("%d\n%d\n", pid[N-1], dp[pid[N-1]]);

	return 0;
}
