/*
FROM: Central European Olympiad in Informatics (CEOI) 2007 day 1
PROB: nasty calculations
KEYW: RPN, numbers in base != 10
*/

#include <cstdio>
#include <cassert>
#include <cstring>

typedef int type;

enum {PLUS = 2000000001, MINUS, MUL, VAR};
const int MAXTOK = 1 << 17;
const int MAXTOKLEN = 1 << 6;
const int MAXB = 1 << 6;
const int MAXLEN = 1 << 17;

int T, B;
type expr[MAXTOK];
type res[MAXB];

int to10 (char x) {
	return x <= '9' ? x - '0' : x - 'A' + 10;
}

char toB (int x) {
	return x < 10 ? x + '0' : x - 10 + 'A';
}

void mymod (type &a) {
	a += B;
	a %= B;
}

int eval (int x) {
	static type stk[MAXTOK];
	int sp = 0;
	for (int i = 0; i < T; ++i) {
		switch (expr[i]) {
			case PLUS: assert (sp >= 2); stk[sp-2] += stk[sp-1]; --sp; mymod (stk[sp-1]); break;
			case MINUS: assert (sp >= 2); stk[sp-2] -= stk[sp-1]; --sp; mymod (stk[sp-1]); break;
			case MUL: assert (sp >= 2); stk[sp-2] *= stk[sp-1]; --sp; mymod (stk[sp-1]); break;
			case VAR: stk[sp++] = x; break;
			default : stk[sp++] = expr[i]; break;
		}
	}

	assert (sp == 1);
	return stk[0];
}

int main () {
	int n;
	scanf ("%d %d\n", &B, &n);

	static char buf[MAXLEN], tok[MAXTOKLEN];
	gets (buf);
	int bp = 0;
	int sn;
	while (buf[bp]) {
		sscanf (buf + bp, "%s%n", tok, &sn);
		switch (*tok) {
			case '+': expr[T++] = PLUS; break;
			case '-': expr[T++] = MINUS; break;
			case '*': expr[T++] = MUL; break;
			case 'x': expr[T++] = VAR; break;
			default : expr[T++] = to10 (tok[strlen (tok) - 1]);
		}
		bp += sn;
	}

	int i;
/*	for (i = 0; i < T; ++i)
		switch (expr[i]) {
			case PLUS: putchar ('+'); break;
			case MINUS: putchar ('-'); break;
			case MUL: putchar ('*'); break;
			case VAR: putchar ('x'); break;
			default: printf ("%d", expr[i]); break;
		}
	puts ("");*/

	for (i = 0; i < B; ++i)
		res[i] = eval (i);

	for (i = 0; i < n; ++i) {
		gets (tok);
		printf ("%c\n", toB (res[to10 (tok[strlen (tok) - 1])]));
	}

	return 0;
}
