#include "necklace.h"

#include <cstring>
//#include <cassert>
#include <utility>

#include <cstdio>

#define l first
#define r second

const int MAXN = 1 << 18;
const int MAXP = 32;
/*
void assert (bool x) {
	if (x == 0) {
		char *p = (char *)123;
		*p = 0;//sig segv
	}
}
*/
void assert (bool) {}

struct bnds_data {
	int lb, rb;
	bnds_data () {}
	bnds_data (int _l, int _r) : lb (_l), rb (_r) {}
	bnds_data (const bnds_data &old, char op, int on_left) {
		if (on_left) {
			lb = old.lb + (op == 'R' ? 1 : (-1));
			rb = old.rb;
		} else {
			lb = old.lb;
			rb = old.rb + (op == 'R' ? (-1) : 1);
		}
	}
	bnds_data (const bnds_data &a, const bnds_data &b) {
		lb = a.lb >? b.lb;
		rb = a.rb <? b.rb;
	}
};

int N;
bnds_data btr[MAXN][MAXP];//256 mb
int btrl[MAXN][MAXP];//128 mb
std::pair <int, int> lr[MAXN];//8 mb

void init () {
	assert (N == 0);
	memset (btrl, -1, sizeof (btrl));

	btrl[N][0] = 0;//to itself
	btr[N][0] = bnds_data (-1, 0);//itself
	lr[N] = std::make_pair (-99, -99);
/*
	for (int i = 0; btrl[N][i] != -1; ++i) {
		printf ("btrl[%d][%d] -- (%d %d) (%d %d)\n", N, i, btr[N][i].l.min, btr[N][i].l.max, btr[N][i].r.min, btr[N][i].r.max);
	}
*/
	++N;
}

int pearl (int neck_id, int on_left) {
	return on_left ? lr[neck_id].l : lr[neck_id].r;
}

int btr_find (int s, int pos) {
//	printf ("btr_find %d %d\n", s, pos);
	int i;
	int c = s;
	for (i = MAXP - 1; i; --i) {
		assert (i < MAXP && i > 0
		 && c >= 0 && c < MAXN);
		if (btrl[c][i] == -1) continue;
//		printf ("ic %d %d (link %d) lmax, rmin %d %d\n", i, c, btrl[c][i], btr[c][i].l.max, btr[c][i].r.min);
		if (btr[c][i].lb < pos
		 && btr[c][i].rb > pos) {
//		 	printf ("go!\n");
			c = btrl[c][i];
		}
	}

	assert (c != s);
	if (btr[c][0].lb == pos - 1)
		return lr[c].l;
	else if (btr[c][0].rb == pos + 1)
		return lr[c].r;
	else {
		assert (0);
	}
}

void create (int from, char op, int on_left, int param) {
//	printf ("create %d %c %d %d\n", from, op, on_left, param);
	if (N == MAXN) exit (-1);
	assert (N < MAXN);
	assert (0 <= from && from < N);
	assert (op == 'A' || op == 'R');
	assert (param >= 0);
	btrl[N][0] = N;//to itself
	btrl[N][1] = from;

	btr[N][0] = bnds_data (btr[ btrl[N][1] ][0], op, on_left);
	btr[N][1] = bnds_data (btr[N][0], btr[ btrl[N][1] ][0]);
	for (int i = 2; i < MAXP; ++i) {
		btrl[N][i] = btrl[ btrl[N][i-1] ][i-1];
		if (btrl[N][i] == -1) {
			assert (i < 25);
			break;
		}
		btr[N][i] = bnds_data (btr[N][i-1], btr[ btrl[N][i-1] ][i-1]);
	}
/*
	for (int i = 0; i < MAXP && btrl[N][i] != -1; ++i) {
		printf ("btrl[%d][%d] -- (%d %d) (%d %d) %d\n", N, i, btr[N][i].l.min, btr[N][i].l.max, btr[N][i].r.min, btr[N][i].r.max, btrl[N][i]);
	}
*/

	if (btr[N][0].rb - btr[N][0].lb == 1) {//the new necklace is empty
		lr[N] = std::make_pair (-99, -99);
		++N;
		return;
	}

	if (on_left) {
		lr[N].l = (op == 'A' ? param : btr_find (N, btr[N][0].lb + 1));
		lr[N].r = (btr[N][0].rb - btr[N][0].lb == 2 ? lr[N].l : lr[btrl[N][1]].r);
	} else {
		lr[N].r = (op == 'A' ? param : btr_find (N, btr[N][0].rb - 1));
		lr[N].l = (btr[N][0].rb - btr[N][0].lb == 2 ? lr[N].r : lr[btrl[N][1]].l);
	}

//	printf ("final %d -- %d %d\n", N, lr[N].l, lr[N].r);
	++N;
//	assert (0);
}
