/*
FROM: Central European Olympiad in Informatics (CEOI) 2007 day 2
PROB: treasury (royal treasury)
KEYW: dynamical programming on tree, big numbers (+ - * /)
*/

#include <cstdio>
#include <cstring>
#include <utility>

typedef long long big;

const int MAXN = 1 << 10;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N;
int vec[MAXN];
el buf[MAXN];

int pcnt[2][MAXN];
big ways[2][MAXN];
std::pair <int, big> use_best[MAXN];

int trav_q[MAXN];

void use_bestf (int root) {
//	printf ("in here!\n");
	if (pcnt[0][root] == pcnt[1][root]) {
//		printf ("case add\n");
		use_best[root] = std::make_pair (pcnt[0][root], ways[0][root] + ways[1][root]);
		return;
	}

	if (pcnt[0][root] > pcnt[1][root])
		use_best[root] = std::make_pair (pcnt[0][root], ways[0][root]);
	else
		use_best[root] = std::make_pair (pcnt[1][root], ways[1][root]);
}

void dpf (int v) {
//	printf ("dpf %d\n", v);
	if (vec[v] == -1) {
//		printf ("in here2\n");
		ways[0][v] = 1;
//		printf ("in use\n");
		use_bestf (v);
//		printf ("out use\n");
//		printf ("!finished dpf %d:\n", v);
//		printf ("!%d %Ld  %d %Ld    %d %Ld\n", pcnt[0][v], ways[0][v], pcnt[1][v], ways[1][v], use_best[v].first, use_best[v].second);
		return;
	}
//	printf ("out of here!\n");

	//now calc v, 0 --> do not use the root, the root is free afterwards
	ways[0][v] = 1;
	int j;
	for (j = vec[v]; j != -1; j = buf[j].next) {
		pcnt[0][v] += use_best[buf[j].to].first;
		ways[0][v] *= use_best[buf[j].to].second;
	}

	//now calc v, 1 --> use the root, the root is NOT free afterwards
	static int link[MAXN], lp, bdif;
	lp = 0, bdif = MAXN;
	big tmp;
	for (j = vec[v]; j != -1; j = buf[j].next) {
		if (bdif > (tmp = use_best[buf[j].to].first - pcnt[0][buf[j].to])) {
			bdif = tmp;
			lp = 0;
		}
		if (tmp == bdif)
			link[lp++] = buf[j].to;
	}
//	printf ("bdif == %d\n", bdif);

	pcnt[1][v] = pcnt[0][v] - bdif + 1;
	ways[1][v] = 0;
	for (j = 0; j < lp; ++j) {
//		printf ("\tlink %d -- %Ld / %Ld * %Ld\n", link[j], ways[0][v], use_best[link[j]].second, ways[0][link[j]]);
		ways[1][v] += ways[0][v] / use_best[link[j]].second * ways[0][link[j]];
	}

//	printf ("in use\n");
	use_bestf (v);
//	printf ("out use\n");
//	printf ("finished dpf %d:\n", v);
//	printf ("%d %Ld  %d %Ld    %d %Ld\n", pcnt[0][v], ways[0][v], pcnt[1][v], ways[1][v], use_best[v].first, use_best[v].second);
}

int main () {
	scanf ("%d", &N);

	int i, j;
	int a, b, c, bp = 0;
	memset (vec, -1, sizeof (vec));
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &a, &c);
		--a;
		trav_q[i] = a;
		for (j = 0; j < c; ++j) {
			scanf ("%d", &b);
			--b;
			buf[bp] = el (b, vec[a]);
			vec[a] = bp++;
		}
	}
/*
	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (j = vec[i]; j != -1; j = buf[j].next)
			printf (" %d", buf[j].to);
		puts ("");
	}
*/
	for (i = N-1; i >= 0; --i)
		dpf (trav_q[i]);

	printf ("%d\n%Ld\n", use_best[0].first, use_best[0].second);

	return 0;
}
