/*
FROM: Central European Olympiad in Informatics (CEOI) 2007 day 2
PROB: airport (airport show)
KEYW: dead lock checker, dfs, thread simulation
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 1 << 10;
const int MAXL = 5010;

int N;
bool res[2][MAXN];
int seq[MAXL * 2];
bool used[MAXL][MAXL];
int L[2];
int show[2][MAXL];
//int _c1, _c2;
void dfs (int p1, int p2) {
//	++_c1;
	if (used[p1][p2]) return;
//	++_c2;
	printf ("dfs %d %d ---", p1, p2);
	for (int i = 0; i < N; ++i) printf ("(%d %d) ", res[0][i], res[1][i]); printf ("__%d %d", show[0][p1], show[1][p2]); puts ("");
	used[p1][p2] = 1;
	if (p1 == L[0] || p2 == L[1]) {
//		printf ("one is at the end!\n");
		return;//everything is ok
	}

	bool good = 0;
	if (res[0][show[0][p1]]		//release
	 || !res[1][show[0][p1]]) {	//reserve and is free
	 	good = 1;
		res[0][show[0][p1]] = !res[0][show[0][p1]];
		seq[p1 + p2] = 1;
		printf ("\tgoto %d %d --> %d %d\n", p1, p2, p1 + 1, p2);
		dfs (p1 + 1, p2);
		res[0][show[0][p1]] = !res[0][show[0][p1]];
	}
	if (res[1][show[1][p2]]		//release
	 || !res[0][show[1][p2]]) {	//reserve and is fre
		good = 1;
		res[1][show[1][p2]] = !res[1][show[1][p2]];
		seq[p1 + p2] = 2;
		printf ("\tgoto %d %d --> %d %d\n", p1, p2, p1, p2 + 1);
		dfs (p1, p2 + 1);
		res[1][show[1][p2]] = !res[1][show[1][p2]];
	}
	if (good) return;
	for (int i = 0; i < p1 + p2; ++i) printf ("%d", seq[i]);
	puts ("");
	exit (0);
}

int main () {
	scanf ("%d", &N);

	int k, i;
	for (k = 0; k < 2; ++k) {
		scanf ("%d", L + k);
		int tn;
		for (i = 0; i < L[k]; ++i) {
			scanf ("%*s %d\n", &tn);
			show[k][i] = --tn;
		}
	}

	for (k = 0; k < 2; ++k)
		for (i = 0; i < L[k]; ++i)
			printf ("show[%d][%d] -- %d\n", k, i, show[k][i]);

	dfs (0, 0);
	puts ("The performances will always finish.");
//	fprintf (stderr, "%d %d\n", _c1, _c2);

	return 0;
}
