/*
FROM: ROMANIA 2005/2006 round 1 L
PROB: honest
KEYW: dfs
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 1 << 10;
const int MAXM = 1 << 19;

struct el {
	int to;
	int inv;
	int next;
	el () {}
	el (int _to, int _inv, int _next) : to (_to), inv (_inv), next (_next) {}
};

int N, M;
int vec[MAXN];
el buf[MAXM];

int used[MAXN];
int type[MAXN];
bool not_root[MAXN];
int ch, cl;
int cg;

void dfs (int v, int t) {
	type[v] = t;
	used[v] = cg;
	if (t) ++cl; else ++ch;
	for (int i = vec[v]; i != -1; i = buf[i].next)
		if (!used[buf[i].to])
			dfs (buf[i].to, t ^ buf[i].inv);
}

void inverse_group () {
	for (int i = 0; i < N; ++i)
		if (used[i] == cg) {
			type[i] = (type[i] ? 0 : 1);
		}
}

int main () {
	scanf ("%d %d\n", &N, &M);

	int i;
	int a, b;
	char c;
	int bp = 0;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %c %d\n", &a, &c, &b);
		not_root[b] = 1;
		--a; --b;

		buf[bp] = el (b, c == 'm', vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, c == 'm', vec[b]);
		vec[b] = bp++;
	}

	for (i = 0; not_root[i]; ++i);
	++cg;//the first time must be 1;
	dfs (i, 1);
	if (ch < cl)
		inverse_group ();
	ch = cl = 0;

	for (i = 0; i < N; ++i)
		printf ("%d\n", !type[i]);

	return 0;
}
