/*
FROM: Champion 2005 round 1 Large
PROB: police
KEYW: dfs
*/

#include <cstdio>
#include <vector>

const int MAXN = 1 << 11;
const int MAXM = 1 << 13;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N, M;
el buf[MAXM];
int vec[MAXN];
int prev[MAXN];
bool used[MAXN];

int vlvl[MAXN];
int lvl;

std::vector <std::vector <int> > output;
std::vector <int> tmp;

void dfs (int a) {
	++lvl;
	vlvl[a] = lvl;
	used[a] = 1;

	for (int i = vec[a]; i != -1; i = buf[i].next) {
		if (!used[buf[i].to]) {
			prev[buf[i].to] = a;
			dfs (buf[i].to);
		} else if (buf[i].to != prev[a]) {
			if (vlvl[a] > vlvl[buf[i].to]) {
				int crnt = a;
				tmp.clear ();
				while (crnt != buf[i].to) {
					tmp.push_back (crnt + 1);
					crnt = prev[crnt];
				}
				tmp.push_back (buf[i].to + 1);
				tmp.push_back (a + 1);
				output.push_back (tmp);
			}

		}
	}
	--lvl;
}

int main () {
	scanf ("%d %d", &N, &M);

	int i;
	int bp =0;
	int a, b;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		buf[bp] = el (b, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, vec[b]);
		vec[b] = bp++;
	}

	for (i = 0; i < N; ++i)
		if (!used[i])
			dfs (i);

	printf ("%d\n", output.size ());
	for (size_t i = 0; i < output.size (); ++i) {
		printf ("%d", output[i][0]);
		for (size_t j = 1; j < output[i].size (); ++j)
			printf (" %d", output[i][j]);
		printf ("\n");
	}
}
