/*
FROM: Champion 2005 round 2 Large
PROB: zmeu
KEYW: dijkstra
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 10;
const int MAXP = 1 << 9;
const int NP = 1 << 3;
const int _infinity = 1 << 20;

int N, M, P;

int ma3x[MAXN][MAXN];
int pos[NP];
int escape[MAXP];

int dist[NP][MAXN];
int dexit[NP];

void dijkstra (int a) {
	static bool used[MAXN];
	int i;
	for (i = 0; i < N; ++i) {
		dist[a][i] = _infinity;
		used[i] = 0;
	}

	dist[a][pos[a]] = 0;

	int min, mini =0;

	for (;;) {
		min = _infinity;
		for (i = 0; i < N; ++i)
			if (!used[i] && dist[a][i] < min) {
//				printf ("dist[%d][%d] == %d\n", a, i, dist[a][i]);
				min = dist[a][i];
				mini = i;
			}

		if (min == _infinity) return;

		used[mini] = 1;
		for (i = 0; i < N; ++i)
			if (dist[a][i] > min + ma3x[mini][i]) {
				dist[a][i] = min + ma3x[mini][i];
//				printf ("upgrade %d %d with %d (min, ma3x %d %d)\n", a, i, dist[a][i], min, ma3x[mini][i]);
			}
	}
}

int main () {
	scanf ("%d %d %d", &N, &M, &P);

	int i, j;
	int a, b, d;
	for (i = 0; i < N; ++i) for (j = 0; j < N; ++j) ma3x[i][j] = _infinity;
	for (i = 0; i < 6; ++i) {scanf ("%d", &a); pos[i] = a - 1;}
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", &a, &b, &d);
		--a; --b;
		ma3x[a][b] = ma3x[b][a] = d;
	}
/*
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			printf ("%7d ", ma3x[i][j]);
		printf ("\n");
	}
*/
	for (i = 0; i < P; ++i) {
		scanf ("%d", &a); escape[i] = a - 1;
	}

	for (i = 0; i < 6; ++i)
		dijkstra (i);

	for (i = 1; i < 6; ++i) {
		dexit[i] = _infinity;
		for (j = 0; j < P; ++j)
			if (dexit[i] > dist[i][escape[j]])
				dexit[i] = dist[i][escape[j]];
	}
/*
	for (i = 0; i < 6; ++i) printf ("%d ", pos[i]); printf ("\n");
	for (i = 0; i < 6; ++i) {
		for (j = 0; j < N; ++j)
			printf ("%d ", dist[i][j]);
		printf ("\n");
	}
*/
	int vec[NP];
	for (i = 0; i < 5; ++i)
		vec[i] = i + 1;

	int best = _infinity;
	int sum;
	do {
		sum = dist[0][pos[vec[0]]];
		for (i = 1; i < 5; ++i)
			sum += dist[vec[i-1]][pos[vec[i]]];

		sum += dexit[vec[4]];
		if (best > sum)
			best = sum;
	} while (std::next_permutation (vec, vec + 5));

	printf ("%d\n", best);

	return 0;
}
