/*
FROM: Champion 2005 round 3 Large
PROB: judete
KEYW: dynamical programming on tree, tele like
*/

#include <cstdio>
#include <cassert>
#include <cstring>

typedef unsigned char uchar;

const int MAXN = 1 << 7;

struct el {
	uchar to;
	uchar next;
	el () {}
	el (uchar _to, uchar _next) : to (_to), next (_next) {}
};

int N, K;
uchar vec[MAXN];
el buf[MAXN * 2];

uchar dp[MAXN][MAXN];
uchar sz[MAXN];

void dpf (int a) {
	dp[a][0] = 0xfe;
	dp[a][1] = 1;
	sz[a] = 1;

	uchar i, c;
	int ii, jj;
	for (i = vec[a]; i != 0xff; i = buf[i].next) {
		c = buf[i].to;
		if (dp[c][0] != 0xff) continue;//this should! be our father
		dpf (c);
		for (ii = sz[a]; ii; --ii) {
			for (jj = sz[c]; jj; --jj)
				dp[a][ii + jj] <?= dp[a][ii] >? dp[c][jj] >? (ii + jj);
			dp[a][ii] >?= dp[c][0];
		}
		sz[a] += sz[c];
	}
	assert (dp[a][0] == 0xfe);
	for (ii = K; ii <= sz[a]; ++ii) dp[a][0] <?= dp[a][ii];

//	for (ii = 0; ii <= sz[a]; ++ii) printf ("%d ", dp[a][ii] != 0xff ? dp[a][ii] : 9); printf ("<-- %d\n", a);
}

int main () {
	scanf ("%d %d\n", &N, &K);

	int i;
	int a, b, bp = 0;
	for (i = 0; i < N; ++i) vec[i] = 0xff;
	for (i = 0; i < N - 1; ++i) {
		scanf ("%d %d\n", &a, &b);
		--a; --b;

		buf[bp] = el ((uchar)b, vec[a]);
		vec[a] = bp++;

		buf[bp] = el ((uchar)a, vec[b]);
		vec[b] = bp++;
	}

	memset (dp, 0xff, sizeof (dp));
	dpf (0);

	printf ("%d\n", (int)dp[0][0]);

	return 0;
}
