/*
FROM: Champion 2005 round 3 Large
PROB: strict
KEYW: longest increasing subsequence, comparing binary trees
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 14;//10 000
const int MAXM = 1 << 7;//128 (51 * 2)
const int MAXLINELEN = 1 << 9;//500

int N, M;
char data[MAXN][MAXM];
char root[MAXN];

bool used[MAXM];

bool _cmpeq (int a, int ai, int b, int bi) {
	if (data[a][ai * 2] == -1 && data[b][bi * 2] == -1) return 1;
	if (data[a][ai * 2] == -1 || data[b][bi * 2] == -1) return 0;
	return _cmpeq (a, data[a][ai * 2], b, data[b][bi * 2]) && _cmpeq (a, data[a][ai * 2 + 1], b, data[b][bi * 2 + 1]);
}

bool _cmpls (int a, int ai, int b, int bi) {
	if (data[a][ai * 2] == -1 && data[b][bi * 2] != -1) return 1;
	if (data[a][ai * 2] == -1 || data[b][bi * 2] == -1) return 0;
	return _cmpls (a, data[a][ai * 2], b, data[b][bi * 2]) || (
			_cmpeq (a, data[a][ai * 2], b, data[b][bi * 2]) &&
			_cmpls (a, data[a][ai * 2 + 1], b, data[b][bi * 2 + 1]));
}

bool cmp (int a, int b) {
	return _cmpeq (a, root[a], b, root[b]) || _cmpls (a, root[a], b, root[b]);
}

int vec[MAXN];

bool bsrch (int id, int ub) {
	int l = 0, r = ub + 1, m;
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (cmp (vec[m], id))
			l = m;
		else
			r = m;
	}

	vec[r] = id;
//	printf ("put %d in %d\n", id, r);

	return (r == ub + 1);
}

int solve () {
	int k = 1;
	vec[1] = 0;

	for (int i = 1; i < N; ++i)
		if (bsrch (i, k)) ++k;

	return k;
}

int main () {
	scanf ("%d %d\n", &N, &M);

	char buf[MAXLINELEN];
	char cnum;
	int cp, sz;
	int i, j;
	for (i = 0; i < N; ++i) {
		gets (buf);
		buf[(sz = strlen (buf))] = ' ';
		buf[sz + 1] = 0;
		memset (used, 0, sizeof (bool) * MAXM);

		cnum =0; cp =0;
		for (j = 0; buf[j]; ++j)
			if (buf[j] == ' ') {
				if (cnum == 0) {
					data[i][cp++] = -1;
					data[i][cp++] = -1;
				} else {
					--cnum;
					data[i][cp++] = cnum;
					used[(int)cnum] = 1;
					cnum = 0;
				}
			} else {
				cnum *= 10;
				cnum += buf[j] - '0';
			}
		for (j = 0; j < M && used[j]; ++j);
		root[i] = j;
	}

	printf ("%d\n", solve ());

	return 0;
}
