/*
FROM: Champion 2005 round 4 Large
PROB: auto
KEYW: dijkstra with stl heap, graph expansion
*/

#include <cstdio>
#include <queue>

const int MAXN = 1 << 7;
const int MAXT = 1 << 7;
const int MAXM = 1 << 9;

struct el {
	int to;
	int time;
	int next;
	el () {}
	el (int _to, int _time, int _next) : to (_to), time (_time), next (_next) {}
};

struct heap {
	int to;
	int time;
	int cost;
	heap () {}
	heap (int _to, int _time, int _cost) : to (_to), time (_time), cost (_cost) {}
	bool operator < (const heap &a) const {return cost > a.cost;}//inversed
};

int N, M;
int A, B, T;

int pt[MAXN];
int fwt[MAXM][MAXT];

int vec[MAXN];
el buf[MAXM << 1];

int dijkstra () {
	bool used[MAXN][MAXT] = {{0}};
	std::priority_queue <heap> h;

	int i;
	h.push (heap (A, 0, 0));
/*
	for (i = vec[A]; i != -1; i = buf[i].next)
		h.push (heap (buf[i].to, buf[i].time, fwt[i>>1][0] * buf[i].time));
*/
	heap crnt;
	while (!h.empty ()) {
		crnt = h.top (); h.pop ();
//		printf ("popped %d %d %d\n", crnt.to, crnt.time, crnt.cost);

		if (crnt.to == B) return crnt.cost;
		if (used[crnt.to][crnt.time]) continue;
		used[crnt.to][crnt.time] = 1;

		if (crnt.time + 1 < T/* && !used[crnt.to][crnt.time + 1]*/) {
//			printf ("push %d %d %d\n", crnt.to, crnt.time + 1, crnt.cost + pt[crnt.to]);
			h.push (heap (crnt.to, crnt.time + 1, crnt.cost + pt[crnt.to]));
		}
		for (i = vec[crnt.to]; i != -1; i = buf[i].next)
			if (crnt.time + buf[i].time <= T/* && !used[buf[i].to][crnt.time + buf[i].time]*/) {
				h.push (heap (buf[i].to, crnt.time + buf[i].time, crnt.cost + fwt[i>>1][crnt.time] * buf[i].time));
//				printf ("push %d %d %d\n", buf[i].to, crnt.time + buf[i].time, crnt.cost + fwt[i>>1][crnt.time] * buf[i].time);
			}
	}

	return -1;
}

int main () {
	scanf ("%d %d", &N, &M);
	scanf ("%d %d %d", &A, &B, &T);
	--A; --B;

	int i, j;
	for (i = 0; i < N; ++i)
		scanf ("%d", pt + i);

	int a, b, d, bp =0;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", &a, &b, &d);
		--a; --b;

		buf[bp] = el (b, d, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, d, vec[b]);
		vec[b] = bp++;

		for (j = 0; j < T; ++j)
			scanf ("%d", &fwt[i][j]);
	}
	pt[A] = pt[B] = 0;

	printf ("%d\n", dijkstra ());

	return 0;
}
