/*
FROM: Champion 2005 round 5 Large
PROB: leaves
KEYW: dynamical programming with optimization on the inner cycle using a queue
*/

#include <cstdio>
#include <algorithm>

#define MAXN = 1 << 17;

int N, K;
long long w[MAXN];
long long sum[MAXN];
long long tcost[MAXN];

long long _old[MAXN], _crnt[MAXN];
long long *crnt = _crnt, *old = _old;
int queue[MAXN];
int p1, p2;
/*
inline long long _cost (int targ, int back) {
	return tcost[back] - tcost[targ] - (long long)(sum[back] - sum[targ]) * (long long)targ;
}
*/
#define _cost(a,b) (tcost[(b)] - tcost[(a)] - (sum[(b)] - sum[(a)]) * (long long)(a))
/*
int _f (const long long &a, int b) {
	return (a / b) + (!!(a % b));
}
*/
#define _f(A,B) (((A) / (B)) + (!!((A) % (B))))

//int __f;
long long _X;
inline int f (int a, int b) {
	return a - ((_X = old[a] - old[b] - _cost (a, b)) <= 0 
	? 0 : _f (/*old[a] - old[b] - _cost (a, b)*/ _X, sum[b] - sum[a]));
}

int main () {
	scanf ("%d %d", &N, &K);

	int i, j;
	for (i = 0; i < N; ++i)
		scanf ("%Ld", w + i);

	for (i = 1; i <= N; ++i) {
		sum[i] = sum[i-1] + w[i-1];
		tcost[i] = tcost[i-1] + w[i-1] * (i-1);
	}

	for (j = 0; j < N; ++j) old[j] = _cost (j, N);
	for (i = 2; i <= K; ++i) {
		p1 = p2 = 0;
		queue[p2++] = N-i+1;
		for (j = N-i; j >= 0; --j) {
			if (p2 - p1 > 1 && (f (queue[p1+1], queue[p1])) >= j)
				++p1;
			crnt[j] = old[queue[p1]] + _cost (j, queue[p1]);
			while (p2 - p1 > 1 && f (j, queue[p2-1]) >= f (queue[p2-1], queue[p2-2]))
				--p2;
			queue[p2++] = j;
		}

		std::swap (crnt, old);
	}

	printf ("%Ld\n", old[0]);

	return 0;
}
