/*
FROM: ROMANIA 2005/2006 ROUND 5 L
PROB: leaves
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 17;
const int MAXK = 1 << 4;

int N, K;
int w[MAXN];

long long opt[MAXN][MAXK];
int fp[MAXN][MAXK];
int sum[MAXN];

long long cost (int a, int b) {
	return (long long)(sum[b - 1] - (a ? sum[a - 1] : 0)) * a;
}

int main () {
	scanf ("%d %d", &N, &K);

	int i, j;
	long long ALL =0;
	for (i = 0; i < N; ++i) {
		scanf ("%d", w + i);
		ALL += w[i] * i;
	}

	sum[0] = w[0];
	for (i = 1; i < N; ++i) sum[i] = sum[i-1] + w[i];

	opt[N][0] = ALL;
	fp[N][0] = N;

	int ub;
	for (i = N - 1; i >= 0; --i) {
		ub = (N - i + 1 < K ? N - i + 1 : K);
		for (j = 0; j < ub; ++j) {
			opt[i][j] = ALL + 1;
			if (j) {
//				printf ("%d fp[%d][%d] = %Ld\n", i, i+1, j-1, cost (i, fp[i + 1][j - 1]));

				opt[i][j] = opt[i + 1][j - 1] - cost (i, fp[i + 1][j - 1]);
				fp[i][j] = i;
			}

			if (i + j < N && opt[i][j] > opt[i + 1][j]) {
//				printf ("!");
				opt[i][j] = opt[i + 1][j];
				fp[i][j] = fp[i + 1][j];
			}
//			printf ("opt[%d][%d] == %Ld, fp[%d][%d] == %d\n", i, j, opt[i][j], i, j, fp[i][j]);
		}
	}


	printf ("%Ld\n", opt[0][K-1]);

	return 0;
}
