/*
FROM: ROMANIA 2005/2006 ROUND 5 L
PROB: leaves
KEYW: dynamical programming with VERY IMPORTANT optimization
NOTE: see also IOI 2002
*/

#include <cstdio>
#include <queue>

const int MAXN = 1 << 17;
const int MAXK = 1 << 4;

int N, K;

int w[MAXN];

long long allcost[MAXN];
int sum[MAXN];

inline long long cost (int a, int b) {
	return allcost[b] - (a ? allcost[a - 1] : 0) - (long long)(sum[b] - (a ? sum[a - 1] : 0)) * a;
}

long long A[MAXN][MAXK];

int j;
long long g (int k1, int k2) {
	if (k1 == k2) printf ("wop!\n");
	return (A[k1-1][j-1] - A[k2-1][j-1] + cost (k1, k2-1)) / (k2 - k1) - sum[k2-1];
}

int f (int i) {
	return -sum[i];
}

int main () {
	scanf ("%d %d", &N, &K);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d", w + i);

	for (i = 1, sum[0] = w[0]; i < N; ++i) {
		allcost[i] = allcost[i - 1] + w[i] * i;
		sum[i] = sum[i - 1] + w[i];
	}

	for (i = 0; i < N; ++i) {
		A[i][1] = allcost[i];
//		printf ("%Ld ", A[i][1]);
	}
//	printf ("\n");

	std::deque <int> q;
	for (j = 2; j <= K; ++j) {
//		printf ("****************\nj === %d\n", j);
		q.clear ();
		q.push_back (j - 1);
		A[j-1][j] = 0;//every leaf is a heap alone

		for (i = j; i < N; ++i) {
//			printf ("i == %d --", i); for (int k = 0; k < q.size (); ++k) printf ("%d ", q[k]); printf ("\n");
			while (q.size () >= 2 && g (q.back (), i) >= g (*(q.end () - 2), q.back ()))
				q.pop_back ();
			q.push_back (i);
			while (q.size () >= 2 && f (i) <= g (q[0], q[1]))
				q.pop_front ();

			A[i][j] = A[q[0] - 1][j - 1] + cost (q[0], i);
//			printf ("father == %d -- %Ld(%Ld)\n", q[0], A[i][j], cost (q[0], i));
		}
	}

	printf ("%Ld\n", A[N-1][K]);

	return 0;
}
