/*
FROM: Champion 2005 round 5 Large
PROB: leaves
KEYW: dynamical programming with optimization on the inner cycle using a queue
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 17;

int N, K;
int w[MAXN];
int sum[MAXN];
long long tcost[MAXN];

long long _old[MAXN], _crnt[MAXN];
long long *crnt = _crnt, *old = _old;
int queue[MAXN];
int p1, p2;

#define _f(a,b) (a/b+!!(a%b))
int _res;
inline void f (int a, int b) {
	_res = a - (old[a] <= old[b] ? 0 : _f (old[a] - old[b], sum[b-1] - sum[a-1]));
//	_res = a - (0 >? _f (old[a] - old[b], sum[b-1] - sum[a-1]));
}
#define _cost(A,B) (tcost[(B)-1] - tcost[(A)-1] - (sum[(B)-1] - sum[(A)-1]) * (long long)(A))

int main () {
	scanf ("%d %d", &N, &K);

	int i, j;
	for (i = 0; i < N; ++i) {
		scanf ("%d", w + i);

		sum[i+1] = sum[i] += w[i];
		tcost[i+1] = tcost[i] += w[i] * i;
	}

	for (j = 1; j < N; ++j) old[j] = _cost (j, N);

	for (i = 2; i <= K; ++i) {
		p1 = p2 = 0;
		queue[p2++] = N-i+1;
		for (j = N-i; j; --j) {
			if (p2 - p1 > 1 && (f (queue[p1+1], queue[p1]), _res) >= j) ++p1;
			crnt[j] = old[queue[p1]] + _cost (j, queue[p1]);
			queue[p2++] = j;
			while (p2 - p1 > 2 && (f (queue[p2-1], queue[p2-2]), _res) >= (f (queue[p2-2], queue[p2-3]), _res)) {queue[p2-2] = queue[p2-1]; --p2;}
		}
		if (p2 - p1 > 1 && (f (queue[p1+1], queue[p1]), _res) >= j) ++p1;
		crnt[j] = old[queue[p1]] + tcost[queue[p1] - 1];

		std::swap (crnt, old);
	}

	printf ("%Ld\n", old[0]);

	return 0;
}
