/*
FROM: Campion 2005/2006 round 6 Large
PROB: grazing
KEYW: dynamical programming, large numbers, multiplication, combinatorics - combinations, permutations
NOTE: The graphs we are counting consist only of paths and cycles (length NON devisible by 3), which DO NOT have common points
*/

#include <cstdio>
#include <cstring>
#include <cassert>

const int MAXN = 310;
const int MAX = 1 << 7;
const int BASE = 1000000000;

struct big {
	int a[MAX];
	big () {memset (a, 0, sizeof (a));}
	big (int b) {memset (a, 0, sizeof (a)); a[0] = b;}

	big& operator = (const big &b) {memcpy (a, b.a, sizeof (a)); return *this;}

	big& operator += (const big &b) {
		int c = 0;
		for (int i = 0; i < MAX; ++i) {
			a[i] += b.a[i] + c;
			c = a[i] / BASE;
			a[i] %= BASE;
		}
		assert (!c);
		return *this;
	}

	big& operator *= (int b) {
		long long c = 0, res;
		for (int i = 0; i < MAX; ++i) {
			res = (long long)a[i] * b + c;
			c = res / BASE;
			a[i] = res % BASE;
		}
		assert (!c);
		return *this;
	}

	big& d2 () {
		long long c = 0, res;
		for (int i = MAX-1; i >= 0; --i) {
			res = c * BASE + a[i];
			a[i] = res / 2;
			c = res % 2;
		}
		assert (!c);
		return *this;
	};

	void prnt () const {
		int i;
		for (i = MAX-1; i && !a[i]; --i);
		printf ("%d", a[i]);
		for (--i; i >= 0; --i) printf ("%09d", a[i]);
		puts ("");
	}
};

int N;
big dp[MAXN];

int main () {
	scanf ("%d", &N);

	dp[0] = dp[1] = 1;
	dp[2] = 2;
//	dp[3] = 7;
	big tmp;
	int mul;
	for (int i = 3; i <= N; ++i) {
		dp[i] = dp[i-1];//add a new vertex without connecting it anywhere
		dp[i - 2] *= i - 1;
		dp[i] += dp[i - 2];//make a "chain" with one more element
		for (int j = 3; j <= i; ++j) {
			dp[i - j] *= i - 1;
			tmp = dp[i - j];
			mul = j + !!(j % 3);
			tmp.d2 ();
//			printf ("i,j,mul tmp %d %d  %d   ", i, j, mul); tmp.prnt ();
			tmp *= mul;
			dp[i] += tmp;
		}
//		printf ("dp[%d] == ", i); dp[i].prnt ();\
	}

	dp[N].prnt ();

	return 0;
}
