/*
FROM: Campion 2005/2006 round 6 Large
PROB: pstring
KEYW: KMP, dynamical programming, precomputing
*/

#include <cstdio>
#include <cstring>

const int MAXT = 10010;
const int MAXC = 1024;
const int MALPHA = 32;
const int ALPHA = 26;
const int INF = 0xffff;


//BEGIN
int M, C;
char m[MAXT];
char c[MAXC];
short fl[MAXC];
short pre[MAXC][MALPHA];

unsigned short dp[MAXT][MAXC];
//END

void kmp_pre () {
	fl[0] = 0;
	fl[1] = 0;
	int crnt = 0;
	for (int i = 2; i <= C; ++i) {
		while (crnt && c[crnt] != c[i-1]) crnt = fl[crnt];
		if (c[crnt] == c[i-1]) ++crnt;
		fl[i] = crnt;
	}
//	for (int i = 0; i <= C; ++i) printf (" %d", fl[i]); puts ("");
	for (int i = 0; i < C; ++i) {
		c[i] -= 'a';//make it from 0 to 25 inclusive
		for (int j = 0; j < ALPHA; ++j) {
			crnt = i;
			while (crnt && c[crnt] != j) crnt = fl[crnt];
			if (c[crnt] == j) ++crnt;
			pre[i][j] = crnt;
//			if (crnt) printf ("%d %d(%c) -- %d\n", i, j, j + 'a', crnt);
		}
	}
}

int main () {
	gets (m); M = strlen (m);
	gets (c); C = strlen (c);

	kmp_pre ();

	register int i, j;
	for (j = 0; j < C; ++j) dp[M][j] = 0;//we finished the big string and the small one hasn't reached it's end
	dp[M][C] = INF;
	for (i = M-1; i >= 0; --i) {
		dp[i][C] = INF;
		for (j = 0; j < C; ++j)
			dp[i][j] = (dp[i+1][j] + 1) <? (dp[i+1][pre[j][m[i]-'a']]);
	}

	printf ("%hu\n", dp[0][0]);

	return 0;
}
