/*
FROM: Campion 2005/2006 round 9 Large
PROB: firma
KEYW: 2D lowest bit index tree
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 10;
const int MAXM = 1 << 10;

int N, M, P;
int idt[MAXN][MAXM];
char crc[MAXN][MAXM];
char mrc[MAXN][MAXM];
char inc[MAXN][MAXM];

void add (int x, int y, int val) {
	static int i, j;
	for (i = x; i <= N; i += i & -i)
		for (j = y; j <= M; j += j & -j)
			idt[i][j] += val;
}

int _srch (int x, int y) {
	static int i, j, res;
	res = 0;
	for (i = x; i; i &= i-1)
		for (j = y; j; j &= j-1)
			res += idt[i][j];
	return res;
}

int srch (int x1, int y1, int x2, int y2) {
	return _srch (x1, y1) + _srch (x2, y2) - _srch (x1, y2) - _srch (x2, y1);
}

int main () {
	scanf ("%d %d %d", &N, &M, &P);
	int i;
	int x, y, a, b, c;
	for (i = 0; i < P; ++i) {
		scanf ("%d %d %d %d %d\n", &x, &y, &a, &b, &c);
		mrc[x][y] = a;
		crc[x][y] = b;
		inc[x][y] = c;
		add (x, y, (int)inc[x][y] * crc[x][y]);
	}

	int Q;
	scanf ("%d", &Q);
	int type;
	for (i = 0; i < Q; ++i) {
		scanf ("%d", &type);
		if (type == 1) {
			scanf ("%d %d", &x, &y);
			if (crc[x][y] < mrc[x][y]) {
				++crc[x][y];
				add (x, y, (int)inc[x][y]);
			}
		} else if (type == 2) {
			scanf ("%d %d", &x, &y);
			if (crc[x][y]) {
				--crc[x][y];
				add (x, y, -(int)inc[x][y]);
			}
		} else {
			scanf ("%d %d %d %d", &x, &y, &a, &b);
			if (x < a) std::swap (x, a);
			if (y < b) std::swap (y, b);
			printf ("%d\n", srch (x, y, a-1, b-1));
		}
	}

	return 0;
}
