/*
FROM: Campion 2005/2006 round 9 Large
PROB: vile
KEYW: stack
*/

#include <cstdio>
#include <utility>

using std::make_pair;

const int MAXN = 1 << 17;

int N, K;
int vec[MAXN];
std::pair <int, int> stk[MAXN];
int stk_top, stk_bot;

void push_stack (const std::pair <int, int> &a) {
	while (stk_top > stk_bot && stk[stk_top - 1].first >= a.first) --stk_top;
	stk[stk_top++] = a;
}

void pop_stack (int pos) {
	if (stk[stk_bot].second == pos) ++stk_bot;
}

int main () {
	scanf ("%d %d", &N, &K);

	int i;
	for (i = 0; i < N; ++i) scanf ("%d", vec + i);
	for (i = 0; i < K; ++i)
		push_stack (make_pair (vec[i], i));


	int res = 0;
	for (i = K; i < N && i <= 2 * K; ++i) {
		push_stack (make_pair (vec[i], i));
		res >?= vec[i-K] - stk[stk_bot].first;
	}

	for (i = 2 * K + 1; i < N; ++i) {
		push_stack (make_pair (vec[i], i));
		pop_stack (i - 2 * K - 1);
		res >?= vec[i - K] - stk[stk_bot].first;
	}

	for (i = N - K; i < N; ++i) {
		pop_stack (i - K - 1);
		res >?= vec[i] - stk[stk_bot].first;
	}

	printf ("%d\n", res);

	return 0;
}
