/*
FROM: Campion 2005/2006 round 10 Large
PROB: albinuta
KEYW: mars index tree, rearanging the elements first, adding a value to a whole interval
*/

#include <cstdio>
#include <cassert>
#include <cstring>

#define MAXN (1 << 16)
const int MOD = 30103;

struct node {
	int all;
	int kids;
	node () {}
	node (int _all, int _kids) : all (_all), kids (_kids) {}
};

int N, K, M;
int GC;//group size
int pos[MAXN];
node idt[MAXN * 2];

int _add_val;
long long _result;

inline int f (int idx, int len) {
	return idt[idx].kids + idt[idx].all * len;
}

void add (int l, int r, int lb =0, int rb =MAXN, int p =0) {
//	if (p == 0) printf ("add %d %d  %d %d %d (%d)\n", l, r, lb, rb, p, _add_val);
	if (l < lb) l = lb;
	if (r > rb) r = rb;
	if (l >= r) return;
	if (l == lb && r == rb) {
		idt[p].all += _add_val;
		idt[p].all %= MOD;
//		printf ("%d %d <----- %d %d\n", lb, rb, idt[p].all, idt[p].kids);
		return;
	}
	int m = (lb + rb) / 2;
	add (l, r, lb, m, p * 2 + 1);
	add (l, r, m, rb, p * 2 + 2);
	idt[p].kids = f (p * 2 + 1, m - lb) + f (p * 2 + 2, rb - m);
	idt[p].kids %= MOD;
//	printf ("%d %d <-- %d %d\n", lb, rb, idt[p].all, idt[p].kids);
}

void srch (int l, int r, int lb =0, int rb =MAXN, int p =0) {
//	if (p == 0) printf ("srch %d %d  %d %d %d\n", l, r, lb, rb, p);
	if (l < lb) l = lb;
	if (r > rb) r = rb;
	if (l >= r) return;
	if (l == lb && r == rb) {
//		printf ("\t%d %d -- %d\n", lb, rb, f (p, rb - lb));
		_result += (long long)f (p, rb - lb) * _add_val;
		_result %= MOD;
		return;
	}
	int m = (lb + rb) / 2;
	srch (l, r, lb, m, p * 2 + 1);
	srch (l, r, m, rb, p * 2 + 2);
	_result += (long long)(r - l) * idt[p].all * _add_val;
	_result %= MOD;
//	printf ("%d %d <-- added %d -- %d\n", lb, rb, (r - l) * idt[p].all, _result);
}

int main () {
	memset (pos, -1, sizeof (pos));

	scanf ("%d %d %d", &N, &K, &M);

	int i, j;
	int cpos = 0, old_cpos;
	for (i = 0; cpos != N; ++i) {
		if (pos[i] != -1) continue;
		old_cpos = cpos;
		for (j = i; pos[j] == -1; j = (j + K) % N)
			pos[j] = cpos++;
		assert (GC == 0 || GC == cpos - old_cpos);
		GC = cpos - old_cpos;
	}

	int a, b, c;
	int gca, gcb, begin, end;
	typeof (&add) to_call;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", &a, &b, &c);
		++b; --a;
		b += pos[a];
		a = pos[a];
//		printf ("__%d %d\n", a, b);

		gca = a / GC;
		gcb = b / GC;
		begin = gca * GC;
		end = begin + GC;

		if (c) to_call = &add;
		else to_call = &srch;
		_add_val = c >? 1;
		_result = 0;
		if (gca == gcb)
			to_call (a, b);
		else {
			to_call (a, end);
			to_call (begin, begin + b % GC);
			if (gcb - gca > 1) {
				_add_val *= (gcb - gca - 1);
				to_call (begin, end);
			}
		}
		if (!c) printf ("%Ld\n", _result);
	}

	return 0;
}
