/*
FROM: Campion 2005/2006 round 10 Large
PROB: rlcs
KEYW: idea from longest increasing subsequence, dynamical programming, binary search
*/

#include <cstdio>
#include <algorithm>

const int MAXD = 1 << 20;
const int MAXN = 1 << 14;

int N, M;

short vec[MAXD];
short buf[MAXN];

short dp[MAXN];

int main () {
	memset (vec, -1, sizeof (vec));
	memset (dp, 0x7f, sizeof (dp));//INF = 0x7f7f
	dp[0] = -dp[1];//-INF = -0x7f7f

	scanf ("%d %d", &N, &M);
	int i, j;
	int a;
	for (i = 0; i < N; ++i) {//build the graph
		scanf ("%d", &a);
		buf[i] = vec[a];
		vec[a] = i;
	}

	int csz = 1;
	for (i = 0; i < M; ++i) {
		scanf ("%d", &a);
		for (j = vec[a]; j != -1; j = buf[j]) {
			*std::lower_bound (dp, dp + csz, j) = j;
			if (dp[csz] != 0x7f7f) ++csz;
		}
	}

	printf ("%d\n", csz - 1);

	return 0;
}
