/*
FROM: ROMANIA CHAMPION 2005/2006
PROB: stea
KEYW: dynamical programming
*/

#include <cstdio>
#include <algorithm>

using std::min;
using std::max;

const int MAXN = 1 << 7;
const int MAXM = 1 << 8;

int N, M;
bool ma3x[MAXN][MAXM];
int opt[MAXN][MAXM];

int main () {
	scanf ("%d\n", &N);
	M = 2 * N - 1;

	int i, j;
	char tmp;
	for (i = 0; i < N; ++i) {
		while (scanf ("%c", &tmp), tmp == ' ');
		ma3x[i][i] = (tmp == '-');
		for (j = i + 1; j < M - i; ++j) {
			scanf ("%c", &tmp);
			ma3x[i][j] = (tmp == '-');
		}
		scanf ("\n");
	}
/*
	for (i = 0; i < N; ++i) {
		for (j = 0; j < M - i; ++j)
			printf ("%d ", ma3x[i][j]);
		printf ("\n");
	}
*/
	int best = 0;

	for (j = 0; j < M; j += 2) {
		opt[0][j] = ma3x[0][j];
		if (ma3x[0][j]) best = 1;
	}

	for (i = 1; i < N; ++i)
		for (j = i; j < M - i; j += 2) {
			opt[i][j] = (ma3x[i][j] ? (ma3x[i - 1][j] ? min (opt[i - 1][j - 1], opt[i - 1][j + 1]) : 0) + 1 : 0);
			if (best < opt[i][j])
				best = opt[i][j];
		}
/*
	for (i = 0; i < N; ++i) {
		for (j = 0; j < M - i; ++j)
			printf ("%d ", opt[i][j]);
		printf ("\n");
	}
*/
	for (i = 0; i < N - 1; ++i) {
		opt[i][i + 1] = ma3x[i][i + 1];
		opt[i][M - i - 2] = ma3x[i][M - i - 2];
		if (ma3x[i][i + 1] || ma3x[i][M - i - 2]) best = max (best, 1);
	}

	for (i = N - 4; i >= 0; --i) {
		for (j = i + 3; j < M - i - 3; j += 2) {
			opt[i][j] = (ma3x[i][j] ? (ma3x[i + 1][j] ? min (opt[i + 1][j - 1], opt[i + 1][j + 1]) : 0) + 1 : 0);
			if (best < opt[i][j]) {
				best = opt[i][j];
			}
		}
	}
/*
	for (i = 0; i < N; ++i) {
		for (j = 0; j < M - i; ++j)
			printf ("%d ", opt[i][j]);
		printf ("\n");
	}
*/
	printf ("%d\n", best * best);

	return 0;
}
