/*
FROM: ROMANIA CHAMPION 2005/2006
PROB: submatrix
KEYW: triangular search
*/

#include <cstdio>

const int MAXN = 1 << 7;
const int MAXM = 1 << 7;

int N, M;
bool ma3x[MAXN][MAXM];
int opt[MAXN][MAXM];

int tell (int a1, int b1, int a2, int b2) {
	return opt[a2][b2] - (a1 ? opt[a1 - 1][b2] : 0) - (b1 ? opt[a2][b1 - 1] : 0) + (a1 && b1 ? opt[a1 - 1][b1 - 1] : 0);
}

int S (int a1, int b1, int a2, int b2) {
	return (a2 - a1 + 1) * (b2 - b1 + 1);
}

int main () {
	scanf ("%d %d\n", &N, &M);

	int i, j;
	char tmp;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < M; ++j) {
			scanf ("%c", &tmp);
			ma3x[i][j] = tmp == '1';
		}
		scanf ("\n");
	}

	opt[0][0] = ma3x[0][0];
	for (i = 1; i < N; ++i)
		opt[i][0] = opt[i - 1][0] + ma3x[i][0];
	for (j = 1; j < M; ++j)
		opt[0][j] = opt[0][j - 1] + ma3x[0][j];

	for (i = 1; i < N; ++i)
		for (j = 1; j < M; ++j)
			opt[i][j] = opt[i - 1][j] + opt[i][j - 1] - opt[i - 1][j - 1] + ma3x[i][j];
/*
	for (i = 0; i < N; ++i) {
		for (j = 0; j < M; ++j)
			printf ("%d ", opt[i][j]);
		printf ("\n");
	}
*/
	int ii, jj;
	int bi = -1, bj = -1, bii = -1, bjj = -1, best = 0;
	int ss;
	for (i = 0; i < N; ++i)
		for (j = 0; j < M; ++j) {
//			printf ("%d %d\n", i, j);
			ii = i; jj = M - 1;
			while (jj >= j && ii < N) {
				if (tell (i, j, ii, jj) == (ss = S (i, j, ii, jj))) {
					if (best < ss) {
						best = ss;
						bi = i; bj = j;
						bii = ii; bjj = jj;
					}
					++ii;
				} else {
					--jj;
				}
//				printf ("(%d %d %d) ", ii, jj, ss);
			}

//			printf ("\n");
		}
	printf ("%d\n%d %d %d %d\n", best, bi + 1, bj + 1, bii + 1, bjj + 1);

	return 0;
}
