/*
FROM: ROMANIA 2005/2006 ROUND 12 L
PROB: atac
KEYW: mars index tree
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 17;

struct rec {
	int u, d, l, r;
};

struct node {
	int allcov;
	int partcov;
	int lencov;
	node () {}
	node (int _allcov, int _partcov, int _lencov) : allcov (_allcov), partcov (_partcov), lencov (_lencov) {}
};

int N;
int rN;
rec vec[MAXN];

node id[MAXN * 2];

int gr (int a) {return a < N ? vec[a].l : vec[a-N].r;}
bool cmp (int a, int b) {return gr (a) < gr (b);}
void getlencov (node a, int &cov, int &len, int anl) {
	cov = a.allcov + a.partcov;
	len = (!a.partcov ? !a.allcov ? 0 : anl : a.lencov);
}

void add (int la, int ra, int val, int l, int r, int p) {
	int m = (l + r) / 2;

	if (la == l && ra == r) {
		id[p].allcov += val;
		return;
	}
	if (ra <= m)
		add (la, ra, val, l, m, p * 2 + 1);
	else if (la >= m )
		add (la, ra, val, m, r, p * 2 + 2);
	else {
		add (la, m, val, l, m, p * 2 + 1);
		add (m, ra, val, m, r, p * 2 + 2);
	}
	int cov1, len1, cov2, len2;
	getlencov (id[p*2+1], cov1, len1, m - l);
	getlencov (id[p*2+2], cov2, len2, r - m);

	id[p].partcov = std::max (cov1, cov2);
	id[p].lencov = (id[p].partcov == cov1 ? len1 : 0) + (id[p].partcov == cov2 ? len2 : 0);
}

int main () {
	freopen ("atac.in", "r", stdin);
	freopen ("atac.out", "w", stdout);

	scanf ("%d", &N);
	rN = N;
	while ((rN & -rN) != rN) rN &= rN - 1;//remove lowest bit
	if (rN < N) rN <<= 1;//if N is power of 2 - remain

	int i;
	int idx[MAXN * 2];
	for (i = 0; i < N; ++i) {
		scanf ("%d %d %d %d", &vec[i].l, &vec[i].d, &vec[i].r, &vec[i].u);
		idx[i * 2] = i;
		idx[i * 2 + 1] = i + N;
	}

	std::sort (idx, idx + 2 * N, cmp);

	int times_covered = 0;
	int S_covered = 0;
	int p, c, tc, lc;
	for (i = 0; i < 2 * N; ++i) {
		if (i && gr (idx[i]) != gr (idx[i-1])) {
			p = gr (idx[i-1]);
			c = gr (idx[i]);
			getlencov (id[0], tc, lc, rN);//the one of the previous

			if (times_covered < tc) {
				times_covered = tc;
				S_covered = 0;
			}
			if (times_covered == tc)
				S_covered += lc * (c - p);
		}

		if (idx[i] < N)
			add (vec[idx[i]].d,		 vec[idx[i]].u, 	1, 		0, rN, 0);
		else
			add (vec[idx[i]-N].d, 	vec[idx[i]-N].u, 	-1, 	0, rN, 0);
	}

	printf ("%d %d\n", times_covered, S_covered);

	return 0;
}
