/*
FROM: Champion 2006 #13
PROB: bio
KEYW: dynamical programming
*/

#include <cstdio>
#include <vector>
#include <utility>
#include <cstring>

const int MAXLEN = 1 << 7;

std::vector <std::vector <std::pair <int, int> > > trf1;
bool trf2[1 << 4][1 << 4];
int YC;
int yng[1 << 4];
bool young[1 << 4];

int len;
int crnt[MAXLEN];

bool opt[MAXLEN][MAXLEN][1 << 4];

void make_opt () {
	int i, j, m, k, _k, p;
	int d;

	for (i = 0; i <= 100; ++i)
		for (j = 0; j <= 100; ++j)
			for (k = 0; k <= 10; ++k)
				opt[i][j][k] = 0;

	for (i = 0; i < len; ++i)
		for (k = 0; k < 10; ++k) {
			if (!young[k]) continue;
			opt[i][i+1][k] = (k == crnt[i] || trf2[k][crnt[i]]);
		}

	for (d = 2; d <= len; ++d)
		for (i = 0; i + d <= len; ++i)
			for (_k = 0; _k < YC; ++_k) {
				k = yng[_k];
				for (p = 0; p < (int)trf1[k].size (); ++p)
					for (m = i + 1; m < i + d; ++m)
						if (opt[i][m][trf1[k][p].first] && opt[m][i+d][trf1[k][p].second]) {
							opt[i][i+d][k] = 1;
							goto nxtk;
						}

				nxtk:;
			}
}


void get_one () {
	int i;
	char buf[MAXLEN];
	len = 0;
	scanf ("%s", buf);
//	printf ("scanned -%s-\n", buf);
	len = strlen (buf);
	for (i = 0; i < len; ++i)
		crnt[i] = buf[i] - '0';
}

int main () {
	freopen ("bio.in", "r", stdin);
	freopen ("bio.out", "w", stdout);

	int n, tcnt;

	scanf ("%d", &YC);

	int i, j;
	int a, b, c;

	for (i = 0; i < YC; ++i) {
		scanf ("%d", yng + i);
		young[yng[i]] = 1;
	}

	trf1.resize (10);
	scanf ("%d", &tcnt);
//	printf ("%d\n", tcnt);
	for (i = 0; i < tcnt; ++i) {
		scanf ("%d%d%d", &a, &b, &c);

		if (c == -1)
			trf2[a][b] = 1;
		else
			trf1[a].push_back (std::make_pair (b, c));

//		printf ("%d %d %d\n", a, b, c);
	}

	scanf ("%d\n", &n);


	for (i = 0; i < n; ++i) {
		get_one ();

		if (len == 1 && crnt[0] == 0) {
			printf ("%s\n", young[0] ? "a young virus" : "an adult virus");
			continue;
		}

		make_opt ();
		if (opt[0][len][0]) {
			for (j = 0; j < len; ++j)
				if (young[crnt[j]]) {
					printf ("a young virus\n");
					break;
				}
			if (j == len) printf ("an adult virus\n");
		} else
			printf ("not a virus\n");
	}

	return 0;
}
