/*
FROM: Champion 2006 round 1 (training)
PROB: numere
KEYW: dynamical programming with optimizations on the inner cycle
*/

#include <cstdio>

const int MAXB = 1 << 10;
const long long MOD = 666013;

int N, B;
long long dp[4][MAXB];

int main () {
	freopen ("numere.in", "r", stdin);
	freopen ("numere.out", "w", stdout);

	scanf ("%d %d", &N, &B);

	int pid = 1, cid = 2;

	int i, j;
	long long sum1, sum2;
	for (j = 1; j < B; ++j) dp[pid][j] = 1;
	for (i = 2; i <= N; ++i) {
		sum1 = sum2 = 0;
		for (j = 1; j < B; ++j) sum1 += dp[pid][j];
		for (j = 1; j < B; ++j) {
			sum1 -= dp[pid][j];
			sum2 += dp[pid][j] * j;
			dp[cid][j] = (sum1 * j + sum2) % MOD;
//			printf ("%d %d -- %Ld(%Ld %Ld)\n", i, j, dp[cid][j], sum1, sum2);
		}
		pid = cid;
		cid = (cid + 1) & 3;
	}

	sum1 = 0;
	for (j = 1; j < B; ++j)
		sum1 += dp[pid][j];
	sum1 %= MOD;
	printf ("%Ld\n", sum1);

	return 0;
}
