#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>

const long double EPS = 1e-3;
int N;

long double rad (long double grad) {
	return grad / 180 * M_PI;
}

int main (int argc, char *argv[]) {
	assert (argc == 3);

	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");

	assert (in && out);

	fscanf (in, "%d\n", &N);
	
	long double cang = 0;
	long double dang;
	long double cx = 0, cy = 0;
	int len;
	for (int i = 0; i < N; ++i) {
		fscanf (in, "%d", &len);
		fscanf (out, "%Lf", &dang);
		if (dang < 0 || dang >= 360.) {
			printf ("WRONG!!\n");
			exit (0);
		}

		cang += rad (dang);
		cx += len * cos (cang);
		cy += len * sin (cang);
//		printf ("(%d %Lf)now (%d) in pnt %Lf %Lf (ang == %Lf)\n", len, dang, i, cx, cy, cang);
	}

	int endx, endy;
	fscanf (in, "%d %d", &endx, &endy);
	printf ("(%d %d) (%Lf %Lf)\n", endx, endy, cx, cy);
	printf ("%s\n", (fabsl (endx - cx) + fabsl (endy - cy) < EPS ? "CORRECT" : "WRONG"));

	return 0;
}
