/*
FROM: Champion 2006 round 2 Large
PROB: formule
KEYW: reverse polish notation, full exhaustion
*/

#include <cstdio>
#include <cctype>
#include <cassert>

const int ALPHA = 1 << 5;
const int MAXSTK = 1 << 8;

enum {NOT = 16, AND = 17, OR = 18, IMP = 19, EQ = 20};

int used[ALPHA];
int cu;

int sp;
int stk[MAXSTK];

void to_stk (int a) {
	if (isalpha (a)) {
		a -= 'a';
		if (used[a] == -1) {
			used[a] = cu;
			stk[sp++] = cu++;
		} else
			stk[sp++] = used[a];
	} else
		stk[sp++] = a;
}

int read_op () {
	int tmp = getchar ();
	switch (tmp) {
		case '&': /*printf ("_&_");*/ return AND;
		case '|': /*printf ("_|_");*/ return OR;
		case '-': /*printf ("_->_");*/ return getchar (), IMP;
		case '<': /*printf ("_<->_");*/ return getchar (), getchar (), EQ;
		default : printf ("%c\n", tmp); assert (0);
	}
}

void read () {
	int tmp;
	if (isalpha (tmp = getchar ())) {
//		printf ("__%c__", tmp);
		to_stk (tmp);
	} else {//tmp == '('
//		printf ("__(__");
		tmp = getchar ();
		if (tmp == '!') {
//			printf ("__!__");
			read ();
			to_stk (NOT);
//			printf ("__)__");
			assert (getchar () == ')');//eat the ')'
			return;
		}
		ungetc (tmp, stdin);
		read ();
		int oper = read_op ();
		read ();
//		printf ("__)__");
		assert (getchar () == ')');//eat the ')'
		to_stk (oper);
	}
}

unsigned _val;
bool eval () {
	static bool stk2[MAXSTK];
	static int sp2;

	sp2 = 0;
	for (int i = 0; i < sp; ++i) {
		if (stk[i] < NOT) {
			stk2[sp2++] = _val & (1 << stk[i]);
//			printf ("(->%d)", stk2[sp2-1]);
		} else switch (stk[i]) {
			case NOT: stk2[sp2-1] = !stk2[sp2-1]; break;
			case AND: stk2[sp2-2] = stk2[sp2-2] && stk2[sp2-1]; --sp2; /*printf ("(%d)", stk2[sp2-1]); */break;
			case  OR: stk2[sp2-2] = stk2[sp2-2] || stk2[sp2-1]; --sp2; /*printf ("(%d)", stk2[sp2-1]); */break;
			case IMP: stk2[sp2-2] = !(stk2[sp2-2] && !stk2[sp2-1]); --sp2; /*printf ("(IMP%d)", stk2[sp2-1]); */break;
			case  EQ: stk2[sp2-2] = (stk2[sp2-2] == stk2[sp2-1]); --sp2; /*printf ("(%d)", stk2[sp2-1]); */break;
		}
	}
//	printf ("\n");
	assert (sp2 == 1);
	return stk2[0];
}

int main () {
	int N;
	scanf ("%d\n", &N);

	while (N--) {
		for (int i = 0; i < ALPHA; ++i) used[i] = -1;
		cu = sp = 0;
		read ();
/*
		for (int i = 0; i < sp; ++i) {
			if (stk[i] < NOT)
				printf (" %c", stk[i] + 'a');
			else {
				switch (stk[i]) {
					case NOT: printf (" !"); break;
					case AND: printf (" &"); break;
					case OR: printf (" |"); break;
					case IMP: printf (" ->"); break;
					case EQ: printf (" <->"); break;
					default: assert (0);
				}
			}
		}
		printf ("\n");
*/
		unsigned ub = 1u << cu;
		_val = 0;
		bool to_be = eval ();
		for (_val = 1u; _val < ub && eval () == to_be; ++_val);
//		printf ("%u %d\n", _val, to_be);
		printf ("%c\n", _val != ub ? 'N' : to_be ? 'T' : 'C');
		assert (getchar () == '\n');//eat the new line
	}

	return 0;
}
