/*
FROM: Champion 2006 round 3 Large
PROB: ture
KEYW: dynamical programming with mask
*/

#include <cstdio>
#include <cstring>
#include <utility>

const int MAXN = 256;
const int MAXM = 16;
const int MAXK = 16;
const int MAXMASK = 1 << 15;

typedef unsigned long long big;

int N, P;
unsigned M, K;
big dp[MAXN][MAXMASK];
unsigned board[MAXN];
std::pair <int, int> vec[MAXN];

int main () {
	FILE *in = fopen ("ture.in", "r");
	FILE *out = fopen ("ture.out", "w");

	fscanf (in, "%d %u %u", &N, &M, &K);
	fscanf (in, "%d", &P);

	register int i;
	register unsigned j, ii;
	for (i = 0; i < P; ++i)
		fscanf (in, "%d %d", &vec[i].first, &vec[i].second);
	fclose (in);

	if (N < (int)M) {
		for (i = 0; i < P; ++i)
			board[vec[i].second - 1] |= 1 << vec[i].first - 1;
		i = N; N = M; M = i;
	} else {
		for (i = 0; i < P; ++i)
			board[vec[i].first - 1] |= 1 << vec[i].second - 1;
	}

	if (K > M) {printf ("0\n"); return 0;}

	unsigned ub = 1 << M, sb = 1 << M - 1;
	unsigned jj, pc;
	register unsigned bm;
	for (j = 0u; j < ub; ++j) {
		jj = j;
		pc = 0;
		while (jj) {
			++pc;
			jj &= jj - 1;
		}
		if (pc == K) dp[N][j] = 1;			
	}

	for (i = N-1; i >= 0; --i) {
		for (j = 0; j < ub; ++j) {
			jj = j;
			pc = 0;
			while (jj) {
				++pc;
				jj &= jj - 1;
			}
			dp[i][j] = dp[i+1][j];
			if (pc != K) {
				bm = board[i] | j;
				for (ii = sb; ii; ii >>= 1u)
					if (!(bm & ii))
						dp[i][j] += dp[i+1][j | ii];
			}
		}
	}

//	prnt (dp[0][0][K]);
	fprintf (out, "%Ld\n", dp[0][0]);
	fclose (out);

	return 0;
}
