/*
FROM: Champion 2006 round 3 Large
PROB: ture
KEYW: dynamical programming with mask
*/

#include <cstdio>
#include <cstring>
#include <utility>

const int MAXN = 256;
const int MAXM = 16;
const int MAXK = 16;
const int MAXMASK = 1 << 15;

typedef unsigned long long big;

int N, P;
unsigned M, K;
big dp[MAXN][MAXMASK][MAXK];
unsigned board[MAXN];
std::pair <int, int> vec[MAXN];

int main () {
	scanf ("%d %u %u", &N, &M, &K);
	scanf ("%d", &P);

	register int i;
	register unsigned j, ii, k;
	for (i = 0; i < P; ++i)
		scanf ("%d %d", &vec[i].first, &vec[i].second);

	if (N < (int)M) {
		for (i = 0; i < P; ++i)
			board[vec[i].second - 1] |= 1 << vec[i].first - 1;
		i = N; N = M; M = i;
	} else {
		for (i = 0; i < P; ++i)
			board[vec[i].first - 1] |= 1 << vec[i].second - 1;
	}

	if (K > M) {printf ("0\n"); return 0;}

	unsigned ub = 1 << M;
	register unsigned bm;
	for (j = 0u; j < ub; ++j) dp[N][j][0] = 1;
	for (i = N-1; i >= 0; --i) {
		for (j = 0; j < ub; ++j) {
/*			// k == 0
			dp[i][j][0] = dp[i+1][j][0];

//			bm = board[i] | j;
			for (k = 1u; k <= K; ++k) {
				dp[i][j][k] = dp[i+1][j][k];
			}
*/
			memcpy (dp[i][j], dp[i+1][j], (K+1) * sizeof (big));
			bm = board[i] | j;
			for (ii = 1u; ii < ub; ii <<= 1u) {
				if (!(bm & ii)) {
					for (k = 1u; k <= K; ++k)
						dp[i][j][k] += dp[i+1][j | ii][k-1u];
				}
			}
		}
	}

//	prnt (dp[0][0][K]);
	printf ("%Ld\n", dp[0][0][K]);

	return 0;
}
