/*
FROM: Champion 2006 round 7 Large
PROB: croco
KEYW: dinitz max flow, min cut
*/

#include <cstdio>
#include <cstring>
//#include <vector>
#include <algorithm>

const int MAXN = 1 << 7;
const int MAX_CAP = 1 << 10;

int N;
short rd[MAXN][MAXN];
char D[MAXN];
char bD[MAXN];
short ma3x[MAXN][MAXN];
int source, sink;

unsigned vp;
unsigned char vl[MAXN];
//bool used[MAXN];

void bfs () {
	static int q[MAXN];
	static int p3, i, j;

	memset (D, -1, sizeof (D));
//	memset (used, 0, sizeof (used)); used[source] = 1;
/*	for (i = 0; i < N; ++i) {
		D[i] = -1;
		used[i] = 0;
	}*/
//	used[source] = 1;
	p3 = 0;
	D[q[p3++] = sink] = 0;

	for (i = 0; i < p3; ++i) {
//		printf ("pop %d(%d)\n", q[i], D[i]);
		for (j = 0; j < N; ++j) {
			if (rd[j][q[i]] > 0 && D[j] == -1) {
//				printf ("\rpush %d(%d)\n", j, D[q[i]] + 1);
				D[j] = D[q[i]] + 1;
				q[p3++] = j;
			}
		}
	}/*
	for (i = 0; i < N; ++i)
		printf ("%d ", D[i]); printf ("--bfs-\n");*/
}

int _dfs_ret;
void dfs (int a) {
//	printf ("dfs %d\n", a);
	if (a == sink) {
		_dfs_ret = MAX_CAP;
		return;
	}

	for (int i = 0; i < N; ++i)
		if (D[i] == D[a] - 1 && rd[a][i] > 0) {
//			printf ("\rdfs push %d\n", i);
			vl[vp++] = i;
			dfs (i);
			if (_dfs_ret) {_dfs_ret <?= rd[a][i]; D[a] = -5; return;}
			--vp;
		}

	D[a] = -5;//cannot be reached again
	_dfs_ret = 0;
}

int maxflow;
void dinitz (int _sink) {
	static unsigned i;
	static int c, _sv_d_source;
	sink = _sink;
	memcpy (rd, ma3x, sizeof (ma3x));

	maxflow = 0;
	while (bfs (), D[source] != -1) {
		_sv_d_source = D[source];
		while (vp = 0, D[source] = _sv_d_source, dfs (source), _dfs_ret) {
			maxflow += _dfs_ret;
			c = source;
			for (i = 0; i < vp; ++i) {
				rd[c][vl[i]] -= _dfs_ret;
				rd[vl[i]][c] += _dfs_ret;
				c = vl[i];
			}
		}
	}
}

int main () {
	FILE *in = fopen ("croco.in", "r");
	FILE *out = fopen ("croco.out", "w");
//	FILE *in = stdin;
//	FILE *out = stdout;

	fscanf (in, "%d", &N);
	int i, j;
	int sum = 0;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			fscanf (in, "%hd", &ma3x[i][j]);
			sum += ma3x[i][j];
		}
	fclose (in);

	source = 0;
	int best = (dinitz (1), maxflow), besti = 1;
	memcpy (bD, D, sizeof (D));
	for (i = 2; i < N; ++i)
		if ((dinitz (i), maxflow) < best) {
			best = maxflow;
			besti = i;
			memcpy (bD, D, sizeof (D));
		}
//	for (int i = 0; i < N; ++i) printf (" %d", bD[i]); printf ("------\n");
//	dinitz (besti);

//	printf ("%d %d\n", best, besti);
/*	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			printf (" %d", rd[i][j]);
		printf ("\n");
	}
*/
/*	for (i = 0; i < N; ++i)
		if (D[i] == -1)
			ans.push_back (i);*/

	fprintf (out, "%d ", sum / 2 - best);
	fprintf (out, "%d\n%d", (int)std::count (bD, bD + N, -1), source + 1);
	for (i = 1; i < N; ++i) if (bD[i] == -1) fprintf (out, " %d", i + 1); fprintf (out, "\n");

	return 0;
}
