/*
FROM: Champion 2006 round 7 Large
PROB: johnie
KEYW: euler cycle, stl
*/

#include <cstdio>
#include <cassert>
#include <utility>
#include <vector>
#include <algorithm>

using std::make_pair;

const int MAXN = 1 << 16;
const int MAXM = 1 << 18;

struct el {
	int to;
	bool used, spec;
	int next;
	el () {}
	el (int _to, bool _used, bool _spec, int _next) : to (_to), used (_used), spec (_spec), next (_next) {}
};

int op (int a) {return a ^ 1;}

int N, M;
int vec[MAXN];
int in[MAXN];
el buf[MAXM];

int sp, sp2;
std::pair <int, bool> stk[MAXM + MAXN];
std::pair <int, bool> stk2[MAXM + MAXN];
std::vector <std::vector <int> > ans;

void output () {
	static std::vector <std::vector <int> > a1;
	a1.clear ();
	a1.push_back (std::vector <int> ());
/*	for (int i = sp2-1; i >= 0; --i)
		printf ("(%d %d)", stk2[i].first, stk2[i].second);
	printf ("\n");*/
	for (int i = sp2-1; i >= 0; --i) {
		if (stk2[i].second)
			a1.push_back (std::vector <int> ());
		a1.back ().push_back (stk2[i].first);
	}

	if (a1.size () > 1u) {
		std::copy (a1[0].begin (), a1[0].end (), back_inserter (a1.back ()));
	} else {
		assert (0);
	}

	for (int i = 1; i < (int)a1.size (); ++i) {
/*		printf ("-->");
		for (int j = 0; j < a1[i].size (); ++j)
			printf ("%d ", a1[i][j]);
		printf ("\n");*/
		ans.push_back (a1[i]);
	}
	sp2 = 0;
}

void euler () {
	int ii, i;
	for (ii = 0; ii < N; ++ii) {
		for (i = vec[ii]; i != -1; i = buf[i].next) {
			if (!buf[i].used) {
//				#warning check here
//				stk[sp++] = make_pair (ii, 0); //wont add this
				stk[sp++] = make_pair (buf[i].to, buf[i].spec);
				buf[i].used = buf[op (i)].used = 1;
//				printf ("start with %d -> %d %d\n", ii, buf[i].to, buf[i].spec);
				break;
			}
		}
		if (i == -1) {
//			printf ("cannot start from %d\n", ii);
			continue;//there is no free way starting from ii
		}
		while (sp) {
//			printf ("on top (%d %d)\n", stk[sp-1].first, stk[sp-1].second);
			for (i = vec[stk[sp-1].first]; i != -1; i = buf[i].next) {
				if (!buf[i].used) {
					stk[sp++] = make_pair (buf[i].to, buf[i].spec);
					buf[i].used = buf[op (i)].used = 1;
//					printf ("add %d %d\n", buf[i].to, buf[i].spec);
					break;
				}
			}
			if (i == -1) {
//				printf ("pop it!\n");
				stk2[sp2++] = stk[--sp];
			}
		}
		assert (sp == 0);
		output ();
	}
}

int main () {
	FILE *fin = fopen ("johnie.in", "r");
	FILE *out = fopen ("johnie.out", "w");
//	FILE *fin = stdin;
//	FILE *fout = stdout;

	fscanf (fin, "%d %d", &N, &M);

	int i, j;
	int a, b, bp = 0;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		fscanf (fin, "%d %d", &a, &b);
		--a; --b;
		++in[a]; ++in[b];

		buf[bp] = el (b, 0, 0, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, 0, 0, vec[b]);
		vec[b] = bp++;
	}
/*
	for (i = 0; i < N; ++i) {
		printf ("%d(%d) ->", i, in[i]);
		for (j = vec[i]; j != -1; j = buf[j].next)
			printf (" (%d %d %d)", buf[j].to, buf[j].used, buf[j].spec);
		printf ("\n");
	}
*/
	int other = -1;
	for (i = 0; i < N; ++i)
		if (in[i] & 1)
			if (other == -1)
				other = i;
			else {//add pair other <-> i
				buf[bp] = el (i, 0, 1, vec[other]);
				vec[other] = bp++;

				buf[bp] = el (other, 0, 1, vec[i]);
				vec[i] = bp++;
				other = -1;
			}
/*
	printf ("%d\n", bp - 2 * M);

	for (i = 0; i < N; ++i) {
		printf ("%d(%d) ->", i, in[i]);
		for (j = vec[i]; j != -1; j = buf[j].next)
			printf (" (%d %d %d)", buf[j].to, buf[j].used, buf[j].spec);
		printf ("\n");
	}
*/
	euler ();
	fprintf (out, "%d\n", (int)ans.size ());
	for (i = 0; i < (int)ans.size (); ++i) {
		fprintf (out, "%d", (int)ans[i].size ());
		for (int j = 0; j < (int)ans[i].size (); ++j)
			fprintf (out, " %d", ans[i][j] + 1);
		fprintf (out, "\n");
	}

	return 0;
}
