/*
FROM: Champion 2006 round 8 Large
PROB: arthur
KEYW: dijkstra, bfs
*/

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <queue>
#include <utility>

using std::make_pair;

const int MAXN = 1 << 8;
const int MAXM = 1 << 8;
const int MAXP = 1 << 7;

const short dx[] = {-2, -2, -1, 1, 2,  2,  1, -1};
const short dy[] = {-1,  1,  2, 2, 1, -1, -2, -2};

int N, M, K, P;
short pre[MAXP][MAXN][MAXM];
short inn[MAXP][2];

short ma3x[MAXP][MAXP];

short prev[MAXP];
short best[MAXN];

short man_dst (int a, int b) {
	return abs (inn[a][0] - inn[b][0]) >? abs (inn[a][1] - inn[b][1]);
}

void bfs (int id) {
	static std::pair <short, short> q[MAXM * MAXN];
	static int p3, i, k;
	static std::pair <short, short> c, n;
	static const short UNUSED = 0x7F7F;

	q[p3 = 0, p3++] = make_pair (inn[id][0], inn[id][1]);
	pre[id][inn[id][0]][inn[id][1]] = 0;
	for (i = 0; i < p3; ++i) {
		c = q[i];
		if (pre[id][c.first][c.second] == K) break;
		for (k = 0; k < 8; ++k) {
			n = make_pair (c.first + dx[k], c.second + dy[k]);
			if (n.first  >= 0 && n.first  < N
			 && n.second >= 0 && n.second < M
			 && pre[id][n.first][n.second] == UNUSED) {
				pre[id][n.first][n.second] = pre[id][c.first][c.second] + 1;
				q[p3++] = n;
			}
		}
	}
}


void dijkstra () {
	static std::priority_queue <std::pair <short, short> > q;
	static std::pair <short, short> c, n;
	static bool used[MAXN];

//	memset (prev, -1, sizeof (prev));
	memset (best, 0x7F, sizeof (best));

	q.push (make_pair (0, P+1));
	best[P+1] = 0;
	prev[P+1] = -2;
	while (!q.empty ()) {
		c = q.top (); q.pop ();
		c.first *= -1;
		used[c.second] = 1;
		for (int i = 0; i < P + 2; ++i) {
			if (best[i] > c.first + ma3x[c.second][i]) {
				best[i] = c.first + ma3x[c.second][i];
				q.push (make_pair (-best[i], i));
				prev[i] = c.second;
			}
		}
	}
}

std::pair <short, short> ans[MAXN];
int ap;

short trf (short a) {
	return a > 0 ? 1 : a < 0 ? -1: 0;
}

void pb_foot (std::pair <short, short> s, std::pair <short, short> d) {
	if (s == d) return;
	ans[ap++] = d;
	return pb_foot (s, make_pair (d.first + trf (s.first - d.first), d.second + trf (s.second - d.second)));
}

void pb_h (std::pair <short, short> s, std::pair <short, short> d, int id) {
	static std::pair <short, short> n;
	if (s == d) return;
	ans[ap++] = d;
	for (int k = 0; k < 8; ++k) {
		n = make_pair (d.first + dx[k], d.second + dy[k]);
		if (n.first >= 0 && n.first < N
		 && n.second >= 0 && n.second < M
		 && pre[id][d.first][d.second] - 1 == pre[id][n.first][n.second])
			return pb_h (s, n, id);
	}
}

int main () {
	scanf ("%d %d %d %d", &N, &M, &K, &P);

	int i, j;
	int a, b;
	scanf ("%d %d", &a, &b); inn[P+1][0] = --a; inn[P+1][1] = --b;//arthur position
	scanf ("%d %d", &a, &b); inn[P][0] = --a; inn[P][1] = --b;//castle position
	for (i = 0; i < P; ++i) {
		scanf ("%d %d", &a, &b);
		inn[i][0] = --a;
		inn[i][1] = --b;
	}

	memset (pre, 0x7F, sizeof (pre));
	for (i = 0; i < P; ++i)
		bfs (i);

	for (i = 0; i < P; ++i) {
		for (int ii = 0; ii < N; ++ii) {
			for (int jj = 0; jj < M; ++jj)
				printf ("%3hd", pre[i][ii][jj] > 100 ? 99 : pre[i][ii][jj]);
			printf ("\n");
		}
		printf ("\n--------\n");
	}

	memset (ma3x, 0x7F, sizeof (ma3x));
	for (i = 0; i < P; ++i)
		for (j = i + 1; j <= P; ++j)
			ma3x[i][j] = ma3x[j][i] = pre[i][inn[j][0]][inn[j][1]] <? man_dst (i, j);

	for (i = 0; i <= P; ++i)
		ma3x[P+1][i] = man_dst (P+1, i);

	for (printf ("     "), i = 0; i <= P + 1; ++i) printf ("%3d", i); printf ("\n");
	for (i = 0; i <= P+1; ++i) {
		printf ("%2d ->", i);
		for (j = 0; j <= P+1; ++j)
			printf ("%3hd", ma3x[i][j] > 100 ? (short)99 : ma3x[i][j]);
		printf ("\n");
	}

	if (inn[P][0] == inn[P+1][0] && inn[P][1] == inn[P+1][1]) {printf ("0\n%hd %hd\n", inn[P][0], inn[P][1]); exit (0);}

	dijkstra ();
	for (i = P; i != P+1; i = prev[i]) {
//		ans[ap++] = make_pair (inn[i][0], inn[i][1]);
		if (best[i] - best[prev[i]] == man_dst (prev[i], i)) {//on foot
			printf ("on foot between %d -> %d\n", prev[i], i);
			pb_foot (make_pair (inn[prev[i]][0], inn[prev[i]][1]), make_pair (inn[i][0], inn[i][1]));
		} else {//on horse
			printf ("on h %d -> %d\n", prev[i], i);
			pb_h (make_pair (inn[prev[i]][0], inn[prev[i]][1]), make_pair (inn[i][0], inn[i][1]), prev[i]);
//			ans[ap++] = make_pair (inn[i][0] + 100, inn[i][1] + 100);
		}
	}
	ans[ap++] = make_pair (inn[P+1][0], inn[P+1][1]);

	for (i = ap-1; i >= 0; --i) printf ("%hd %hd\n", ans[i].first + 1, ans[i].second + 1);

	return 0;
}
