/*
FROM: Campion 2006/2007 round 9 Large
PROB: sol
KEYW: checker
*/

#include <cstdio>
#include <cstring>
#include <cassert>

const int MAXN = 1 << 8;
const int MAXE = 1 << 8;
const int MAXC = 1 << 8;

int N, E, C;
int edge[MAXE][2];
int ma3x[MAXN][MAXN];
int col[MAXN];
int col_used[MAXC];
int prev[MAXN];

void dfs (int a) {
	for (int i = 0; i < N; ++i)
		if (ma3x[a][i])
			if (prev[i] == -1) {
				prev[i] = a;
				dfs (i);
			} else
				assert (i == prev[a]);//only a link to our father is accepted
}

int main (int argc, char *argv[]) {
	assert (argc == 3);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");

	assert (in && out);

	fscanf (in, "%d %d %d", &N, &E, &C);

	int j;
	int a, b;
	for (int i = 0; i < E; ++i) {
		fscanf (in, "%d %d", &a, &b);
		edge[i][0] = --a;
		edge[i][1] = --b;
	}

	for (int i = 0; i < C; ++i)
		for (fscanf (in, "%d", &j); j; --j) {
			fscanf (in, "%d", &a);
			col[--a] = i;
		}

	fscanf (out, "%d", &a);
	if (a == -1) {printf ("said NO SOLUTION\n"); return 0;}
	assert (a == N-1);
	for (int i = 0; i < a; ++i) {
		fscanf (out, "%d", &b);
		--b;
		
		ma3x[edge[b][0]][edge[b][1]] = 1;
		ma3x[edge[b][1]][edge[b][0]] = 1;
		assert (!col_used[col[b]]);
		col_used[col[b]] = 1;
	}

	memset (prev, -1, sizeof (prev));
	prev[0] = -2;
	dfs (0);

	printf ("seems CORRECT!\n");

	return 0;
}
