/*
FROM: Champion 2006 round 10 Large
PROB: druid
KEYW: divide and conquer
*/

#include <cstdio>
#include <utility>
#include <algorithm>

#define x first
#define y second
#define a first
#define b second.first
#define c second.second

const int MAXN = 1 << 10;
const int MAXM = 1 << 10;

int N, M;
std::pair <int, int> pos[MAXN];
std::pair <int, std::pair <int, int> > line[MAXM];
int idx[MAXN];

int tell (int did, int lid) {
	return line[lid].a * pos[did].x + line[lid].b * pos[did].y + line[lid].c;
}

int _tell (int lid, int X, int Y) {
//	printf ("_tell %d %d %d -- %d(%d)\n", lid, X, Y, line[lid].a * X + line[lid].b * Y + line[lid].c, line[lid].a * X + line[lid].b * Y + line[lid].c > 0);
	return line[lid].a * X + line[lid].b * Y + line[lid].c > 0;
}

bool sort (int lb, int rb, int lvl) {
//	printf ("sort %d %d %d\n", lb, rb, lvl);
	if (lb + 1 >= rb) return 0;//there is 0 or 1 druid
	if (lvl == M) return 1;//there are > 1 druids but no more lines

	int l = lb-1, r = rb;
	for (;;) {
		while (++l < rb && tell (idx[l], lvl) < 0);
		while (--r >= lb && tell (idx[r], lvl) > 0);
		if (l < r) std::swap (idx[l], idx[r]);
		else break;
	}
	++lvl;
	return sort (lb, l, lvl) || sort (l, rb, lvl);
}

int main () {
	FILE *in = fopen ("druid.in", "r");
	FILE *out = fopen ("druid.out", "w");
	int i;
	int maxX, maxY, minX, minY;
	while (fscanf (in, "%d %d %*d\n", &N, &M) == 2) {
		maxX = maxY = -(minX = minY = 1 << 11);
		for (i = 0; i < N; ++i) {
			fscanf (in, "%d %d\n", &pos[i].x, &pos[i].y);
			maxX >?= pos[i].x; maxY >?= pos[i].y;
			minX <?= pos[i].x; minY <?= pos[i].y;
			idx[i] = i;
		}
//		printf ("%d %d %d %d--\n", maxX, maxY, minX, minY);
		for (i = 0; i < M; ++i) {
			fscanf (in, "%d %d %d\n", &line[i].a, &line[i].b, &line[i].c);
			if (((_tell (i, maxX, maxY)
			  	+ _tell (i, maxX, minY)
			  	+ _tell (i, minX, maxY)
			  	+ _tell (i, minX, minY))
			  & 3) == 0
			 ) {//the four are either 0 or 1 so the sum is 0 or 4 wichi end in 00 (binary)
//				printf ("erase! %d %d %d\n", line[i].a, line[i].b, line[i].c);
				--i; --M;
			}
		}
		fgetc (in);//eats #
		std::random_shuffle (line, line + M);
//		for (i = 0; i < N; ++i) printf ("(%d %d)", pos[i].x, pos[i].y); printf ("\n");
//		for (i = 0; i < M; ++i) printf ("(%d %d %d)", line[i].a, line[i].b, line[i].c); printf ("\n");

		fprintf (out, "%s\n", sort (0, N, 0) ? "YES" : "NO");
	}

	return 0;
}
