/*
FROM: Champion 2006 round 11 Large
PROB: caravane
KEYW: dynamical programming on tree
*/

#include <cstdio>
#include <cstring>

const int MAXN = 100010;
const int MAXK = 1 << 5;

struct el {
	int to;
	int dst;
	int next;
	el () {}
	el (int _to, int _dst, int _next) : to (_to), dst (_dst), next (_next) {}
};

struct node {
	int c, s;
	node& operator += (const node &a) {c += a.c; s += a.s; return *this;}
	node () {}
	node (int _c, int _s) : c (_c), s (_s) {}
};

int N, K, K1;
int vec[MAXN];
el buf[MAXN * 2];

int prev[MAXN];
int pl[MAXN];
node dp[MAXN][MAXK];

long long res;

int main () {
	#warning check I/O
	freopen ("caravane.in", "r", stdin);
	freopen ("caravane.out", "w", stdout);

	scanf ("%d %d", &N, &K); K1 = K + 1;

	int i, j;
	int a, b, c, bp = 0;
	memset (vec, -1, sizeof (vec));
	for (i = 1; i < N; ++i) {
		scanf ("%d %d %d", &a, &b, &c);
		--a; --b;

		buf[bp] = el (b, c, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, c, vec[b]);
		vec[b] = bp++;
	}

	pl[0] = 0; prev[0] = -1;
//	dpf (0);
	static int stk[MAXN], sp;
	static bool used[MAXN];
	stk[sp++] = 0;
	//
	while (sp) {
		a = stk[--sp];
		if (!used[a]) {
			used[a]	= 1;
			++sp;
			for (i = vec[a]; i != -1; i = buf[i].next) {
				if (buf[i].to == prev[a]) continue;
				prev[buf[i].to] = a;
				pl[buf[i].to] = buf[i].dst;
				stk[sp++] = buf[i].to;
			}
		} else {
			for (i = vec[a]; i != -1; i = buf[i].next)
				if (buf[i].to != prev[a])
					for (j = 1; j < K; ++j)
						dp[a][j+1] += dp[buf[i].to][j];

//			for (j = 1; j <= K; ++j) printf ("(%d %d)", dp[a][j].c, dp[a][j].s); printf ("BEG %d\n", a);

			for (i = vec[a]; i != -1; i = buf[i].next) {
				if (buf[i].to == prev[a]) continue;
				for (j = 1; j < K; ++j) {
//					printf ("\tin dpf %d from %d, %d --> %d * %d(%d - %d)\n", a, buf[i].to, j, dp[buf[i].to][j].s, dp[a][K1-j].c - dp[buf[i].to][K-j].c, dp[a][K1-j].c, dp[buf[i].to][K-j].c);

					res += (long long)dp[buf[i].to][j].s * (dp[a][K1-j].c - dp[buf[i].to][K-j].c);
				}
			}
			dp[a][1].c = 1;
			for (j = 1; i <= K; ++i)
				dp[a][i].s += dp[a][i].c * pl[a];

			if (a) res += dp[a][K].s;
//			for (i = 1; i <= K; ++i) printf ("(%d %d)", dp[a][i].c, dp[a][i].s); printf ("<--%d\n", a);
		}
	}
	//

	printf ("%Ld\n", res * 2ll);

	return 0;
}

/*
void dpf (int a) {
	int i, j;
	for (i = vec[a]; i != -1; i = buf[i].next) {
		if (buf[i].to == prev[a]) continue;
		prev[buf[i].to] = a;
		pl[buf[i].to] = buf[i].dst;
		dpf (buf[i].to);
		for (j = 1; j < K; ++j)
			dp[a][j+1] += dp[buf[i].to][j];
	}
	for (i = vec[a]; i != -1; i = buf[i].next) {
		if (buf[i].to == prev[a]) continue;
		for (j = 1; j < K; ++j) {
			printf ("\tin dpf %d from %d, %d --> %d * %d(%d - %d)\n", a, buf[i].to, j, dp[buf[i].to][j].s, dp[a][K1-j].c - dp[buf[i].to][K-j].c, dp[a][K1-j].c, dp[buf[i].to][K-j].c);
			res += (long long)dp[buf[i].to][j].s * (dp[a][K1-j].c - dp[buf[i].to][K-j].c);
		}
	}
	dp[a][1].c = 1;
	for (j = 1; i <= K; ++i)
		dp[a][i].s += dp[a][i].c * pl[a];

	if (a) res += dp[a][K].s;
	for (i = 1; i <= K; ++i) printf ("(%d %d)", dp[a][i].c, dp[a][i].s); printf ("<--%d\n", a);
}*/
