/*
FROM: Champion 2006 round 11 Large
PROB: cuburi
KEYW: dynamical programming on mask, hard code
NOTE: WOW
*/

#include <cstdio>
#include <cassert>
#include <cstring>
#include <algorithm>

const int POS = 18;
const int MAXS = 160 * 160 * 20;
const int NC = 16;
const int MOD = 10000;
const int MAXN = 64;

struct el {
	int to;
	int a;
	int b;
	int sp;
//	el () {}
	el (int _to, int _a, int _b, int _sp =0) : to (_to), a (_a), b (_b), sp (_sp) {}
};

el nxt[POS][16] = {
	{
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2,  1,  0), el ( 3,  1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15, -1, -1), el (16, -1, -1),
		el (17,  4,  0)
	},{//1
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2, -1,  0), el ( 3, -1,  0), el ( 4, -1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7, -2,  0), el ( 8, -2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11, -3,  0), el (12,  3,  0),
										  el (15,  -1,  1,  1), el (16, -1, -1),
		el (17,  4,  0)
	},{//2
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2,  1,  0), el ( 3, -1,  0), el ( 4, -1,  0),
		el ( 5,  2,  0), el ( 6, -2,  0), el ( 7, -2,  0), el ( 8,  2,  0),
		el ( 9, -3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15, -1, -1), el (16, -1,  1, 1),
		el (17,  4,  0)
	},{//3
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2, -1,  0), el ( 3,  1,  0), el ( 4, -1,  0),
		el ( 5, -2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8, -2,  0),
		el ( 9,  3,  0), el (10, -3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15, -1, -1), el (16,  1, -1),
		el (17,  4,  0)
	},{//4
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2, -1,  0), el ( 3, -1,  0), el ( 4,  1,  0),
		el ( 5, -2,  0), el ( 6, -2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12, -3,  0),
										  el (15,  1, -1), el (16,  -1, -1),
		el (17,  4,  0)
	},{//5
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2,  1,  0), el ( 3, -1,  0), el ( 4, -1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7, -2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15, -1,  1,  1), el (16, -1,  1,  1),
		el (17,  4,  0)
	},{//6
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2, -1,  0), el ( 3,  1,  0), el ( 4, -1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8, -2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15, -1,  1,  1), el (16,  1, -1),
		el (17,  4,  0)
	},{//7
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2, -1,  0), el ( 3,  1,  0), el ( 4,  1,  0),
		el ( 5, -2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15,  1, -1), el (16,  1, -1),
		el (17,  4,  0)
	},{//8
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2,  1,  0), el ( 3, -1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6, -2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15,  1, -1), el (16, -1,  1, 1),
		el (17,  4,  0)
	},{//9
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2, -1,  0), el ( 3,  1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
		el (13,  2,  0), 				  				   el (16,  1, -1),
		el (17,  4,  0)
	},{//10
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2,  1,  0), el ( 3, -1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
		el (13,  2,  0), 				  				   el (16, -1,  1, 1),
		el (17,  4,  0)
	},{//11
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2,  1,  0), el ( 3,  1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
						 el (14,  2,  0), el (15,  1, -1),
		el (17,  4,  0)
	},{//12
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2,  1,  0), el ( 3,  1,  0), el ( 4, -1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
						 el (14,  2,  0), el (15, -1,  1, 1),
		el (17,  4,  0)
	},{//13
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2, -1,  0), el ( 3, -1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
		el (13,  2,  0),								   el (16, -1, -1),
		el (17,  4,  0)
	},{//14
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2,  1,  0), el ( 3,  1,  0), el ( 4, -1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
						 el (14,  2,  0), el (15, -1, -1),
		el (17,  4,  0)
	},{//15
		el ( 0,  0,  0),
		el ( 1,  1,  0, 1), el ( 2, -1,  0, 0), el ( 3, -1,  0, 0), el ( 4,  1,  0, 0),
		el ( 5,  2,  0, 1), el ( 6,  2,  0, 1), el ( 7,  2,  0, 0), el ( 8,  2,  0, 0),
		el ( 9,  3,  0, 2), el (10,  3,  0, 2), el (11,  3,  0, 0), el (12,  3,  0, 1),
										  		el (15,  1,  1, 0), el (16, -1, -1, 0),
		el (17,  4,  0, 2)
	},{//16
		el ( 0,  0,  0),
		el ( 1, -1,  0, 0), el ( 2,  1,  0, 1), el ( 3,  1,  0, 0), el ( 4, -1,  0, 0),
		el ( 5,  2,  0, 1), el ( 6,  2,  0, 0), el ( 7,  2,  0, 0), el ( 8,  2,  0, 1),
		el ( 9,  3,  0, 0), el (10,  3,  0, 1), el (11,  3,  0, 2), el (12,  3,  0, 2),
										  		el (15, -1, -1, 0), el (16,  1,  1, 0),
		el (17,  4,  0, 2)
	},{//17
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2,  1,  0), el ( 3,  1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
		el (13,  2,  0), el (14,  2,  0),
		el (17,  4,  0)
	}
};

struct q_el {
	int a, b, p;
	q_el () {}
	q_el (int _a, int _b, int _p) : a (_a), b (_b), p (_p) {}
};

void app (int i, int j, int p, int l, int &a, int &b, int &t) {
	t = nxt[p][l].to;
	switch (nxt[p][l].sp) {
		case 0: if (nxt[p][l].a <= 0) a = -nxt[p][l].a; else a = i + nxt[p][l].a;
				if (nxt[p][l].b <= 0) b = -nxt[p][l].b; else b = j + nxt[p][l].b;
				break;
		case 1: if (nxt[p][l].a <= 0) a = -nxt[p][l].a; else a = j + nxt[p][l].a;
				if (nxt[p][l].b <= 0) b = -nxt[p][l].b; else b = i + nxt[p][l].b;
				break;
		case 2: a = b = i + j;
				if (nxt[p][l].a <= 0) a = -nxt[p][l].a; else a += nxt[p][l].a;
				if (nxt[p][l].b <= 0) b = -nxt[p][l].b; else b += nxt[p][l].b;
				break;
		default: assert (0);
	}
}

int N, K;
int res;
int used[160][160][20];
int dp[2][160][160][20];
int _crnt = 0, _old = 1;
int pow16[MAXN];

int main () {
	scanf ("%d %d", &N, &K);

	pow16[0] = 1; for (int i = 1; i < MAXN; ++i) pow16[i] = (pow16[i-1] * 16) % MOD;

	res = 0;

	static q_el _q1[MAXS], _q2[MAXS];
	q_el *crntq = _q1, *oldq = _q2;
	int cp, op;
	oldq[op = 0, op++] = q_el (0, 0, 0);
	dp[_old][0][0][0] = 1;

	int a, b, p;
	int toa, tob, top;
	int i, l;
	for (int k = 1; k <= N; ++k) {
		cp = 0;
//		printf ("__level %d\n", k);
		for (i = 0; i < op; ++i) {
			a = oldq[i].a;
			b = oldq[i].b;
			p = oldq[i].p;
//			printf ("work with %d %d %d -- %d\n", a, b, p, dp[_old][a][b][p]);
//			printf ("lvl %d, popped %d %d %d\n", k, a, b, p);

			for (l = 0; l < NC; ++l) {
				app (a, b, p, l, toa, tob, top);
//				printf ("\tgoto %d %d %d\n", toa, tob, top);
				if (toa >= K || tob >= K) {
//					printf ("\t\tadding dp[%d][%d][%d][%d] * pow16[%d] == %d\n", _old, a, b, p, N-k, dp[_old][a][b][p] * pow16[N-k]);
					res += dp[_old][a][b][p] * pow16[N-k];
					res %= MOD;
				} else {
					if (used[toa][tob][top] == k) {
						dp[_crnt][toa][tob][top] += dp[_old][a][b][p];
						dp[_crnt][toa][tob][top] %= MOD;
					} else {
						dp[_crnt][toa][tob][top]  = dp[_old][a][b][p];
						used[toa][tob][top] = k;
						crntq[cp++] = q_el (toa, tob, top);
					}
				}
			}
		}
		std::swap (crntq, oldq);
		std::swap (cp, op);
		std::swap (_crnt, _old);
	}

	printf ("%d\n", res);

	return 0;
}
