/*
FROM: Champion 2006 round 11 Large
PROB: cuburi
KEYW: dynamical programming on mask, hard code
NOTE: WOW
*/

#include <cstdio>
#include <cassert>
#include <cstring>

const int POS = 18;
const int NC = 16;
const int MOD = 10000;
const int MAXN = 64;

struct el {
	int to;
	int a;
	int b;
	int sp;
//	el () {}
	el (int _to, int _a, int _b, int _sp =0) : to (_to), a (_a), b (_b), sp (_sp) {}
};

el nxt[POS][16] = {
	{
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2,  1,  0), el ( 3,  1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15, -1, -1), el (16, -1, -1),
		el (17,  4,  0)
	},{//1
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2, -1,  0), el ( 3, -1,  0), el ( 4, -1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7, -2,  0), el ( 8, -2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11, -3,  0), el (12,  3,  0),
										  el (15,  -1,  1,  1), el (16, -1, -1),
		el (17,  4,  0)
	},{//2
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2,  1,  0), el ( 3, -1,  0), el ( 4, -1,  0),
		el ( 5,  2,  0), el ( 6, -2,  0), el ( 7, -2,  0), el ( 8,  2,  0),
		el ( 9, -3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15, -1, -1), el (16, -1,  1, 1),
		el (17,  4,  0)
	},{//3
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2, -1,  0), el ( 3,  1,  0), el ( 4, -1,  0),
		el ( 5, -2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8, -2,  0),
		el ( 9,  3,  0), el (10, -3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15, -1, -1), el (16,  1, -1),
		el (17,  4,  0)
	},{//4
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2, -1,  0), el ( 3, -1,  0), el ( 4,  1,  0),
		el ( 5, -2,  0), el ( 6, -2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12, -3,  0),
										  el (15,  1, -1), el (16,  -1, -1),
		el (17,  4,  0)
	},{//5
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2,  1,  0), el ( 3, -1,  0), el ( 4, -1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7, -2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15, -1,  1,  1), el (16, -1,  1,  1),
		el (17,  4,  0)
	},{//6
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2, -1,  0), el ( 3,  1,  0), el ( 4, -1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8, -2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15, -1,  1,  1), el (16,  1, -1),
		el (17,  4,  0)
	},{//7
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2, -1,  0), el ( 3,  1,  0), el ( 4,  1,  0),
		el ( 5, -2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15,  1, -1), el (16,  1, -1),
		el (17,  4,  0)
	},{//8
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2,  1,  0), el ( 3, -1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6, -2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
										  el (15,  1, -1), el (16, -1,  1, 1),
		el (17,  4,  0)
	},{//9
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2, -1,  0), el ( 3,  1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
		el (13,  2,  0), 				  				   el (16,  1, -1),
		el (17,  4,  0)
	},{//10
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2,  1,  0), el ( 3, -1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
		el (13,  2,  0), 				  				   el (16, -1,  1, 1),
		el (17,  4,  0)
	},{//11
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2,  1,  0), el ( 3,  1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
						 el (14,  2,  0), el (15,  1, -1),
		el (17,  4,  0)
	},{//12
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2,  1,  0), el ( 3,  1,  0), el ( 4, -1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
						 el (14,  2,  0), el (15, -1,  1, 1),
		el (17,  4,  0)
	},{//13
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2, -1,  0), el ( 3, -1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
		el (13,  2,  0),								   el (16, -1, -1),
		el (17,  4,  0)
	},{//14
		el ( 0,  0,  0),
		el ( 1, -1,  0), el ( 2,  1,  0), el ( 3,  1,  0), el ( 4, -1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
						 el (14,  2,  0), el (15, -1, -1),
		el (17,  4,  0)
	},{//15
		el ( 0,  0,  0),
		el ( 1,  1,  0, 1), el ( 2, -1,  0, 0), el ( 3, -1,  0, 0), el ( 4,  1,  0, 0),
		el ( 5,  2,  0, 1), el ( 6,  2,  0, 1), el ( 7,  2,  0, 0), el ( 8,  2,  0, 0),
		el ( 9,  3,  0, 2), el (10,  3,  0, 2), el (11,  3,  0, 0), el (12,  3,  0, 1),
										  		el (15,  1,  1, 0), el (16, -1, -1, 0),
		el (17,  4,  0, 2)
	},{//16
		el ( 0,  0,  0),
		el ( 1, -1,  0, 0), el ( 2,  1,  0, 1), el ( 3,  1,  0, 0), el ( 4, -1,  0, 0),
		el ( 5,  2,  0, 1), el ( 6,  2,  0, 0), el ( 7,  2,  0, 0), el ( 8,  2,  0, 1),
		el ( 9,  3,  0, 0), el (10,  3,  0, 1), el (11,  3,  0, 2), el (12,  3,  0, 2),
										  		el (15, -1, -1, 0), el (16,  1,  1, 0),
		el (17,  4,  0, 2)
	},{//17
		el ( 0,  0,  0),
		el ( 1,  1,  0), el ( 2,  1,  0), el ( 3,  1,  0), el ( 4,  1,  0),
		el ( 5,  2,  0), el ( 6,  2,  0), el ( 7,  2,  0), el ( 8,  2,  0),
		el ( 9,  3,  0), el (10,  3,  0), el (11,  3,  0), el (12,  3,  0),
		el (13,  2,  0), el (14,  2,  0),
		el (17,  4,  0)
	}
};
/*
el ns[17] = {
16,
16,16,16,16,
16,16,16,16,
16,16,16,16,
16,16,16,16,
16
};*/

int N, K;
int res;
int dp[2][160][160][20];
int _crnt = 0, _old = 1;
int pow2[MAXN];

void app (int i, int j, int p, int l, int &a, int &b, int &t) {
	t = nxt[p][l].to;
	switch (nxt[p][l].sp) {
		case 0: if (nxt[p][l].a <= 0) a = -nxt[p][l].a; else a = i + nxt[p][l].a;
				if (nxt[p][l].b <= 0) b = -nxt[p][l].b; else b = j + nxt[p][l].b;
				break;
		case 1: if (nxt[p][l].a <= 0) a = -nxt[p][l].a; else a = j + nxt[p][l].a;
				if (nxt[p][l].b <= 0) b = -nxt[p][l].b; else b = i + nxt[p][l].b;
				break;
		case 2: a = b = i + j;
				if (nxt[p][l].a <= 0) a = -nxt[p][l].a; else a += nxt[p][l].a;
				if (nxt[p][l].b <= 0) b = -nxt[p][l].b; else b += nxt[p][l].b;
				break;
		default: assert (0);
	}
}

int __bulk, __myreal;

int main () {
//	FILE *out = fopen ("outx", "w");
	scanf ("%d %d", &N, &K);
	pow2[0] = 1;
	for (int i = 1; i < MAXN; ++i) pow2[i] = (pow2[i-1] * 16) % MOD;

/*
	for (N = 1; N <= 40; ++N)
		for (K = 1; K <= N * 4; ++K) {*/
//////////////////////////////////////////////////
	res = 0;
	_old = 0; _crnt = 1;
	memset (dp, 0, sizeof (dp));
	dp[_old][0][0][0] = 1;

	int a, b, t;
	int i, j, p, l;
	for (int k = 1; k <= N; ++k) {
//		printf ("_new level!\n");
		memset (dp[_crnt], 0, sizeof (dp) / 2);

		for (i = 0; i < K; ++i)
			for (j = 0; j < K; ++j)
				for (p = 0; p < POS; ++p) {
					if (!dp[_old][i][j][p]) {
//						++__bulk;
						continue;
					}
//					++__myreal;
					for (l = 0; l < NC; ++l) {
						app (i, j, p, l, a, b, t);
						if (a >= K || b >= K) {
//							printf ("adding from %d %d %d -- %d (move to %d)\n", i, j, p, dp[_old][i][j][p] * pow2[N-k], nxt[p][l].to);
							res += dp[_old][i][j][p] * pow2[N-k];
							res %= MOD;
						} else {
//							printf ("updating %d %d %d from %d %d %d -- %d (move to %d)\n", a, b, t, i, j, p, dp[_old][i][j][p], nxt[p][l].to);
							dp[_crnt][a][b][t] += dp[_old][i][j][p];
							dp[_crnt][a][b][t] %= MOD;
						}
					}
				}
		_crnt = _old;
		_old = !_old;
	}
	printf ("x[%d][%d] = %d\n", N, K, res);
//	fprintf (out, "x[%d][%d] = %d\n", N, K, res);
//	printf ("%lf\n", (double)__myreal / (__bulk + __myreal));
/////////////////////////////////////////////////////////////////////////////
//	}
//	fclose (out);

	return 0;
}
