/*
FROM: Campion 2006/2007 round 12 Large
PROB: mese
KEYW: dynamical programming on tree
*/

#include <cstdio>
#include <cstring>
#include <algorithm>

const int MAXN = 100010;

int N, S;
int vec[MAXN];
int buf[MAXN];

int grc[MAXN];
int rs[MAXN];

int main () {
	freopen ("mese.in", "r", stdin);
	freopen ("mese.out", "w", stdout);

	scanf ("%d %d", &N, &S);

	int i, j;
	int prev;
	int root = -1;
	memset (vec, -1, sizeof (vec));
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &prev, rs + i);
		--prev;
		if (prev == -1) root = i;

		buf[i] = vec[prev];
		vec[prev] = i;
		grc[i] = 1;
	}
/*
	printf ("root %d\n", root);
	for (i = 0; i < N; ++i) {
		printf ("%d -> ", i);
		for (j = vec[i]; j != -1; j = buf[j])
			printf (" %d", j);
		printf ("\n");
	}
*/
	static int stk[MAXN], stkp, c;
	static int kids[MAXN], kp;
	static bool used[MAXN];

	stk[stkp++] = root;
	while (stkp) {
		c = stk[stkp-1];
		if (!used[c]) {
//			printf ("phase 1 %d\n", c);
			for (i = vec[c]; i != -1; i = buf[i])
				stk[stkp++] = i;
			used[c] = 1;
		} else {
//			printf ("phase 2 %d\n", c);
			--stkp;

			for (i = vec[c], kp = 0; i != -1; i = buf[i]) {
				kids[kp++] = rs[i];
				grc[c] += grc[i];
			}

			std::sort (kids, kids + kp);
			for (i = 0; i < kp && (rs[c] += kids[i]) <= S; ++i) {
//				printf ("\ttaken %d\n", kids[i]);
			}
			if (i != kp) {
//				printf ("\tremove last %d\n", kids[i]);
				rs[c] -= kids[i];
			}

			grc[c] -= i;
//			printf ("\tgrc[%d] -- %d, rs -- %d\n", c, grc[c], rs[c]);
		}
	}

	printf ("%d\n", grc[root]);

	return 0;
}
