/*
FROM: Campion 2006/2007 round 13 (final) Large
PROB: hperm
KEYW: dynamical programming, extended euclidean algorithm, multiplicative inverse, modulus division
*/

#include <cstdio>
#include <utility>

const int MAXN = 1 << 14;

int N, MOD;

bool t[MAXN];
int s[MAXN];
int dp[MAXN];

std::pair <int, int> ext_gcd_rec (int a, int b) {
	std::pair <int, int> tmp;
	return b ? (tmp = ext_gcd_rec (b, a % b), std::make_pair (tmp.second, tmp.first - tmp.second * (a / b))) : std::make_pair (1, 0);
}

int mul_inv (int a) {
	return (ext_gcd_rec (a, MOD).first % MOD + MOD) % MOD;
}

int main () {
	scanf ("%d %d", &N, &MOD);

	t[3] = 1;
	s[3] = 1;

	dp[1] = 1;
	dp[2] = 1;
	dp[3] = 2;
	int C = 2;// C (1, 2)
//	int C2 = 2;
//	printf ("was 1 2\n");

	for (int i = 4; i <= N; ++i) {
		s[i] = s[i-1] + (t[i] = t[i/2]);

		dp[i] = dp[s[i]];
		dp[i] *= dp[i - 1 - s[i]];
		dp[i] %= MOD;

//		printf ("* %d * %d (%d %d)\n", dp[s[i]], dp[i-1-s[i]], s[i], i-1-s[i]);

		C *= i - 1;
//		C2 *= i-1; //
		C %= MOD;
//		printf ("up * %d\n", i - 1);
		if (t[i]) {
			C *= mul_inv (s[i]);
//			C2 /= s[i]; //
//			printf ("down * %d\n", s[i]);
		} else {
			C *= mul_inv (i - 1 - s[i]);
//			C2 /= i - 1 - s[i]; //
//			printf ("down * %d\n", i - 1 - s[i]);
		}

		C %= MOD;
		dp[i] *= C;
//		printf ("* %d (%d)\n", C, C2);
		dp[i] %= MOD;
	}

	printf ("%d\n", dp[N]);

	return 0;
}
