/*
have sequence of digits a0 a1 ... a(N-1)
find the longest sequense ap a(p+1) ... a(q-1) such that for every i, j in [p, q[ abs (ai - aj) <= D (D, N, ax given)
*/

#include <cstdio>
#include <vector>
#include <queue>

const int MAXN = 1 << 20;

struct heap {
	int num, idx;
	heap (int _num, int _idx) : num (_num), idx (_idx) {}
};

struct cmp_heap_min_inv {
	bool operator () (const heap &a, const heap &b) {return a.num > b.num;}
};

struct cmp_heap_max_inv {
	bool operator () (const heap &a, const heap &b) {return a.num < b.num;}
};

int N, D;
int vec[MAXN];

std::priority_queue <heap, std::vector <heap>, cmp_heap_min_inv> hmin;
std::priority_queue <heap, std::vector <heap>, cmp_heap_max_inv> hmax;

int blen =1, bp =0;//will store the best sequence

void solve () {
	for (int i = 1, cbeg = 1; i < N; ++i) {
		hmin.push (heap (vec[i-1], i-1));
		hmax.push (heap (vec[i-1], i-1));

		while (!hmin.empty () && (hmin.top ().idx < cbeg || abs (hmin.top ().num - vec[i]) > D && (cbeg = hmin.top ().idx + 1)))
			hmin.pop ();

		while (!hmax.empty () && (hmax.top ().idx < cbeg || abs (hmax.top ().num - vec[i]) > D && (cbeg = hmax.top ().idx + 1)))
			hmax.pop ();

		if (blen < i + 1 - cbeg) {
			blen = i + 1 - cbeg;
			bp = cbeg;
		}
	}
}

int main () {
	scanf ("%d %d", &N, &D);
	for (int i = 0; i < N; ++i)
		scanf ("%d", vec + i);

	solve ();
	printf ("%d\n%d\n", blen, bp);

	return 0;
}
