/**************************************************
 *___b_:_'<bukvi>'___ -> init             //tip1
 *___b_=_b_&_b_|_b.....~ ->               //tip2
 *___b -> print                           //tip3
 **************************************************/

#include <cstdio>
#include <cctype>
#include <cstdlib>
#include <cstring>

const int ALEN = 26;
const int MAXPERLINE = 80;
const int MAXSTCLEN = MAXPERLINE;

struct set {
	bool a[ALEN];
	set () {for (int i = 0; i < ALEN; ++i) a[i] = 0;}
	set (const set &b) {for (int i = 0; i < ALEN; ++i) a[i] = b.a[i];}
	set operator = (const set &b) {
		for (int i = 0; i < ALEN; ++i) a[i] = b.a[i];
		return *this;
	}

	void init (char *s) {
		for (; *s; ++s) a[*s - 'a'] = 1;
	}

	void prnt () {
		printf ("[");
		int i;
		for (i = 0; i < ALEN && !a[i]; ++i);
		if (i == ALEN) goto end;
		printf ("%c", i + 'a');
		for (++i; i < ALEN; ++i)
			if (a[i]) printf (", %c", i + 'a');
		end:;
		puts ("]");
	}

	set& operator |= (const set &b) {
		for (int i = 0; i < ALEN; ++i) a[i] = a[i] || b.a[i];
		return *this;
	}
	set& operator &= (const set &b){
		for (int i = 0; i < ALEN; ++i) a[i] = a[i] && b.a[i];
		return *this;
	}
	set& operator ~ () {
		for (int i = 0; i < ALEN; ++i) a[i] = !a[i];
		return *this;
	}
};

set db[ALEN];

void ew (char *&s) {
	for (; *s && isspace (*s); ++s);
}

const int OR = 27;
const int AND = 28;
const int INV = 29;
const int LB = 26;

int lc;

set eval (char *s) {
	int st1[MAXSTCLEN], st1p =0;
	int st2[MAXSTCLEN], st2p =0;
	int csign;

	ew (s);

	while (*s) {
		if (islower (*s)) {
			st1[st1p++] = *s - 'a';
		} else {
			if (*s == '(') {
				st2[st2p++] = LB;
			} else if (*s == ')') {
				for (; st2p > 0 && st2[st2p - 1] != LB; st1[st1p++] = st2[--st2p]);
				if (!st2p) {
					printf ("line %d - error in expression - too many ')'\n", lc);
					exit (-1);
				}
				--st2p;//eat the (
			} else {
				switch (*s) {
					case '|': csign = OR; break;
					case '&': csign = AND; break;
					case '~': csign = INV; break;
					default : printf ("line %d - undefined symbol '%c'(expected |, &, ~, (, ) or lowercase letter)\n", lc, *s); exit (-1);
				}

				for (; st2p > 0 && st2[st2p - 1] >= csign; st1[st1p++] = st2[--st2p]);
				st2[st2p++] = csign;
			}
		}
		ew (++s);
	}
	for (; st2p > 0; st1[st1p++] = st2[--st2p]);
/*
	for (int i = 0; i < st1p; ++i)
		printf ("%c ", (st1[i] < 26 ? st1[i] + 'a' : st1[i] == OR ? '|' : st1[i] == AND ? '&' : '~'));
	puts ("");
*/
	set st[MAXSTCLEN];
	int stp = 0;
	for (int i = 0; i < st1p; ++i) {
		if (st1[i] > 25) {
			if (st1[i] == INV) {
				if (!stp) {printf ("line %d - wrong expression (no argument for ~)\n", lc); exit (-1);}
				~st[stp - 1];
			} else {
				if (stp < 2) {printf ("line %d - wrong expression (no argument for -%d-)\n", lc, st1[i]); exit (-1);}
				switch (st1[i]) {
					case AND: st[stp - 2] &= st[stp - 1]; --stp; break;
					case OR:  st[stp - 2] |= st[stp - 1]; --stp; break;
				}
			}
		} else {
			st[stp++] = db[st1[i]];
		}
	}

	if (stp != 1) {printf ("line %d - wrong expression (too many variables)\n", lc); exit (-1);}

	return st[0];
}

void parse () {
	++lc;
	char line[MAXPERLINE];
    gets (line);
	if (!(*line)) return;
	char *c;
	for (c = line; *c && isspace (*c); ++c);
	if (*c == 'Q' && !(*(c+1))) {printf ("by by!\n"); exit (0);}
	if (!(*c)) {printf ("line %d - unexpected end\n", lc); exit (-1);}
	int nw = *c - 'a';
	if (nw < 0 || nw > 25) {printf ("line %d - wrong identifier '%c'(expected lowercase letter)\n", lc, *c); exit (-1);}
	for (++c; *c && isspace (*c); ++c);
	if (!(*c)) {//prnt
		db[nw].prnt ();
		return;
	}

	char *beg;

	switch (*c) {
		case '=': for (++c; *c && isspace (*c); ++c); goto evallbl;
		case ':': for (++c; *c && isspace (*c); ++c); goto setlbl;
		default : printf ("line %d - unexpected character \'%c\'\n", lc, *c); exit (-1);
    }

//setlbl*****************
    setlbl:;
	if (!(*c)) {
		printf ("line %d - unexpected end of line\n", lc);
		exit (-1);
	} else if (*c != '\'') {
		printf ("line %d - expected \'\'\'\n", lc);
		exit (-1);
	}
	beg = c + 1;

	for (++c; *c && islower (*c); ++c);
	if (!(*c)) {
		printf ("line %d - expected \'\'\' before end of line\n", lc);
		exit (-1);
	} else if (!islower (*c) && *c != '\'') {
		printf ("line %d - expected \'\'\' got \'%c\'\n", lc, *c);
		exit (-1);
	}

	*c = 0;//terminate the sting
	db[nw].init (beg);
	for (++c; *c && isspace (*c); ++c);
	if (*c) {
		printf ("line %d - unreachable code(\"%s\")\n", lc, c);
		exit (-1);
	}
	return;

//evallbl********************
	evallbl:;
	db[nw] = eval (c);
	return;
}


int main () {
	for (int i = 0; i < 26; ++i) db[i].init ("");
	while (1)//exit with typing 'Q'
		parse ();

    return 0;
}
