/*
TASK: http://www.math.bas.bg/softeng/bantchev/misc/phone/phone.txt
*/

#include <cstdio>
#include <cassert>
#include <cctype>

#include <iostream>
#include <iterator>
#include <fstream>
#include <ext/functional>
#include <vector>
#include <string>
#include <utility>

using namespace std;
using namespace __gnu_cxx;

struct node {
	node *prevl;
	int prevd;
	node *l[10];
	node *fl;
	std::vector <int> end;
	node (node *_prevl, int _prevd) : prevl (_prevl), prevd (_prevd), fl (0) {memset (l, 0, sizeof (l));}
};

std::vector <std::pair <std::vector <int>, std::string> > dic;
node *head;

std::string number;
//									< to,  id>
std::vector <std::vector <std::pair <int, int> > > gr;

//			   A  B  C  D  E  F  G  H  I  J  K  L  M  N  O  P  Q  R  S  T  U  V  W  X  Y  Z
int _to_i[] = {5, 7, 6, 3, 0, 4, 9, 9, 6, 1, 7, 8, 5, 1, 8, 8, 1, 2, 3, 4, 7, 6, 2, 2, 3, 9};

int to_i (char x) {
	if (x >= 'a') x -= 'a' - 'A';
	return _to_i[x-'A'];
}

std::vector <int> to_dig (const std::string &a) {
	std::vector <int> ret;
	for (unsigned i = 0; i < a.size (); ++i)
		if (isalpha (a[i]))
			ret.push_back (to_i (a[i]));

	return ret;
}

void read_dict () {
	ifstream in ("words.dic");
	string word;
	while (getline (in, word))
		dic.push_back (make_pair (to_dig (word), word));
	in.close ();
}

void add_word (node *pos, int id, unsigned c =0) {
	if (dic[id].first.size () == c) {
		pos->end.push_back (id);
		return;
	}
	if (!pos->l[dic[id].first[c]])
		pos->l[dic[id].first[c]] = new node (pos, dic[id].first[c]);

	add_word (pos->l[dic[id].first[c]], id, c + 1);
}

void build_fl (node *pos) {
	if (!pos) return;
	
	pos->fl = head;

	for (node *tmp = pos->prevl; tmp->fl; tmp = tmp->fl) {
		if (tmp->fl->l[pos->prevd]) {
			pos->fl = tmp->fl->l[pos->prevd];
			break;
		}
	}

	for (unsigned i = 0; i < 10; ++i)
		build_fl (pos->l[i]);
}

void add_end_fl (node *pos) {
	if (!pos) return;

	for (node *tmp = pos->fl; tmp; tmp = tmp->fl)
		std::copy (tmp->end.begin (), tmp->end.end (), back_inserter (pos->end));

	for (unsigned i = 0; i < 10; ++i)
		add_end_fl (pos->l[i]);
}

void build_trie () {
	head = new node (0, -1);
	for (unsigned i = 0; i < dic.size (); ++i)
		add_word (head, i);

//	printf ("head -> %p\n", head);
	assert (!head->fl);
	for (unsigned i = 0; i < 10; ++i)
		build_fl (head->l[i]);

	add_end_fl (head);
}

unsigned __in_graph;
void build_graph () {
	gr = std::vector <std::vector <std::pair <int, int> > > (number.size ());
	node *tpos = head;//in trie

	for (unsigned cpos = 0; cpos != number.size ();) {
//		printf ("%d --> %p\n", cpos, tpos);

		for (; tpos && !tpos->l[(int)number[cpos]]; tpos = tpos->fl);// printf ("new tpos %p\n", tpos);
//		printf ("new tpos %p\n", tpos);
		if (tpos) {
//			printf ("from %p move on dig %d to %p\n", tpos, (int)number[cpos], tpos->l[(int)number[cpos]]);
			tpos = tpos->l[(int)number[cpos]];
		} else {
			tpos = head;
		}

		//add tpos->end
		++cpos;
		for (unsigned i = 0; i != tpos->end.size (); ++i) {
//			cout << dic[tpos->end[i]].second << " <-- " << tpos->end[i] << "(" << cpos << ")" << tpos << endl;
//			assert (cpos - dic[tpos->end[i]].first.size () >= 0);
			gr[cpos - dic[tpos->end[i]].first.size ()].push_back (make_pair (cpos, tpos->end[i]));
			++__in_graph;
		}

	}
}

const int MAXLEN = 1 << 6;
int row[MAXLEN], rp;
void prnt () {
	for (int i = 0; i < rp; ++i) {
		if (i) cout << ' ';
		if (row[i] >= 0)
			cout << dic[row[i]].second;
		else
			cout << -row[i]-1;
	}
	cout << endl;
}

bool rec (unsigned pos, bool jump) {
	if (pos == gr.size ()) {
		prnt ();
		return 1;
	}
	bool overall = 0;
	for (unsigned i = 0; i < gr[pos].size (); ++i) {
		row[rp++] = gr[pos][i].second;
		overall |= rec (gr[pos][i].first, 1);
		--rp;
	}
	if (overall == 0 && jump) {
		row[rp++] = -number[pos]+'0'-1;
		overall |= rec (pos + 1, 0);
		--rp;
	}
	return overall;
}

unsigned __deleted;
void clean_up (node *pos) {
	if (!pos) return;
	for (unsigned i = 0; i < 10; ++i)
		clean_up (pos->l[i]);
	++__deleted;
	delete pos;
}

void pr (int a) {for (int i = 0; i < a; ++i) printf ("\t");}
void trav (node *pos, int depth) {
	if (depth == 4) return;
	if (!pos) {
		pr (depth); printf ("(NONE)\n");
		return;
	}
//	pr (depth); printf ("%p\n", pos);
	pr (depth); printf ("go 5 ->(%p)\n", pos->l[5]); trav (pos->l[5], depth+1);
	pr (depth); printf ("go 3 ->(%p)\n", pos->l[3]); trav (pos->l[3], depth+1);
	pr (depth); printf ("go 8 ->(%p)\n", pos->l[8]); trav (pos->l[8], depth+1);
}

int main () {
	read_dict ();
/*	for (unsigned i = 0; i < dic[9].first.size (); ++i) cout << dic[9].first[i];
	cout << " -> " << dic[9].second << endl;*/
	build_trie ();

	while (getline (std::cin, number)) {
//		std::cout << "*" << number << "* --> ";

		//removes ' ' and '-' and '/'
		number.resize (std::remove_if (	number.begin (), number.end (),
										compose2 (	logical_or <bool> (),
													bind2nd (	equal_to <char> (), ' '),
													compose2 (	logical_or <bool> (),
																bind2nd (	equal_to <char> (), '-'),
																bind2nd (	equal_to <char> (), '/')))) - number.begin ());

//		cout << number << endl;
		std::transform (number.begin (), number.end (), number.begin (), bind2nd (minus<char> (), '0'));
/*		for (unsigned i = 0; i < number.size (); ++i)
			std::cout << (int)number[i] << ' ';*/
//		std::cout << endl;
		//now using number
		build_graph ();
/*
		for (unsigned i = 0; i < gr.size (); ++i) {
			printf ("%d ->", i);
			for (unsigned j = 0; j < gr[i].size (); ++j)
				printf (" (%d %d)", gr[i][j].first, gr[i][j].second);
			puts ("");
		}
*/
		std::transform (number.begin (), number.end (), number.begin (), bind2nd (plus<char> (), '0'));
		cout << number << ": " << endl;
		rec (0, 1);
/*		printf ("------------\n");
		node *tmp = head->l[5]->l[5]->l[3];
		for (unsigned i = 0; i < tmp->end.size (); ++i)
			printf ("%d ", tmp->end[i]);
		puts ("");*/
	}

//	trav (head, 0);

	clean_up (head);
//	cout << "done " << __deleted << ' ' << __in_graph << endl;

	return 0;
}
