/*
FROM: LISH 07 day 1
PROB: houses
KEYW: geometry
*/

#include <cstdio>
#include <cstdlib>
#include <list>
#include <algorithm>

const int MAXN = 1 << 10;
const int MAXSTAT = MAXN;

struct pnt {
	int x, y;
	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}
	pnt (const pnt &a) : x (a.x), y (a.y) {}
};
const pnt orig (0, 0);

struct rec {
	pnt f, s;
	rec () {}
	rec (const pnt &_f, const pnt &_s) : f (_f), s (_s) {}
	bool back (const rec &a) {return f.x >= a.f.x && s.y >= a.s.y;}
};

int N, TT;
rec vec[MAXN];

int S (const pnt &a, const pnt &b, const pnt &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

int tr (int a) {
//	printf ("%d --> %d\n", a, a > 0 ? 1 : a < 0 ? -1 : 0);
	return a > 0 ? 1 : a < 0 ? -1 : 0;
}

bool inter (const pnt &a, int rid) {
	return S (a, vec[rid].f, vec[rid].s) > 0;
};

bool used[MAXN];
std::list <rec> block;
typedef std::list <rec> :: iterator LIT;

LIT nxt (const LIT &a) {
	LIT ret = a;
	return ++ret;	
}

#warning is_prev -> i, i
bool is_prev (int id1, int id2) {
//	printf ("%d %d\n", id1, id2);
	static int s00, s01, s10, s11;
	s00 = S (orig, vec[id2].f, vec[id1].f);
	s01 = S (orig, vec[id2].f, vec[id1].s);
	s10 = S (orig, vec[id2].s, vec[id1].f);
	s11 = S (orig, vec[id2].s, vec[id1].s);

	if (s00 >= 0 && s11 <= 0
	 && vec[id2].back (vec[id1])) {
//		printf ("case 1\n");
		return 1;
	}

	#warning -- too much change
	if (s00 > 0 && s01 < 0
	 && S (vec[id2].f, vec[id1].f, vec[id1].s) > 0) {
//		printf ("case 2\n");
		return 1;
	}

	if (s10 > 0 && s11 < 0
	 && S (vec[id2].s, vec[id1].f, vec[id1].s) > 0) {
//		printf ("case 3\n");
		return 1;
	}

	if (s00 <= 0 && s11 >= 0
	 && !vec[id1].back (vec[id2])) {
//		printf ("case 4\n");
		return 1;
	}

	return 0;
}

int tell_t (LIT it, const pnt &p) {
	static int s1, s2, s3;
	s1 = S (orig, it->f, p);
	s2 = S (orig, it->s, p);
	s3 = S (orig, nxt (it)->f, p);
//	printf ("\ttell t -- %d %d  %d %d  (%d %d) %d %d --> %d %d %d\n", it->f.x, it->f.y, it->s.x, it->s.y, nxt (it)->f.x, nxt (it)->f.y, p.x, p.y, s1, s2, s3);

	if (s1 > 0 || s3 <= 0) return -1;

	if (s1 == 0) return 0;
	if (s2 == 0) return 2;
	return (s2 < 0) * 2 + 1;
}

int whole, part;
void tell_all (const LIT &p1, int t1, const LIT &p2, int t2, const rec &p, LIT &bi, LIT &ei, rec &nrec) {
	if (t1 >= 2 && t2 == 3 && p1 == p2
	 || t1 >= 2 && t2 == 0 && nxt (p1) == p2) {
//		printf ("whole!\n");
		++whole;
	} else if (!(t1 < 3 && t2 < 3 && p1 == p2)) {
//		printf ("part\n");
		++part;
	}

	bi = (t1 < 3 ? p1 : nxt (p1));
	ei = nxt (p2);
	nrec.f = (t1 < 3 ? p1->f : p.f);
	nrec.s = (t2 < 3 ? p2->s : p.s);

/*	printf ("-->%d %d %d %d  %d %d  %d %d\n"
	, bi->f.x, bi->f.y, bi->s.x, bi->s.y
	, ei->f.x, ei->f.y, ei->s.x, ei->s.y);
	printf ("%d %d %d %d<_-\n", nrec.f.x, nrec.f.y, nrec.s.x, nrec.s.y);*/
}

void dfs (int r) {
	used[r] = 1;
//	printf ("dfs %d\n", r);
	for (int i = 0; i < N; ++i)
		if (!used[i] && is_prev (i, r)) {
//			printf ("-->%d\n", i);
			used[i] = 1;
			dfs (i);
		}
/*
	printf ("cont %d\n", r);
	for (LIT it = block.begin (); it != block.end (); ++it) {
		printf ("%d %d  %d %d\n", it->f.x, it->f.y, it->s.x, it->s.y);
	}
*/

	LIT crnt;	

	LIT p1, p2;
	int t1, t2, tx;	
	t1 = -1;

	for (crnt = block.begin ();; ++crnt) {
		if (t1 == -1) {
			tx = tell_t (crnt, vec[r].f);
			if (tx != -1) {
//				printf ("set 1 - %d\n", tx);
				p1 = crnt;
				t1 = tx;
			}
		}
		if (t1 != -1) {
			tx = tell_t (crnt, vec[r].s);
			if (tx != -1) {
//				printf ("set 2 - %d\n", tx);
				p2 = crnt;
				t2 = tx;
				break;
			}
		}
//		printf ("forward\n");
	}

	LIT bi, ei;
	rec nrec;

//	printf ("dfs %d fin -- (%d %d  %d %d) %d, (%d %d  %d %d) %d\n"\
	, r\
	, p1->f.x, p1->f.y, p1->s.x, p1->s.y, t1\
	, p2->f.x, p2->f.y, p2->s.x, p2->s.y, t2);

	tell_all (p1, t1, p2, t2, vec[r], bi, ei, nrec);

	if (bi == block.begin ()) ++bi;
	block.erase (bi, ei);
	block.insert (ei, nrec);
/*
	for (LIT it = block.begin (); it != block.end (); ++it) {
		printf ("%d %d  %d %d\n", it->f.x, it->f.y, it->s.x, it->s.y);
	}

	printf ("----------\n");
*/
}

int main () {
	scanf ("%d", &TT);
	scanf ("%d", &N);

	int i, j;
	int x1, y1, x2, y2;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d %d %d", &x1, &y1, &x2, &y2);
		if (x1 > x2) std::swap (x1, x2);
		if (y1 > y2) std::swap (y1, y2);
		vec[i].f = pnt (x1, y2);
		vec[i].s = pnt (x2, y1);
	}

	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j) {
			if (i == j) continue;
			if (vec[i].f.x <= vec[j].f.x && vec[j].s.x <= vec[i].s.x
			 && vec[i].f.y <= vec[j].f.y && vec[j].s.y <= vec[i].s.y) {
				vec[j] = vec[--N];
				printf ("YA!\n");
			}
		}
	}

	block.push_back (rec (pnt (0, 1), pnt (0, 1)));
	block.push_back (rec (pnt (1, 0), pnt (1, 0)));

	for (int i = N-1; i >= 0; --i)
		if (!used[i]) {
			used[i] = 1;
			dfs (i);
		}

/*	dfs (0);
	dfs (2);
	dfs (1);*/
	printf ("%d\n", (TT == 1 ? whole : whole + part));

	return 0;
}
