#include <cstdio>

const int MAXN = 35;

int N, K, M;
struct ma3x {
	long long m[MAXN][MAXN];
	ma3x& operator = (const ma3x &a) {for (int i = 0; i < N; ++i) for (int j = 0; j < N; ++j) m[i][j] = a.m[i][j]; return *this;}
	ma3x operator * (const ma3x &a) const {ma3x res; for (int i = 0; i < N; ++i) for (int j = 0; j < N; ++j) {res.m[i][j] = 0; for (int k = 0; k < N; ++k) {res.m[i][j] += ((long long)m[i][k] * a.m[k][j]) % M;} res.m[i][j] %= M;} return res;}
	ma3x sq () const                      {ma3x res; for (int i = 0; i < N; ++i) for (int j = 0; j < N; ++j) {res.m[i][j] = 0; for (int k = 0; k < N; ++k) {res.m[i][j] += ((long long)m[i][k] *   m[k][j]) % M;} res.m[i][j] %= M;} return res;}
	ma3x operator + (const ma3x &a) const {ma3x res; for (int i = 0; i < N; ++i) for (int j = 0; j < N; ++j) res.m[i][j] = (m[i][j] + a.m[i][j]) % M; return res;}
};

ma3x A;
ma3x _1;

ma3x Apow (int k) {
	if (k == 1) return A;
	return k & 1 ? Apow (k-1) * A : Apow (k / 2).sq ();
}

ma3x S (int k) {
	if (k == 1) return A;
	return k & 1 ? S (k-1) + Apow (k) : S (k / 2) * (Apow (k/2) + _1);
}

long long diag (const ma3x &a) {
	long long res = 0;
	for (int i = 0; i < N; ++i) res += a.m[i][i];
	return res % M;
}

int main () {
	scanf ("%d %d %d", &N, &K, &M);

	int i, j;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			scanf ("%Ld", &A.m[i][j]);
		A.m[i][i] = 0;
	}
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			_1.m[i][j] = 0;
	for (i = 0; i < N; ++i)
		_1.m[i][i] = 1;

	printf ("%Ld\n", diag (S (K)));

	return 0;
}
