/*
TASK:mirrors
LANG:C++

FROM: NOI 2005 R3
PROB: mirrors
KEYW: ad-hoc
NOTE: Velin's warmup : Theme 1 (convex hull, binary search)
*/

#include "module.h"

#include <cstdio>
#include <utility>
#include <vector>
#include <algorithm>

const int MAXN = 1 << 7;

int N, M, P;

struct tri {
	int m[3];
	tri () {m[0] = m[1] = m[2] = -1;}
	tri (int *a) {for (int i = 0; i < 3; ++i) m[i] = a[i];}
	tri (const tri &a) {for (int i = 0; i < 3; ++i) m[i] = a.m[i];}
	tri& operator = (const tri &a) {for (int i = 0; i < 3; ++i) m[i] = a.m[i]; return *this;}
};

tri bound1[MAXN * 4];
tri bound2[MAXN * 4];

int states[6];

void tryit (tri &w, int ub) {
	static int x, y;
//	for (int i = 0; i < ub; ++i) printf ("%d (%d), ", w.m[i], states[i]); printf ("\n");
	getView (ub, w.m, states, &x, &y);
	if (bound1[x].m[0] == -1) bound1[x] = w;
	if (bound2[y].m[0] == -1) bound2[y] = w;
}

void gen2 (int cpos, tri &x, int ub) {
	if (cpos == ub) {tryit (x, ub); return;}
	states[cpos] = 0; gen2 (cpos + 1, x, ub);
	states[cpos] = 1; gen2 (cpos + 1, x, ub);
	states[cpos] = 2; gen2 (cpos + 1, x, ub);
}

void gen3 (int cpos, int *mir, int ub) {
	if (cpos == ub) {getView (ub, mir, states, &M, &N); return;}
	states[cpos] = 0; gen3 (cpos + 1, mir, ub);
	states[cpos] = 1; gen3 (cpos + 1, mir, ub);
	states[cpos] = 2; gen3 (cpos + 1, mir, ub);
}

void gen (int cpos, tri &x, int ub) {
	if (cpos == ub) {gen2 (0, x, ub); return;}
	int prev;
	if (cpos == 0) prev = -1; else prev = x.m[cpos-1];
	for (int i = prev+1; i < P; ++i) {x.m[cpos] = i; gen (cpos + 1, x, ub);}
}

int main () {
	init ();
	N = getN ();
	M = getM ();
	P = getP ();

//	printf ("%d %d %d\n", N, M, P);
	int i;
	tri mirrors = tri ();
	for (i = 1; i <= (3 <? P); ++i) {
		gen (0, mirrors, i);
	}

	int mirrs[6];
	int ub = (M + N) << 1;
	for (i = 0; i < ub; ++i)
		if (bound1[i].m[0] != -1 && bound2[i].m[0] != -1) {//there is something here
			std::vector <int> bucket;
			for (int j = 0; j < 3; ++j) {bucket.push_back (bound1[i].m[j]); bucket.push_back (bound2[i].m[j]);}
/*			bucket.push_back (bound[i].m[0]);
			bucket.push_back (bound[i].m[1]);
			bucket.push_back (bound[o].m[2]);
			bucket.push_back (vec[i].first.m[0]);
			bucket.push_back (vec[i].first.m[1]);
			bucket.push_back (vec[i].first.m[2]);
*/			std::sort (bucket.begin (), bucket.end ());
			bucket.resize (std::unique (bucket.begin (), bucket.end ()) - bucket.begin ());
			if (bucket[0] == -1) bucket.erase (bucket.begin ());
			for (int j = 0; j < (int)bucket.size (); ++j) mirrs[j] = bucket[j];
			gen3 (0, mirrs, bucket.size ());
			return 0;
		}

	return 0;
}
