/*
TASK:rods
LANG:C++

FROM: IOI 2002 day2
PROB: rods
KEYW: binary search, module
NOTE: Velin's warmup : Theme 1 (convex hull, binary search)
*/

#include "crectlib.h"

#include <cstdio>
#include <cassert>

int N;

int _rect (int x1, int y1, int x2, int y2) {
	int ans = rect (x1, x2, y1, y2);
	return ans;
}

int bsupb (int x1, int y1, int x2, int y2) {
	int m;
	while (x1 < x2) {
		m = (x1 + x2) / 2;
		if (_rect (x1, y1, m, y2) == 0)
			x1 = m + 1;
		else
			x2 = m;
	}

	return x2;
}

int bsdwb (int x1, int y1, int x2, int y2) {
	int m;
	while (x1 < x2) {
		m = (x1 + x2) / 2;
		if (_rect (m + 1, y1, x2, y2) == 0)
			x2 = m;
		else
			x1 = m + 1;
	}

	return x2;
}

int bslfb (int x1, int y1, int x2, int y2) {
	int m;
	while (y1 < y2) {
		m = (y1 + y2) / 2;
		if (_rect (x1, y1, x2, m) == 0)
			y1 = m + 1;
		else
			y2 = m;
	}

	return y2;
}

int bsrgb (int x1, int y1, int x2, int y2) {
	int m;
	while (y1 < y2) {
		m = (y1 + y2) / 2;
		if (_rect (x1, m + 1, x2, y2) == 0)
			y2 = m;
		else
			y1 = m + 1;
	}

	return y2;
}

int main () {
	N = gridsize ();

	int up = bsupb (1, 1, N, N);
	int down = bsdwb (1, 1, N, N);
	int left = bslfb (1, 1, N, N);
	int right = bsrgb (1, 1, N, N);

	int a1 = _rect (up, left, up, left),
		a2 = _rect (up, right, up, right),
		a3 = _rect (down, right, down, right),
		a4 = _rect (down, left, down, left);

	if (a1 + a2 + a3 + a4 == 0) {
		int k1 = bsupb (up, left, down, left);
		int k2 = bslfb (up, left, up, right);
		report (k1, left, k1, right, up, k2, down, k2);
	}

	int r1x1 = -1, r1y1 = -1, r1x2 = -1, r1y2 = -1;
	int r2x1 = -1, r2y1 = -1, r2x2 = -1, r2y2 = -1;
	if (a1 && a3) {
		if (_rect (up, left+1, up, left+1)) {
			r1x1 = up; r1x2 = up;
			r1y1 = left;
			r1y2 = bsrgb (up, left, up, right-1);
			if (a2 && r1y2 == right-1) r1y2 = right;

			r2y1 = r2y2 = right;
			r2x2 = down;
			r2x1 = bsupb (up+1, right, down, right);
			if (a2 && r2x1 == up+1) r2x1 = up;
		} else {
			r1x1 = r1x2 = down;
			r1y2 = right;
			r1y1 = bslfb (down, left + 1, down, right);
			if (a4 && r1y1 == left + 1) r1y1 = left;

			r2y1 = r2y2 = left;
			r2x1 = up;
			r2x2 = bsdwb (up, left, down-1, left);
			if (a4 && r2x2 == down-1) r2x2 = down;
		}
	} else if (a2 && a4) {
		if (_rect (up, right-1, up, right-1)) {
			r1x1 = r1x2 = up;
			r1y2 = right;
			r1y1 = bslfb (up, left+1, up, right);
			if (a1 && r1y1 == left+1) r1y1 = left;

			r2y1 = r2y2 = left;
			r2x2 = down;
			r2x1 = bsupb (up+1, left, down, left);
			if (a1 && r2x1 == up+1) r2x1 = up;
		} else {
			r1x1 = r1x2 = down;
			r1y1 = left;
			r1y2 = bsrgb (down, left, down, right-1);
			if (a3 && r1y2 == right-1) r1y2 = right;

			r2y1 = r2y2 = right;
			r2x1 = up;
			r2x2 = bsdwb (up, right, down-1, right);
			if (a3 && r2x2 == down-1) r2x2 = down;
		}
	} else if (a1 && a2) {
		r1x1 = r1x2 = up;
		r1y1 = left; r1y2 = right;

		r2x2 = down;
		r2y1 = r2y2 = bslfb (up+1, left, down, right);
		r2x1 = bsupb (up+1, r2y1, down, r2y1);
		if (r2x1 == up+1) r2x1 = up;
	} else if (a2 && a3) {
		r2y1 = r2y2 = right;
		r2x1 = up; r2x2 = down;

		r1y1 = left;
		r1x1 = r1x2 = bsupb (up, left, down, right-1);
		r1y2 = bsrgb (r1x1, left, r1x1, right-1);
		if (r1y2 == right-1) r1y2 = right;
	} else if (a3 && a4) {
		r1x1 = r1x2 = down;
		r1y1 = left; r1y2 = right;

		r2x1 = up;
		r2y1 = r2y2 = bslfb (up, left, down-1, right);
		r2x2 = bsdwb (up, r2y1, down-1, r2y1);
		if (r2x2 == down-1) r2x2 = down;
	} else if (a1 && a4) {
		r2y1 = r2y2 = left;
		r2x1 = up; r2x2 = down;

		r1y2 = right;
		r1x1 = r1x2 = bsupb (up, left + 1, down, right);
		r1y1 = bslfb (r1x1, left + 1, r1x1, right);
		if (r1y1 == left+1) r1y1 = left;
	}
	report (r1x1, r1y1, r1x2, r1y2, r2x1, r2y1, r2x2, r2y2);
	return 0;
}
