/*
TASK:round
LANG:C++

FROM: SPRING 2004 A
PROB: round
KEYW: precomputing, dynamical programming, N^2
NOTE: Velin's warmup : Theme 1 (convex hull, binary search)
*/

#include <cstdio>

const int MAXN = 1 << 11;

int N;
short row[2][MAXN];
short exc[2][MAXN][MAXN];
int dp[MAXN][MAXN];

inline int min (int a, int b) {return a < b ? a : b;}

int main () {
	scanf ("%d", &N);

	int i, j, k;
	int tmp;
	for (k = 0; k < 2; ++k)
		for (i = 0; i < N; ++i) {
			scanf ("%d", &tmp);
			row[k][i] = tmp - 1;
		}

	//precomputing
	//taking from the first row
	int c1;
	for (i = 0; i < N; ++i) {
		c1 = 0;
		for (j = 0; j < i; ++j) c1 += row[0][j] < row[0][i];
		for (j = 0; j <= N; ++j) {
			exc[0][i][j] = min (c1, i + j - c1);
			c1 += row[1][j] < row[0][i];
		}
	}
	//taking from the second row
	for (i = 0; i < N; ++i) {
		c1 = 0;
		for (j = 0; j < i; ++j) c1 += (row[1][j] - row[1][i]) * (2 * (N - row[1][j]) - 1) > 0;
		for (j = 0; j <= N; ++j) {
			exc[1][i][j] = min (c1, i + j - c1);
			c1 += (row[0][j] - row[1][i]) * (2 * (N - row[0][j]) - 1) > 0;
		}
	}
	//end precomputing
/*	for (k = 0; k < 2; ++k) {
		for (i = 0; i < N; ++i) {
			for (j = 0; j <= N; ++j)
				printf ("%d ", exc[k][i][j]);
			printf ("\n");
		}
		printf ("\n");
	}
*/
	dp[N][N] = 0;//the final situation

	for (i = N-1, j = N; i >= 0; --i) dp[i][j] = exc[0][i][j] + dp[i+1][j];
	for (j = N-1, i = N; j >= 0; --j) dp[i][j] = exc[1][j][i] + dp[i][j+1];

	for (i = N-1; i >= 0; --i)
		for (j = N-1; j >= 0; --j)
			dp[i][j] = min (dp[i+1][j] + exc[0][i][j], dp[i][j+1] + exc[1][j][i]);
/*
	for (i = 0; i <= N; ++i) {
		for (j = 0; j <= N; ++j)
			printf ("%d ", dp[i][j]);
		printf ("\n");
	}
*/
	printf ("%d\n", dp[0][0]);

	return 0;
}
