/*
TASK: cowq
LANG: C++

FROM: USACO 2003 Dec GREEN
PROB: cowq
KEYW: dynamical programming, decoding
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 5;

char l[MAXN], l2[MAXN];
char u[MAXN];
int ll, uu;
int num;

int low[MAXN][MAXN][2];
int up[MAXN][MAXN][2];
int all[MAXN][MAXN][2];

void  fall () {
	int i, j;
	all[0][0][0] = 1;
	all[0][1][1] = 1;
	for (i = 1; i < MAXN; ++i) {
		all[i][0][0] = 1;
		for (j = 1; j < MAXN; ++j) {
			all[i][j][0] = all[i-1][j][0] + all[i-1][j][1];
			all[i][j][1] = all[i-1][j-1][0] + all[i-1][j-1][1];
		}
	}
}

void fdp (int _dp[MAXN][MAXN][2], char s[MAXN]) {
	int i, j;
	_dp[0][0][0] = 1;
	_dp[0][1][1] = s[0] == '1';
	for (i = 1; i < MAXN; ++i) {
		_dp[i][0][0] = 1;
		for (j = 1; j < MAXN; ++j)
			if (s[i] == '1') {
				_dp[i][j][1] = _dp[i-1][j-1][0] + _dp[i-1][j-1][1];
				_dp[i][j][0] = all[i-1][j][0] + all[i-1][j][1];
			} else {
				_dp[i][j][1] = 0;
				_dp[i][j][0] = _dp[i-1][j][0] + _dp[i-1][j][1];
			}
	}
}

int f (int a, int b, int c, bool lll, bool uuu) {
	if (lll)
		return uuu ? up[a][b][c] - low[a][b][c] : all[a][b][c] - low[a][b][c];
	else
		return uuu ? up[a][b][c] : all[a][b][c];
}

int main () {
	gets (l); ll = strlen (l);
	gets (u); uu = strlen (u);
	scanf ("%d", &num);

	std::reverse (l, l + ll);
	std::reverse (u, u + uu);
	int i;
	for (i = ll; i < MAXN; ++i) l[i] = '0';
	for (i = uu; i < MAXN; ++i) u[i] = '0';

	for (i = 0; i < 32; ++i) l2[i] = l[i];
	for (i = 0; i < 32 && l[i] == '0'; ++i) l[i] = '1';
	fall ();

	if (i != 32) {
		l[i] = '0';
		fdp (low, l);
	}

	fdp (up, u);

	--num;
	for (i = 0; i < MAXN; ++i)
		if ((num -= f (31, i, 0, 1, 1) + f (31, i, 1, 1, 1)) < 0)
			break;


	num += f (31, i, 0, 1, 1) + f (31, i, 1, 1, 1);
	printf ("i, num == %d %d\n", i, num);

	bool bl = 1, bu = 1;
	int j;
	char ans[MAXN];
	for (j = 31; j >= 0; --j) {
		if ((num -= f (j, i, 0, bl, bu)) < 0) {
			num += f (j, i, 0, bl, bu);
			ans[j] = '0';
			if (bu && u[j] == '1') bu = 0;
		} else {
			--i;
			ans[j] = '1';
			if (bl && l2[j] == '0') bl = 0;
		}
	}

	for (i = 31; i > 0 && ans[i] == '0'; --i);
	for (; i >= 0; --i) putchar (ans[i]); putchar ('\n');

	return 0;
}
