/*
TASK: paths
LANG: C++

FROM: NOI 2004 r3
PROB: paths
KEYW: 2-phase dynamical programming
*/

#include <cstdio>
#include <cassert>
#include <utility>

using std::make_pair;

const int MAXN = 1 << 17;

struct el {
	int to;
	int dist;
	int next;
	el () {}
	el (int _to, int _dist, int _next) : to (_to), dist (_dist), next (_next) {}
};

int N;
int vec[MAXN];
el buf[MAXN * 2];

int prev[MAXN];
int pd[MAXN];
int queue[MAXN];
std::pair <std::pair <int, int>, std::pair <int, int> > dsts[MAXN];

void upd (int id, const std::pair <int, int> &p) {
	printf ("%d -- %d %d\n", id, p.first, p.second);
	if (dsts[id].first.second < p.second) {
		dsts[id].second = dsts[id].first;
		dsts[id].first = p;
	} else if (dsts[id].second.second < p.second)
		dsts[id].second = p;
}

void bfs () {
	int p3 = 0;
	queue[p3++] = 0;

	int c, i, j;
	for (i = 0; i < p3; ++i) {
		c = queue[i];

		for (j = vec[c]; j != -1; j = buf[j].next) {
			if (buf[j].to == prev[c]) continue;
			queue[p3++] = buf[j].to;
			prev[buf[j].to] = c;
			pd[buf[j].to] = buf[j].dist;
		}
	}
	assert (p3 == N);
}

int main () {
	int M;
	scanf ("%d %d", &N, &M);
	assert (M == N - 1);

	int i;
	int a, b, d;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", &a, &b, &d);
		--a; --b;

		buf[i * 2] = el (b, d, vec[a]);
		vec[a] = i * 2;

		buf[i * 2 + 1] = el (a, d, vec[b]);
		vec[b] = i * 2 + 1;
	}

	printf ("bah maamu\n");
	bfs ();

	for (i = 0; i < N; ++i) printf ("%d ", queue[i]); printf ("\n");
	for (i = 0; i < N; ++i) dsts[i] = make_pair (make_pair (-1, 0), make_pair (-1, 0));

	int j = -100;
	for (i = N-1; i >= 0; --i)
		for (j = vec[queue[i]]; j != -1; j = buf[j].next)
			if (buf[j].to != prev[queue[i]])
				upd (queue[i], make_pair (buf[j].to, buf[j].dist + dsts[buf[j].to].first.second));

	for (i = 1; i < N; ++i) //the 0th is done
		if (queue[i] != dsts[prev[queue[i]]].first.first)
			upd (queue[i], make_pair (prev[queue[i]], pd[queue[i]] + dsts[prev[queue[i]]].first.second));
		else
			upd (queue[i], make_pair (prev[queue[i]], pd[queue[i]] + dsts[prev[queue[i]]].second.second));

	for (i = 0; i < N; ++i)
		printf ("%d\n", dsts[i].first.second);

	return 0;
}
