/*
TASK: tribe
LANG: C++

FROM: BOI 2003 day 2
PROB: tribe
KEYW: 2-phase dynamical programming
*/

#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>

const int MAXN = 1 << 17;

int N;
int prev[MAXN];
int in[MAXN];
int queue[MAXN];

std::vector <int> vec[MAXN];
std::pair <int, std::pair <int, int> > data[MAXN];

int gmff (int a) {
	return data[prev[a]].first - (data[prev[a]].second.second < data[a].first);
}

void f_lum (int a) {
	int mdif = 0;
	int i;
	for (i = 0; i < (int)vec[a].size (); ++i)
		if (mdif < i - vec[a][i]) {
			mdif = i - vec[a][i];
			data[a].second.first = data[a].second.second = vec[a][i];//l and u
		} else if (mdif == i - vec[a][i]) {
			data[a].second.second = vec[a][i];//u onlu
		}
	data[a].first = vec[a].size () - mdif;
/*	printf ("in f_lum %d(%u):\n", a, vec[a].size ());
	for (i = 0; i < (int)vec[a].size (); ++i) printf ("%d ", vec[a][i]); printf ("\n");
	printf ("%d  %d %d\n", data[a].first, data[a].second.first, data[a].second.second);
*/
}

int main () {
	scanf ("%d", &N);

	int i;
	int a, b;
	for (i = 0; i < N - 1; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		++in[a];
		prev[b] = a;
	}

	for (i = 0; i < N; ++i) vec[i].reserve (in[i] + 1);//include the father

	int p3 = 0;
	int c;
	for (i = 0; i < N; ++i) if (!in[i]) queue[p3++] = i;

	for (i = 0; i < p3; ++i) {
		c = queue[i];
		std::sort (vec[c].begin (), vec[c].end ());
		f_lum (c);
		vec[prev[c]].push_back (data[c].first);
		if (!--in[prev[c]]) queue[p3++] = prev[c];
	}

	assert (p3 == N && queue[p3-1] == 0);//the boss is on the top and we hava visited everyone

//	printf ("-----\n");

	int fmax;
	for (i = p3-2; i >= 0; --i) {//the boss is calculated properly
		c = queue[i];

		fmax = gmff (c);
		vec[c].insert (std::lower_bound (vec[c].begin (), vec[c].end (), fmax), fmax);//include it in our vec
		f_lum (c);
	}

	int ans = -1;
	for (i = 0; i < N; ++i) ans >?= data[i].first;

	printf ("%d\n", ans + 1);

	return 0;
}
