/*
TASK: batch
LANG: C++

FROM: IOI 2002 day 2
PROB: batch
KEYW: dynamical programming with optimizations of the inner cycle
*/

#include <cstdio>
#include <climits>

const int MAXN = 1 << 14;

int N, S;
int T[MAXN], F[MAXN];
int sT[MAXN], sF[MAXN];
int opt[MAXN], prev[MAXN];

int main () {
	scanf ("%d%d", &N, &S);

	int i, j;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", T + i, F + i);

	for (i = N-1; i >= 0; --i) {
		sT[i] = sT[i+1] + T[i];
		sF[i] = sF[i+1] + F[i];
	}

	opt[N-1] = (S + sT[0]) * F[N-1]; prev[N-1] = N;
//	printf ("%d -> %d %d\n", N-1, opt[N-1], prev[N-1]);
	for (i = N-2; i >= 0; --i) {
		opt[i] = INT_MAX;
		for (j = prev[i+1]; j > i; --j) {
//			printf ("%d %d --> %d (%d + %d + %d * %d)\n", i, j, opt[j] + S * sF[j] + (S + sT[0] - sT[j]) * (sF[i] - sF[j]),\
			opt[j], S * sF[j], (S + sT[i] - sT[j]), (sF[i] - sF[j]));
			if (opt[i] > opt[j] + S * sF[j] + (S + sT[0] - sT[j]) * (sF[i] - sF[j])) {
				opt[i] = opt[j] + S * sF[j] + (S + sT[0] - sT[j]) * (sF[i] - sF[j]);
				prev[i] = j;
			}
		}
//		printf ("%d -> %d %d\n", i, opt[i], prev[i]);
	}

	printf ("%d\n", opt[0]);

	return 0;
}
