/*
TASK: convex
LANG: C++

FROM: NOI 2004 k2
PROB: convex
KEYW: dynamical programming with optimization of the inner cycle
*/

#include <cstdio>
#include <cstring>
#include <cassert>
#include <algorithm>

const int MAXN = 1 << 9;
const int MOD = 1048576;

struct point {
	int x, y;
	point () {}
	point (int _x, int _y) : x (_x), y (_y) {}
	point (const point &a) : x (a.x), y (a.y) {}
};

int N;
point pnt[MAXN];
int ord[MAXN][MAXN];

bool cmpX (const point &a, const point &b) {
	return a.y != b.y ? a.y < b.y : a.x < b.x;
}

inline int S (const point &a, const point &b, const point &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

point crnt;
bool cmpS (int a, int b) {
	return (pnt[a].y - crnt.y) * (pnt[b].y - crnt.y) < 0 ?\
			pnt[a].y < pnt[b].y :
			S (crnt, pnt[a], pnt[b]) > 0;
}

inline void inc (int &a) {++a != N - 1 ?: a = 0;}

int dp[MAXN][MAXN];

int ans;
void fdp (int base) {
//	printf ("base == %d\n", base);
	int i;
	for (i = 0; i < N-1 && ord[base][i] < base; ++i);

	memset (dp, 0, sizeof (dp));

	int p1, p2, s1, s2;
	int crnt;
	int sum;
	for (; i < N-1; ++i) {
		crnt = ord[base][i];
		assert (crnt > base);

		for (p2 = 0; ord[crnt][p2] != base; inc (p2)); s1 = p2;
		for (p1 = p2, inc (p1); p1 != s1 && S (pnt[base], pnt[crnt], pnt[ord[crnt][p1]]) <= 0; inc (p1)); s2 = p1;

//		printf ("%d -- %d %d\n", crnt, p1, p2);

		dp[base][crnt] = 1;
		sum = 0;
		for (; p1 != s1; inc (p1)) {
			if (ord[crnt][p1] < base) continue;//it is lower

			for (; p2 != s2 && S (pnt[ord[crnt][p2]], pnt[crnt], pnt[ord[crnt][p1]]) > 0; inc (p2)) {
				if (ord[crnt][p2] < base) continue;//it is lower
				sum += dp[ord[crnt][p2]][crnt];
				sum %= MOD;
//				printf ("take %d %d %d(%d)\n", base, ord[crnt][p2], crnt, dp[base][ord[crnt][p2]][crnt]);
			}
//				printf ("%d %d %d <- %d\n", base, crnt, ord[crnt][p1], sum);
			dp[crnt][ord[crnt][p1]] = sum;
//			dp[base][crnt][ord[crnt][p1]] %= MOD;
			ans += sum;
			ans %= MOD;
		}
	}
}

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &pnt[i].x, &pnt[i].y);
		pnt[i].x *= 2;
		pnt[i].y *= 2;
	}

	std::sort (pnt, pnt + N, cmpX);

	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j) ord[i][j] = j;
		ord[i][i] = ord[i][N-1];
		crnt = pnt[i]; ++crnt.y;
		std::sort (ord[i], ord[i] + N-1, cmpS);
//		printf ("%d -->", i); for (j = 0; j < N-1; ++j) printf ("%d ", ord[i][j]); printf ("\n");
//		printf ("(%d %d) ==>", crnt.x >> 1, crnt.y - 1 >> 1); for (j = 0; j < N-1; ++j) printf ("(%d %d)", pnt[ord[i][j]].x >> 1, pnt[ord[i][j]].y >> 1); printf ("\n");
	}

	for (i = 0; i < N; ++i) fdp (i);

	printf ("%d\n", ans);

	return 0;
}
