/*
TASK: euro
LANG: C++

FROM: BOI 2003 day 2
PROB: euro
KEYW: dynamical programming with optimization of the inner cycle
*/

#include <cstdio>
#include <climits>

const int MAXN = 1 << 16;

int N, T;
int D[MAXN];
int id[MAXN];
int s[MAXN];
long long dp[MAXN];
int prev[MAXN];

int main () {
	scanf ("%d%d", &N, &T);

	int i, j;
	for (i = 1; i <= N; ++i)
		scanf ("%d", D + i);

	int cp = 1;
	for (cp = 1; cp <= N && D[cp] < 0; ++cp) id[cp] = cp;
	for (i = cp + 1; i <= N; ++i)
		if ((D[cp] += D[i]) < 0) {
			id[cp] = i;
			D[++cp] = 0;
		}
	id[cp] = N;


	N = cp + 1;
//	for (i = 1; i < N; ++i) printf ("%d ", D[i]); printf ("\n");
	for (i = 1; i < N; ++i) s[i] = s[i-1] + D[i];

	dp[1] = D[1] * id[1] - T; prev[1] = 0;
	for (i = 2; i < N; ++i) {
		dp[i] = LONG_LONG_MIN;
		for (j = prev[i-1]; j < i; ++j) {
			if (dp[i] < dp[j] + (long long)(s[i] - s[j]) * id[i] - T)
				dp[i] = dp[j] + (long long)(s[i] - s[j]) * id[i] - T;
				prev[i] = j;
			}
	}

	printf ("%Ld\n", dp[N-1]);

	return 0;
}
