/*
TASK: game
LANG: C++

FROM: BOI 2004 day 2
PROB: game
KEYW: dynamical programming with optimizations of the inner cycle
*/

#include <cstdio>
#include <cassert>

const int MAXN = 1 << 11;
const int _infinity = 1 << 30;

int N[2];
int vec[2][MAXN];
int s[2][MAXN];

int dp[2][MAXN][MAXN];
int fdp[MAXN][MAXN];
int prev[2][MAXN][MAXN];

int main () {
	scanf ("%d %d", N, N + 1);

	int i, j, k;
	for (k = 0; k < 2; ++k)
		for (i = 1; i <= N[k]; ++i) {
			scanf ("%d", vec[k] + i);
			--vec[k][i];
		}

/*	for (k = 0; k < 2; ++k) {
		for (i = 0; i < N[k]; ++i)
			printf ("%d ", vec[k][i]);
		printf ("\n");
	}
*/
	for (i = 1; i <= N[0]; ++i) s[0][i] = s[0][i-1] + vec[0][i];
	for (j = 1; j <= N[1]; ++j) s[1][j] = s[1][j-1] + vec[1][j];

	for (j = 1; j < N[1]; ++j) {
		fdp[0][j] = dp[1][0][j] = _infinity;
		prev[1][0][j] = -1;
		prev[0][0][j] = -2;
	}
	for (i = 1; i < N[0]; ++i) {
		fdp[i][0] = dp[0][i][0] = _infinity;
		prev[0][i][0] = -1;
		prev[1][i][0] = -2;
	}

	for (i = 1; i <= N[0]; ++i)
		for (j = 1; j <= N[1]; ++j) {
			dp[0][i][j] = dp[1][i][j] = fdp[i-1][j-1] + vec[0][i] * vec[1][j];
			prev[0][i][j] = j-1;
			prev[1][i][j] = i-1;

			assert (prev[0][i][j-1] != -2 && prev[1][i-1][j] != -2);

			if (prev[0][i][j-1] != -1 && dp[0][i][j] > fdp[i-1][prev[0][i][j-1]] + (s[1][j] - s[1][prev[0][i][j-1]]) * vec[0][i]) {
				dp[0][i][j] = fdp[i-1][prev[0][i][j-1]] + (s[1][j] - s[1][prev[0][i][j-1]]) * vec[0][i];
				prev[0][i][j] = prev[0][i][j-1];
			}
			if (prev[1][i-1][j] != -1 && dp[1][i][j] > fdp[prev[1][i-1][j]][j-1] + (s[0][i] - s[0][prev[1][i-1][j]]) * vec[1][j]) {
				dp[1][i][j] = fdp[prev[1][i-1][j]][j-1] + (s[0][i] - s[0][prev[1][i-1][j]]) * vec[1][j];
				prev[1][i][j] = prev[1][i-1][j];
			}
			fdp[i][j] = dp[0][i][j] <? dp[1][i][j];
//			printf ("(%d %d)%d - %d %d  %d %d\n", i, j, fdp[i][j], dp[0][i][j], prev[0][i][j], dp[1][i][j], prev[1][i][j]);
		}

	printf ("%d\n", fdp[N[0]][N[1]]);

	return 0;
}
