/*
TASK: cp
LANG: C++

FROM: CEOI 2000 day 1
PROB: cp (caterpillar)
KEYW: permutational tasks come down to tasks with intervals
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <vector>

const int MAXN = 1 << 14;

int N;
std::vector <int> vec[MAXN];
int in[MAXN];
bool leaf[MAXN];
int row[MAXN], rp;
int lbl[MAXN];

int main () {
	scanf ("%d", &N);

	int i, j;
	int a, b;
	for (i = 1; i < N; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		vec[a].push_back (b);
		vec[b].push_back (a);
	}

	for (i = 0; i < N; ++i) leaf[i] = (in[i] = (int)vec[i].size ()) == 1;
//	for (i = 0; i < N; ++i) if (leaf[i]) printf (" %d", i); printf ("\n");
	for (i = 0; i < N; ++i)
		if (leaf[i] && (--in[vec[i][0]]) == 1) {
			row[0] = vec[i][0];
			break;
		}

	if (i == N) {
		assert (N < 3);
		printf ("1"); for (i = 1; i < N; ++i) printf (" %d", i+1); printf ("\n");
		exit (0);
	}

	j = -1;
	for (i = 0;; ++i) {
		for (j = 0; j < (int)vec[row[i]].size (); ++j)
			if (!leaf[vec[row[i]][j]] && (!i || row[i-1] != vec[row[i]][j])) {
				row[i+1] = vec[row[i]][j];
				break;
			}
		if (j == ((int)vec[row[i]].size ())) break;
	}

	rp = i+1;
//	for (i = 0; i < rp; ++i) printf (" %d", row[i]); printf ("\n");

	int A = 1, B = N;
	bool sec = 0;
	for (i = 0; i < rp; ++i) {
		if (sec) {
			lbl[row[i]] = B--;
			for (j = 0; j < (int)vec[row[i]].size (); ++j) if (leaf[vec[row[i]][j]]) lbl[vec[row[i]][j]] = A++;
		} else {
			lbl[row[i]] = A++;
			for (j = 0; j < (int)vec[row[i]].size (); ++j) if (leaf[vec[row[i]][j]]) lbl[vec[row[i]][j]] = B--;
		}
		sec = !sec;
	}

	printf ("%d", lbl[0]); for (i = 1; i < N; ++i) printf (" %d", lbl[i]); printf ("\n");

	return 0;
}
