/*
TASK: turnin
LANG: C++

FROM: USOPEN 2004 GREEN
PROB: turnin
KEYW: dynamical programming, permutational task to task solved with intervals
*/

#include <cstdio>
#include <climits>
#include <algorithm>
#include <utility>

const int MAXH = 1 << 10;
const int MAXC = 1 << 10;

int C, B;
int dp[MAXH][MAXH];
std::pair <int, int> data[MAXC];

int main () {
	scanf ("%d %*d %d", &C, &B);

	int i, j;
	int a, b;
	for (i = 0; i < C; ++i) {
		scanf ("%d %d", &a, &b);
		data[i] = std::make_pair (a, b);
	}
	std::sort (data, data + C);
	int np = 0;
	for (i = 1; i < C; ++i)
		if (data[i].first == data[i-1].first)
			data[np].second = data[i].second;
		else
			data[++np] = data[i];
	C = np + 1;
//	for (i = 0; i < C; ++i) printf ("%d %d\n", data[i].first, data[i].second); printf ("\n");

	for (i = 0; i < C; ++i)
		for (j = 0; j < C; ++j)
			dp[i][j] = INT_MAX;

	dp[0][C-1] = data[0].first >? data[0].second;
	dp[C-1][0] = data[C-1].first >? data[C-1].second;

	for (j = C-1; j; --j)
		for (i = 0; i + j < C; ++i) {
//			printf ("%d %d -- %d %d\n", i, i + j, dp[i][i+j], dp[i+j][i]);
			dp[i+1][i+j] <?= (dp[i][i+j] + data[i+1].first - data[i].first) >? data[i+1].second;
			dp[i+j][i+1] <?= (dp[i][i+j] + data[i+j].first - data[i].first) >? data[i+j].second;

			dp[i+j-1][i] <?= (dp[i+j][i] + data[i+j].first - data[i+j-1].first) >? data[i+j-1].second;
			dp[i][i+j-1] <?= (dp[i+j][i] + data[i+j].first - data[i].first) >? data[i].second;
		}

	int res = INT_MAX;
	for (i = 0; i < C; ++i) {
//		printf ("%d - %d %d(%d %d)\n", i, dp[i][i], abs (B - data[i].first), data[i].first, data[i].second);
		res <?= dp[i][i] + abs (B - data[i].first);
	}

	printf ("%d\n", res);

	return 0;
}
