/*
TASK: utopia
LANG: C++

FROM: IOI 2002 day 1
PROB: utopia
KEYW: permutational task solved with intervals
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 14;

const bool dir[2][4] = {{1, 0, 0, 1}, {1, 1, 0, 0}};

int N;
bool s[2][MAXN];
int id[2][MAXN];
int d[2][MAXN];
int row[MAXN*2];

inline int dtoi (bool a) {return -1 + (a << 1);}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < (N << 1); ++i) scanf ("%d", row + i);

	int tmp;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &tmp);
		--tmp;
		s[0][i] = dir[0][tmp];
		s[1][i] = dir[1][tmp];
	}

	std::sort (row, row + N * 2);
	for (i = 0; i < N; ++i) {
		id[0][i] = row[i];
		id[1][i] = row[i+N];
	}

//	for (i = 0; i < N; ++i) printf ("%d %d %d %d\n", id[0][i], id[1][i], s[0][i], s[1][i]);

	int chc;
	int A, B;
	int fst;
	for (int k = 0; k < 2; ++k) {
		chc = 0;
		for (i = 1; i < N; ++i)
			if (s[k][i] != s[k][i-1])
				++chc;
		fst = N-1-chc;
//		printf ("%d -- %d %d\n", k, chc, fst);
		A = fst-1; B = fst+1;
		d[k][0] = dtoi (s[k][0]) * id[k][fst];
//		printf ("%d - > %d %d %d\n", k, d[k][0], fst, s[k][0]);
		for (i = 1; i < N; ++i) {
			if (s[k][i] != s[k][i-1]) {
				d[k][i] = id[k][B] * dtoi (((B - fst) & 1) ^ s[k][0]);
				++B;
			} else {
				d[k][i] = id[k][A] * dtoi (((fst - A) & 1) ^ s[k][0]);
				--A;
			}
		}
	}

	for (i = 0; i < N; ++i)
		printf ("%d %d\n", d[0][i], d[1][i]);

	return 0;
}
