/*
TASK: register
LANG: C++

FROM: CEOI 2003 day 2
PROB: register
KEYW: linear equations
*/

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>

#define MAXM (32)

const int MAXN = 1 << 10;
typedef unsigned uint;

struct bs {
	uint m[MAXM];
	bs () {memset (m, 0, sizeof (m));}
	void pop (uint id) {m[id >> 5] |= 1 << (id & 31);}
	uint ask (uint id) {return m[id >> 5] & (1 << (id & 31));}
	void operator ^= (const bs &a) {for (uint i = 0; i < MAXM; ++i) m[i] ^= a.m[i];}
};

uint N;
bs *ma3x[MAXN];

void prnt () {
	uint i, j;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			putchar (ma3x[i]->ask (j) ? '#' : '.');
		putchar (' ');
		putchar (ma3x[i]->ask (N) ? '#' : '.');
		putchar ('\n');
	}
}

int main () {
	scanf ("%d", &N);

	uint i, j;
	for (i = 0; i < N; ++i) ma3x[i] = new bs;

	uint a;
	int ii;
	for (i = 0; i < N << 1; ++i) {
		scanf ("%u", &a);
		if (!a) continue;//nothing to pop
		ii = i >= N ? (6 - i) : N-1-i;
//		printf ("i, ii %u %d\n", i, ii);
		for (j = ii >= 0 ? 0 : i - N + 1; j < N && j + ii < N; ++j) {
//			printf ("pop %u %u\n", j, ii + j);
			ma3x[j]->pop (ii+j);
		}
		if (i >= N) {
//			printf ("!pop %u %u\n", i-N, N);
			ma3x[i-N]->pop (N);
		}
	}
//	prnt ();
//	printf ("--\n--\n");
	for (i = 0; i < N; ++i) {
		for (j = i; j < N && !ma3x[j]->ask (i); ++j);
		if (j == N) {printf ("-1\n"); exit (0);}
		if (i != j) std::swap (ma3x[i], ma3x[j]);
		for (j = 0; j < i; ++j) if (ma3x[j]->ask (i)) *ma3x[j] ^= *ma3x[i];
		for (j = i+1; j < N; ++j) if (ma3x[j]->ask (i)) *ma3x[j] ^= *ma3x[i];
//		printf ("--%u--\n", i); prnt ();
	}

	for (i = 0; i < N; ++i) {putchar (ma3x[i]->ask (N) ? '1' : '0'); if (i != N-1) putchar (' ');} putchar ('\n');

	return 0;
}
