/*
TASK: x
LANG: C++

FROM: CEOI 2000 day 1
PROB: x (X-planet)
KEYW: linear equations
*/

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <algorithm>

#define MAXM (64)
const uint MAXN = 1 << 10;

typedef unsigned uint;

struct bs {
	uint m[MAXM];
	bs () {memset (m, 0, sizeof (m));}
	void pop (uint id) {m[id >> 5] |= 1 << (id & 31);}
	uint ask (uint id) {return m[id >> 5] & (1 << (id & 31));}
	void operator ^= (const bs &a) {for (uint i = 0; i < MAXM; ++i) m[i] ^= a.m[i];}
};

uint N;
bs *ma3x[MAXN];
bs targ;

void prnt () {
	static uint i, j;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < 2 * N; ++j) {
			if (j == N) putchar (' ');
			putchar (ma3x[i]->ask (j) ? '#' : '.');
		}
		printf ("\n");
	}
}

int main () {
	scanf ("%u", &N);
	for (uint i = 0; i < N; ++i) ma3x[i] = new bs;

	uint i, j;
	uint a, b;
	for (i = 0; i < (N << 1) - 3; ++i) {
		scanf ("%u %u", &a, &b);
		--a; --b;
//		printf ("%u %u\n", a, b);
		ma3x[a]->pop (b);
		ma3x[b]->pop (a);
	}
//	prnt (); printf ("__\n");

	for (i = 0; i < N; ++i) {
		ma3x[i]->pop (i);
		ma3x[i]->pop (i+N);
	}

	for (i = 0; i < N; ++i) {
		scanf ("%d", &a);
		if (!a) targ.pop (i);
	}
//	prnt ();
//	printf ("---\n---\n");

	bs bad;
	for (i = 0; i < N; ++i) {
		for (j = i; j < N && !ma3x[j]->ask (i); ++j);
		if (i != j) std::swap (ma3x[i], ma3x[j]);//only pointers - very easy swap
		if (j == N) {bad.pop (i); continue;}//this is a 'bad' line. later we will see what to do with it
/*			if (targ.ask (i)) {printf ("0\n"); exit (0);}
			else continue;//we dont need it and it is 0 everywhere
*/		for (j = 0; j < i; ++j) if (ma3x[j]->ask (i)) *ma3x[j] ^= *ma3x[i];
		for (j = i+1; j < N; ++j) if (ma3x[j]->ask (i)) *ma3x[j] ^= *ma3x[i];
//		printf ("--%d--\n", i); prnt ();
	}

	bs ans;
	for (i = 0; i < N; ++i)
		if (targ.ask (i))
			if (!bad.ask (i))
				ans ^= *ma3x[i];
			else if (!ans.ask (i)) {//it is not popped and we CANNOT pop it
				printf ("0\n");
				exit (0);
			}

//	for (i = 0; i < N; ++i) if (ans.ask (i)) putchar ('#'); else putchar ('.');
	std::vector <uint> res;
	for (i = 0; i < N; ++i)
		if (ans.ask (i + N))
			res.push_back (i + 1);//printf (" %d", i + 1); printf ("\n");

	printf ("%u", res[0]); for (i = 1; i < res.size (); ++i) printf (" %u", res[i]); printf ("\n");

	return 0;
}
