/*
TASK: fat
LANG: C++

FROM: NOI 2000 r3
PROB: fat
KEYW: finding maximum with 'napre4en' minimum
*/

#include <cstdio>
#include <cmath>
#include <climits>

const int MAXN = 1 << 8;

inline int sq (int a) {return a * a;}

struct pnt {
	int x, y;
	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}
	int dist (const pnt &a) {return sq (x - a.x) + sq (y - a.y);}
};

int N, H;
pnt data[MAXN];

int ans = INT_MAX;

void dijkstra () {
	static int d[MAXN];
	static bool used[MAXN] = {0};

	int i;
	for (i = 0; i < N; ++i)
		d[i] = sq (data[i].y);

	for (int k = 0; k < N; ++k) {
		int maxi;
		for (maxi = 0; used[maxi]; ++maxi);
		for (i = maxi + 1; i < N; ++i)
			if (!used[i] && d[i] < d[maxi])
				maxi = i;
//		printf ("%d -- %d %d -- %d\n", k, maxi, d[maxi], d[maxi] >? H - data[maxi].y);
		used[maxi] = 1;
		ans <?= d[maxi] >? sq (H - data[maxi].y);
		for (i = 0; i < N; ++i) {
//			if (!used[i]) printf ("try update %d with %d\n", i, (data[maxi].dist (data[i]) >? d[maxi]));
			if (!used[i] && (data[maxi].dist (data[i]) >? d[maxi]) < d[i])
				d[i] = (data[maxi].dist (data[i]) >? d[maxi]);
		}
	}
}

int main () {
	scanf ("%d %d", &H, &N);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &data[i].x, &data[i].y);

	dijkstra ();
	printf ("%.4lf\n", (int)(sqrt (ans) * 1000) / 1000.0);

	return 0;
}
