/*
TASK: robot
LANG: C++

FROM: BOI 2002 day 1
PROB: robot (zad1)
KEYW: maximum with 'napre4en' minimum
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <climits>

const int MAXN = 1 << 7;//128
const int MAXM = 1 << 5;//32

struct pnt {
	int x, y;
	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}
};

int dst (const pnt &a, const pnt &b) {
	return abs (a.x - b.x) >? abs (a.y - b.y);
}

int M, N;
pnt bound[2][MAXM];
pnt data[MAXN];
int dtb[2][MAXN];

int ans = INT_MAX;

void dijkstra () {
	static int d[MAXN];
	static bool used[MAXN];

	int i;
	for (i = 0; i < N; ++i) d[i] = dtb[0][i];

	for (int k = 0; k < N; ++k) {
		int mini;
		for (mini = 0; used[mini]; ++mini);
		for (i = mini + 1; i < N; ++i)
			if (!used[i] && d[i] < d[mini]) mini = i;
		used[mini] = 1;
		ans <?= d[mini] >? dtb[1][mini];
		for (i = 0; i < N; ++i)
			if (!used[i] && (d[mini] <? dst (data[mini], data[i])) < d[i])
				d[i] = d[mini] <? dst (data[mini], data[i]);
	}
}

int fnd_dst (const pnt &a, int k) {
	int ret = INT_MAX;
	for (int i = 0; i < M; ++i)
		if (bound[k][i].x == bound[k][i+1].x) {
			if ((bound[k][i].y - bound[k][i+1].y) * (bound[k][i].y - a.y) >= 0) {
//				printf ("try!! %d %d, %d, %d -- %d\n", a.x, a.y, k, i, abs (bound[k][i].x - a.x));
				ret <?= abs (bound[k][i].x - a.x);
			}
			ret <?= dst (a, bound[k][i]);
		} else {
			if ((bound[k][i].x - bound[k][i+1].x) * (bound[k][i].x - a.x) >= 0) {
//				printf ("try!! %d %d, %d, %d -- %d\n", a.x, a.y, k, i, abs (bound[k][i].y - a.y));
				ret <?= abs (bound[k][i].y - a.y);
			}
			assert (bound[k][i].y == bound[k][i+1].y);
			ret <?= dst (a, bound[k][i]);
		}
	ret <?= dst (a, bound[k][M]);
	return ret;
}

int main () {
	int i, k;

	scanf ("%d", &M);
	for (k = 0; k < 2; ++k) for (i = 0; i <= M; ++i) scanf ("%d %d", &bound[k][i].x, &bound[k][i].y);
	scanf ("%d", &N);
	for (i = 0; i < N; ++i) scanf ("%d %d", &data[i].x, &data[i].y);

//	for (i = 0; i <= M; ++i) printf ("%d %d  %d %d\n", bound[0][i].x, bound[0][i].y, bound[1][i].x, bound[1][i].y);
//	for (i = 0; i < N; ++i) printf ("%d %d\n", data[i].x, data[i].y);

	for (k = 0; k < 2; ++k) for (i = 0; i < N; ++i) dtb[k][i] = fnd_dst (data[i], k);

//	for (i = 0; i < N; ++i) printf ("%d %d --> %d %d\n", data[i].x, data[i].y, dtb[0][i], dtb[1][i]);

	for (i = 0; i < M; ++i)
		if (bound[0][i].x == bound[0][i+1].x) {
			assert (bound[1][i].x == bound[1][i+1].x);
			ans <?= abs (bound[0][i].x - bound[1][i].x);
		} else {
			assert (bound[0][i].y == bound[0][i+1].y && bound[1][i].y == bound[1][i+1].y);
			ans <?= abs (bound[0][i].y - bound[1][i].y);
		}

	dijkstra ();
	printf ("%d\n", ans);

	return 0;
}
