/*
TASK: pizza
LANG: C++

FROM: USACO 2004 MARCH GREEN
PROB: pizza
KEYW: coding combinations, hash, dinitz max flow, matching (wow)
*/

#include <cstdio>
#include <algorithm>

const int MAXC = 1 << 10;
const int MAXT = 1 << 5;

const int MAXN = 1 << 20;
const int MAXM = 1 << 20;

const int MAXHASH = 1 << 20;

class el {
	unsigned dat;
	public:
	int next;
	el () {}
	el (unsigned _to, bool _rd, int _next) : dat ((_rd << 30) | _to), next (_next) {}
	unsigned to () {return dat & 0xbfffffff;}
	unsigned rd () {return dat & 0x40000000;}
	void up () {dat |= 0x40000000;}
	void down () {dat &= 0xbfffffff;}
};

struct hash_el {
	int code;
	int next;
	hash_el () {}
	hash_el (int _code, int _next) : code (_code), next (_next) {}
};

int C, T, K;
int like[MAXC][MAXT];
int lp[MAXC];

int N, M;
int vec[MAXN];
el buf[MAXM*2];
int source, sink;

int ccomb[MAXT];
int Cmb[MAXT][MAXT];

int hash[MAXHASH];
hash_el buf_hash[MAXHASH];
int _c_b_h;

inline int hashf (int code) {return code % (MAXHASH-1);}
inline int op (int a) {return a ^ 1;}

int fnd_hash (int h) {
	int line = hashf (h);
	for (int i = hash[line]; i != -1; i = buf_hash[i].next)
		if (buf_hash[i].code == h) return i;

	buf_hash[_c_b_h] = hash_el (h, hash[line]);
	hash[line] = _c_b_h;

	vec[_c_b_h + C + 2] = -1;
	buf[M] = el (sink, 1, vec[_c_b_h + C + 2]);
	vec[_c_b_h + C + 2] = M++;

	buf[M] = el (_c_b_h + C + 2, 0, vec[sink]);
	vec[sink] = M++;

	return _c_b_h++;
}

int _c_add;
void code () {
	int i, j;
	int res = 0;
	i = T;
	for (int i = 0; i < K; ++i) printf ("%d ", ccomb[i]); printf ("--tocode\n");
	for (j = K-1; j >= 0; --j)
		for (--i; T-1-i < ccomb[K-1-j]; --i) {
			res += Cmb[i][j];
			printf ("take from %d %d - %d\n", i, j, Cmb[i][j]);
		}

	printf ("res == %d\n", res);

	int id = fnd_hash (res) + C + 2;
//	vec[id] = -1;
	buf[M] = el (id, 1, vec[_c_add]);
	vec[_c_add] = M++;

	buf[M] = el (_c_add, 0, vec[id]);
	vec[id] = M++;
}

void generate (int id, int pos =0, int toput =0) {
	printf ("gen %d %d %d\n", id, pos, toput);
	if (pos == K) {code (); return;}

	if (lp[id] - toput > K - pos) generate (id, pos, toput + 1);
	ccomb[pos] = like[id][toput];
	generate (id, pos + 1, toput + 1);
}

void fill_C () {
	Cmb[0][0] = 1;
	for (int i = 1; i <= T; ++i) {
		Cmb[i][0] = 1;
		for (int j = 1; j <= i; ++j)
			Cmb[i][j] = Cmb[i-1][j-1] + Cmb[i-1][j];
	}
	for (int i = 0; i <= C; ++i) {
		for (int j = 0; j <= C; ++j)
			printf ("%3d", Cmb[i][j]);
		printf ("\n");
	}
}

void input () {
	scanf ("%d %d %d", &C, &T, &K);
	printf ("C T K %d %d %d\n", C, T, K);

	int i, j;
	for (i = 0; i < C; ++i) {
		scanf ("%d", lp + i);
		for (j = 0; j < lp[i]; ++j) {
			scanf ("%d", like[i] + j);
			--like[i][j];
		}
		std::sort (like[i], like[i] + lp[i]);
	}
}

void build_graph () {
	source = 0;
	sink = 1;

	for (int i = 0; i < MAXHASH; ++i) hash[i] = -1;

	int i;
	for (i = 0; i < C + 2; ++i) vec[i] = -1;
	for (i = 0; i < C; ++i) {
		if (lp[i] < K) continue;
		printf ("____%d --- %d (%d)\n", i, Cmb[lp[i]][K], lp[i]);
		if (Cmb[lp[i]][K] >= C) {
			buf[M] = el (sink, 1, vec[i+2]);
			vec[i+2] = M++;

			buf[M] = el (i+2, 0, vec[sink]);
			vec[sink] = M++;
		} else {
			_c_add = i + 2;
			for (int j = 0; j < lp[i]; ++j) printf (" %d", like[i][j]); printf ("--tobe generated!\n");
			generate (i);
		}
		buf[M] = el (i+2, 1, vec[source]);
		vec[source] = M++;

		buf[M] = el (source, 0, vec[i+2]);
		vec[i+2] = M++;
	}

	N = _c_b_h + C + 2;

	for (int i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (int j = vec[i]; j != -1; j = buf[j].next)
			printf (" (%d %d)", buf[j].to (), !!buf[j].rd ());
		printf ("\n");
	}
}

int D[MAXN];
bool used[MAXN];
int vl[MAXN], vp;

bool bfs () {
	static int i, j, p3, crnt;
	static int queue[MAXN];
	for (i = 0; i < N; ++i) {
		used[i] = 0;
		D[i] = -1;
	}
	used[source] = 1;
	p3 = 0;
	queue[p3++] = sink;
	D[sink] = 0;

	for (i = 0; i < p3; ++i) {
		crnt = queue[i];
		for (j = vec[crnt]; j != -1; j = buf[j].next)
			if (D[buf[j].to ()] == -1 && buf[op (j)].rd ()) {
				D[buf[j].to ()] = D[crnt] + 1;
				queue[p3++] = buf[j].to ();
			}
	}

	return D[source] != -1;
}

bool dfs (int v) {
	if (v == sink) {
		used[sink] = 0;
		return 1;
	}

	for (int i = vec[v]; i != -1; i = buf[i].next)
		if (D[buf[i].to ()] == D[v] - 1 && !used[buf[i].to ()] && buf[i].rd ()) {
			used[buf[i].to ()] = 1;
			vl[vp++] = i;
			if (dfs (buf[i].to ())) return 1;
			--vp;
		}
	return 0;
}

int dinitz () {
	int maxflow = 0;
	while (bfs ()) {
		while (vp = 0, dfs (source)) {
			++maxflow;
			for (int i = 0; i < vp; ++i) {
				printf ("%d ", buf[vl[i]].to ());
				buf[vl[i]].down ();
				buf[op (vl[i])].up ();
			}
			printf (" --path!\n");
		}
	}

	return maxflow;
}

int main () {
	input ();
	fill_C ();
	build_graph ();

	int maxflow = dinitz ();
	printf ("%d\n", maxflow);

	return 0;
}
