/*
TASK: bugs
LANG: C++

FROM: CEOI 2002 day 1
PROB: bugs
KEYW: dynamical programming
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cstring>

const int MAXN = 150;
const int MAXM = 10;
const int MAXS = 60000;//3 ^ 10

const int pow3[] = {1, 3, 9, 27, 81, 243, 729, 2187, 6561, 19683, 59049};

int N, M, S;
char dp[/*MAXN*/2][MAXM][MAXS];
bool board[MAXN][MAXM];

bool if_bugs (int x, int y, int dx, int dy) {
	if (x + 1 < dx || y + 1 < dy) {/*printf ("no space!");*/ return 1;}

	for (int i = 0; i < dx; ++i)
		for (int j = 0; j < dy; ++j)
			if (board[x-i][y-j]) {/*printf ("bug %d %d", x-i, y-j);*/ return 1;}

	return 0;//no bugs
}

int code (int *vec) {
	int res = 0;
	for (int i = 0; i < M; ++i) {
		res *= 3;
		res += vec[i];
	}
	return res;
}

inline int call (int a) {return (a + 2) & 1;}

char pre (int x, int y, int *vec) {
	return y ? (/*printf ("<%d %d>", x, y-1),*/ dp[call (x)][y-1][code (vec)]) : (/*printf ("<%d %d>", x-1, M-1),*/ dp[call (x-1)][M-1][code (vec)]);
}

bool ok_p (int x, int y, int *vec) {
	if (x >= 2) return 1;//its ok

	for (int k = 0; k < M; ++k)
		if (vec[k] + (k > y) > x + 1) return 0;

	return 1;//its ok
}

void inc_p (int *vec) {
	static int i;
	for (i = M-1; i >= 0 && vec[i] == 2; --i) vec[i] = 0;
	if (i >= 0) ++vec[i];
}

void dpf () {
	int i, j, id;
	bool f1;
	int vec[MAXM];
	S = pow3[M];
//	printf ("%d %d\n", N, M);
	for (i = 1; i < N; ++i)
		for (j = 0; j < M; ++j) {
			memset (vec, 0, sizeof (vec));
			id = 0;
			do {
				assert (code (vec) == id);
//				if (code (vec) != id) {printf ("%d %d %d", i, j, id); for (int k = 0; k < M; ++k) printf (" %d ", vec[k]); exit (-1);}
				if (!ok_p (i, j, vec)) continue;
//				printf ("%d %d -- ", i, j);
//				for (int k = 0; k < M; ++k) printf ("%d ", vec[k]);

				if (vec[j]) {--vec[j]; f1 = 1;} else f1 = 0;
//				printf (">>>>"); for (int k = 0; k < M; ++k) printf ("%d ", vec[k]); printf ("<<<");
				dp[call (i)][j][id] = pre (i, j, vec);// printf ("_%d__", dp[i][j][id]);
				if (f1) ++vec[j];

//				if (j == 0 || vec[j] || vec[j-1]) printf ("_1_p1_");
				if (j && !vec[j] && !vec[j-1] && !if_bugs (i, j, 3, 2)) {
//					printf ("_IN_1__");
					vec[j] = vec[j-1] = 2;
//					printf ("(pre %d %d)", i, j-1); for (int k = 0; k < M; ++k) printf ("%d ", vec[k]);printf (")(%d)", pre (i, j-1, vec));
					dp[call (i)][j][id] >?= pre (i, j-1, vec) + 1;
					vec[j] = vec[j-1] = 0;
				}

//				if (j <= 1 || vec[j] || vec[j-1] || vec[j-2]) printf ("_2_p1_");
				if (j > 1 && !vec[j] && !vec[j-1] && !vec[j-2] && !if_bugs (i, j, 2, 3)) {
//					printf ("_IN_2__");
					vec[j] = vec[j-1] = vec[j-2] = 1;
//					printf ("(pre %d %d)", i, j-2); for (int k = 0; k < M; ++k) printf ("%d ", vec[k]);printf (")(%d)", pre (i, j-2, vec));
					dp[call (i)][j][id] >?= pre (i, j-2, vec) + 1;
					vec[j] = vec[j-1] = vec[j-2] = 0;
				}
//				printf (" !!%d\n", dp[i][j][id]);
			} while (inc_p (vec), ++id < S);
		}
}

void clear_all () {
	memset (dp, 0, sizeof (dp));
	memset (board, 0, sizeof (board));
}

int main () {
	int D;
	scanf ("%d", &D);
	while (D--) {
		int B;
		scanf ("%d %d %d", &N, &M, &B);
		clear_all ();

		while (B--) {
			int x, y;
			scanf ("%d %d", &x, &y);
			board[--x][--y] = 1;
		}

		dpf ();
		printf ("%d\n", dp[call (N-1)][M-1][0]);
	}

	return 0;
}
