/*
TASK: build
LANG: C++

FROM: FALL 2001 A
PROB: build
KEYW: dynamical programming
*/

#include <cstdio>
#include <vector>

const int MAXH = 13;
const int MAXS = 1 << MAXH;

int W, H, S;
std::vector <int> gr[MAXS];

long long dp[MAXH][MAXS];

int cr;
int nr;
std::vector <int> *crnt;
int _cntr;

void generate (int pos) {
	if (pos == W) {crnt->push_back (nr); ++_cntr; return;}
	if (cr & (1 << pos)) {//the current is NOT free
		nr &= ~(1 << pos);//turn down bit pos
		generate (pos + 1);
		return;
	}
	if (!(cr & (1 << pos + 1))) {
		nr &= ~(3 << pos);//turn down bits pos & pos + 1
		generate (pos + 2);
	}
	nr |= 1 << pos;//pick up bit 'pos'
	generate (pos + 1);
}

void fill_gr () {
	for (int i = 0; i < S; ++i) {
		crnt = gr + i;
		cr = i | (1 << W);//buffer
		generate (0);
	}
}

int main () {
	int i, j, k;
	scanf ("%d %d", &W, &H);
	if (W > H) W ^= H ^= W ^= H;
	S = 1 << W;

	fill_gr ();

	dp[0][0] = 1;
	for (k = 0; k < (int)gr[0].size (); ++k)
		dp[1][gr[0][k]] += dp[0][0];// += 1

	for (j = 1; j < H; ++j)
		for (i = 0; i < S; ++i)
			for (k = 0; k < (int)gr[i].size (); ++k)
				dp[j+1][gr[i][k]] += dp[j][i];

	printf ("%d\n", _cntr);
	printf ("%Ld\n", dp[H][0]);

	return 0;
}
