/*
TASK: twofive
LANG: C++

FROM: IOI 2001 day 1
PROB: twofive
KEYW: multiple dynamical programming
*/

#include <cstdio>
#include <cassert>

const int MAXN = 1 << 3;
const int N = 5;
const int MAXS = 1 << 13;

int board[MAXN][MAXN];
int bound[MAXN][MAXN];

bool used[MAXN * MAXN];

int dp[MAXS];

const int _coef[] = {1296, 216, 36, 6, 1};
int code (int *vec) {
	static int i, res;
	for (i = res = 0; i < N; ++i) {
		res *= 6;
		res += vec[i];
	}

	return res;
}

void decode (int a, int *vec) {
	for (int i = N - 1; i >= 0; --i) {
		vec[i] = a % 6; a /= 6;
	}
}

void setvec (int x, int y, int *vec) {
	static int i;
	for (i = 0; i < x; ++i) vec[i] = 0;
	vec[x] = 4 - y;
	for (i = x + 1; i < N; ++i) vec[i] = 5;
}

int dpf (int id) {
	if (dp[id] != -1) return dp[id];
	dp[id] = 0;

	int toput;
	int vec[MAXN];
	for (toput = 0; used[toput]; ++toput);
	used[toput] = 1;

	decode (id, vec);
	int max = 0;
	for (int i = 0; i < 5; ++i) {
		if (vec[i] <= max) continue;
		max = vec[i];
		if (bound[i][5 - max] >= toput) continue;
		dp[id] += dpf (id - _coef[i]);
	}

	used[toput] = 0;
	return dp[id];
}

int f (int id) {
	for (int i = 0; i < MAXS; ++i) dp[i] = -1;
	dp[1] = dp[0] = 1;//when everything is empty or there is only 1 left on the last row (Y)

	return dpf (id);
}

int main () {
	int vec[MAXN];
	char c;
	int i, j, k;
	scanf ("%c\n", &c);

	if (c == 'W') {
		char buf[MAXN * MAXN];
		gets (buf);
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j)
				board[i][j] = buf[i*N + j] - 'A';
/*
		for (i = 0; i < N; ++i) {
			for (j = 0; j < N; ++j)
				printf ("%d ", board[i][j]);
			printf ("\n");
		}
*/
		used[0] = 1;
		int res = 0;
		for (i = 0; i < N; ++i)
			for (j = !i; j < N; ++j) {
				assert (board[i][j] >= bound[i][j] + 1);
				for (k = bound[i][j] + 1; k < board[i][j]; ++k) {
					if (used[k]) continue;

					if (i < 4) bound[i+1][j] >?= k;
					if (j < 4) bound[i][j+1] >?= k;
					used[k] = 1;
					setvec (i, j, vec);
					res += f (code (vec));
					used[k] = 0;
				}
				if (i < 4) bound[i+1][j] >?= board[i][j];
				if (j < 4) bound[i][j+1] >?= board[i][j];
				used[board[i][j]] = 1;
			}

		printf ("%d\n", res + 1);
	} else {//c == 'N'
		int n, id;
		int ans[MAXN][MAXN] = {{0}};
		scanf ("%d", &n);
		--n;

		used[0] = 1;
		for (i = 0; i < N; ++i)
			for (j = !i; j < N; ++j) {
				for (k = bound[i][j] + 1; k < 25; ++k) {
					if (used[k]) continue;

					if (i < 4) bound[i+1][j] >?= k;
					if (j < 4) bound[i][j+1] >?= k;
					used[k] = 1;

					setvec (i, j, vec);
					f (id = code (vec));
					if (dp[id] > n) break;
					else n -= dp[id];
					used[k] = 0;
				}
				assert (k < 25);
				ans[i][j] = k;
			}
		assert (n == 0);
/*		for (i = 0; i < N; ++i) {
			for (j = 0; j < N; ++j)
				printf ("%d ", ans[i][j]);
			printf ("\n");
		}
		printf ("\n");
*/		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j)
				printf ("%c", ans[i][j] + 'A');
		printf ("\n");
	}

	return 0;
}
