/*
TASK: fence
LANG: C++

FROM: FALL 2001 A
PROB: fence
KEYW: computational geometry, angles
*/

#include <cstdio>
#include <cassert>
#include <cmath>

const int MAXN = 1 << 10;

struct pnt {
	int x, y;

	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}

	pnt operator - (const pnt &a) {return pnt (x - a.x, y - a.y);}
	double sq () {return x * x + y * y;}
	double len () {return sqrt (sq ());}
};

int N;
pnt pnts[MAXN];
int R[MAXN];

double ang[MAXN];
int hid[MAXN];

double sq (double x) {return x * x;}

double base_ang;
double myatan (const pnt &a) {
	double ret = atan2 (a.y, a.x);
	while (ret < base_ang) ret += M_PI * 2;
	return ret;
}

double myang (int a, int b) {
	return myatan (pnts[b] - pnts[a]) + asin ((R[a] - R[b]) / (pnts[b] - pnts[a]).len ());
}

int fnd_nxt (int crnt, int pos) {
	double min = 1e99, tmp;
	int mini = -1;
	for (int i = 0; i < N; ++i) {
		if (i == crnt || min <= (tmp = myang (crnt, i))) continue;
		min = tmp;
		mini = i;
	}
	ang[pos] = base_ang = min;
	hid[pos] = crnt;
	return mini;
}


int main () {
	int x, y, r;
	while (scanf ("%d %d %d", &x, &y, &r) == 3) {
		pnts[N] = pnt (x, y);
		R[N++] = r;
	}

	int sp = 0;
	int i;
	for (i = 1; i < N; ++i)
		if (pnts[i].y - R[i] < pnts[sp].y - R[sp] || pnts[i].y - R[i] == pnts[sp].y - R[sp] && pnts[i].x > pnts[sp].x)
			sp = i;

	base_ang = 0;

	int cp = 0;
	int crnt = fnd_nxt (sp, cp++);
	while (crnt != sp) crnt = fnd_nxt (crnt, cp++);
	ang[cp] = ang[0];
	hid[cp] = hid[0];
	double res = 0;
	res += (ang[0] - (ang[cp-1] - M_PI * 2)) * R[hid[0]];
	for (i = 1; i < cp; ++i) res += (ang[i] - ang[i-1]) * R[hid[i]];
	for (i = 1; i <= cp; ++i) res += sqrt ((pnts[hid[i]] - pnts[hid[i-1]]).sq () - sq (R[hid[i]] - R[hid[i-1]]));

	printf ("%lf\n", res);

	return 0;
}
