/*
TASK: fence
LANG: C++

FROM: FALL 2001 A
PROB: fence
KEYW: computational geometry, angles
*/

#include <cstdio>
#include <cassert>
#include <cmath>

const int MAXN = 1 << 10;

struct pnt {
	int x, y;

	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}

	pnt operator - (const pnt &a) {return pnt (x - a.x, y - a.y);}
	double sq () {return x * x + y * y;}
	double len () {return sqrt (sq ());}
};

int N;
pnt pnts[MAXN];
int R[MAXN];

double ang[MAXN];
int hid[MAXN];

double degree (double x) {return x * 180 / M_PI;}

double base_ang;
double myatan (const pnt &a) {
	double ret = atan2 (a.y, a.x);
	while (ret < base_ang) ret += M_PI * 2;
	return ret;
}

double myang (int a, int b) {
	printf ("%d %d - %lf %lf\n", a, b, degree (myatan (pnts[b] - pnts[a])), degree (asin ((R[a] - R[b]) / (pnts[b] - pnts[a]).len ())));
	return myatan (pnts[b] - pnts[a]) + asin ((R[a] - R[b]) / (pnts[b] - pnts[a]).len ());
}

double sq (double a) {return a * a;}

int fnd_nxt (int crnt, int pos) {
	double min = 1e99, tmp;
	int mini = -1;
	printf ("%d %d!!\n", crnt, pos);
	for (int i = 0; i < N; ++i) {
		if (i == crnt) continue;
		tmp = myang (crnt, i);
		printf ("%d -- %lf\n", i, degree (tmp));
		if (min > tmp) {
			printf ("upd!\n");
			min = tmp;
			mini = i;
		}
	}
	if (mini == -1) printf ("baad!\n");

	printf ("___%lf___%d\n", degree (min), mini);
	ang[pos] = min;
	base_ang = min;
	hid[pos] = crnt;
	printf ("\n\n");
	return mini;
}


int main () {
	int x, y, r;
	while (scanf ("%d %d %d", &x, &y, &r) == 3) {
		pnts[N] = pnt (x, y);
		R[N] = r;
		++N;
	}
	for (int i = 0; i < N; ++i) printf ("%d %d %d\n", pnts[i].x, pnts[i].y, R[i]); printf ("\n");

	printf ("!!!\n");

	int sp = 0;
	int i;
	for (i = 1; i < N; ++i)
		if (pnts[i].y - R[i] < pnts[sp].y - R[sp] || pnts[i].y - R[i] == pnts[sp].y - R[sp] && pnts[i].x > pnts[sp].x)
			sp = i;

	printf ("sp == %d\n", sp);

	base_ang = 0;

	int cp = 0;
	int crnt = fnd_nxt (sp, cp++);
	while (crnt != sp) crnt = fnd_nxt (crnt, cp++);

	for (i = 0; i < cp; ++i) printf ("%d - %lf\n", hid[i], degree (ang[i]));
	ang[cp] = ang[0];
	hid[cp] = hid[0];
	double res = 0;
	for (i = 1; i < cp; ++i) {
		res += (ang[i] - ang[i-1]) * R[hid[i]];
		printf (">> %lf\n", (ang[i] - ang[i-1]) * R[hid[i]]);
	}
	res += (ang[0] - (ang[cp-1] - M_PI * 2)) * R[hid[0]];
	printf (">> %lf\n", (ang[0] - (ang[cp-1] - M_PI * 2)) * R[hid[0]]);
	for (i = 1; i <= cp; ++i) {
		res += sqrt ((pnts[hid[i]] - pnts[hid[i-1]]).sq () - sq (R[hid[i]] - R[hid[i-1]]));
		printf (">>> %lf\n", sqrt ((pnts[hid[i]] - pnts[hid[i-1]]).sq () - sq (R[hid[i]] - R[hid[i-1]])));
	}
	printf ("%lf\n", res);

	return 0;
}
