/*
TASK: oldmap
LANG: C++

FROM: BOI 2002 day 2
PROB: oldmap
KEYW: double connected edge list
*/

#include <cstdio>
#include <cmath>

#include <vector>
#include <algorithm>

const int MAXN = 1 << 10;
const int MAXM =  MAXN * MAXN;

struct pnt {
	int x, y;
	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}
};

struct edge {
	int to_pnt;
	int next_star;

	bool used;
	int next_edge;

	edge () {}
	edge (int _to_pnt, int _next_star) : to_pnt (_to_pnt), next_star (_next_star), used (0) {}
};

inline int op (int a) {return a ^ 1;}

int N, K;
int vec[MAXN];
edge buf[MAXM];
pnt pnts[MAXN];
int fst[MAXN];

int _base;
bool cmp_atan2 (int a, int b) {
	return	atan2 (pnts[buf[a].to_pnt].y - pnts[_base].y, pnts[buf[a].to_pnt].x - pnts[_base].x)
			<
			atan2 (pnts[buf[b].to_pnt].y - pnts[_base].y, pnts[buf[b].to_pnt].x - pnts[_base].x);
}

int main () {
	scanf ("%d", &N);

	int i, j, k;
	int a, c;
	int bp = 0;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d %d", &pnts[i].x, &pnts[i].y, &c);
		for (j = 0; j < c; ++j) {
			scanf ("%d", &a);
			--a;

			if (a < i) continue;//already done
			buf[bp] = edge (a, vec[i]);
			vec[i] = bp++;

			buf[bp] = edge (i, vec[a]);
			vec[a] = bp++;
		}
	}
	scanf ("%d", &K);

	static int cid[MAXN], cp;
	for (i = 0; i < N; ++i) {
		cp = 0;
		for (j = vec[i]; j != -1; j = buf[j].next_star)
			cid[cp++] = j;
		_base = i;
		std::sort (cid, cid + cp, cmp_atan2);
		fst[i] = cid[0];
		for (j = 0; j < cp - 1; ++j)
			buf[op (cid[j])].next_edge = cid[j + 1];
		buf[op (cid[cp-1])].next_edge = cid[0];
	}

	int lpid = 0;
	for (i = 1; i < N; ++i)
		if (pnts[i].y < pnts[lpid].y)
			lpid = i;

	buf[fst[lpid]].used = 1;
//	printf (">>%d(%d)\n", fst[lpid], buf[fst[lpid]].to_pnt);
	for (j = buf[fst[lpid]].next_edge; j != fst[lpid]; j = buf[j].next_edge) {
		buf[j].used = 1;
//		printf (">>%d(%d)\n", j, buf[j].to_pnt);
	}

	static int used[MAXN];
	int cui = 1, cntr;
	int ans = 0;
	bool bad_flag;
	for (i = 0; i < N; ++i) {
		for (j = vec[i]; j != -1; j = buf[j].next_star) {
			if (buf[j].used) continue;
			used[buf[j].to_pnt] = cui;
//			printf ("__cui %d\n", cui);
//			printf (" %d\n", buf[j].to_pnt);
			cntr = 1;
			bad_flag = 0;
			for (k = buf[j].next_edge; k != j; k = buf[k].next_edge) {
//				printf (" %d\n", buf[k].to_pnt);
				if (used[buf[k].to_pnt] == cui)
					bad_flag = 1;
				used[buf[k].to_pnt] = cui;
				buf[k].used = 1;
				++cntr;
			}
			if (cntr == K && !bad_flag) {
//				printf ("YEP!\n");
				++ans;
			}
			++cui;
		}
	}

	printf ("%d\n", ans);

	return 0;
}
