/*
TASK: sequence
LANG: C++

FROM: BOI 2002
PROB: sequences
KEYW: binary search
NOTE: Velin's warmup : Theme 1 (convex hull, binary search)
*/


#include "module.h"

#include <cstdio>
#include <cstdlib>
#include <climits>
#include <vector>

const int MAXN = 1 << 4;

int N;
std::vector <std::vector <int> > data;
int idx[MAXN];

int ask (int a, int b) {
	if (data[a][b] != -1) return data[a][b];
	else return data[a][b] = GetA (a + 1, b + 1);
}

int bsrch (int row, int dig) {
	int l = -1, r = data[row].size (), m;

	while (l + 1 < r) {
		m = (l + r) / 2;

		if (ask (row, m) == dig) return idx[row] = m;
		if (ask (row, m) < dig)
			l = m;
		else
			r = m;
	}

	return idx[row] = r;
}

int test (int d) {
	int sum = 0;
	for (int i = 0; i < N; ++i)
		sum += bsrch (i, d);
	return sum;
}

void dofin (int d) {
	int res = INT_MAX;
	for (int i = 0; i < N; ++i)
		if (idx[i] != (int)data[i].size ())
			res <?= data[i][idx[i]];
	printf ("%d\n", res);

	Finish ();
}

int main () {
	Init ();
	N = GetN ();
	data.resize (N);

	int K;
	K = GetK ();

	for (int i = 0; i < N; ++i) data[i].resize (GetLen (i + 1), -1);

	int l = 0, r = INT_MAX, m;

	int tres;
	while (l + 1 < r) {
		m = (l + r) / 2;

		tres = test (m);
		if (tres == K-1) dofin (m);
		if (tres < K-1)
			l = m;
		else
			r = m-1;
	}

	return 0;
}
