/*
TASK: tr
LANG: C++

FROM: BOI 2002 day 1
PROB: tr
KEYW: sweep line
*/

#include <cstdio>
#include <climits>
#include <algorithm>

const int MAXN = 1 << 11;

struct el {
	int x, y;
	int m;
};

int N;
el vec[MAXN];
int Y[MAXN];

bool cmp1 (const el &a, const el &b) {
	return a.x < b.x;
}

void upd (std::pair <int, int> *dat, int &p, const std::pair <int, int> &toput) {
	if (dat[p].first == INT_MIN) {dat[p] = toput; return;}
	if (dat[p].first == toput.first) {dat[p].second >?= toput.second; return;}
	dat[++p] = toput;
}

int _D;
long long S (int a, int b) {
	b -= a;
	if (b > _D)
		return (long long)b * b - (long long)(b - _D) * (b - _D);
	else
		return (long long)b * b;
}

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d %d", &vec[i].x, &vec[i].y, &vec[i].m);
		Y[i] = vec[i].y;
	}

	std::sort (Y, Y + N);
	std::sort (vec, vec + N, cmp1);
	int Yp = std::unique (Y, Y + N) - Y;

	Y[Yp] = INT_MAX / 2;
	static std::pair <int, int> cvec[MAXN];
	int cvp, cend;
	long long res = 0;
	for (i = 0; i < Yp; ++i) {
		cvec[cvp = 0] = std::make_pair (INT_MIN, INT_MIN);
		for (j = 0; j < N; ++j)
			if (vec[j].y <= Y[i] && vec[j].y + vec[j].m > Y[i]) {
//				printf ("<%d %d>\n", vec[j].x, vec[j].x + vec[j].y + vec[j].m - Y[i]);
				upd (cvec, cvp, std::make_pair (vec[j].x, vec[j].x + vec[j].y + vec[j].m - Y[i]));
			}
		++cvp;
//		printf ("%d -->", i); for (j = 0; j < cvp; ++j) printf (" (%d %d)", cvec[j].first, cvec[j].second); printf ("\n");
		_D = Y[i+1] - Y[i];
		res += S (cvec[0].first, cvec[0].second);
		cend = cvec[0].second;
		for (j = 1; j < cvp; ++j) {
			if (cvec[j].second <= cend) continue;
			if (cvec[j].first < cend)
				res -= S (cvec[j].first, cend);
			res += S (cvec[j].first, cvec[j].second);
			cend = cvec[j].second;
		}
	}

	printf ("%Ld.%d\n", res / 2, res & 1 ? 5 : 0);

	return 0;
}
