/*
TASK:circle
LANG:C++

FROM: SPRING 2003 A
PROB: circle
KEYW: lowest bit index tree
*/

#include <cstdio>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 19;

int N, N2;
std::pair <int, int> vec[MAXN * 2];

int idt[MAXN * 2];

inline int lowest_bit (int a) {return a & -a;}

void add (int i, int val) {
	for (; i <= N2; i += lowest_bit (i))
		idt[i] += val;
}

int _srch (int i) {
	static int ret = 0;
	for (ret = 0; i; i -= lowest_bit (i))
		ret += idt[i];

	return ret;
}

int srch (int l, int r) {
	return _srch (r) - _srch (l);//warning!! this is ONLY in case that pos l is empty otherwise it should be l-1
}

int main () {
	scanf ("%d", &N);
	N2 = N << 1;

	int i;
	int a, b;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &a, &b);
		vec[i*2] = std::make_pair (a, b);
		vec[i*2+1] = std::make_pair (b, a);
	}

	std::sort (vec, vec + N2);

	long long sum = 0;
	for (i = 0; i < N2; ++i)
		if (vec[i].first < vec[i].second)
			add (vec[i].first, 1);
		else {
			add (vec[i].second, -1);//remove
			sum += srch (vec[i].second, vec[i].first);
		}

	printf ("%Ld\n", sum);
	return 0;
}
