/*
TASK: mar
LANG: C++

FROM: BaOI 2001
PROB: mar (mars)
KEYW: real index tree, mars index tree :)
*/

#include <cstdio>
#include <cassert>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 14;
const int MAXCOOR = 1 << 15;

struct node {
	int all;
	int cov;
};

int N, N2;

std::pair <int, int> x[MAXN];
std::pair <int, int> y[MAXN];

std::pair <int, int> row[MAXN * 2];

node idt[MAXCOOR * 2];

int f (int id, int sum) {
	return idt[id].all ? sum : idt[id].cov;
}

void add (int l, int r, int lb, int rb, int p, int val) {
	if (l < lb) l = lb;
	if (r > rb) r = rb;
	if (l >= r) return;
	if (l == lb && r == rb) {idt[p].all += val; return;}

	int m = (lb + rb) >> 1;
	add (l, r, lb, m, p * 2 + 1, val);
	add (l, r, m, rb, p * 2 + 2, val);

	idt[p].cov = f (p * 2 + 1, m - lb) + f (p * 2 + 2, rb - m);
}

int main () {
	scanf ("%d", &N);
	N2 = N << 1;

	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d %d %d", &x[i].first, &y[i].first, &x[i].second, &y[i].second);
		row[i * 2] = std::make_pair (x[i].first, i);
		row[i * 2 + 1] = std::make_pair (x[i].second, i);
	}

	std::sort (row, row + N2);

	add (y[row[0].second].first, y[row[0].second].second, 0, MAXCOOR, 0, 1);
	int ret = 0;
	for (i = 1; i < N2; ++i) {
		ret += idt[0].cov * (row[i].first - row[i-1].first);//the first can never be covered completely (idt[0].all == 0)
		if (x[row[i].second].first == row[i].first)
			add (y[row[i].second].first, y[row[i].second].second, 0, MAXCOOR, 0,  1);
		else
			add (y[row[i].second].first, y[row[i].second].second, 0, MAXCOOR, 0, -1);
	}
	assert (!idt[0].cov);

	printf ("%d\n", ret);

	return 0;
}
