/*
TASK:mobiles
LANG:C++

FROM: IOI 2001 day 1
PROB: mobiles
KEYW: 2D lowest bit index tree
*/

#include <cstdio>

const int MAXN = 1 << 10;//warning - EXACTLY as the upper bound

int N;
int idt[MAXN][MAXN];

inline int lowest_bit (int a) {return (a+1) & -(a+1);}//use [0,N[ rather than [1,N+1[

void add (int x, int y, int val) {
	static int i, j;
	for (i = x; i < N; i += lowest_bit (i))
		for (j = y; j < N; j += lowest_bit (j))
			idt[i][j] += val;
}

int _srch (int x, int y) {//no problem if x || y is negative
	static int i, j, ret;
	for (i = x, ret = 0; i >= 0; i -= lowest_bit (i))
		for (j = y; j >= 0; j -= lowest_bit (j))
			ret += idt[i][j];
	return ret;
}

int srch (int x1, int y1, int x2, int y2) {
	return --x1, --y1, _srch (x2, y2) - _srch (x2, y1) - _srch (x1, y2) + _srch (x1, y1);
}

int main () {
	scanf ("0 %d\n", &N);

	int comm;
	int x1, y1, x2, y2;
	int val;
	while (scanf ("%d", &comm), comm != 3)
		switch (comm) {
			case 1: scanf ("%d %d %d", &x1, &y1, &val); add (x1, y1, val); break;
			case 2: scanf ("%d %d %d %d", &x1, &y1, &x2, &y2);
					printf ("%d\n", srch (x1, y1, x2, y2)); fflush (stdout);
					break;
		}

	return 0;
}
