/*
TASK:moofest
LANG:C++

FROM: USOPEN 2004 GREEN
PROB: moofest
KEYW: lowest bit index tree
*/

#include <cstdio>
#include <cassert>
#include <algorithm>

const int MAXN = 1 << 15;

int N;
int v[MAXN], x[MAXN];
int idx[MAXN];
int idt[2][MAXN];

inline int lowest_bit (int i) {return i & -i;}

void add (int id, int i, int val) {
	for (; i < MAXN; i += lowest_bit (i))
		idt[id][i] += val;
}

int srch (int id, int i) {
	static int ret;
	for (ret = 0; i; i -= lowest_bit (i))
		ret += idt[id][i];
	return ret;
}

void clear (int id) {
	for (int i = 0; i < MAXN; ++i) idt[id][i] = 0ll;
}

inline bool cmp (int a, int b) {
	return x[a] < x[b];
}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", v + i, x + i);
		idx[i] = i;
	}

	std::sort (idx, idx + N, cmp);

	long long res = 0;
	for (i = 0; i < N; ++i) {
		res += (srch (1, v[idx[i]]) * x[idx[i]] - srch (0, v[idx[i]])) * (long long)v[idx[i]];
		add (0, v[idx[i]], x[idx[i]]);
		add (1, v[idx[i]], 1);
	}

	clear (0); clear (1);

	for (i = N-1; i >= 0; --i) {
		res += (srch (0, v[idx[i]] - 1) - srch (1, v[idx[i]] - 1) * x[idx[i]]) * (long long)v[idx[i]];
		add (0, v[idx[i]], x[idx[i]]);
		add (1, v[idx[i]], 1);
	}

	printf ("%Ld\n", res);

	return 0;
}
