/*
TASK: mou
LANG: C++

FROM: IOI 2005 day 1
PROB: mou (mountain)
KEYW: full index tree, mars index tree, coordinate copression
*/

#include <cstdio>
#include <cassert>

#include <algorithm>

const int MAXINPUT = 1 << 17;
const int MAXLINE = 1 << 6;
const int MAXCOOR = MAXINPUT * 2;
const int NO_D = 1 << 30;

struct inp {
	bool type;//0 is modify, 1 is query
	int a, b, d;//if type == 1 only a matters
	inp () {}
	inp (bool _type, int _a, int _b = -1, int _d = -1) : type (_type), a (_a), b (_b), d (_d) {}
};

struct node {
	int s;
	int d;
	int maxh;
};

inp input[MAXINPUT];
int ip;
int coor[MAXCOOR+1], cp;//very very ugly

node idt[MAXCOOR * 2];

void add (int l, int r, int lb, int rb, int p, int val) {
//	printf ("add (%d %d  %d %d) ", l, r, lb, rb);
	if (l < lb) l = lb;
	if (r > rb) r = rb;
//	printf ("%d %d  %d %d <<%d>>(%d)\n", l, r, lb, rb, val, idt[p].d);
	if (l >= r) return;

	if (l == lb && r == rb) {
		idt[p].d = val;
		idt[p].s = val * (coor[rb] - coor[lb]);
		idt[p].maxh = idt[p].s >? 0;
//		printf ("bootom -- %d %d %d(%d)\n", idt[p].d, idt[p].s, idt[p].maxh, (coor[rb] - coor[lb]));
		return;
	}

	int m = (lb + rb) >> 1;
	if (idt[p].d != NO_D) {
//		printf ("these 2 are for cooming down!\n");
		add (lb, m, lb, m, p * 2 + 1, idt[p].d);
		add (m, rb, m, rb, p * 2 + 2, idt[p].d);
		idt[p].d = NO_D;
	}

	add (l, r, lb, m, p * 2 + 1, val);
	add (l, r, m, rb, p * 2 + 2, val);
	idt[p].s = idt[p * 2 + 1].s + idt[p * 2 + 2].s;
	idt[p].maxh = (idt[p * 2 + 1].maxh) >? (idt[p * 2 + 2].maxh + idt[p * 2 + 1].s);
}

int srch (int h, int lb, int rb, int p) {
//	printf ("srch %d -- %d %d (%d) -- maxh %d\n", h, lb, rb, p, idt[p].maxh);
	if (h >= idt[p].maxh) return coor[rb] - coor[lb];

	int m = (lb + rb) >> 1;
	if (idt[p].d == NO_D)
		if (h >= idt[p * 2 + 1].maxh)
			return coor[m] - coor[lb] + srch (h - idt[p * 2 + 1].s, m, rb, p * 2 + 2);
		else
			return srch (h, lb, m, p * 2 + 1);
	else {
		assert (idt[p].d > 0);
		return h / idt[p].d;
	}
}

int bsrch (int x) {
	int l = -1, r = cp, m;

	while (l + 1 < r) {
		m = (l + r) >> 1;
		if (x > coor[m])
			l = m;
		else
			r = m;
	}

	assert (r != cp);
	return r;
}

int main () {
	char line[MAXLINE];
	scanf ("%d\n", coor); cp = 1;
	coor[cp++] = 0;
	int a, b, d;
	while (fgets (line, MAXLINE, stdin), line[2]) {//line is NOT 1character (and \n)(only "E" is one character)
		switch (line[0]) {
			case 'I': sscanf (line + 2, "%d %d %d\n", &a, &b, &d); input[ip++] = inp (0, --a, b, d); coor[cp++] = a; coor[cp++] = b; break;
			case 'Q': sscanf (line + 2, "%d\n", &a); input[ip++] = inp (1, a); break;
			default : assert (0);
		}
	}

	std::sort (coor, coor + cp);
	cp = std::unique (coor, coor + cp) - coor;
	for (int i = cp; i <= MAXCOOR; ++i) coor[i] = coor[cp-1];

	int maxc;
	for (maxc = 2; maxc < cp; maxc *= 2);
//	printf ("maxc == %d\n", maxc);
//	for (int i = 0; i <= maxc; ++i) printf ("%d ", coor[i]); printf ("\n");

	idt[0].d = NO_D;
	add (0, maxc, 0, maxc, 0, 0);//make it flat at the begining
	for (int i = 0; i < ip; ++i) {
//		printf ("<<%d %d %d %d\n", input[i].type, input[i].a, input[i].b, input[i].d);
		if (input[i].type)
			printf ("%d\n", srch (input[i].a, 0, maxc, 0));
		else
			add (bsrch (input[i].a), bsrch (input[i].b), 0, maxc, 0, input[i].d);
	}
	return 0;
}
