/*
TASK:round
LANG:C++

FROM: SPRING 2004 A
PROB: round
KEYW: dynamical programming, lowest bit index tree
*/

#include <cstdio>
#include <climits>

const int MAXN = 1 << 11;

int N, N2;
int r[2][MAXN];
int idt[MAXN * 2];

int dpmemo[MAXN][MAXN];

inline int lowest_bit (int i) {return i & -i;}

void add (int i, int val) {
	for (; i <= N2; i += lowest_bit (i))
		idt[i] += val;
}

int _srch (int i) {
	static int ret;
	for (ret = 0; i; i -= lowest_bit (i))
		ret += idt[i];
	return ret;
}

int srch1 (int pos, int sum) {
	static int tmp;
	tmp = _srch (pos - 1);
	return tmp <? sum - tmp;
}

int srch2 (int pos, int sum) {
	static int tmp;
	if (pos > N)
		tmp = _srch (pos - 1) - _srch (N);
	else
		tmp = _srch (N) - _srch (pos);
	return tmp <? sum - tmp;
}

int dp (int i, int j) {
	if (dpmemo[i][j] != INT_MAX) return dpmemo[i][j];

	if (i < N) {
		add (r[0][i], 1);
		dpmemo[i][j] <?= dp (i + 1, j) + srch1 (r[0][i], i + j);
		add (r[0][i], -1);
	}

	if (j < N) {
		add (r[1][j], 1);
		dpmemo[i][j] <?= dp (i, j + 1) + srch2 (r[1][j], i + j);
		add (r[1][j], -1);
	}

	return dpmemo[i][j];
}

int main () {
	scanf ("%d", &N);
	N2 = N << 1;

	int i, j;
	for (j = 0; j < 2; ++j)
		for (i = 0; i < N; ++i)
			scanf ("%d", r[j] + i);

	for (i = 0; i <= N; ++i)
		for (j = 0; j <= N; ++j)
			dpmemo[i][j] = INT_MAX;

	dpmemo[N][N] = 0;//bottom of dp

	printf ("%d\n", dp (0, 0));

	return 0;
}
