/*
TASK: team
LANG: C++

FROM: BOI 2004 day 1
PROB: team
KEYW: lowest bit index tree for minimum, hardest version
*/

#include <cstdio>
#include <utility>
#include <climits>
#include <algorithm>

const int MAXN = 1 << 19;

int N;
int row[MAXN];
int pos[MAXN];
int val[MAXN];

int idt[MAXN];

inline int lowest_bit (int a) {return a & -a;}

void add (int i, int v) {
	for (; i <= N; i += lowest_bit (i))
		idt[i] <?= v;
}

int srch (int i) {
	static int ret;
	for (ret = INT_MAX; i; i -= lowest_bit (i))
		ret <?= idt[i];
	return ret;
}

int main () {
	scanf ("%d", &N);

	int i, tmp;
	for (i = 0; i < N; ++i) {scanf ("%d", row + i); --row[i];}
	for (i = 0; i < N; ++i) {scanf ("%d", &tmp); pos[tmp-1] = i+1;}
	for (i = 0; i < N; ++i) {scanf ("%d", &tmp); val[tmp-1] = i;}

//	std::sort (pos, pos + N);
//	std::sort (val, val + N);

	for (i = 1; i <= N; ++i) idt[i] = INT_MAX;

	int res = 0;
	for (i = 0; i < N; ++i) {
		if (srch (pos[row[i]]) > val[row[i]]) ++res;
		add (pos[row[i]], val[row[i]]);
	}

	printf ("%d\n", res);

	return 0;
}
