/*
TASK:travers
LANG:C++

FROM: BOI 2003 day 1
PROB: travers
KEYW: lowest bit index tree
*/

#include <cstdio>
#include <cstring>

#include <algorithm>

const int MAXN = 1 << 17;
const int MOD = 9901;

int N, H;
int vec[MAXN];
int sh[MAXN];

int idt[MAXN];

inline int lowest_bit (int i) {return i & -i;}
inline int mymod (int i) {return i >= MOD ? i - MOD : i;}

inline void add (int i, int val) {
	for (; i <= N; i += lowest_bit (i))
		idt[i] = mymod (idt[i] + val);
}

inline int _srch (int i) {
	static int ret;
	for (ret = 0; i; i -= lowest_bit (i))
		ret += idt[i];

	return ret % MOD;//hopefully works :))
}

inline int srch (int l, int r) {
	return mymod (_srch (r) - _srch (l-1) + MOD);
}

int bsrch (int x) {
	int l = 0, r = N, m;
	while (l + 1 < r) {
		m = (l + r) >> 1;
		if (x > sh[m])
			l = m;
		else
			r = m;
	}

	return r;
}

int main () {
	scanf ("%d %d", &N, &H);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d", vec + i);

	memcpy (sh+1, vec, sizeof (int) * N);
	std::sort (sh+1, sh+N+1);

	add (bsrch (vec[N-1]), 1);

	int l, r;
	for (i = N - 2; i >= 0; --i) {
		l = bsrch (vec[i] - H);
		r = bsrch (vec[i] + H);
		if (sh[r] > vec[i] + H) --r;
		add (bsrch (vec[i]), mymod (srch (l, r) + 1));
	}

	printf ("%d\n", mymod (srch (1, N) - N % MOD + MOD));

	return 0;
}
