/*
TASK: seq
LANG: C++

FROM: NOI 2002 k2
PROB: seq
KEYW: mathematics
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>

const int MAX = 1 << 16;

int a, b;

bool npr[MAX];
int pr[MAX], prc;
int pr2[MAX];

int S (int n) {
	int nn = n;

	int tmp;
	int res = 1;
	for (int i = 0; pr2[i] <= nn && n > 1; ++i) {
		tmp = pr[i];
		while (!(n % pr[i])) {
			n /= pr[i];
			tmp *= pr[i];
		}
		tmp = (tmp - 1) / (pr[i] - 1);
		res *= tmp;
	}
	if (n != 1) res *= (n + 1);
	return res - nn;
}

int doall (int a) {
	int nxt;
	int i;
	for (i = 0; a > 1; ++i) {
		nxt = S (a);
		if (nxt >= a) break;
		a = nxt;
	}

	return i + 1;
}

void eratosten () {
	int i, j;
	for (i = 2; i * i < MAX; ++i)
		if (!npr[i]) {
			pr[prc] = i; pr2[prc++] = i * i;
			for (j = i * i; j < MAX; j += i) npr[j] = 1;
		}
	for (; i < MAX; ++i) if (!npr[i]) {pr[prc] = i; pr2[prc++] = i * i;}

//	for (i = 0; i < prc; ++i) printf ("%d ", pr[i]); printf ("\n");
}

int main () {
	eratosten ();

	scanf ("%d %d", &a, &b);

	int max = -1, maxi = -1, tmp;
	for (int i = a; i <= b; ++i)
		if ((tmp = doall (i)) > max) {
			max = tmp;
			maxi = i;
		}

	assert (max != -1);
	printf ("%d %d\n", maxi, max);

	return 0;
}
