/*
TASK: crazy
LANG: C++

FROM: SPRING 2004 A
PROB: crazy
KEYW: acyclic game
*/

#include "crazy.h"

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <vector>
#include <utility>
#include <climits>

const int MAXN = 1 << 10;

bool opt[MAXN][MAXN];
int t[MAXN][MAXN];
std::pair <int, int> prev[MAXN][MAXN];
bool calced[MAXN][MAXN];

std::vector <int> pre[MAXN];

int gcd (int a, int b) {
	return a ? gcd (b % a, a) : b;
}

void precompute () {
	int i, j;
	for (i = 1; i < MAXN; ++i)
		for (j = 1; j < i; ++j)
			if (gcd (j, i) > 1)
				pre[i].push_back (j);
}

int cntr_rec;

int fopt (int a, int b) {
	assert (a <= b);
	if (pre[a].empty () && pre[b].empty () || t[a][b]) return opt[a][b];
	++cntr_rec;
	int la = -2, lb = -2, lt = INT_MAX;//best losing a, b, t
	int wa = -2, wb = -2, wt = -1;//best winning a, b, t

	unsigned i;
	int ta, tb;
	for (int k = 0; k < 2; ++k) {
		for (i = 0; i < pre[a].size (); ++i) {
			ta = pre[a][i] <? b + 1;
			tb = pre[a][i] >? b + 1;
			if (fopt (ta, tb)) {
				if (wt < t[ta][tb]) {
					wt = t[ta][tb];
					wa = ta;
					wb = tb;
				}
			} else {
				if (lt > t[ta][tb]) {
					lt = t[ta][tb];
					la = ta;
					lb = tb;
				}
			}
		}
		ta = a; a = b; b = ta;
	}

	if (lt != INT_MAX) {
		opt[a][b] = 1;//we win couse we have a path to a losing position
		t[a][b] = lt + 1;
		prev[a][b] = std::make_pair (la, lb);
	} else {
		assert (wt != -1);
		opt[a][b] = 0;//we lose couse we dont have a path to a losing position
		t[a][b] = wt + 1;
		prev[a][b] = std::make_pair (wa, wb);
	}

	return opt[a][b];
}

int main () {
	precompute ();

	int a, b;
	int ra, rb;
	for (;;) {
		getnum ((long*)&a, (long*)&b);
		ra = a; rb = b;
		if (a > b) {a = b; b = ra;}//swap
		fopt (a, b);

		if (prev[a][b].first == ra + 1 || prev[a][b].second == rb + 1)
			setnum ((long)prev[a][b].first, (long)prev[a][b].second);
		else
			setnum ((long)prev[a][b].second, (long)prev[a][b].first);
	}

	return 0;
}
