/*
FROM: SPRING 2004 A
PROB: crazy
KEYW: game
*/

#include "crazy.h"

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <vector>
#include <utility>
#include <climits>

static const int MAXN = 1 << 10;

static bool opt[MAXN][MAXN];
static int t[MAXN][MAXN];
static std::pair <int, int> prev[MAXN][MAXN];

static std::vector <int> pre[MAXN];

static int gcd (int a, int b) {
	return a ? gcd (b % a, a) : b;
}

static void precompute () {
	int i, j;
	for (i = 4; i < MAXN; ++i)
		for (j = 2; j < i; ++j)
			if (gcd (j, i) != 1)
				pre[i].push_back (j);
}

static int fopt (int a, int b) {
	if (pre[a].empty () && pre[b].empty () || t[a][b]) return opt[a][b];
	int la = -1, lb =-1, lt = INT_MAX;//best losing a, b, t
	int wa = -1, wb =-1, wt = -1;//best winning a, b, t

	unsigned i;
	int ta, tb;
	for (int k = 0; k < 2; ++k) {
		for (i = 0; i < pre[a].size (); ++i) {
			ta = pre[a][i] <? b + 1;
			tb = pre[a][i] >? b + 1;
			if (fopt (ta, tb)) {
				if (wt < t[ta][tb]) {
					wt = t[ta][tb];
					wa = ta;
					wb = tb;
				}
			} else {
				if (lt > t[ta][tb]) {
					lt = t[ta][tb];
					la = ta;
					lb = tb;
				}
			}
		}
		a ^= b ^= a ^= b;//swap 2 times so at the end it is normal
	}

	if (lt < INT_MAX) {
		opt[a][b] = 1;//we win couse we have a path to a losing position
		t[a][b] = lt + 1;
		prev[a][b] = std::make_pair (la, lb);
	} else {
		assert (wt != -1);
		opt[a][b] = 0;//we lose couse we dont have a path to a losing position
		t[a][b] = wt + 1;
		prev[a][b] = std::make_pair (wa, wb);
	}

	return opt[a][b];
}

static std::pair <int, int> ready;

static int cntr;

void getnum (int *a, int *b) {
	static int first = 1;
	if (first) {
		precompute ();
		FILE *in = fopen ("crazy.in", "r");
		fscanf (in, "%d %d", a, b);
		first = 0;
		return;
	}
	++cntr;

	*a = ready.first;
	*b = ready.second;
}

extern int cntr_rec;

void setnum (int a, int b) {
	++cntr;
	static int ra, rb;
	ra = a; rb = b;
	if (a > b) a ^= b ^= a ^= b;//swap
	fopt (a, b);
	if (t[a][b] == 0) {printf ("%d\n", cntr); exit (0);}
	if (prev[a][b].second == rb + 1 || prev[a][b].first == ra + 1)
		ready = std::make_pair (prev[a][b].first, prev[a][b].second);
	else
		ready = std::make_pair (prev[a][b].second, prev[a][b].first);
}

/*
int main () {
	precompute ();

	int a, b;
	int ra, rb;
	for (;;) {
		getnum (&a, &b);
		ra = a; rb = b;
		if (a > b) a ^= b ^= a ^= b;//swap
		fopt (a, b);
//		printf ("(%d)", t[a][b]);
		if (prev[a][b].second == rb + 1 || prev[a][b].first == ra + 1)
			setnum (prev[a][b].first, prev[a][b].second);
		else
			setnum (prev[a][b].second, prev[a][b].first);
	}

	return 0;
}
*/