/*
TASK: ioiwari
LANG: C++

FROM: IOI 2001 day 1
PROB: ioiwari
KEYW: acyclic game
*/

#include "ioiwari.h"

#include <cstdio>
#include <cstring>

const int B = 7;
const int MAXCODE = 1 << 23;//it is 6 000 000
const int NOT_CALCED = -10;

char opt[MAXCODE];
int prev[MAXCODE];

int coef[B+1];
int code (int *v) {
	static int i, ret;
	for (i = 0, ret = 0; i <= B; ++i) ret += v[i] * coef[i];
	return ret;
}

void decode (int c, int *v) {
	for (int i = B; i >= 0; --i) {v[i] = c / coef[i]; c %= coef[i];}
}

int mymod (int a) {return a >= B ? a - B : a;}

int doit (int *v1, int m, int *v2) {
	int i;
	int inhand = v1[m];
	int mybank = v1[B];
	for (i = 0, v2[B] = 0; i < B; ++i) v2[B] += (v2[i] = v1[i]);
	v2[B] = 20 - mybank - v2[B];
	v2[m] = 0;//in hand

	for (i = mymod (m + 1); inhand; i = mymod (i + 1)) {
		if (inhand == 1) {
			if (v2[i] == 0 || v2[i] == 5) {
				--inhand;
				++v2[B];//the opponents bank
			} else {
				mybank += 1 + v2[i];
				--inhand;
				v2[i] = 0;//move all to my hand
			}
		} else {
			if (v2[i] == 5) {
				++mybank;
				--v2[i];//take it for my bank
			} else {
				--inhand;
				++v2[i];//put one from my hand
			}
		}
	}

	return mybank;
}

int f (int id) {
	if (opt[id] != NOT_CALCED) return opt[id];
	int beads[B+1], _new[B+1];
	int i, _newid;
	int myhand;

	decode (id, beads);
	for (i = 0; i < B && !beads[i]; ++i);
	if (i == B) return prev[id] = -1, opt[id] = beads[B];

	for (; i < B; ++i) {
		if (!beads[i]) continue;
		myhand = doit (beads, i, _new);
		_newid = code (_new);
		f (_newid);
		if (opt[id] < 20 - opt[_newid]) {//get more
			opt[id] = 20 - opt[_newid];
			prev[id] = i;
		}
	}

	return opt[id];
}

int main () {
	freopen ("ioiwari.in", "r", stdin);
	int i;
	coef[0] = 1;
	for (i = 1; i <= B; ++i) coef[i] = coef[i-1] * 6;

	for (i = 0; i < MAXCODE; ++i) opt[i] = NOT_CALCED;

	int beads[B+1] = {0}, _new[B+1];
	for (i = 0; i < B; ++i) scanf ("%d", beads + i);
	int id = code (beads);
	f (id);

	domove (prev[id] + 1);
	doit (beads, prev[id], _new); memcpy (beads, _new, sizeof (_new));

	for (;;) {
		id = code (beads);
		int move = getmove ();
		doit (beads, move - 1, _new);

		id = code (_new);
		if (prev[id] == -1) return 0;//final

		domove (prev[id] + 1);
		doit (_new, prev[id], beads);
	}

	return 0;
}
