/*
TASK:score
LANG:C++

FROM: IOI 2001 day 2
PROB: score
KEYW: acyclic game
*/

#include "score.h"

#include <cstdio>
#include <cassert>
#include <climits>

const int MAXN = 1 << 10;

int N;
int ma3x[MAXN][MAXN];

bool own[MAXN];
bool ref[MAXN];
int val[MAXN];

int opt[MAXN];
int prev[MAXN];

int row[MAXN], rp;

bool used[MAXN];
void topsort (int a) {
	used[a] = 1;
	for (int i = 0; i <= N; ++i)
		if (ma3x[a][i] && !used[i])
			topsort (i);

	row[rp++] = a;
}

int main () {
	FILE *in = fopen ("score.in", "r");
//	FILE *in = stdin;

	fscanf (in, "%d", &N);

	int i, j;
	int tmp;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			fscanf (in, "%d", &tmp);
			ma3x[i][j] = tmp;
		}

	for (i = 1; i < N; ++i)
		if (ma3x[i][0]) {
			ma3x[i][0] = 0;
			ma3x[i][N] = 1;
		}

	for (i = 0; i < N; ++i) {
		fscanf (in, "%d", &tmp);
		own[i] = tmp == 2;
	}

	for (i = 0; i < N; ++i) {
		fscanf (in, "%d", &tmp);
		val[i] = tmp;
		ref[tmp] = own[i];
	}
	if (in != stdin) fclose (in);
	//the last one (virtual) will be winning for us but with val 0 :(    :))

	topsort (0);
	assert (rp == N+1);

//	for (i = 0; i < rp; ++i) printf ("%d ", row[i]); printf ("\n");

	int bw, bl;
	int pw = -1, pl = -1;

	for (i = 1; i < rp; ++i) {
		bw = -1; pw = -1;
		bl = INT_MAX; pl = -1;
		for (j = 0; j <= N; ++j) {
			if (!ma3x[row[i]][j]) continue;

			if (ref[opt[j]] == own[row[i]]) {
				if (bw < opt[j]) {
					bw = opt[j];
					pw = j;
				}
			} else {
				if (bl > opt[j]) {
					bl = opt[j];
					pl = j;
				}
			}
		}
		if (bw != -1) {
			if (val[row[i]] > bw) bw = val[row[i]];
			opt[row[i]] = bw;
			prev[row[i]] = pw;
		} else {
			assert (bl != INT_MAX);
			if (val[row[i]] > bl) bl = val[row[i]];
			opt[row[i]] = bl;
			prev[row[i]] = pl;
		}
	}

	int cplace = 0;
	int score[2] = {0};

	for (;;) {
		if (!cplace && (score[0] || score[1])) {printf ("end - %d %d\n", score[0], score[1]); return 0;}

		score[own[cplace]] >?= val[cplace];
		if (own[cplace])
			cplace = getpos () - 1;
		else
			setpos ((cplace = prev[cplace] % N) + 1);
	}

	return 0;
}
