/*
TASK: libconq
LANG: C++

FROM: CEOI 2002 day 1
PROB: conquer
KEYW: strategy game
*/

#include "libconq.h"

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 11;
const int BORDER = 1000000001;

int N;
int _vec1[MAXN*4];
int _vec2[MAXN*4];
int *vec1 = _vec1, *vec2 = _vec2;

void lose () {
	int i;
	for (i = 1; i <= N; ++i)
		if (vec1[i]) {
			vec2[i] = 1;
			--vec1[i];
		}
}

int main () {
	int i;
	start (&N, vec1);
/*
	int needed = 1;
	for (i = 1; i <= N; ++i) {
		if (needed <= vec1[i]) {
			break;
		} else
			needed -= vec1[i];
		needed *= 2;
	}
	if (i == N + 1) lose ();
*/
	int diff;
	int tmp;
	for (;;) {
		diff = 0;
//		printf ("now!!\n");
//		for (i = 1; i <= N; ++i) printf ("%d ", vec1[i]); printf ("\n");
		if (vec1[1]) return 0;
		vec2[1] = 0;
		for (i = 2; i <= N; ++i) {//start from 2 because there is nothing at 1
			diff <<= 1;
			if (diff > BORDER) break;//we shouldn't take any more
			if (diff <= vec1[i]) {
				tmp = vec1[i] - diff;
				diff = tmp % 2;
				vec2[i] = tmp / 2 + tmp % 2;
			} else {
				diff -= vec1[i];
				vec2[i] = 0;//take nothing
			}
			vec1[i] = vec1[i] - vec2[i];//the rest
//			printf ("%d -- %d %d(%d)\n", i, vec1[i], vec2[i], diff);
		}
		for (; i <= N; ++i) vec2[i] = 0;
//		for (i = 1; i <= N; ++i) printf ("(%d %d) ", vec1[i], vec2[i]); printf ("\n");
		if (step (vec2) == 1) std::swap (vec1, vec2);//this should stay => vec1 -> vec2
		++vec1; ++vec2;
	}

	return 0;
}
