/*
TASK: libconq
LANG: C++

FROM: CEOI 2002 day 1
PROB: conquer
KEYW: strategy game
*/

#include "libconq.h"

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 11;
const int BORDER = 1000000001;

int N;
int _vec1[MAXN*4];
int _vec2[MAXN*4];
int *vec1 = _vec1, *vec2 = _vec2;

int main () {
	start (&N, vec1);

	int i;
	for (;;) {
		int needed = 1;
		vec1[1] = vec2[1] = 0;
//		for (i = 1; i <= N; ++i) printf ("(%d -- %d %d) ", i, vec1[i], vec2[i]); printf ("\n");
		for (i = 2; i <= N && needed; ++i) {
			if (needed > BORDER) break;//nothing can help us
			if (needed >= vec1[i]) {
				vec2[i] = vec1[i];
				vec1[i] = 0;
				needed -= vec2[i];
			} else {
				vec2[i] = needed;
				vec1[i] -= needed;
				needed = 0;
			}
			needed *= 2;
		}

//		if (vec1[1] || vec2[1]) printf ("!!\n");
//		for (i = 1; i <= N; ++i) printf ("(%d -- %d %d) ", i, vec1[i], vec2[i]); printf ("\n");
		if (step (vec1) == 2) std::swap (vec1, vec2);
		++vec1; ++vec2;
	}

	return 0;
}
