/*
TASK: hgame
LANG: C++

FROM: Ivan Anev
PROB: hgame
KEYW: nim, sum of games, sg theory
*/

#include "hgame.h"

#include <cstdio>
#include <vector>
#include <cassert>

const int MAXP = 1 << 7;
const int MAXN = 1 << 7;

int P;
std::vector <int> ptr[MAXP];

int N;
char line[MAXN];
int sg[MAXN];
int go[MAXN][MAXN << 1];

inline int highest_bit (int a) {while (a & a - 1) a &= a - 1; return a;}

void input () {
	FILE *in = fopen ("hgame.in", "r");

	fscanf (in, "%d\n", &P);

	char _line[MAXP];
	int i, j;
	for (i = 0; i < P; ++i) {
		fgets (_line, MAXP, in);
		assert (_line[0] == '1');

		for (j = 0; _line[j] != '\n'; ++j) if (_line[j] == '1') ptr[i].push_back (j);
	}

	fclose (in);
}

void compute_sg () {
	sg[N] = 0;//the final position

	int i, j, k;
	for (i = N - 1; i >= 0; --i) {
		for (j = 0; j < P; ++j) {
			int cs = 0;
			for (k = 0; k < (int)ptr[j].size () && i + ptr[j][k] < N; ++k)
				cs ^= sg[ptr[j][k] + i];

			go[i][cs] = j + 1;//no problem if assigning 2 times to 1 place
		}

		for (j = 0; go[i][j]; ++j);
		sg[i] = j;
	}
}

int calc_sg () {
	static int i, res;
	for (i = res = 0; i < N; ++i) if (line[i] == 'H') res ^= sg[i];
	return res;
}

void apply_pattern (int st, int j) {
	for (int i = 0; i < (int)ptr[j].size () && st + ptr[j][i]< N; ++i)
		line[st + ptr[j][i]] = 'H' + 'T' - line[st + ptr[j][i]];
}

int main () {
	input ();

	get (line);
	N = strlen (line);
	compute_sg ();
/*
	int i, j;
	for (i = 0; i < N; ++i) {
		printf ("%d -- %d\n", i, sg[i]);

		for (j = 0; j < sg[i]; ++j) printf ("\t%d - %d\n", j, go[i][j]);
	}
*/
	for (;;) {
		int csg = calc_sg ();
		int hb_csg = highest_bit (csg);
//		printf (">>%d %d\n", csg, hb_csg);
		for (int i = 0; i < N; ++i)
			if (line[i] == 'H' && sg[i] & hb_csg) {
				int needed = sg[i] ^ csg;
//				printf (">>%d -- %d\n", i, go[i][needed]);
				apply_pattern (i, go[i][needed]-1);
				break;
			}
//		printf ("*%s*\n", line);
		//printf ("NOT MINE!\n");
		set (line);
		get (line);
		//printf ("MINE!\n");
//		printf ("got *%s*\n", line);
	}

	return 0;
}
