/*
TASK: hgame
LANG: C++

FROM: Ivan Anev
PROB: hgame
KEYW: nim, sum of games, sg theory
*/

#include "hgame.h"

#include <cstdio>
#include <vector>
#include <ctime>
#include <cstdlib>

static const int MAXP = 1 << 7;
static const int MAXN = 1 << 7;

static int P;
static std::vector <int> ptr[MAXP];

static int N;
static char line[MAXN];
static int sg[MAXN];
static int go[MAXN][MAXN << 1];

static inline int highest_bit (int a) {while (a & a - 1) a &= a - 1; return a;}


static void compute_sg ();
static void input () {
	FILE *in = fopen ("hgame.in", "r");

	fscanf (in, "%d\n", &P);

	char _line[MAXP];
	int i, j;
	for (i = 0; i < P; ++i) {
		fgets (_line, MAXP, in);
		assert (_line[0] == '1');

		for (j = 0; _line[j] != '\n'; ++j) if (_line[j] == '1') ptr[i].push_back (j);
	}

	fgets (line, MAXN, in);
	N = strlen (line);
	line[--N] = 0;
	compute_sg ();

	fclose (in);
}

static void compute_sg () {
	sg[N] = 0;//the final position

	int i, j, k;
	for (i = N - 1; i >= 0; --i) {
		for (j = 0; j < P; ++j) {
			int cs = 0;
			for (k = 0; k < (int)ptr[j].size () && i + ptr[j][k] < N; ++k)
				cs ^= sg[ptr[j][k] + i];

			go[i][cs] = j + 1;//no problem if assigning 2 times to 1 place
		}

		for (j = 0; go[i][j]; ++j);
		sg[i] = j;
	}
}

static int calc_sg (const char *_line) {
	static int i, res;
	for (i = res = 0; i < N; ++i) if (_line[i] == 'H') res ^= sg[i];
	return res;
}

static void apply_pattern (const char *_line, int st, int j) {
//	printf ("ap -- %d %d\n", st, j);  fflush (stdout);
//	printf ("ap\n");
	strcpy (line, _line);
//	printf ("asc!\n");  fflush (stdout);
	for (int i = 0; i < (int)ptr[j].size () && st + ptr[j][i]< N; ++i)
		line[st + ptr[j][i]] = 'H' + 'T' - _line[st + ptr[j][i]];
//	printf ("/ap\n");
//	printf ("--%s -- %s\n", line, _line);
}

static bool check_end (const char *_line) {
//	printf ("in ce1\n");
	static int i;
	for (i = 0; i < N && _line[i] == 'T'; ++i);
//	printf ("out ce1\n");
	return i == N;
}

static void check_correct (const char *_line) {
	static std::vector <int> tmp;
	static int i, j, k;
	for (i = 0; i < N; ++i)
		if (_line[i] != 'T' && _line[i] != 'H') {printf ("0\nunrecognised character \'%c\'\n", _line[i]); exit (0);}

	for (i = 0; i < N && _line[i] == line[i]; ++i);
	if (i == N) {printf ("0\nString not changed!\n"); exit (0);}
	if (_line[i] == 'H') {printf ("0\nApplying pattern starting with \'T\'\n%s\n%s", line, _line); exit (0);}

	tmp.clear (); tmp.push_back (0);
	int st = i;
	for (++i; i < N; ++i)
		if (_line[i] != line[i]) tmp.push_back (i - st);

	i = st;
	for (j = 0; j < P; ++j) {
		for (k = 0; k < (int)ptr[j].size () && k < (int)tmp.size () && i + ptr[j][k] < N && ptr[j][k] == tmp[k]; ++k);

		if (k == (int)ptr[j].size () || i + ptr[j][k] >= N) return;//everything is ok
	}

	printf ("0\nInvalid Move!\n"); exit (0);
}

void get (char *_line) {
	static int first = 1;
	if (first) {
		input ();
		strcpy (_line, line);
		first = 0;
		srand (time (0));
		return;
	}
	strcpy (_line, line);
//	printf ("in get - ret %s\n", _line);
}

void set (const char *_line) {
//	printf ("in set       %s\n", _line);
	if (check_end (_line)) {printf ("10\nYou Win!\n"); exit (0);}
	check_correct (_line);

	int csg = calc_sg (_line);
	if (csg) {
		int hb_csg = highest_bit (csg);
		printf ("here!\n");
		for (int i = 0; i < N; ++i)
			if (_line[i] == 'H' && sg[i] & hb_csg) {
				int needed = sg[i] ^ csg;
				apply_pattern (_line, i, go[i][needed]-1);//applys onto line
				break;
			}

//		printf ("mw!\n");
		if (check_end (line)) {printf ("0\nModule Wins!\n"); exit (0);}
		return;
	}

//	printf ("P == %d\n", P);
	int j;
	for (int i = N-1; i >= 0; --i) {
		if (_line[i] == 'H') {
			if (sg[i] != 0) j = rand () % sg[i];
			else
				for (j = 1; !go[i][j]; ++j);
			apply_pattern (_line, i, go[i][j] - 1);
			return;
		}
	}
}
