/*
TASK:xor
LANG:C++

FROM: IOI 2002 day 1
PROB: xor
KEYW: constantly improving the situation
*/

#include <cstdio>
#include <vector>
#include <utility>

using std::make_pair;

const int MAXN = 1 << 11;

int N;
//bool _ma3x[MAXN][MAXN];
//bool ma3x[MAXN][MAXN];
std::vector <std::vector <bool> > _ma3x, ma3x;

std::vector <std::pair <std::pair <int, int>, std::pair <int, int> > > ans;

void Xor (int x1, int y1, int x2, int y2) {
	assert (ma3x[x1][y1]); ma3x[x1][y1] = 0;
	assert (ma3x[x2][y1]); ma3x[x2][y1] = 0;
	assert (ma3x[x1][y2]); ma3x[x1][y2] = 0;
	ma3x[x2][y2] = 1 - ma3x[x2][y2];
	ans.push_back (make_pair (make_pair (y1 + 1, y2), make_pair (x1 + 1, x2)));
/*
	for (int i = x1+1; i <= x2; ++i)
		for (int j = y1+1; j <= y2; ++j)
			_ma3x[i][j] = 1 - _ma3x[i][j];
*/
}

int main (int argc, char *argv[]) {
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "w");
//	FILE *in = stdin;
//	FILE *out = stdout;

	fscanf (in, "%d", &N);
	_ma3x.resize (N+5);
	ma3x.resize (N+5);

	int tmp;
	int i, j;
	for (i = 0; i < N+5; ++i) {
		_ma3x[i].resize (N+5);
		ma3x[i].resize (N+5);
	}

	for (i = 1; i <= N; ++i) {
		_ma3x[i].resize (N+2);
		for (j = 1; j <= N; ++j)
			fscanf (in, "%d", &tmp), _ma3x[i][j] = tmp;
	}

	fclose (in);

	for (i = 0; i <= N; ++i) {
		ma3x[i].resize (N+1);
		for (j = 0; j <= N; ++j)
			ma3x[i][j] = (_ma3x[i][j] + _ma3x[i][j+1] + _ma3x[i+1][j] + _ma3x[i+1][j+1]) & 1;
	}

	int ii, jj;
	for (;;) {
/*		for (i = 0; i <= N; ++i) {
			for (j = 0; j <= N; ++j)
				putchar (_ma3x[i][j] ? 'W' : '.');
			putchar ('\n');
		}*/

		for (i = 0; i <= N; ++i)
			for (j = 0; j <= N; ++j)
				if (ma3x[i][j]) goto nxt;
		break;
		nxt:;
//		printf ("beg! %d %d\n", i, j);
		for (ii = i + 1; ii <= N && !ma3x[ii][j]; ++ii); //printf ("%d %d\n", ii, j), getchar (); printf ("--\n");
		for (jj = j + 1; jj <= N && !ma3x[i][jj]; ++jj); //printf ("%d %d\n", i, jj), getchar (); printf ("--\n");
		assert (ii <= N && jj <= N);
//		if (ii > N || j > N) return 0;
		Xor (i, j, ii, jj);
//		printf ("%d %d %d %d\n\n", i, j, ii, jj);
	}

	fprintf (out, "%u\n", ans.size ());
	for (i = 0; i < (int)ans.size (); ++i)
		fprintf (out, "%d %d %d %d\n", ans[i].first.first, ans[i].first.second, ans[i].second.first, ans[i].second.second);

	return 0;
}
