/*
FROM: IOI 2002 day 1
PROB: xor
NOTE: checker
*/

#include <cstdio>
#include <vector>
#include <utility>

using std::make_pair;

const int MAXN = 1 << 11;

int N;
std::vector <std::vector <bool> > _ma3x, ma3x;

std::vector <std::pair <std::pair <int, int>, std::pair <int, int> > > ans;

void Xor (int x1, int y1, int x2, int y2) {
	if (x1 < 0 || x1 > N
	 || x2 < 0 || x2 > N
	 || y1 < 0 || y1 > N
	 || y2 < 0 || y2 > N)
		{printf ("0\nInvalid Rectangle:%d %d %d %d\n", y1 + 1, y2, x1 + 1, x2); exit (0);}

	ma3x[x1][y1] = 1 - ma3x[x1][y1];
	ma3x[x2][y1] = 1 - ma3x[x2][y1];
	ma3x[x1][y2] = 1 - ma3x[x1][y2];
	ma3x[x2][y2] = 1 - ma3x[x2][y2];
}

int main (int argc, char *argv[]) {
	if (argc != 3) {printf ("Error with argc!\n"); exit (-1);}
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
//	FILE *in = stdin;
//	FILE *out = stdout;

	fscanf (in, "%d", &N);
	_ma3x.resize (N+5);
	ma3x.resize (N+5);

	int tmp;
	int i, j = -1;
	for (i = 0; i < N+5; ++i) {
		_ma3x[i].resize (N+5);
		ma3x[i].resize (N+5);
	}

	for (i = 1; i <= N; ++i) {
		_ma3x[i].resize (N+2);
		for (j = 1; j <= N; ++j)
			fscanf (in, "%d", &tmp), _ma3x[i][j] = tmp;
	}

	fclose (in);

	for (i = 0; i <= N; ++i) {
		ma3x[i].resize (N+1);
		for (j = 0; j <= N; ++j)
			ma3x[i][j] = (_ma3x[i][j] + _ma3x[i][j+1] + _ma3x[i+1][j] + _ma3x[i+1][j+1]) & 1;
	}

	int C;
	fscanf (out, "#FILE xor %*d");
	fscanf (out, "%d", &C);

	int x1, y1, x2, y2;
	for (i = 0; i < C; ++i) {
		fscanf (out, "%d %d %d %d", &y1, &y2, &x1, &x2);
		--y1; --x1;
		Xor (x1, y1, x2, y2);
	}
	for (i = 0; i <= N; ++i)
		for (j = 0; j <= N; ++j)
			if (ma3x[i][j]) goto nxt;

	nxt:;
	if (j != N + 1) {printf ("0\nShape is Different\n"); exit (0);}
	printf ("10\nCorrect! -- %d xors\n", C);

	return 0;
}
