/*
TASK: 3dlab
LANG: C++

FROM: NOI 2004 k2
PROB: lab
KEYW: graph expansion with memory optimizations, bfs, 3D labirint
*/

#include <cstdio>
#include <cassert>

const int MAXN = 40;//short in memory
const int MAXCC = 55;
const int COLC = 10;//colour count

const int MAXS = MAXN * MAXN * MAXN * MAXCC;

const int dx[] = {-1,  0,  0, 1, 0, 0};
const int dy[] = { 0, -1,  0, 0, 1, 0};
const int dz[] = { 0,  0, -1, 0, 0, 1};

int N;
char map[MAXN][MAXN][MAXN];
char tr[MAXN][MAXN][MAXN];

char dec_col[MAXCC][2];
int code_col[COLC][COLC];

int Sx, Sy, Sz, Sc1, Sc2;
int Fx, Fy, Fz;

int _tr[5];

int code (int x, int y, int z, int c1, int c2) {
	return x + y * _tr[1] + z * _tr[2] + code_col[c1][c2] * _tr[3];
}

void decode (int c, int &x, int &y, int &z, int &c1, int &c2) {
	c1 = dec_col[c / _tr[3]][0];
	c2 = dec_col[c / _tr[3]][1]; c %= _tr[3];
	z = c / _tr[2]; c %= _tr[2];
	y = c / _tr[1]; c %= _tr[1];
	x = c;
}

bool ok_pos (int x, int y, int z, int c1, int c2) {
	return
	(	x >= 0 && x < N
	 && y >= 0 && y < N
	 && z >= 0 && z < N
	 && (map[x][y][z] == c1
	 || map[x][y][z] == c2)
	);
}

int queue[MAXS], p3;
char prev[MAXS];
char ans[MAXS];

void bfs () {
	queue[p3++] = code (Sx, Sy, Sz, Sc1, Sc2); prev[queue[0]] = -2;//only this

	int i, k;
	int c = *queue, go;
	int x, y, z, c1, c2;
	int nx, ny, nz;
	for (i = 0; i < p3; ++i) {
		c = queue[i];

		decode (c, x, y, z, c1, c2);
//		printf ("%d %d %d  %d %d(%d)\n", x, y, z, c1, c2, i);
		if (x == Fx && y == Fy && z == Fz) break;

		///move
		for (k = 0; k < 6; ++k) {
			nx = x + dx[k];
			ny = y + dy[k];
			nz = z + dz[k];
			if (ok_pos (nx, ny, nz, c1, c2) && prev[go = code (nx, ny, nz, c1, c2)] == -1) {
//				printf ("push %d %d %d  %d %d(%d %c)pl %d\n", nx, ny, nz, c1, c2, k, k + 'U', p3);
				queue[p3++] = go;
				prev[go] = k + 'U';
			}
		}

		///change color
		if (tr[x][y][z] >= 10) continue;
		if (tr[x][y][z] != c1) {
//			printf ("NOW COL %d %d --> change c1 with %d\n", c1, c2, tr[x][y][z]);
			go = code (x, y, z, tr[x][y][z], c2);
			if (prev[go] == -1) {
//				printf ("psuh %d %d %d  >%c< %c(%d)\n", x, y, z, tr[x][y][z] + 'A', c2 + 'A', code_col[c1][c2]);
				queue[p3++] = go;
				prev[go] = code_col[c1][c2];
			}
		}
		if (tr[x][y][z] != c2) {
//			printf ("NOW COL %d %d --> change c2 with %d\n", c1, c2, tr[x][y][z]);
			go = code (x, y, z, c1, tr[x][y][z]);
			if (prev[go] == -1) {
//				printf ("psuh %d %d %d  %c >%c<(%d)\n", x, y, z, c1 + 'A', tr[x][y][z] + 'A', code_col[c1][c2]);
				queue[p3++] = go;
				prev[go] = code_col[c1][c2];
			}
		}
	}
	assert (i != p3);

	int _c1, _c2;
	i = 0;
	while (prev[c] != -2) {
		decode (c, x, y, z, c1, c2);
		if (prev[c] > 'A') {
			ans[i++] = prev[c];
			c = code (x - dx[prev[c]-'U'], y - dy[prev[c]-'U'], z - dz[prev[c]-'U'], c1, c2);
		} else {
			_c1 = dec_col[(int)prev[c]][0];
			_c2 = dec_col[(int)prev[c]][1];
			if (_c1 == c1 || _c1 == c2)
				ans[i++] = _c2 + 'A';
			else
				ans[i++] = _c1 + 'A';
			c = code (x, y, z, _c1, _c2);
		}
	}

	printf ("%d\n", i);
	for (--i; i >= 0; --i) putchar (ans[i]); putchar ('\n');
}

int main () {
	scanf ("%d %d %d %d %d %d %d\n", &N, &Sx, &Sy, &Sz, &Fx, &Fy, &Fz);
	--Sx; --Sy; --Sz; --Fx; --Fy; --Fz;
	Sc1 = getchar () - 'A';
	Sc2 = getchar () - 'A';
	getchar ();

	int x, y, z;
	for (z = 0; z < N; ++z) {
		for (x = 0; x < N; ++x) {
			for (y = 0; y < N; ++y) {
				map[x][y][z] = getchar () - 'A';
//				printf ("got %c\n", map[x][y][z] + 'A');
			}
			getchar ();
		}
//		getchar ();
	}
/*
	for (x = 0; x < N; ++x) {
		for (y = 0; y < N; ++y) {
			for (z = 0; z < N; ++z)
				printf ("%c", map[x][y][z] + 'A');
			printf ("\n");
		}
		printf ("\n");
	}
*/
	for (z = 0; z < N; ++z) {
		for (x = 0; x < N; ++x) {
			for (y = 0; y < N; ++y)
				tr[x][y][z] = getchar () - 'A';
			getchar ();
		}
//		getchar ();
	}

/*	printf ("\n");
	for (x = 0; x < N; ++x) {
		for (y = 0; y < N; ++y) {
			for (z = 0; z < N; ++z)
				printf ("%c", tr[x][y][z] + 'A');
			printf ("\n");
		}
		printf ("\n");
	}
*/
	z = 0;
	for (x = 0; x < 10; ++x)
		for (y = x; y < 10; ++y) {
			dec_col[z][0] = x;
			dec_col[z][1] = y;
			code_col[x][y] = code_col[y][x] = z++;
		}
/*
	for (int i = 0; i < 55; ++i)
		printf ("%d %c %c\n", i, dec_col[i][0] + 'A', dec_col[i][1] + 'A');
	for (int i = 0; i < 10; ++i)
		for (int j = 0; j < 10; ++j)
			printf ("%c %c -- %d\n", i + 'A', j + 'A', code_col[i][j]);
*/
	_tr[0] = 1;
	for (x = 1; x < 4; ++x)
		_tr[x] = _tr[x-1] * N;
	_tr[4] = _tr[3] * MAXCC;

	for (x = 0; x < _tr[4]; ++x) prev[x] = -1;//free, not in queue

/*	int cd = code (Sx, Sy, Sz, Sc1, Sc2);
	int t1, t2, t3, t4, t5;
	decode (cd, t1, t2, t3, t4, t5);
	printf ("%d %d %d  %d %d\n", t1, t2, t3, t4, t5);
*/
	bfs ();

	return 0;
}
