/*
TASK: bic
LANG: C++

FROM: BaOI 2002 day 2
PROB: bic
KEYW: graph expansion with optimizations, dijkstra with stl heap
*/

#include <cstdio>
#include <climits>

#include <queue>

struct el {
	int to;
	int c;
	int t;
	int next;
	el () {}
	el (int _to, int _c, int _t, int _next) : to (_to), c (_c), t (_t), next (_next) {}
};

struct heap {
	int to;
	int c;
	int t;
	heap () {}
	heap (int _to, int _c, int _t) : to (_to), c (_c), t (_t) {}
	bool operator < (const heap &a) const {return t != a.t ? t > a.t : c > a.c;}//inverted
};

const int MAXN = 1 << 7;//100
const int MAXM = 1 << 9;//300

int N, M, S, F;
int vec[MAXN];
el buf[MAXM * 2];

int cnt;
std::priority_queue <heap> h;

int bestC[MAXN];

void dijkstra () {
	h.push (heap (S, 0, 0));

	heap crnt;
	while (!h.empty ()) {
		crnt = h.top (); h.pop ();

		if (crnt.c >= bestC[crnt.to]) continue;
		bestC[crnt.to] = crnt.c;
		if (crnt.to == F) {++cnt; continue;}//no more (:

		for (int i = vec[crnt.to]; i != -1; i = buf[i].next)
			if (crnt.c + buf[i].c < bestC[buf[i].to])
				h.push (heap (buf[i].to, crnt.c + buf[i].c, crnt.t + buf[i].t));
	}
}

int main () {
	scanf ("%d %d %d %d", &N, &M, &S, &F);
	--S; --F;

	int i;
	int a, b, c, d;
	int bp = 0;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d %d", &a, &b, &c, &d);
		--a; --b;

		buf[bp] = el (b, c, d, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, c, d, vec[b]);
		vec[b] = bp++;
	}

	for (i = 0; i < N; ++i) bestC[i] = INT_MAX;
	dijkstra ();

	printf ("%d\n", cnt);
}
