/*
TASK: lab
LANG: C++

FROM: NOI 2001 k2
PROB: lab
KEYW: graph expansion, bfs, 2 queues
*/

#include <cstdio>
#include <cassert>
#include <cctype>
#include <queue>
#include <string>
#include <algorithm>

const int MAXN = 1 << 5;
const int MAXS = 1 << 20;

const int dx[] = {0, 1, 0, -1};
const int dy[] = {1, 0, -1, 0};

int N, M;
bool map[MAXN+1][MAXN+1];//very ugly :)
int spos;//starting position
int Tx, Ty;

int code (int sx, int sy, int bx, int by) {
	return sx << 15 | sy << 10 | bx << 5 | by;
}

void decode (int id, int &sx, int &sy, int &bx, int &by) {
	by = id & 31; id >>= 5; bx = id & 31; id >>= 5;
	sy = id & 31; id >>= 5; sx = id;
}

//BEGIN queue stuff
std::queue <int> q1, q2;

inline bool empty () {return q1.empty () && q2.empty ();}
inline void push1 (int s) {q1.push (s);}
inline void push2 (int s) {q2.push (s);}
inline int pop () {int ret; if (q1.empty ()) {ret = q2.front (); q2.pop ();} else {ret = q1.front (); q1.pop ();} return ret;}

//END queue stuff

char itoc[] = {'r', 'd', 'l', 'u'};//save 1 byte
int ctoi (char x) {switch (x) {case 'r': return 0; case 'd': return 1; case 'l': return 2; case 'u': return 3; default: return -1;}}

char prev[MAXS];

int moveback (int cs) {
	static int sx, sy, bx, by, k;
	decode (cs, sx, sy, bx, by);
//	printf ("in mb %d %d %d %d\n", sx, sy, bx, by);
	k = ctoi (tolower (prev[cs]));
	sx -= dx[k]; sy -= dy[k];
	if (isupper (prev[cs])) {bx -= dx[k]; by -= dy[k];}
//	printf ("out mb %d %d %d %d\n", sx, sy, bx, by);
	return code (sx, sy, bx, by);
}

void bfs () {
	push1 (spos); prev[spos] = -1;

	int k;
	int c, go;
	int sx, sy, bx, by;
	int nx, ny;
	while (!empty ()) {
		c = pop ();

		decode (c, sx, sy, bx, by);
//		printf ("%d %d  %d %d(%u)\n", sx, sy, bx, by, q1.size () + q2.size ());
		if (bx == Tx && by == Ty) goto ok;
		for (k = 0; k < 4; ++k) {
			nx = sx + dx[k];
			ny = sy + dy[k];
			if (!map[nx][ny]) continue;//go onto wall

			if (!map[nx][ny]) continue;//the box cannot go onto a wall
			if (nx == bx && ny == by) {//push the box
				nx += dx[k];
				ny += dy[k];
				go = code (bx, by, nx, ny);
				if (!prev[go]) {
//					printf ("push2 %d %d %d %d\n", bx, by, nx, ny);
					push2 (go);
					prev[go] = toupper (itoc[k]);
				}
			} else if (!prev[go = code (nx, ny, bx, by)]) {
//				printf ("push1 %d %d %d %d\n", nx, ny, bx, by);
				push1 (go);
				prev[go] = itoc[k];
			}
		}
	}

	printf ("Impossible.\n"); return;

	ok:;
	std::string ans;
	int t1, t2, t3, t4;
	for (; c != spos; c = moveback (c)) {
		decode (c, t1, t2, t3, t4);
//		printf ("-->%d %d %d %d(%d %d)\n", t1, t2, t3, t4, c, prev[c]);
		ans.push_back (prev[c]);
	}

	std::reverse (ans.begin (), ans.end ());
	printf ("%s\n", ans.c_str ());
}

int main () {
	scanf ("%d %d\n", &N, &M);

	int i, j;
	char tmp;
	int sx (0), sy (0), bx (0), by (0);
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= M; ++j) {
			scanf ("%c", &tmp);
			map[i][j] = tmp != '#';//can be passed -> 1
			if (tmp == 'S') {sx = i; sy = j;}
			if (tmp == 'B') {bx = i; by = j;}
			if (tmp == 'T') {Tx = i; Ty = j;}
		}
		scanf ("\n");
	}
	assert (sx && bx && Tx);
/*
	for (i = 0; i <= N+1; ++i) {
		for (j = 0; j <= M+1; ++j)
			putchar (map[i][j] ? '.' : '#');
		putchar ('\n');
	}
*/
	//	printf ("%d %d %d %d %d %d\n", sx, sy, bx, by, Tx, Ty);

	spos = code (sx, sy, bx, by);
/*	int t1, t2, t3, t4;
	decode (spos, t1, t2, t3, t4);
	printf ("%d %d %d %d--\n", t1, t2, t3, t4);
*/	bfs ();

	return 0;
}
