/*
TASK: robots
LANG: C++

FROM: IOI 2003 day 2
PROB: robots
KEYW: graph expansion, bfs, coding
*/

#include <cstdio>
#include <cassert>

#include <vector>

const int MAXN = 1 << 5;
const int MAXG = 1 << 4;
const int MAXT = 1 << 4;
const int MAXS = 2116800;
struct pos {
	int x, y;
	pos () {}
	pos (int _x, int _y) : x (_x), y (_y) {}
	pos (const pos &a) : x (a.x), y (a.y) {}
	pos& operator += (const pos &a) {x += a.x; y += a.y; return *this;}
	pos operator + (const pos &a) const {pos ret(*this); return ret += a;}
	pos operator * (int a) const {return pos (x * a, y * a);}
	bool operator == (const pos &a) const {return x == a.x && y == a.y;}
};

const pos dif[] = {pos (0,1), pos (1,0), pos (0,-1), pos (-1,0)};

int dim[2][2];
bool map[2][MAXN][MAXN];

int gc[2];//guard count
pos gpl[2][MAXG][MAXT];
pos st[2];//starting positions

int ctoi (char d) {switch (d) {case 'E': return 0; case 'S': return 1; case 'W': return 2; case 'N': return 3; default: return 100;}}

void fill_gpl (int m, int g, pos sp, int d, int k) {
//	printf ("fg %d %d  %d %d  %d %d\n", m, g, sp.x, sp.y, d, k);
	gpl[m][g][0] = sp;
	int i;
	for (i = 1; i < d; ++i)
		gpl[m][g][i] = sp + dif[k] * i;
	int tmp = 2 * (d - 1);
	for (; i < tmp; ++i)
		gpl[m][g][i] = gpl[m][g][tmp-i];
	for (; i <= 12; ++i)
		gpl[m][g][i] = gpl[m][g][i-tmp];

//	printf ("%d %d %d %d: ", sp.x, sp.y, d, k);
//	for (i = 0; i <= 12; ++i) printf ("(%d %d) ", gpl[m][g][i].x, gpl[m][g][i].y); printf ("\n");
}

int _coef[] = {1, 21, 420, 8820, 176400, 2116800};
int code (const pos &a, const pos &b, int t) {
	return a.x + a.y * _coef[1] + b.x * _coef[2] + b.y * _coef[3] + t * _coef[4];
}

void decode (int id, pos &a, pos &b, int &t) {
	t = id / _coef[4]; id %= _coef[4];
	b.y = id / _coef[3]; id %= _coef[3];
	b.x = id / _coef[2]; id %= _coef[2];
	a.y = id / _coef[1]; id %= _coef[1];
	a.x = id;
}


char *toc = "ESWN";
int prev[MAXS];
char prevD[MAXS];
int queue[MAXS], p3;
void bfs () {
	for (int i = 0; i < MAXS; ++i) prev[i] = -1;
	queue[p3++] = code (st[0], st[1], 0);
	prev[queue[0]] = -2;

	int i, j, k;
	int p1;
	int c = -100, go;
	pos crnt[2], np[2];
	int t;
	for (p1 = 0; p1 < p3; ++p1) {
		c = queue[p1];

		decode (c, crnt[0], crnt[1], t);
//		printf ("!!%d(%d)%d %d  %d %d  %d\n", p1, c, crnt[0].x, crnt[0].y, crnt[1].x, crnt[1].y, t);
		//assert ((crnt[0].x == 20 || !map[0][crnt[0].x][crnt[0].y]) && (crnt[1].x == 20 || !map[1][crnt[1].x][crnt[1].y]));
		if (crnt[0].x == 20 && crnt[1].x == 20) break;

		for (k = 0; k < 4; ++k) {
			for (j = 0; j < 2; ++j) {
				if (crnt[j].x == 20) {np[j].x = 20; continue;}//already out
				np[j] = crnt[j] + dif[k];
				if (np[j].x < 0 || np[j].x >= dim[j][0]
				 || np[j].y < 0 || np[j].y >= dim[j][1]) {
					np[j] = pos (20, 0);
					continue;
				}

				if (map[j][np[j].x][np[j].y]) np[j] = crnt[j]; //wall on the way -> stay at the same place

				for (i = 0; i < gc[j]; ++i)
					if (np[j] == gpl[j][i][t+1]
					 || (np[j] == gpl[j][i][t]
					 && crnt[j] == gpl[j][i][t+1])) break;

				if (i != gc[j]) break;
			}
			if (j != 2) continue;//problem with the move

//			#warning FIX THISS
			if (!((np[0].x == 20 || !map[0][np[0].x][np[0].y]) && (np[1].x == 20 || !map[1][np[1].x][np[1].y])))  {
//				printf ("%d(%d) %d(%d)  %d(%d) %d(%d) %d   %d!!!!!\n", crnt[0].x, np[0].x, crnt[0].y, np[0].y, crnt[1].x, np[1].x, crnt[1].y, np[1].y, t, k);
				assert (0);
			}
			go = code (np[0], np[1], (t + 1) % 12);
			if (prev[go] == -1) {
				queue[p3++] = go;
				prev[go] = c;
				prevD[go] = k;
//				printf ("push (%d) %d %d  %d %d %d(%d) __%d\n", k, np[0].x, np[0].y, np[1].x, np[1].y, (t+1) % 12, go, p3-1);
			}
		}
	}
	if (p1 == p3) {printf ("-1"); return;}
//	end:;
	std::vector <int> ans;
	for (; prev[c] != -2; c = prev[c]) {
		decode (c, crnt[0], crnt[1], t);
//		printf ("%d %d  %d %d  %d\n", crnt[0].x, crnt[0].y, crnt[1].x, crnt[1].y, t);
		ans.push_back (prevD[c]);//printf ("%d ", prevD[c]);
	}
//	printf ("%c", toc[ans.back ()]);
	for (int i = ans.size () - 1; i >= 0; --i) printf ("%c\n", toc[ans[i]]);
	printf ("\n");
}

int main () {
	int k;
	int i, j=-1;

	int a, b, c;
	char d, tmp;
	for (k = 0; k < 2; ++k) {
		scanf ("%d %d\n", &dim[k][0], &dim[k][1]);

		for (i = 0; i < dim[k][0]; ++i) {
			for (j = 0; j < dim[k][1]; ++j) {
				map[k][i][j] = (tmp = getchar ()) == '#';//wall is 1
				if (tmp == 'X') {st[k] = pos (i, j);}
			}
			getchar ();
		}
/*
		printf ("%d %d(%d)\n", st[k].x, st[k].y, k);

		for (i = 0; i < dim[k][0]; ++i) {
			for (j = 0; j < dim[k][1]; ++j)
				putchar (map[k][i][j] ? '#' : '.');
			putchar ('\n');
		}
*/
		scanf ("%d\n", gc + k);
		for (i = 0; i < gc[k]; ++i) {
			scanf ("%d %d %d %c\n", &a, &b, &c, &d);
			--a; --b;
			fill_gpl (k, i, pos (a, b), c, ctoi (d));
		}
	}

/*	int cd = code (pos (20, 19), pos (20, 19), 5);
	pos t1, t2;
	int t3;
	decode (cd, t1, t2, t3);
	printf ("%d %d %d %d %d\n", t1.x, t1.y, t2.x, t2.y, t3);
*/
	bfs ();

	return 0;
}
