/*

*/

#include <cstdio>
#include <cstdlib>
#include <cctype>
#include <cassert>
#include <cstring>

const int MAXN = 1 << 5;
const int MAXM = 1 << 5;
const int MAXSTATE = 1 << 20;

const int difx[] = {0, 1, 0, -1};
const int dify[] = {1, 0, -1, 0};

int N, M;
int Sx, Sy, Bx, By, Tx, Ty;
bool map[MAXN][MAXM];

char letter[] = "rdlu";

int toint (char x) {
	x = tolower (x);
	switch (x) {
		case 'r': return 0;
		case 'd': return 1;
		case 'l': return 2;
		case 'u': return 3;
	}
//	return 1000000000;
//	printf ("____%c____\n", x);
	printf ("0\nInvalid simbol!\n"); exit (0);
//	assert (0);
}

char *tos (char *s) {
	char *ss = s;
	for (; *s; ++s)
		if (*s == ' ')
			*s = '_';
		else if (*s == '\n')
			*s = 'N';
	return ss;
}

void prnt () {
	char c;
	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < M; ++j) {
			c = '.';
			if (i == Sx && j == Sy) c = 'S';
			if (i == Bx && j == By) c = 'B';
			if (i == Tx && j == Ty) c = 'T';
			printf ("%c", map[i][j] ? '#' : c);
		}
		printf ("\n");
	}
	printf ("\n");
}

int main (int argc, char *argv[]) {
	if (argc != 4) {printf ("wrong number of arguments\n"); exit (-1);}
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
	FILE *sol = fopen (argv[3], "r");

	fscanf (in, "%d %d\n", &N, &M);

	int i, j, k;
	char tmp;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < M; ++j) {
			tmp = getc (in);
			map[i][j] = tmp == '#';
			if (!isalpha (tmp)) continue;
			switch (tmp) {
				case 'S': Sx = i; Sy = j; break;
				case 'B': Bx = i; By = j; break;
				case 'T': Tx = i; Ty = j; break;
			}
		}
		getc (in);
	}

//	prnt ();

	int lc = 0, mc = 0;
//	printf ("%d %d\n", Sx, Sy);
	char line[1 << 10];//, line_[1 << 9];
	fgets (line, 1 << 10, out);
	if (!strcmp (line, "Impossible.\n")) {
		if (fgets (line, 1 << 9, sol), !strcmp (line, "Impossible.\n"))
			printf ("10\nOK!\n");
		else
			printf ("0\nWA!\n");
		exit (0);
	}

	i = 0;
	while (isalpha (tmp = line[i++])) {
//		prnt ();
		++lc;
		mc += !!(isupper (tmp));
		k = toint (tmp);
		Sx += difx[k];
		Sy += dify[k];
//		printf ("%c -- %d -- %d %d\n", tmp, k, Sx, Sy);
		if (Sx < 0 || Sx >= N || Sy < 0 || Sy >= M) {printf ("0\nEXIT BOUNDARYS!\n"); exit (0);}
		if (map[Sx][Sy]) {printf ("0\nHIT THE WALL!\n"); exit (0);}
		if (Sx == Bx && Sy == By) {
			if (islower (tmp)) {printf ("0\nLOWER / UPPER!\n"); exit (0);}
			Bx += difx[k];
			By += dify[k];
			if (Bx < 0 || Bx >= N || By < 0 || By >= M) {printf ("0\nEXIT BOUNDARYS!(B)\n"); exit (0);}
			if (map[Bx][By]) {printf ("0\nHIT THE WALL!(B i.e cannot move)\n"); exit (0);}
		} else if (isupper (tmp)) {printf ("0\nNOT MOVING THE B!\n"); exit (0);}
	}

	if (Bx != Tx || By != Ty) {printf ("0\nNOT IN T!\n"); exit (0);}

	fgets (line, 1 << 10, sol);
	fclose (sol);
	int Alc = 0, Amc = 0;
	for (int i = 0; isalpha (line[i]); ++i, ++Alc)
		if (isupper (line[i])) ++Amc;

	if (Amc == mc && Alc == lc)
		printf ("10\nOK!(%d %d)\n", Alc, Amc);
	else
		printf ("0\nMore moves. Optimal: %d moves %d pushes, your %d moves %d pushes\n", Alc, Amc, lc, mc);

	return 0;
}
