/*
TASK: wappo
LANG: C++

FROM: SPRING 2005 A
PROB: wappo
KEYW: gpaph expansion, bfs, coding
*/

#include <cstdio>
#include <cassert>
#include <vector>

const int MAXN = 1 << 3;
const int MAXS = 793152;

struct pos {
	int x, y;
	pos () {}
	pos (int _x, int _y) : x (_x), y (_y) {}
	pos (const pos &a) : x (a.x), y (a.y) {}
	pos& operator += (const pos &a) {x += a.x; y += a.y; return *this;}
	pos& operator -= (const pos &a) {x -= a.x; y -= a.y; return *this;}
	bool operator == (const pos &a) const {return x == a.x && y == a.y;}
	bool operator != (const pos &a) const {return x != a.x || y != a.y;}
	pos operator + (const pos &a) const {pos ret (*this); return ret += a;}
	pos operator - (const pos &a) const {pos ret (*this); return ret -= a;}
	pos mod () {pos ret (*this); if (x) ret.x /= abs (x); if (y) ret.y /= abs (y); return ret;}
};

const pos dif[] = {pos (0, -1), pos (0, 1), pos (-1, 0), pos (1, 0)};

void fnd (const pos &x, int &k1, int &k2) {
	assert (x.x || x.y);
	assert (abs (x.y) == 1 || !x.y);
	assert (abs (x.x) == 1 || !x.x);
	if (x.y) {
		k1 = (1 + x.y) / 2;//0 or 1
		if (x.x) k2 = (1 + x.x) / 2 + 2;//2 or 3
		else k2 = k1;
	} else
		k1 = k2 = (1 + x.x) / 2 + 2;//only x move
}

struct state {
	pos h, m1, m2;
	int p1, p2;
	state () {}
	state (pos _h, pos _m1, pos _m2, int _p1, int _p2) : h (_h), m1 (_m1), m2 (_m2), p1 (_p1), p2 (_p2) {}
	state (const state &a) : h (a.h), m1 (a.m1), m2 (a.m2), p1 (a.p1), p2 (a.p2) {}
};

int _c[] = {1, 6, 36, 216, 1296, 7776, 46656, 186624, 746496};
int code (const state &a) {
	return a.h.x + a.h.y * _c[1] + a.m1.x * _c[2] + a.m1.y * _c[3] +  a.m2.x * _c[4] + a.m2.y * _c[5] + a.p1 * _c[6] + a.p2 * _c[7];
}

void decode (int id, state &a) {
	a.p2 = id / _c[7]; id %= _c[7];
	a.p1 = id / _c[6]; id %= _c[6];
	a.m2.y = id / _c[5]; id %= _c[5];;
	a.m2.x = id / _c[4]; id %= _c[4];
	a.m1.y = id / _c[3]; id %= _c[3];
	a.m1.x = id / _c[2]; id %= _c[2];
	a.h.y = id / _c[1]; id %= _c[1];
	a.h.x = id;
}

int N;
bool trap[MAXN][MAXN];
int map[MAXN][MAXN];
state ss;

int queue[MAXS], p3;
int prev[MAXS];
char prevD[MAXS];

std::vector <int> ans;

void prnt (const state &a) {
	printf ("%d %d  %d %d  %d %d  %d %d\n", a.h.x, a.h.y, a.m1.x, a.m1.y, a.m2.x, a.m2.y, a.p1, a.p2);
}

void pma3x (const state &a) {
	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < N; ++j)
			if (a.h == pos (i, j))
				printf ("H");
			else if (a.m1 == pos (i, j))
				printf ("1");
			else if (a.m2 == pos (i, j))
				printf ("2");
			else
				printf (".");
		printf ("\n");
	}
}

bool ok_move (const pos &p, int k) {
	return !(map[p.x][p.y] & (1 << k));
}

bool _mvd;
pos move_monster (const pos &m, const pos &h) {
	static int k1, k2;
	fnd ((h - m).mod (), k1, k2);
	if (ok_move (m, k1))
		return _mvd = 1, m + dif[k1];
	else if (ok_move (m, k2))
		return _mvd = 1, m + dif[k2];
	else
		return _mvd = 0, m;//no move
}

bool move_monsters (state &s) {
//	printf ("mms: "); prnt (s);
	static pos tmp;
	if (s.m1 == s.h || s.m2 == s.h) return 0;
	if (s.m1 == s.m2) {//super
		s.p1 = s.p2 = 0;
		for (int i = 0; i < 3; ++i)
			if ((s.m1 = s.m2 = move_monster (s.m1, s.h)) == s.h) return 0;//gotcha
	} else {//mormal
		for (int i = 0; i < 2; ++i) {
			if (s.m1 == s.m2) return s.m1 != s.h;//super
			///first monster
			if (s.p1) goto secmon;
			s.m1 = move_monster (s.m1, s.h);
			if (_mvd && trap[s.m1.x][s.m1.y]) {
				s.p1 = 4;
				goto secmon;
			}
			if (s.m1 == s.h) return 0;//gotcha

			///second monster
			secmon:;
			if (s.p2) continue;
			s.m2 = move_monster (s.m2, s.h);
			if (s.m2 == s.m1) return s.m1 != s.h;//super
			if (_mvd && trap[s.m2.x][s.m2.y]) {
				s.p2 = 4;
				continue;
			}
			if (s.m2 == s.h) return 0;//gotcha
		}
		///decrease penality
		if (s.p1) --s.p1;
		if (s.p2) --s.p2;
	}
	assert (s.p1 < 4 && s.p2 < 4 && s.p1 >= 0 && s.p2 >= 0);
//	printf ("OK!!: "); prnt (s);
	return 1;
}

bool out (const pos &a) {
	return a.x < 0 || a.x >= N || a.y < 0 || a.y >= N;
}

int trf[] = {2, 3, 0, 1};

void bfs () {
	for (int i = 0; i < MAXS; ++i) prev[i] = -1;
	queue[p3++] = code (ss);
	prev[queue[0]] = -2;

	int k;
	int c = -100;
	int go;
	state st, gos;
	for (int i = 0; i < p3; ++i) {
		c = queue[i];

		decode (c, st);
//		printf ("pop "); prnt (st);
		for (k = 0; k < 4; ++k) {
			if (!ok_move (st.h, k)) continue;
			if (out (st.h + dif[k])) {
//				printf ("%d %d\n", st.h.x + dif[k].x, st.h.y + dif[k].y);
				ans.push_back (k);//the last move - continue from the previous
				goto end;
			}
			if (trap[st.h.x + dif[k].x][st.h.y + dif[k].y]) continue;

			gos = st;
			gos.h += dif[k];
//			printf ("try move k = %d -- %d %d --> %d %d\n", k, dif[k].x, dif[k].y, gos.h.x, gos.h.y);
			if (!move_monsters (gos)) continue;
			go = code (gos);
			if (prev[go] == -1) {
//				printf ("push "); prnt (gos);
				queue[p3++] = go;
				prev[go] = c;
				prevD[go] = k;
			}
		}
	}

	assert (0);
	end:;
	for (; prev[c] != -2; c = prev[c]) {
		ans.push_back (prevD[c]);
//		pma3x ((decode (c, gos), gos));
//		printf ("\n");
	}

	printf ("%u\n", ans.size ());
	for (int i = ans.size () - 1; i >= 0; --i) printf ("%d\n", trf[ans[i]]);
}

void input () {
	int T;
	scanf ("%d %d %d %d %d %d %d %d", &N, &ss.h.x, &ss.h.y, &ss.m1.x, &ss.m1.y, &ss.m2.x, &ss.m2.y, &T);
//	printf ("start:"); prnt (ss);
	--ss.h.x; --ss.h.y; --ss.m1.x; --ss.m1.y; --ss.m2.x; --ss.m2.y;
	int i, j, k, a, b;
	for (i = 0; i < T; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		trap[a][b] = 1;
	}

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			scanf ("%d", &map[i][j]);

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			for (k = 0; k < 4; ++k)
				if (map[i][j] & (1 << k) && !out (pos (i, j) + dif[k]))
					map[i+dif[k].x][j+dif[k].y] |= (1 << (k ^ 1));
/*
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			printf ("%d ", map[i][j]);
		printf ("\n");
	}
*/
}

int main () {
	input ();
	bfs ();
//	state s (pos (1, 4), pos (1, 0), pos (4, 4), 0, 0);
//	pma3x (s); puts ("");
//	move_monsters (s);
//	pma3x (s);
	return 0;
}
