/*
TASK: pdrm
LANG: C++

FROM: NOI 2002 r1
PROB: pdrm
KEYW: rabin karp, palindrome
*/

#include <cstdio>
#include <cstdlib>
#include <cstring>

const int MAXLEN = 1 << 17;
const int ALPHA = 128;
const int MOD = 9699689;

int N;
char t[MAXLEN];
int pow[MAXLEN];

void exp (int &f, int &s, int &x) {
	x = (x + (long long)pow[abs (f-s)] * t[s]) % MOD;
	s += f < s ? 1 : -1;
}

void movel (int &f, int &s, int &x) {
	x = (x * (long long)ALPHA) % MOD;
	x -= ((long long)pow[f - s] * t[++s]) % MOD;
	x += t[++f];
	x %= MOD;
}

void mover (int &f, int &s, int &x) {
	x += ((long long)pow[s-f] * t[s++]) % MOD;
	x -= t[f++];
	x = (x + MOD) % MOD;
}

int st, len = -1;
void upd (int l, int s) {
	if (l > len) {
		len = l;
		st = s;
	}
}

int main () {
	gets (t);
	N = strlen (t);

	int i;
	pow[0] = 1;
	for (i = 1; i < N; ++i)
		pow[i] = ((long long)pow[i-1] * (long long)ALPHA) % MOD;

	int lf, ls, lx, rf, rs, rx;
	for (i = 1; i < N && t[i-1] != t[i]; ++i);
	if (i == N) goto scnd;
	lf = i-1; rf = i;
	ls = i-2; rs = i+1;
	lx = t[i-1]; rx = t[i];

	for (;;) {
		while (lx == rx && ls > 0 && rs < N) {
			exp (lf, ls, lx);
			exp (rf, rs, rx);
		}
		upd (rs - ls - 3, ls + 2);
		if (rs == N) break;
		movel (lf, ls, lx);
		mover (rf, rs, rx);
	}

	scnd:;
	for (i = 2; i < N && t[i] != t[i-2]; ++i);
	if (i == N) goto prnt;
	lf = i-2; rf = i;
	ls = i-3; rs = i+1;
	lx = t[i-2]; rx = t[i];

	for (;;) {
		while (lx == rx && ls > 0 && rs < N) {
			exp (lf, ls, lx);
			exp (rf, rs, rx);
		}
		upd (rs - ls - 3, ls + 2);
		if (rs == N) break;
		movel (lf, ls, lx);
		mover (rf, rs, rx);
	}

	prnt:;
	if (len == -1) printf ("NO PALINDROM\n");
	else printf ("%d %d\n", st + 1, len);

	return 0;
}
