/*
FROM: GCJ (Google Code Jam) Round 1A 2008
PROB: A Minimum Scalar Product
KEYW: greedy

LANG: GNU C++ (g++ (GCC) 4.3.1 20080612 (Red Hat 4.3.1-2))
OPT: -lm -O2
*/

#include <cstdio>
#include <set>

typedef long long ll;

int N;
std::multiset <int> s[2];

int first(int k) {
	return *s[k].begin();
}

int xfirst(int k) {
	int ret = first(k);
	s[k].erase(s[k].begin());
	return ret;
}

int last(int k) {
	return *(--s[k].end());
}

int xlast(int k) {
	int ret = last(k);
	s[k].erase(--s[k].end());
	return ret;
}


int main() {
	int tc;
	scanf("%d", &tc);

	for (int ctc = 1; ctc <= tc; ++ctc) {
		scanf("%d", &N);
		int a;
		for (int k = 0; k < 2; ++k) {
			s[k].clear();
			for (int i = 0; i < N; ++i) {
				scanf("%d", &a);
				s[k].insert(a);
			}
		}

		long long res = 0;
		while (N && first(0) < 0 && last(1) > 0) {
			//printf("%d %d  1\n", first(0), last(1));
			res += (ll)xfirst(0) * (ll)xlast(1);
			--N;
		}
		while (N && last(0) > 0 && first(1) < 0) {
			//printf("%d %d  2\n", last(0), first(1));
			res += (ll)xlast(0) * (ll)xfirst(1);
			--N;
		}
		while (N) {
			//printf("%d %d  3\n", first(0), last(1));
			res += (ll)xfirst(0) * (ll)xlast(1);
			--N;
		}
		printf("Case #%d: %Ld\n", ctc, res);
	}

	return 0;
}
