/*
FROM: GCJ (Google Code Jam) Round 1A 2008
PROB: B Milkshakes
KEYW: greedy

LANG: GNU C++ (g++ (GCC) 4.3.1 20080612 (Red Hat 4.3.1-2))
OPT: -lm -O2
*/

#include <cstdio>
#include <cstring>
#include <vector>
#include <utility>

using std::pair;

const int MAXN = 1 << 11;
const int MAXM = 1 << 11;

int N, M;
char ms[MAXN];

std::vector <int> rc[MAXN];

std::vector <int> cust[MAXM];
int custx[MAXM];
int hope[MAXM];

bool flip(int pos) {
	for (size_t i = 0; i < rc[pos].size(); ++i) {
		--hope[rc[pos][i]];
		if (hope[rc[pos][i]]) continue;
		if (custx[rc[pos][i]] == -1)
			return false;//no way to do it
		else if (ms[custx[rc[pos][i]]] == 0) {
			ms[custx[rc[pos][i]]] = 1;
			if (!flip(custx[rc[pos][i]]))
				return false;
		}
	}
	return true;
}

int main() {
	int tc;
	scanf("%d", &tc);

	int i, j;
	for (int ctc = 1; ctc <= tc; ++ctc) {
		scanf("%d %d", &N, &M);

		memset(ms, 0, sizeof(char) * N);
		memset(custx, -1, sizeof(int) * M);

		for (i = 0; i < N; ++i)
			rc[i].clear();

		for (i = 0; i < M; ++i) {
			int sz;
			scanf("%d", &sz);
			cust[i].resize(sz);
			for (j = 0; j < sz; ++j) {
				int a, b;
				scanf("%d %d", &a, &b);
				--a;
				if (b == 1) {
					custx[i] = a;
					cust[i].resize(cust[i].size() - 1);
				} else {
					rc[a].push_back(i);
					cust[i][j] = a;
				}
			}
			hope[i] = cust[i].size();

			if (hope[i] == 0) {
				ms[custx[i]] = 1;
			}
		}

		printf("Case #%d:", ctc);
		for (i = 0; i < N; ++i)
			if (ms[i] == 1)
				if (!flip(i)) {
					printf(" IMPOSSIBLE\n");
					goto next_case;
				}

		for (i = 0; i < N; ++i)
			printf(" %d", (int)ms[i]);
		puts("");

		next_case:;
	}

	return 0;
}
