/*
FROM: GCJ (Google Code Jam) Round 1B 2008
PROB: C Mousetrap
KEYW: binary search, lowest bit index tree
NOTE: works (28 sec user time big case)

LANG: GNU C++ (g++ (GCC) 4.3.1 20080612 (Red Hat 4.3.1-2))
OPT: -lm -O2
*/

#include <cstdio>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <ext/numeric>

namespace std {
	using namespace __gnu_cxx;
}

const int MAXIDTSZ = 1 << 20;
const int MAXNEED = 1 << 7;

int K;
int idt[MAXIDTSZ];

void clear() {
	memset(idt, 0, sizeof(int) * (K + 1));
}

void add(int pos) {
	for (; pos <= K; pos += pos & -pos)
		++idt[pos];
}

int _srch(int pos) {
	static int res;
	//printf("LLS %d -- ", pos);
	for (res = 0; pos; pos &= pos - 1)
		res += idt[pos];
	//printf("%d\n", res);
	return res;
}

//for the user the places are from 0 to N-1 (for the tree they are 1 to N)
int srch(int p1, int p2) {
	return _srch(p2) - _srch(p1);
}

int srchE(int p1, int p2) {
	int res = p2 - p1 - srch(p1, p2);
	//printf("srcE %d %d -- %d\n", p1, p2, res);
	return res;
}

int N;
int needed[MAXNEED];
int deck[MAXIDTSZ];

bool cmp_need(int i1, int i2) {
	return needed[i1] < needed[i2];
}

int ctc;
int findKth(int from, int k) {
	//printf("findKth %d %d\n", from, k);
	int l = from-1, r = K-1, m;
	assert(srchE(from, K) >= k);
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (srchE(from, m+1) < k)
			l = m;
		else
			r = m;
	}
	//fprintf(stderr, "r == %d, %d %d\n", r, srchE(from, r), srchE(from, r+1));
	assert(srchE(from, r) == k-1 && srchE(from, r+1) == k);
	//printf("--->found %d\n", r);
	return r;
}

int main() {
	int tc;
	scanf("%d", &tc);

	for (ctc = 1; ctc <= tc; ++ctc) {
		fprintf(stderr, "%d\n", ctc);
		scanf("%d %d", &K, &N);
		for (int i = 0; i < N; ++i)
			scanf("%d", needed + i);
		//std::iota(nidx, nidx + N, 0);
		//std::sort(nidx, nidx + N, cmp_need);
		//int current_need = 0;
		clear();
		int first_free = 0;
		for (int to_put = 1; to_put <= K; ++to_put) {
			int to_end = srchE(first_free, K);
			int put_to;
			//fprintf(stderr, "to put , to end  %d %d\n", to_put, to_end);
			if (to_put <= to_end) {
				put_to = findKth(first_free, to_put);
			} else {
				int num = to_put - to_end;
				int den = K - to_put + 1;
				//fprintf(stderr, "%d %% %d = %d  %d\n", num, den, num % den, num % den == 0 ? den : num % den);
				put_to = findKth(0, num % den == 0 ? den : num % den);
			}
			/*
			if (current_need != N && needed[nidx[current_need]] == to_put) {
				needed[nidx[current_need]] = put_to + 1;
				++current_need;
			}*/
			deck[put_to] = to_put;
			add(put_to + 1);
			first_free = put_to == K - 1 ? 0 : put_to + 1;
		}

		//for (int i = 0; i < K; ++i) printf(" %d", deck[i]); puts("");
		printf("Case #%d:", ctc);
		for (int i = 0; i < N; ++i)
			printf(" %d", deck[needed[i]-1]);
		puts("");
	}

	return 0;
}