#include <cstdio>
#include <cmath>
#include <cassert>
#include <cstdlib>

const int TRIES = 100000000;

double sq (double x) {return x * x;}

int main () {
	int tc;
	scanf ("%d", &tc);

	for (int ctc = 1; ctc <= tc; ++ctc) {
		double f, R, t, r, g;
		scanf ("%lf %lf %lf %lf %lf", &f, &R, &t, &r, &g);
		if (g - 2. * f < 1e-9) {
			printf ("Case #%d: %lf\n", ctc, 1.);
			continue;
		}
		double rx = R - t - f;
		double rf = r + f;
		double grf = g + r - f;
		double g2r = g + 2. * r;

		int tries = 0;
		int hits = 0;
		for (int tx = 0; tx < TRIES; ++tx) {
			int _x = rand ();
			int _y = rand ();

			double x = (double)_x / ((double)RAND_MAX / R);
			double y = (double)_y / ((double)RAND_MAX / R);
			assert (x >= 0 && x <= R);

			if (sq (x) + sq (y) >= sq (R)) continue;//out of circle
			++tries;
			if (sq (x) + sq (y) >= sq (rx)) {
				++hits;
			} else {
				double xrem = fmod (x, g2r);
				double yrem = fmod (y, g2r);
				if ((xrem <= rf || xrem >= grf)
				 && (yrem <= rf || yrem >= grf))
					++hits;
			}
		}
		printf ("Case #%d: %lf\n", ctc, (double)hits / tries);
		//fprintf (stderr, "%lf\n", (double)tries / TRIES);
	}

	return 0;
}
