/*
FROM: GCJ (Google Code Jam) Round 2 2008
PROB: C Star Wars
KEYW: farmost points with manhattan distance in 3d
*/

#include <cstdio>
#include <cmath>
#include <cassert>

const int MAXN = 1 << 10;

int N;
int co[MAXN][4];
int p[MAXN];

double farmost(int v) {
	double fm = 0;
	for (int i = 1; i < N; ++i)
		for (int j = 0; j < i; ++j) {
			double opt = (double)co[i][v] + ((double)co[j][v] - co[i][v])
					* (double)p[i] / ((double)p[i] + p[j]);
			double tpow = fabs(opt - co[i][v]) / p[i];
			assert(fabs(tpow - fabs(opt-co[j][v]) / p[j]) < 1e-9);
			if (fm < tpow)
				fm = tpow;
		}
	return fm;
}

int main() {
	int tc;
	scanf("%d", &tc);

	for (int ctc = 1; ctc <= tc; ++ctc) {
		scanf("%d", &N);

		for (int i = 0; i < N; ++i) {
			int x, y, z;
			scanf("%d %d %d %d", &x, &y, &z, p + i);

			co[i][0] = x + y + z;
			co[i][1] = x + y - z;
			co[i][2] = x - y + z;
			co[i][3] = x - y - z;
		}

		double ans = 0;
		for (int i = 0; i < 4; ++i) {
			double fm = farmost(i);
			if (ans < fm) {
				ans = fm;
			}
		}

		printf("Case #%d: %.7lf\n", ctc, ans);
	}

	return 0;
}
