/*
FROM: GCJ (Google Code Jam) Round 2 2008
PROB: C Star Wars
KEYW: nested binary search (no idea why works)
NOTE: it WORKS with 70 cycles
*/

#include <cstdio>
#include <cassert>
#include <cmath>

const int MAXN = 1 << 10;

struct pnt {
	double x, y, z;
	pnt() {}
	//pnt(int _x, int _y, int _z) : x(_x), y(_y), z(_z) {}

	double &operator [] (const int &c) {
		switch (c) {
		case 0: return x;
		case 1: return y;
		default: return z;
		}
	}

	double len(const pnt &p) {return fabs(x - p.x) + fabs(y - p.y) + fabs(z - p.z);}
};

int N;
pnt vec[MAXN];
double p[MAXN];

pnt cc;
double ans[4];

const int CYCLES = 70;

double bsrch(int s) {
	if (s == 3) {
		double opt = 0.;
		for (int i = 0; i < N; ++i) {
			double v = cc.len(vec[i]) / p[i];
			//fprintf(stderr, "%lf\n", v);
			if (opt < v)
				opt = v;
		}
		return opt;
	}

	double opt1, opt2;
	double lb = 0., ub = 1e6;
	for (int _i = 0; _i < CYCLES; ++_i) {
		double mid1 = lb + (ub - lb) / 3.;
		double mid2 = lb + 2. * (ub - lb) / 3.;

		cc[s] = mid1;
		opt1 = bsrch(s+1);
		cc[s] = mid2;
		opt2 = bsrch(s+1);
		//fprintf(stderr, "%d opt1 opt2: %lf %lf\n", s, opt1, opt2);
		if (opt1 < opt2) {
			ub = mid2;
		} else {
			lb = mid1;
		}
	}
	assert(fabs(ub - lb) < 1e-6);
	cc[s] = (ub + lb) / 2.;
/*	if (s == 0)
		fprintf(stderr, "opt x == %lf\n", (ub + lb) / 2.);*/
	return bsrch(s+1);
}

int main() {
	int tc;
	scanf("%d", &tc);

	for (int ctc = 1; ctc <= tc; ++ctc) {
		scanf("%d", &N);
		fprintf(stderr, "case %d\n", ctc);

		for (int i = 0; i < N; ++i) {
			scanf("%lf %lf %lf %lf", &vec[i].x, &vec[i].y, &vec[i].z, p + i);
			/*fprintf(stderr, "%lf %lf %lf %lf\n", vec[i].x, vec[i].y, vec[i].z, p[i]);*/
		}


		//bsrch(0);

		printf("Case #%d: %.7lf\n", ctc, bsrch(0));
	}

	return 0;
}
