/*
FROM: GCJ (Google Code Jam) Round 2 2008
PROB: C Star Wars
KEYW: binary search on the answer, intersecting 'speres' in manhattan distance in 3D
*/

#include <cstdio>
#include <cmath>
#include <cassert>
#include <algorithm>

const double INF = 1e9;
const double EPS = 1e-10;

struct pnt {
	double x, y, z;
	pnt() {}
	//pnt(int _x, int _y, int _z) : x(_x), y(_y), z(_z) {}

	double &operator [] (const int &c) {
		switch (c) {
		case 0: return x;
		case 1: return y;
		default: return z;
		}
	}

	double len(const pnt &p) {return fabs(x - p.x) + fabs(y - p.y) + fabs(z - p.z);}
};

const int MAXN = 1 << 10;

int N;
pnt vec[MAXN];
double p[MAXN];

int coefs[4][3] = {
	{1,  1,  1},
	{1, -1,  1},
	{1,  1, -1},
	{1, -1, -1},
};

void prnt(double bnd[4][2], int x) {
	for (int i = 0; i < 4; ++i)
		fprintf(stderr, "%d  %lf %lf\n", i, bnd[i][0], bnd[i][1]);
	fprintf(stderr, "%d\n", x);
	assert(0);
}

bool inter(double r) {
	double bnd[4][2];
	for (int i = 0; i < 4; ++i) {
		bnd[i][0] = -INF;
		bnd[i][1] = INF;
	}

	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < 4; ++j) {
			double sum = 0;
			for (int k = 0; k < 3; ++k) {
				sum += coefs[j][k] * vec[i][k];
			}
			double lb = sum - r * p[i];
			double ub = sum + r * p[i];
			bnd[j][0] = std::max(bnd[j][0], lb);
			bnd[j][1] = std::min(bnd[j][1], ub);
		}
	}

	bool good[4];
	for (int i = 0; i < 4; ++i)
		good[i] = bnd[i][0] < bnd[i][1] + EPS;

/*
	if ( good[0] &&  good[1] &&  good[2] && !good[3]) prnt(bnd, 3);
	if ( good[0] &&  good[1] && !good[2] &&  good[3]) prnt(bnd, 2);
	if ( good[0] && !good[1] &&  good[2] &&  good[3]) prnt(bnd, 1);
	if (!good[0] &&  good[1] &&  good[2] &&  good[3]) prnt(bnd, 0);
	*/
	return good[0] && good[1] && good[2] && good[3];
}


int main() {
	int tc;
	scanf("%d", &tc);

	for (int ctc = 1; ctc <= tc; ++ctc) {
		scanf("%d", &N);

		for (int i = 0; i < N; ++i) {
			scanf("%lf %lf %lf %lf", &vec[i].x, &vec[i].y, &vec[i].z, p + i);
		}

		double lb = 0, ub = INF, mid;
		for (int i = 0; i < 64; ++i) {
			mid = (lb + ub) / 2.;
			if (inter(mid))
				ub = mid;
			else
				lb = mid;
		}

		printf("Case #%d: %.7lf\n", ctc, mid);
	}

	return 0;
}

