/*
This code is N^3 <-> 1000^3. It can be made N^2 by a simple observation. Check c1.cpp
*/

#include <algorithm>
#include <string>
#include <vector>
#include <ctype.h>
#include <math.h>
//#include <iostream>
//#include <set>
//#include <map>
//#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<int> vll;
typedef vector<string> vs;


#define MAXX(A,B) {typeof(B) b = B; if (A < b) {A = b;}}


#define LS <
#define Size(x) (int(x.size()))
#define LET(k,val) typeof(val) k = (val)
#define CLC(act,val) (*({act; static typeof(val) CLCR; CLCR = (val); &CLCR;}))

#define FOR(k,a,b) for(typeof(a) k=(a); k LS (b); ++k)
#define FORREV(k,a,b) for(typeof(b) k=(b); (a) <= (--k);)

#define FIRST(k,a,b,cond) CLC(LET(k, a); for(; k LS (b); ++k) if(cond) break, k)
#define LAST(k,a,b,cond) CLC(LET(k, b); while((a) <= (--k)) if(cond) break, k)
#define EXISTS(k,a,b,cond) (FIRST(k,a,b,cond) LS (b))
#define FORALL(k,a,b,cond) (!EXISTS(k,a,b,!(cond)))
#define FOLD0(k,a,b,init,act) CLC(LET(k, a); LET(R##k, init); for(; k LS (b); ++k) {act;}, R##k)
#define SUMTO(k,a,b,init,x)  FOLD0(k,a,b,init,R##k += (x))
#define SUM(k,a,b,x) SUMTO(k,a,b,(typeof(x)) (0), x)
#define PRODTO(k,a,b,init,x) FOLD0(k,a,b,init,R##k *= (x))
#define PROD(k,a,b,x) PRODTO(k,a,b,(typeof(x)) (1), x)
#define MAXTO(k,a,b,init,x)  FOLD0(k,a,b,init,R##k >?= (x))
#define MINTO(k,a,b,init,x)  FOLD0(k,a,b,init,R##k <?= (x))
#define QXOR(k,a,b,x) FOLD0(k,a,b,(typeof(x)) (0), R##k ^= x)
#define QAND(k,a,b,x) FOLD0(k,a,b,(typeof(x)) (-1), R##k &= x)
#define QOR(k,a,b,x) FOLD0(k,a,b,(typeof(x)) (-1), R##k |= x)
#define FOLD1(k,a,b,init,act) CLC(LET(k, a); LET(R##k, init); for(++k; k LS (b); ++k) act, R##k)
#define MAX(k,a,b,x) FOLD1(k,a,b,x, R##k >?= (x))
#define MIN(k,a,b,x) FOLD1(k,a,b,x, R##k <?= (x))
#define FIRSTMIN(k,a,b,x) (MIN(k,a,b,make_pair(x,k)).second)

int bitc(ll r) {return r == 0 ? 0 : (bitc(r>>1) + (r&1));}
ll gcd(ll x, ll y) {return x ? gcd(y%x,x) : y;}

/*
template<class T> T& operator >?= (T& x, T y) {if(y>x) x=y; return x;}
template<class T> T& operator <?= (T& x, T y) {if(y<x) x=y; return x;}
template<class T> T operator >? (T x, T y) {return x>y?x:y;}
template<class T> T operator <? (T x, T y) {return x<y?x:y;}
*/
#define Pa(xy) ((xy).first)
#define Ir(xy) ((xy).second)

string cts(char c) {string s=""; s+=c; return s;}

/// ----

#define BUFSIZE 1000000
char buf[BUFSIZE];

#ifdef DEBUG
#define DEB(x) x
#else
#define DEB(x)
#endif

string getLine() {
  string s;
  while(!feof(stdin)) {
    char c = fgetc(stdin);
    if(c == 13) continue;
    if(c == 10) return s;
    s += c;
    }
  return s;
  }

int getNum() {
  string s = getLine();
  return atoi(s.c_str());
  }

int co[2048][8];

int INF = 100000000;

ld flabs(ld f) { if(f>0) return f; else return -f;}

ld solveLine(int N, int id) {
  ld best = INF;

//printf("vals:"); FOR(k,0,N) printf(" %f/%d", co[k][id]+.0, co[k][4]); printf("\n");

  FOR(k,0,N) FOR(l,0,k) {
    ld Z = .0;
    ld pos = co[k][id] +
      (co[l][id] - co[k][id]) * co[k][4] / (co[k][4]+co[l][4]+Z);
    ld cur = 0;

//  printf("[%d,%d] pos = %f\n", k,l, pos);

    FOR(u,0,N) MAXX(cur, flabs(pos - co[u][id])/co[u][4]);

//  printf("cur = %f\n", cur);

    if(cur < best) best = cur;
    }

  return best;
  }

void solveCase(int cnum) {
  int res = 0;

  int N = getNum();

  FOR(a,0,N) {
    string s = getLine();
    int x, y, z, p;
    sscanf(s.c_str(), "%d%d%d%d", &x, &y, &z, &p);
    co[a][0] = x+y+z;
    co[a][1] = x+y-z;
    co[a][2] = x-y+z;
    co[a][3] = x-y-z;
    co[a][4] = p;
    }

  ld sol = 0;
  FOR(u,0,4) MAXX(sol, solveLine(N, u));

  if(N == 1) sol = 0;

  printf("Case #%d: %.7f\n", cnum+1, float(sol));

  fprintf(stderr, "Case #%d.\n", cnum); fflush(stdout);
  }

int main() {
  int N;
  string Nstr = getLine();
  N = atoi(Nstr.c_str());
  FOR(cnum,0,N)
    solveCase(cnum);
  return 0;
  }
