/*
FROM: GCJ (Google Code Jam) Round 3 2008
PROB: A How Big Are the Pockets?
KEYW: geometry

LANG: GNU C++ (g++ (GCC) 4.3.1 20080612 (Red Hat 4.3.1-2))
OPT: -lm -O2
*/

#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>

struct pnt {
	int x, y;
	pnt() {}
	pnt(int _x, int _y) : x(_x), y(_y) {}
	bool operator == (const pnt &p) const {return x == p.x && y == p.y;}
	bool operator != (const pnt &p) const {return !(*this == p);}
};

int dx[] = {0, 1, 0, -1};
int dy[] = {1, 0, -1, 0};

int L;
std::vector <pnt> vec;
std::vector <pnt> cor_pts[4];
std::vector <pnt> vecx;

int cc[128];
pnt cp;
int cdir;

inline void app(int t) {
	cp.x += dx[cdir] * t;
	cp.y += dy[cdir] * t;
}

int gfpm[][4] =
{
	{-1, 0, -1, 3},
	{-1, 1, -1, 0},
	{-1, 2, -1, 1},
	{-1, 3, -1, 2}
};

int gfp(int cdir, int turn) {
	return gfpm[cdir][turn];
}

int glx[4] = {-1, 1,  1, -1};
int gly[4] = { 1, 1, -1, -1};

bool ff(int d1, int d2) {
	return d1 * d2 > 0;
}

pnt fxx(int p, pnt o, pnt n) {
	//printf("in here %d %d %d %d\n", o.x, o.y, n.x, n.y);
	switch(p) {
		case 0: case 2: return pnt(o.x, n.y); break;
		case 1: case 3: return pnt(n.x, o.y); break;
		default: assert(0); return pnt(0, 0);
	}
}

void prune(int p) {
//	fprintf(stderr, "in prune %d\n", p);
	int i;
	if (p == 0)
		vecx.clear();
	vecx.push_back(cor_pts[p][0]);
	for (i = 1; i < (int)cor_pts[p].size(); ++i) {
		if (ff(cor_pts[p][i].x - vecx.back().x, glx[p])
		 && ff(cor_pts[p][i].y - vecx.back().y, gly[p])) {
//		 	fprintf(stderr, "got %d %d\n", cor_pts[p][i].x, cor_pts[p][i].y);
		 	vecx.push_back(fxx(p, vecx.back(), cor_pts[p][i]));
			vecx.push_back(cor_pts[p][i]);
		} else {
/*
			fprintf(stderr, "reject %d %d (%d %d)\n"\
				, cor_pts[p][i].x\
				, cor_pts[p][i].y\
				, ff(cor_pts[p][i].x - cor_pts[p][i-1].x, glx[p])\
				, ff(cor_pts[p][i].y - cor_pts[p][i-1].y, glx[p]));
*/
		}
	}
}

bool cmp0(pnt p1, pnt p2) {
	return p1.y != p2.y ? p1.y < p2.y : p1.x < p2.x;
}

bool cmp1(pnt p1, pnt p2) {
	return p1.x != p2.x ? p1.x < p2.x : p1.y > p2.y;
}

bool cmp2(pnt p1, pnt p2) {
	return p1.y != p2.y ? p1.y > p2.y : p1.x > p2.x;
}

bool cmp3(pnt p1, pnt p2) {
	return p1.x != p2.x ? p1.x > p2.x : p1.y < p2.y;
}

int S(std::vector <pnt> &v) {
/*
	fprintf(stderr, "FIND S:");
	for (int i = 0; i < (int)v.size(); ++i)
		fprintf(stderr, " (%d %d)", v[i].x, v[i].y);
	fputs("\n", stderr);
*/
	int res = 0;

	//magic
	v.reserve(v.size() + 1);
	v[v.size()] = v[0];

	for (int i = 0; i < (int)v.size(); ++i) {
		res += v[i].x * v[i+1].y;
		res -= v[i].y * v[i+1].x;
	}

	return res;
}


int lfx[][4] = {
	{-1,  1, -1,  2},
	{ 3, -1,  2, -1},
	{-1,  0, -1,  3},
	{ 0, -1,  1, -1},
};

/*
bool __reg;
void XXclear() {
	__reg = false;
}*/

int _first, _last;
/*void XXregister(int cdir, int turn) {
	if (__reg)
		_last = cdir;
	else {
		_first = (cdir + 4 - turn) % 4;
		__reg = true;
	}
}*/

int calc_dir(pnt p1, pnt p2) {
	int x = p2.x - p1.x;
	int y = p2.y - p1.y;
	x = (x > 0) - (x < 0);
	y = (y > 0) - (y < 0);
	for (int i = 0; i < 4; ++i)
		if (dx[i] == x && dy[i] == y) return i;
	//fprintf(stderr, "%d %d  %d %d\n", p1.x, p1.y, p2.x, p2.y);
	assert(0);
	return -1;
}

int main() {
	int tc;
	scanf("%d", &tc);

	cc['R'] = 1;
	cc['L'] = 3;

	char str[64];
	int i, j, k;
	for (int ctc = 1; ctc <= tc; ++ctc) {
		scanf("%d", &L);
		vec.clear();
		std::vector <int> dirs;
		int t;
		cp = pnt(0, 0);
		cdir = 0;
		for (i = 0; i < 4; ++i) cor_pts[i].clear();
		//XXclear();
		int _bad_cnt = 0;
		for (i = 0; i < L; ++i) {
			scanf("%s %d", str, &t);

/*
			dirs.clear();
			if (str[0] != 'F') {
				dirs.push_back(0);
				dirs.push_back(cc[str[0]]);
			} else
				dirs.push_back(1);

			for (j = 1; str[j]; ++j) {
				if (str[j] == 'F')
					if (str[j-1] == 'F')
						++dirs[dirs.size() - 1];
					else
						dirs.push_back(1);
				else
					dirs.push_back(cc[str[j]]);
			}
			if (dirs.size() & 1)
				dirs.push_back(0);//turn 0

			for (j = 0; j < t; ++j) {
				//printf("str %s\n", str);
				for (k = 0; k < (int)dirs.size(); k += 2) {
					//printf("XX %d %d\n", dirs[k], dirs[k+1]);
					app(dirs[k]);
					cdir = (cdir + dirs[k+1]) % 4;
					if (cp == pnt(0, 0)) ++_bad_cnt;
					if (dirs[k+1] != 0 && cp != pnt(0, 0)) {
						//XXregister(cdir, dirs[k+1]);
						cor_pts[gfp(cdir, dirs[k+1])].push_back(cp);
						vec.push_back(cp);
//						printf("%d\n", dirs[k+1] == 3 ? -1 : 1);
					}
				}
			}
*/
			for (j = 0; j < t; ++j) {
				for (k = 0; str[k]; ++k) {
					assert(str[k] == 'F' || str[k] == 'R' || str[k] == 'L');

					switch(str[k]) {
						case 'F': app(1); break;
						case 'R': case 'L':
							if (cp == pnt(0, 0)) {
								++_bad_cnt;
								break;
							}
							cdir = (cdir + cc[str[k]]) % 4;
							cor_pts[gfp(cdir, cc[str[k]])].push_back(cp);
							vec.push_back(cp);
							break;
					}
				}
			}
//			fprintf(stderr, "%d %d\n", ctc, i);
			assert(_bad_cnt <= 2);
		}

/*
		if (cdir != 0 && cdir != 2) {
			tot_turns += cdir == 3 ? 1 : -1;
			cor_pts[0].push_back((pnt) {0, 0});
		}

		if (!(vec.back().x == 0 && vec.back().y == 0))
			vec.push_back((pnt) {0, 0});
*/
		//dark magic
		_first = calc_dir(pnt(0, 0), vec.front());
		_last = calc_dir(vec.back(), pnt(0, 0));

		if (lfx[_last][_first] >= 0) {
			//printf("%d %d\n", _last, _first);

			vec.push_back(pnt(0, 0));
			cor_pts[lfx[_last][_first]].push_back(vec.back());
		}

/*
		for (i = 0; i < (int)vec.size(); ++i)
			fprintf(stderr, " (%d %d)", vec[i].x, vec[i].y);
		fputs("\n", stderr);
*/
/*
		for (i = 0; i < 4; ++i) {
			printf("%d -->", i);
			for (j = 0; j < (int)cor_pts[i].size(); ++j)
				printf (" (%d %d)", cor_pts[i][j].x, cor_pts[i][j].y);
			puts("");
		}
*/
		std::sort(cor_pts[0].begin(), cor_pts[0].end(), cmp0);
		std::sort(cor_pts[1].begin(), cor_pts[1].end(), cmp1);
		std::sort(cor_pts[2].begin(), cor_pts[2].end(), cmp2);
		std::sort(cor_pts[3].begin(), cor_pts[3].end(), cmp3);

/*
		for (i = 0; i < 4; ++i) {
			fprintf(stderr, "%d -->", i);
			for (j = 0; j < (int)cor_pts[i].size(); ++j)
				fprintf (stderr, " (%d %d)", cor_pts[i][j].x, cor_pts[i][j].y);
			fputs("\n", stderr);
		}
*/

		for (i = 0; i < 4; ++i) prune(i);
/*
		for (i = 0; i < (int)vecx.size(); ++i)
			fprintf(stderr, " (%d %d)", vecx[i].x, vecx[i].y);
		fputs("\n", stderr);

*/
		int s1 = abs(S(vec)) / 2;
		int s2 = abs(S(vecx)) / 2;
//		fprintf(stderr, "%d %d\n", s1, s2);
		printf("Case #%d: %d\n", ctc, s2 - s1);
	}

	return 0;
}
