/*
FROM: GCJ (Google Code Jam) Round 3 2008
PROB: B Portal
KEYW: bfs, wappo type

LANG: GNU C++ (g++ (GCC) 4.3.1 20080612 (Red Hat 4.3.1-2))
OPT: -lm -O2
*/

#include <cstdio>
#include <queue>
#include <cstring>
#include <utility>
#include <ext/hash_set>

#define MAXX 1000000000

using std::pair;
using std::make_pair;

namespace std {
	using namespace __gnu_cxx;
};

struct pnt {
	int x, y;
	pnt() {}
	pnt(int _x, int _y) : x(_x), y(_y) {}
	bool operator == (const pnt &p) const {return x == p.x && y == p.y;}
	bool operator != (const pnt &p) const {return !(*this == p);}
	pnt operator + (const pnt &p) const {return pnt(x + p.x, y + p.y);}
	pnt &operator += (const pnt &p) {*this = *this + p; return *this;}
	size_t bin() const {
		return (x ^ (y << 4));
	}
};

pnt NONE = pnt(0, 0);
pnt d[] = {pnt(-1, 0), pnt(0, 1), pnt(1, 0), pnt(0, -1)};

struct state {
	pnt p;
	pnt por1, por2;
	int por1d, por2d;

	state() {}
	state(pnt _p, pnt _por1, pnt _por2, int _por1d, int _por2d)
	: p(_p), por1(_por1), por2(_por2), por1d(_por1d), por2d(_por2d) {}

	bool operator == (const state &s) const {
		return p == s.p
		 && por1 == s.por1 && por1d == s.por1d
		 && por2 == s.por2 && por2d == s.por2d;
		//return memcmp(this, &s, sizeof(s)) == 0;
	}

	bool ffp(pnt p, int dir) {
		return !(por1 == p && por1d == dir)
			&& !(por2 == p && por2d == dir);
	}

	void prnt() {
		fprintf(stderr, "%d %d | %d %d   %d | %d %d  %d\n"
				, p.x, p.y
				, por1.x, por1.y, por1d
				, por2.x, por2.y, por2d);
	}
};
typedef pair<state, int> psi;

struct hash_state {
	size_t operator () (const state &s) const {
#warning change this!!!
		return s.p.bin()
			^ (s.por1.bin() << 8)
			^ (s.por2.bin() << 16)
			^ (s.por1d << 24)
			^ (s.por2d << 26);
	}
};

const int MAXROW = 32;
const int MAXCOL = 32;
int R, C;
pnt cake;
char brd[MAXROW][MAXCOL];

bool good_pos(pnt p) {
	return brd[p.x][p.y] != '#';
}

pnt fwd(pnt p, int dir) {
	for (; brd[p.x][p.y] != '#'; p += d[dir]) ;
	return p;
}

#define PUSH1 \
	if (used.find(ns) == used.end()) {\
		used.insert(ns);\
		/*printf("push to 1: \n");*/\
		/*ns.prnt();*/\
		q1.push(psi(ns, steps));\
	}

#define PUSH1X \
	if (used.find(ns) == used.end()) {\
		used.insert(ns);\
		/*printf("push to 1x: \n");*/\
		/*ns.prnt();*/\
		q1.push(psi(ns, steps + 1));\
	}


std::hash_set <state, hash_state> used;
int bfs(state beg) {
	std::queue <pair <state, int> > q1, q2;

	used.clear();
	used.insert(beg);

	q1.push(psi(beg, 0));

	psi cp;
	state c, ns;
	int steps;
	int __cnt = 0;
	while (!q1.empty() || !q2.empty()) {
		if (!q1.empty()) {
			++__cnt;
			pair<state, int> cp = q1.front(); q1.pop();
			c = cp.first;
			steps = cp.second;
			/*
			fprintf (stderr, "popped from 1: ");
			c.prnt();
			printf ("%d %d-----\n", steps, used.size());
			*/

			if (__cnt == MAXX) break;

			if (brd[c.p.x][c.p.y] == 'X')
				return steps;

			for (int i = 0; i < 4; ++i) {
				pnt npp = fwd(c.p, i);

				if (c.ffp(npp, i)) {
					ns = c;
					ns.por1 = npp;
					ns.por1d = i;
					PUSH1;

					ns = c;
					ns.por2 = npp;
					ns.por2d = i;
					PUSH1;
				}
			}

			//fprintf(stderr, "push to p2: "); cp.first.prnt();

			q2.push(cp);
		} else {
			++__cnt;
			pair<state, int> cp = q2.front(); q2.pop();
			c = cp.first;
			steps = cp.second;

			/*
			fprintf (stderr, "popped from 2: ");
			c.prnt();
			printf ("%d %d-----!!!\n", steps, used.size());
			*/
			if (__cnt == MAXX) break;

			for (int i = 0; i < 4; ++i) {
				pnt np = c.p + d[i];
				if (good_pos(np)) {
					ns = c;
					ns.p = np;
					PUSH1X;
				} else if (np == c.por1 && c.por1d == i && c.por2 != NONE) {
					ns = c;
					ns.p = c.por2 + d[c.por2d ^ 2];
					PUSH1X;
				} else if (np == c.por2 && c.por2d == i && c.por1 != NONE) {
					ns = c;
					ns.p = c.por1 + d[c.por1d ^ 2];
					PUSH1X;
				}
			}
		}
	}
	return -1;
}

int main() {
	int tc;
	scanf("%d", &tc);

	for (int ctc = 1; ctc <= tc; ++ctc) {
		scanf("%d %d ", &R, &C);

		memset(brd, '#', sizeof(brd));
		for (int i = 1; i <= R; ++i) {
			fgets(brd[i]+1, MAXCOL - 1, stdin);
			brd[i][0] = brd[i][C+1] = '#';
		}

		state s;
		for (int i = 1; i <= R; ++i)
			for (int j = 1; j <= C; ++j) {
				if (brd[i][j] == 'O') {
					s.p = pnt(i, j);
					goto nxt;
				}
			}
		nxt:;

/*
		for (int i = 0; i <= R+1; ++i) {
			for (int j = 0; j <= C+1; ++j) {
				printf("%c", brd[i][j]);
			}
			puts("");
		}
	*/
		s.por1 = s.por2 = NONE;
		s.por1d = -1;
		s.por2d = -1;
		int res = bfs(s);
		if (res >= 0)
			printf("Case #%d: %d\n", ctc, res);
		else
			printf("Case #%d: THE CAKE IS A LIE\n", ctc);
	}
}
