/*
FROM: GCJ (Google Code Jam) Round 3 2008
PROB: C No Cheating
KEYW: matching, min cut, maximum vertex cover, minimum independent set??

LANG: GNU C++ (g++ (GCC) 4.3.1 20080612 (Red Hat 4.3.1-2))
OPT: -lm -O2
*/

#include <cstdio>
#include <cstring>

const int MAXROW = 1 << 7;
const int MAXCOL = 1 << 7;

int R, C;
char brd[MAXROW][MAXCOL];

int di[] = {-1, 0, 1, -1, 0, 1};
int dj[] = {-1, -1, -1, 1, 1, 1};

///FLOW
struct el {
	int to;
	int rd;
	int next;
	el () {}
	el (int _to, int _rd, int _next)
	: to(_to), rd(_rd), next(_next) {}
};

const int MAXN = MAXROW * MAXCOL;
const int MAXM = MAXN * 8;//6 + 2 (source/sink)

int N, M;
int P1, P2;
int _source, _sink;
int vec[MAXN];
int bp = 0;
el buf[MAXM];

void clear_graph() {
	memset(vec, -1, sizeof(vec));
	bp = 0;
}

void add_edge(int v1, int v2);
void create_bipart(int p1, int p2) {
	P1 = p1;
	P2 = p2;
	_source = p1 + p2;
	_sink = _source + 1;
	N = _sink + 1;
	for (int i = 0; i < p1; ++i)
		add_edge(_source, i);
	for (int i = 0; i < p2; ++i)
		add_edge(i + p1, _sink);
}

void add_edge(int v1, int v2) {
	buf[bp] = el(v2, 1, vec[v1]);
	vec[v1] = bp++;
	buf[bp] = el(v1, 0, vec[v2]);
	vec[v2] = bp++;
}

int idx1(int x, int y) {
	y /= 2;
	return y * R + x;
}

int idx2(int x, int y) {
	y /= 2;
	return y * R + x + P1;
}

///REAL STUFF
int D[MAXN];
int _d_source;
bool bfs() {
	static int q[MAXN];
	static int p3;
	q[p3 = 0, p3++] = _sink;
	memset(D, -1, sizeof(D));
	D[_sink] = 0;

	for (int i = 0; i < p3; ++i) {
		int c = q[i];
		for (int j = vec[c]; j != -1; j = buf[j].next) {
			if (D[buf[j].to] == -1 && buf[j].rd == 0) {
				D[buf[j].to] = D[c] + 1;
				q[p3++] = buf[j].to;
			}
		}
	}


	return (_d_source = D[_source]) != -1;
}

/*int ep;
int elist[MAXN];
*/
bool dfs(int a) {
	if (a == _sink) {
		D[_sink] = 0;
		return true;
	}

	for (int i = vec[a]; i != -1; i = buf[i].next) {
		if (D[buf[i].to] == D[a] - 1 && buf[i].rd) {
			if (dfs(buf[i].to)) {
				//elist[ep++] = i;
				buf[i].rd = 0;
				buf[i^1].rd = 1;
				D[a] = -2;//used
				return true;
			}
		}
	}

	D[a] = -2;
	return false;
}

int dinitz() {
	int flow = 0;
	while (bfs()) {
		while (/*ep = 0,*/ D[_source] = _d_source, dfs(_source)) {
			++flow;
		}
	}
	return flow;
}


///END FLOW

bool cb(int x, int y) {
	return x >= 0 && x < R
		&& y >= 0 && y < C
		&& brd[x][y] == '.';
}

int main() {
	int tc;
	scanf("%d", &tc);

	int i, j, k;
	for (int ctc = 1; ctc <= tc; ++ctc) {
		scanf("%d %d ", &R, &C);

		for (i = 0; i < R; ++i) {
			fgets(brd[i], MAXROW, stdin);
			brd[i][C] = '\0';
		}

		clear_graph();
		create_bipart(R * (C + 1) / 2, R * C / 2);
		for (j = 0; j < C; j += 2) {
			for (i = 0; i < R; ++i) {
				if (cb(i, j)) {
					for (k = 0; k < 6; ++k)
						if (cb(i+di[k], j+dj[k]))
							add_edge(idx1(i, j), idx2(i+di[k], j+dj[k]));
				}
			}
		}

		int empty_cells = 0;
		for (i = 0; i < R; ++i)
			for (j = 0; j < C; ++j)
				empty_cells += cb(i, j);

		int mincut = dinitz();
		printf("Case #%d: %d\n", ctc, empty_cells - mincut);
	}
}
