/*
FROM: Croatia Final Competition in Informatics 2001 day 2
PROB: fatboy
KEYW: dynamical programming with prev optimizations (2 * dp instead of dp + prev)
*/

#include <cstdio>
#include <cassert>
#include <cstring>

char msg[3][110];
int len[3];

char res[2][110];
int rlen[2];

bool dp[110][110][4];

bool dpf (int mid, int rid) {
	memset (dp, 0, sizeof (dp));
	int i, j, k, jj;
	for (i = 0; i < 4; ++i)
		if (msg[mid][i] == res[rid][0])
			dp[0][i][3-i] = 1;

//	printf ("mid, rid %d %d\n", mid, rid);
	for (i = 0; i < rlen[rid]; ++i)
		for (j = 0; j < len[mid]; ++j)
			for (k = 0; k <= 3; ++k) {
				if (dp[i][j][k] == 0) continue;
//				printf ("%d %d %d == 1\n", i, j, k);
				if (i == rlen[rid] - 1) return 1;
				for (jj = j + 1; jj <= j + k + 4; ++jj) {
//					printf ("\t%d %d %d\n", i+1, jj, j + k + 4 - jj <? 3);
					dp[i+1][jj][j+k+4-jj<?3] = 1;
				}
			}

	return 0;
}

int main (int argc, char *argv[]) {
	assert (argc == 4);

	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
	FILE *sol = fopen (argv[3], "r");

	fgets (msg[0], 110, in); len[0] = strlen (msg[0]) - 1;
	fgets (msg[1], 110, in); len[1] = strlen (msg[1]) - 1;
	fgets (msg[2], 110, in); len[2] = strlen (msg[2]) - 1;

	fgets (res[0], 110, out); rlen[0] = strlen (res[0]) - 1;
	fgets (res[1], 110, sol); rlen[1] = strlen (res[1]) - 1;

	int rmask1 = dpf (0, 0) << 2 | dpf (1, 0) << 1 | dpf (0, 0);
	int rmask2 = dpf (0, 1) << 2 | dpf (1, 1) << 1 | dpf (2, 1);

	if (rmask2 != 7) printf ("wrong test??\n");
	if (rmask1 != 7) printf ("wrong solution!!\n");
	if (rlen[0] < rlen[1]) printf ("my solution is better?\n");
	if (rlen[0] > rlen[1]) printf ("wrong solution (longer)\n");
	printf ("everything seems correct!\n");

	return 0;
}
