/*
FROM: Croatia Final Competition in Informatics 2001 day 1
PROB: power
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 10;
const int INF = 1 << 30;

int N, S;
int dp[MAXN][MAXN];
int pos[MAXN], pow[MAXN];
int lsum[MAXN], rsum[MAXN];

inline int sum (int lb, int rb) {
//	printf ("\tsum %d %d -- %d\n", lb, rb, lsum[lb] + rsum[rb]);
	return lsum[lb] + rsum[rb];
}

int main () {
	scanf ("%d %d", &N, &S);

	int i;
	for (i = 1; i <= N; ++i)
		scanf ("%d %d", pos + i, pow + i);

	for (i = 1; i <= N+1; ++i) lsum[i] = lsum[i-1] + pow[i];
	for (i = N; i >= 0; --i) rsum[i] = rsum[i+1] + pow[i];

	pos[0] = pos[1];
	pos[N+1] = pos[N];

	int d, wb;
	for (d = N-1, wb = 1; d; --d) {
		//0 [d] --> 0 [d+1]
		dp[d][0] = dp[d+1][0] + wb * sum (0, d + 1) * (pos[d+1] - pos[d]);
//		printf ("dp[%d][%d] -- %d\n", d, 0, dp[d][0]);
		for (i = 1; i + d <= N; ++i) {
			dp[i][i+d] = dp[i+d][i] = INF;
			//[i] i+d --> [i-1] i+d
			if (i != 1) dp[i][i+d] <?= dp[i-1][i+d] + wb * sum (i - 1, i + d) * (pos[i] - pos[i-1]);
			//[i] i+d --> i-1 [i+d]
			dp[i][i+d] <?= dp[i+d][i-1] + wb * sum (i - 1, i + d) * (pos[i+d] - pos[i]);
//			printf ("dp[%d][%d] -- %d\n", i, i + d, dp[i][i+d]);
		
			//i [i+d] --> i [i+d+1]
			if (i+d != N) dp[i+d][i] <?= dp[i+d+1][i] + wb * sum (i, i + d + 1) * (pos[i+d+1] - pos[i+d]);
			//i [i+d] --> [i] i+d+1
			dp[i+d][i] <?= dp[i][i+d+1] + wb * sum (i, i + d + 1) * (pos[i+d] - pos[i]);
//			printf ("dp[%d][%d] -- %d\n", i+d, i, dp[i+d][i]);
		}
		//[N+1-d] N+1 --> [N-d] N+1
		dp[N+1-d][N+1] = dp[N-d][N+1] + wb * sum (N - d, N + 1) * (pos[N+1-d] - pos[N-d]);
//		printf ("dp[%d][%d] -- %d\n", N+1-d, N+1, dp[N+1-d][N+1]);
	}

	printf ("%d\n", dp[S][S+1]);

	return 0;
}
