/*
FROM: Cro 2001 Final second day
PROB: marica
KEYW: heap djikstra
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 1024;
const int MAXN2 = 2048;
const int MAXM = 524288;
const int _infinity = 100000000;

struct heap {
    int to;
    int dist;
};

heap h[MAXN2];
int hend;
int index[MAXN];
bool used[MAXN];

struct el {
    int to;
    int dist;
    int next;
//    el *rev;
};

int N, M;
int vec[MAXN];
el buf[MAXM*2];
int bp;
int prev[MAXN];

void prnt_heap ();

void init () {
//    N*=2;
    h[0].to = -1;
    h[0].dist = -_infinity;
    for (int i = 1; i < MAXN2; ++i) {
        h[i].dist = _infinity;
        h[i].to = -1;
    }
//    N/=2;
    for (int i = 0; i < N; ++i) {
        index[i] = -1;//element i is NOT in the heap
        used[i] = 0;
    }
    hend = 1;
}

heap pop () {
    if (hend == 1) {
        printf ("CAN NOT POP!!!!\n");
        heap pppp;
        return pppp;
    }
    
    heap ret = h[1];
    heap tomove = h[--hend];
    h[hend].to = -1;
    h[hend].dist = _infinity;

    int p1 = 1, p2 = 2;
    for (;;) {
        if (h[p2+1].dist < h[p2].dist)
            p2++;

        if (h[p2].dist < tomove.dist) {
            h[p1] = h[p2];
            index[h[p2].to] = p1;
            p1 = p2;
            p2 *= 2;
        } else
            break;
    }
    h[p1] = tomove;
    index[tomove.to] = p1;
    index[ret.to] = -1;
    used[ret.to] = 1;//do not add again
    return ret;
}

void siftup (int id) {
    heap tomove = h[index[id]];
    int p1 = index[id], p2 = p1/2;

    for (;;) {
        if (tomove.dist < h[p2].dist) {
            h[p1] = h[p2];
            index[h[p2].to] = p1;
            p1 = p2;
            p2 /= 2;
        } else
            break;
    }
    h[p1] = tomove;
    index[id] = p1;
}

void add (int to, int dist) {
    if (index[to] != -1) {
        if (h[index[to]].dist > dist) {
            h[index[to]].dist = dist;
            siftup (to);
        }
    } else {
        index[to] = hend++;
        h[index[to]].to = to;
        h[index[to]].dist = dist;
        siftup (to);
    }
}

int dijkstra () {
    int i;
    int d[MAXN];
    int set[MAXN], sp = N;
    for (i = 0; i < N; ++i) {
        d[i] = _infinity;
        set[i] = i;
    }
//    set[0] = set[--sp];//remove 0 from set
    d[0] = 0;

    int min, mini, rx;
    for (;;) {
        min = _infinity;
        for (i = 0; i < sp; ++i) {
            if (d[set[i]] < min) {
                min = d[set[i]];
                mini = i;
            }
        }
        
        if (set[mini] == N-1) {//reached the final town
            return min;
        }
        
        rx = set[mini];
//        printf ("%d popped\n", rx);
        set[mini] = set[--sp];
    
        for (i = vec[rx]; i != -1; i = buf[i].next)
            if (d[buf[i].to] > min + buf[i].dist) {
                d[buf[i].to] = min + buf[i].dist;
                prev[buf[i].to] = rx;
            }
    }
}
int dijkstra2 () {
    int i;
    init ();
    add (0, 0);//add the starting point
    
    heap crnt;
    for (;;) {
        crnt = pop ();
        if (crnt.to == N-1)
            return crnt.dist;

        for (i = vec[crnt.to]; i != -1; i = buf[i].next)
            if (!used[buf[i].to]) {
                add (buf[i].to, crnt.dist + buf[i].dist);
            }
    }
}

void remove (int x, int y, int &id1, int &id2) {
    int i;
    if (buf[vec[x]].to == y) {
        id1 = vec[x];
        vec[x] = buf[id1].next;
        goto lbl2;
    }
    for (i = vec[x]; buf[i].next != -1; i = buf[i].next) {
//       printf ("fst cycle %d\n", i);
        if (buf[buf[i].next].to == y) {
            id1 = buf[i].next;
            buf[i].next = buf[id1].next;
            break;
        }
    }
    lbl2:;
    if (buf[vec[y]].to == x) {
        id2 = vec[y];
        vec[y] = buf[id2].next;
        return;
    }
    for (i = vec[y]; buf[i].next != -1; i = buf[i].next) {
//        printf ("scnd cycle %d\n", i);
        if (buf[buf[i].next].to == x) {
            id2 = buf[i].next;
            buf[i].next = buf[id2].next;
            break;
        }
    }
}

void putback (int x, int y, int id1, int id2) {
    buf[id1].next = vec[x];
    vec[x] = id1;
    buf[id2].next = vec[y];
    vec[y] = id2;
}

void prnt () {
    for (int i = 0; i < N; ++i) {
        printf ("%d ->", i+1);
        for (int j = vec[i]; j != -1; j = buf[j].next)
            printf (" %d", buf[j].to+1);
        printf ("\n");
    }
}

void prnt_heap () {
    int i = 1;
    for (int j = 2; j < N*2; j *= 2) {
        for (; i < j; ++i) {
            printf ("(%d,%d)", h[i].to, h[i].dist);
        }
        printf ("\n");
    }
}

int main () {
    int i;
//    FILE *xxxx = freopen ("marica.inx", "r", stdin);
    scanf ("%d%d", &N, &M);
    
    int x,y,l;
    for (i = 0; i < N; ++i) vec[i] = -1;//NULL :)
    for (i = 0; i < M; ++i) {
        scanf ("%d%d%d", &x, &y, &l);    
        x--; y--;
        buf[bp].to = y;
        buf[bp].dist = l;
        buf[bp].next = vec[x];
        vec[x] = bp++;

        buf[bp].to = x;
        buf[bp].dist = l;
        buf[bp].next = vec[y];
        vec[y] = bp++;
    }
//    fclose (xxxx);
    for (i = 0; i < N; ++i) prev[i] = i;
    dijkstra ();//to set prev[]
    
/*    for (i = N-1; i != prev[i]; i = prev[i]) {
        printf ("%d ", i);
    }
    printf ("\n");
*/    
    int m, max = 0, id1, id2;
    for (i = N-1; i != prev[i]; i = prev[i]) {
//        printf ("before remove");
        remove (i, prev[i], id1, id2);
//        printf ("after remove:\n");
//        prnt ();
//       printf ("removed %d %d\n", i, prev[i]);
//        prnt ();

        if ((m = dijkstra2()) > max)
            max = m;
        putback (i, prev[i], id1, id2);
//        printf ("after putback:\n");
//        prnt ();
//        system ("PAUSE");
    }

    printf ("%d\n", max);
//    system ("PAUSE");

    return 0;
}

