/*
FROM: Croatia Final Competition in Informatics 2002 day 2
PROB: dogs
KEYW: output checker
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <utility>

std::pair <int, int> operator + (const std::pair <int, int> &a, const std::pair <int, int> &b) {
	return std::make_pair (a.first + b.first, a.second + b.second);
}

int mhdst (const std::pair <int, int> &a, const std::pair <int, int> &b) {
	return abs (a.first - b.first) + abs (a.second - b.second);
}

int main (int argc, char *argv[]) {
	assert (argc == 3);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
	assert (in && out);

	int N;
	fscanf (in, "%d", &N);
	std::pair <int, int> ppos, tpos, cpos;
	int d, pd;
	fscanf (in, "%d %d %d", &tpos.first, &tpos.second, &pd);
	fscanf (out, "%d %d", &ppos.first, &ppos.second);
	assert (mhdst (tpos, ppos) <= d);
	for (int i = 1; i < N; ++i) {
		fscanf (in, "%d %d %d", &tpos.first, &tpos.second, &d);
		fscanf (out, "%d %d", &cpos.first, &cpos.second);
		assert (mhdst (cpos, tpos) <= d);
		assert (mhdst (ppos + std::make_pair (0, pd), cpos) <= d);
		assert (mhdst (ppos + std::make_pair (0, -pd), cpos) <= d);
		assert (mhdst (ppos + std::make_pair (pd, 0), cpos) <= d);
		assert (mhdst (ppos + std::make_pair (-pd, 0), cpos) <= d);
		pd = d;
		ppos = cpos;
	}

	printf ("everything seems ok!\n");

	return 0;
}

