/*
FROM: Croatia Final Competition in Informatics 2002 day 2
PROB: dogs
KEYW: linear dp
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <utility>

const int MAXN = 1 << 17;

struct rec {
	int u, d, l, r;
	rec () {}
	rec (int _x, int _y, int _d) {
		int x = _x + _y;
		int y = _x - _y;
		l = x - _d; r = x + _d;
		d = y - _d; u = y + _d;
		fix ();
	}

	rec (int x, int y, int dd, int) {
		l = x - dd; r = x + dd;
		d = y - dd; u = y + dd;
		fix ();
	}

	rec (const rec &a, int ddif) {
		l = a.l - ddif; r = a.r + ddif;
		d = a.d - ddif; u = a.u + ddif;
		fix ();
	}
	rec (const rec &a, const rec &b) {
		l = a.l >? b.l; r = a.r <? b.r;
		d = a.d >? b.d; u = a.u <? b.u;
		fix ();
	}
	rec & operator = (const rec &a) {
		l = a.l; r = a.r;
		d = a.d; u = a.u;
		return *this;
	}
	
	std::pair <int, int> one_point () const {
		return (l + d) & 1 ? in (l + 1, d) ? std::make_pair (l + 1, d) : std::make_pair (l, d + 1) : std::make_pair (l, d);
	}

	void fix () {
		assert (l <= r && d <= u);
/*		if (l == r && d & 1) ++d;
		if (l == r && u & 1) --u;
		if (d == u && l & 1) ++l;
		if (d == u && r & 1) --r;*/
	}

	bool in (int x, int y) const {
		return (l <= x && x <= r && d <= y && y <= u);
	}

	void prnt (bool newline = 1) const {
		printf (" %d %d %d %d", l, r, d, u);
		if (newline) puts ("");
	}
};

int N;
int d[MAXN];
rec can[MAXN];

std::pair <int, int> find (const rec &a, int x, int y, int d) {
	return rec (a, rec (x, y, d, 1)).one_point ();
}

int main () {
	scanf ("%d", &N);

	int i;
	int x, y;
	scanf ("%d %d %d", &x, &y, d);
	can[0] = rec (x, y, d[0]);
	for (i = 1; i < N; ++i) {
		scanf ("%d %d %d", &x, &y, d + i);
		can[i] = rec (rec (x, y, d[i]), rec (can[i-1], d[i] - d[i-1]));
	}

	static std::pair <int, int> res[MAXN];
	res[N-1] = can[N-1].one_point ();

	for (i = N-2; i >= 0; --i)
		res[i] = find (can[i], res[i+1].first, res[i+1].second, d[i+1] - d[i]);

	for (i = 0; i < N; ++i)
		printf ("%d %d\n"
		, (res[i].first + res[i].second) / 2
		, res[i].first - (res[i].first + res[i].second) / 2);

	return 0;
}
