/*
FROM: Croatia Final Competition in Informatics 2002 day 2
PROB: dogs
KEYW: linear dp
*/

#include <cstdio>
#include <cassert>
#include <utility>

const int MAXN = 1 << 17;

struct rec {
	int u, d, l, r;
	rec () {}
	rec (int _x, int _y, int _d) {
		int x = _x + _y;
		int y = _x - _y;
		l = x - _d;
		r = x + _d;
		d = y - _d;
		u = y + _d;
		fix ();
	}

	rec (const rec &a, int ddif) {
		l = a.l - ddif;
		r = a.r + ddif;
		d = a.d - ddif;
		u = a.u + ddif;
		fix ();
	}
	rec (const rec &a, const rec &b) {
		l = a.l >? b.l;
		r = a.r <? b.r;
		d = a.d >? b.d;
		u = a.u <? b.u;
		fix ();
	}
	rec & operator = (const rec &a) {
		l = a.l; r = a.r;
		d = a.d; u = a.u;
		return *this;
	}
	
	void fix () {
/*		if (l == r && d & 1) ++d;
		if (l == r && u & 1) --u;
		if (d == u && l & 1) ++l;
		if (d == u && r & 1) --r;*/
	}

	bool in (int x, int y) const {
		return (l <= x && x <= r && d <= y && y <= u);
	}

	void prnt (bool newline = 1) const {
		printf (" %d %d %d %d", l, r, d, u);
		if (newline) puts ("");
	}
};

int N;
int d[MAXN];
rec can[MAXN];

std::pair <int, int> my_try (const rec &a, int x1, int y1, int x2, int y2) {
	if (a.in (x1, y1)) return std::make_pair (x1, y1);
	if (a.in (x2, y2)) return std::make_pair (x2, y2);
	if (x1 == a.l || x1 == a.r) {
		if ((x1 + ((y1 + y2) / 2)) & 1)
			return my_try (a, x1, (y1 + y2) / 2 - 1, x1, (y1 + y2) / 2 + 1);
		else
			return std::make_pair (x1, (y1 + y2) / 2);
	}
	if (y1 == a.d || y1 == a.u) {
		if (((x1 + x2) / 2 + y1) & 1)
			return my_try (a, (x1 + x2) / 2 - 1, y1, (x1 + x2) / 2 + 1, y1);
		else
			return std::make_pair ((x1 + x2) / 2, y1);
	}
	assert (0);
}

std::pair <int, int> find (const rec &a, int x, int y) {
//	printf ("find "); a.prnt (0); printf ("  %d %d\n", x, y);
	if (a.in (x, y)) {
//		printf ("return %d %d\n", x, y);
		return std::make_pair (x, y);
	}

	if (x < a.l
	 && a.l - x >= y - a.u
	 && a.l - x >= a.d - y)
		return my_try (a, a.l, y + a.l - x, a.l, y - a.l + x);

	if (x > a.r
	 && x - a.r >= y - a.u
	 && x - a.r >= a.d - y)
		return my_try (a, a.r, y + x - a.r, a.r, y - x + a.r);

	if (y < a.d
	 && a.d - y >= a.l - x
	 && a.d - y >= x - a.r)
		return my_try (a, x + a.d - y, a.d, x - a.d + y, a.d);

	if (y > a.u
	 && y - a.u >= a.l - x
	 && y - a.u >= x - a.r)
		return my_try (a, x + y - a.u, a.u, x - y + a.u, a.u);

	assert (0);
}

int main () {
	scanf ("%d", &N);

	int i;
	int x, y;
	scanf ("%d %d %d", &x, &y, d);
	can[0] = rec (x, y, d[0]);
	for (i = 1; i < N; ++i) {
		scanf ("%d %d %d", &x, &y, d + i);
//		printf ("%d ---", i); rec (x, y, d[i]).prnt (0); rec (can[i-1], d[i] - d[i-1]).prnt ();
		can[i] = rec (rec (x, y, d[i]), rec (can[i-1], d[i] - d[i-1]));
	}

/*	for (i = 0; i < N; ++i)
		can[i].prnt ();*/


	static std::pair <int, int> res[MAXN];
	res[N-1] = find (can[N-1], can[N-1].l, can[N-1].d + (can[N-1].l + can[N-1].d) % 2);
//	printf ("%d %d=--------\n", res[N-1].first, res[N-1].second);

	for (i = N-2; i >= 0; --i)
		res[i] = find (can[i], res[i+1].first, res[i+1].second);

	for (i = 0; i < N; ++i)
		printf ("%d %d\n"
//		, i
//		, res[i].first, res[i].second
		, (res[i].first + res[i].second) / 2
		, res[i].first - (res[i].first + res[i].second) / 2);

	return 0;
}
