/*
FROM: Croatia 2002 Final Exam 2nd day
PROB: tele
KEYW: dynamical programming in tree, base task
*/

#include <cstdio>
#include <vector>
#include <cstdlib>

const int MAXN = 1 << 12;
const int MAXM = 1 << 12;
const int _infinity = 1 << 29;

struct el {
	int to;
	int cost;
};

int N, M;
std::vector <std::vector <el> > vec;

int p[MAXM];

int opt[MAXN][MAXM];

void fill_opt () {
	for (int i = 0; i < N; ++i)
		for (int j = 0; j <= M; ++j)
			opt[i][j] = -_infinity;
}

int optf (int a) {
	if (a >= N - M) {//leaf <-> user
		opt[a][0] = 0;
		opt[a][1] = p[a-(N-M)];
		return 1;
	}

	int uc = 0;
	int i, j, k;
	for (i = 0; i < (int)vec[a].size (); ++i)
		uc += optf (vec[a][i].to);

	opt[a][0] = 0;
	for (i = 0; i < (int)vec[a].size (); ++i)
		for (j = uc; j > 0; --j)
			for (k = 0; k <= j; ++k)
				opt[a][j] >?= opt[a][k] + opt[vec[a][i].to][j-k] - vec[a][i].cost;

	return uc;
}

int main () {
	scanf ("%d %d", &N, &M);
	vec.resize (N-M);

	int i, j;
	int k;
	for (i = 0; i < N-M; ++i) {
		scanf ("%d", &k);
		vec[i].resize (k);

		for (j = 0; j < k; ++j) {
			scanf ("%d %d", &vec[i][j].to, &vec[i][j].cost);
			--vec[i][j].to;
		}
	}

	for (i = 0; i < M; ++i)
		scanf ("%d", p + i);

	fill_opt ();
	optf (0);
	for (i = M; i >= 0 && opt[0][i] < 0; --i);

	printf ("%d\n", i);

	return 0;
}
