/*
FROM: Croatia Final Competition in Informatics 2003 day 1
PROB: list
KEYW: output checker
*/

#include <cstdio>
#include <cassert>
#include <list>
#include <vector>
#include <queue>
#include <utility>

const int MAXN = 1 << 17;

int N;
int deg[MAXN];
int row[MAXN];

std::pair <int, int> edges[MAXN];
std::list <int> gr[MAXN];
std::priority_queue <int, std::vector <int>, std::greater <int> > leafs;

int main (int argc, char *argv[]) {
	assert (argc == 3);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
	assert (in && out);

	fscanf (in, "%d", &N);
	int i;
	for (i = 0; i < N - 1; ++i)
		fscanf (in, "%d", row + i);

	for (i = 0; i < N - 1; ++i) {
		fscanf (out, "%d %d", &edges[i].first, &edges[i].second);
		gr[edges[i].first].push_back (edges[i].second);
		gr[edges[i].second].push_back (edges[i].first);
		++deg[edges[i].first];
		++deg[edges[i].second];
	}

	for (i = 1; i <= N; ++i)
		if (deg[i] == 1)
			leafs.push (i);

	int leaf, hang;
	for (i = 0; i < N - 1; ++i) {
		leaf = leafs.top (); leafs.pop ();
		assert (gr[leaf].size () == 1);
		hang = *gr[leaf].begin ();
		gr[leaf].erase (gr[leaf].begin ());
		for (std::list <int> :: iterator it = gr[hang].begin (); it != gr[hang].end (); ++it)
			if (*it == leaf) {
				gr[hang].erase (it);
				break;
			}
		if (++gr[hang].begin () == gr[hang].end ())
			leafs.push (hang);

		assert (hang == row[i]);
	}

	printf ("everything seems ok!\n");

	return 0;
}
