/*
FROM: Croatia Final Competition in Informatics 2004 day 1
PROB: grupe
KEYW: stack, linear, connection problem
*/

#include <cstdio>
#include <cassert>

const int MAXN = 1 << 19;

int N;
int nxt[MAXN];
int sz[MAXN];
int lb[MAXN], ub[MAXN];
int mine[MAXN], maxe[MAXN];
int row[MAXN];

int find_g (int s) {
	for (; s != nxt[s]; s = nxt[s]) nxt[s] = nxt[nxt[s]];
	return s;
}

int join (int g1, int g2) {
	assert (g1 == nxt[g1] && g2 == nxt[g2]);
	if (sz[g1] > sz[g2]) {
		nxt[g2] = g1;
		sz[g1] += sz[g2];
	} else {
		nxt[g1] = g2;
		sz[g2] += sz[g1];
	}
	assert (nxt[g1] == nxt[g2]);
	return nxt[g1];
}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d", row + i);
		mine[i] = maxe[i] = row[i];
		lb[i] = i;
		ub[i] = i+1;
		nxt[i] = i;
		sz[i] = 1;
	}

	static int ans[MAXN][2], ap;

	int cgr, pgr, ngr;
	int nmin, nmax, nlb, nub;
	for (i = 1; i != N;) {
		cgr = find_g (i);
		assert (i == lb[cgr]);
		if (i == 0) {//no previous
			i = ub[cgr];
			continue;
		}
		pgr = find_g (i - 1);
		if (maxe[pgr] + 1 == mine[cgr]
		 || maxe[cgr] + 1 == mine[pgr]) {
			nmin = mine[cgr] <? mine[pgr];
			nmax = maxe[cgr] >? maxe[pgr];
			nlb = lb[pgr];
			nub = ub[cgr];

			ngr = join (cgr, pgr);
			mine[ngr] = nmin; maxe[ngr] = nmax;
			lb[ngr] = nlb; ub[ngr] = nub;

			

			ans[ap][0] = nmin;
			ans[ap][1] = nmax;
			ap++;
			i = lb[ngr];
		} else
			i = ub[cgr];
	}	

	if (ap == N-1) {
		printf ("DA\n");
		for (i = 0; i < ap; ++i)
			printf ("%d %d\n", ans[i][0], ans[i][1]);
	} else
		printf ("NE\n");

	return 0;
}
