/*
FROM: Croatia Final Competition in Informatics 2004 day 1
PROB: mapa
KEYW: coordinate transformation, closest point with cmp (a, b) -- (abs (a.x - b.x) >? abs (a.y - b.y))
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 17;
const int INF = 1 << 30;

struct pos {
	int x, y;
	pos () {}
	pos (int _x, int _y) : x (_x), y (_y) {}
	int dst (const pos &a) {return abs (x - a.x) >? abs (y - a.y);}
};

int N;
pos coor[MAXN];

bool cmpx (const pos &a, const pos &b) {
	return a.x != b.x ? a.x < b.x : a.y < b.y;
}

bool cmpy (const pos &a, const pos &b) {
	return a.y != b.y ? a.y < b.y : a.x < b.x;
}

int main () {
	scanf ("%d", &N);

	int i, j;
	int minx = INF, miny = INF, maxx = -1, maxy = -1;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &coor[i].x, &coor[i].y);
		coor[i].y *= 3;
		minx <?= coor[i].x; maxx >?= coor[i].x;
		miny <?= coor[i].y; maxy >?= coor[i].y;
	}

	int ans = INF;
	if (maxx - minx > maxy - miny) {
		printf ("x!\n");
		std::sort (coor, coor + N, cmpx);
		for (i = 0; i < N; ++i) {
			printf ("%d %d\n", coor[i].x, coor[i].y);
			for (j = i + 1; j < N && coor[j].x - coor[i].x < ans; ++j) {
				printf ("\t%d %d -- %d\n", coor[j].x, coor[j].y, coor[i].dst (coor[j]));
				ans <?= coor[i].dst (coor[j]);
			}
		}
	} else {
		printf ("y!\n");
		std::sort (coor, coor + N, cmpy);
		for (i = 0; i < N; ++i) {
			printf ("%d %d\n", coor[i].x, coor[i].y);
			for (j = i + 1; j < N && coor[j].y - coor[i].y < ans; ++j) {
				printf ("\t%d %d -- %d\n", coor[j].x, coor[j].y, coor[i].dst (coor[j]));
				ans <?= coor[i].dst (coor[j]);
			}
		}
	}

	printf ("%.2lf\n", ans / 3.);

	return 0;
}
