#include "sifrelib.h"

#include <cstring>
#include <cassert>
#include <cstdio>
#include <cstdlib>

namespace {
	FILE *log;
	const int MAXPASSCNT = 1 << 7;
	const int MAXPASSLEN = 1 << 7;
	const int MAXCALLSCNT = 1700;


	int calls_cnt = 0;

	int N;
	char data[MAXPASSCNT][MAXPASSLEN];
	int passlen[MAXPASSCNT];

	int mystrcmp (const char *a, const char *b) {
		int i;
		for (i = 0; a[i]; ++i) {
			if (a[i] != b[i])
				break;
			if (!a[i]) {
				++i;
				break;
			}
		}

		return i + 1;
	}
}

void Init () {
	log = fopen ("sifrelib.log", "w");
	assert (log);

	scanf ("%d\n", &N);

	calls_cnt = 0;
	for (int i = 0; i < N; ++i) {
		gets (data[i]);
		passlen[i] = strlen (data[i]);
		fprintf (log, "%s - %d\n", data[i], passlen[i]);
	}
}

int Probaj (const char *a) {
	++calls_cnt;
	int ret =0;
	fprintf (log, "Probaj - %s - ", a);
	for (int i = 0; i < N; ++i)
		ret += mystrcmp (data[i], a);
	fprintf (log, "%d\n", ret);
	return ret;
}

void Rjesenje (const char *a) {
	fprintf (log, "Rjesenje %s\n", a);
	if (calls_cnt > MAXCALLSCNT)
		printf ("%d > %d - WRONG!\n", calls_cnt, MAXCALLSCNT);

	for (int i = 0; i < N; ++i)
		if (!strcmp (data[i], a)) {
			printf ("correct! - %d\n", calls_cnt);
			exit (0);
		}

	fclose (log);
	printf ("INCORRECT!\n");
	exit (0);
}
