/*
FROM: Croatia Final Exam 2005 1st day
PROB: papir
KEYW: dynamical programming with memory optimization, map
*/

#include <cstdio>
#include <vector>
#include <utility>
#include <map>

using std::make_pair;

const int MAXN = 1 << 14;

struct el {
	int len;
	int gone;
	el () : len (-1) {}
};
//////////////HASH/////////////
const int MAXHASH = (1 << 20) - 1;
struct node {
	std::pair <int, int> key;
	el val;
	node *next;
};

node *hash[MAXHASH];

int hashf (std::pair <int, int> key) {
	return (key.first * 10001 + key.second) % MAXHASH;
}

el pop (std::pair <int, int> key) {
	int line = hashf (key);
	for (node *i = hash[line]; i; i = i->next) {
		if (i->key == key)
			return i->val;
	}

	return el ();
}

void add (std::pair <int, int> key, el val) {
	int line = hashf (key);
	node *_new = new node;
	_new->key = key;
	_new->val = val;
	_new->next = hash[line];
	hash[line] = _new;
}

/////////////END HASH///////////

int N;
bool row[MAXN];
std::vector <std::vector <int> > vec1, vec2;

//std::map <std::pair <int, int>, el> opt;
//int cntr;

el rec (int l, int r) {
//	++cntr;
//	printf ("rec -- %d %d\n", l, r);
	el ret, tmp;
	ret.len = r - l;
	for (int i = 0; i < (int)vec1[l].size (); ++i) {
		if ((vec1[l][i] << 1) - l <= r) {
			tmp = pop (make_pair (vec1[l][i], r));
			if (tmp.len == -1)
				tmp = rec (vec1[l][i], r);

			if (tmp.len < ret.len) {
				ret.len = tmp.len;
				ret.gone = vec1[l][i];
//				printf ("opt from %d %d with %d\n", vec1[l][i], r, tmp.len);
			}
		} else
			break;
	}
//	printf ("mid %d %d\n", l, r);
	for (int i = (int)vec2[r].size () - 1; i >= 0; --i) {
		if (((r - vec2[r][i]) << 1) < r - l) {
			tmp = pop (make_pair (l, vec2[r][i]));
			if (tmp.len == -1)
				tmp = rec (l, vec2[r][i]);
			if (tmp.len < ret.len) {
				ret.len = tmp.len;
				ret.gone = vec2[r][i];
//				printf ("opt from %d %d with %d\n", l, vec2[r][i], tmp.len);
			}
		} else
			break;
	}

	add (make_pair (l, r), ret);
//	printf ("--rett -- (%d %d)%d %d\n", l, r, ret.len, ret.gone);

	return ret;
}

int main () {
	scanf ("%d\n", &N);
	vec1.resize (N);
	vec2.resize (N+1);

	int i, j;
	char tmp;
	for (i = 0; i < N; ++i) {
		scanf ("%c", &tmp);
		row[i] = (tmp == 'p');
	}

	for (i = 0; i < N - 1; ++i)
		for (j = 0; i - j >= 0 && i + j + 1 < N && row[i - j] != row[i + j + 1]; ++j) {
//			printf ("i,j %d %d\n", i, j);
			vec1[i - j].push_back (i + 1);
			vec2[i + j + 2].push_back (i + 1);
		}
/*
	for (i = 0; i <= N; ++i) {
		printf ("%d ->", i);
		for (j = 0; j < (int)vec2[i].size (); ++j)
			printf ("%d ", vec2[i][j]);
		printf ("\n");
	}
*/
	rec (0, N);

	printf ("%d\n", pop (make_pair (0, N)).len);
//	printf ("%d\n", cntr);

	return 0;
}
