/**/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <algorithm>

const int MAXN = 1 << 14;

int N;
int l, r;
bool vec[MAXN];

void dofold (int a) {
	static int i;
//	for (i = l; i < r; ++i) printf ("%d ", vec[i]); printf ("(%d)\n", a);
	assert (a < r - l);
	if (a <= (r - l) / 2) {
		for (i = 0; i < a; ++i)
			assert (vec[l + i] != vec[l + 2 * a - 1 - i]);
		l += a;
	} else {
		a = r - l - a;
		for (i = 0; i < a; ++i)
			assert (vec[r - i - 1] != vec[r - 2 * a + i]);
		r -= a;
		for (i = l; i < r; ++i) vec[i] = !vec[i];
		std::reverse (vec + l, vec + r);
	}
}

int main (int argc, char *argv[]) {
	static int i;
	assert (argc == 4);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
	FILE *sol = fopen (argv[3], "r");

	assert (in && out && sol);

	fscanf (in, "%d\n", &N);
	for (i = 0; i < N; ++i) {
		char tmp = getc (in);
		vec[i] = tmp == 'c';
	}
//	for (i = 0; i < N; ++i) printf ("%d ", vec[i]); printf ("\n");
	fclose (in);

	int len, targ_len;
	fscanf (out, "%d", &len);
	fscanf (sol, "%d", &targ_len);
//	printf ("%d %d\n", len, targ_len);
	assert (targ_len == len);

	int cop;
	fscanf (out, "%d", &cop);

	int a;
	l = 0, r = N;
	for (i = 0; i < cop; ++i) {
		fscanf (out, "%d", &a);
		dofold (a);
	}

	assert (r - l == len);
	printf ("looks correct!\n");

	return 0;
}
