/*
*/

#include <cstdio>
#include <string>
#include <iostream>
#include <sstream>
#include <cassert>

const int MAXN = 1 << 5;
const int MAXLINE = 1 << 6;
const int MOD = 10000;

int N, L;

int mymod (int a) {
	a %= MOD;
	if (a < 0)
		a += MOD;
	return a;
}

struct ma3x {
	int m[MAXN][MAXN];
	ma3x () {for (int i = 0; i < N; ++i) for (int j = 0; j < N; ++j) m[i][j] = 0;}
	ma3x& operator = (const ma3x &a) {for (int i = 0; i < N; ++i) for (int j = 0; j < N; ++j) m[i][j] = a.m[i][j]; return *this;}
	ma3x operator * (const ma3x &a) {ma3x res; for (int i = 0; i < N; ++i) for (int j = 0; j < N; ++j) for (int k = 0; k < N; ++k) res.m[i][j] += m[i][k] * a.m[k][j]; return res.norm ();}
	ma3x sq () {return ((*this) * (*this)).norm ();}
	void prnt () {for (int i = 0; i < N; ++i) {for (int j = 0; j < N; ++j) printf ("%d ", m[i][j]); printf ("\n");}}
	ma3x pow (int n) {if (n == 1) return *this; if (n & 1) return (pow (n - 1) * (*this)).norm (); else return (pow (n / 2).sq ()).norm ();}
	ma3x& norm () {for (int i = 0; i < N; ++i) for (int j = 0; j < N; ++j) m[i][j] = mymod (m[i][j]); return *this;}
};

ma3x ma3xs[MAXLINE];
bool ma3xscalc[MAXLINE];
int _cycle[MAXLINE];
int cycle[MAXLINE];
bool cycleprnt[MAXLINE];
int otherend[MAXLINE];
int prnt[MAXLINE];

ma3x base;

void init_vecs () {
	for (int i = 0; i < MAXLINE; ++i) {
		ma3xscalc[i] = 0;
		cycle[i] = -1;
		cycleprnt[i] = 0;
		otherend[i] = 1000;
		prnt[i] = -1;
	}

	for (int i = 0; i < N; ++i) {
		base.m[i][i] = 1;
	}
}

void calc_ma3x_line (int id, std::string line) {
//	printf ("%d --%s-\n", id, line.c_str ());
	ma3x crnt = base;
	int asgn_to;
	int tmpint;
	int var;

	std::string tmp, tmpx;
	std::istringstream in (line);

	in >> tmp;
	assert (tmp.size () == 1);
	asgn_to = tmp[0] - 'a';
	in >> tmp;
	assert (tmp == "=");

	crnt.m[asgn_to][asgn_to] = 0;

	bool csign = 0;//0 is +, 1 is -
	while (in) {
		in >> tmpx;
		if (tmpx == tmp) break;
		else tmp = tmpx;
//		printf ("-%s-", tmp.c_str ());
		if (tmp == "+" || tmp == "-") {
			csign = (tmp == "-");
//			printf ("now sign == %c\n", csign ? '-' : '+');
		} else {
			if (tmp[0] <= '9') {
				std::istringstream inn (tmp);
				inn >> tmpint;
			} else
				tmpint = 1;

			if (tmp[tmp.size () - 1] >= 'a')
				var = tmp[tmp.size () - 1] - 'a';
			else
				var = 26;//the 1 :)
//			printf ("xx%d %d\n", var, tmpint);
			if (csign)
				crnt.m[var][asgn_to] -= tmpint;
			else
				crnt.m[var][asgn_to] += tmpint;
		}
	}
	crnt.norm ();
	ma3xs[id] = crnt;
	ma3xscalc[id] = 1;
//	crnt.prnt ();
//	printf ("----%d------\n", id);
}

bool find_prnt (int id) {
	int beg = id;
	int i;
	bool ret = 0;
	for (i = id + 1; otherend[i] != beg; ++i) {
		if (cycle[i] != -1) {
			ret |= find_prnt (i);
			i = otherend[i];
		} else {
			ret |= (prnt[i] != -1);
		}
	}

	cycleprnt[beg] = ret;

	return ret;
}

void input () {
	int stck[MAXLINE];
	int stp = 0;
	std::string line;
	std::string tmp1, tmp2;
	int tmp3, tmp4;

	init_vecs ();
	int i;
	for (i = 0; std::cin; ++i) {
		getline (std::cin, line);
		if (line == "") break;
//		printf ("--%s--\n", line.c_str ());

		if (line == "BEGIN") {
			assert (i == 0);
			cycle[i] = 1;
			stck[stp++] = i;
			continue;
		}
		std::istringstream in (line);
		in >> tmp1;
		if (tmp1 == "REPEAT") {
			in >> tmp3;
			cycle[i] = tmp3;
			stck[stp++] = i;
		} else if (tmp1 == "STOP") {
			tmp4 = stck[--stp];
			otherend[i] = tmp4;
			otherend[tmp4] = i;
		} else if (tmp1 == "PRINT") {
			in >> tmp2;
			assert (tmp2.size () == 1);
			prnt[i] = tmp2[0] - 'a';
		} else {//it is '=' line
			calc_ma3x_line (i, line);
		}
	}
	L = i;
//	for (i = 0; i < L; ++i) printf ("%d ", otherend[i]); printf ("\n");
	for (i = 0; i < L; ++i) _cycle[i] = cycle[i];
	find_prnt (0);
}

void calc_cycle (int id) {
	ma3x crnt = base;
	int pow = _cycle[id];
	for (int i = id + 1; otherend[i] > i; ++i) {
		if (cycle[i] == -1)
			crnt = crnt * ma3xs[i];
		else if (ma3xscalc[i]) {
			crnt = crnt * ma3xs[i];
			i = otherend[i];
		} else {
			calc_cycle (i);
			crnt = crnt * ma3xs[i];
			i = otherend[i];
		}
	}
	ma3xs[id] = crnt.pow (pow);
	ma3xscalc[id] = 1;
}

int main () {
	N = 27;

	input ();
//	printf ("after input!\n");
	ma3x crnt = base;
	for (int i = 0; i != L; ++i) {
//		printf ("i == %d\n", i);
//		printf ("%d %d %d %d %d\n", prnt[i], cycle[i], cycleprnt[i], ma3xscalc[i], otherend[i]);
		if (otherend[i] < i)
			if (cycle[otherend[i]] != 0)
				i = otherend[i] - 1;
			else
				cycle[otherend[i]] = _cycle[otherend[i]];
		else if (prnt[i] != -1)
			printf ("%c = %d\n", prnt[i] + 'a', crnt.m[26][prnt[i]]);
		else if (cycle[i] == -1)
			crnt = crnt * ma3xs[i];
		else if (cycle[i] == 0)
			i = otherend[i];
		else if (cycleprnt[i])
			--cycle[i];
		else if (ma3xscalc[i]) {
			crnt = crnt * ma3xs[i];
			i = otherend[i];
		} else {
			calc_cycle (i);
			crnt = crnt * ma3xs[i];
			i = otherend[i];
		}
	}

	return 0;
}
