/*
FROM: Croatia 2005 National Junior 1st day
PROB: autoput
KEYW: dynamical programming
*/

#include <cstdio>
#include <cassert>

const int MAXN = 1 << 17;
const int infinity = 1 << 25;

int A, B, C;
int N, K;

char map[MAXN];

int h[MAXN * 2];
const int hBASE = MAXN;
int to[MAXN];
int dist[MAXN];

int _opt1[MAXN];
int _opt2[MAXN];

int todig1 (char c) {
	switch (c) {
		case 'D': return -1;
		case 'G': return 1;
		case 'R': return 0;
	}
	assert (0);
	return -1;
}

int todig2 (char c) {
	return (c ? B : A);
}

void swap (int *&a, int *&b) {
	int *c = a;
	a = b;
	b = c;
}

int main () {
	scanf ("%d %d %d\n", &A, &B, &C);
	scanf ("%d %d\n", &N, &K);
	gets (map);

	int i;
	for (i = 0; i < N; ++i) map[i] = todig1 (map[i]);

	for (i = 0; i <= N; ++i) to[i] = -1;//no prev
	for (i = 0; i < MAXN * 2; ++i) h[i] = -1;//unused

	int ch = hBASE;
	h[ch] = 0;
	for (i = 1; i <= N; ++i) {
		ch += map[i-1];

		if (h[ch] != -1 && h[ch] != i - 1) {
			to[i] = h[ch];
			dist[i] = i - h[ch];
		}
		h[ch] = i;
	}

	int *prev = _opt1, *opt = _opt2;
	prev[0] = 0;
	for (i = 1; i <= N; ++i)
		prev[i] = prev[i-1] + todig2 (map[i-1]);

	int k;
	int best = infinity;
	for (k = 1; k <= K; ++k) {
		opt[0] = infinity;//you CANNOT have used bridjes or aqueducts at the first square
		for (i = 1; i <= N; ++i) {
			opt[i] = (to[i] != -1 && prev[to[i]] + dist[i] * C < opt[i-1] + todig2 (map[i-1]) ?
									prev[to[i]] + dist[i] * C : opt[i-1] + todig2 (map[i-1]));
		}
		if (opt[N] >= infinity) break;
		swap (prev, opt);
		best <?= prev[N];
	}
//if breaked -> the K cannot be made in opt so the answer is in prev, else we have made a swap, and the answer is in prev too
	printf ("%d\n", best);

	return 0;
}
