/*
FROM: Croatia 2005 National Juniors 2nd day
PROB: lopta
KEYW: dynamical programming
*/

#include <cstdio>
#include <utility>

const int MAXN = 1 << 10;
const int DIR = 4;



int N, K;

bool map[MAXN][MAXN];
std::pair <int, int> opt[DIR][MAXN][MAXN];

int main () {
	scanf ("%d %d\n", &N, &K);

	int i, j;
	std::pair <int, int> cpos;
	char tmp;
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= N; ++j) {
			scanf ("%c", &tmp);
			map[i][j] = (tmp == 'X');
			if (tmp == 'L')
				cpos = std::make_pair (i, j);
		}
		scanf ("\n");
	}

	for (i = 0; i < N + 2; ++i) {
		map[i][0] = map[i][N+1] = 1;
		map[0][i] = map[N+1][i] = 1;
	}
/*
	for (i = 0; i < N + 2; ++i) {
		for (j = 0; j < N + 2; ++j)
			printf ("%d ", map[i][j]);
		printf ("\n");
	}
*/
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= N; ++j) {
			opt[2][i][j] = map[i-1][j] ? std::make_pair (i, j) : opt[2][i-1][j];
			opt[3][i][j] = map[i][j-1] ? std::make_pair (i, j) : opt[3][i][j-1];
		}

	for (i = N; i > 0; --i)
		for (j = N; j > 0; --j) {
			opt[0][i][j] = map[i+1][j] ? std::make_pair (i, j) : opt[0][i+1][j];
			opt[1][i][j] = map[i][j+1] ? std::make_pair (i, j) : opt[1][i][j+1];
		}

	int cdir = 0;
	cpos = opt[cdir][cpos.first][cpos.second];//just in case drop the ball
//	printf ("%d %d\n", cpos.first, cpos.second);
	for (i = 0; i < K; ++i) {
		scanf ("%c\n", &tmp);
//		printf ("tmp == __%c__(%d)\n", tmp, (tmp == 'D') ? 1 : -1);

		cdir += (tmp == 'D') ? 1 : -1;
		cdir = (cdir + DIR) % DIR;
		cpos = opt[cdir][cpos.first][cpos.second];
//		printf ("%d %d(%d)\n", cpos.first, cpos.second, cdir);
	}

	switch (cdir) {
		case 0: for (i = 1; i <= N; ++i) { for (j = 1; j <= N; ++j) printf ("%c", map[i][j] ? 'X' : cpos.first == i && cpos.second == j ? 'L' : '.'); printf ("\n");} break;
		case 1: for (j = 1; j <= N; ++j) { for (i = N; i >= 1; --i) printf ("%c", map[i][j] ? 'X' : cpos.first == i && cpos.second == j ? 'L' : '.'); printf ("\n");} break;
		case 2: for (i = N; i >= 1; --i) { for (j = N; j >= 1; --j) printf ("%c", map[i][j] ? 'X' : cpos.first == i && cpos.second == j ? 'L' : '.'); printf ("\n");} break;
		case 3: for (j = N; j >= 1; --j) { for (i = 1; i <= N; ++i) printf ("%c", map[i][j] ? 'X' : cpos.first == i && cpos.second == j ? 'L' : '.'); printf ("\n");} break;
	}

	return 0;
}
