/*
FROM: Croatia 2005 National Junior 2nd day
PROB: nogomet
KEYW: recursive, sort
*/

#include <cstdio>
#include <utility>
#include <algorithm>

using std::make_pair;

const int MAXK = 1 << 10;
const int MAXN = 1 << 7;

int N, K;
std::pair <std::pair <int, int>, std::pair <int, int> > vec[MAXK];

int idx[MAXN];

int pnts[MAXN];

int goaldiff[MAXN];
int goalscored[MAXN];
int wins[MAXN];

void add_all (std::pair <std::pair <int, int>, std::pair <int, int> > a) {
	goaldiff[a.first.first] += a.second.first - a.second.second;
	goaldiff[a.first.second] += a.second.second - a.second.first;

	goalscored[a.first.first] += a.second.first;
	goalscored[a.first.second] += a.second.second;

	wins[a.first.first] += a.second.first > a.second.second;
	wins[a.first.second] += a.second.first < a.second.second;
}

bool cmp1 (int a, int b) {
	return pnts[a] > pnts[b];
}

bool cmp2 (int a, int b) {
	return 	goaldiff[a] != goaldiff[b] ?
			goaldiff[a]  > goaldiff[b] :
			goalscored[a] != goalscored[b] ?
			goalscored[a]  > goalscored[b] :
			wins[a] != wins[b] ?
			wins[a]  > wins[b] :
			a < b;
}

void rec (int l, int r) {
	if (l + 1 == r) return;//nothing to do


	bool here[MAXN] = {0};
	int i;
	for (i = l; i < r; ++i) {here[idx[i]] = 1; pnts[idx[i]] = 0;}

	for (i = 0; i < K; ++i) if (here[vec[i].first.first] && here[vec[i].first.second]) {
		pnts[vec[i].first.first] += vec[i].second.first != vec[i].second.second ? vec[i].second.first > vec[i].second.second ? 3 : 0 : 1;
		pnts[vec[i].first.second] += vec[i].second.first != vec[i].second.second ? vec[i].second.first < vec[i].second.second ? 3 : 0 : 1;
	}

	std::sort (idx + l, idx + r, cmp1);

//	printf ("rec %d %d\n", l, r);
//	for (i = l; i < r; ++i) printf ("%d ", idx[i]); printf ("\n");

	int pend = l;
	for (i = l + 1; i < r; ++i)
		if (pnts[idx[i]] != pnts[idx[i-1]]) {
			rec (pend, i);
			pend = i;
		}
	if (pend != l)
		rec (pend, r);//the last group;
	else {
//		printf ("sort final\n");
		std::sort (idx + l, idx + r, cmp2);
	}
}

int main () {
	scanf ("%d %d", &N, &K);

	int i;
	int a, b, c, d;
	for (i = 0; i < K; ++i) {
		scanf ("%d %d %d:%d",&a, &b, &c, &d);
		--a; --b;
		vec[i] = make_pair (make_pair (a, b), make_pair (c, d));

		add_all (vec[i]);
	}
	for (i = 0; i < N; ++i) idx[i] = i;

	rec (0, N);

	printf ("%d", idx[0] + 1); for (i = 1; i < N; ++i) printf (" %d", idx[i] + 1); printf ("\n");

	return 0;
}
