/*
FROM: Croatia 2005 National Seniors 1st day
PROB: jmbg
KEYW: dynamical programming
*/

#include <cstdio>

const int LEN = 1 << 5;
const int MOD = 19;

char line[LEN];

long long opt[LEN][MOD];
int mul[] = {10, 9, 8, 7, 6, 5, 4, 3, 2, 10, 9, 8, 7, 6, 5, 4, 3, 2};
int inm[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

char tmp[1 << 4] = "00000000";

inline bool inc_year () {
	for (int add = 1, i = 7; add; --i)
		if (tmp[i] == '9')
			tmp[i] = '0';
		else {
			++tmp[i];
			add = 0;
		}
//	printf ("%c%c%c%c\n", tmp[4], tmp[5], tmp[6], tmp[7]);
	tmp[2] = tmp[3] = '0';
	return (line[4] != 'X' && line[4] != tmp[4] || line[5] != 'X' && line[5] != tmp[5] ||
			line[6] != 'X' && line[6] != tmp[6] || line[7] != 'X' && line[7] != tmp[7]);
}

inline bool inc_month () {
	++tmp[3];
	if (tmp[3] == '9' + 1) {
		tmp[3] = '0';
		++tmp[2];
	}

	tmp[0] = tmp[1] = '0';
	return (line[2] != 'X' && line[2] != tmp[2] || line[3] != 'X' && line[3] != tmp[3]);
}

inline bool inc_day () {
	++tmp[1];
	if (tmp[1] == '9' + 1) {
		tmp[1] = '0';
		++tmp[0];
	}
	return !(line[0] != 'X' && line[0] != tmp[0] || line[1] != 'X' && line[1] != tmp[1]);
}

inline bool leap (int y) {
	return !(y % 4) && (y % 100) || !(y % 400);
}

int getmod () {
	int res = 0;
	for (int i = 0; i < 8; ++i)
		res += mul[i] * (tmp[i] - '0');
	return res % MOD;
}

void gen () {
	int y, m, d;
	bool is_leap;
	for (y = 1; y < 10000; ++y) {
		if (inc_year ()) continue;
		is_leap = leap (y);
		for (m = 0; m < 12; ++m) {
			if (inc_month ()) continue;
			for (d = 0; d < inm[m] + (m == 1 && is_leap); ++d)
				if (inc_day ()) {
//					printf ("%s\n", tmp);
					++opt[8][getmod ()];
				}
		}
	}
}

int main () {
	gets (line);
	gen ();
/*////////////////
	int y;
	scanf ("%d", &y);
	printf ("%d\n", leap (y));
/*///////////////////

//	printf ("---%s---\n", line);
	int i, j, k;
	int lb, ub;
	for (i = 8; i < 18; ++i) {
		if (line[i] == 'X') {
			lb = 0; ub = 10;
		} else {
			lb = line[i] - '0';
			ub = lb + 1;
		}

		for (k = lb; k < ub; ++k)
			for (j = 0; j < MOD; ++j)
				opt[i + 1][(j + k * mul[i]) % MOD] += opt[i][j];
	}

	long long res =0;
	if (line[18] == 'X') {
		for (i = 0; i < MOD; ++i)
			res += opt[18][i];
	} else {
		if (line[18] != '0')
			res += opt[18][19 - (line[18] - '0')];
		res += opt[18][line[18] - '0'];
	}

	printf ("%Ld\n", res);

	return 0;
}
