/*
FROM: Croatia 2005 National Seniors 1st day
PROB: kvadrat
KEYW: full exhaustion
*/

#include <cstdio>
#include <cassert>
#include <iostream>

struct square {
	int a[3][3];
};

square sq;
square sol;

int sumr[3], sumc[3], summd, sumsd;
int ucr[3], ucc[3], ucmd, ucsd;


void prnt_stat () {
	int i;
	for (i = 0; i < 3; ++i) printf ("(%d %d) ", sumr[i], ucr[i]); printf ("\n");
	for (i = 0; i < 3; ++i) printf ("(%d %d) ", sumc[i], ucc[i]); printf ("\n");
	printf ("(%d %d)\n", summd, ucmd);
	printf ("(%d %d)\n", sumsd, ucsd);
}

void prnt_sol () {
	for (int i = 0; i < 3; ++i) {
		for (int j = 0; j < 3; ++j) {
			if (j) printf (" ");
			printf ("%d", sol.a[i][j]);
		}
		printf ("\n");
	}
}

void put (int i, int j, int val) {
//	printf ("--------------\nPUT %d %d %d\n", i, j, val);
	sol.a[i][j] = val;

	sumc[j] += val; --ucc[j];
	sumr[i] += val; --ucr[i];
	if (i == j) {
		summd += val;
		--ucmd;
	}
	if (i + j == 2) {
		sumsd += val;
		--ucsd;
	}
//	prnt_stat ();
//	prnt_sol ();
//	printf ("-------------\n");
}

bool now_fill (int sum) {
//	printf ("\nin now_fill %d\n", sum);
//	prnt_stat ();
//	prnt_sol ();
//	std::cin.get ();

	int i, j;

	for (i = 0; i < 3 && ucr[i] != 1; ++i);
	if (i != 3) {
		for (j = 0; j < 3 && sol.a[i][j]; ++j);

		put (i, j, sum - sumr[i]);

		return now_fill (sum);
	}

	for (j = 0; j < 3 && ucc[j] != 1; ++j);
	if (j != 3) {
		for (i = 0; i < 3 && sol.a[i][j]; ++i);

		put (i, j, sum - sumc[j]);

		return now_fill (sum);
	}

	if (ucmd == 1) {
		for (i = 0; i < 3 && sol.a[i][i]; ++i);
		put (i, i, sum - summd);

		return now_fill (sum);
	}

	if (ucsd == 1) {
		for (i = 0; i < 3 && sol.a[i][2-i]; ++i);
		put (i, 2-i, sum - sumsd);

		return now_fill (sum);
	}

	for (i = 0; i < 3; ++i) if (sum != sumc[i]) return 0;
	for (i = 0; i < 3; ++i) if (sum != sumr[i]) return 0;
	if (sum != summd) return 0;
	if (sum != sumsd) return 0;
	return 1;
}

bool find_sol () {
	int sum;
	int i, j;
	for (i = 0; i < 3; ++i)
		for (j = 0; j < 3; ++j)
			sol.a[i][j] = sq.a[i][j];

	for (i = 0; i < 3; ++i) {
		sumr[i] = 0; ucr[i] = 0;
		for (j = 0; j < 3; ++j) {
			sumr[i] += sq.a[i][j];
			ucr[i] += !sq.a[i][j];
		}
	}

	for (j = 0; j < 3; ++j) {
		sumc[j] = 0; ucc[j] = 0;
		for (i = 0; i < 3; ++i) {
			sumc[j] += sq.a[i][j];
			ucc[j] += !sq.a[i][j];
		}
	}

	summd = 0; ucmd = 0;
	for (i = 0; i < 3; ++i) {
		summd += sq.a[i][i];
		ucmd += !sq.a[i][i];
	}

	sumsd = 0; ucsd = 0;
	for (i = 0; i < 3; ++i) {
		sumsd += sq.a[i][2-i];
		ucsd += !sq.a[i][2-i];
	}

	for (i = 0; i < 3; ++i)
		if (ucr[i] == 0) {
			sum = sumr[i];
			break;
		}

	for (j = 0; j < 3; ++j)
		if (ucc[j] == 0) {
			sum = sumc[j];
			break;
		}

	if (ucmd == 0) sum = summd;
	if (ucsd == 0) sum = sumsd;

	return (now_fill (sum));
}

int main () {
	int i, j;
	for (i = 0; i < 3; ++i)
		for (j = 0; j < 3; ++j)
			scanf ("%d", &sq.a[i][j]);

	if (find_sol ()) {
		prnt_sol ();
		return 0;
	}

	for (i = 0; i < 3; ++i)
		for (j = 0; j < 3; ++j)
			if (sq.a[i][j] == 0) goto endfor;

	endfor:;
	for (int ii = 1; ii <= 20000; ++ii) {
		sq.a[i][j] = ii;
		if (find_sol ()) {
			prnt_sol ();
			return 0;
		}
	}
	printf ("no sol!\n");
	assert (0);

	return 0;
}
