#include "svemlib.h"

#include <cstdio>
#include <cstdlib>

namespace {
	typedef long long big;
	const int MAXCALLS = 200;

	int N;
	int X, Y, Z;
	big last_dist;
	big new_dist;

	void calc_dist (int x, int y, int z) {
		x -= X; y -= Y; z -= Z;
		new_dist = (long long)x * (long long)x + (long long)y * (long long)y + (long long)z * (long long)z;
	}
}

int DajN () {
	static bool called = 0;
	if (called) {printf ("calling DajN () again\n"); exit (-1);}
	called = 1;

	scanf ("%d %d %d %d", &N, &X, &Y, &Z);//read from the input

	return N;
}

int Pomak (int x, int y, int z) {
	static int calls = 0;
	if (++calls > MAXCALLS) {printf ("too many calls to Pomak(%d)\n", calls); exit (-1);}

	if (!(1 <= x && x <= N && 1 <= y && y <= N && 1 <= z && z <= N)) {
		printf ("wrong arguments to Pomak!(%d %d %d)\n", x, y, z);
		exit (-1);
	}
	if (x == X && y == Y && z == Z) {printf ("OK!(%d)\n", calls); exit (0);}
//	printf ("%d %d %d\n", x, y, z);

	::calc_dist (x, y, z);

	int ans;
	if (last_dist == new_dist) ans = 0;
	if (last_dist > new_dist) ans = -1;
	else					ans = 1;
	last_dist = new_dist;
//	printf ("dst == %Ld\n", new_dist);
	return ans;
}
