/*
FROM: Croatia 2005 National Seniors 2nd day
PROB: labudovi
KEYW: bfs, binary search
*/

#include <cstdio>
#include <queue>
#include <utility>
#include <vector>
#include <cstring>

using std::make_pair;

const int MAXR = 1 << 11;
const int MAXC = 1 << 11;

int difx[] = {0, 1, 0, -1};
int dify[] = {1, 0, -1, 0};

int R, C;
bool map[MAXR][MAXC];
int dm[MAXR][MAXC];

std::vector <std::pair <int, int> > leb;

std::queue <std::pair <int, int> > q;

void bfs1 () {
	int i, j, ni, nj;
	while (!q.empty ()) {
		i = q.front ().first;
		j = q.front ().second;
		q.pop ();

		for (int k = 0; k < 4; ++k) {
			ni = i + difx[k];
			nj = j + dify[k];
			if (map[ni][nj] && !dm[ni][nj]) {

				q.push (std::make_pair (ni, nj));
				dm[ni][nj] = dm[i][j] + 1;
			}
		}
	}
}

bool bfs2 (int a) {
	std::queue <std::pair <int, int> > q;
	static bool used[MAXR][MAXC];
	memset (used, 0, sizeof (used));

	q.push (leb[0]);
	used[leb[0].first][leb[0].second] = 1;

	int ni, nj, k;
	std::pair <int, int> crnt;
	while (!q.empty ()) {
		crnt = q.front (); q.pop ();
		if (crnt == leb[1]) return 1;

		for (k = 0; k < 4; ++k) {
			ni = crnt.first + difx[k];
			nj = crnt.second + dify[k];

			if (dm[ni][nj] <= a && !used[ni][nj]) {

				q.push (make_pair (ni, nj));
				used[ni][nj] = 1;
			}
		}
	}

	return 0;
}

int main () {
	scanf ("%d %d\n", &R, &C);

	int i, j;
	char tmp;
	for (i = 1; i <= R; ++i) {
		for (j = 1; j <= C; ++j) {
			scanf ("%c", &tmp);
			map[i][j] = (tmp == 'X');
			if (tmp == 'L')
				leb.push_back (make_pair (i, j));
		}
		scanf ("\n");
	}

	for (i = 1; i <= R; ++i)
		for (j = 1; j <= C; ++j)
			if (!map[i][j])
				q.push (std::make_pair (i, j));

	bfs1 ();

	int l = 0, r = R >? C, m;

	for (i = 0; i < R+2; ++i)
		dm[i][0] = dm[i][C+1] = MAXR * 2;
	for (j = 0; j < C+2; ++j)
		dm[0][j] = dm[R+1][j] = MAXR * 2;

	while (l + 1 < r) {
		m = (l + r) / 2;

		if (bfs2 (m))
			r = m;
		else
			l = m;
	}

	printf ("%d\n", r);

	return 0;
}
