/*
FROM: Croatia 2005 National Seniors 2nd day
PROB: utrka
KEYW: sort
*/

#include <cstdio>
#include <algorithm>
#include <utility>
#include <vector>
#include <cassert>

const int MAXN = 1 << 7;
const int MAXC = 1 << 7;
const int MAXM = 1 << 14;

int C, N, M;

int expect[MAXN];
int passed[MAXN];
int lastid[MAXN];

std::vector <std::pair <int, int> > log;

bool cmp (int a, int b) {
	return (passed[a] != passed[b] ?
			passed[a] > passed[b] :
			lastid[a] < lastid[b]);
}

int main () {
	scanf ("%d %d %d", &C, &N, &M);
	log.resize (M);

	int i;
	int x, y;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &x, &y);
		--x; --y;
		if (expect[x] != y) continue;
		expect[x] = (expect[x] + 1) % C;
		++passed[x];
		log[i] = std::make_pair (x, y);
		lastid[x] = i;
	}
/*
	for (i = 0; i < N; ++i) lastid[i] = -1;
	for (i = 0; i < N; ++i) expect[i] = (expect[i] + C - 1) % C;
	int cid = 0;
	for (i = M-1; i >= 0; --i) {
		if (lastid[log[i].first] == -1 && expect[log[i].first] == log[i].second)
			lastid[log[i].first] = cid++;
	}
*/
	for (i = 0; i < N; ++i) assert (lastid[i] != -1);

	int idx[MAXN];
	for (i = 0; i < N; ++i) idx[i] = i;
	std::sort (idx, idx + N, cmp);

	printf ("%d", idx[0] + 1); for (i = 1; i < N; ++i) printf (" %d", idx[i] + 1); printf ("\n");

	return 0;
}
