/*
FROM: Croatia National Olympiad in Informatics
PROB: deva
KEYW: module, bfs, permutations
*/

#include "devalib.h"

#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <cstring>

const int MAXN = 1 << 20;
const int MAXK = 1 << 4;

static int N, L;
static int K;
static int maxd;

static int gr[MAXK];
static int ref[MAXN];
static std::vector <std::vector <int> > vec;

bool uused[MAXN];

static void rec (int a, int d) {
	if (d >= maxd) return;
	static int tmp[10];
	static int n;
	if (uused[a]) return;
	uused[a] = 1;

	Neighbours (a, &n, tmp);

	for (int i = 0; i < n; ++i) {
		vec[a].push_back (tmp[i]);
		vec[tmp[i]].push_back (a);
	}

	for (int i = 0; i < (int)vec[a].size (); ++i)
		rec (vec[a][i], d + 1);
}

static bool ma3x[MAXK][MAXK];

static void bfs1 (int id) {
	static int queue[MAXN];
	static bool used[MAXN];
	memset (used, 0, sizeof (bool) * N);
	int p1 = 0, p2 = 1, p3 = 0, lvl = 0;
	queue[p3++] = gr[id];

	int i, j, crnt;
	while (p1 != p2 && lvl <= L) {
		for (i = p1; i < p2; ++i) {
			crnt = queue[i];
			if (ref[crnt] != -1)
				ma3x[id][ref[crnt]] = 1;

			for (j = 0; j < (int)vec[crnt].size (); ++j)
				if (!used[vec[crnt][j]]) {
					used[vec[crnt][j]] = 1;
					queue[p3++] = vec[crnt][j];
				}
		}
		p1 = p2;
		p2 = p3;
		++lvl;
	}
}

int main () {
	Init (&N, &L);
	vec.resize (N);
	Cities (&K, gr);

	maxd = (L / 2) + (L & 1);
	int i;
	for (i = 0; i < K; ++i)
		rec (gr[i], 0);
	gr[K] = gr[0];

	for (i = 0; i < N; ++i) ref[i] = -1;
	for (i = 0; i < K; ++i) ref[gr[i]] = i;
	for (i = 0; i < K; ++i)
		bfs1 (i);

	std::sort (gr + 1, gr + K);
	do {
		for (i = 0; i < K && ma3x[ref[gr[i]]][ref[gr[i+1]]]; ++i);
		if (i == K) Solution (K + 1, gr);
	} while (std::next_permutation (gr + 1, gr + K));

	printf ("mrii!\n");

	return 0;
}
