#include "devalib.h"

#include <cstdlib>
#include <vector>
#include <cstdio>
#include <queue>
#include <cstring>

namespace {
	const int MAXK = 1 << 4;
	const int MAXCALL = 5000;
	const int MAXN = 1 << 20;
	int N, L;
	int K;
	int gr[MAXK];
	int ref[MAXN];
	int calls;
	std::vector <std::vector <int> > vec;
	void input ();
	void bfs (int);
	bool ma3x[MAXK][MAXK];
}

void bfs (int id) {
	static int queue[MAXN];
	static bool used[MAXN];
	memset (used, 0, sizeof (bool) * N);
	int p1 = 0, p2 = 1, p3 = 0, lvl = 0;
	queue[p3++] = gr[id];

	int i, j, crnt;
	while (p1 != p2 && lvl <= L) {
		for (i = p1; i < p2; ++i) {
			crnt = queue[i];
			if (ref[crnt] != -1)
				ma3x[id][ref[crnt]] = 1;

			for (j = 0; j < (int)vec[crnt].size (); ++j)
				if (!used[vec[crnt][j]]) {
					used[vec[crnt][j]] = 1;
					queue[p3++] = vec[crnt][j];
				}
		}
		p1 = p2;
		p2 = p3;
		++lvl;
	}
}

void input () {
	scanf ("%d %d\n%d\n", &N, &L, &K);
	vec.resize (N);
	int i, n, j;
	for (i = 0; i < K; ++i) {scanf ("%d", gr + i); --gr[i];}
	for (i = 0; i < N; ++i) {
		scanf ("%d", &n);
		vec[i].resize (n);
		for (j = 0; j < n; ++j) {
			scanf ("%d", &vec[i][j]);
			--vec[i][j];
		}
	}
	for (i = 0; i < N; ++i) ref[i] = -1;
	for (i = 0; i < K; ++i) ref[gr[i]] = i;
	for (i = 0; i < K; ++i)
		::bfs (i);
/*
	printf ("-------------\n");
	for (i = 0; i < K; ++i) {
		for (j = 0; j < K; ++j)
			printf ("%d ", ma3x[i][j]);
		printf ("\n");
	}
	printf ("------------------\n");
*/
}

void Init (int *n, int *l) {
	calls = 0;
	::input ();
	*n = N;
	*l = L;
}

void Cities (int *k, int *_gr) {
	*k = K;
	for (int i = 0; i < K; ++i)
		_gr[i] = gr[i];
}

void Neighbours (int city, int *n, int *_vec) {
	++calls;
	if (calls > MAXCALL) {printf ("too many calls!\n"); exit (-1);}
	if (city < 0 || city >= N) {printf ("wrong city (%d, N == %d)\n", city, N); exit (-1);}
	*n = vec[city].size ();
	for (int i = 0; i < *n; ++i)
		_vec[i] = vec[city][i];
}

void Solution (int n, int *_vec) {
	if (_vec[0] != ::gr[0] || _vec[n-1] != ::gr[0]) {printf ("wrong solution (frst)\n"); exit (-1);}
	int i;
	for (i = 0; i < n-1; ++i)
		if (!::ma3x[ref[_vec[i]]][ref[_vec[i+1]]]) {
			printf ("wrong answer (row)\n");
			exit (-1);
		}

	printf ("OK!(%d)\n", calls);
	exit (0);
}
