/*
FROM: Croatia Olympiad in Informatics 2005
PROB: vid
KEYW: HARD linear, geometry
*/

#include <cstdio>
//#include <vector>
//#include <algorithm>

const int MAXN = 1 << 17;

struct point {
	int x;
	int y;
};

int CNT, N;

point vec[MAXN];
point _new;
int X, Y;

point st1[MAXN], st2[MAXN], st3[MAXN], st4[MAXN];
int p1, p2, p3, p4;

inline bool in_rec (const point &a, const point &b, const point &c) {
	return 	(long long)(b.x - a.x) * (c.x - b.x) > 0 &&
			(long long)(b.y - a.y) * (c.y - b.y) > 0;
}

//typedef bool (*funk) (const point &, const point &, const point &);

void put (point *st, int &p, const point &a) {
	while (p)
		if (in_rec (_new, st[p-1], a) || in_rec (_new, a, st[p-1])) {
			--p;
		} else break;
	st[p++] = a;
}

void put2 (point *st, int &p, const point &a) {
	if (!in_rec (_new, st[p-1], a))
		st[p++] = a;
}

int b11[MAXN], b12[MAXN], b21[MAXN], b22[MAXN];

int ff (int a, int b) {
	return b - a - 1 > 0 ? b - a - 1 : 0;
}

int solve () {
	p1 = p2 = p3 = p4 = 0;
	int x, y;
	int i, j;
	for (i = 0; i < N; ++i) {
		x = vec[i].x; y = vec[i].y;
		if (x > X) {
			if (y > Y) {
				put (st1, p1, vec[i]);
			} else {
				put (st4, p4, vec[i]);
			}
		} else {
			if (y > Y) {
				put2 (st2, p2, vec[i]);
			} else {
				put2 (st3, p3, vec[i]);
			}
		}
	}
/*
	printf ("--(%d %d)--\n", X, Y);
	printf ("st1->"); for (i = 0; i < p1; ++i) printf ("(%d %d) ", st1[i].x, st1[i].y); printf ("\n");
	printf ("st2->"); for (i = 0; i < p2; ++i) printf ("(%d %d) ", st2[i].x, st2[i].y); printf ("\n");
	printf ("st3->"); for (i = 0; i < p3; ++i) printf ("(%d %d) ", st3[i].x, st3[i].y); printf ("\n");
	printf ("st4->"); for (i = 0; i < p4; ++i) printf ("(%d %d) ", st4[i].x, st4[i].y); printf ("\n");
*/
	int remove = 0;

	int _1, _2, _3, _4;
///////case 1.1
	_1 = p1 - 1; _2 = 0; _3 = 0;
	for (; _1 >= 0; --_1) {
		while (_2 < p2 && st2[_2].y > st1[_1].y) ++_2;
		if (_2 == p2) {
			for (j = _1; j >= 0; --j) b11[j] = p3;
			break;
		}
		while (_3 < p3 && !in_rec (st1[_1], st2[_2], st3[_3])) ++_3;
		if (_3 == p3) {
			for (j = _1; j >= 0; --j) b11[j] = p3;
			break;
		}
		b11[_1] = _3;
	}
///////case 1.2
	_1 = 0; _3 = p3 - 1; _4 = 0;
	for (; _1 < p1; ++_1) {
		while (_4 < p4 && st4[_4].x > st1[_1].x) ++_4;
		if (_4 == p4) {
			for (j = _1; j < p1; ++j) b12[j] = -1;
			break;
		}
		while (_3 >= 0 && !in_rec (st1[_1], st4[_4], st3[_3])) --_3;
		if (_3 == -1) {
			for (j = _1; j < p1; ++j) b12[j] = -1;
			break;
		}
		b12[_1] = _3;
	}
///////case 2.1
	_2 = 0; _1 = p1 - 1; _4 = p4 - 1;
	for (; _2 < p2; ++_2) {
		while (_1 >= 0 && st1[_1].y > st2[_2].y) --_1;
		if (_1 == -1) {
			for (j = _2; j < p2; ++j) b21[j] = -1;
			break;
		}
		while (_4 >= 0 && !in_rec (st2[_2], st1[_1], st4[_4])) --_4;
		if (_4 == -1) {
			for (j = _2; j < p2; ++j) b21[j] = -1;
			break;
		}
		b21[_2] = _4;
	}
///////case 2.2
	_2 = p2 - 1; _3 = p3 - 1; _4 = 0;
	for (; _2 >= 0; --_2) {
		while (_3 >= 0 && st3[_3].x < st2[_2].x) --_3;
		if (_3 == -1) {
			for (j = _2; j >= 0; --j) b22[j] = p4;
			break;
		}
		while (_4 < p4 && !in_rec (st2[_2], st3[_3], st4[_4])) ++_4;
		if (_4 == p4) {
			for (j = _2; j >= 0; --j) b22[j] = p4;
			break;
		}
		b22[_2] = _4;
	}
	for (i = 0; i < p1; ++i)
		remove += ff (b12[i], b11[i]);

	for (i = 0; i < p2; ++i)
		remove += ff (b21[i], b22[i]);
/*
	printf ("add = %d\n", p1 + p2 + p3 + p4);
	printf ("remove == %d\n", remove);
	for (i = 0; i < p1; ++i) printf ("%d -- %d\n", b12[i], b11[i]);
	printf ("-----\n");
	for (i = 0; i < p2; ++i) printf ("%d -- %d\n", b21[i], b22[i]);
	printf ("\n");
	*/
	return p1 + p2 + p3 + p4 - remove;
}


bool cmp (const point &a, const point &b) {
	return a.x > b.x;
}

int main () {
	scanf ("%d", &CNT);

	scanf ("%d %d", &vec[0].x, &vec[0].y);
	printf ("0\n");

	int rc = 0;
	int i;
	for (N = 1; N < CNT; ++N) {
		scanf ("%d %d", &X, &Y);
		_new = (point) {X, Y};

		rc += solve ();
		printf ("%d\n", rc);

		//insertion sort
		for (i = N - 1; i >= 0; --i)
			if (cmp (_new, vec[i])) {
//				printf ("move %d %d from %d to %d\n", vec[i].x, vec[i].y, i, i + 1);
				vec[i + 1] = vec[i];
			} else
				break;
//		printf ("write %d %d to %d\n", _new.x, _new.y, i + 1);
		vec[i + 1] = _new;
//		printf ("sorted: "); for (i = 0; i <= N; ++i) printf ("(%d %d) ", vec[i].x, vec[i].y); printf ("\n");
	}

	return 0;
}
