/*
FROM: Croatia National Olympiad in Informatics
PROB: x1
KEYW: roman numerals, bfs
*/

#include <cstdio>
#include <queue>
#include <utility>

const int MAXN = 1 << 7;

const int difx[] = {0, 1, 0, -1};
const int dify[] = {1, 0, -1, 0};

int N;
char map[MAXN][MAXN];

char row[10000];
int pos;

void add (int a, char b[]) {
	if (a < 4) {
		while (a) {row[pos++] = b[0]; --a;}
	} else if (a == 4) {
		row[pos++] = b[0];
		row[pos++] = b[1];
	} else if (a == 5) {
		row[pos++] = b[1];
	} else if (a < 9) {
		row[pos++] = b[1];
		a -= 5;
		while (a) {row[pos++] = b[0]; --a;}
	} else {
		row[pos++] = b[0];
		row[pos++] = b[2];
	}
}

void toroman (int a) {
	int a1 = a % 10;
	int a2 = a / 10 % 10;
	int a3 = a / 100 % 10;

//	printf ("%d %d %d\n", a1, a2, a3);

	add (a3, "CD");
	add (a2, "XLC");
	add (a1, "IVX");
	row[pos++] = '.';
}

void input () {
	scanf ("%d\n", &N);
	int i, j;

	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= N; ++j)
			scanf ("%c", &map[i][j]);
		scanf ("\n");
	}

	for (i = 0; i < N + 2; ++i)
		map[i][0] = map[0][i] = map[i][N+1] = map[N+1][i] = 'W';
/*
	for (i = 0; i < N + 2; ++i) {
		for (j = 0; j < N + 2; ++j)
			printf ("%c ", map[i][j]);
		printf ("\n");
	}
*/
}

std::queue <std::pair <int, int> > q;
int used[MAXN][MAXN];

int main () {
	int i;
	for (i = 1; i < 900; ++i)
		toroman (i);

	input ();

	std::pair <int, int> crnt;
	q.push (std::make_pair (N / 2 + 1, N / 2 + 1));
	int ni, nj;
	int k;
	while (!q.empty ()) {
		crnt = q.front (); q.pop ();

		for (k = 0; k < 4; ++k) {
			ni = crnt.first + difx[k];
			nj = crnt.second + dify[k];
			if (map[ni][nj] == row[used[crnt.first][crnt.second]] && used[ni][nj] != used[crnt.first][crnt.second] + 1) {
				used[ni][nj] = used[crnt.first][crnt.second] + 1;
				q.push (std::make_pair (ni, nj));
			}
		}
	}

	int lvl = used[crnt.first][crnt.second] - 1;
//	for (i = 0; i <= lvl; ++i) printf ("%c", row[i]); printf ("\n");
	int cntr = 0;
	for (; lvl; --lvl)
		cntr += row[lvl] == '.';

	printf ("%d\n", cntr);
	return 0;
}
