/*
FROM: Croatia 2005 regional juniors
PROB: ovce
KEYW: bfs
*/

#include <cstdio>
#include <queue>
#include <utility>

using std::make_pair;

const int MAXN = 1 << 8;
const int MAXM = 1 << 8;
const int MAXGR = MAXN * MAXM;

int difx [] = {-1, 0, 1, 0};
int dify [] = {0, 1, 0, -1};

int N, M;
char map[MAXN][MAXM];
int mgr[MAXN][MAXM];
int grcnt = 1;
int ingr[MAXGR][2];

void bfs (int x, int y) {
	std::queue <std::pair <int, int> > q;
	q.push (make_pair (x, y));
	mgr[x][y] = grcnt;

	std::pair <int, int> crnt;
	while (!q.empty ()) {
		crnt = q.front (); q.pop ();
		for (int i = 0; i < 4; ++i)
			if (map[crnt.first + difx[i]][crnt.second + dify[i]] != '#' && !mgr[crnt.first + difx[i]][crnt.second + dify[i]]) {
				mgr[crnt.first + difx[i]][crnt.second + dify[i]] = grcnt;
				q.push (make_pair (crnt.first + difx[i], crnt.second + dify[i]));
			}
	}
	++grcnt;
}

int main () {
	scanf ("%d %d\n", &N, &M);

	int i, j;
//	char tmp;
	for (i = 0; i <= N + 1; ++i) map[i][0] = map[i][M+1] = '#';
	for (j = 0; j <= M + 1; ++j) map[0][j] = map[N+1][j] = '#';
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= M; ++j)
			map[i][j] = getc (stdin);
		scanf ("\n");
	}
/*
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= M; ++j)
			printf ("%c", map[i][j]);
		printf ("\n");
	}
*/
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j)
			if (!mgr[i][j] && map[i][j] != '#') bfs (i, j);
/*
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= M; ++j)
			printf ("%d ", mgr[i][j]);
		printf ("\n");
	}
*/
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j)
			if (map[i][j] == 'o')
				++ingr[mgr[i][j]][0];
			else if (map[i][j] == 'v')
				++ingr[mgr[i][j]][1];

	int oleft =0, vleft =0;
	for (i = 1; i < grcnt; ++i)
		if (ingr[i][0] > ingr[i][1])
			oleft += ingr[i][0];
		else
			vleft += ingr[i][1];

	printf ("%d %d\n", oleft, vleft);

	return 0;
}
