/*
FROM: Croatia 2005 regional senior
PROB: nule
KEYW: dynamical programming
*/

#include <cstdio>

inline int min (int a, int b) {
	return a < b ? a : b;
}

const int MAXN = 1 << 10;
const int infinity = 1 << 16;

int N;

int ma3x[MAXN][MAXN];
int opt[MAXN][MAXN][2];

inline int tell2 (int a) {
	int res = 0;
	while (!(a & 1)) {
		++res;
		a >>= 1;
	}
	return res;
}

inline int tell5 (int a) {
	int res = 0;
	while (!(a % 5)) {
		++res;
		a /= 5;
	}
	return res;
}

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			scanf ("%d", &ma3x[i][j]);

	opt[0][0][0] = tell2 (ma3x[0][0]);
	opt[0][0][1] = tell5 (ma3x[0][0]);

	for (i = 1; i < N; ++i)
		if (ma3x[i][0]) {
			opt[i][0][0] = opt[i-1][0][0] + tell2 (ma3x[i][0]);
			opt[i][0][1] = opt[i-1][0][1] + tell5 (ma3x[i][0]);
		} else
			opt[i][0][0] = opt[i][0][1] = infinity;

	for (j = 1; j < N; ++j)
		if (ma3x[0][j]) {
			opt[0][j][0] = opt[0][j-1][0] + tell2 (ma3x[0][j]);
			opt[0][j][1] = opt[0][j-1][1] + tell5 (ma3x[0][j]);
		} else
			opt[0][j][0] = opt[0][j][1] = infinity;


	for (i = 1; i < N; ++i)
		for (j = 1; j < N; ++j)
			if (ma3x[i][j]) {
				opt[i][j][0] = min (opt[i][j-1][0], opt[i-1][j][0]) + tell2 (ma3x[i][j]);
				opt[i][j][1] = min (opt[i][j-1][1], opt[i-1][j][1]) + tell5 (ma3x[i][j]);
			} else
				opt[i][j][0] = opt[i][j][1] = infinity;

	printf ("%d\n", min (opt[N-1][N-1][0], opt[N-1][N-1][1]));

	return 0;
}
