/*
FROM: Croatia 2006 Final exam day 1
PROB: karla
KEYW: bfs with graph expansion
*/

#include <cstdio>
#include <utility>
#include <cassert>
#include <cstring>

const int MAXR = 64;
const int MAXC = 64;
const int MAXW = 12;
const int MAXF = 12;
const int MAXD = 2;

struct pos {
	int x, y;
	int w, f;
	bool dir;
	pos () : x (-1), y (0) {};//not set -> only used in array prev
	pos (int _x, int _y, int _w, int _f, bool _dir =0) : x (_x), y (_y), w (_w), f (_f), dir (_dir) {}
};

const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};

#define _E '.'
#define _W 'v'
#define _F 's'

const char *_D = "|-+";

int R, C;
int W, F;
char map[MAXR][MAXC];

pos prev[MAXR][MAXC][MAXW][MAXF][MAXD];
pos fin_state;

void bfs () {
	static pos q[MAXR * MAXC * MAXW * MAXF * MAXD], cp;
	int p3 = 0;
	int gx, gy, gw, gf, gd;//go x, go y, go water, gp forest, go dir
	q[p3++] = pos (1, 1, W, F);
	prev[1][1][W][F][0].y = -1;//0 means unused => this is used

	for (int i = 0; i < p3; ++i) {
		cp = q[i];
//		printf ("POP %d %d (%c) %d %d %d\n", cp.x, cp.y, map[cp.x][cp.y], cp.w, cp.f, cp.dir);
		if (cp.x == R && cp.y == C) {fin_state = cp; return;}

		for (int j = 0; j < 4; ++j) {
			gx = cp.x + dx[j];
			gy = cp.y + dy[j];
			gw = cp.w;
			gf = cp.f;
			gd = 0;
			switch (map[cp.x][cp.y]) {
				case _E: switch (map[gx][gy]) {
					case _E: break;
					case _W: --gw; gd = j & 1; break;
					case _F: --gf; break;
					default: gw = -1;//invalid
				} break;

				case _W : switch (map[gx][gy]) {
					case _F: --gf;//continue to _E
					case _E: if ((j & 1) != cp.dir) gw = -1; break;//invalid or gd == 0
					case _W: if ((j & 1) == cp.dir) gd = cp.dir; else gw = -1; break;//else -> invalid
					default: gw = -1;//invalid
				} break;

				case _F : switch (map[gx][gy]) {
					case _E: break;
					case _W: --gw; gd = j & 1; break;
					case _F: break;
					default: gw = -1;//invalid
				} break;

				default: assert (0);
			}
//			printf ("%d --> %d %d %d %d %d\n", j, gx, gy, gw, gf, gd);
			if (gw >= 0 && gf >= 0 && prev[gx][gy][gw][gf][gd].y == 0) {
//				printf ("PUSH!\n");
				prev[gx][gy][gw][gf][gd] = cp;
				q[p3++] = pos (gx, gy, gw, gf, gd);
			}
		}
	}
	assert (0);
}

void burn (int x, int y) {
	static std::pair <int, int> q[MAXR * MAXC];
	int i, j, p3 = 0;
	q[p3++] = std::make_pair (x, y);
	for (i = 0; i < p3; ++i) {
		map[q[i].first][q[i].second] = '.';
		for (j = 0; j < 4; ++j)
			if (map[q[i].first+dx[j]][q[i].second+dy[j]] == _F)
				q[p3++] = std::make_pair (q[i].first+dx[j], q[i].second+dy[j]);
	}
}

int main () {
	scanf ("%d %d\n%d %d\n", &R, &C, &W, &F);

	int i, j;
	memset (map, '#', sizeof (map));
	map[0][C+2] = '\0';
	for (i = 1; i <= R; ++i) {
		for (j = 1; j <= C; ++j)
			map[i][j] = getchar ();
		map[i][j+1] = '\0';
		getchar ();
	}
	map[i][C+2] = '\0';

//	for (i = 0; i <= R + 1; ++i) puts (map[i]);
	bfs ();
//	printf ("%d %d %d %d %d\n", fin_state.x, fin_state.y, fin_state.w, fin_state.f, fin_state.dir);

	pos crnt = fin_state;
	while (crnt.y != -1) {
		switch (map[crnt.x][crnt.y]) {
			case _E: break;
			case _W: map[crnt.x][crnt.y] = _D[crnt.dir]; break;
			case _F: burn (crnt.x, crnt.y); break;
			case '|': case '-': map[crnt.x][crnt.y] = _D[2]; break;
		}
		crnt = prev[crnt.x][crnt.y][crnt.w][crnt.f][crnt.dir];
	}

	for (i = 1; i <= R; ++i) {map[i][C+1] = 0; puts (map[i] + 1);}

	return 0;
}
