/*
FROM: Croatia 2006 Final exam day 1
PROB: severina
KEYW: Aho Corasick, multiple string matching, dynamical programming
*/

#include <cstdio>
#include <cassert>
#include <cstring>

const int ALPHA = 26;
const int MAXN = 4000;
const int MAXLEN = 1 << 7;
const int MAXT = 300010;
const int MOD = 1337377;

#warning remove __num, __id
int __num;
struct node {
	int __id;
	int fid, ll;
	node *fl, *prev, *next[ALPHA];
	node (int _ll, node *_prev) : __id (__num++), fid (-1), ll (_ll), fl (0) , prev (_prev) {memset (next, 0, sizeof (next));}
};

int N, T;
char word[MAXN][MAXLEN];
int wl[MAXN];

node *head;
long long dp[MAXT];//we will use % MOD only one time at a square (not every time) - that is why it is long long
char text[MAXT];

void add_trie (node *pos, int id, int n) {
	if (!word[id][n]) {
		pos -> fid = id;
		wl[id] = n;
		return;
	}

	if (pos -> next[word[id][n] - 'a']) add_trie (pos -> next[word[id][n] - 'a'], id, n + 1);
	else add_trie (pos -> next[word[id][n] - 'a'] = new node (word[id][n] - 'a', pos), id, n + 1);
}

void pr_tab (int n) {for (int i = 0; i < n; ++i) putchar ('\t');}

void prnt_trie (node *pos, int lvl) {
	pr_tab (lvl); printf ("(%d %c %d)\n", pos -> fid, (char)(pos -> ll + 'a'), pos -> __id);
	if (pos -> fl) pr_tab (lvl), printf ("(%d)\n", pos -> fl -> __id);
	for (int i = 0; i < ALPHA; ++i)
		if (pos -> next[i]) {
			pr_tab (lvl);
			printf ("--> %c\n", i + 'a');
			prnt_trie (pos -> next[i], lvl + 1);
		}
}

void make_fl (node *pos) {
	if (pos == head) {head -> fl = head; return;}

	node *crnt = pos -> prev -> fl;
	while (crnt != head && !(crnt -> next[pos -> ll])) crnt = crnt -> fl;

	pos -> fl = (crnt != head || crnt -> next[pos -> ll] && crnt -> next[pos -> ll] != pos ? crnt -> next[pos -> ll] : head);
}

void make_all_fl () {
	node *q[MAXN * MAXLEN];
	int p3 = 0;
	q[p3++] = head;
	for (int i = 0; i < p3; ++i) {
		make_fl (q[i]);
		for (int j = 0; j < ALPHA; ++j)
			if (q[i] -> next[j])
				q[p3++] = q[i] -> next[j];
	}
}

node *crnt;

void go_trie (int cl, int dp_pos) {
	while (crnt != head && !crnt -> next[cl])
		crnt = crnt -> fl;

	if (crnt -> next[cl])
		crnt = crnt -> next[cl];
	node *tmp = crnt;

	while (tmp != head) {
		if (tmp -> fid != -1)
			dp[dp_pos] += dp[dp_pos - wl[tmp -> fid]];
		tmp = tmp -> fl;
	}
}

int main () {
	gets (text);

	head = new node (-1, 0);

	scanf ("%d\n", &N);
	int i;

	for (i = 0; i < N; ++i) {
		gets (word[i]);
		add_trie (head, i, 0);
	}

	make_all_fl ();
//	prnt_trie (head, 0);

	dp[0] = 1;
	crnt = head;
	for (i = 0; text[i];) {
		int i1 = i + 1;
		go_trie (text[i] - 'a', i1);
		i = i1;

		dp[i] %= MOD;
	}

	printf ("%Ld\n", dp[i]);

	return 0;
}
