/*
FROM: Croatia National Senior day 1
PROB: maraton
KEYW: vectors, cycle finding
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 10;

int N;
long long K;
bool win[MAXN][MAXN];

int ma3x[MAXN][MAXN];
long long vec1[MAXN], vec2[MAXN];

void inc (int &a) {
	if (a == N - 1) a = 0;
	else ++a;
}

void sim (int &a, int &b, long long *vec) {
	++vec[a];
	++vec[b];
	if (win[a][b]) {
		inc (b);
		if (a == b) inc (b);
	} else {
		int t = a;
		a = b;
		inc (b);
		if (t == b) inc (b);
	}
}

void prnt (long long *vec) {
	printf ("%Ld", vec[0]);
	for (int i = 1; i < N; ++i)
		printf (" %Ld", vec[i]);
	printf ("\n");
}

int main () {
	scanf ("%d %Ld\n", &N, &K);

	int i, j;
	char tmp;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j) {
			tmp = getchar ();
			win[i][j] = tmp == '1';
		}
		getchar ();//eat the newline
	}

	memset (ma3x, -1, sizeof (ma3x));
	int a = 0, b = 1;
	int mc = 0;

	while (ma3x[a][b] == -1) {
		if (mc == K) {prnt (vec1); return 0;}//the end is nearer than the cycle :)
		ma3x[a][b] = mc++;
		sim (a, b, vec1);
	}
//	prnt (vec1);

	int ca = a, cb = b;
	long long cc = (K - ma3x[ca][cb]) / (mc - ma3x[ca][cb]);//cycle count
	int ac = (K - ma3x[ca][cb]) % (mc - ma3x[ca][cb]);//after cycle
//	printf ("cc ac %Ld %d (%Ld - %d # %d - %d)\n", cc, ac, K, ma3x[ca][cb], mc, ma3x[ca][cb]);

	a = 0, b = 1;
	while (ca != a || cb != b) {
		sim (a, b, vec2);
	}
//	prnt (vec2);

	for (int i = 0; i < N; ++i) {
		vec1[i] -= vec2[i];
		vec1[i] *= cc;
	}
//	prnt (vec1);

	a = ca, b = cb;
	for (int i = 0; i < ac; ++i) {
		sim (a, b, vec2);
	}

	printf ("%Ld", vec1[0] + vec2[0]);
	for (i = 1; i < N; ++i)
		printf (" %Ld", vec1[i] + vec2[i]);
	printf ("\n");

	return 0;
}
