/*
FROM: Croatia 2006 National Senior day 2
PROB: kutije
KEYW: coding
NOTE: checker
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <vector>
#include <utility>

#define white first
#define black second

using namespace std;

char command[8][16] = {
						"LIJEVO\n",
						"DESNO\n",
						"UZMI BIJELU\n",
						"UZMI CRNU\n",
						"SPUSTI BIJELU\n",
						"SPUSTI CRNU\n"
					};


int N;
int cp;//crane position
int cc;
pair <int, int> crane;
vector <pair <int, int> > box;

void XXX (const char *message) {
	puts (message);
	printf ("crane position - %d\ncommand # - %d\n", cp, cc);
	for (int i = 0; i < box.size (); ++i)
		printf ("(%d %d) ", box[i].white, box[i].black);
	puts ("");
	exit (0);
}

void prnt_stat () {
	printf ("in crane %d %d\n", crane.white, crane.black);
	printf ("crane position - %d\ncommand # - %d\n", cp, cc);
	for (int i = 0; i < box.size (); ++i)
		printf ("(%d %d) ", box[i].white, box[i].black);
	puts ("\n");
}

int main (int argc, char *argv[]) {
	assert (argc == 3);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
	assert (in && out);

	fscanf (in, "%d\n", &N);
	box.resize (N, pair <int, int> (0, 0));
	char tmp[2];
	int i;
	for (i = 0; i < N; ++i) {
		fscanf (in, "%c%c ", tmp, tmp+1);
		printf ("__%c%c\n", tmp[0], tmp[1]);
		if (tmp[0] == 'B') ++box[i].white;
		else ++box[i].black;
		if (tmp[1] == 'C') ++box[i].black;
		else ++box[i].white;
	}

	static char line[1024];
	prnt_stat ();
	while (fgets (line, 1024, out)) {
		++cc;
		for (i = 0; i < 6; ++i)
			if (strcmp (line, command[i]) == 0) break;
		switch (i) {
			case 0: if (cp == 0) XXX ("cannot go LEFT"); --cp; break;
			case 1: if (cp == N-1) XXX ("cannot go RIGHT"); ++cp; break;
			case 2: if (crane.white + crane.black >= 2) XXX ("cannot take any more");
					if (box[cp].white == 0) XXX ("cannot take white from here");
					++crane.white;
					--box[cp].white;
					break;
			case 3: if (crane.white + crane.black >= 2) XXX ("cannot take any more");
					if (box[cp].black == 0) XXX ("cannot take black from here");
					++crane.black;
					--box[cp].black;
					break;
			case 4: if (crane.white == 0) XXX ("cannot put white here");
					--crane.white;
					++box[cp].white;
					break;
			case 5: if (crane.black == 0) XXX ("cannot put black here");
					--crane.black;
					++box[cp].black;
					break;
			default: XXX ("invalid command");
		}
		prnt_stat ();
	}
	for (i = 0; i < box.size (); ++i) {
		if (box[i].white + box[i].black != 2) XXX ("arrangement error!");
		if (box[i].white && box[i].black) XXX ("two different balls in same box!");
	}
	XXX ("everything seems ok!");

	return 0;
}
