/*
FROM: Croatia 2006 National Senior day 2
PROB: kaos
KEYW: index tree, similar to BOI 2004 - team
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 17;
const int MAXLEN = 1 << 5;

int N;
char word[MAXN][MAXLEN];
int idt[MAXN];

int tmp[MAXN];
int ref1[MAXN], idx2[MAXN];

bool cmp1 (int a, int b) {
	return strcmp (word[a], word[b]) > 0;//invert it
}

bool cmp2 (int a, int b) {
	return strcmp (word[a], word[b]) < 0;//normal comparison
}

int lowest_bit (int a) {return a & -a;}
void add (int pos) {
	for (; pos <= N; pos += lowest_bit (pos))
		++idt[pos];
}
int srch (int pos) {
	static int res;
	for (res = 0; pos; pos &= pos - 1)
		res += idt[pos];
	return res;
}

int main () {
	scanf ("%d\n", &N);

	int i;
	for (i = 0; i < N; ++i) {
		ref1[i] = i;
		tmp[i] = i;
		gets (word[i]);
	}
	std::sort (ref1, ref1 + N, cmp1);
	for (i = 0; i < N; ++i)
		std::reverse (word[i], word[i] + strlen (word[i]));
	std::sort (tmp, tmp + N, cmp2);
	for (i = 0; i < N; ++i) idx2[tmp[i]] = i;

	long long res = 0;
	for (i = 0; i < N; ++i) {
		res += srch (idx2[ref1[i]] + 1);
		add (idx2[ref1[i]] + 1);
	}
	printf ("%Ld\n", res);

	return 0;
}
