/*
FROM: Croatia 2006 National Senior day 2
PROB: kaos
KEYW: buckets, accumulative sum
*/

#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>

const int MAXN = 1 << 17;
const int MAXNN = 1 << 9;
const int MAXLEN = 1 << 5;

int N, NN;
char words[MAXN][MAXLEN];
int ref[MAXN];
int idx1[MAXN], idx2[MAXN];

int buf[MAXN];
int bucket[MAXNN][MAXNN];
int acbs[MAXNN][MAXNN];//accumulative bucket size (abs[i][j] += abs[i+1][j] + abs[i][j-1] - abs[i+1][j-1])

int cmp1 (int a, int b) {
	return strcmp (words[a], words[b]) < 0;
}

void add_to_bucket (int x, int y, int id) {
//	printf ("add to bucket %d %d %d\n", x, y, id);
	++acbs[x][y];
	buf[id] = bucket[x][y];
	bucket[x][y] = id;
}

int find_in_bucket (int x, int y, int id) {
//	printf ("find in bucket %d %d %d ", x, y, id);
	int res = 0;
	for (int k = bucket[x][y]; k != -1; k = buf[k])
		if (idx1[k] > idx1[id]
		 && idx2[k] < idx2[id]) ++res;
//	printf ("-- %d\n", res);
	return res;
}

int main () {
	scanf ("%d\n", &N);
	NN = (int)sqrt (N);
	if (NN * NN < N) ++NN;

	int i, j;
	for (i = 0; i < N; ++i) {
		ref[i] = i;
		gets (words[i]);
	}

	std::sort (ref, ref + N, cmp1);
	for (i = 0; i < N; ++i) {idx1[ref[i]] = i; ref[i] = i;}
	for (i = 0; i < N; ++i)
		std::reverse (words[i], words[i] + strlen (words[i]));

	std::sort (ref, ref + N, cmp1);
	for (i = 0; i < N; ++i) idx2[ref[i]] = i;
	fprintf (stderr, "HOP!\n");
/*
	for (i = 0; i < N; ++i)
		printf ("%d %d\n", idx1[i], idx2[i]);
*/
	memset (bucket, -1, sizeof (bucket));
	for (i = 0; i < N; ++i)
		add_to_bucket (idx1[i] / NN, idx2[i] / NN, i);

	j = 0;
	for (i = NN-2; i >= 0; --i)
		acbs[i][j] += acbs[i+1][j];
	i = NN-1;
	for (j = 1; j < NN; ++j)
		acbs[i][j] += acbs[i][j-1];

	for (i = NN-2; i >= 0; --i)
		for (j = 1; j < NN; ++j)
			acbs[i][j] += acbs[i+1][j] + acbs[i][j-1] - acbs[i+1][j-1];

	long long res = 0;
	for (int k = 0; k < N; ++k) {
		int bx = idx1[k] / NN;
		int by = idx2[k] / NN;
/*		if (bx != NN-1 && by) {
			printf ("%d add %d\n", k, acbs[bx+1][by-1]);
		}*/
		res += (bx != NN-1 && by) ? acbs[bx+1][by-1] : 0;
		j = by;
		for (i = bx; i < NN; ++i)//here include bx, by
			res += find_in_bucket (i, j, k);

		i = bx;
		for (j = 0; j < by; ++j)
			res += find_in_bucket (i, j, k);
	}

	printf ("%Ld\n", res);

	return 0;
}
