/*
FROM: Croatia 2006 National Senior day 2
PROB: kutije
KEYW: coding
*/

#include <cstdio>
#include <cstring>
#include <cassert>

const int MAXN = 1 << 9;

char command[8][16] = {
						"LIJEVO",
						"DESNO",
						"UZMI BIJELU",
						"UZMI CRNU",
						"SPUSTI BIJELU",
						"SPUSTI CRNU"
					};

char eng[8][16] = {
						"LEFT",
						"RIGHT",
						"TAKE WHITE",
						"TAKE BLACK",
						"PUT WHITE",
						"PUT BLACK"
					};

int N;
char box[MAXN][2];

int left[MAXN*2], right[MAXN*2];
int lp, rp;

int ans[2 * MAXN * MAXN], ap = sizeof (ans) / sizeof (ans[0]);
int tmp[2 * MAXN * MAXN], tp;

int _cp;//current position of the crane
void move_to (int pos) {
	if (pos == _cp) return;
	if (pos > _cp)
		for (; pos > _cp; ++_cp)
			tmp[tp++] = 1;
	else
		for (; pos < _cp; --_cp)
			tmp[tp++] = 0;
}

int __xor_mask;
void take_left () {
	tmp[tp++] = 2 ^ __xor_mask;
}

void take_right () {
	tmp[tp++] = 3 ^ __xor_mask;
}
void put_left () {
	tmp[tp++] = 5 ^ __xor_mask;
}
void put_right () {
	tmp[tp++] = 4 ^ __xor_mask;
}

void calc_it () {
	int i, j;
//	for (i = 0; i < lp; ++i) printf ("%d ", left[i]); puts ("");
//	for (i = 0; i < rp; ++i) printf ("%d ", right[i]); puts ("");

	tp = 0;
	_cp = 0;
	if (lp == 0) {ap = 0; return;}

	if (lp == 1) {
		move_to (left[0]);
		take_left ();
		move_to (right[0]);
		put_right ();
		take_right ();
		move_to (left[0]);
		put_left ();
		if (tp < ap) {
			memcpy (ans, tmp, sizeof (int) * tp);
			ap = tp;
		}

		return;
	}
	move_to (left[0]);
	take_left ();
	move_to (left[1]);
	take_left ();
	for (i = 0; i + 2 <= rp; i += 2) {
		move_to (right[i]);
		put_right ();
		take_right ();
		move_to (right[i+1]);
		put_right ();
		take_right ();

		if (i + 3 >= lp) break;
		move_to (left[i+2]);
		put_left ();
		take_left ();
		move_to (left[i+3]);
		put_left ();
		take_left ();
	}
	if (lp & 1) {
		i += 2;
		move_to (left[i]);
		put_left ();
		take_left ();
		move_to (right[i]);
		put_right ();
		take_right ();

	}
	move_to (left[1]);
	put_left ();
	move_to (left[0]);
	put_left ();

	if (tp < ap) {
		memcpy (ans, tmp, sizeof (int) * tp);
		ap = tp;
	}
	for (i = 0; i < tp; ++i) fprintf (stderr, "%s\n", eng[tmp[i]]);
	fprintf (stderr, "(%d)\n", tp);
	fprintf (stderr, "--------\n");
}

int main () {
	scanf ("%d\n", &N);

	int i, j;
	int bc = 0;//black count
	for (i = 0; i < N; ++i) {
		scanf ("%2c ", box[i]);
		bc += box[i][0] == 'B';
		bc += box[i][1] == 'B';
	}

	//1st case -> the white are at the begining
	__xor_mask = 1;
	for (i = 0; i < bc / 2; ++i)
		for (j = 0; j < 2; ++j)
			if (box[i][j] == 'C')
				left[lp++] = i;

	for (i = N-1; i >= bc / 2; --i)
		for (j = 0; j < 2; ++j)
			if (box[i][j] == 'B')
				right[rp++] = i;
	calc_it ();

	//2nd case -> the black are at the begining
	__xor_mask = 0;
	lp = rp = 0;
	int wc = N * 2 - bc;
	for (i = 0; i < wc / 2; ++i)
		for (j = 0; j < 2; ++j)
			if (box[i][j] == 'B')
				left[lp++] = i;
	for (i = N-1; i >= wc / 2; --i)
		for (j = 0; j < 2; ++j)
			if (box[i][j] == 'C')
				right[rp++] = i;
	calc_it ();


	for (i = 0; i < ap; ++i)
		printf ("%s\n", command[ans[i]]);

	return 0;
}
