/*
FROM: Croatia Olympiad in Informatics 2006
PROB: banana
KEYW: binary search, tree
*/

#include <cstdio>
#include <cstring>
#include <cassert>

const int MAXN = 1 << 17;

struct el {
	int to;
	int mc;//max cost
	int mr;//max reduce
	int next;
	el () {}
	el (int _to, int _mc, int _mr, int _next) : to (_to), mc (_mc), mr (_mr), next (_next) {}
};

int N, M;
int vec[MAXN];
el buf[MAXN * 2];
int max[MAXN];
int prev[MAXN];
bool is_leaf[MAXN];

int used_money;
int targ;

int find_max (int pos, int cval) {
	max[pos] = cval;//in case there are no children
	is_leaf[pos] = 1;
	for (int i = vec[pos]; i != -1; i = buf[i].next) {
		if (buf[i].to == prev[pos]) continue;
		is_leaf[pos] = 0;
		prev[buf[i].to] = pos;
		max[pos] >?= find_max (buf[i].to, cval + buf[i].mc);
	}
	return max[pos];
}

void dfs (int pos, int taken) {
	assert (max[pos] - taken > targ);
	if (is_leaf[pos]) {used_money = M+1; return;}
//	printf ("dfs %d %d(%d)\n", pos, taken, max[pos]);
	for (int i = vec[pos]; i != -1; i = buf[i].next) {
		if (buf[i].to == prev[pos]) continue;

		if (max[buf[i].to] - taken <= targ) continue;
		if (max[buf[i].to] - taken - targ <= buf[i].mr) {
//			printf ("partitialy recover %d -> %d -- %d(%d) was %d\n", pos, buf[i].to, max[buf[i].to] - taken - targ, buf[i].mr, max[buf[i].to]);
			used_money += max[buf[i].to] - taken - targ;
		} else {
//			printf ("fully recover %d -> %d -- %d\n", pos, buf[i].to, buf[i].mr);
			used_money += buf[i].mr;
			dfs (buf[i].to, taken + buf[i].mr);
		}
	}
}

int main () {
	scanf ("%d %d", &N, &M);

	int i;
	int x, y, a, b;
	int bp = 0;
	memset (vec, -1, sizeof (vec));
	for (i = 0; i < N-1; ++i) {
		scanf ("%d %d %d %d", &x, &y, &a, &b);
		--x; --y;
		b = a - b;
		assert (b >= 0);

		buf[bp] = el (y, a, b, vec[x]);
		vec[x] = bp++;

		buf[bp] = el (x, a, b, vec[y]);
		vec[y] = bp++;
	}

	prev[0] = -1;
	find_max (0, 0);

	int l = -1, r = max[0];
	//fprintf (stderr, "%d\n", max[0]);
	while (l + 1 < r) {
		targ = (l + r) / 2;
		used_money = 0;
		dfs (0, 0);
		if (used_money <= M)
			r = targ;
		else
			l = targ;
	}

/*	targ = 17;
	dfs (0, 0);
	printf ("%d\n");*/
	printf ("%d\n", r);

	return 0;
}
