/*
FROM: Croatia Olympiad in Informatics 2006
PROB: trokut
KEYW: full exhaustion, bit operations
*/

#include <cstdio>
#include <cstring>

const int MAXN = 320;
const int MAXX = 10;

struct pnt {
	int x, y;
	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}
};

int N;
pnt vec[MAXN];
unsigned pre[MAXN][MAXN][MAXX];

inline void set (int i, int j, int k) {
//	printf ("set %d %d %d\n", i, j, k);
	pre[i][j][k >> 5] |= 1 << (k & 31);
}

inline int S (const pnt &a, const pnt &b, const pnt &c) {
//	printf ("%d %d   %d %d   %d %d -- %d\n", a.x, a.y, b.x, b.y, c.x, c.y, (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x));
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

unsigned tmp[MAXX];
inline void mv (int a, int b) {
	memcpy (tmp, pre[a][b], sizeof (tmp));
}

inline void _and (int a, int b) {
	for (int i = 0; i < MAXX; ++i)
		tmp[i] &= pre[a][b][i];
}

inline int popcount () {
	int res = 0;
	for (int i = 0; i < MAXX; ++i)
		res += __builtin_popcount (tmp[i]);
	return res;
}

int cnt (int a, int b, int c) {
	mv (a, b);
	_and (b, c);
	_and (c, a);
//	printf ("cnt %d %d %d %x\n", a, b, c, tmp[0]);
	return popcount ();
}

int main () {
	scanf ("%d", &N);

	int i, j, k;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &vec[i].x, &vec[i].y);

	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j) {
			if (i == j) continue;
			for (k = 0; k < N; ++k)
				if (S (vec[i], vec[j], vec[k]) >= 0)
					set (i, j, k);
		}
	}

	int best = 0;
	int bi = -1, bj = -1, bk = -1;
	int tmp;
	for (i = 0; i < N; ++i)
		for (j = i + 1; j < N; ++j)
			for (k = j + 1; k < N; ++k) {
				tmp = S (vec[i], vec[j], vec[k]);
				if (!tmp) continue;
				if (tmp > 0) {
					if (best < (tmp = cnt (i, j, k))) {
						best = tmp;
						bi = i;
						bj = j;
						bk = k;
					}
				} else {
					if (best < (tmp = cnt (k, j, i))) {
						best = tmp;
						bi = i;
						bj = j;
						bk = k;
					}
				}
			}

	printf ("%d\n%d %d %d\n", best, bi + 1, bj + 1, bk + 1);

	return 0;
}
