/*
FROM: Croatia 2006 Regional
PROB: toplist
KEYW: strings, adhoc
*/

#include <iostream>
#include <string>
#include <vector>
#include <cassert>

const int MAXN = 1 << 9;

int S, N;
std::vector <std::string> songs;
bool here[MAXN][MAXN];
bool xx[MAXN];
int hc[MAXN];

int get_num (const std::string &s) {
	int i;
	for (i = 0; i < N; ++i)
		if (s == songs[i])
			break;

	if (i == N) {
		songs.push_back (s);
		++N;
	}

	return i;
}

void fix () {
	for (int i = 2; i < MAXN; ++i)
		for (int j = 0; j < MAXN; ++j)
			if (here[i-1][j])
				here[i][j] = 1;
}

void fill_hc () {
	for (int i = 1; i < MAXN; ++i) {
		hc[i] = 0;
		for (int j = 0; j < MAXN; ++j)
			hc[i] += here[i][j];
	}
}

void erase () {
	for (int i = MAXN-1; i > 1; --i)
		for (int j = 0; j < MAXN; ++j)
			if (here[i-1][j])
				here[i][j] = 0;
}

int find (int i) {
	for (int j = 0; j < N; ++j)
		if (here[i][j]) return j;

	assert (0);
	return -1;
}

int main () {
	std::cin >> S;

	int i, j;
	int n, num, gr;
	std::string tmp;
	for (i = 0; i < S; ++i) {
		std::cin >> n >> tmp >> gr;

		for (j = 0; j < n; ++j) {
			std::cin >> tmp;
			num = get_num (tmp);
//			printf ("%s scanned -> %d(%d)\n", tmp.c_str (), num, gr);

			here[gr][num] = 1;
		}
	}

	fix ();
	fill_hc ();
	for (i = 1; i < MAXN; ++i)
		if (hc[i] == i) xx[i] = 1;
/*
	for (i = 1; i <= N; ++i) {
		printf ("%d ->", i);
		for (j = 0; j < N; ++j)
			if (here[i][j])
				printf (" %d", j);
		printf ("(%d %d)\n", hc[i], xx[i]);
	}
*/
	erase ();
	fill_hc ();
/*
	for (i = 1; i <= N; ++i) {
		printf ("%d ->", i);
		for (j = 0; j < N; ++j)
			if (here[i][j])
				printf (" %d", j);
		printf ("(%d %d)\n", hc[i], xx[i]);
	}
*/

	for (i = 1; i < MAXN; ++i)
		if (hc[i] == 1 && xx[i])
			std::cout << i << ' ' << songs[find (i)] << std::endl;

	return 0;
}
