/*
FROM: Croatia Olympiad in Informatics 2007
PROB: policija
KEYW: artic points, artic edges, dfs
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 17;
const int MAXE = 1 << 19;
const int LOG = 18;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N, E;
int vec[MAXN];
el buf[MAXE * 2];//8mb

int lowest[MAXN];
int prenum[MAXN];
int sz[MAXN];
int lvl[MAXN];
int prev[LOG][MAXN];//7mb
int comp[MAXN], ccomp;
bool ap[MAXN], ae[MAXN];

void dfs (int a) {
//	printf ("in dfs %d (prev %d)\n", a, prev[0][a]);
	static int cpn, ii;
	prenum[a] = lowest[a] = cpn++;
	comp[a] = ccomp;
	sz[a] = 1;

	for (ii = 1; prev[ii-1][a] != -1; ++ii) {
		prev[ii][a] = prev[ii-1][prev[ii-1][a]];
//		printf ("prev[%d][%d] <- %d\n", ii, a, prev[ii][a]);
	}

	for (int i = vec[a]; i != -1; i = buf[i].next) {
		if (comp[buf[i].to]) {
			if (buf[i].to != prev[0][a])
				lowest[a] <?= prenum[buf[i].to];
		} else {
			prev[0][buf[i].to] = a;
			lvl[buf[i].to] = lvl[a] + 1;
			dfs (buf[i].to);
			lowest[a] <?= lowest[buf[i].to];
			sz[a] += sz[buf[i].to];
			if (lowest[buf[i].to] > prenum[a]) {
//				printf ("%d -> %d (is both!)\n", a, buf[i].to);
				ae[buf[i].to] = 1;//artic edge
				ap[buf[i].to] = 1;//#warning artic point
			} else if (lowest[buf[i].to] == prenum[a]) {
//				printf ("%d -> %d (is ap)\n", a, buf[i].to);
				ap[buf[i].to] = 1;//#warning artic point
			}
		}
	}
	
//	printf ("<<- %d %d %d %d %d\n", a, prenum[a], lowest[a], sz[a], comp[a]);
}

int myin (int a, int b) {
//	printf ("in %d %d -- %d\n", a, b, (prenum[b] >= prenum[a] && prenum[b] < prenum[a] + sz[a]) * 2 - 1);
	return (prenum[b] >= prenum[a] && prenum[b] < prenum[a] + sz[a]) * 2 - 1;//1 if ok, -1 if not
}

int go_up (int pos, int to_lvl) {
//	printf ("go_up %d (%d) -> %d ---- ", pos, lvl[pos], to_lvl);
	to_lvl = lvl[pos] - to_lvl;
	for (int i = 0; i < LOG; ++i)
		if ((to_lvl >> i) & 1)
			pos = prev[i][pos];
//	printf ("%d\n", pos);
	return pos;
}

int main () {
	scanf ("%d %d", &N, &E);

	int i;
	int a, b, bp = 0;
	memset (vec, -1, sizeof (vec));
	for (i = 0; i < E; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		buf[bp] = el (b, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, vec[b]);
		vec[b] = bp++;
	}

	memset (prev, -1, sizeof (prev));

	for (i = 0; i < N; ++i) {
		if (comp[i]) continue;//already processed
		++ccomp;
		dfs (i);
	}

	#define _NO {printf ("no\n"); continue;}
	#define _YES {printf ("yes\n"); continue;}

	int Q;
	scanf ("%d", &Q);
	int type;
	int c, d;
	int r1, r2;
	for (i = 0; i < Q; ++i) {
		scanf ("%d", &type);
		if (type == 1) {
			scanf ("%d %d %d %d\n", &a, &b, &c, &d);
			--a; --b; --c; --d;
			if (comp[a] != comp[b]) _NO
			if (prev[0][c] == d && ae[c] && myin (c, a) * myin (c, b) < 0) _NO
			if (prev[0][d] == c && ae[d] && myin (d, a) * myin (d, b) < 0) _NO
			_YES
		} else {
//			printf ("not done yet!\n");
//			#warning write it!
			scanf ("%d %d %d\n", &a, &b, &c);
			--a; --b; --c;
			if (comp[a] != comp[b]) _NO
			if (comp[a] != comp[c]) _YES//the point we are blocking is in another component
			if (myin (c, a) > 0 && myin (c, b) > 0) {
				r1 = go_up (a, lvl[c] + 1);
				r2 = go_up (b, lvl[c] + 1);
				if (r1 == r2) _YES;
				if (ap[r1] || ap[r2]) _NO
				else _YES
			} else if (myin (c, a) > 0) {
				r1 = go_up (a, lvl[c] + 1);
				if (ap[r1]) _NO
				else _YES
			} else if (myin (c, b) > 0) {
				r2 = go_up (b, lvl[c] + 1);
				if (ap[r2]) _NO
				else _YES
			} else {//both are out
				_YES
			}
		}
	}

	return 0;
}
