/*
FROM: Croatia Olympiad in Informatics 2007
PROB: sabor
KEYW: bfs with levels, ad-hoc
*/

#include <cstdio>
#include <cstring>
#include <utility>
#include <algorithm>

const unsigned CEN = 1 << 13;
const unsigned SZ = 1 << 14;
const unsigned MAX = SZ * SZ / 8;
const unsigned MAX_IN_QUEUE = 1 << 18;
unsigned BRD_LEN = 1;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};

unsigned B, S;
unsigned char data[MAX];

inline void make_used (unsigned x, unsigned y) {
	static unsigned t;
	t = (x << 14) | y;
	data[t >> 3] |= 1 << (t & 7);
}

inline bool is_used (unsigned x, unsigned y) {
	static unsigned t;
	t = (x << 14) | y;
	return (data[t >> 3] >> (t & 7)) & 1;
}

inline bool on_board (unsigned x, unsigned y) {
	return (x == CEN + BRD_LEN || x == CEN - BRD_LEN) && (y >= CEN-BRD_LEN) && (y <= CEN+BRD_LEN)
		|| (y == CEN + BRD_LEN || y == CEN - BRD_LEN) && (x >= CEN-BRD_LEN) && (x <= CEN+BRD_LEN);
}

unsigned long long cnt[2];
typedef std::pair <unsigned, unsigned> PUU;

void bfs () {
	static PUU _q1[MAX_IN_QUEUE], _q2[MAX_IN_QUEUE], *nq = _q1, *oq = _q2, c, go;
	unsigned np = 0, op = 0;
	unsigned i, j;
	unsigned lvl;//what we PUSH
	bool break_after = 0;
	unsigned obc = BRD_LEN * 8;

	make_used (CEN, CEN);
	oq[op++] = PUU (CEN, CEN);
	++cnt[0];

	for (lvl = 1; lvl <= S; ++lvl) {
		for (i = 0; i < op; ++i) {
			c = oq[i];
			for (j = 0; j < 4; ++j) {
				go = PUU (c.first + dx[j], c.second + dy[j]);
				if (!is_used (go.first, go.second)) {
					make_used (go.first, go.second);
//					printf ("going %d %d\n", (int)go.first - CEN, (int)go.second - CEN);
					nq[np++] = go;
					if (on_board (go.first, go.second) && !(--obc)) break_after = 1;
				}
			}
		}
//		printf ("lvl == %u, push %u\n", lvl, np);
		cnt[lvl & 1] += np;
		if (break_after) break;
		std::swap (nq, oq);
		op = np;
		np = 0;
	}
	printf ("here! %d\n", BRD_LEN);
	for (i = lvl + 1; i <= S; ++i) {
		np += 4;
		cnt[i & 1] += np;
	}
}

int main () {
	scanf ("%u %u", &B, &S);

	unsigned i;
	int x, y;
	for (i = 0; i < B; ++i) {
		scanf ("%d %d", &x, &y);
		make_used (x + CEN, y + CEN);
		BRD_LEN >?= (unsigned)abs (x);
		BRD_LEN >?= (unsigned)abs (y);
	}
	++BRD_LEN;
/*
	for (int i = CEN - BRD_LEN * 4; i < CEN + BRD_LEN * 4; ++i) {
		for (int j = CEN - BRD_LEN * 4; j < CEN + BRD_LEN * 4; ++j)
			putchar (" #"[is_used (i, j)]);
		puts ("");
	}
*/
	
	bfs ();
	printf ("%Lu %Lu\n", cnt[0], cnt[1]);
/*
	for (int i = CEN - BRD_LEN * 4; i < CEN + BRD_LEN * 4; ++i) {
		for (int j = CEN - BRD_LEN * 4; j < CEN + BRD_LEN * 4; ++j)
			putchar (" #"[is_used (i, j)]);
		puts ("");
	}*/
}
