/*
FROM: Croatia Olympiad in Informatics 2007
PROB: sabor
KEYW: bfs, ad-hoc
*/

#include <cstdio>
#include <cstring>
#include <utility>

using namespace std;

const int MAXN = 1 << 10;
const int OX = 1 << 9;
const int OY = 1 << 9;
const int DIF = 32;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};

char map[MAXN][MAXN];
int B, S;

void prnt () {
	int i, j;
	for (i = OY + DIF; i >= OY - DIF; --i) {
		for (j = OX - DIF; j <= OX + DIF; ++j)
			putchar (map[j][i]);
		putchar ('\n');
	}
}

void bfs () {
	static pair <int, int> q[MAXN * MAXN], c, go;
	int p3, i, j;

	map[OX][OY] = '#';
	q[p3 = 0, p3++] = make_pair (OX, OY);

	for (i = 0; i < p3; ++i) {
		c = q[i];
		for (j = 0; j < 4; ++j) {
			go = make_pair (c.first + dx[j], c.second + dy[j]);
			if (map[go.first][go.second] == ' ') {
				q[p3++] = go;
				map[go.first][go.second] = "#."[(go.first + go.second) & 1];
			}
		}
		if (i != 0 && p3 != i + 1 && map[c.first][c.second] != map[q[i+1].first][q[i+1].second])
			prnt ();
	}
}

int main () {
	scanf ("%d %d", &B, &S);

	memset (map, ' ', sizeof (map));
	int x, y;
	for (int i = 0; i < B; ++i) {
		scanf ("%d %d", &x, &y);
		map[x+OX][y+OY] = 'X';
	}

	bfs ();

	return 0;
}
