/*
FROM: Croatia 2007 Regional
PROB: circle
KEYW: bit operations
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 7;
const int MAXP = 1 << 10;

int N, K;
struct el {
	char a[MAXN];
	void operator = (const el &x) {memcpy (a, x.a, sizeof (a));}
	bool operator == (const el &x) {
		int i, j;
		for (i = 0; i < N; ++i) {
			for (j = 0; j < N && a[j] == x.a[(i+j)%N]; ++j);
			if (j == N) return 1;
		}
		return 0;
	}
	void next () {
		char fst = a[0];
		for (int i = 0; i < N-1; ++i) {
			a[i] = (a[i] + a[i+1]) & 1;
		}
		a[N-1] = (fst + a[N-1]) & 1;
	}
	void prev () {
		for (int i = 1; i < N; ++i)
			a[i] = (a[i-1] + 2 - a[i]) & 1;
	}
	void inv () {
		for (int i = 0; i < N; ++i)
			a[i] = 1 - a[i];
	}
	int popcnt () {
		int res = 0;
		for (int i = 0; i < N; ++i)
			res += a[i];
		return res;
	}
	void prnt () {
		int i;
		for (i = 0; i < N; ++i)
			printf ("%c", a[i]+'0');
		printf ("\n");
	}
};

int popp;
el pop[MAXP];

void inv2 (int fr, int to) {
	pop[to] = pop[fr];
	pop[to].inv ();
}

int main () {
	scanf ("%d %d\n", &N, &K);
	int i, j, k;
	for (i = 0; i < N; ++i)
		pop[0].a[i] = (getchar () == 'W');

	for (i = 0; i < K-1; ++i)
		pop[0].next ();

	inv2 (0, 1);
	popp = 2;
/*
	for (i = 0; i < popp; ++i)
		pop[i].prnt ();
	printf ("----\n");
*/
	static char used[MAXP];
	for (k = 0; k < K-1; ++k) {
		memset (used, 0, sizeof (used));
		for (i = 0; i < popp; ++i) {
			if ((pop[i].popcnt () & 1) == 0) {
				pop[i].prev ();
				inv2 (i, i + popp);
			} else {
				used[i] = 1;
				used[i+popp] = 1;
			}
		}

		popp *= 2;
/*		for (i = 0; i < popp; ++i) {
			printf ("%d -- ", used[i]);
			pop[i].prnt ();
		}
		printf ("----\n");
*/
		for (i = 0; i < popp; ++i) {
			if (used[i]) continue;
			for (j = i+1; j < popp; ++j)
				if (!used[j] && pop[i] == pop[j]) {
//					printf ("%d -> %d\n", i, j);
					used[j] = 1;
				}
		}
		int np = 0;
		for (i = 0; i < popp; ++i)
			if (!used[i])
				pop[np++] = pop[i];
		popp = np;
/*		for (i = 0; i < popp; ++i)
			pop[i].prnt ();
		printf ("----\n");*/
	}

	printf ("%d\n", popp);
/*
	for (i = 0; i < popp; ++i)
		pop[i].prnt ();
*/
	return 0;
}
