/*
FROM: COCI (Croatia Open Competition in Informatics) 2006 contest 1
PROB: debug
KEYW: ad hoc
*/

#include <cstdio>

const int MAXN = 310;
const int MAXM = 310;

int N, M;
char map[MAXN][MAXM];

struct state {
	int u, d, l, r;
	state () {}
	state (int _u, int _d, int _l, int _r) : u (_u), d (_d), l (_l), r (_r) {}
};

int XX = MAXN * MAXM * 2 - 1;
state queue[MAXN * MAXM * 2];
int p3, p2;

void myinc (int &a) {
	if (a == XX) a = 0; else ++a;
}

bool ok2 (int a, int b) {
	return map[a][b] == map[a+1][b+1] && map[a+1][b] == map[a][b+1];
}

bool ok3 (int a, int b) {
	return map[a][b] == map[a+2][b+2] && map[a+1][b] == map[a+1][b+2] && map[a+2][b] == map[a][b+2] && map[a][b+1] == map[a+2][b+1];
}

bool incr (state x) {
	static int n, i;
	n = x.d - x.u;
	for (i = 0; i <= n; ++i) {
//		printf ("%d %d   %d %d\n%d %d   %d %d\n", x.d, x.l + i, x.u - 1, x.r - 1 - i,\
		x.u + i, x.r, x.d-1-i, x.l-1);
		if (map[x.d][x.l + i] != map[x.u-1][x.r-1-i]
		 || map[x.u + i][x.r] != map[x.d-1-i][x.l-1])
			return 0;
	}

	return 1;
}

int main () {
	scanf ("%d %d", &N, &M);
	int i, j;
//	printf ("!\n");
	for (i = 0; i <= N + 1; ++i) {
		map[i][0] = map[i][M+1] = '2';
	}
	for (j = 0; j <= M + 1; ++j) map[0][j] = map[N+1][j] = '2';
	map[N+1][M+1] = '3';//avoid the frame to be considered 'good'

//	printf ("!!!\n");

	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= M; ++j)
			map[i][j] = getchar ();
		getchar ();
	}
/*
	for (i = 0; i <= N + 1; ++i) {
		for (j = 0; j <= M + 1; ++j)
			printf ("%c", map[i][j]);
		putchar ('\n');
	}*/
//	printf ("!1\n");

	for (i = 1; i < N; ++i)
		for (j = 1; j < M; ++j)
			if (ok2 (i, j))
				queue[p3++] = state (i, i + 2, j, j + 2);
	for (i = 1; i < N - 1; ++i)
		for (j = 1; j < M - 1; ++j)
			if (ok3 (i, j))
				queue[p3++] = state (i, i + 3, j, j + 3);

//	printf ("!\n");

	int res = -1;
	for (; p2 != p3; myinc (p2)) {
		res >?= queue[p2].d - queue[p2].u;
		if (incr (queue[p2])) {
			queue[p3] = state (queue[p2].u-1, queue[p2].d+1, queue[p2].l-1, queue[p2].r+1);
			myinc (p3);
		}
	}

	printf ("%d\n", res);

	return 0;
}
