/**/

#include <cstdio>

struct pos {
	int x, y;
	pos () {}
	pos (int _x, int _y) : x (_x), y (_y) {}
};

const int MAXN = 1 << 6;
const int MAXM = 1 << 6;
const int NEVER = 1000000000;

const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};

int N, M;
char map[MAXN][MAXM];
int time[MAXN][MAXM];

void bfs1 () {
	static pos queue[MAXN * MAXM];
	static int p3, i, j, k;
	p3 = 0;

	for (i = 0; i <= N + 1; ++i)
		for (j = 0; j <= M + 1; ++j)
			time[i][j] = NEVER;//not flooded

	for (i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j)
			if (map[i][j] == '*') {
				queue[p3++] = pos (i, j);
				time[i][j] = 0;
			}

	pos c, nc;
	for (i = 0; i < p3; ++i) {
		c = queue[i];
//		printf ("%d %d -- %d\n", c.x, c.y, time[c.x][c.y]);
		for (k = 0; k < 4; ++k) {
			nc = pos (c.x + dx[k], c.y + dy[k]);
			if (map[nc.x][nc.y] != 'X' && map[nc.x][nc.y] != 'D' && time[nc.x][nc.y] == NEVER) {
				queue[p3++] = nc;
				time[nc.x][nc.y] = time[c.x][c.y] + 1;
			}
		}
	}
/*
	for (i = 0; i <= N+1; ++i) {
		for (j = 0; j <= M+1; ++j)
			printf ("%3d", time[i][j]);
		putchar ('\n');
	}
*/
}
static int used[MAXN][MAXM];

int bfs2 () {
	static int i, j, k, p3;
	static pos queue[MAXN * MAXM];
	p3 = 0;

	for (i = 0; i <= N + 1; ++i)
		for (j = 0; j <= M + 1; ++j)
			used[i][j] = -1;//haven't been there

	for (i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j)
			if (map[i][j] == 'S') {
				queue[p3++] = pos (i, j);
				used[i][j] = 0;
				goto start;
			}

	start:;
	pos c, cn;
	for (i = 0; i < p3; ++i) {
		c = queue[i];
//		printf ("popped %d %d -- %d\n", c.x, c.y, used[c.x][c.y]);

		if (map[c.x][c.y] == 'D') return used[c.x][c.y];
		for (k = 0; k < 4; ++k) {
			cn = pos (c.x + dx[k], c.y + dy[k]);
//			printf ("try go %d %d -- ", cn.x, cn.y);
//			printf ("%d %d(%d %d) %d\n", map[cn.x][cn.y] != 'X', time[cn.x][cn.y] > used[c.x][c.y] + 1, time[cn.x][cn.y], used[c.x][c.y], used[cn.x][cn.y] == -1);
			if (map[cn.x][cn.y] != 'X' && time[cn.x][cn.y] > used[c.x][c.y] + 1 && used[cn.x][cn.y] == -1) {
				queue[p3++] = cn;
				used[cn.x][cn.y] = used[c.x][c.y] + 1;
			}
		}
	}

	return -1;
}

int main () {
	scanf ("%d %d\n", &N, &M);

	int i, j;
	for (i = 0; i <= N + 1; ++i) map[i][0] = map[i][M+1] = 'X';
	for (j = 0; j <= M + 1; ++j) map[0][j] = map[N+1][j] = 'X';
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= M; ++j) {
			char c = getchar ();
			map[i][j] = c;
		}
		getchar ();
	}
/*
	for (i = 0; i <= N+1; ++i) {
		for (j = 0; j <= M+1; ++j)
			putchar (map[i][j]);
		putchar ('\n');
	}
*/
	bfs1 ();
	int res = bfs2 ();
	/*
	for (i = 0; i <= N+1; ++i) {
		for (j = 0; j <= M+1; ++j)
			printf ("%4d", used[i][j]);
		putchar ('\n');
	}
		*/
	if (res != -1) printf ("%d\n", res);
	else printf ("KAKTUS\n");

	return 0;
}
