/*
FROM: COCI (Croatia Open Competition in Informatics) 2006 contest 3
PROB: bicikli
KEYW: topsort, bfs, dynamical programming
*/

#include <cstdio>
#include <cassert>

const int MAXN = 1 << 14;
const int MAXM = 1 << 17;
const int MOD = 1000000000;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N, M;
int vec[MAXN];
el buf[MAXM];

bool cov[MAXN];
int dp[MAXN];
int in[MAXN];
bool ovr[MAXN];

int _q[MAXN];

void bfs_cover () {
	static int p3 = 0, i, j;
	_q[p3++] = 0;
	cov[0] = 1;

	for (i = 0; i < p3; ++i)
		for (j = vec[_q[i]]; j != -1; j = buf[j].next)
			if (!cov[buf[j].to]) {
				cov[buf[j].to] = 1;
				_q[p3++] = buf[j].to;
			}
}

void bfs_dp () {
	static int p3 = 0, i, j;
	_q[p3++] = 0;
	dp[0] = 1;

	for (i = 0; i < p3; ++i) {
		for (j = vec[_q[i]]; j != -1; j = buf[j].next) {
			dp[buf[j].to] += dp[_q[i]];
			ovr[buf[j].to] |= ovr[_q[i]];
			if (dp[buf[j].to] >= MOD) {dp[buf[j].to] -= MOD; ovr[buf[j].to] = 1;}
			if (!(--in[buf[j].to])) _q[p3++] = buf[j].to;
		}
	}
}

int main () {
	scanf ("%d %d", &N, &M);

	int i, j, a, b;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		buf[i] = el (b, vec[a]);
		vec[a] = i;
	}
/*
	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (j = vec[i]; j != -1; j = buf[j].next)
			printf (" %d", buf[j].to);
		printf ("\n");
	}
*/
	bfs_cover ();
//	for (i = 0; i < N; ++i) printf ("%d ", cov[i]); printf ("\n");
	if (!cov[1]) {printf ("0\n"); return 0;}//no path to 2
	for (i = 0; i < N; ++i) {
		if (!cov[i]) continue;
		for (j = vec[i]; j != -1; j = buf[j].next) {
//			#warning remove this
//			assert (cov[buf[j].to]);
			++in[buf[j].to];
		}
	}

	bfs_dp ();
	if (in[1] != 0)//not all pahts have been traversed
		printf ("inf\n");
	else if (ovr[1])
		printf ("%09d\n", dp[1]);
	else
		printf ("%d\n", dp[1]);

	return 0;
}
