/*
FROM: COCI (Croatia Open Competition in Informatics) 2006 contest 3
PROB: tenkici
KEYW: stack
*/

#include <cstdio>
#include <vector>
#include <stack>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 9;

unsigned N;
std::vector <std::pair <int, int> > pos;
std::stack <int> stks[MAXN];

std::vector <std::pair <int, int> > ans;

int _dir;
inline void wrt (int id, int cnt) {
//	printf ("--> %d %d %d\n", id, cnt, _dir);
	for (int i = 0; i < cnt; ++i) ans.push_back (std::make_pair (id, _dir));
}

void solve (int dir) {
	_dir = dir;
	unsigned i, j, _old_size;
	int cs = 0;
/*
	for (i = 0; i < N; ++i) printf ("%d - %d\n", i, stks[i].size ());
	puts ("");
*/
	for (i = 0; i < N; ++i) {
		_old_size = stks[i].size ();
		if (cs < 0 && _old_size) {
//			printf ("i, cs, stks[i].size () %d %d %d", i, cs, stks[i].size ());
			for  (j = -cs; j && stks[i].size (); --j) {
				wrt (stks[i].top (), j);
				stks[i-j].push (stks[i].top ());
				stks[i].pop ();
			}
		}
		cs += _old_size;
		--cs;
	}
	if (dir & 1)
		for (i = 0; i < N; ++i) stks[i] = std::stack <int> ();
	else
		std::reverse (stks, stks + N);
}

int main () {
	scanf ("%u", &N);
	pos.resize (N);

	unsigned i;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &pos[i].first, &pos[i].second);
		--pos[i].first;
		--pos[i].second;
	}

	for (i = 0; i < N; ++i)
		stks[pos[i].first].push (i);
	solve (0);
	solve (1);

	for (i = 0; i < N; ++i)
		stks[pos[i].second].push (i);
	solve (2);
	solve (3);

	printf ("%u\n", (unsigned)ans.size ());
	const char *toc = "UDLR";
	for (i = 0; i < ans.size (); ++i)
		printf ("%d %c\n", ans[i].first, toc[ans[i].second]);

	return 0;
}
