/*
FROM: COCI (Croatia Open Competition in Informatics) 2006 contest 3
PROB: tenkici
KEYW: stack
NOTE: Only solves one part of the task (60%)
*/

#include <cstdio>
#include <vector>

const int MAXN = 1 << 9;

int N;
int _rows[MAXN];
int _cols[MAXN];
int moves;

void solve (int vec[]) {
	static std::vector <int> to_give;
	static std::vector <int> to_take;

	for (int i = 0; i < N; ++i) {
		if (vec[i] == 0) {
			if (to_take.empty ()) {
				to_give.push_back (i);
			} else {
				moves += i - to_take.back ();
				to_take.pop_back ();
			}
		} else if (vec[i] > 1) {
			for (int j = 1; j < vec[i]; ++j)
				if (to_give.empty ()) {
					to_take.push_back (i);
				} else {
					moves += i - to_give.back ();
					to_give.pop_back ();
				}
		}
	}
}

int main () {
	scanf ("%d", &N);

	int i, x, y;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &x, &y);
		--x; --y;
		++_rows[x];
		++_cols[y];
	}

	solve (_rows);
	solve (_cols);

	printf ("%d\n", moves);

	return 0;
}
