/*
FROM: COCI (Croatia Open Competition in Informatics) 2006 contest 3
PROB: tenkici
KEYW: stack
NOTE: checker!!
*/

#include <cstdio>
#include <cassert>
#include <vector>

const int MAXN = 1 << 9;

int N;
int res;
bool board[MAXN][MAXN];
std::vector <std::pair <int, int> > pos;

int dx[] = {-1, 1, 0, 0};
int dy[] = {0, 0, -1, 1};

char toi (char d) {
	switch (d) {
		case 'U': return 0;
		case 'D': return 1;
		case 'L': return 2;
		case 'R': return 3;
		default : return 255;
	}
}

int main (int argc, char *argv[]) {
	assert (argc == 4);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
	FILE *sol = fopen (argv[3], "r");
	assert (in && out && sol);

	fscanf (in, "%d", &N);
	pos.resize (N);
	int i;
	for (i = 0; i < N; ++i) {
		fscanf (in, "%d %d", &pos[i].first, &pos[i].second);
		--pos[i].first;
		--pos[i].second;
		board[pos[i].first][pos[i].second] = 1;
	}
	fclose (in);

	fscanf (out, "%d", &res);
	int res2;
	fscanf (sol, "%d", &res2);
	assert (res == res2);
	int a;
	char d;
	int nx, ny;
	
	
//	printf ("%d res\n", res);
	for (i = 0; i < res; ++i) {
		fscanf (out, "%d %c", &a, &d);
		d = toi (d);
//		printf ("-- %d %d\n", a, d);

		nx = pos[a].first + dx[d];
		ny = pos[a].second + dy[d];
		assert (nx >= 0 && ny >= 0 && nx < N && ny < N && !board[nx][ny]);
		board[nx][ny] = 1;
		board[pos[a].first][pos[a].second] = 0;
		pos[a].first = nx;
		pos[a].second = ny;
	}
	
	static bool used[MAXN];
	for (i = 0; i < N; ++i) used[pos[i].first] = 1;
	for (i = 0; i < N; ++i) assert (used[i]);
	for (i = 0; i < N; ++i) used[pos[i].second] = 0;
	for (i = 0; i < N; ++i) assert (!used[i]);

	printf ("YEP!\n");

	return 0;
}
