/*
FROM: COCI (Croatia Open Competition in Informatics) 2006 contest 3
PROB: trojke
KEYW: full exhaustion
*/

#include <cstdio>
#include <cstdlib>
#include <cctype>

const int ALPHA = 1 << 5;
const int MAXN = 1 << 7;

int _nod (int a, int b) {
	return b ? _nod (b, a % b) : a;
}

inline int nod (int a, int b) {
	return a > b ? _nod (a, b) : _nod (b, a);
}

struct pos {
	int x, y;
	pos () {}
	pos (int _x, int _y) : x (_x), y (_y) {}
	pos operator - (const pos &a) const {return pos (x - a.x, y - a.y);}
	bool operator == (const pos &a) const {return x == a.x && y == a.y;}
	pos scr () const {pos ret (x, y); int k = nod (abs (x), abs (y)); ret.x /= k; ret.y /= k; if (ret.x < 0) {ret.x = -x; ret.y = -y;} return ret;}
};

int N;
int A;
pos vec[ALPHA];

int main () {
	scanf ("%d\n", &N);

	static char line[MAXN];
	int i, j, k;
	for (i = 0; i < N; ++i) {
		gets (line);
		for (j = 0; j < N; ++j)
			if (isalpha (line[j]))
				vec[A++] = pos (i, j);
		
	}
/*
	for (i = 0; i < A; ++i)
		printf ("%d %d\n", vec[i].x, vec[i].y);
*/
	int sum = 0;
	pos _tmp;
	for (i = 0; i < A; ++i)
		for (j = i + 1; j < A; ++j) {
			_tmp = (vec[j] - vec[i]).scr ();
			for (k = j + 1; k < A; ++k)
				sum += _tmp == (vec[k] - vec[i]).scr ();
		}

	printf ("%d\n", sum);

	return 0;
}
