/*
FROM: COCI (Croatia Open Competition in Informatics) 2007 contest 5
PROB: dvaput
KEYW: string matching, double hash
*/

#include <cstdio>
#include <map>

const int MAXN = 1 << 18;

const long long MOD1 = 989898989;
const int BASE1 = 26;
const long long MOD2 = 901278940;
const int BASE2 = 27;
/*
const unsigned long long MOD1 = 9894156784956179ll;
const int BASE1 = 29;
const unsigned long long MOD2 = 9894156784956179ll;
const int BASE2 = 29;
*/
int N;
char line[MAXN];
std::map <std::pair <int, int>, int> oc;

bool _try (int k) {
//	printf ("_try %d\n", k);
	int i;
	unsigned long long ch1 = 0, ch2 = 0, X1 = 1, X2 = 1;
	std::map <std::pair <int, int>, int> :: iterator it;
	for (i = 0; i < k; ++i) {
		ch1 *= BASE1;
		ch1 += line[i];
		ch1 %= MOD1;

		ch2 *= BASE2;
		ch2 += line[i];
		ch2 %= MOD2;
		
		X1 *= BASE1;
		X1 %= MOD1;

		X2 *= BASE2;
		X2 %= MOD2;
	}

	oc = std::map <std::pair <int, int>, int> ();
	for (i = k; i < N; ++i) {
//		printf ("%d -- %Ld\n", i-k, ch);
		oc[std::make_pair (ch1, ch2)] = i - k;
		ch1 *= BASE1;
		ch1 += line[i];
		ch1 += MOD1 * 26ll;
		ch1 -= X1 * line[i-k];
		ch1 %= MOD1;
		
		ch2 *= BASE2;
		ch2 += line[i];
		ch2 += MOD2 * 26ll;
		ch2 -= X2 * line[i-k];
		ch2 %= MOD2;

		if ( (it = oc.find (std::make_pair (ch1, ch2))) != oc.end ()) {
//			printf ("pos %d %d (%d)\n", it->second, i - k + 1, k);
			return 1;
		}
	}
	return 0;
}

int main () {
	scanf ("%d\n", &N);
	gets (line);
	for (int i = 0; i < N; ++i) line[i] -= 'a';

	int l = 0, r = N, m;
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (_try (m))
			l = m;
		else
			r = m;
	}

	printf ("%d\n", l);

	return 0;
}
