/*
FROM: COCI (Croatia Open Competition in Informatics) 2007 contest 5
PROB: ivana
KEYW: dynamical programming
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 7;
const int MAXrN = MAXN * 2;

int N, rN;
int vec[MAXrN];
int sum[MAXrN];
int dp[MAXrN][MAXrN];

int f (int i, int j) {
	if (dp[i][j] != -1) return dp[i][j];
	if (i == j) return dp[i][j] = 0;
	return dp[i][j] = sum[i] - sum[j] - (f (i, j-1) <? f (i+1, j));
}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d", vec + i);
		vec[i+N] = vec[i] = vec[i] & 1;
	}

	for (i = 2*N-1; i >= 0; --i) sum[i] = sum[i+1] + vec[i % N];
//	for (i = 0; i < 2 * N; ++i) printf ("%d ", sum[i]); printf ("--sums!\n");
	if (sum[0] == 0) {printf ("0\n"); return 0;}

	memset (dp, -1, sizeof (dp));
	f (0, 2 * N);
/*
	for (i = 0; i < 2 * N; ++i) {
		for (int j = 0; j < 2 * N; ++j)
			printf ("%3d", dp[i][j]);
		printf ("\n");
	}
*/
	
	int M = sum[0] / 2, res = 0;
	M = M / 2 - !(M % 2);
	for (i = 0; i < N; ++i)
		if (dp[i+1][i+N] <= M) {
//			printf ("dp[%d][%d] <= %d\n", i+1, i+N, M);
			++res;
		}

	printf ("%d\n", res);

	return 0;
}
