/*
FROM: COCI (Croatia Open Competition in Informatics) 2007 contest 6
PROB: V
KEYW: dynamical programming, brute force, mathematics, 2 solutions
*/

#include <cstdio>
#include <cctype>

const int DIG = 16;
const int MAXN = 16;
const int MAXMOD = 1 << 17;

int NN = 11;//number of digits of biggest UB
long long N, LB, UB;
long long dp[MAXN][MAXMOD];

long long pow10[MAXN];

bool pos[DIG];
int pl[DIG], plc;

int mymod (long long a) {
	static long long BIGMUL = (pow10[NN+1] / N + 1) * N;
	return (a + BIGMUL) % N;
}

void calc_dp () {
	int i, j, k;
	dp[0][0] = 1;
	for (i = 1; i <= NN; ++i)
		for (j = 0; j < N; ++j)
			for (k = 0; k < plc; ++k) {
//				printf ("%d %d %d(%d) -- newmod %d\n", i, j, k, pl[k], mymod (j - pl[k] * pow10[i-1]));
				dp[i][j] += dp[i-1][mymod (j - pl[k] * pow10[i-1])];
			}
/*
	for (i = 0; i < NN; ++i) {
		for (j = 0; j < N; ++j)
			printf (" %3Ld", dp[i][j]);
		puts ("");
	}*/
}

long long calc_le (long long v) {
//	printf ("calc_le %Ld\n", v);
	if (v == 0) return 1;


	long long res = 0;
	int i, j;
	int vec[MAXN], vp = 0;
	while (v) {
		vec[vp++] = v % 10;
		v /= 10;
	}
	
//	printf ("yep!\n");

	if (pos[0])
		res += dp[vp-1][0];
	else
		for (i = 1; i < vp; ++i)
			res += dp[i][0];

//	printf ("yep!\n");

	long long cmod = 0;
	for (i = vp-1; i >= 0; --i) {
//		printf ("here??");
		for (j = (i == vp-1); j < vec[i]; ++j) {
			if (!pos[j]) continue;
//			printf ("put dig %d at %d - adding dp[%d][%d] (%Ld)\n", j, i, i, mymod (cmod - pow10[i] * j), \
			dp[i][mymod (cmod - pow10[i] * j)]);

			res += dp[i][mymod (cmod - pow10[i] * j)];
		}
		if (pos[j]) cmod = mymod (cmod - pow10[i] * j);
		else break;
	}

	if (i == -1 && !cmod) {
//		printf ("!inc\n");
		++res;
	}
//	printf ("returning - %Ld\n", res);
	return res;
}

int main () {
	scanf ("%Ld %Ld %Ld\n", &N, &LB, &UB);
	char t;
	while (isdigit (t = getchar ())) {
		pos[t-'0'] = 1;
		pl[plc++] = t-'0';
	}

	int i; for (i = pow10[0] = 1; i < MAXN; ++i) pow10[i] = pow10[i-1] * 10;

	if (N < MAXMOD) {
		calc_dp ();
		printf ("%Ld\n", calc_le (UB) - calc_le (LB-1));
	} else {
		long long res = 0;
		for (int i = 1; N * i <= UB; ++i) {
			if (N * i < LB) continue;
			long long ii = i * N;
			while (ii) {
				if (!pos[ii % 10]) break;
				ii /= 10;
			}
			if (!ii) ++res;
		}
		printf ("%Ld\n", res);
	}

	return 0;
}
