/*
FROM: COCI (Croatia Open Competition in Informatics) 2007 contest 6
PROB: V
KEYW: dynamical programming, brute force, mathematics, 2 solutions
*/

#include <cstdio>
#include <cassert>
#include <cctype>

const int MAXBF = 99999;
const int MAXN = 16;
const int MAXMOD = 1 << 17;//130 000

long long X, LB, UB;
long long MULX;
bool can[16];
int pos[16], PC;

long long dp[MAXN][MAXMOD];
long long pow10[MAXN];

long long cnt (long long bnd) {
	long long res = 0;
	if (can[0]) {
		
	} else {
		for (i = 0; (pos10[i+1] - 1) < bnd; ++i) {
			res += dp[i][0];
		}
		for (; i; --i) {
			long long ub = bnd % pow10[i+1] / pow10[i];
			long long p10 = pow10[i] % X;
			for (j = 0; j < ub; ++j) {
				if (!can[j]) continue;
				res += dp[i-1][(CMOD + MULX - p10 * pos[j]) % X];
			}
			if (can[ub]) {
				CMOD -= p10 * ub - MULX;
				CMOD %= X;
			} else break;
		}
		if (i == 0) {
			for (j = 0; j <= bnd % 10; ++j)
				if (can[j] && j % X == CMOD) ++res;
		}
	}
	return res;
}


int main () {
	scanf ("%Ld %Ld %Ld\n", &X, &LB, &UB);
	MULX = X * 100;

	char t;
	while (isdigit (t = getchar ())) {
		can[t - '0'] = 1;
		pos[PC++] = t - '0';
	}

	long long res = 0;
	if (X > MAXBF) {
		long long i, ii;
		fprintf (stderr, "%Ld\n", (UB - LB) / X);
		for (i = LB + (X - LB % X) % X; i <= UB; i += X) {
			ii = i;
			while (ii && can[ii % 10]) ii /= 10;
			if (!ii) ++res;
		}
	} else {
		for (pow10[0] = i = 1; i < 12; ++i) pow10[i] = pow10[i-1] * 10;

		for (i = 0; i < 10; ++i) if (can[i]) ++dp[0][i % X];
		for (i = 1; pow10[i] <= UB; ++i) {
			long long p10 = pow10[i] % X;
			for (j = 0; j < X; ++j) {
				for (k = 0; k < PC; ++k) {
					dp[i][j] += dp[i-1][(j - p10 * pos[k] + MULX) % X];
				}
			}
		}
		res = cnt (UB) - cnt (LB-1);
	}

	printf ("%Ld\n", res);

	return 0;
}
