/*
TASK:double
LANG:C++

FROM: IOI 2001 day2
PROB: double
KEYW: module, output-only, add-hoc
NOTE: Velin's warmup : Theme 1 (convex hull, binary search)
*/

#include "aeslibc.h"

#include <stdio.h>
//#include <algorithm>
#include <string.h>
#include <stdlib.h>

const int MAXN = 1 << 20;

struct blkey {
	Block b;
	int k;
//	blkey () {}
//	blkey (const Block _b, int _k) : k (_k) {memcpy (b, _b, sizeof (Block));}
//	blkey& operator = (const blkey a) {memcpy (b, a.b, sizeof (Block)); k = a.k; return *this;}
};

HexStr _beg;
HexStr _targ;
Block beg;
Block targ;
int s;
int ub;

blkey mids[MAXN];
Block keys[MAXN];

char toc (int a) {
	return a < 10 ? a + '0' : a - 10 + 'A';
}

inline int cmpBlock (const Block a, const Block b) {
	int i;
	for (i = 15; i && a[i] == b[i]; --i);
	return a[i] - b[i] < 0 ? -1 : a[i] - b[i] > 0 ? 1 : 0;
}
/*
inline bool cmp (int a, int b) {
	return cmpBlock (mids[a].b, mids[b].b);
}
*/
inline int cmp (const void *a, const void *b) {
	return cmpBlock (mids[*(const int*)(a)].b, mids[*(const int*)(b)].b);
}

int *idx;
int bsrch (Block x) {
	int l = -1, r = ub, m;
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (cmpBlock (mids[idx[m]].b, x) < 0)
			l = m;
		else
			r = m;
	}

	return r == ub || cmpBlock (mids[idx[r]].b, x) ? -1 : idx[r];
}

int main () {
	scanf ("%d\n", &s);
	gets (_beg);
	gets (_targ);

	hexstr2block (_beg, beg);
	hexstr2block (_targ, targ);

	ub = 1 << 4 * s;

	HexStr cHS;
	Block cB;
	Block mid;
	int i, j;
	int ii;
	for (i = 0; i < ub; ++i) {
		ii = i;
		for (j = 0; j < s; ++j) {
			cHS[j] = toc (ii & 15);
			ii >>= 4;
		}
		hexstr2block (cHS, cB);
		encrypt (beg, cB, mid);

		memcpy (keys[i], cB, sizeof (Block));
		memcpy (mids[i].b, mid, sizeof (Block));
		mids[i].k = i;
	}

	idx = new int [ub];
	for (i = 0; i < ub; ++i) idx[i] = i;
	qsort (idx, ub, sizeof (int), cmp);

	int pos;
	HexStr k1, k2;
	for (i = 0; i < ub; ++i) {
		decrypt (targ, keys[i], mid);
		if ((pos = bsrch (mid)) != -1) {
			block2hexstr (keys[mids[pos].k], k1);
			block2hexstr (keys[i], k2);
			printf ("%s\n%s\n", k1, k2);
			return 0;
		}
	}

	printf ("NO MACH FOUND!\n");
	return -1;
}
