/*
FROM: IOI 2006 day 0
PROB: fifth
KEYW: kmp, interactive
*/

#include <cstdio>
#include <cassert>

const int MAXN = 1 << 23;

int N;
int fl[MAXN];

int mod (int i) {return i < N ? i : i - N;}

bool diff (int s1, int p1, int s2, int p2) {
	printf ("E %d %d %d %d\n", p1 + 1, s1 + 2, p2 + 1, s2 + 2); fflush (stdout);
	int ans;
	scanf ("%d", &ans);
	assert (ans != 2);
	return ans == 0;
}

void pre () {
	fl[0] = 0;
	fl[1] = 0;
	int crnt;
	for (int i = 2; i < N; ++i) {
		crnt = fl[i-1];
		while (crnt && diff (2, crnt, 2, i-1)) crnt = fl[crnt];
		fl[i] = crnt + !diff (2, crnt, 2, i-1);
//		printf ("--fl[%d] == %d\n", i, fl[i]);
	}
//	for (int i = 0; i < N; ++i) printf ("%d ", fl[i]); printf ("\n");
}

void kmp () {
	int crnt = 0;
	for (int i = 0;; ++i) {
		while (crnt && diff (2, crnt, 1, mod (i))) crnt = fl[crnt];
		crnt += !diff (2, crnt, 1, mod (i));
		if (crnt == N) {printf ("R 1 %d\n", i - N + 1); break;}
		if (i - crnt >= N) {printf ("R 0\n"); break;}
	}
}

int main () {
	printf ("N\n"); fflush (stdout);
	scanf ("%d", &N);

	pre ();
	kmp ();

	return 0;
}
