/*
FROM: International Olympiad in Informatics (IOI) 2006 day 2
PROB: points
KEYW: input generator
*/

#include <cstdio>
#include <cassert>
#include <vector>
#include <cstdlib>
#include <algorithm>

struct pnt {
	int x, y;
	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}
};

long long S (const pnt &a, const pnt &b, const pnt &c) {
	return (long long)(b.x - a.x) * (c.y - a.y) - (long long)(b.y - a.y) * (c.x - a.x);
}

int G, R, C;
std::vector <pnt> vec;

bool add (const pnt &p) {
	size_t i, j;
	for (i = 0; i < vec.size (); ++i)
		for (j = i + 1; j < vec.size (); ++j)
			if (S (vec[i], vec[j], p) == 0) goto end;
	end:;
	if (i != vec.size ()) return 0;
	vec.push_back (p);
	return 1;
}

int main (int argc, char *argv[]) {
	srand (time (0));
	assert (argc == 5);

	sscanf (argv[1], "%d", &G);
	sscanf (argv[2], "%d", &R);
	sscanf (argv[3], "%d", &C);
	FILE *out = fopen (argv[4], "w");
	assert (out);

	add (pnt (0, C));
	add (pnt (C, C));
	add (pnt (0, 0));
	add (pnt (C, 0));
	while ((int)vec.size () < G + 2) {
		add (pnt (rand () % (C - 2) + 1, rand () % (C - 2) + 1));
		printf ("%d\r", vec.size ());
	}
	
	while ((int)vec.size () < G + R) {
		add (pnt (rand () % (C - 2) + 1, rand () % (C - 2) + 1));
		printf ("%d\r", vec.size ());
	}

	std::swap (vec[G], vec[2]);
	std::swap (vec[G+1], vec[3]);


	fprintf (out, "%d\n", G);
	int i;
	for (i = 0; i < G; ++i)
		fprintf (out, "%d %d\n", vec[i].x, vec[i].y);
	fprintf (out, "%d\n", R);
	for (i = 0; i < R; ++i)
		fprintf (out, "%d %d\n", vec[i + G].x, vec[i + G].y);

	fclose (out);

	return 0;
}
