/*
FROM: IOI 2006 day 0
PROB: highways
KEYW: dfs, graph theory
*/

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <utility>

const int MAXN = 1 << 14;

int N, M;
std::vector <int> vec[MAXN];
bool used[MAXN];
std::vector <std::pair <int, int> > ans;

bool dfs (int a) {
	used[a] = 1;
	bool ret = 1;
	for (unsigned i = 0; i < vec[a].size (); ++i) {
		if (used[vec[a][i]]) continue;
		if (dfs (vec[a][i])) {
			ans.push_back (std::make_pair (a, vec[a][i]));
			ret = !ret;
		}
	}

	return ret;
}

int main () {
	scanf ("%d %d", &N, &M);

	int i, a, b;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		vec[a].push_back (b);
		vec[b].push_back (a);
	}

	for (i = 0; i < N; ++i)
		if (!used[i])
			if (dfs (i)) {
				printf ("-1\n");
				exit (0);
			}

	printf ("%u\n", ans.size ());
	for (i = 0; i < (int)ans.size (); ++i)
		printf ("%d %d\n", ans[i].first + 1, ans[i].second + 1);

	return 0;
}
