/*
FROM: IOI 2006 day 0
PROB: highways
KEYW: iterative dfs, graph theory
*/

#include <cstdio>
#include <cstdlib>

#include <vector>
#include <stack>
#include <utility>

const int MAXN = 1 << 14;

int N, M;
std::vector <int> vec[MAXN];

std::vector <std::pair <int, int> > ans;
bool sz[MAXN];
int prev[MAXN];

void dfs (int start) {
	std::stack <std::pair <int, int> > q;
	q.push (std::make_pair (start, 0));
	sz[start] = 1;
	prev[start] = N;

	int i;
	while (!q.empty ()) {
		std::pair <int, int> crnt = q.top ();
//		printf ("%d %d\n", crnt.first, crnt.second);
		for (i = crnt.second; i < (int)vec[crnt.first].size () && prev[vec[crnt.first][i]] != -1; ++i);
		if (i == (int)vec[crnt.first].size ()) {
			q.pop ();
//			printf ("fin %d -- %d\n", crnt.first, sz[crnt.first]);
			if (sz[crnt.first]) {
				sz[prev[crnt.first]] = !sz[prev[crnt.first]];
				ans.push_back (std::make_pair (prev[crnt.first], crnt.first));
			}
		} else {
//			printf ("go from %d to %d\n", crnt.first, vec[crnt.first][i]);
			prev[vec[crnt.first][i]] = crnt.first;
			sz[vec[crnt.first][i]] = 1;
			q.top ().second = i + 1;
			q.push (std::make_pair (vec[crnt.first][i], 0));
		}
	}
}

int main () {
	scanf ("%d %d", &N, &M);

	int i, a, b;
	for (i = 0; i < N; ++i) prev[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		vec[a].push_back (b);
		vec[b].push_back (a);
	}

	for (i = 0; i < N; ++i)
		if (prev[i] == -1)
			if (dfs (i), sz[i]) {
				printf ("-1\n");
				exit (0);
			}

	printf ("%u\n", ans.size ());
	for (i = 0; i < (int)ans.size (); ++i)
		printf ("%d %d\n", ans[i].first + 1, ans[i].second + 1);

	return 0;
}
