#include <stdio.h>
#include <queue>
#include <vector>
using namespace std;
      
//int pro[4] = {0, 1, 2, 3}; //priority to sort points: {scalar, cross}
  
struct Point
{
       int x, y;
       Point(){}
       Point(int _x, int _y):x(_x),y(_y){}
       Point operator-(Point p)
       {
             return Point(x - p.x, y - p.y);
       }
} P[1000020];
int cntP;

struct List
{
       int key;
       int next;
} G[400000];
int table[100020], cntG;

int removed[400000];

struct comp
{
     bool operator ()(int a, int b) const
     {
          if (P[a].y != P[b].y)
           return P[a].y > P[b].y;
          return P[a].x > P[b].x;
     }
};
priority_queue<int, vector<int>, comp> q;

int priority(Point A, Point B)
{
    int cross = A.x*B.y - A.y*B.x;
    if (cross > 0) return 0;
    else if (cross < 0) return 2;
    else return 1;
}
bool compClock(Point A, Point B, Point C)
{
     return (priority(A, B) < priority(A, C));
}

int N, W;
void init()
{
    scanf("%d", &N);
    for (int i = 1; i <= N; i++)
     table[i] = -1;
    for (int i = 1; i <= N; i++)
    {
        scanf("%d%d", &P[i].x, &P[i].y);
        q.push(i);
    }
    
    scanf("%d", &W);
    
    for (int i = 0; i < W; i++)
    {
        int a, b;
        scanf("%d%d", &a, &b);
        int save = table[a];
        table[a] = cntG;
        G[cntG].key = b;
        G[cntG++].next = save;
        
            save = table[b];
        table[b] = cntG;
        G[cntG].key = a;
        G[cntG++].next = save;
    }
    /*SORT ME*/
    for (int i = 1; i <= N; i++)
    {
        int v1 = table[i];
        if (G[v1].next != -1)
        for (; G[ G[v1].next ].next != -1; v1 = G[v1].next)
        {
            for (int v2 = G[v1].next; G[v2].next != -1; v2 = G[v2].next)
            {
                if ( !compClock(P[ G[ table[i]   ].key ] - P[i], 
                                P[ G[ G[v1].next ].key ] - P[i], 
                                P[ G[ G[v2].next ].key ] - P[i] ))
                {
                     //swap connections to save the twin neighboring   
                     if (G[v1].next != v2) 
                     {
                          int save = G[ G[v1].next ].next;
                          G[ G[v1].next ].next = G[ G[v2].next ].next;
                          G[ G[v2].next].next = save;
                     
                          save = G[v2].next;
                          G[v2].next = G[v1].next;
                          G[v1].next = save;
                     }
                     else 
                     {
                          G[v1].next = G[v2].next;
                          G[v2].next = G[ G[v2].next ].next;
                          G[ G[v1].next ].next = v2;
                          v2 = G[v1].next;
                     }
                }    
            }             
        }
        if (G[v1].next != -1)
         G[ G[v1].next ].next = table[i];  //make a cycle
        else G[v1].next = v1;
    }
}

int br = 0;
void solve()
{
     int cnt = 0;
     int visited[400000], cntV = 0;
     while (!q.empty())
     {
           cnt++;
           int p = q.top();
           q.pop();
           
           bool test = 0; //test for unremoved ribs
           int rib, miny = 1000001;
           for (int i = 0, v1 = table[p]; i < 4; v1 = G[v1].next, i++)
            if (!removed[v1]) 
            {
                 test = 1; 
                 if (P[G[v1].key].y < miny) {rib = v1; miny = P[G[v1].key].y; }
            }
           if (!test) continue;
     
           while (1)
           {            
                 while (removed[rib]) //cycle around the point to find the next rib
                 {
                       if (removed[rib] == cnt) break; // got the fall down walls
                       rib = G[rib].next;
                 }
                 if (removed[rib] == cnt) break;
                 
                 removed[rib] = cnt;
                 visited[cntV++] = rib;
                 rib ^= 1;            //go there by turning the rib
                 rib = G[rib].next;   //take the next
           }
           
           for (int i = 0; i < cntV; i++) if (removed[ visited[i] ] == cnt) // remove oposite ribs
            if (removed[ visited[i] ] != removed[ visited[i]^1 ]) removed[ visited[i]^1 ] = -1;
            else br++;
           cntV = 0;
     }
}
          
int main()
{
    init();
    solve();
    printf("%d\n", br/2);
    for (int i = 0; i < 2*W; i += 2)
     if (removed[i] == removed[i + 1]) printf("%d\n", (i/2) + 1);
    return 0;
}
