/*
FROM: LISH 07 day 1
PROB: flow
KEYW: dinitz max flow with full optimizations
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 10;
const int MAXM = 1 << 15;
const int MAX = 1 << 20;

struct el {
	int to;
	int rd;
	int next;
	el () {}
	el (int _to, int _rd, int _next) : to (_to), rd (_rd), next (_next) {}
};

int N, M;
int vec[MAXN];
el buf[MAXM];
int D[MAXN];
int source, sink;

int __bac_D_source;
bool bfs () {
	static int q[MAXN], p3;
	int i, j;
	memset (D, -1, sizeof (D));

	q[p3 = 0, p3++] = sink;
	D[sink] = 0;
	for (i = 0; i < p3; ++i) {
//		printf ("pop %d %d\n", q[i], D[q[i]]);
		for (j = vec[q[i]]; j != -1; j = buf[j].next) {
//			printf ("->%d %d\n", buf[j].to, buf[j ^ 1].rd);
			if (D[buf[j].to] == -1 && buf[j ^ 1].rd) {
//				printf ("\tpush %d\n", buf[j].to);
				D[buf[j].to] =  D[q[i]] + 1;
				q[p3++] = buf[j].to;
			}
		}
	}
	return (__bac_D_source = D[source]) != -1;
}

int edge_l[MAXN], elp;


int dfs (int v) {
//	printf ("dfs %d\n");
	if (v == sink) {
		return MAX;
	}

	int tmp;
	for (int i = vec[v]; i != -1; i = buf[i].next) {
		if (D[buf[i].to] == D[v] - 1 && buf[i].rd) {
			edge_l[elp++] = i;
			if (tmp = dfs (buf[i].to)) {return tmp <? buf[i].rd;}
			--elp;
		}
	}

//	printf ("<--\n");
	D[v] = -2;
	return 0;
}

int dinitz () {
	int maxflow = 0, cflow;
	while (bfs ()) {
		while (elp = 0, D[source] = __bac_D_source, cflow = dfs (source)) {
			maxflow += cflow;
//			printf ("cflow = %d\n", cflow);
			for (int i = 0; i < elp; ++i) {
				buf[edge_l[i]].rd -= cflow;
				buf[edge_l[i] ^ 1].rd += cflow;
			}
		}
	}
	return maxflow;
}

int main () {
	scanf ("%d %d", &N, &M);

	int i;
	int a, b, c;
	int bp = 0;
	memset (vec, -1, sizeof (vec));
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", &a, &b, &c);
		--a; --b;

		buf[bp] = el (b, c, vec[a]);
		vec[a] = bp++;
		buf[bp] = el (a, 0, vec[b]);
		vec[b] = bp++;
	}

	scanf ("%d%d", &source, &sink);
	--source; --sink;

	printf ("%d\n", dinitz ());

	return 0;
}
