/**/

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

const int MAXN = 1 << 8;
const int MAXM = 1 << 8;
const int ALPHA = 1 << 8;

const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};

int N, M;
unsigned char brd[MAXN][MAXM];

bool targ[ALPHA];
int used_col[ALPHA];
bool used[MAXN][MAXM];

int res;

int code (int x, int y) {
	return (x << 8) | y;
}

void decode (int code, int &x, int &y) {
	x = code >> 8;
	y = code & 0xff;
}

inline bool in_brd (int nx, int ny) {
	return nx >= 0 && nx < N
		&& ny >= 0 && ny < M;	
}

void bfs1 (int sx, int sy) {
	static int q[MAXN * MAXM], p3;
	int cx, cy;
	int nx, ny;
	int i, k;
	q[p3 = 0, p3++] = code (sx, sy);

	for (i = 0; i < p3; ++i) {
		decode (q[i], cx, cy);
		for (k = 0; k < 4; ++k) {
			nx = cx + dx[k];
			ny = cy + dy[k];
			if (in_brd (nx, ny)) {
				if (brd[nx][ny] == 'A'
				 && !used[nx][ny]) {
					used[nx][ny] = 1;
					q[p3++] = code (nx, ny);
				} else if (brd[nx][ny] != 'A') {
					if (targ[(int)brd[nx][ny]] != 1) {
//						printf ("targ[%c] = 1 (%d)\n", brd[nx][ny], (int)brd[nx][ny]);
						++res;
//						printf ("_%c_ targ\n", brd[nx][ny]);
						targ[(int)brd[nx][ny]] = 1;
					}
				}
			}
		}
	}
//	printf ("-----\n");
}
int _q1[MAXN * MAXM], _q2[MAXN * MAXM], *q1 = _q1, *q2 = _q2;
int p11, p21;
int p13, p23;

void beg_add (int x, int y) {
	if (used_col[(int)brd[x][y]] == -1) {
//		printf ("brd[%d][%d] == %c --> added\n", x, y, brd[x][y]);
		used_col[(int)brd[x][y]] = 1;//
		used[x][y] = 1;
		q2[p23++] = code (x, y);
//		printf ("-->%d\n", p13 - p11 + p23 - p21);
	}
}

bool nempty () {
	return p13 - p11 + p23 - p21 > 0;	
}

void get (int &x, int &y) {
	if (p13 - p11) {
//		printf ("got1 --");
		decode (q1[p11++], x, y);
	} else {
//		printf ("got2 --");
		assert (p23 - p21);
		decode (q2[p21++], x, y);
	}
}

int step = -1;
void bfs2 () {
	int i, j, k;
	int nx, ny;
	int cx, cy;
	memset (used_col, -1, sizeof (used_col));

	for (i = 0; i < N; ++i) {
		beg_add (i, 0);
		beg_add (i, M-1);
	}
	for (j = 1; j < M-1; ++j) {
		beg_add (0, j);
		beg_add (N-1, j);
	}

	while (nempty ()) {
		get (cx, cy);
//		printf ("%d %d -- _%c_(%d)\n", cx, cy, brd[cx][cy], used_col[(int)brd[cx][cy]]);
		if (targ[(int)brd[cx][cy]] && step == -1) {
			step = used_col[(int)brd[cx][cy]] - 1;
		}
		for (k = 0; k < 4; ++k) {
			nx = cx + dx[k];
			ny = cy + dy[k];
			if (in_brd (nx, ny)) {
//				printf ("\t\tnxy  %d %d\n", nx, ny);
				if (brd[nx][ny] == brd[cx][cy]) {
					if (!used[nx][ny]) {
						used[nx][ny] = 1;
						q1[p13++] = code (nx, ny);
//						printf ("\tpush %d %d _%c_\n", nx, ny, brd[nx][ny]);
					}
				} else if (used_col[(int)brd[nx][ny]] == -1 && brd[nx][ny] != 'A'){//new color
//					printf ("will add 2 -- %d %d _%c_ --> %d\n", nx, ny, brd[nx][ny], used_col[(int)brd[nx][ny]]);
					used[nx][ny] = 1;
					used_col[(int)brd[nx][ny]] = used_col[(int)brd[cx][cy]] + 1;
					q2[p23++] = code (nx, ny);
//					printf ("\tpush2 %d %d _%c_(%d)\n", nx, ny, brd[nx][ny], used_col[(int)brd[nx][ny]]);
				}
			}
		}
/*		for (i = 0; i < N; ++i) {
			for (j = 0; j < M; ++j)
				putchar (".#"[used[code (i, j)]]);
			putchar ('\n');
		}*/
	}
}

int main () {
	scanf ("%d %d\n", &N, &M);

	int i, j;
	for (i = 0; i < N; ++i)
		gets ((char *)brd[i]);
/*
	for (i = 0; i < N; ++i) {
		for (j = 0; j < M; ++j)
			printf ("(%3d)", (int)brd[i][j]);
		puts ("");
	}
*/
	for (i = 0; i < N; ++i)
		for (j = 0; j < M; ++j)
			if (brd[i][j] == 'A')
				bfs1 (i, j);

	memset (used, 0, sizeof (used));
	bfs2 ();
	for (i = 0; i < N; ++i)
		for (j = 0; j < M; ++j)
			if (targ[(int)brd[i][j]]
			 && !used[i][j]) {
				printf ("-1\n");
				return 0;
			}

	printf ("%d\n", step + res);

	return 0;
}
