/*
FROM: LISH 2007 day 3
PROB: folding
KEYW: dynamical programming, hash codes string
*/

#include <cstdio>
#include <cmath>
#include <cstring>
#include <utility>

#define x first
#define y second

typedef std::pair <unsigned, unsigned> PI;
const PI BASE (29, 31);

PI operator + (const PI &a, const PI &b) {return PI (a.x + b.x, a.y + b.y);}
PI operator - (const PI &a, const PI &b) {return PI (a.x - b.x, a.y - b.y);}
PI operator * (const PI &a, const PI &b) {return PI (a.x * b.x, a.y * b.y);}
PI dup (unsigned a) {return PI (a, a);}

const int MAXN = 1 << 7;
const int INF = 1 << 20;

PI hash[MAXN];
PI POW_BASE[MAXN];

PI find_hash (int b, int l) {
//	printf ("%d %d --> hash[%d] - hash[%d] * PB[%d] -- %u %u * %u -- %u %u -- %u\n"\
	, b, l\
	, b + l, b, l\
	, hash[b+l].x, hash[b].x, POW_BASE[l].x\
	, hash[b+l].x, (hash[b] * POW_BASE[l]).x\
	, (hash[b+l] - hash[b] * POW_BASE[l]).x);
	return hash[b+l] - hash[b] * POW_BASE[l];
}

int N;
char s[MAXN];
int dp[MAXN][MAXN];
PI prev[MAXN][MAXN];


bool pat_match (int a, int b, int c) {
	b -= a;
	PI beg_hash = find_hash (a, b);
	for (int i = a + b; i != c; i += b)
		if (find_hash (i, b) != beg_hash) {
//			printf ("%d %d %d --> BAD (%d)\n", a, b, c, i);
			return 0;
		}

//	printf ("%d %d %d --> GOOD!\n", a, b, c);
/*	for (int i = a; i != c; i += b)
		printf ("%.*s(%u)", b, s + i, find_hash (i, b).x);
	puts ("");*/
	return 1;
}


int dig_cnt (int a) {
	return (int)floor (log10 (a)) + 1;
}

void prnt (int l, int r) {
	if (l + 1 == r) {
		putchar (s[l]);
		return;
	}

	if (prev[l][r].second == 0){
		prnt (l, prev[l][r].first);
		prnt (prev[l][r].first, r);
		return;
	}

	printf ("%d(", prev[l][r].second);
	prnt (l, prev[l][r].first);
	putchar (')');
}

int main () {
	gets (s);
	N = strlen (s);

	int i, j, d, k;

	hash[0] = dup (0);
	for (i = 1; i <= N; ++i)
		hash[i] = hash[i-1] * BASE + dup (s[i-1] - 'A' + 1);
	POW_BASE[0] = dup (1);
	for (i = 1; i <= N; ++i)
		POW_BASE[i] = POW_BASE[i-1] * BASE;
/*
	for (i = 0; i <= N; ++i)
		printf ("%10u %10u\n", POW_BASE[i].x, POW_BASE[i].y);

	for (i = 0; i <= N; ++i)
		printf ("%10u %10u\n", hash[i].x, hash[i].y);

	for (i = 0; i <= N; ++i)
		for (j = i + 1; j <= N; ++j)
			printf ("%.*s -- %10u %10u\n", j - i, s + i, find_hash (i, j-i).x, find_hash (i, j-i).y);
*/		
//	return 0;
	for (i = 0; i < N; ++i)
		dp[i][i+1] = 1;//cannot fold more

	for (d = 2; d <= N; ++d)
		for (i = 0; (j = i + d) <= N; ++i) {
			dp[i][j] = INF;
			for (k = i + 1; k < j; ++k) {
				if (dp[i][j] > dp[i][k] + dp[k][j]) {
					dp[i][j] = dp[i][k] + dp[k][j];
					prev[i][j] = PI (k, 0);
				}
				if ((j - i) % (k - i) == 0
				 && pat_match (i, k, j)
				 && dp[i][j] > dp[i][k] + 2 + dig_cnt ((j - i) / (k - i))) {
					dp[i][j] = dp[i][k] + 2 + dig_cnt ((j - i) / (k - i));
					prev[i][j] = PI (k, (j - i) / (k - i));
//					printf ("collapse %d %d --> %d (%d) -- %.*s\n", i, j, k, (j-i) / (k-i), j-i, s + i);
				}
			}
		}

	printf ("%d\n", dp[0][N]);
	prnt (0, N);

	return 0;
}
