/*
TASK: http://acmicpc-live-archive.uva.es/nuevoportal/data/problem.php?p=3565
*/

#include <cstdio>
#include <cassert>
#include <map>

const int MAXP = 1 << 6;

struct tri {
	int pos;
	int n, l;
	tri () {}
	tri (int _pos, int _n, int _l) : pos (_pos), n (_n), l (_l) {}
	bool operator < (const tri &a) const {
		return 	pos != a.pos ?
					pos < a.pos :
					n != a.n ?
						n < a.n:
						l < a.l;
	}
};

typedef std::map <tri, char> map_t;
typedef map_t :: iterator map_it_t;

int N, L;
int P;
char line[MAXP];

map_t dp;

int fnd (int pos) {
//	printf ("fnd %d --> ", pos);
	for (; pos <= P && line[pos] == '0'; ++pos);
//	printf ("%d\n", pos);
	return pos;
}

int to_dig (int pos, int k) {
	int res = 0, i;
	for (i = pos; i < pos + k; ++i) {
		res <<= 1;
		res |= (line[i] == '1');
	}
	return res;
}

int dpf (const tri &c) {
	map_it_t it;
	int npos, ladd;
	int k;
//	printf ("dpf %d %d %d -- \n", c.pos, c.n, c.l);
	assert (c.pos <= P);
	if (c.n > N || c.l > L) {
//		printf ("<< too bad 0\n");
		return 0;
	}
	if ((it = dp.find (c)) != dp.end ()) return (*it).second;
	if (c.pos == P)
		if (c.n == N && c.l == L) {
//			printf ("<<%d %d %d ret 1\n", c.pos, c.n, c.l);
			return dp[c] = 1;
		} else {
//			printf ("<< ret 0\n");
			return dp[c] = 0;
		}
	assert (c.pos < P);
	assert (line[c.pos] == '1');
	//k == 1 --> take 1 it should be 1
	if (line[c.pos + 1] != '1') {
		npos = fnd (c.pos + 1);
//		printf ("case 1 --> %d %d %d\n", npos, npos - c.pos + c.n, c.l + 1);
		dp[c] += dpf (tri (npos, npos - c.pos + c.n, c.l + 1));
	}
	//k == 2 --> 11 or 111 original
	if (c.pos + 2 <= P && line[c.pos + 2] != '1' && line[c.pos + 1] == '1') {
		npos = fnd (c.pos + 2);
//		printf ("case 2.0 --> %d %d %d\n", npos, npos - c.pos + c.n, c.l + 2);
//		printf ("case 2.1 --> %d %d %d\n", npos, npos - c.pos + c.n, c.l + 2);
		dp[c] += dpf (tri (npos, npos - c.pos + c.n, c.l + 2));
		dp[c] += dpf (tri (npos, npos - c.pos + c.n + 1, c.l + 3));
	}
	//k >= 3
	for (k = 3; k + c.pos <= P; ++k) {
		if (line[c.pos + k] == '1') continue;
		ladd = to_dig (c.pos, k);
		npos = fnd (c.pos + k);
//		printf ("case 3 (%d) %d %d %d\n", k, npos, npos - c.pos - k + c.n + ladd, c.l + ladd);
		dp[c] += dpf (tri (npos, npos - c.pos - k + c.n + ladd, c.l + ladd));
	}
/*	if (dp[c])
		printf ("<<< %d %d %d -- %d\n", c.pos, c.n, c.l, dp[c]);*/
	return dp[c];
}

int main () {
	int tc = 0;
	int i;
	while (scanf ("%d %d\n", &N, &L), N != 0) {
		printf ("Case #%d: ", ++tc);
		gets (line);
		P = strlen (line);
/*		printf ("P === %d\n", P);
		for (i = 0; i < P; ++i)
			printf ("(%c)", line[i]);
		puts ("");
		printf ("%d %d\n", N, L);
*/
		for (i = 0; i < P && line[i] == '0'; ++i);
		if (i == P) {printf ("YES\n"); continue;}//only zeros
		int res = dpf (tri (i, i, 0));
		dp = map_t ();
		printf ("%s\n", res == 0 ? "NO" : res == 1 ? "YES" : "NOT UNIQUE");
	}

	return 0;	
}
