/*
TASK: http://acmicpc-live-archive.uva.es/nuevoportal/data/problem.php?p=3570
*/

#include <cstdio>
#include <queue>

const int MAXN = 1 << 7;
typedef std::pair <int, int> PII;
const int INF = 0x3f3f3f3f;

int N, M;
int ma3x[MAXN][MAXN];

int D[MAXN * MAXN];

int code (int a, int b) {
	return (a << 7) | b;
}

void decode (int c, int &a, int &b) {
	a = c >> 7;
	b = c & 0x7f;
}

std::priority_queue <PII> q;
void trp (PII go) {
	if (D[go.second] > -go.first) {
		D[go.second] = -go.first;
//		printf ("push (%x) %d\n", go.second, -go.first);
		q.push (go);
	}
}

int dijkstra () {
	q = std::priority_queue <PII> ();
	int i;
	int a, b;
	PII c;
	memset (D, 0x7f, sizeof (D));

	D[0] = 1;
	q.push (PII (-1, 0));// (0,0)
	while (!q.empty ()) {
		c = q.top (); q.pop ();
		c.first *= -1;//make it positive
	
		decode (c.second, a, b);
//		printf ("popped %d %d  %d\n", a, b, c.first);
		if (a == b && a == 1) return c.first;
		//a,b --> c,d
		////a,b --> a,__c__
		for (i = 0; i < N; ++i) {
			if (ma3x[i][b] != 1) continue;
			trp (PII (- c.first - 1, code (a, i)));
		}
		////a,b --> __c__,b
		for (i = 0; i < N; ++i) {
			if (ma3x[a][i] != 1) continue;
			trp (PII (- c.first - 1, code (i, b)));
		}
		////a,b --> __c__,__c__
		for (i = 0; i < N; ++i) {
			if (ma3x[a][i] != 1
			 || ma3x[i][b] != 1) continue;
			trp (PII (- c.first - 1, code (i, i)));
		}
		////a,b --> b,a
		if (ma3x[a][b] != 0x3f3f3f3f) {
//			printf ("(spec %d %d)\n", - c.first - ma3x[a][b] + 1, code (b, a));
			trp (PII (- c.first - ma3x[a][b] + 1, code (b, a)));
		}
	}

	return -1;
}

int tc;
int main () {
	int i, j, k;
	int a, b;
	while (scanf ("%d %d", &N, &M), N != 0) {		
		printf ("Network %d\n", ++tc);
		memset (ma3x, 0x3f, sizeof (ma3x));
		for (i = 0; i < M; ++i) {
			scanf ("%d %d", &a, &b);
			--a; --b;
			ma3x[a][b] = 1;
		}
		for (k = 0; k < N; ++k)
			for (i = 0; i < N; ++i)
				for (j = 0; j < N; ++j)
					if (ma3x[i][j] > ma3x[i][k] + ma3x[k][j])
						ma3x[i][j] = ma3x[i][k] + ma3x[k][j];
/*
		for (i = 0; i < N; ++i) {
			for (j = 0; j < N; ++j)
				printf ("%3d ", ma3x[i][j] == INF ? 999 : ma3x[i][j]);
			printf ("\n");
		}
*/
		int ans = dijkstra ();
		if (ans == -1)
			printf ("Impossible\n\n");
		else
			printf ("Minimum number of nodes = %d\n\n", ans);			
	}

	return 0;
}
