/*
FROM:
TASK: Flat Broken Line
KEYW: lowest bit index tree, minimum with cross maximum
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 19;
const int MAXCC = 1 << 20;
const int CC = MAXCC - 1;

struct pnt {
	int x, y;
	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}

	bool operator < (const pnt &a) const {return x != a.x ? x < a.x : y > a.y;}
};

int N;
pnt vec[MAXN];

int idt[MAXCC];
int dp[MAXN];

void add (int pos, int val) {
	for (; pos <= CC; pos += pos & -pos)
		idt[pos] >?= val;
}

int srch (int pos) {
	static int ret;
	for (ret = 0; pos; pos &= pos - 1)
		ret >?= idt[pos];
	return ret;
}

int main () {
	scanf ("%d", &N);

	int i;
	int x, y;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &x, &y);
		vec[i] = pnt (x - y + 300001, -x - y + 600001);
//		printf ("%d %d --> %d %d\n", x, y, vec[i].x, vec[i].y);
	}

	std::sort (vec, vec + N);

	int ans = 0;
	for (i = 0; i < N; ++i) {
//		printf ("%d %d -- %d\n", vec[i].x, vec[i].y, srch (vec[i].y - 1));
		add (vec[i].y, dp[i] = srch (vec[i].y - 1) + 1);
		ans >?= dp[i];
	}

	printf ("%d\n", ans);
	
	return 0;
}
