/*
TASK: perm
KEYW: encoding, decoding
NOTE: sort all permutation using the adjasent difference between them as key
*/

#include <cstdio>
#include <cstring>

const int MAXN = 32;
const int BASE = MAXN - 2;

int N;
long long dp[MAXN][MAXN];

long long dpf (int in, int out) {
	if (dp[in][out] != -1) return dp[in][out];
	dp[in][out] = 0;
	if (in) dp[in][out] += dpf (in-1, out) * in;
	for (int i = 0; i < out; ++i) dp[in][out] += dpf (in + i, out - 1 - i) * 2;
	return dp[in][out];
}

long long code;
bool used[MAXN * 2];
int vec[MAXN * 2];

long long crnt;

int main () {
	int t;
	scanf ("%d %d", &t, &N);
	memset (dp, -1, sizeof (dp));
	dp[0][0] = 1;

	int lb = BASE, ub = lb + 1;
	int i, j;
	int nin = -1, nout = -1;
	if (t == 1) {
		scanf ("%I64d", &crnt);
		lb = BASE, ub = lb + 1;
		used[BASE] = 1;
		vec[0] = BASE;
		for (i = 1; i < N; ++i) {
			for (j = ub - N; j < lb + N; ++j) {
				if (used[j]) continue;
				nout = N + (lb <? j) - (ub >? (j + 1));
				nin = N - nout - i - 1;
				if ((crnt -= dpf (nin, nout)) < 0) break;
			}
			crnt += dpf (nin, nout);
			lb = lb <? j;
			ub = ub >? (j + 1);
			used[j] = 1;
			vec[i] = j;
		}
		for (i = 0; i < N; ++i) printf (" %d", vec[i] - lb + 1); puts ("");
	} else {
		int first, crnt;
		long long res = 0;
		scanf ("%d", &first);
		used[BASE] = 1;
		for (i = 1; i < N; ++i) {
			scanf ("%d", &crnt);
			int id = crnt - first + BASE;
			for (j = ub - N; j < lb + N; ++j) {
				if (j == id) break;
				if (used[j]) continue;
				nout = N + (lb <? j) - (ub >? (j + 1));
				nin = N - nout - i - 1;
				res += dpf (nin, nout);
			}
			lb <?= j;
			ub >?= j + 1;
			used[j] = 1;
		}
		printf ("%I64d\n", res);
	}

	return 0;
}
