/*
TASK: perm
KEYW: encoding, decoding
NOTE: sort all permutation using the adjasent difference between them as key
*/

#include <cstdio>
#include <cstring>

const int MAXN = 32;
const int BASE = MAXN - 2;

int N;
long long dp[MAXN][MAXN];

long long dpf (int in, int out) {
	if (dp[in][out] != -1) return dp[in][out];
	dp[in][out] = 0;
	if (in) dp[in][out] += dpf (in-1, out) * in;
	for (int i = 0; i < out; ++i) dp[in][out] += dpf (in + i, out - 1 - i) * 2;
//	printf ("\n%d %d --> %I64d\n", in, out, dp[in][out]);
	return dp[in][out];
}

long long code;
bool used[MAXN * 2];
int vec[MAXN * 2];

#define WORK \
	vec[i] = j;\
	code += dpf (xin, xout);\
	used[j] = 1;\
	goto nexti

#define WORK2(XOUT) \
	if (j == id) goto nexti2;\
	xout = XOUT;\
	xin = N - xout - i - 1;\
	res += dpf (xin, xout)

int main () {
	int t;
	scanf ("%d\n%d", &t, &N);

	int lb = BASE, ub = lb + 1;
//	int in, out;
	int xin = -1, xout = -1;
	int i, j;
	memset (dp, -1, sizeof (dp));
	dp[0][0] = 1;//one way - it is already finished
	if (t == 1) {//decode
		scanf ("%I64d", &code);
		used[BASE] = 1;
		vec[0] = BASE;
		
		for (i = 1; i < N; ++i) {
//			printf ("i == %d, %d %d (%I64d)\n", i, lb, ub, code);
			for (j = ub - N; j < lb; ++j) {
				xout = j - ub + N;
				xin = N - xout - i - 1;
//				printf ("!%d (%d %d) <%d %d>-- %d %d --> %I64d  %I64d\n", i, j, j - BASE, lb, ub, xin, xout, dpf (xin, xout), code);
				if ((code -= dpf (xin, xout)) < 0) {
					lb = j;
					WORK;
				}
			}
			for (j = lb; j < ub; ++j) {
				if (used[j]) continue;
				xout = N - (ub - lb);
				xin = N - xout - i - 1;
//				printf ("!!%d (%d %d) <%d %d>-- %d %d --> %I64d  %I64d\n", i, j, j - BASE, lb, ub, xin, xout, dpf (xin, xout), code);
				if ((code -= dpf (xin, xout)) < 0) {
					WORK;
				}
			}

			for (j = ub; j < lb + N; ++j) {
				xout = lb + N - j - 1;
				xin = N - xout - i - 1;
//				printf ("!!!%d (%d %d) <%d %d>-- %d %d --> %I64d  %I64d\n", i, j, j - BASE, lb, ub, xin, xout, dpf (xin, xout), code);
				if ((code -= dpf (xin, xout)) < 0) {
					ub = j + 1;
					WORK;
				}
			}

			nexti:;
		}
		int mine = 100000;
		for (i = 0; i < N; ++i) mine <?= vec[i];
		for (i = 0; i < N; ++i) printf (" %d", vec[i] - mine + 1);
	} else {//encode
		int first, crnt;
		scanf ("%d", &first);
		lb = BASE, ub = lb + 1;
		used[BASE] = 1;
		long long res = 0;
		for (i = 1; i < N; ++i) {
			scanf ("%d", &crnt);
			int id = crnt - first + BASE;
//			printf ("i, id == %d %d\n", i, id);
			for (j = ub - N; j < lb; ++j) {
				WORK2 (j - ub + N);
			}
			for (j = lb; j < ub; ++j) {
				if (used[j]) continue;
				WORK2 (N - (ub - lb));
			}
			for (j = ub; j < lb + N; ++j) {
				WORK2 (lb + N - j - 1);
			}
			nexti2:;
			used[j] = 1;
			lb <?= id;
			ub >?= id + 1;
		}
		printf ("%I64d\n", res);
	}

	return 0;
}
