/*
FROM: British Olympiad
TASK: Zig-zag numbers
KEYW: dynamical programming
*/

#include <cstdio>
#include <cstring>
#include <algorithm>

const int MAXN = 16;

int dp[MAXN][MAXN];

int dpf (int in, int out) {
	if (dp[in][out] != -1) return dp[in][out];
	dp[in][out] = 0;
	if (in == 0 && out == 0) return 1;
	if (out == 0) return 0;//no way

	for (int i = 1; i <= out; ++i)
		dp[in][out] += dpf (out - i, in - 1 + i);

	return dp[in][out];
}

int N, C;
int used[MAXN];

int main () {
	scanf ("%d %d", &N, &C);
	memset (dp, -1, sizeof (dp));

	int in = 0, out = N;
	int i, j;
	int cp = N-1;
	int dif = -1;
	for (i = 0; i < N - 1; ++i) {
		for (j = i & 1 ? 1 : out; j && j <= out && ((C -= dpf (out - j, in - 1 + j)) >= 0); j += dif);

		in += j - 1;
		out -= j;
		std::swap (in, out);
		C += dpf (in, out);

		while (used[cp] || --j) cp += dif;
		printf ("%c", cp < 9 ? cp + '1' : cp - 9 + 'a');
		used[cp] = 1;
		dif = -dif;
	}
	while (used[cp]) cp += dif;
	printf ("%c", cp < 9 ? cp + '1' : cp - 9 + 'a');

	return 0;
}
