#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>

const int MAXN = 1 << 11;

int N;
std::vector <int> fgr;
std::vector <std::vector <int> > rgr;//forward, reverse

typedef std::vector <std::vector <std::string> > final_graph_t;
typedef std::vector <int> raw_cycle_t;
typedef std::vector <std::string> final_cycle_t;

int _uc;
int used[MAXN];
int prev[MAXN];

raw_cycle_t find_cycle (int beg) {
	raw_cycle_t result;
	int crnt = beg;
	for (;;) {
		used[crnt] = _uc;
		if (used[fgr[crnt]]) break;
		prev[fgr[crnt]] = crnt;
		crnt = fgr[crnt];
	}
	if (used[fgr[crnt]] != _uc) return result;//empty vector -- no cycle here
	int targ = fgr[crnt];
	while (crnt != targ) {
		result.push_back (crnt);
		crnt = prev[crnt];
	}
	result.push_back (targ);
	std::reverse (result.begin (), result.end ());
	return result;
}

std::string code_tree (int root, int no_go) {
	std::vector <std::string> tmp;
	size_t j;
	for (j = 0; j < rgr[root].size (); ++j)
		if (rgr[root][j] != no_go) {
//			printf ("%d %d --> %d %d\n", root, no_go, rgr[root][j], -1);
//			system ("PAUSE");
			tmp.push_back (code_tree (rgr[root][j], -1));
		}

	std::sort (tmp.begin (), tmp.end ());
	std::string result ("(");
	for (j = 0; j < tmp.size (); ++j)
		result += tmp[j];
	result += ')';
	return result;
}

void find_min_rotation (final_cycle_t &rc) {
	int bid = 0;
	size_t i, j;
	for (i = 1; i < rc.size (); ++i) {
		for (j = 0; j < rc.size () && rc[(bid+j) % rc.size ()] == rc [(i+j) % rc.size ()]; ++j);
		if (rc[(bid+j) % rc.size ()] > rc [(i+j) % rc.size ()]) {
			bid = i;
		}
	}
	std::rotate (rc.begin (), rc.begin () + bid, rc.end ());
}

final_graph_t do_graph () {
	final_graph_t result;
	fgr.resize (N);
	rgr.clear ();
	rgr.resize (N);
	int i;
	size_t j;
	int a;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &a);
		--a;
		fgr[i] = a;
		rgr[a].push_back (i);
	}
//	for (i = 0; i < N; ++i) printf ("%d - %d\n", i, fgr[i]);
	memset (used, 0, sizeof (used));
	for (i = 0; i < N; ++i) {
		if (used[i]) continue;
		++_uc;
		raw_cycle_t cc = find_cycle (i);
		if (cc.empty ()) continue;
//		for (j = 0; j < cc.size (); ++j) printf (" %d", cc[j]); puts ("  raw cicle");

		final_cycle_t rc;
		for (j = 0; j < cc.size (); ++j)
			rc.push_back (code_tree (cc[j], cc[(j+cc.size ()-1) % cc.size ()]));
		find_min_rotation (rc);
/*		printf ("-- bomb --\n");
		for (j = 0; j < rc.size (); ++j)
			printf ("%s\n", rc[j].c_str ());
		printf ("--\n");*/
		result.push_back (rc);
	}
	std::sort (result.begin (), result.end ());
	return result;
}

int main () {
	int tc;
	for (scanf ("%d", &tc); tc; --tc) {
		scanf ("%d", &N);
		fgr.resize (N);
		rgr.resize (N);

//		printf ("___________ now process graph # 1\n");
		final_graph_t first = do_graph ();
/*		printf ("_thisis FINAL:\n");
		for (size_t i = 0; i < first.size (); ++i) {
			for (size_t j = 0; j < first[i].size (); ++j)
				printf ("%s\n", first[i][j].c_str ());
			puts ("");
		}
		printf ("___________ now process graph # 2\n");*/
		final_graph_t second = do_graph ();
/*		printf ("_thisis FINAL:\n");
		for (size_t i = 0; i < first.size (); ++i) {
			for (size_t j = 0; j < first[i].size (); ++j)
				printf ("%s\n", first[i][j].c_str ());
			puts ("");
		}*/
		printf ("%c\n", first == second ? 'T' : 'N');
	}

	return 0;
}
