#include <cstdio>
#include <algorithm>
#include <map>

struct state {
	int id;
	int left, right;
	int miny, maxy;
	state () {}
	state (int _id, int _left, int _right, int _miny, int _maxy)
	 : id (_id), left (_left), right (_right), miny (_miny), maxy (_maxy) {}
	int idx () const {return 32 * (32 * (32 * (32 * id + left) + right) + miny) + maxy;}
	bool operator < (const state &a) const {return idx () < a.idx ();}
	bool operator != (const state &a) const {return idx () != a.idx ();}
};

struct pos {
	int x, y;
	pos () {}
	pos (int _x, int _y) : x (_x), y (_y) {}
	bool operator < (const pos &a) const {return x != a.x ? x < a.x : y < a.y;}
};

char dirs[][6] = {
	"left",
	"right",
	"up",
	"down"
};

std::map <state, int> dp;
std::map <state, std::pair <state, int> > prev;
std::map <pos, int> points;

int N, A;
pos coor[64];
int minx[32], miny[32], maxx[32], maxy[32];

void upd (const state &crnt, const state &go, int len, int dir) {
	static std::map <state, int> :: iterator it;

//	printf ("\tupd %d  %d %d  %d %d -%s- %d\n", go.id, go.left, go.right, go.miny, go.maxy, dirs[dir], len);
	
	if ((it = dp.find (go)) == dp.end ()
	 || it->second > len) {
		dp[go] = len;
		prev[go] = std::make_pair (crnt, dir);
	}
}

void dpf (const state &c) {
	static std::map <state, int> :: iterator it;
	static int cdp;
	cdp	= dp[c];

//	printf ("%d  %d %d  %d %d --> %d\n", c.id, c.left, c.right, c.miny, c.maxy, cdp);
	
	//up
	if (minx[coor[c.id].y] == coor[c.id].x
	 && coor[c.id].y > c.left
	 && coor[c.id].y < c.right)
		upd (c, state (c.id + 1, c.left, c.right, c.miny, c.maxy), cdp + coor[c.id].x, 0);
	
	//down
	if (maxx[coor[c.id].y] == coor[c.id].x)
		upd (c, state (c.id + 1, c.left, c.right, c.miny <? coor[c.id].y, c.maxy >? coor[c.id].y), cdp + A - coor[c.id].x, 1);

	//right
	if (maxy[coor[c.id].x] == coor[c.id].y && coor[c.id].y > c.maxy)
		upd (c, state (c.id + 1, c.left, c.right <? coor[c.id].y, c.miny, c.maxy), cdp + A - coor[c.id].y, 2);
	
	//left
	if (miny[coor[c.id].x] == coor[c.id].y && coor[c.id].y < c.miny)
		upd (c, state (c.id + 1, c.left >? coor[c.id].y, c.right, c.miny, c.maxy), cdp + coor[c.id].y, 3);
}

int main () {
	scanf ("%d", &A);
	scanf ("%d", &N);

	int i;
	for (i = 0; i < A; ++i) minx[i] = miny[i] = A;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &coor[i].x, &coor[i].y);
		points[coor[i]] = i;
		miny[coor[i].x] <?= coor[i].y; maxy[coor[i].x] >?= coor[i].y;
		minx[coor[i].y] <?= coor[i].x; maxx[coor[i].y] >?= coor[i].x;
	}

	std::sort (coor, coor + N);

	state beg (0, 0, A, A, 0);
	dp[beg] = 0;
	while (!dp.empty () && dp.begin ()->first.id < N) {
//		printf ("----------%d %d\n", coor[dp.begin ()->first.id].x, coor[dp.begin ()->first.id].y);
		dpf (dp.begin ()->first);
		dp.erase (dp.begin ());
	}

	state last;
	int res = 1000000;
	for (std::map <state, int> :: iterator it = dp.begin (); it != dp.end (); ++it)
		if (res > it->second) {
			res = it->second;
			last = it->first;
		}

	static int ans[64];	
	while (last != beg) {
//		ans[ap++] = prev[last].second;
		ans[points[coor[prev[last].first.id]]] = prev[last].second;
		last = prev[last].first;
	}

	printf ("%d\n", res);
	for (i = 0; i < N; ++i)
		printf ("%s\n", dirs[ans[i]]);

	return 0;
}
