#include <cstdio>
#include <cstring>
#include <cassert>

const int MAXN = 1 << 11;
const int MAXM = 1 << 13;
const int BASE = 1 << 10;

const short dx[] = {-1, 0, 1, 0};
const short dy[] = {0, 1, 0, -1};

const char dirs[][6] = {
	"up",
	"right",
	"down",
	"left"
};

struct pos {
	short x, y;
	pos () {}
	pos (short _x, short _y) : x (_x), y (_y) {}
	bool operator != (const pos &a) {return x != a.x || y != a.y;}
};

char brd[MAXN][MAXN];
pos crnt;
char moves[MAXM];
int mvp;
char prev[MAXN][MAXN];
short used[MAXN][MAXN];

bool find_path () {
	static int _uc = 0;
	static pos go;
	static pos q[MAXN * MAXN];
	static int i, k;
	int p3 = 0;

	q[p3++] = crnt;
	used[crnt.x][crnt.y] = ++_uc;
	for (i = 0; i < p3; ++i) {
//		printf ("pop %d %d (%d)\n", q[i].x, q[i].y, i);
		if (brd[q[i].x][q[i].y] == '\0') {
			mvp = 0;
			for (go = q[i]; go != crnt;
				go = pos (go.x - dx[(int)prev[go.x][go.y]]
						, go.y - dy[(int)prev[go.x][go.y]]))
				moves[mvp++] = prev[go.x][go.y];
			return 1;//found a path
		}

		for (k = 0; k < 4; ++k) {
			go = pos (q[i].x + dx[k], q[i].y + dy[k]);
			if (brd[go.x][go.y] != '#' && used[go.x][go.y] != _uc) {
//				printf ("\tpush %d %d\n", go.x, go.y);
				prev[go.x][go.y] = k;
				used[go.x][go.y] = _uc;
				q[p3++] = go;
			}
		}
	}

	return 0;
}

int main () {
	brd[BASE][BASE] = '.';
	crnt = pos (BASE, BASE);
	int res = 1;
	static char ans[16];
	while (find_path ()) {
		for (int i = mvp - 1; i >= 0; --i) {
			printf ("%s\n", dirs[(int)moves[i]]);
			fflush (stdout);
			scanf ("%s", ans);
			if (i) assert (strcmp (ans, "ok") == 0);
			crnt = pos (crnt.x + dx[(int)moves[i]], crnt.y + dy[(int)moves[i]]);
		}
		if (ans[0] == 'f') {//fail
			brd[crnt.x][crnt.y] = '#';
			crnt = pos (crnt.x - dx[(int)moves[0]], crnt.y - dy[(int)moves[0]]);
		} else {//ok
			brd[crnt.x][crnt.y] = '.';
			++res;
		}
	}

	printf ("%d\n", res);
	fflush (stdout);
	
	return 0;
}
