/*
FROM: NOI 1998 round 4
PROB: p1
KEYW: bfs
*/

#include <cstdio>
#include <queue>
#include <utility>

const int MAXN = 1 << 8;
const int MAXLEN = 1 << 7;//just in case

const int diffx[] = {0, 1, 0, -1};
const int diffy[] = {-1, 0, 1, 0};

int N, M;
int map[MAXN][MAXN];

int bfs (int x, int y) {
	static int ZC = 1;
	++ZC;
	int res = 0;

	std::queue <std::pair <int, int> > q;
	q.push (std::make_pair (x, y));
	map[x][y] = ZC;
	std::pair <int, int> crnt;
	int ni, nj;
	while (!q.empty ()) {
		crnt = q.front (); q.pop ();
		++res;
		for (int k = 0; k < 4; ++k) {
			ni = crnt.first + diffx[k];
			nj = crnt.second + diffy[k];

			if (0 <= ni && ni < N && 0 <= nj && nj < N && !map[ni][nj]) {
				q.push (std::make_pair (ni, nj));
				map[ni][nj] = ZC;
			}
		}
	}

	return res;
}

bool is_asterix (char *s) {
	for (; *s; ++s) if (*s == '*') return 1;
	return 0;
}

int main () {
	scanf ("%d %d\n", &N, &M);

	char line[MAXLEN];
	int i, j;
	int ii, jj;
	int di, dj;
	for (i = 0; i < M; ++i) {
//		fgets (line, MAXLEN, stdin);
		gets (line);
		if (is_asterix (line)) {
			if (line[0] == '*') {//horizontal
				sscanf (line + 2, "%d", &jj);
				ii = 0;
				dj = 0; di = 1;
			} else {//vertical
				sscanf (line, "%d", &ii);
				jj = 0;
				di = 0; dj = 1;
			}
		} else {
			sscanf (line, "%d %d", &ii, &jj);
			if (ii == jj && ii != 0) {//second diagonal
				di = 1; dj = -1;
				jj = N - 1;
				ii = ii - jj;
			} else {//first diagonal
				di = 1;
				dj = 1;
				ii = 0;
			}
		}
		for (; ii < N && jj < N; ii += di, jj += dj)
			map[ii][jj] = 1;
	}

	for (i = 0; i < N; ++i) {
		if (!map[i][0]) bfs (i, 0);
		if (!map[i][N-1]) bfs (i, N - 1);
		if (!map[0][i]) bfs (0, i);
		if (!map[N-1][i]) bfs (N - 1, i);
	}
	int best = 0;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			if (!map[i][j])
				best >?= bfs (i, j);

	printf ("%d\n", best);

	return 0;
}
