/*
FROM: NOI 1998 round 4
PROB: p2
KEYW: reversed polish signature(code)
*/

#include <cstdio>
#include <cctype>

const int MAXSET = 1 << 5;
const int MAXLEN = 1 << 8;
const int MAXSETLEN = 1 << 9;

struct set {
	bool m[MAXSETLEN];
	set () {for (int i = 0; i < MAXSETLEN; ++i) m[i] = 0;}
	set& operator = (const set &a) {for (int i = 0; i < MAXSETLEN; ++i) m[i] = a.m[i]; return *this;}
	set operator + (const set &a) {for (int i = 0; i < MAXSETLEN; ++i) m[i] = m[i] || a.m[i]; return *this;}
	set operator * (const set &a) {for (int i = 0; i < MAXSETLEN; ++i) m[i] = m[i] && a.m[i]; return *this;}
	set operator - () {for (int i = 0; i < MAXSETLEN; ++i) m[i] = !m[i]; return *this;}
	int cnt () {int res = 0; for (int i = 0; i < MAXSETLEN; ++i) res += m[i]; return res;}
	void prnt () {for (int i = 0; i < MAXSETLEN; ++i) if (m[i]) printf ("%d ", i + 1); printf ("\n");}
};

set db[MAXSET];

char line[MAXLEN];

set let () {
	set ret;
	int tmp = 0;
	for (int i = 7; line[i]; ++i) {
		if (isdigit (line[i])) {
			tmp *= 10;
			tmp += line[i] - '0';
		} else {
			ret.m[--tmp] = 1;
			tmp = 0;
		}
	}
//	ret.prnt ();

	return ret;
}

const int LB = 26, PLUS = 27, MINUS = 28, MUL = 29;

int find () {
	static int st1[MAXLEN], st2[MAXLEN];
	static set st3[MAXLEN];

	int st1p = 0, st2p = 0, st3p = 0;

	for (int i = 5; line[i]; ++i) {
		if (isupper (line[i])) {
			st1[st1p++] = line[i] - 'A';
		} else {
			switch (line[i]) {
				case '(':	st2[st2p++] = LB; break;
				case '+':	st2[st2p++] = PLUS; break;
				case '-':	st2[st2p++] = MINUS; break;
				case '*':	st2[st2p++] = MUL; break;
				case ')': for (--st2p; st2[st2p] != LB; --st2p) {st1[st1p++] = st2[st2p]; /*printf ("cpy %d\n", st2[st2p]);*/}
			}
		}
	}

//	printf ("-(%d)\n", st2p);
	for (--st2p; st2p >= 0; --st2p) {st1[st1p++] = st2[st2p]; /*printf ("cpy %d\n", st2[st2p]);*/}
//	printf ("-\n");
/*
	for (int i = 0; i < st1p; ++i)
		printf ("%c", st1[i] < 26 ? st1[i] + 'A' : st1[i] == PLUS ? '+' : st1[i] == MINUS ? '-' : st1[i] == MUL ? '*' : '?');
	printf ("\n");
*/
	set x1, x2;
	for (int i = 0; i < st1p; ++i) {
		if (st1[i] < 26)
			st3[st3p++] = db[st1[i]];
		else {
			switch (st1[i]) {
				case PLUS: x1 = st3[--st3p]; x2 = st3[--st3p]; st3[st3p++] = x1 + x2; break;
				case MUL: x1 = st3[--st3p]; x2 = st3[--st3p]; st3[st3p++] = x1 * x2; break;
				case MINUS: x1 = st3[--st3p]; st3[st3p++] = -x1; break;
			}
		}
	}
//	st3[0].prnt ();

	return st3[0].cnt ();
}

int main () {
	while (gets (line), line[0] != 'S') {
		if (line[0] == 'L') {//let
			db[line[4] - 'A'] = let ();
		} else {//find
			printf ("%d\n", find ());
		}
	}

	return 0;
}
