/*
FROM: NOI 1998 round 4
PROB: p3
KEYW: matching, dinitz
*/

#include <cstdio>
#include <cctype>
#include <cassert>

const int MAXrN = 1 << 6;//44
const int MAXrM = 1 << 10;//966
const int MAXLEN = 1 << 6;//EXACTLY!!

struct el {
	bool c;
	int to;
	int next;
};

inline int op (int a) {
	return a + (a & 1 ? -1 : 1);
}

int source, sink;
int N, M;
int rN, rM;

el buf[MAXrM];
int vec[MAXrN];

void input () {
	scanf ("%d %d\n", &N, &M);
	source = N + M;
	sink = source + 1;
	rN = sink + 1;

	char line[MAXLEN];
	int id;
	int bp = 0;
	for (int i = 0; i < rN; ++i) vec[i] = -1;
	for (int i = 0; i < M; ++i) {
		gets (line);

		id = 0;
		int tmp = 0;
		do {
			if (isdigit (line[id])) {
				tmp *= 10;
				tmp += line[id] - '0';
			} else {
//				printf ("scanned %d\n", tmp);
				--tmp;
				tmp += M;
				buf[bp] = (el) {1, tmp, vec[i]};
				vec[i] = bp++;
				buf[bp] = (el) {0, i, vec[tmp]};
				vec[tmp] = bp++;

				tmp = 0;
			}
		} while (line[id++]);
//		printf ("----\n");
	}

	int i;//, j;
	for (i = 0; i < M; ++i) {
		buf[bp] = (el) {1, i, vec[source]};
		vec[source] = bp++;
		buf[bp] = (el) {0, source, vec[i]};
		vec[i] = bp++;
	}
	for (i = M; i < source; ++i) {
		buf[bp] = (el) {0, i, vec[sink]};
		vec[sink] = bp++;
		buf[bp] = (el) {1, sink, vec[i]};
		vec[i] = bp++;
	}
}

int vis[MAXrN], vp;
bool used[MAXrN];
int D[MAXrN];

bool bfs () {
	for (int i = 0; i < rN; ++i) {
		used[i] = 0;
		D[i] = -1;
	}
	used[source] = 1;

	int queue[MAXrN];
	int p1 =0, p2 =1, p3 =0, lvl =0;
	queue[p3++] = sink;
	D[sink] = lvl++;

	while (p1 != p2) {
		for (int i = p1; i < p2; ++i) {
			for (int j = vec[queue[i]]; j != -1; j = buf[j].next)
				if (D[buf[j].to] == -1 && buf[op (j)].c) {
					printf ("push %d %d\n", buf[j].to, lvl);
					D[buf[j].to] = lvl;
					queue[p3++] = buf[j].to;
				}
		}

		p1 = p2;
		p2 = p3;
		++lvl;
	}

	return D[source] != -1;
}

bool dfs (int a) {
	if (a == sink) {
		used[sink] = 0;
		return 1;
	}

	for (int i = vec[a]; i != -1; i = buf[i].next)
		if (D[a] == D[buf[i].to] + 1 && buf[i].c && !used[buf[i].to]) {
			used[buf[i].to] = 1;
			vis[vp++] = i;
			if (dfs (buf[i].to)) {
//				--vp;
				return 1;
			}
			--vp;
		}

	return 0;
}

void dinitz () {
	while (bfs ()) {
		for (int i = 0; i < rN; ++i) printf ("%d ", D[i]); printf ("---\n");
		while (vp = 0, dfs (source)) {
			for (int i = 0; i < vp; ++i) {
				printf ("%d (%d)\n", vis[i], buf[vis[i]].to);
				assert (buf[vis[i]].c);
				assert (!buf[op (vis[i])].c);

				buf[vis[i]].c = !buf[vis[i]].c;
				buf[op (vis[i])].c = !buf[op (vis[i])].c;
			}
			printf ("---\n");
			getchar ();
		}
		printf ("-!-!-!-\n");
		getchar ();
	}
}

int main () {
	input ();
	dinitz ();

	for (int i = 0; i < M; ++i)
		for (int k = vec[i]; k != -1; k = buf[k].next)
			if (!buf[k].c && buf[k].to >= M && buf[k].to < M + N) {
				printf ("%d\n", buf[k].to - M + 1);
				break;
			}

	return 0;
}
