/*
FROM: NOI 1998 round 4
PROB: p5
KEYW: dynamical programming, optimization, binary
*/

#include <cstdio>
//#include <algorithm>
#include <vector>

const int MAXM = 20;
const int MAXOPT = 1 << MAXM;

int c1[MAXOPT];
int sort[MAXOPT];
bool opt[MAXOPT];

std::vector <std::vector <int> > group;

int N, M;
int n;

bool cmp (int a, int b) {
	return c1[a] < c1[b];
}

inline void deal (int a) {
	static int i;
	static int cnt;
	static int sum;
	for (i = cnt = sum = 0; i < M; ++i)
		if (a & (1 << i))
			++cnt;
		else
			sum += i + 1;

//	printf ("%d -> %d %d\n", a, cnt, sum);
	if (n - sum < 0) opt[a] = 1;
	else group[cnt].push_back (a);
}

int main () {
	int i, j, k;
	scanf ("%d %d", &n, &M);
	group.resize (M + 1);
	N = 1 << M;

	for (i = 0; i < N; ++i)
		deal (i);

//	std::sort (sort, sort + N, cmp);

	for (i = 0; i <= M; ++i) {
//		printf ("i = %d--------\n", i);
		for (j = 0; j < (int)group[i].size (); ++j) {
			for (k = 0; k < M; ++k)
				if ((group[i][j] & (1 << k)) && !opt[group[i][j] ^ (1 << k)]) {
//					printf ("opt[%d] == 1 -> %d\n", group[i][j], k + 1);
					opt[group[i][j]] = 1;
					goto nxt;
				}
//			printf ("opt[%d] = 0\n", group[i][j]);
			opt[group[i][j]] = 0;
			nxt:;
		}
	}

	if (opt[N-1]) {//A wins
		printf ("A побеждава\n");
		for (i = 0; i < M; ++i)
			if (!opt[(N-1)^(1<<i)])
				printf ("%d печеливш\n", i + 1);
			else {
				printf ("%d ", i + 1);
				for (k = 0; k < M; ++k) {
					if (k == i) continue;
					if (!opt[(N-1)^((1<<i)|(1 << k))]) {
						printf ("%d\n", k + 1);
						break;
					}
				}
			}
	} else {//B wins
		printf ("B побеждава\n");
		for (i = 0; i < M; ++i) {
			printf ("%d ", i + 1);
			for (k = 0; k < M; ++k) {
				if (k == i) continue;
				if (!opt[(N-1)^((1 << i) | (1 << k))]) {
					printf ("%d\n", k + 1);
					break;
				}
			}
		}
	}

	return 0;
}
