/*
FROM: NOI 1999 round 4
PROB: bas
KEYW: full exhaustion, recursion
*/

#include <cstdio>
#include <cassert>
#include <vector>

const int MAXN = 1 << 6;//35

int N, M;

std::vector <std::vector <int> > vec;
int covered[MAXN];
int in_cnt;
int covcnt;

bool which [MAXN];

inline bool all_covered () {
	static int i;
	for (i = 0; i < N && covered[i]; ++i);
	return (i == N);
}

bool ok () {
	for (int i = 0, j; i < N; ++i) {
		if (!which[i]) continue;
		for (j = 0; j < (int)vec[i].size () && covered[vec[i][j]] > 2; ++j);
		assert (covered[vec[i][j]]);
		if (j == (int)vec[i].size ()) return 0;
	}
	return 1;
}

int best;

void rec (int a) {
	if (in_cnt == best) return;
	if (all_covered ()) {best = in_cnt; return;}
	if (a == N) return;

	for (int i = a; i < N; ++i) {
		which[i] = 1; ++in_cnt;
		for (int j = 0; j < (int)vec[i].size (); ++j) ++covered[vec[i][j]];
		if (ok ()) rec (i + 1);
		for (int j = 0; j < (int)vec[i].size (); ++j) --covered[vec[i][j]];
		which[i] = 0; --in_cnt;
	}
}

int main () {
	scanf ("%d %d", &N, &M);
	vec.resize (N);
	best = N;

	int i;
	int a, b;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		vec[a].push_back (b);
		vec[b].push_back (a);
	}

	for (i = 0; i < N; ++i) vec[i].push_back (i);

	rec (0);
	printf ("%d\n", best);

	return 0;
}
