/*
FROM: NOI 1999 round 4
PROB: gle
KEYW: geometry
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 10;

struct el {
	int x;
	int y;
	bool operator < (const el &a) const {return x * a.y < y * a.x;}
	bool operator <= (const el &a) const {return x * a.y <= y * a.x;}
	bool operator > (const el &a) const {return a < *this;}
	bool operator >= (const el &a) const {return a <= *this;}
	bool operator == (const el &a) const {return x == a.x && y == a.y;}
};

struct ost {
	el f, s;
	bool operator == (const ost &a) {return f == a.f && s == a.s;}
};

int N;
ost data[MAXN];

bool cmp (const ost &a, const ost &b) {
	return a.f.x + a.f.y < b.f.x + b.f.y;
}

ost st[MAXN];
int stp;

ost INACTIVE = (ost) {(el) {-1, -1}, (el) {-1, -1}};

int main () {
	scanf ("%d", &N);

	int i, j;
	int x1, x2, y1, y2;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d %d %d", &x1, &y1, &x2, &y2);
		if (x1 < x2)
			data[i] = (ost) {(el) {x1, y1}, (el) {x2, y2}};
		else
			data[i] = (ost) {(el) {x2, y2}, (el) {x1, y1}};
	}

	std::sort (data, data + N, cmp);

	st[stp++] = (ost) {(el) {0, 20001}, (el) {20001, 0}};//0 and infinity

	int _stp = stp;//to keep the newly added segmets of seing :))
	int cntr = 0;//keep the answer
	bool f;
	for (i = 0; i < N; ++i) {
//		printf ("i == %d -- %d %d %d %d\n", i, data[i].f.x, data[i].f.y, data[i].s.x, data[i].s.y);
		f = 0;
		for (j = 0; j < stp; ++j) {
			if (st[j] == INACTIVE) continue;
//			printf ("\tj == %d\n", j);
			if (data[i].f <= st[j].f) {
				if (data[i].s > st[j].f && data[i].s < st[j].s) {
//					printf ("\t0.0\n");
					st[j].f = data[i].s;
					f = 1;
				} else if (data[i].s >= st[j].s) {//erase the whole interval
//					printf ("\t0.1\n");
					f = 1;
					st[j] = INACTIVE;//erase it;
				}
			} else if (data[i].f < st[j].s) {
				if (data[i].s < st[j].s) {//one more
//					printf ("\t1.0\n");
					st[_stp++] = (ost) {data[i].s, st[j].s};
					st[j].s = data[i].f;
					f = 1;
				} else {
//					printf ("\t1.1\n");
					f = 1;
					st[j].s = data[i].f;
				}
			}
		}
		cntr += f;

		stp = _stp;//update stp
/*
		printf ("---\n");
		for (j = 0; j < stp; ++j)
			printf ("\t%d %d %d %d\n", st[j].f.x, st[j].f.y, st[j].s.x, st[j].s.y);
*/
	}

	printf ("%d\n", cntr);

	return 0;
}
