/*
FROM: NOI 1999 round 4
PROB: mobile
KEYW: back-tracking
*/

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <utility>

const int MAXN = 1 << 5;

int N;
int NC;
std::vector <std::pair <int, int> > vec[MAXN];

int parse () {
//	printf ("in parse!\n");
	static int cN = 0;
	char c;
	int cn;
	bool eatcomma = 0;
	std::vector <std::pair <int, int> > crnt;

	while ((c = getchar ()) != ')' && c != '\n') {
//		printf ("scanned %c\n", c);
		if (c == ',')
			if (eatcomma)
				eatcomma = 0;
			else
				{crnt.push_back (std::make_pair (cn, -1)); cn = -100;}
		else if (c == '(') {--NC; crnt.push_back (std::make_pair (cn, parse ())); eatcomma = 1; cn = -100;}
		else {
			ungetc (c, stdin);
			scanf ("%d", &cn);
			++NC;
//			printf ("/%d/\n", cn);
		}
	}
	if (cn != -100) crnt.push_back (std::make_pair (cn, -1));
//	for (int i = 0; i < (int)crnt.size (); ++i) printf ("(%d %d) ", crnt[i].first, crnt[i].second); printf ("(%d)\n", cN);
	vec[cN] = crnt;
	return cN++;
}

bool used[MAXN];
int w[MAXN];

void prnt (int id = -1) {
	if (id == -1) id = N-1;
	putchar ('(');

	if (vec[id][0].second >= 0) prnt (vec[id][0].second);
	else printf ("%d", -vec[id][0].second);
	for (int i = 1; i < (int)vec[id].size (); ++i) {
		putchar (',');
		if (vec[id][i].second >= 0) prnt (vec[id][i].second);
		else printf ("%d", -vec[id][i].second);
	}
	putchar (')');
	if (id == N - 1) {puts (""); exit (0);}
}

void gen (int id, int pos = 0, int sum = 0) {
//	printf ("gen %d %d(%u) %d\n", id, pos, vec[id].size (),sum);
	if (id == N) prnt ();
	if (pos == (int)vec[id].size ()) {
		if (!sum) gen (id + 1);
//		printf ("<- %d %d %d\n", id, pos, sum);
		return;
	}
	if (vec[id][pos].second >= 0) {
		w[id] += w[vec[id][pos].second];
//		printf ("taking %d with w == %d\n", vec[id][pos].second, w[vec[id][pos].second]);
		gen (id, pos + 1, sum + vec[id][pos].first * w[vec[id][pos].second]);
		w[id] -= w[vec[id][pos].second];
	}
	else {
		for (int i = 1; i <= NC; ++i) {
			if (used[i]) continue;
			used[i] = 1;
			w[id] += i;
			vec[id][pos].second = -i;
//			printf ("putting %d\n", i);
			gen (id, pos + 1, sum + vec[id][pos].first * i);
			w[id] -= i;
			used[i] = 0;
		}
	}
//	printf ("<- %d %d %d\n", id, pos, sum);
}

int main () {
	getchar ();//eat the (
	N = parse () + 1;
	gen (0);

	return 0;
}
