/*
FROM: NOI 1999 round 4
PROB: star
KEYW: dynamical programming, hardcoding
*/

#include <cstdio>
#include <vector>

const int LINE = 1 << 4;
const int CELL = 1 << 6;

int data[LINE][CELL] =
	{
		{4,5,6,7,8,9,10,11,12,13,14,-1}, 		//A 0
		{15,16,17,18,19,20,21,22,23,-1}, 		//B 1
		{24,25,26,27,28,29,30,31,32,-1},		//C 2
		{33,34,35,36,37,38,39,40,41,42,43,-1},	//D 3

		{33,34,24,25,16,17,7,8,1,2,0,-1},		//E 4
		{35,36,26,27,18,19,9,10,3,-1},			//F 5
		{44,37,39,28,29,20,21,11,12,-1},		//G 6
		{47,45,46,39,40,30,31,22,23,13,14,-1},	//H 7

		{4,5,15,16,25,26,36,37,44,45,47,-1},	//I 8
		{6,7,17,18,27,28,38,39,46,-1},			//J 9
		{1,8,9,19,20,29,30,40,41,-1},			//K 10
		{0,2,3,10,11,21,22,31,32,42,43,-1}		//L 11
	};

int linemax[LINE];
int pmax[CELL];
int sat[CELL];

int opt[CELL][1 << LINE];

int main () {
	int i, j;
	for (i = 0; i < 12; ++i)
		scanf ("%d", linemax + i);

	for (i = 0; i < 48; ++i) pmax[i] = 10;
	for (i = 0; i < 12; ++i)
		for (j = 0; data[i][j] != -1; ++j)
			if (pmax[data[i][j]] > linemax[i]) {//erase current and add
				pmax[data[i][j]] = linemax[i];
				sat[data[i][j]] = (1 << i);
			} else if (pmax[data[i][j]] == linemax[i])//add to current
				sat[data[i][j]] |= (1 << i);

	int sum = 0;
	int done = 0;
	for (i = 0; i < 48; ++i) {
		sum += pmax[i];
		done |= sat[i];
	}
	if (done != ((1 << 12) - 1)) {
		printf ("NO SOLUTION\n");
		return 0;
	}

	for (i = 0; i < (1 << 12); ++i)
		opt[48][i] = CELL * 10;

	opt[48][(1 << 12) - 1] = 0;//the final 'right' position

	for (i = 47; i >= 0; --i)
		for (j = 0; j < (1 << 12); ++j)
			opt[i][j] = opt[i+1][j] <? (opt[i+1][j | sat[i]] + pmax[i]);

	printf ("%d %d\n", opt[0][0], sum);

	return 0;
}
