/*
FROM: NOI 2000 round 4 1st day
PROB: contour
KEYW: euler path
*/

#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>

const int MAXrN = 1 << 10;//it is 480 but just to be sure
const int MAXLEN = 1 << 20;//should be enough

struct point {
	int x, y, n;
	point (int _x, int _y, int _n) : x (_x), y (_y), n (_n) {}
};

int N;
std::vector <std::vector <point> > vec;
std::vector <point> pnts;

bool ma3x[MAXrN][MAXrN];

int inpp () {
	int tmp;
	while (!isdigit (tmp = getchar ()) && tmp != '-');
	ungetc (tmp, stdin);
	int a1, a2 =0, t3 = 3;
	scanf ("%d", &a1);
	tmp = getchar ();
	assert (tmp == '.');
	while (isdigit (tmp = getchar ())) {
		a2 *= 10;
		a2 += tmp - '0';
		--t3;
	}
	while (t3) {a2 *= 10; --t3;}

//	printf ("%d %d\n", a1, a2);
	if (a1 > 0)
		return a1 * 1000 + a2;
	else
		return a1 * 1000 - a2;
}

int cN;
point cross (point p1, point q1, point p2, point q2) {
	return (p2.y < p1.y && p1.y < q2.y && p1.x < p2.x && p2.x < q1.x ? point (p2.x, p1.y, cN++) : point (0,0,-1));
}

bool cmp (const point &a, const point &b) {
	return 	a.x != b.x ?
			a.x  < b.x :
			a.y  < b.y;
}

int trav[MAXLEN], tp;

void euler () {
	int st1[MAXLEN], stp = 0;
	st1[stp++] = 0;
	int i, c;
	while (stp) {
		c = st1[stp-1];
//		printf ("-%d(%d)-\n", c, stp);
		for (i = 0; i < cN; ++i)
			if (ma3x[c][i]) {
				ma3x[c][i] = 0;
				ma3x[i][c] = 0;
				st1[stp++] = i;
				break;
			}

		if (i == cN) trav[tp++] = st1[--stp];
	}
}

void prnt2 (int x) {
	char buf[4] = {0};
	buf[0] = x / 100 + '0';
	buf[1] = x / 10 % 10 ? x / 10 % 10 + '0' : 0;
	buf[2] = x % 10 ? x % 10 + '0' : 0;
	printf ("%s", buf);
}

void prnt (int id) {
	printf ("%d.", pnts[id].x / 1000);
	if (pnts[id].x % 1000)
		prnt2 (abs (pnts[id].x) % 1000);

	putchar (' ');

	printf ("%d.", pnts[id].y / 1000);
	if (pnts[id].y % 1000)
		prnt2 (abs (pnts[id].y) % 1000);
}

int main () {
	scanf ("%d", &N);
	vec.resize (cN = 4 * N);

	int i;
	int x1, y1, x2, y2;
	for (i = 0; i < N; ++i) {
		x1 = inpp ();
		y1 = inpp ();
		x2 = inpp ();
		y2 = inpp ();

		if (x1 > x2) x1 ^= x2 ^= x1 ^= x2;
		if (y1 > y2) y1 ^= y2 ^= y1 ^= y2;

		vec[i * 2].push_back (point (x1, y1, i * 4));
		vec[i * 2].push_back (point (x2, y1, i * 4 + 1));

		vec[i * 2 + 1].push_back (point (x1, y2, i * 4 + 2));
		vec[i * 2 + 1].push_back (point (x2, y2, i * 4 + 3));

		vec[N * 2 + i * 2].push_back (point (x1, y1, i * 4));
		vec[N * 2 + i * 2].push_back (point (x1, y2, i * 4 + 2));

		vec[N * 2 + i * 2 + 1].push_back (point (x2, y1, i * 4 + 1));
		vec[N * 2 + i * 2 + 1].push_back (point (x2, y2, i * 4 + 3));

		pnts.push_back (point (x1, y1, i * 2));
		pnts.push_back (point (x2, y1, i * 2 + 1));
		pnts.push_back (point (x1, y2, i * 2 + 2));
		pnts.push_back (point (x2, y2, i * 2 + 3));
	}

	point X (0, 0, -1);
	int j;

	for (i = 0; i < 2 * N; ++i)
		for (j = 2 * N; j < 4 * N; ++j)
			if ((X = cross (vec[i][0], vec[i][1], vec[j][0], vec[j][1])).n != -1) {
//				printf ("%d %d %d\n", X.x, X.y, X.n);
				vec[i].push_back (X);
				vec[j].push_back (X);
				pnts.push_back (X);
			}


	for (i = 0; i < 4 * N; ++i)
		std::sort (vec[i].begin (), vec[i].end (), cmp);
/*
	printf ("cN == %d\n", cN);
	for (i = 0; i < 4 * N; ++i) {
		for (j = 0; j < (int)vec[i].size (); ++j)
			printf ("(%d %d %d) ", vec[i][j].x, vec[i][j].y, vec[i][j].n);
		printf ("\n");
	}
*/
	for (i = 0; i < 4 * N; ++i) {
		ma3x[vec[i][0].n][vec[i][1].n] = 1;
		ma3x[vec[i].back ().n][vec[i][vec[i].size ()-2].n] = 1;
//		printf ("(%d %d) (%d %d)\n", vec[i][0].n, vec[i][1].n, vec[i].back ().n, vec[i][vec[i].size ()-2].n);
		for (j = 1; j < (int)vec[i].size () - 1; ++j) {
			ma3x[vec[i][j].n][vec[i][j+1].n] = 1;
			ma3x[vec[i][j].n][vec[i][j-1].n] = 1;
//			printf ("(%d %d) (%d %d)\n", vec[i][j].n, vec[i][j+1].n, vec[i][j].n, vec[i][j-1].n);
		}
//		printf ("--------\n");
	}
/*
	for (i = 0; i < cN; ++i) {
		for (j = 0; j < cN; ++j)
			printf ("%d ", ma3x[i][j]);
		printf ("\n");
	}
*/
	euler ();

	printf ("%d\n", tp);
	for (i = tp - 1; i >= 0; --i) {
		prnt (trav[i]);
//		printf ("%d(%d %d(%d)) ", trav[i], pnts[trav[i]].x, pnts[trav[i]].y, pnts[trav[i]].n);
		putchar ('\n');
	}

	return 0;
}
