/*
FROM: NOI 2000 round 4 1st day
PROB: flow
KEYW: linear, sort, simulation
*/

#include <cstdio>
#include <vector>
#include <algorithm>

const int MAXN = 1 << 10;
const int MAXM = 1 << 11;

int N, M;

int h[MAXN];
double bucket[MAXN];

std::vector <std::vector <int> > vec;

bool cmp (int a, int b) {
	return h[a] > h[b];
}

int main () {
	scanf ("%d %d", &N, &M);
	vec.resize (N);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d", h + i);

	int a, b, d;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", &a, &b, &d);
		--a; --b;
		if (h[a] > h[b]) a ^= b ^= a ^= b;
		if (h[a] == h[b]) {
			bucket[a] += d / 2.;
			bucket[b] += d / 2.;
//			printf ("%d %d -- to equal (%lf)\n", a, b, d / 2.0);
		} else {
			bucket[a] += d;
			vec[b].push_back (a);
//			printf ("%d %d -- to %d(%d) (add %d to vec[%d])\n", a, b, a, d, a, b);
		}
	}

//	for (i = 0; i < N; ++i) printf ("%lf(%u) ", bucket[i], vec[i].size ()); printf ("\n");

	int idx[MAXN];
	for (i = 0; i < N; ++i) idx[i] = i;

	std::sort (idx, idx + N, cmp);
	int j;
	for (i = 0; i < N; ++i) {
		if (!vec[idx[i]].size ()) continue;
		for (j = 0; j < (int)vec[idx[i]].size (); ++j)
			bucket[vec[idx[i]][j]] += (double)bucket[idx[i]] / vec[idx[i]].size ();
		bucket[idx[i]] = 0.;
	}

	for (i = 0; i < N; ++i)
		if (bucket[i] > 1e-9)
			printf ("%d %.4lf\n", i + 1, bucket[i]);

	return 0;
}
