#include  <stdio.h>

#define  INPUT_NAME   "ulica.inp"
#define  OUTPUT_NAME  "ulica.out"
#define  EPSILON      0.00001

int Zero (double x)
{
  return x > -EPSILON && x < EPSILON;
}

int main ()
{
  FILE    *fpInput = fopen (INPUT_NAME, "rt");
  FILE    *fpOutput = fopen (OUTPUT_NAME, "rt");
  int     x,y;
  double  x1,y1;
  double  x2,y2;
  double  a,b,c;
  double  dSign;
  double  dOldSign;
  double  dNewSign;

  if (fpInput == NULL)
  {
    printf ("[error: unable to open %s]\n", INPUT_NAME);
    return 1;
  }
  if (fpOutput == NULL)
  {
    printf ("[error: unable to open %s]\n", OUTPUT_NAME);
    return 1;
  }

  if (fscanf (fpOutput, "%lf %lf %lf %lf", &x1, &y1, &x2, &y2) != 4)
  {
    printf ("[error: wrong number of output parameters]\n");
    return 1;
  }

  if (x1 == 0.0 && y1 == 00 && x2 == 0.0 && y2 == 0.0)
  {
    printf ("NO SOLUTION.\n");
    return 0;
  }

  fclose (fpOutput);

  a = y2 - y1;
  b = x1 - x2;
  c = -a * x1 -b * y2;

  dSign = 0.0;

  do
  {
    fscanf (fpInput, "%d %d", &x, &y);
    if (x || y)
    {
      dOldSign = a * (double)x + b * (double)y + c;
      if (dSign * dOldSign < -EPSILON || Zero (dOldSign))
      {
        printf ("WRONG ANSWER.\n");
        return 0;
      }
      dSign = dOldSign;
    }
  } while (x || y);

  dSign = 0.0;
  while (fscanf (fpInput, "%d %d", &x, &y) == 2)
  {
    dNewSign = a * (double)x + b * (double)y + c;
    if (dSign * dNewSign < -EPSILON || dNewSign * dOldSign > EPSILON || Zero (dNewSign))
    {
      printf ("WRONG ANSWER.\n");
      return 0;
    }
    dSign = dNewSign;
  }

  printf ("OK.\n");

  return 0;
}