/*
FROM: 2001 k2
PROB: island
KEYW: full exhaustion
*/

#include <cstdio>
#include <cassert>

const int MAXN = 1 << 6;
const int MAXLEN = 1 << 7;
const int MAXSTATE = 486;

struct stat {
	int type;
	bool neg;
	int a, b, c;
	stat () {}
	stat (int _type, bool _neg, int _a, int _b, int _c) : type (_type), neg (_neg), a (_a), b (_b), c (_c) {}
};

stat cs[MAXN];

int type[5];
int day;
bool lying[5];

void decode (int a) {
	type[0] = a / 162; a %= 162;
	type[1] = a / 54; a %= 54;
	type[2] = a / 18; a %= 18;
	type[3] = a / 6; a %= 6;
	type[4] = a / 2; a %= 2;
	day = a;
	for (int i = 0; i < 5; ++i) lying[i] = (type[i] == 1 || (type[i] == 2 && day));
}

bool _new;
int Xtype[5];
int Xday;

void upd () {
	if (_new) {
		for (int i = 0; i < 5; ++i) Xtype[i] = type[i];
		Xday = day;
		_new = 0;
	} else {
		for (int i = 0; i < 5; ++i) if (Xtype[i] != type[i]) Xtype[i] = -1;
		if (Xday != day) Xday = -1;
	}
}

void prnt (int n) {
	if (n != 1) puts ("");
	printf ("Conversation #%d\n", n);
	if (Xday == 300) {printf ("This is impossible.\n"); return;}
	bool pp = 0;
	for (int i = 0; i < 5; ++i)
		if (Xtype[i] != -1) printf ("%c is %s.\n", i + 'A', Xtype[i] == 0 ? "divine" : Xtype[i] == 1 ? "evil" : "human"), pp = 1;

	if (Xday != -1) printf ("It is %s.\n", Xday ? "night" : "day"), pp = 1;
	if (!pp) printf ("No facts are deducible.\n");
}

int toint (char c) {
	switch (c) {
		case 'd': return 0;
		case 'e': return 1;
		case 'h': return 2;
		default : assert (0);
	}
}

void input (int N) {
	static char line[MAXLEN];
	stat crnt;
	for (int i = 0; i < N; ++i) {
		fgets (line, MAXLEN, stdin);
		if (line[5] == 'a') line[3] = line[0];
		if (line[5] == ' ') {cs[i] = stat (2, 0, line[0] - 'A', line[9] == 'n', 0); continue;}
		crnt.a = line[0] - 'A';
		crnt.b = line[3] - 'A';
		crnt.neg = line[8] == 'n';
		if (line[8 + (crnt.neg ? 4 : 0)] == 'l') {
			crnt.type = 1;
			crnt.c = 0;
		} else {
			crnt.type = 0;
			crnt.c = toint (line[8 + (crnt.neg ? 4 : 0)]);
		}

		cs[i] = crnt;
	}
}

int main () {
	int N;
	int cv = 1, i, j;
	while (scanf ("%d\n", &N), N) {
		input (N);

		Xday = 300;//if not touched - impossible
		_new = 1;
		for (i = 0; i < MAXSTATE; ++i) {
			decode (i);
			for (j = 0; j < N; ++j) {
				switch (cs[j].type) {
					case 0:	if (!cs[j].neg) {
								if ((type[cs[j].b] == cs[j].c) == lying[cs[j].a]) goto nxt;
							} else {
								if ((type[cs[j].b] != cs[j].c) == lying[cs[j].a]) goto nxt;
							}
							break;
					case 1:	if (!cs[j].neg) {
								if (lying[cs[j].b] == lying[cs[j].a]) goto nxt;
							} else {
								if (lying[cs[j].b] != lying[cs[j].a]) goto nxt;
							}
							break;
					case 2: if ((cs[j].b == day) == lying[cs[j].a]) goto nxt;
				}
			}
			nxt:;
			if (j == N) upd ();
		}

		prnt (cv++);
	}
	puts ("");

	return 0;
}
