/*
FROM: 2001 k2
PROB: lab
KEYW: bfs, deque, push to the front, buffer elements in the queue
*/

#include <cstdio>
#include <cctype>
#include <queue>

const int MAXN = 1 << 5;
const int MAXM = 1 << 5;
const int MAXSTATE = 1 << 20;

const int difx[] = {0, 1, 0, -1};
const int dify[] = {1, 0, -1, 0};

int N, M;
int Sx, Sy, Bx, By, Tx, Ty;
bool map[MAXN][MAXM];

int _T[4];
int code (int x1, int y1, int x2, int y2) {
	return x1 * _T[0] + y1 * _T[1] + x2 * _T[2] + y2 * _T[3];
}

void decode (int a, int &x1, int &y1, int &x2, int &y2) {
	x1 = a / _T[0]; a %= _T[0];
	y1 = a / _T[1]; a %= _T[1];
	x2 = a / _T[2]; a %= _T[2];
	y2 = a / _T[3]; a %= _T[3];
}
char letter[] = "rdlu";

int toint (char x) {
	x = tolower (x);
	switch (x) {
		case 'r': return 0;
		case 'd': return 1;
		case 'l': return 2;
		case 'u': return 3;
	}
	return 1000000000;
}

///DEQUE
std::queue <int> q1, q2;
int pop () {int ret; if (!q1.empty ()) {ret = q1.front (); q1.pop ();} else {ret = q2.front (); q2.pop ();} return ret;}
void pushb (int a) {q2.push (a);}
void pushf (int a) {q1.push (a);}
bool not_empty () {return (!q1.empty ()) || (!q2.empty ());}
///END DEQUE

bool used[MAXSTATE];
char prev[MAXSTATE];

int make_prev (int coded) {
	static int x1, y1, x2, y2, k;
	decode (coded, x1, y1, x2, y2);
	k = toint (prev[coded]);
	x1 -= difx[k];
	y1 -= dify[k];
	if (isupper (prev[coded])) {
		x2 -= difx[k];
		y2 -= dify[k];
	}

	return code (x1, y1, x2, y2);
}

char res[MAXSTATE];
int rp;

void bfs () {
	int ss = code (Sx, Sy, Bx, By);
	pushb (ss);
	prev[ss] = -1;
	used[ss] = 1;

	int x1, y1, x2, y2;
	int nx, ny;
	int k;
	int _add, c = -1;
	while (not_empty ()) {
		c = pop ();
		decode (c, x1, y1, x2, y2);
		if (x2 == Tx && y2 == Ty) goto prnt;//found solution

		for (k = 0; k < 4; ++k) {
			nx = x1 + difx[k];
			ny = y1 + dify[k];
			if (nx < 0 || nx >= N
			 || ny < 0 || ny >= M) continue;

			if (nx == x2 && ny == y2) {//push the B
				nx += difx[k];//see where the B is going
				ny += dify[k];//----------//-----------

				if (nx < 0 || nx >= N
				 || ny < 0 || ny >= M) continue;
				if (!map[nx][ny] && !used[(_add = code (x2, y2, nx, ny))]) {
					used[_add] = 1;
					prev[_add] = toupper (letter[k]);
					pushb (_add);
				}
			} else
				if (!map[nx][ny] && !used[(_add = code (nx, ny, x2, y2))]) {
					used[_add] = 1;
					prev[_add] = letter[k];
					pushf (_add);
				}
		}
	}
	printf ("Impossible.\n");
	return;

	prnt:;
	int cs = c;
	while (cs != ss) {
		res[rp++] = prev[cs];
		cs = make_prev (cs);
	}

	for (k = rp-1; k >= 0; --k) printf ("%c", res[k]); puts ("");
}

int main () {
	scanf ("%d %d\n", &N, &M);

	int i, j;
	char tmp;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < M; ++j) {
			scanf ("%c", &tmp);
			map[i][j] = tmp == '#';
			if (!isalpha (tmp)) continue;
			switch (tmp) {
				case 'S': Sx = i; Sy = j; break;
				case 'B': Bx = i; By = j; break;
				case 'T': Tx = i; Ty = j; break;
			}
		}
		scanf ("\n");
	}

	_T[3] = 1;
	_T[2] = _T[3] * M;
	_T[1] = _T[2] * N;
	_T[0] = _T[1] * M;

	bfs ();

	return 0;
}
