/*
FROM: NOI 2001 round 3
PROB: conf
KEYW: matching
*/

#include <cstdio>

const int MAXK = 1 << 20;
const int MAXN = 1 << 11;

struct el {
	int to;
	bool cap;
	int next;
};

int n, m, K;

int N;
int source, sink;
int vec[MAXN];
el buf[MAXK];

inline int op (int a) {
	return a & 1 ? a - 1 : a + 1;
}

int D[MAXN];
bool used[MAXN];


bool bfs () {
	int i, j;
	for (i = 0; i < N; ++i) {
		D[i] = -1;
		used[i] = 0;
	}
	used[source] = 1;

	static int queue[MAXN];
	int p1 = 0, p2 = 1, p3 = 0, lvl = 0;
	queue[p3++] = sink;
	D[sink] = lvl++;

	while (p1 != p2) {
		for (i = p1; i < p2; ++i)
			for (j = vec[queue[i]]; j != -1; j = buf[j].next) {
				if (D[buf[j].to] == -1 && buf[op (j)].cap) {
					D[buf[j].to] = lvl;
					queue[p3++] = buf[j].to;
				}
			}

		p1 = p2;
		p2 = p3;
		++lvl;
	}
//	for (i = 0; i < N; ++i) printf ("(%d - %d) ", i, D[i]); printf ("\n");

	return D[source] != -1;
}

int vp;
int vis[MAXN];

bool dfs (int v) {
//	printf ("dfs %d\n", v);
	if (v == sink) {
		used[sink] = 0;
		return 1;
	}

	for (int i = vec[v]; i != -1; i = buf[i].next) {
		if (D[buf[i].to] + 1 == D[v] && buf[i].cap && !used[buf[i].to]) {
			used[buf[i].to] = 1;
			vis[vp++] = i;
			if (dfs (buf[i].to))
				return 1;
			--vp;
		}
	}
//	printf ("<-\n");

	return 0;
}

int maxflow;
void dinitz () {
	while (bfs ()) {
		while (vp = 0, dfs (source)) {
//			printf ("-----------\n");
//			getchar ();
			++maxflow;
			for (int i = 0; i < vp; ++i) {
				buf[vis[i]].cap = !buf[vis[i]].cap;
				buf[op (vis[i])].cap = !buf[op (vis[i])].cap;
			}
		}
//		printf ("---new bfs--------\n");
	}
}

int main () {
	scanf ("%d %d %d", &n, &m, &K);

	source = n + m;
	sink = source + 1;
	N = sink + 1;
	int bp = 0;
	int p1, p2;
	int i;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < K; ++i) {
		scanf ("%d %d", &p1, &p2);
		--p1; --p2;
		p2 += n;

		buf[bp] = (el) {p2, 1, vec[p1]};
		vec[p1] = bp++;

		buf[bp] = (el) {p1, 0, vec[p2]};
		vec[p2] = bp++;
	}
	for (i = 0; i < n; ++i) {
		buf[bp] = (el) {i, 1, vec[source]};
		vec[source] = bp++;

		buf[bp] = (el) {source, 0, vec[i]};
		vec[i] = bp++;
	}
	for (i = n; i < source; ++i) {
		buf[bp] = (el) {sink, 1, vec[i]};
		vec[i] = bp++;

		buf[bp] = (el) {i, 0, vec[sink]};
		vec[sink] = bp++;
	}
/*
	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (int j = vec[i]; j != -1; j = buf[j].next)
			printf (" (%d %d)", buf[j].to, buf[j].cap);
		printf ("\n");
	}
*/
	dinitz ();
//	printf ("maxflow == %d\n", maxflow);
	printf ("%d\n", m + n - maxflow);

	return 0;
}
