/*
FROM: NOI 2001 round 3
PROB: game
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 7;

int N;
int vec[MAXN];
int opt[MAXN][MAXN];
int sum[MAXN];

int fsum (int a, int b) {
	return sum[b] - (a ? sum[a-1] : 0);
}

int main () {
	scanf ("%d", &N);

	int i, j;
	int op1, op2;
	for (i = 0; i < N; ++i)
		scanf ("%d", vec + i);

	sum[0] = vec[0];
	for (i = 1; i < N; ++i)
		sum[i] = sum[i - 1] + vec[i];

	for (i = 0; i < N; ++i) opt[i][i] = vec[i];
	for (j = 1; j < N; ++j)
		for (i = 0; i + j < N; ++i) {
			op1 = fsum (i + 1, i + j) - opt[i + 1][i + j] + vec[i];
			op2 = fsum (i, i + j - 1) - opt[i][i + j - 1] + vec[i + j];
			if (op1 > op2) {
				opt[i][i+j] = op1;
				opt[i+j][i] = 1;
			} else {
				opt[i][i+j] = op2;
				opt[i+j][i] = 2;
			}
		}

	printf ("%d %d\n", opt[0][N-1], opt[N-1][0]);

	for (i = 0; i < N; ++i) printf ("%3d ", vec[i]); printf ("\n\n");
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			printf ("%3d ", opt[i][j]);
		printf ("\n");
	}

	return 0;
}
