/*
FROM: NOI 2001 round 3
PROB: square
KEYW: sort, geometry
*/

#include <cstdio>
#include <algorithm>
#include <cassert>

const int MAXN = 1 << 7;

struct sq {
	int x1, x2;
	int y1, y2;
};

struct point {
	int x, y;
};

int N;
sq data[MAXN];
int dst[MAXN];
point P;

bool cmp (int a, int b) {
	if (dst[a] != dst[b])
		return dst[a] < dst[b];
	else
		return a < b;
}

int sqr (int a) {return a * a;}

int dist_sq (sq a) {
	printf ("%d %d   %d %d %d %d\n", P.x, P.y, a.x1, a.x2, a.y1, a.y2);
	int tmp = 0;
	if (P.y > a.y2)
		tmp += 0;
	else if (P.y >= a.y1)
		tmp += 3;
	else
		tmp += 6;

	if (P.x > a.x2)
		tmp += 0;
	else if (P.x >= a.x1)
		tmp += 1;
	else
		tmp += 2;

	printf ("tmp == %d\n", tmp);

	switch (tmp) {
		case 0: return sqr (P.x - a.x2) + sqr (P.y - a.y2);
		case 1: return sqr (P.y - a.y2);
		case 2: return sqr (P.x - a.x1) + sqr (P.y - a.y2);

		case 3: return sqr (P.x - a.x2);
		case 4: return 0;
		case 5: return sqr (P.x - a.x1);

		case 6: return sqr (P.x - a.x2) + sqr (P.y - a.y1);
		case 7: return sqr (P.y - a.y1);
		case 8: return sqr (P.x - a.x1) + sqr (P.y - a.y1);
		default: assert (0);
	}
}

int main () {
	scanf ("%d", &N);

	int i;
	int xx1, xx2, yy1, yy2;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d %d %d", &xx1, &yy1, &xx2, &yy2);
		data[i].x1 = xx1 <? xx2;
		data[i].x2 = xx1 >? xx2;

		data[i].y1 = yy1 <? yy2;
		data[i].y2 = yy1 >? yy2;
	}

	scanf ("%d %d", &P.x, &P.y);

	int idx[MAXN];
	for (i = 0; i < N; ++i) {dst[i] = dist_sq (data[i]); idx[i] = i;}
	for (i = 0; i < N; ++i) printf ("%d ", dst[i]); printf ("\n");

	std::sort (idx, idx + N, cmp);

	printf ("%d", idx[0] + 1); for (i = 1; i < N; ++i) printf (" %d", idx[i] + 1); printf ("\n");

	return 0;
}
