/*
FROM: 2002 k1
PROB: assem
KEYW: RPN (reverse polish notation)
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <vector>
#include <string>
#include <cstring>

using std::vector;
using std::string;

const int MAXX = 1 << 10;
const int MAX = 1 << 7;
const int BASE = 1000000000;
const int MAXMEM = 1 << 14;
const int MAXLEN = 1 << 8;

struct num {
	int a[MAXX];
	num (int b = 0) {for (int i = 1; i < MAX; ++i) a[i] = 0; a[0] = b;}
	num& operator = (const num &b) {for (int i = 0; i < MAX; ++i) a[i] = b.a[i]; return *this;}
	num& operator += (const num &b) {
		for (int i = 0; i < MAX-1; ++i) {
			a[i] += b.a[i];
			a[i+1] += a[i] / BASE;
			a[i] %= BASE;
		}
		return *this;
	}
	num& operator *= (const num &b) {
		num res;
		long long tmp;
		for (int i = 0; i < MAX/2-1; ++i)
			for (int j = 0; j < MAX/2-1; ++j) {
				tmp = (long long)a[i] * (long long)b.a[j];
				res.a[i+j] += tmp % BASE; res.a[i+j] %= BASE;
				res.a[i+j+1] += tmp / BASE; res.a[i+j+1] %= BASE;
			}
		return *this = res;
	}
	void prnt () const {
		int i;
		for (i = MAX-1; i > 0 && !a[i]; --i);
		printf ("%d", a[i]);
		for (--i; i >= 0; --i) printf ("%09d", a[i]);
		printf ("\n");
	}
};

num mem[MAXMEM];
int memp;
char expr[MAXLEN];
int stk[MAXLEN], sp;
const int _ADD = 10, _MUL = 11, _LB = 12;

void toRPN () {
	expr[0] = '(';
	expr[strlen (expr)] = ')';
	int i;
	int stk2[MAXLEN], s2p = 0;
	for (i = 0; expr[i]; ++i) {
		if (expr[i] == 'X') {
			stk[sp++] = expr[++i] - '0';
		} else if (expr[i] == '+') {
			for (--s2p; stk2[s2p] != _LB; --s2p)
				stk[sp++] = stk2[s2p];
			++s2p;//move NEXT the LB
			stk2[s2p++] = _ADD;
		} else if (expr[i] == '*') {
			stk2[s2p++] = _MUL;
		} else if (expr[i] == '(') {
			stk2[s2p++] = _LB;
		} else {// ')'
			assert (expr[i] == ')');
			for (--s2p; stk2[s2p] != _LB; --s2p)
				stk[sp++] = stk2[s2p];
		}
	}
//	for (i = 0; i < sp; ++i) printf ("%d ", stk[i]); printf ("\n");
}

std::vector <std::string> com;
char buf[MAXLEN];

void LOA (int p) {
	mem[0] = mem[p];
//	printf ("LOA %d\n", p);
	sprintf (buf, "LOA %d", p);
	com.push_back (string (buf));

}

void STO (int p) {
	mem[p] = mem[0];
//	printf ("STO %d\n", p);
	sprintf (buf, "STO %d", p);
	com.push_back (string (buf));

}

void ADD (int p) {
	mem[0] += mem[p];
//	printf ("ADD %d\n", p);
	sprintf (buf, "ADD %d", p);
	com.push_back (string (buf));

}

void MUL (int p) {
	mem[0] *= mem[p];
//	printf ("MUL %d\n", p);
	sprintf (buf, "MUL %d", p);
	com.push_back (string (buf));

}

int i, tmp;
int main () {
	for (i = 1; i < 10; ++i) {
		scanf ("%d", &tmp);
		mem[i] = tmp;
	}

	scanf ("%s", expr + 1);
	toRPN ();

	memp = 10;//the first free cell
	for (i = 0; i < sp; ++i) {
		if (stk[i] < 10) {
			LOA (stk[i]);
			STO (memp++);
		} else if (stk[i] == _ADD) {
			LOA (--memp);
			ADD (--memp);
			STO (memp++);
		} else if (stk[i] == _MUL) {
			LOA (--memp);
			MUL (--memp);
			STO (memp++);
		}
	}

	mem[0].prnt ();
	printf ("%u\n", com.size ());
	for (i = 0; i < (int)com.size (); ++i)
		puts (com[i].c_str ());

	return 0;
}
