/*
FROM: 2002 k1
PROB: pass
KEYW: kmp
*/

#include <cstdio>
#include <vector>

const int MAXN = 1 << 19;
const int MAXM = 1 << 9;
const int MAXLEN = 1 << 9;

int N, M;
char ss[MAXN];
char s[MAXM][MAXLEN];

std::vector <int> vec[MAXN];
int opt[MAXN];

void kmp (int id) {
//	printf ("-%s-\n", s[id]);
	static int fl[MAXLEN] = {0};

	int i, crnt = 0;
	for (i = 2; s[id][i-1]; ++i) {
		while (crnt && s[id][crnt] != s[id][i-1]) crnt = fl[crnt];
		fl[i] = crnt += s[id][crnt] == s[id][i-1];
	}
	int len = i - 1;

	crnt = 0;
	for (i = 0; i < N; ++i) {
		while (crnt && s[id][crnt] != ss[i]) crnt = fl[crnt];
		if (s[id][crnt] == ss[i] && ++crnt == len) {
			vec[i - len + 1].push_back (i + 1);
//			printf ("%d -- %d\n", i - len + 1, i + 1);
			crnt = fl[crnt];
		}
	}
}

int main () {
	scanf ("%d %d\n", &N, &M);
	gets (ss);
	int i, j;
	for (i = 0; i < M; ++i) {
		gets (s[i]);
		kmp (i);
	}

	for (i = 1; i <= N; ++i) opt[i] = INT_MAX;
	opt[0] = 0;

	for (i = 0; i < N; ++i) {
//		printf ("opt[%d] = %d\n", i, opt[i]);
		for (j = 0; j < (int)vec[i].size (); ++j) {
			if (opt[vec[i][j]] > opt[i]) {
				opt[vec[i][j]] = opt[i];
//				printf ("use %d %d, now (%d)\n", i, vec[i][j], opt[i]);
			}
//			opt[vec[i][j]] <?= opt[i];
		}
		opt[i+1] <?= opt[i] + 1;
	}

	printf ("%d\n", opt[N]);

	return 0;
}
