/*
FROM: 2002 k2
PROB: points
KEYW: bfs, geometry
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 10;
const double epsilon = 1e-9;

struct point {
	double x, y;
	point () {}
	point (double _x, double _y) : x (_x), y (_y) {}
};

inline double sq (double a) {return a * a;}

inline double dist (const point &a, const point &b) {
	return sq (a.x - b.x) + sq (a.y - b.y);
}

int N;
double D;
point vec[MAXN];
bool used[MAXN];

void bfs (int start) {
	static int queue[MAXN];
	static int p3;
	p3 = 0;
	queue[p3++] = start;
	used[start] = 1;

	for (int i = 0; i < p3; ++i)
		for (int j = 0; j < N; ++j) {
//			if (!used[j]) printf ("calc %d %d -- %lf(%lf)\n", queue[i], j, dist (vec[queue[i]], vec[j]), D);
			if (!used[j] && dist (vec[queue[i]], vec[j]) - D < epsilon) {
				queue[p3++] = j;
				used[j] = 1;
			}
		}
}

int main () {
	int cntr, i;
	while (scanf ("%d", &N), N) {
		cntr = 0;
		scanf ("%lf", &D);
		D *= D;

		for (i = 0; i < N; ++i)
			scanf ("%lf %lf", &vec[i].x, &vec[i].y);


		memset (used, 0, sizeof (used));
		for (i = 0; i < N; ++i)
			if (!used[i]) {
				bfs (i);
				++cntr;
			}

		printf ("%d\n", cntr);
	}

	return 0;
}
