/*
FROM: 2002 k2
PROB: hill
KEYW: graph expansion, dijkstra with from-scrach heap
*/

#include <cstdio>
#include <climits>

#include <vector>
#include <queue>

const int MAXN = 1000;
const int MAXM = 100000;

struct el {
	int to;
	int dist;
	int id;
	int next;
	el () {}
	el (int _to, int _dist, int _id, int _next) : to (_to), dist (_dist), id (_id), next (_next) {}
};

struct heap {
	int to;
	int dist;
	heap () : dist (INT_MAX) {}
	heap (int _to, int _dist) : to (_to), dist (_dist) {}
	bool operator < (const heap &a) const {return dist > a.dist;}
};

int N, M;
int edges[MAXM][2];
int edist[MAXM];

el buf[MAXM * 2];
int vec[MAXN];

int calcd (int d1, int d2) {
	return ((d2 / 2) - (d1 / 4) >? 0);
}

///HEAP//////////////
const int MAXHEAP = 200000;
heap h[MAXHEAP];
int hp;
int idx[MAXM];
const int NOT_IN = -2, POPPED = -1;

void init () {
	h[0].dist = INT_MIN;
	hp = 1;
	for (int i = 0; i < M; ++i)	idx[i] = NOT_IN;
}

void prnt () {
	int ub = 2, i = 1;
	while (ub < 20) {
		for (; i < ub; ++i)
			printf ("(%d %d) ", h[i].to, h[i].dist);
		printf ("\n");
		ub *= 2;
	}
}

heap pop () {
	heap ret = h[1];
	idx[ret.to] = POPPED;
	heap tomove = h[--hp];
	h[hp] = heap ();
	if (hp == 1) return ret;
	int p1 = 1, p2 = 2;

	for (;;) {
		if (h[p2+1].dist < h[p2].dist)
			++p2;
		if (h[p2].dist < tomove.dist) {
			h[p1] = h[p2];
			idx[h[p2].to] = p1;

			p1 = p2;
			p2 *= 2;
		} else
			break;
	}

	h[p1] = tomove;
	idx[tomove.to] = p1;

	return ret;
}

void siftup (int id) {
	heap tomove = h[idx[id]];
	int p1 = idx[id], p2 = p1 / 2;

	while (h[p2].dist > tomove.dist) {
		h[p1] = h[p2];
		idx[h[p2].to] = p1;

		p1 = p2;
		p2 /= 2;
	}

	h[p1] = tomove;
	idx[id] = p1;
}

void add (int to, int dist) {
	if (idx[to] == NOT_IN) {
//		printf ("add %d %d\n", to, dist);
		h[hp] = heap (to, dist);
		idx[to] = hp++;
		siftup (to);
//		prnt ();
	} else if (idx[to] != POPPED && h[idx[to]].dist > dist) {
//		printf ("update %d %d\n", to, dist);
		h[idx[to]].dist = dist;
		siftup (to);
//		prnt ();
	}
}

///END HEAP//////////
bool used[MAXM];
std::priority_queue <heap> q;
int dijkstra (int s, int f) {
	init ();
	int i, j, k, end;
	for (i = 0; i < M; ++i)
		if (edges[i][0] == s || edges[i][1] == s) {
			add (i, edist[i] / 2);
		}

	heap crnt;
	while (hp > 1) {
		crnt = pop ();
		if (edges[crnt.to][0] == f || edges[crnt.to][1] == f) return crnt.dist;
/*
		for (int i = 0; i < (int)vec[crnt.to].size (); ++i)
			add (vec[crnt.to][i].to, crnt.dist + vec[crnt.to][i].dist);
*/
///dddddddd
		for (k = 0; k < 2; ++k) {
			end = edges[crnt.to][k];
			for (j = vec[end]; j != -1; j = buf[j].next)
				if (buf[j].id != crnt.to)
					add (buf[j].id, crnt.dist + calcd (edist[crnt.to], buf[j].dist));
		}
///dddddddd
	}

	return 0;
}

int main () {
	scanf ("%d %d", &N, &M);

	int i;
	int a, b, d;
	int bp = 0;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", &a, &b, &d);
		--a; --b; d *= 4;//to prevent floating-point arithmetics

		edges[i][0] = a; edges[i][1] = b; edist[i] = d;

		buf[bp] = el (b, d, i, vec[a]);
		vec[a] = bp++;
		buf[bp] = el (a, d, i, vec[b]);
		vec[b] = bp++;
	}
/*
	int j;
	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (j = vec[i]; j != -1; j = buf[j].next)
			printf (" (%d %d)", buf[j].to, buf[j].dist);
		printf ("\n");
	}
*/
	int S, F;
	scanf ("%d %d", &S, &F);
	--S; --F;

	int res = dijkstra (S, F);
	printf ("%.2lf\n", res / 4.);

	return 0;
}
