/*
FROM: 2002 k4
PROB: naver
KEYW: average of 2, dfs, topological sort
*/

#include <cstdio>
#include <cassert>

#include <vector>
#include <algorithm>

const int MAXN = 1 << 9;

int N;
bool ma3x[MAXN][MAXN];
int vec[MAXN];
int type[MAXN];

void add_edge (int a, int b, int c) {/*printf ("add %d %d %d\n", a, b, c);*/ma3x[b][a] = ma3x[b][c] = 1;}
void calc_new (int &a, int &b) {
	if (!a)
		++b;
	else if (b == N-1)
		--a;
	else
		if (vec[a] - vec[a-1] < vec[b+1] - vec[b])
			--a;
		else
			++b;
}

void find_average () {
	int i;
	int p, n;
	for (i = 1; i < N-1; ++i) {
//		printf ("i == %d(%d)\n", i, vec[i]);
		p = i-1; n = i+1;
//		printf ("%d %d(%d %d)\n", p, n, vec[p], vec[n]);
		while (n < N && p >= 0) {
			while (n < N && vec[n] - vec[i] < vec[i] - vec[p]) ++n;
			while (p >= 0 && vec[i] - vec[p] < vec[n] - vec[i]) --p;
//			printf ("%d %d(%d %d)\n", p, n, vec[p], vec[n]);
			if (n >= N || p < 0) break;
			if (vec[p] + vec[n] == (vec[i] << 1)) {
				add_edge (p, i, n);
				calc_new (p, n);
			}
		}
	}
}

void dfs1 (int a, int t) {
	printf ("dfs1 %d %d\n", a, t);
	assert (type[a] != 1-t);
	if (type[a] == t) {printf ("<--\n"); return;}
	type[a] = t;
	for (int i = 0; i < N; ++i)
		if (ma3x[a][i] && ma3x[i][a])
			dfs1 (i, 1-t);
}

std::vector <int> ans;
bool used[MAXN];
void dfs (int a) {
//	printf ("dfs -- %d\n", a);
	for (int i = 0; i < N; ++i) if (ma3x[a][i] && !used[i]) {used[i] = 1; dfs (i);}
	ans.push_back (vec[a]);
}

int main () {
	int i = 0;
	while (scanf ("%d", vec + i) == 1) ++i;
	N = i;

	std::sort (vec, vec + N);

	find_average ();
	for (i = 0; i < N; ++i) type[i] = -1;

	for (i = 0; i < N; ++i) if (type[i] == -1) dfs1 (i, 0);
	for (i = 0; i < N; ++i) {
		if (type[i]) continue;
		printf ("invert %d\n", i);
		for (int j = 0; j < N; ++j)
			if (ma3x[i][j] && ma3x[j][i]) {
				ma3x[i][j] = 0;
//				ma3x[j][i] = 1;
			}
	}

	for (i = 0; i < N; ++i) {
		for (int j = 0; j < N; ++j)
			printf ("%d ", ma3x[i][j]);
		printf ("\n");
	}

	for (i = 0; i < N; ++i)
		if (!used[i]) {used[i] = 1; dfs (i);}

	for (i = 0; i < (int)ans.size (); ++i) printf (" %d", ans[i]); printf ("\n");

	return 0;
}
