/*
FROM: NOI 2002 round 3
PROB: drain
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 9;
const long long _infinity = 1ll << 40;

int N;
int dst[MAXN];
int dr[MAXN];
long long drsb[MAXN];
long long drse[MAXN];

long long opt[MAXN][MAXN];

long long fsum (int a, int b) {
	return drsb[a] + drse[b];
}

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 1; i <= N; ++i)
		scanf ("%d %d", dst + i, dr + i);

	drsb[0] = 0; drse[N+1] = 0;
	for (i = 1; i <= N; ++i)
		drsb[i] = drsb[i-1] + dr[i];
	for (i = N; i >= 1; --i)
		drse[i] = drse[i+1] + dr[i];

	dst[0] = dst[1];
	dst[N+1] = dst[N];
	dr[0] = dr[N+1] = 0;

	opt[0][N+1] = opt[N+1][0] = 0;
	for (i = 1; i <= N; ++i) opt[0][i] = opt[N+1][i] = _infinity;

	for (j = N; j >= 1; --j) {
		opt[j][0] = opt[j+1][0] + (dst[j+1] - dst[j]) * fsum (0, j + 1);
		opt[N+1-j][N+1] = opt[N-j][N+1] + (dst[N+1-j] - dst[N-j]) * fsum (N - j, N + 1);
//		printf ("--%d %d   %d %d--\n", j, 0, j + 1, 0);
//		printf ("--%d %d   %d %d--\n", N+1-j, N+1, N-j, N+1);
		for (i = 1; i + j <= N; ++i) {
			opt[i][i+j] =	(opt[i-1][i+j] + (dst[i] - dst[i-1]) * fsum (i - 1, i + j)) <?
							(opt[i+j][i-1] + (dst[i+j] - dst[i]) * fsum (i - 1, i + j));
			opt[i+j][i] =	(opt[i+j+1][i] + (dst[i+j+1] - dst[i+j]) * fsum (i, i + j + 1)) <?
							(opt[i][i+j+1] + (dst[i+j] - dst[i]) * fsum (i, i + j + 1));
		}
	}
/*
	for (i = 0; i <= N + 1; ++i) {
		for (j = 0; j <= N + 1; ++j)
			printf ("%4Ld ", opt[i][j] == _infinity ? 999 : opt[i][j]);
		printf ("\n");
	}
*/
	long long min = _infinity;
	int pos = -1;
	for (i = 1; i <= N; ++i)
		if (min > opt[i][i+1]) {
			min = opt[i][i+1];
			pos = i;
		}

	printf ("%Ld\n%d\n", min, pos);

	return 0;
}
