/*
TASK: bintree
LANG: C++

FROM: 2003 k2
PROB: bintree
KEYW: dynamical programming
*/

#include <cstdio>
#include <climits>

const int MAXN = 1 << 11;

int N;
int sum[MAXN];
int opt[MAXN][MAXN];
int p[MAXN][MAXN];

int fsum (int a, int b) {
	return sum[b-1] - a ? sum[a-1] : 0;
}

void prnt (int a, int b, int pp, char x) {
//	printf ("--%d %d(%d) %d %c\n", a, b, p[a][b], pp, x);
	if (a == b) return;
	printf ("%d %d %c\n", p[a][b] + 1, pp + 1, x);
	prnt (a, p[a][b], p[a][b], '<');
	prnt (p[a][b] + 1, b, p[a][b], '>');
}

int main () {
	scanf ("%d %*d", &N);

	int i, j, k, tmp;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &tmp);
		opt[i][i+1] = tmp;
		p[i][i+1] = i;
		sum[i] += tmp;
		sum[i+1] = sum[i];
	}

//	for (i = 0; i < N; ++i) printf ("%d %d -- %d\n", i, i + 1, opt[i][i+1]);
	for (j = 2; j <= N; ++j)
		for (i = 0; i + j <= N; ++i) {
			opt[i][i+j] = INT_MAX;
//			printf ("ij %d %d(%d %d)\n", i, i+j, p[i][i+j-1], p[i+1][i+j]);
			for (k = p[i][i+j-1]; k <= p[i+1][i + j]; ++k) {
//				printf ("k == %d -- (%d %d)%d (%d %d)%d\n", k, i, k, opt[i][k], k+1, i + j, opt[k+1][i+j]);
				if (opt[i][i+j] > opt[i][k] + opt[k+1][i+j]) {
					opt[i][i+j] = opt[i][k] + opt[k+1][i+j];
					p[i][i+j] = k;
//					printf ("upd!\n");
				}
			}
			opt[i][i+j] += fsum (i, i + j);
		}

	printf ("%d\n", p[0][N] + 1);
	prnt (0, p[0][N], p[0][N], '<');
	prnt (p[0][N] + 1, N, p[0][N], '>');

	return 0;
}
