/*
FROM: 2003 k2
PROB: diag
KEYW: coding, decoding, dynamical programming
*/

#include <cstdio>
#include <cassert>

const int MAXM = 1 << 5;//20
const int MAXS = 1 << 5;//30
const int MAXN = 1 << 25;

int M;
int p[MAXM];
int P[MAXM];

long long L;
int cd[MAXM][MAXS];
int ans[MAXM][MAXS];
long long opt[MAXN];

int code (int *a) {
	int res = 0;
	for (int i = 0; i < M; ++i)
		res += a[i] * P[i];

	return res;
}

void decode (int a, int *vec) {
	for (int i = M - 1; i >= 0; --i) {
		vec[i] = a / P[i];
		a %= P[i];
	}
}

long long fopt (int n) {
	int vec[MAXM];
	decode (n, vec);

	if (opt[n]) return opt[n];

	int i, max = 0;
	for (i = M-1; i >= 0; --i)
		if (max < vec[i]) {
			max = vec[i];
			--vec[i];
			opt[n] += fopt (code (vec));
			++vec[i];
		}

//	printf ("%d -- %d\n", n, opt[n]);
	return opt[n];
}

long long get (int n) {
	if (!n) return 0ll;

	int vec[MAXM];
	decode (n, vec);

//	printf ("get %d:\n", n); for (int i = 0; i < M; ++i) printf ("%d ", vec[i]); printf ("\n");

	int i, k = 0, max = 0;
	long long res = 0;
	for (i = 0; i < M; ++i) k += vec[i];
	for (i = M - 1; i >= 0; --i) {
		if (max < vec[i]) {
			max = vec[i];
			if (cd[i][max-1] == k) {
				--vec[i];
				return res + get (code (vec));
			} else {
				--vec[i];
				res += fopt (code (vec));
				++vec[i];
			}
		}
	}
	assert (0);
}

void gen (long long n, int *vec) {
	int i, k = 0, max = 0;
	long long tmp;
	for (i = 0; i < M; ++i) k += vec[i];
	if (!k) return;
	for (i = M - 1; i >= 0; --i)
		if (max < vec[i]) {
			max = vec[i];
			--vec[i];
			if ((n -= (tmp = fopt (code (vec)))) < 0) {
				n += tmp;
				ans[i][max-1] = k;
				gen (n, vec);
				++vec[i];
				return;
			} else
				++vec[i];
		}

	assert (0);
}

int main () {
	scanf ("%d", &M);

	int i, j; P[0] = P[1] = 1;
	for (i = 0; i < M; ++i) {
		scanf ("%d", &p[i]);
		P[i+1] *= p[i] + 1;
		P[i+2] = P[i+1];
	}

	assert (P[M] < MAXN);
//	printf ("P[M] == %d\n", P[M]);

	scanf ("%Ld", &L);

	for (i = 0; i < M; ++i)
		for (j = 0; j < p[i]; ++j)
			scanf ("%d", &cd[i][j]);

	opt[0] = 1;
	long long cid = get (code (p));
//	printf ("cid == %Ld\n", cid);

	if (cid >= L) {
		gen (cid - L, p);
		for (i = 0; i < M; ++i) {
			if (p[i] != 0) printf ("%d", ans[i][0]);
			for (j = 1; j < p[i]; ++j)
				printf (" %d", ans[i][j]);
			printf (" \n");
		}
	} else
		printf ("%Ld\n", cid);

	return 0;
}
