/*
FROM: NOI 2003 round 2
PROB: frac
KEYW: farey sequence, from index to element, binary search
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 24;

int N;
long long K;

int cnt_pre_;

long long cnt_pre (int m) {
	++cnt_pre_;
	static long long cnt[MAXN];
	static int i, j;
	static long long sum;

	for (i = 2; i <= N; ++i) cnt[i] = (long long)i * m / N;
	sum = 1;
	for (i = 2; i <= N; ++i) {
		sum += cnt[i];
		for (j = i * 2; j <= N; j += i) cnt[j] -= cnt[i];
	}

	return sum;
}

struct drob {
	int x, y;
};

drob vec[MAXN];
int vp;

int gcd (int a, int b) {
	return a ? gcd (b % a, a) : b;
}

bool cmp (const drob &a, const drob &b) {
	return (long long)a.x * b.y < (long long)a.y * b.x;
}

int main () {
	scanf ("%d %Ld", &N, &K);

	int l = 0, r = N, m;

	while (l + 1 < r) {
		m = (l + r) / 2;
		if (cnt_pre (m) <= K)
			l = m;
		else
			r = m;
	}

	m = l;
	for (int i = 1; i <= N; ++i)
		if ((m * i / N) + 1 <= (m + 1) * i / N)
			if (gcd ((m * i / N) + 1, i) == 1)
				vec[vp++] = (drob) {(m * i / N) + 1, i};

	std::sort (vec, vec + vp, cmp);
	K -= cnt_pre (m);
	printf ("%d/%d(%d)\n", vec[K].x, vec[K].y, cnt_pre_);

	return 0;
}
