/*
FROM: NOI 2003 round 3
PROB: cube
KEYW: full exhaustion
*/

#include <cstdio>
#include <cstring>
#include <cassert>
#include <ctime>

#include <algorithm>
#include <vector>

const int NN = 1 << 4;
const int MAXM = 1 << 3;
const int N = 12;

int M;
int all_cnt;
int CH, ZN;
int cnt[MAXM];
int _cnt[MAXM];
int __vec1[NN], __vec2[NN];
int *vec = __vec1, *vec2 = __vec2;
int Vec[NN];
int fact[NN];

int plf [] = {1,2,3,0,5,6,7,4,9,10,11,8};
int plb [] = {8,5,0,4,11,9,1,3,10,6,2,7};

//std::vector <bool> used;
bool used[8000000];

inline bool _try () {
/*	int i;
	for (i = 0; i < N && Vec[i] == vec[i]; ++i);

	return Vec[i] > vec[i];
*/
	return std::lexicographical_compare (vec, vec + N, Vec, Vec + N);
}

void input () {
	for (int i = 0; i < N; ++i) scanf ("%d", Vec + i);
}

inline void rotf () {
	static int i;
	for (i = 0; i < N; ++i)
		vec2[plf[i]] = vec[i];
	std::swap (vec, vec2);
}

inline void rotb () {
	static int i;
	for (i = 0; i < N; ++i)
		vec2[plb[i]] = vec[i];
	std::swap (vec, vec2);
}

bool ok () {
	memcpy (vec, Vec, sizeof (Vec));
	for (int i = 0; i < 4; ++i) {
		for (int j = 0; j < 4; ++j) {
			if (std::lexicographical_compare (vec, vec + N, Vec, Vec + N)) return 0;
			rotf ();
		}
		rotb ();
	}

	rotf ();
	rotb ();
	for (int i = 0; i < 2; ++i) {
		for (int j = 0; j < 4; ++j) {
			if (std::lexicographical_compare (vec, vec + N, Vec, Vec + N)) return 0;
			rotf ();
		}
		rotb ();
		rotb ();
	}

	return 1;
}

int main () {
	input ();

	int res = 0;
	do {
		if (ok ()) ++res;
	} while (std::next_permutation (Vec + 1, Vec + N));

	printf ("%lf\n", (double)clock () / CLOCKS_PER_SEC);
	printf ("%d\n", res);

	return 0;
}
