/*
FROM: NOI 2003 round 3
PROB: expr
KEYW: full exhaustion, reversed polish signature
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>

#include <stack>
#include <string>

const int MAXM = 1 << 3;

int N, M;

int var[MAXM];

int max;
bool used[MAXM];
int st[MAXM*2], stp;

const int ops[] = {-1, -2, -3, -4};

int eval () {
	static long long st2[MAXM];
	static int stp2;
	static long long v1, v2;
	stp2 = 0;
	for (int i = 0; i < stp; ++i)
		if (st[i] > 0)
			st2[stp2++] = st[i];
		else {
			v2 = st2[--stp2];
			v1 = st2[--stp2];
			if (v1 <= 0 || v2 <= 0) return -1;

			switch (st[i]) {
				case -1: st2[stp2++] = v1 + v2; break;
				case -2: st2[stp2++] = v1 - v2; break;
				case -3: st2[stp2++] = v1 * v2; break;
				case -4: if (v1 % v2) return -1; st2[stp2++] = v1 / v2; break;
			}
		}

	if (st2[0] <= 0) return -1;
	assert (stp2 == 1);
	return st2[0];
}

char otc[] = "+-*/";

char *tostr (int a) {
	static char buf[10];
	int bp = 0;
	while (a) {
		buf[bp++] = a % 10 + '0';
		a /= 10;
	}

	std::reverse (buf, buf + bp);
	buf[bp] = 0;
	return buf;
}

void prnt () {
	std::stack <std::string> stck;
	std::string str1, str2;
	for (int i = 0; i < stp; ++i)
		if (st[i] > 0)
			stck.push (std::string (tostr (st[i])));
		else {
			str2 = stck.top (); stck.pop ();
			str1 = stck.top (); stck.pop ();

			stck.push (std::string ("(") + str1 + otc[-st[i] - 1] + str2 + ')');
		}

	printf ("%s\n", stck.top ().c_str ());
	exit (0);
}

void gen (int vc, int oc) {
	if (vc - oc == 1) {
		if (eval () == -1) return;//something bad
		if (vc == max) {
			if (eval () == N)
				prnt ();
			return;
		}
	}
	if (vc - oc > 1)
		for (int i = 0; i < 4; ++i) {
			st[stp++] = ops[i];
			gen (vc, oc + 1);
			--stp;
		}
	if (vc < max)
		for (int i = 0; i < M; ++i) {
			if (used[i]) continue;
			used[i] = 1;
			st[stp++] = var[i];
			gen (vc + 1, oc);
			--stp;
			used[i] = 0;
		}
}

int main () {
	scanf ("%d", &N);

	M = -1;
	while (scanf ("%d", var + ++M) == 1);

	for (max = 1; max <= M; ++max)
		gen (0, 0);

	return 0;
}
