/*
FROM: 2004 k1
PROB: points
KEYW: area, Pick formula (S = in_p + on_boundaries_p / 2 - 1)
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 1 << 10;

int _gcd (int a, int b) {
	return b ? _gcd (b, a % b) : a;
}

struct point {
	int x, y;
	point () {}
	point (int _x, int _y) : x (_x), y (_y) {}
	point operator - (const point &a) const {return point (x - a.x, y - a.y);}
	int gcd () const {return _gcd (abs (x) >? abs (y), abs (x) <? abs (y));}
};

int N;
point vec[MAXN];

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &vec[i].x, &vec[i].y);

	vec[N] = vec[0];
	int S = 0;
	for (i = 0; i < N; ++i)
		S += vec[i].x * vec[i+1].y;

	for (i = 0; i < N; ++i)
		S -= vec[i+1].x * vec[i].y;

//	printf ("%d\n", S);

	int on_b = 0;
	for (i = 0; i < N; ++i) {
		on_b += (vec[i+1] - vec[i]).gcd ();
//		printf ("%d -- %d(%d %d)\n", i, on_b, (vec[i+1] - vec[i]).x, (vec[i+1] - vec[i]).y);
	}

	int in = (S - on_b + 2) / 2;
	printf ("%d\n", in + on_b);

	return 0;
}
