/*
FROM: 2004 k2
PROB: hexa
KEYW: hexagonal coordinate system, hash
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>

const int MAXLEN = 1 << 20;
const int MAXHASH = 9699689;

struct pos {
	int x, y;
	pos () {}
	pos (int _x, int _y) : x (_x), y (_y) {}
	pos operator + (const pos &a) const {return pos (x + a.x, y + a.y);}
	pos operator - (const pos &a) const {return pos (x - a.x, y - a.y);}
	bool operator == (const pos &a) const {return x == a.x && y == a.y;}
	bool operator != (const pos &a) const {return x != a.x || y != a.y;}
};

struct el {
	pos key;
	el *next;
	el (const pos &_key, el *_next) : key (_key), next (_next) {}
};

const pos dif[6] = {pos (1, 0), pos (0, 1), pos (-1, 1), pos (-1, 0), pos (0, -1), pos (1, -1)};

char line[MAXLEN];
el *hash_in[MAXHASH];
el *hash_out[MAXHASH];

int srch (const pos &a) {
	for (int i = 0; i < 6; ++i) if (dif[i] == a) return i;
	return -10000;
}

int mod (int a) {
	return a > 5 ? a - 6 : a < 0 ? a + 6 : a;
}

inline int f (const pos &a) {
	return abs (a.x * a.y + a.x + a.y) % MAXHASH;
}

inline void h (const pos &a, el *hash[]) {
//	printf ("%d %d\n", a.x, a.y);
	static int id;
	static el *tmp;
	id = f (a);
	assert (id < MAXHASH);

	for (tmp = hash[id]; tmp && tmp->key != a; tmp = tmp->next);
	if (tmp) return;

//	printf ("add!\n");
	tmp = new el (a, hash[id]);
	hash[id] = tmp;
}

int cnt (el *hash[]) {
	int res = 0;
	for (int i = 0; i < MAXHASH; ++i)
		for (el *tmp = hash[i]; tmp; tmp = tmp->next, ++res);

	return res;
}

int main () {
	fgets (line, MAXLEN, stdin);

	pos in(0, 0), out(1, -1);
	h (in, hash_in); h (out, hash_out);
	int k;
	for (int i = 0; line[i] != '\n'; ++i) {
		if (line[i] == '1') {
			k = srch (out - in);
			out = in + dif[mod (k+1)];
//			printf ("new out -- %d %d\n", out.x, out.y);
			h (out, hash_out);
		} else {//2
			k = srch (in - out);
			in = out + dif[mod (k-1)];
//			printf ("new in -- %d %d\n", in.x, in.y);
			h (in, hash_in);
		}
	}

	printf ("%d %d\n", cnt (hash_out), cnt (hash_in));

	return 0;
}
