/*
FROM: 2004 k2
PROB: lab
KEYW: bfs, code, decode
*/

#include <cstdio>
#include <queue>

const int MAXN = 40;//cut in memory :)
const int MAXrN = 40 * 40 * 40 * 10 * 10;

struct state {
	int x, y, z;
	char k1, k2;
	state () {}
	state (int _x, int _y, int _z, char _k1, char _k2) : x (_x), y (_y), z (_z), k1 (_k1), k2 (_k2) {}
};

int difx[] = {-1,  0,  0, 1, 0, 0};
int dify[] = {0,  -1,  0, 0, 1, 0};
int difz[] = {0,   0, -1, 0, 0, 1};

int N;
char col[MAXN][MAXN][MAXN];
char key[MAXN][MAXN][MAXN];

int Sx, Sy, Sz, Fx, Fy, Fz;
char Sk1, Sk2;

int _t1, _t2, _t3, _t4;

void input () {
	scanf ("%d %d %d %d %d %d %d\n", &N, &Sx, &Sy, &Sz, &Fx, &Fy, &Fz);
	--Sx; --Sy; --Sz; --Fx; --Fy; --Fz;
	scanf ("%c%c\n", &Sk1, &Sk2);

	int x, y, z;
	for (z = 0; z < N; ++z) {
		for (x = 0; x < N; ++x) {
			for (y = 0; y < N; ++y)
				scanf ("%c", &col[x][y][z]);
			scanf ("\n");
		}
		scanf ("\n");
	}

	for (z = 0; z < N; ++z) {
		for (x = 0; x < N; ++x) {
			for (y = 0; y < N; ++y)
				scanf ("%c", &key[x][y][z]);
			scanf ("\n");
		}
		scanf ("\n");
	}

	_t4 = 10;
	_t3 = _t4 * 10;
	_t2 = _t3 * N;
	_t1 = _t2 * N;
}

inline int code (const state &a) {
	return a.x * _t1 + a.y * _t2 + a.z * _t3 + (a.k1 - 'A') * _t4 + (a.k2 - 'A');
}

state decode (int a) {
	static state res;
	res.x = a / _t1; a %= _t1;
	res.y = a / _t2; a %= _t2;
	res.z = a / _t3; a %= _t3;
	res.k1 = a / _t4 + 'A'; a %= _t4;
	res.k2 = a + 'A';
	return res;
}

int D[MAXrN];
int prev[MAXrN];

int row[MAXN];

std::queue <int> q;
int crnti;
void add (int _add) {
	if (!D[_add]) {
		D[_add] = D[crnti] + 1;
		prev[_add] = crnti;
		q.push (_add);
	}
}

int fnd (state a, state b) {
	for (int i = 0; i < 6; ++i)
		if (a.x + difx[i] == b.x
		 && a.y + dify[i] == b.y
		 && a.z + difz[i] == b.z)
		 	return i;

	return -1;
}

bool good (int a, int b, int c, char k1, char k2) {
	return 0 <= a && a < N
		&& 0 <= b && b < N
		&& 0 <= c && c < N
		&& (col[a][b][c] == k1
		|| col[a][b][c] == k2);
}

int len;

void bfs () {
	int start = code (state (Sx, Sy, Sz, Sk1, Sk2));
	q.push (start);

	state crnt;
	char kkey;
	int k;
	while (!q.empty ()) {
		crnti = q.front (); q.pop ();
		crnt = decode (crnti);
		if (crnt.x == Fx && crnt.y == Fy && crnt.z == Fz) break;

		for (k = 0; k < 6; ++k)
			if (good (crnt.x + difx[k], crnt.y + dify[k], crnt.z + difz[k], crnt.k1, crnt.k2))
				add (code (state (crnt.x + difx[k], crnt.y + dify[k], crnt.z + difz[k], crnt.k1, crnt.k2)));

		kkey = key[crnt.x][crnt.y][crnt.z];
		if (kkey != 'O' && kkey != crnt.k1)
			add (code (state (crnt.x, crnt.y, crnt.z, kkey, crnt.k2)));

		if (kkey != 'O' && kkey != crnt.k2)
			add (code (state (crnt.x, crnt.y, crnt.z, crnt.k1, kkey)));
	}

	len = D[crnti] + 1;
	for (k = crnti; k != start; k = prev[k])
		row[D[k]] = k;

	row[0] = start;

	printf ("%d\n", len - 1);
	state last;
	int tmp;
	crnt = decode (row[0]);
	for (k = 1; k < len; ++k) {
		last = crnt;
		crnt = decode (row[k]);
		if ((tmp = fnd (last, crnt)) != -1)
			putchar (tmp + 'U');
		else if (last.k1 != last.k2)
			putchar (last.k1);
		else
			putchar (last.k2);
	}
	puts ("");
}

int main () {
	input ();

	bfs ();

	return 0;
}
