/*
TASK:palechko
LANG:C++

FROM: 2004 k3
PROB: palechko
KEYW: binary search, geometry
*/

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <climits>

const int MAXN = 1 << 10;

struct point {
	int x, y;
	point () {}
	point (int _x, int _y) : x (_x), y (_y) {}
	point & operator += (const point &a) {x += a.x; y += a.y; return *this;}
	point operator + (const point &a) const {return point (x + a.x, y + a.y);}
	point operator - (const point &a) const {return point (x - a.x, y - a.y);}
	int operator * (const point &a) const {return x * a.x + y * a.y;}
	int sq () {return x * x + y * y;}
};

int _vc[2];
point _vec[2][MAXN];
point _d[2];
int W;

point *vec;
int vc;
point d;

inline void set (int id) {
//	printf ("set %d\n", id);
	vec = _vec[id];
	vc = _vc[id];
	d = _d[id];
}

inline point Vec (int id) {
	return vec[id] + d;
}

inline int S (const point &a, const point &b, const point &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

double dist (int x, int call = -1) {
	if (call != -1) set (call);
	int l = 1, r = vc-2, m;
	point xx (x, 0);

	while (l != r) {
		m = (l + r) >> 1;

		if ((Vec (m) - xx).sq () < (Vec (m+1) - xx).sq ())
			r = m;
		else
			l = m + 1;
	}

	double ret = sqrt ((Vec (r) - xx).sq ());
	if ((Vec (r+1) - Vec (r)) * (xx - Vec(r)) > 0)
		ret <?= abs (S (xx, Vec (r), Vec (r+1))) / sqrt ((Vec (r) - Vec (r+1)). sq ());
	if ((Vec (r-1) - Vec (r)) * (xx - Vec(r)) > 0)
		ret <?= abs (S (xx, Vec (r), Vec (r-1))) / sqrt ((Vec (r) - Vec (r-1)). sq ());

//	printf ("dist %d --- %lf(%d)\n", x, ret, r);
	return ret;
}

int bsrch (int l, int r, double _t1, double _t2) {
	static int m;
	static double tmp1, tmp2, tmp, _t;
	while (l + 1 < r) {
		m = (l + r) / 2;

		if (dist (m, 0) > dist (m, 1))
			r = m;
		else
			l = m;
	}
	set (0);
	tmp1 = dist (l);
	tmp2 = dist (r);
	set (1);
	tmp1 <?= dist (l);
	tmp2 <?= dist (r);
	tmp = tmp1 >? tmp2;
	_t = _t1 >? _t2;

//	printf ("_%d %d_ %lf %lf, %lf %lf\n", l, r, tmp1, tmp2, _t1, _t2);

	return _t > tmp ? _t1 > _t2 ? 0 : W : tmp1 > tmp2 ? l : r;
}

int main () {
	int K;
	scanf ("%d %*d %d", &W, &K);

	int i, j, k;
	for (k = 0; k < K; ++k) {
		scanf ("%d", _vc + k);
		for (i = 1; i <= _vc[k]; ++i)
			scanf ("%d %d", &_vec[k][i].x, &_vec[k][i].y);

		_vec[k][0] = point (_vec[k][1].x, _vec[k][1].y + 1);
		_vec[k][_vc[k]+1] = point (_vec[k][_vc[k]].x, _vec[k][_vc[k]].y + 1);
		_vc[k] += 2;
	}

	if (K == 1) {//clone the first hand if no second
		for (i = 0; i < _vc[0]; ++i)
			_vec[1][i] = _vec[0][i];
		_vc[1] = _vc[0];
	}

	int minX[2], _miny[2] = {INT_MAX, INT_MAX};
	for (k = 0; k < 2; ++k)
		for (i = 0; i < _vc[k]; ++i)
			if (_miny[k] > _vec[k][i].y) {
				_miny[k] = _vec[k][i].y;
				minX[k] = _vec[k][i].x;
			}


	_d[0] = _d[1] = point (0, 0);

	double tmp1, tmp2;

	set (0);
	tmp1 = dist (0);
	tmp2 = dist (W);
	set (1);
	tmp1 <?= dist (0);
	tmp2 <?= dist (W);
//	printf ("%lf %lf\n", tmp1, tmp2);
//	printf ("%d\n", tmp1 > tmp2 ? 0 : W);
	printf ("%d\n", bsrch (minX[0] <? minX[1], minX[0] >? minX[1], tmp1, tmp2));

	int M;
	point _dd[2];
	scanf ("%d", &M);
	for (j = 0; j < M; ++j) {
		for (k = 0; k < K; ++k)
			scanf ("%d %d", &_dd[k].x, &_dd[k].y);
		if (K == 1) _dd[1] = _dd[0];
		_d[0] += _dd[0]; _d[1] += _dd[1];
		minX[0] += _dd[0].x; minX[1] += _dd[1].x;

		set (0);
		tmp1 = dist (0);
		tmp2 = dist (W);
		set (1);
		tmp1 <?= dist (0);
		tmp2 <?= dist (W);

//		printf ("%lf %lf\n", tmp1, tmp2);
//		printf ("%d\n", tmp1 > tmp2 ? 0 : W);
		printf ("%d\n", bsrch (minX[0] <? minX[1], minX[0] >? minX[1], tmp1, tmp2));
	}

	return 0;
}
