/*
FROM: 2004 k3
PROB: trip
KEYW: dynamical programming
*/

#include <cstdio>
#include <vector>

const int MAXN = 1 << 9;
const int MAXS = 1 << 10;

struct deal {
	int give;
	int cost;
	int id;
};

struct prevs {
	int i, j;
	int id;
	prevs () {}
	prevs (int _i, int _j, int _id) : i (_i), j (_j), id (_id) {}
};

int N;
int Sf, Sw;
int Mf, Mw;
int f[MAXN], w[MAXN];

std::vector <deal> fd[MAXN], wd[MAXN];

void input () {
	scanf ("%*d %d %d %d %d", &Sf, &Sw, &Mf, &Mw);

	scanf ("%d", &N);
	for (int i = 0; i < N - 1; ++i)
		scanf ("%*d %d %d", f + i, w + i);

	int R;
	scanf ("%d", &R);
	int tmp1, tmp2;
	deal crnt;
	for (int i = 0; i < R; ++i) {
		crnt.id = i;
		scanf ("%d %d %d %d", &tmp1, &tmp2, &crnt.cost, &crnt.give);

		if (tmp2)//water
			wd[tmp1-1].push_back (crnt);
		else//food
			fd[tmp1-1].push_back (crnt);
	}
}

int fo[MAXN][MAXS], wo[MAXN][MAXS];
prevs fprev[MAXN][MAXS], wprev[MAXN][MAXS];

int xF (int a) {return a < Mf ? a : Mf;}
int xW (int a) {return a < Mw ? a : Mw;}

int main () {
	input ();

	int i, j, k;
	int _tmp;
	for (i = 0; i < N; ++i) for (j = 0; j < MAXS; ++j) fo[i][j] = wo[i][j] = INT_MAX;
	fo[0][Sf] = 1; fprev[0][Sf] = prevs (-1, -1, -1);
	wo[0][Sw] = 1; wprev[0][Sw] = prevs (-1, -1, -1);
	for (i = 0; i < N - 1; ++i) {
		for (j = 0; j <= Mf; ++j) {
			if (fo[i][j] == INT_MAX) continue;
//			printf ("f - %d %d -- %d\n", i, j, fo[i][j]);

			if (j - f[i] >= 0)
				if (fo[i+1][j-f[i]] > fo[i][j]) {
//					printf ("go %d %d -- %d\n", i+1, j - f[i], fo[i][j]);
					fo[i+1][j-f[i]] = fo[i][j];
					fprev[i+1][j-f[i]] = prevs (i, j, -1);
				}
			for (k = 0; k < (int)fd[i].size (); ++k) {
//				printf ("try deal %d %d %d --- %d(%d)\n", fd[i][k].give, fd[i][k].cost, fd[i][k].id, xF (j + fd[i][k].give) - f[i], fo[i][j] + fd[i][k].cost);
				if ((_tmp = xF (j + fd[i][k].give) - f[i]) >= 0)
					if (fo[i+1][_tmp] > fo[i][j] + fd[i][k].cost) {
//						printf ("!go %d %d -- %d\n", i+1, _tmp, fo[i][j] + fd[i][k].cost);
						fo[i+1][_tmp] = fo[i][j] + fd[i][k].cost;
						fprev[i+1][_tmp] = prevs (i, j, fd[i][k].id);
					}
			}
		}
		////water
		for (j = 0; j <= Mw; ++j) {
			if (wo[i][j] == INT_MAX) continue;
//			printf ("w - %d %d -- %d\n", i, j, wo[i][j]);
			if (j - w[i] >= 0)
				if (wo[i+1][j-w[i]] > wo[i][j]) {
//					printf ("go %d %d -- %d\n", i+1, j - w[i], wo[i][j]);
					wo[i+1][j-w[i]] = wo[i][j];
					wprev[i+1][j-w[i]] = prevs (i, j, -1);
				}
			for (k = 0; k < (int)wd[i].size (); ++k) {
//				printf ("try deal %d %d %d --- %d(%d)\n", wd[i][k].give, wd[i][k].cost, wd[i][k].id, xW (j + wd[i][k].give) - w[i], wo[i][j] + wd[i][k].cost);
				if ((_tmp = xW (j + wd[i][k].give) - w[i]) >= 0)
					if (wo[i+1][_tmp] > wo[i][j] + wd[i][k].cost) {
//						printf ("!go %d %d -- %d\n", i+1, _tmp, wo[i][j] + wd[i][k].cost);
						wo[i+1][_tmp] = wo[i][j] + wd[i][k].cost;
						wprev[i+1][_tmp] = prevs (i, j, wd[i][k].id);
					}
			}
		}
	}

	int best = INT_MAX;
	int bi = -1;

	std::vector <int> ans;

	for (i = 0; i <= Mf; ++i)
		if (best > fo[N-1][i]) {
			best = fo[N-1][i];
			bi = i;
		}

	prevs crnt (N-1, bi, -1);
	for (;crnt.i != -1; crnt = fprev[crnt.i][crnt.j]) {
//		printf ("%d %d %d\n", crnt.i, crnt.j, crnt.id);
		if (crnt.id != -1)
//			printf ("%d ", crnt.id + 1);
			ans.push_back (crnt.id + 1);
	}

	best = INT_MAX;
	for (i = 0; i <= Mw; ++i)
		if (best > wo[N-1][i]) {
			best = wo[N-1][i];
			bi = i;
		}

	crnt = prevs (N-1, bi, -1);
	for (;crnt.i != -1; crnt = wprev[crnt.i][crnt.j]) {
//		printf ("%d %d  %d\n", crnt.i, crnt.j, crnt.id);
		if (crnt.id != -1)
//			printf ("%d ", crnt.id + 1);
			ans.push_back (crnt.id + 1);
	}

	printf ("%u\n", ans.size ());
	printf ("%d", ans[0]); for (i = 1; i < (int)ans.size (); ++i) printf (" %d", ans[i]); printf ("\n");

	return 0;
}
