/*
FROM: NOI 2004 ROUND 2 A
PROB: fast
KEYW: dijkstra with stl heap
*/

#include <cstdio>
#include <vector>
#include <queue>
#include <utility>
#include <limits>

std::vector <bool> used;

int N, M;
std::vector <std::vector <std::pair <int, int> > > vec;

struct Cmp {bool operator () (const std::pair <int, int> &a, const std::pair <int, int> &b) {return a.second < b.second;}};

int dijkstra () {
	used.resize (N);
	std::priority_queue <std::pair <int, int>, std::vector <std::pair <int, int> >, Cmp> q;

	q.push (std::make_pair (0, std::numeric_limits <int>::max ()));

	std::pair <int, int> crnt;
	while (!q.empty ()) {
		crnt = q.top (); q.pop ();
		if (used[crnt.first]) continue;
		used[crnt.first] = 1;
		if (crnt.first == N-1) return crnt.second;

		for (int i = 0; i < (int)vec[crnt.first].size (); ++i)
			if (!used[vec[crnt.first][i].first])
				q.push (std::make_pair (vec[crnt.first][i].first, std::min (vec[crnt.first][i].second, crnt.second)));
	}
	return 0;
}

int main () {
	scanf ("%d %d", &N, &M);

	int i;
	vec.resize (N);
	int a, b, d;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d\n", &a, &b, &d);
		--a; --b;
		vec[a].push_back (std::make_pair (b, d));
		vec[b].push_back (std::make_pair (a, d));
	}

	printf ("%d\n", dijkstra ());

	return 0;
}
