/*
FROM: NOI 2004 ROUND 2 A
PROG: rays
KEYW: computational geometry
NOTE: last test DOWN - reason UNKNOWN!!
*/

#include <cstdio>
#include <algorithm>
#include <cmath>
#include <vector>
#include <utility>

const int MAXN = 1 << 11;
const double epsilon = 1e-9;

struct point {
	int x;
	int y;
};

int N;
point A0;
point vec[MAXN];
int idx[MAXN];

bool EQ (double a, double b) {
	return fabs (a - b) < epsilon;
}


int S (const point &a, const point &b, const point &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

int fill_gr (std::vector <int> &vv, int i) {
	vv.clear ();
	vv.push_back (idx[i]);
	for (++i; i < N && !S (A0, vec[vv.back ()], vec[idx[i]]); ++i)
		vv.push_back (idx[i]);
	return i;
}

std::vector <std::pair <int, int> > vec2;

double myang (int id) {
	return atan2 (vec[id].y - A0.y, vec[id].x - A0.x);
}

bool cmp1 (int a, int b) {
	return !EQ (myang (a), myang (b)) ?
				myang (a) < myang (b) :
				a < b;
}

double myang2 (int a1, int a2) {
	double ang1 = myang (a1);
	double ang2 = myang (a2);
	if (ang1 < ang2)
		return ang2 - ang1;
	else
		return M_PI * 2 - (ang1 - ang2);
}

bool ok_topush (std::pair <int, int> a) {
	return !EQ (myang2 (a.first, a.second), M_PI) ?
			myang2 (a.first, a.second) < M_PI :
			0;
}

void add_to_vec2 (const std::vector <int> &a, const std::vector <int> &b) {
	std::pair <int, int> topush;
/*
	printf ("** **\n");
	for (int i = 0; i < (int)a.size (); ++i) printf ("%d ", a[i]); printf ("\n");
	for (int i = 0; i < (int)b.size (); ++i) printf ("%d ", b[i]); printf ("\n");
	printf ("**************\n");
*/
	for (int i = 0; i < (int)a.size (); ++i)
		for (int j = 0; j < (int)b.size (); ++j) {
			topush = std::make_pair (a[i], b[j]);
			if (ok_topush (topush)) {
//				printf ("----%d %d\n", topush.first, topush.second);
				vec2.push_back (topush);
			}
		}
}

std::pair <int, int> trf (const std::pair <int, int> &a) {
	return std::make_pair (std::min (a.first, a.second), std::max (a.first, a.second));
}

bool cmp2 (const std::pair <int, int> &a, const std::pair <int, int> &b) {
	double ang1 = myang2 (a.first, a.second);
	double ang2 = myang2 (b.first, b.second);
	return !EQ (ang1, ang2) ?
			ang1 < ang2 :
			trf (a) < trf (b);
}

int main () {
	scanf ("%d", &N);
	scanf ("%d %d", &A0.x, &A0.y);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &vec[i].x, &vec[i].y);

	for (i = 0; i < N; ++i) idx[i] = i;
	std::sort (idx, idx + N, cmp1);


//	for (i = 0; i < N; ++i) printf ("%d\n", idx[i]);

	std::vector <int> gr1, gr2;

	i = 0;
	i = fill_gr (gr1, 0);

//	printf ("***************\n");
//	for (int j = 0; j < gr1.size (); ++j) printf ("%d ", gr1[j]); printf ("\n");
	while (i < N) {
		i = fill_gr (gr2, i);
		add_to_vec2 (gr1, gr2);
		gr1 = gr2;
//		for (int j = 0; j < gr1.size (); ++j) printf ("%d ", gr1[j]); printf ("\n");
	}
//	printf ("****************\n");
	fill_gr (gr2, 0);
	add_to_vec2 (gr1, gr2);

//	for (i = 0; i < (int)vec2.size (); ++i) printf ("%d %d\n", vec2[i].first, vec2[i].second);
//	printf ("\n");

	std::sort (vec2.begin (), vec2.end (), cmp2);

	for (i = 0; i < (int)vec2.size (); ++i)
		printf ("%d %d\n", std::min (vec2[i].first, vec2[i].second) + 1, std::max (vec2[i].first, vec2[i].second) + 1);

	return 0;
}
