/*
FROM: 2005 k2
PROB: mark
KEYW: fractions
*/

#include <cstdio>

typedef unsigned long long ull;

const int MAXK = 1 << 7;
int N;

ull _gcd (ull a, ull b) {
	return b ? _gcd (b, a % b) : a;
}

ull gcd (ull a, ull b) {
	return a > b ? _gcd (a, b) : _gcd (b, a);
}

struct frac {
	ull x, y;
	frac (ull _x, ull _y) : x (_x), y (_y) {reduce ();}
	bool take () {
		static ull k, f, s;
		k = gcd (y, N);
		f = N / k;
		s = y / k;
		if (f * x < s)
			return 0;
		else {
			x = f * x - s;
			y *= f;
			reduce ();
			return 1;
		}
	}
	void mul () {
		static ull k;
		k = gcd (y, N);
		x = x * (N / k);
		y /= k;

		reduce ();
	}

	void reduce () {
		static ull k;
		k = _gcd (x, y);
		x /= k;
		y /= k;
	}

	void prnt () const {printf ("%Lu %Lu\n", x, y);}
};

int P, K;
bool rem[MAXK];

int main () {
	ull a, b;

	scanf ("%d %d %d", &N, &P, &K);
	int i, tmp;
	for (i = 0; i < K; ++i) {scanf ("%d", &tmp); rem[tmp-1] = 1;}
	scanf ("%Lu %Lu", &a, &b);

	frac c (a, b);

	int p, gr;
	for (p = 1; p <= P; ++p) {
		gr = 0;
		while (c.take ()) ++gr;
		if (rem[gr]) break;
		c.mul ();
	}

	printf ("%d\n", p <= P ? p : 0);

	return 0;
}
