/*
TASK:burn
LANG:C++
*/

#include <cstdio>
#include <cstdlib>
#include <queue>
#include <cfloat>
using namespace std;

int m,n;
int mtx[256][256];
int deg[256];
int b[256];
int u[10000];
float ebt[10000];
float vb[256];
typedef struct Edge
{
 int len;
 int to;
 int id;
 struct Edge* next;
} Edge;

//Edge* red[256][256];
Edge* v[256];

void input()
{
 int i,s,e,l;
 Edge* p,*q;
// freopen("burn.in","r",stdin);
 scanf("%d %d",&n,&m);
 for(i=0;i<m;i++)
 {
    scanf("%d %d %d",&s,&e,&l);
    deg[s]++;
    deg[e]++;

    p=(Edge*)malloc(sizeof(Edge));
    p->len=l;
    p->to=e;
    p->next=v[s];
    p->id=i;
    v[s]=p;

    q=(Edge*)malloc(sizeof(Edge));
    q->to=s;
    q->len=l;
    q->next=v[e];
    q->id=i;
    v[e]=q;
 }
}

struct Event
{
   float time;
   int v;
   bool operator< (Event& b) const
   {
    return time > b.time;
   };
};

struct cmp
{
 bool operator() (Event& a,Event& b) const
 {
  return a.time>b.time;
 };
};

float burn(int start)
{
 priority_queue< Event ,vector<Event> ,cmp > pq;
 Event e,ne;
 Edge* p;
 int i;
 float res;
 for(i=1;i<=n;i++)
   b[i]=0;
 for(i=0;i<m;i++)
   u[i]=0;
 e.time=deg[start];
 e.v=start;
 pq.push(e);
 while(!pq.empty())
 {
  e=pq.top();
  pq.pop();
  if(b[e.v])
            continue;
  b[e.v]=1;
  vb[e.v]=e.time;
  for(p=v[e.v];p!=NULL;p=p->next)
  {
     if(!b[p->to])
     {
        ne.time=e.time + p->len + deg[p->to];
        ne.v=p->to;
        pq.push(ne);
     }
     if(!u[p->id])
     {
        ebt[p->id]=e.time + p->len;
        u[p->id]=1;
     }
     else if(ebt[p->id] > e.time)
        ebt[p->id] -= (ebt[p->id] - e.time)/2.0;
  }
 }
 res=vb[1];
 for(i=2;i<=n;i++)
   if(vb[i]>res)
     res=vb[i];
 for(i=0;i<m;i++)
   if(ebt[i] > res)
     res=ebt[i];
 return res;
}
int main()
{
   float best=FLT_MAX,cur;
   int i;
   input();
   for(i=1;i<=n;i++)
   {
    cur=burn(i);
    if(cur < best)
       best=cur;
   }
   printf("%.1f",best);
   return 0;
}
