/*
TASK:treas
LANG:C++
*/
#include <stdio.h>
#include <algorithm>

using namespace std;

#define PII pair<int,int>
#define X first
#define Y second
#define IN "treas.in"
#define OUT "treas.out"
#define LL long long

long long N;

#define MAXN 1024
#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)<(b))?(a):(b))

typedef struct node {
        long long a,b,p;
        bool operator < (const node &h) const {
             if (b < h.b) return true;
             if (b > h.b) return false;
             if (a > h.a) return true;
             if (a < h.a) return false;
             if (p < h.p) return true;
             if (p > h.p) return false;
        }
};



node ar[MAXN];
long long dp[MAXN];

long long area(long long a,long long b) {
    if (a > b) return 0;
    
    if ((b-a) % 2 == 0) {
    
       long long mid = (b-a)/2+1;
       return mid*mid;
       
    } else {
    
       long long mid = (b-a+1)/2;
       return mid*(mid+1);
       
    }
}
long long full_cover(long long i,long long j) {
    if (ar[i].a <=ar[j].a && ar[i].b >= ar[j].b) return 1;
    else return 0;
}

long long get_cros(long long i,long long j) {
    return area(ar[i].a,ar[j].b);
}

int main () {
//    freopen(IN,"r",stdin);
//    freopen(OUT,"w",stdout);

    scanf("%lld",&N);

    long long x,y,p;
    for (long long i=1; i<=N; i++) {
        scanf("%lld%lld%lld",&x,&y,&p);
        ar[i].a = x+y+1;
        ar[i].b = x-y-1;
        ar[i].p = p;
    }

    sort(&ar[1],&ar[1]+N);
    long long j = 0;
    long long t = 0;
    for (long long i=1; i<=N; i++) {
        dp[i] = ar[i].p-area(ar[i].a,ar[i].b);
        j = i-1;
        t = 0;
        while (j > 0 && full_cover(i,j)) {
              dp[i] += ar[j].p;
              j--;
        }

        while (j > 0) {
              t >?= (dp[j]+get_cros(i,j));
              j--;
        }
        dp[i] = MAX(dp[i],dp[i]+t);
    }



    long long ans = 0;
    for (long long i=1; i<=N; i++) {
        ans >?= dp[i];
    }

    printf("%lld\n",ans);
    return 0;
}
