/*
TASK:cut
LANG:C++
*/

#include <iostream>
#include <fstream>
#include <map>
#include <set>
#include <algorithm>
using namespace std;
#define maxC 180000
#define To 90000
typedef struct node { int x,y; };
typedef struct around { node ld,lu,rd,ru; };
typedef struct cut { int U1,V1,U2,V2;node A,B; };

typedef struct cmp {
    bool operator() (const node fst,const node snd) const {
        if (fst.x<snd.x) return true;
        if (fst.x>snd.x) return false;
        return (fst.y<snd.y); }; };
typedef struct gc {
    bool operator() (const cut fst,const cut snd) const {
        if (fst.U1<snd.U1) return true;
        if (fst.U1>snd.U1) return false;
        return (fst.V1<snd.V1); }; };

map <node,around,cmp> F;
int N,X1=maxC,Y1=maxC,X2=-maxC,Y2=-maxC;
set <cut,gc> A;

void init();
void solve(int x1,int y1,int x2,int y2);
bool usl(const cut fst,const cut snd);
bool tryC(cut T);
void proceed(cut T);

int main()
{
 init();
 cout<<N-1<<endl;
 solve(X1,Y1,X2,Y2);
 while (A.begin()!=A.end()) proceed( (*A.begin()) );
 return 0;
}

void init()
{
// ifstream fin("cut.in");
 cin>>N;
 node LD,RD,LU,RU,X;X.x=0;X.y=0;
 for (int i=1;i<=N;i++) {
    cin>>LD.x>>LD.y>>RU.x>>RU.y;
    LD.x+=To;LD.y+=To;RU.x+=To;RU.y+=To;
    LU.x=LD.x;LU.y=RU.y;
    RD.x=RU.x;RD.y=LD.y;
    if (LD.x<X1) X1=LD.x;
    if (LD.y<Y1) Y1=LD.y;
    if (RU.x>X2) X2=RU.x;
    if (RU.y>Y2) Y2=RU.y;
    F[LD].ru=RU;
    F[RU].ld=LD;
    F[LU].rd=RD;
    F[RD].lu=LU; }
// fin.close();
}

void solve(int x1,int y1,int x2,int y2)
{
 node ld;ld.x=x1;ld.y=y1;
 node lu;lu.x=x1;lu.y=y2;
 node rd;rd.x=x2;rd.y=y1;
 node ru;ru.x=x2;ru.y=y2;
 if (F[ld].ru.x==ru.x&&F[ld].ru.y==ru.y) return;
 cut C[10];
 // dolu vlqvo
 C[1].U1=x1;C[1].U2=x2;C[1].V1=F[ld].ru.y;C[1].V2=F[ld].ru.y;
 C[2].U1=F[ld].ru.x;C[2].U2=F[ld].ru.x;C[2].V1=y1;C[2].V2=y2;
 // gore vlqvo
 C[3].U1=x1;C[3].U2=x2;C[3].V1=F[lu].rd.y;C[3].V2=F[lu].rd.y;
 C[4].U1=F[lu].rd.x;C[4].U2=F[lu].rd.x;C[4].V1=y1;C[4].V2=y2;
 // dolu vdqsno
 C[5].U1=x1;C[5].U2=x2;C[5].V1=F[rd].lu.y;C[5].V2=F[rd].lu.y;
 C[6].U1=F[rd].lu.x;C[6].U2=F[rd].lu.x;C[6].V1=y1;C[6].V2=y2;
 // gore vdqsno
 C[7].U1=x1;C[7].U2=x2;C[7].V1=F[ru].ld.y;C[7].V2=F[ru].ld.y;
 C[8].U1=F[ru].ld.x;C[8].U2=F[ru].ld.x;C[8].V1=y1;C[8].V2=y2;

 sort(C+1,C+9,usl);

 for (int k=1;k<9;k++)
    if (tryC(C[k])&& ((x1<C[k].U1&&C[k].U1<x2) || (y1<C[k].V1&&C[k].V1<y2)) ) {
       cut Res;
       Res.U1=C[k].U1;
       Res.U2=C[k].U2;
       Res.V1=C[k].V1;
       Res.V2=C[k].V2;
       Res.A.x=x1;
       Res.A.y=y1;
       Res.B.x=x2;
       Res.B.y=y2;
       A.insert(Res);
       return; }
}

bool usl(const cut fst,const cut snd)
{
 if (fst.U1<snd.U1) return true;
 if (fst.U1>snd.U1) return false;
 return (fst.V1<snd.V1);
}

bool tryC(cut T)
{
 node G;
 G.x=T.U1;
 G.y=T.V1;
 if (T.U1==T.U2) {
   while (G.y<T.V2&&G.y>-maxC) {
        G.y=max(F[G].lu.y,F[G].ru.y);
        if (!G.y) G.y=-maxC; }
   return (G.y==T.V2); }
 while (G.x<T.U2&&G.x>-maxC) {
      G.x=max(F[G].rd.x,F[G].ru.x);
      if (!G.x) G.x=-maxC; }
 return (G.x==T.U2);
}

void proceed(cut T)
{
 cout<<T.U1-To<<' '<<T.V1-To<<' '<<T.U2-To<<' '<<T.V2-To<<endl;
 if (T.U1==T.U2) {
    solve(T.A.x,T.A.y,T.U1,T.B.y);
    solve(T.U1,T.A.y,T.B.x,T.B.y); } else {
    solve(T.A.x,T.A.y,T.B.x,T.V1);
    solve(T.A.x,T.V1,T.B.x,T.B.y); }
 A.erase(T);
}
