/*
TASK:burn
LANG:C++
*/

#include <cstdio>
#include <vector>
#include <cmath>
using namespace std;

#define N 128
#define M (1<<13)
int n,m;
vector <int> al[N];
vector <int> ae[N];
int edge[M][3];
int brn[N];
int mat[N][N];
double bst;

typedef unsigned int uint;

void readf()
{
    int i,j,l,k;
    scanf("%d %d",&n,&m);
    for(i=0; i<m; i++)
    {
	scanf("%d %d %d",&j,&l,&k);
	j--; l--;
	al[j].push_back(l);
	ae[j].push_back(k);
	al[l].push_back(j);
	ae[l].push_back(k);
	edge[i][0]=j;
	edge[i][1]=l;
	edge[i][2]=k;
    }
    for(i=0; i<n; i++)
	for(j=0; ((uint)j)<al[i].size(); j++)
	{
	    l=al[i][j];
	    k=ae[i][j]+ae[i].size();
	    if(!mat[i][l] || mat[i][l]>k) mat[i][l]=k;
	}
}

void floyd()
{
    int i,j,k;
    for(k=0; k<n; k++)
	for(i=0; i<n; i++)
	    for(j=0; j<n; j++)
		if(mat[i][k] && mat[k][j])
		    if(!mat[i][j] || mat[i][j]>mat[i][k]+mat[k][j])
			mat[i][j]=mat[i][k]+mat[k][j];
    for(i=0; i<n; i++)
	mat[i][i]=0;
}

void opt()
{
    double d,c,g;
    int i;
    g=0;
    for(i=0; i<n; i++) if(brn[i]>g) g=brn[i];
    for(i=0; i<m; i++)
    {
	d=brn[edge[i][0]] - brn[edge[i][1]];
	if(d<0) d= -d;
	if(d>edge[i][2])
	{
	    c=edge[i][2];
	}
	else
	{
	    c=d;
	    d=edge[i][2]-d;
	    c+=d/2;
	}
	if(brn[edge[i][0]]<brn[edge[i][1]]) c+=brn[edge[i][0]];
	else c+=brn[edge[i][1]];
	if(c>g) g=c;
    }
    if(g<bst || !bst) bst=g;
}

void d1()
{
    int i;
    for(i=0; i<n; i++)
	printf("%d ",brn[i]);
    printf("\n");
}

void solve()
{
    int i,j;
    for(i=0; i<n ;i++)
    {
	for(j=0; j<n; j++)
	    brn[j]=mat[i][j]+al[j].size();
	//d1();
	opt();
    }
}

int main()
{
    readf();
    floyd();
    solve();
    printf("%.1lf\n",bst);
    return 0;
}

