/*
FROM: 2005 k3
PROB: treas
KEYW: dynamical programming
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 10;

struct tr {
	int x, y, w;
};

int N;
tr vec[MAXN];
int w[MAXN];

inline int sq (int a) {return a * a;}

bool cmp (const tr &a, const tr &b) {
	return a.x + a.y < b.x + b.y;
}

int f (int d) {
	return d <= 0 ? 0 : ((d & 1 ? sq (d + 1) : d * (d + 2)) >> 2);
}

int opt[MAXN];

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d %d", &vec[i].x, &vec[i].y, &vec[i].w);
		++vec[i].y;
	}

	std::sort (vec, vec + N, cmp);

	for (i = 0; i < N; ++i) {
		opt[i] = vec[i].w - sq (vec[i].y - 1);
		for (j = 0; j < i; ++j)
			if (vec[j].x - vec[j].y >= vec[i].x - vec[i].y)
				opt[j] += vec[i].w;
			else
				opt[i] >?= opt[j] + vec[i].w + f (vec[j].x - vec[j].y - vec[i].x - vec[i].y + 1) - sq (vec[i].y - 1);
	}

	int best = 0;
	for (i = 0; i < N; ++i) best >?= opt[i];

	printf ("%d\n", best);

	return 0;
}
