/*
FROM: NOI 2005 ROUND 2 A
PROB: path
KEYW: coordinate compression, bfs
NOTE: the case with NO solution was not considered!!!! -> 2 tests down
*/

#include <cstdio>
#include <queue>
#include <utility>
#include <vector>
#include <algorithm>

using std::make_pair;

const int MAXK = 1 << 9;

int N0, M0;
int N, M, K;

std::vector <std::pair <std::pair <int, int>, std::pair <int, int> > > vec (MAXK);
std::vector <int> X;
std::vector <int> Y;

std::vector <std::vector <bool> > map;
std::vector <std::vector <bool> > used;
std::vector <std::vector <std::pair <int, int> > > prev;

double realx (int id) {
	return (X[id] + X[id+1]) / 2.0;
}

double realy (int id) {
	return (Y[id] + Y[id+1]) / 2.0;
}

void fill_map () {
	map.resize (X.size () - 1);
	int i;
	for (i = 0; i < (int)map.size (); ++i) map[i].resize (Y.size () - 1);


	int lbi, lbj, ubi, ubj;
	int ii, jj;
	for (i = 0; i < K; ++i) {
		lbi = std::lower_bound (X.begin (), X.end (), vec[i].first.first) - X.begin ();
		ubi = std::lower_bound (X.begin (), X.end (), vec[i].second.first) - X.begin ();

		lbj = std::lower_bound (Y.begin (), Y.end (), vec[i].first.second) - Y.begin ();
		ubj = std::lower_bound (Y.begin (), Y.end (), vec[i].second.second) - Y.begin ();

//		printf ("%d %d  %d %d\n", lbi, lbj, ubi, ubj);
		for (ii = lbi; ii < ubi; ++ii)
			for (jj = lbj; jj < ubj; ++jj)
				map[ii][jj] = 1;
	}
/*
	for (jj = (int)map[0].size () - 1; jj >= 0; --jj) {
		for (ii = 0; ii < (int)map.size (); ++ii)
			printf ("%d ", (int)map[ii][jj]);
		printf ("\n");
	}
*/
}

int main () {
	scanf ("%d %d %d", &N0, &M0, &K);

	int i, j;
	X.push_back (0); X.push_back (N0);
	Y.push_back (0); Y.push_back (M0);
	for (i = 0; i < K; ++i) {
		scanf ("%d %d %d %d", &vec[i].first.first, &vec[i].first.second, &vec[i].second.first, &vec[i].second.second);
		X.push_back (vec[i].first.first);
		X.push_back (vec[i].second.first);
		Y.push_back (vec[i].first.second);
		Y.push_back (vec[i].second.second);
	}
	std::sort (X.begin (), X.end ());
	std::sort (Y.begin (), Y.end ());

	X.resize (std::unique (X.begin (), X.end ()) - X.begin ());
	Y.resize (std::unique (Y.begin (), Y.end ()) - Y.begin ());

//	for (i = 0; i < (int)X.size (); ++i) printf ("%d ", X[i]); printf ("\n");
//	for (i = 0; i < (int)Y.size (); ++i) printf ("%d ", Y[i]); printf ("\n");

	fill_map ();
	used.resize (map.size ());
	prev.resize (map.size ());
	for (i = 0; i < (int)map.size (); ++i) used[i].resize (map[0].size ()), prev[i].resize (map[0].size ());

	std::vector <std::pair <int, int> > queue (MAXK * MAXK * 4);
//	printf ("uha!\n");

	int p1 = 0, p2, p3 = 0, lvl = 1;
	for (i = 0; i < (int)map.size () && !map[i][0]; ++i) {
		queue[p3++] = make_pair (i, 0);
		used[i][0] = 1;
		prev[i][0] = make_pair (-1, -1);
	}
	for (j = 1; j < (int)map[0].size () && !map[0][j]; ++j) {
		queue[p3++] = make_pair (0, j);
		used[0][j] = 1;
		prev[0][j] = make_pair (-1, -1);
	}

	p2 = p3;
	std::pair <int, int> crnt;
	while (p1 != p2) {
		for (i = p1; i < p2; ++i) {
			crnt = queue[i];
//			printf ("in %d %d (%d)\n", crnt.first, crnt.second, lvl);
			if (crnt.first == (int)map.size () - 1 && crnt.second == (int)map[0].size () - 1) goto end;

			for (j = crnt.first; j < (int)map.size () && !map[j][crnt.second]; ++j)
				if (!used[j][crnt.second]) {
					used[j][crnt.second] = 1;
					queue[p3++] = make_pair (j, crnt.second);
					prev[j][crnt.second] = crnt;
				}
//			printf ("uha2.0\n");

			for (j = crnt.first; j >= 0 && !map[j][crnt.second]; --j)
				if (!used[j][crnt.second]) {
					used[j][crnt.second] = 1;
					queue[p3++] = make_pair (j, crnt.second);
					prev[j][crnt.second] = crnt;
				}
//			printf ("uha2.1\n");

			for (j = crnt.second; j < (int)map[0].size () && !map[crnt.first][j]; ++j)
				if (!used[crnt.first][j]) {
					used[crnt.first][j] = 1;
					queue[p3++] = make_pair (crnt.first, j);
					prev[crnt.first][j] = crnt;
				}
//			printf ("uha2.2\n");

			for (j = crnt.second; j >= 0 && !map[crnt.first][j]; --j)
				if (!used[crnt.first][j]) {
					used[crnt.first][j] = 1;
					queue[p3++] = make_pair (crnt.first, j);
					prev[crnt.first][j] = crnt;
				}
//			printf ("uha2.3\n");
		}
		p1 = p2;
		p2 = p3;
		++lvl;
	}
//	printf ("%d\n", lvl);
//no solution
	printf ("-1\n");
	return 0;

	end:;
	std::vector <std::pair <double, double> > ans;

	crnt = prev[crnt.first][crnt.second];
	while (crnt != make_pair (-1, -1)) {
//		printf ("%d %d (%lf %lf)\n", crnt.first, crnt.second, realx (crnt.first), realy (crnt.second));
		ans.push_back (make_pair (realx (crnt.first), realy (crnt.second)));
		crnt = prev[crnt.first][crnt.second];
	}
	std::reverse (ans.begin (), ans.end ());
	printf ("%u\n", ans.size ());
	for (i = 0; i < (int)ans.size (); ++i)
		printf ("%.2lf %.2lf\n", ans[i].first, ans[i].second);

	return 0;
}
