#include <fstream>
using namespace std;

const int M = 9; // number of rows
const int N =20; // max number of columns
const int COL_MAX = (1<<M)-1; // = 111111111(2)

int Col[N]; // columns as binary numbers
int Row[M]; // rows as binary numbers
/* Up to equivalence we are looking for
   matrices such that Col[0]<Col[1]<...<Col[n]
   and Row[0]<Row[1]<...<Row[M-1]
*/

int nMax=9; // A trivial solution with 9 columns is known.

ofstream cout("mat.txt");

void makeRows(int n)
{ for(int i=0; i<M; i++)
  { Row[i]=0;
    for(int j=0; j<=n; j++)
    { Row[i] <<= 1;  // shift left
      if(Col[j] & (1<<(M-1-i))) Row[i] += 1;
    }
  }
}

bool okSort(int n)
{ for(int i=0; i<M-1; i++)
    if(Row[i]>Row[i+1]) return 0;
  return 1;
}

bool okCode(int n)
{ int p,q,u;
  for(p=0; p<=n-2; p++)
    for(q=p+1; q<=n-1; q++)
    { if(( Col[p] & ~Col[q] & ~Col[n])==0) return 0;
      if((~Col[p] &  Col[q] & ~Col[n])==0) return 0;
      if((~Col[p] & ~Col[q] &  Col[n])==0) return 0;
    }
  return 1;
}

void showCode(int n)
{ cout << "n = " << n+1 << endl;
  for(int i=0; i<M; i++)
  { for(int j=0; j<=n; j++)
      if (Row[i] & (1<<(n-j))) cout << "1 ";
      else cout << "0 ";
    cout << endl;
  }
}

void genCol(int n)
{ for(int x=Col[n-1]+1; x<=COL_MAX; x++)
    { Col[n]=x;
      makeRows(n);
      if(okSort(n) && okCode(n))
      { if(n+1>nMax)
        { nMax=n+1; showCode(n); }
        genCol(n+1);
      }
    }
}

void main()
{ for(int w=1; w<=M; w++)
  { Col[0]=(1<<w)-1; // = 00...011..1 with M-w 0's and w 1's
    genCol(1);
  }
//  cout << "Press Enter..."; cin.get();
}



