/*
FROM: NOI 2005 ROUND 2 A
PROB: mat
KEYW: full exhaustion with optimizations, Kapralov
*/

#include <cstdio>

const int MAXN = 50;
const int MAXDIG = 1 << 9;

int a[MAXN];

int best = 9;
int ba[MAXN];


void save (int pos) {
	printf ("N = %d\n", pos);
	for (int i = 8; i >= 0; --i) {
		for (int j = 0; j < pos; ++j)
			printf ("%d ", !!(a[j] & (1 << i)));
		printf ("\n");
	}
	printf ("**************\n");
}

bool is_sort (int pos) {
	int row[MAXN] = {0};

	int i, j;
	for (i = 0; i < 9; ++i)
		for (j = 0; j < pos; ++j)
			row[i] |= (!!(a[j] & (1 << (8 - i)))) << (pos -1 - j);

	for (i = 1; i < 9; ++i)
		if (row[i] < row[i - 1]) break;

//	for (i = 0; i < 9; ++i) printf ("%d ", row[i]); printf ("\n");
//	save (pos);
//	getchar ();

	return i == 9;
}

bool check (int pos) {
	if (pos < 3)
		return 1;//there are not enough columns to perform check

	bool f1, f2, f3;
	for (int i = 0; i < pos; ++i)
		for (int j = i+1; j < pos; ++j) {
			f1 = f2 = f3 = 0;
			for (int k = 0; k < 9; ++k) {
				if ( (a[i] & (1 << k))  && !(a[j] & (1 << k)) && !(a[pos] & (1 << k)))
					f1 = 1;
				if (!(a[i] & (1 << k))  &&  (a[j] & (1 << k)) && !(a[pos] & (1 << k)))
					f2 = 1;
				if (!(a[i] & (1 << k))  && !(a[j] & (1 << k)) &&  (a[pos] & (1 << k)))
					f3 = 1;
			}
			if (!(f1 && f2 && f3)) {
//				printf ("failed on %d %d %d:\n", i, j, pos);
//				save (pos + 1);
//				getchar ();
				return 0;
			}
		}

	return 1;
}

void bt (int pos) {
//	save (pos);
//	getchar ();

	if (pos > best) {
		save (pos);
		best = pos;
	}

	for (int i = a[pos - 1] + 1; i < MAXDIG; ++i) {
		a[pos] = i;
		if (is_sort (pos + 1) && check (pos)) {
//			printf ("with i == %d because prev was %d\n", i, a[pos-1]);
			bt (pos + 1);
		}
	}

}

int main () {
	for (int i = 1; i < MAXDIG; ++i) {
		a[0] = i;
		bt (1);
	}

	return 0;
}
