/*
FROM: NOI2 2006 ROUND 2 A
PROB: meet
KEYW: LCA, RMQ (Least Common Ancestor, Range Minimum query)
*/

#include <cstdio>
#include <vector>

const int MAXn = 1 << 17;
const int MAXN = 1 << 18;

//BEGIN GRAPH REPRESENTATION
int n, m;
int prev[MAXn];
int vec[MAXn][2];
int vecs[MAXn];
//END GRAPH REPRESENTATION

//BEGIN RMQ STUCTURE
int N;
int E[MAXN];
int L[MAXN];
int R[MAXn];

std::vector <std::vector <int> > M;//precomputed array
//END RMQ STRUCTURE

void euler (int a) {
	static int p = 0;
	static bool used[MAXn] = {0};
	static int h = 0;

	E[p] = a;
	L[p] = h;
	if (!used[a]) {
		used[a] = 1;
		R[a] = p;
	}
	++p;
	++h;
	for (int i = 0; i < vecs[a]; ++i) {
		euler (vec[a][i]);
		E[p] = a;
		L[p++] = h-1;
	}
	--h;
}

void build_RMQ () {
	euler (0);
	N = 2 * n - 1;
/*
	for (int i = 0; i < N; ++i) printf ("%d\t", E[i]); printf ("\n");
	for (int i = 0; i < N; ++i) printf ("%d\t", L[i]); printf ("\n");
	for (int i = 0; i < n; ++i) printf ("%d ", R[i]); printf ("\n");
*/
}

inline int mylog (int a) {
	static int i;
	for (i = 0; (1 << i) < a; ++i);
	return i - 1;
}

int RMQ_query (int u, int v) {
	printf ("%d %d -- ", u, v);
	u = R[u];
	v = R[v];
	printf ("%d %d\n", u, v);

	if (u > v) u ^= v ^= u ^= v;
	int j = mylog (v - u + 1);

	printf ("log == %d\n", j);
	printf ("cells [%d][%d] [%d][%d]\n", u, j, v - (1 << j) + 1, j);
	return (L[M[u][j]] < L[M[v - (1 << j) + 1][j]] ?
			E[M[u][j]] : E[M[v - (1 << j) + 1][j]]);
}

void RMQ_pre () {
	int i, j;
	int j2, j22;
	M.resize (N);
	for (i = 0; i < N; ++i) M[i].push_back (i);
	for (j = 1; (j22 = (1 << (j - 1))), (j2 = j22 << 1) < N; ++j) {
		for (i = 0; i + j2 <= N; ++i)
			M[i].push_back (L[M[i][j - 1]] < L[M[i + j22][j - 1]] ?
							  M[i][j - 1]  :   M[i + j22][j - 1]);
	}
	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (j = 0; j < (int)M[i].size (); ++j)
			printf (" %d(%d)", M[i][j], L[M[i][j]]);
		printf ("\n");
	}
}

int main () {
	scanf ("%d %d", &n, &m);

	int i;
	int tmp;
	for (i = 1; i <= n; ++i) {
		scanf ("%d", &tmp);

		prev[i] = tmp;
		vec[tmp][vecs[tmp]++] = i;
	}
/*
	int j;
	for (i = 0; i <= n; ++i) {
		printf ("%d ->", i);
		for (j = 0; j < vecs[i]; ++j)
			printf (" %d", vec[i][j]);
		printf ("\n");
	}
*/
	++n;
	build_RMQ ();
	RMQ_pre ();

	int a, b;
	for (i = 0; i < m; ++i) {
		scanf ("%d %d", &a, &b);
		printf ("%d\n", RMQ_query (a, b));
	}

	return 0;
}
