/*
FROM: NOI 2006 round 3 day 2
PROB: sym
KEYW: conveh hull, symetry, computational geometry
*/

#include <cstdio>
#include <cstdlib>//exit (int)
#include <algorithm>//sort
#include <ext/numeric>//__gnu_cxx::iota

#warning multiply by 2
#warning wathc out the indexes

const int MAXN = 1 << 14;

struct pnt {
	int x, y;
	pnt () {}
	pnt (int _x, int _y) : x (_x), y (_y) {}
	pnt operator - (const pnt &a) const {return pnt (x - a.x, y - a.y);}
	pnt operator + (const pnt &a) const {return pnt (x + a.x, y + a.y);}
	pnt mid () const {return pnt (x / 2, y / 2);}
	pnt say_op (const pnt &a, const pnt &b) const ;
	bool operator == (const pnt &a) const {return x == a.x && y == a.y;}
	bool operator != (const pnt &a) const {return x != a.x || y != a.y;}
	bool operator < (const pnt &a) const {return x != a.x ? x < a.x : y < a.y;}
	int sq () const {return x * x + y * y;}
};

int S (const pnt &a, const pnt &b, const pnt &c) {
	return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

pnt NONE (30000, 30000);//invalid point
pnt pnt::say_op (const pnt &a, const pnt &b) const {
//	printf ("(%d, %d) (%d, %d) -- %d %d --> ", a.x, a.y, b.x, b.y, x, y);
	long long l = (a - b).sq ();
	long long dx = -(a - b).y;
	long long dy = (a - b).x;
	long long S4 = S (a, b, *this) * 2ll;//S () returns the area * 2
	dx *= S4; dy *= S4;
	if (dx % l || dy % l) {
//		printf ("NONE!\n");
		return NONE;
	} else {
//		printf ("%Ld %Ld\n", x + dx / l, y + dy / l);
		return pnt (int (x + dx / l), int (y + dy / l));
	}
}

int N;
pnt vec[MAXN];
int op[MAXN];//opposite

int hid[MAXN], hsz;//hull id, hull size

bool cmp (int a, int b) {
	static int tmp;
	return (tmp = S (vec[hid[0]], vec[a], vec[b]))
			? tmp > 0
			: (vec[a] - vec[hid[0]]).sq () < (vec[b] - vec[hid[0]]).sq ();
}

int idx[MAXN];
bool cmp2 (int a, int b) {return vec[a] < vec[b];}
void try_make (const pnt &a, const pnt &b) {
//	printf ("(%d, %d) (%d, %d)\n", a.x, a.y, b.x, b.y);
	static int pos;
	memset (op, -1, sizeof (op));//no one has an oposite at the begining
	for (int i = 0; i < N; ++i) {
		if (op[idx[i]] != -1) continue;
		pnt other = vec[idx[i]].say_op (a, b);
		if (other == NONE) return;//this point DOESN'T have an oposite point with integer coordinates -> there is no solution
		vec[N] = other;
		if (vec[idx[pos = (std::lower_bound (idx, idx + N, N, cmp2) - idx)]] == other && pos != N) {
//			printf ("oposite id is %d\n", idx[pos]);
			op[idx[i]] = idx[pos];
			op[idx[pos]] = idx[i];
		} else {
//			printf ("pos was == %d\n", pos);
			return;//point not found
		}
	}
	printf ("%d", op[0] + 1);
	for (int i = 1; i < N; ++i) printf (" %d", op[i] + 1);
	puts ("");
	exit (0);
}

void make_hull () {
	int i;
	int spi = 0;//starting point index
	for (i = 1; i < N; ++i)
		if (vec[i].y <  vec[spi].y
		 || vec[i].y == vec[spi].y
		 && vec[i].x > vec[spi].x)
			spi = i;

	__gnu_cxx::iota (hid, hid + N, 0);
	hid[0] = spi;
	hid[spi] = 0;
	std::sort (hid + 1, hid + N, cmp);

	for (i = hsz = 2; i < N; ++i) {
		while (hsz > 1 && S (vec[hid[hsz-2]], vec[hid[hsz-1]], vec[hid[i]]) <= 0) --hsz;
		hid[hsz++] = hid[i];
	}
//	for (i = 0; i < hsz; ++i) printf ("%d %d\n", vec[hid[i]].x, vec[hid[i]].y);
}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &vec[i].x, &vec[i].y);
		vec[i].x *= 2;
		vec[i].y *= 2;
	}

	make_hull ();

	if (hsz <= 2) {//there is only one point (hsz == 1) or all points lie on a single line -> every points is reflected to itself
		printf ("1");
		for (i = 2; i <= N; ++i)
			printf (" %d", i);
		puts ("");
		return 0;
	}

	hid[hsz] = hid[0];
	__gnu_cxx::iota (idx, idx + N + 1, 0);//idx[N] == N -> use this
	std::sort (idx, idx + N, cmp2);
	if (hsz & 1) {//odd
		int half = hsz / 2;
		for (i = 0; i < half; ++i) {
			try_make (vec[hid[i]], (vec[hid[i+half]] + vec[hid[i+half+1]]).mid ());
			try_make ((vec[hid[i]] + vec[hid[i+1]]).mid (), vec[hid[i+half+1]]);
		}
		try_make (vec[hid[half]], (vec[hid[hsz-1]] + vec[hid[0]]).mid ());
	} else {//even
		int half = hsz / 2;
		for (i = 0; i < half; ++i) {
			try_make (vec[hid[i]], vec[hid[i+half]]);
			try_make ((vec[hid[i     ]] + vec[hid[i     +1]]).mid ()
					, (vec[hid[i+half]] + vec[hid[i+half+1]]).mid ());
		}
	}

	printf ("0\n");//no solution found

	return 0;
}
