/*
FROM: NOI 2006 round 3
PROB: water
KEYW: brute force
*/

#include <cstdio>
#include <cstring>
#include <algorithm>

const int MAXV = 1 << 8;
const int MAXN = MAXV * MAXV;
const int MAXMOVE = 1 << 5;

int K, V;
int d[3][4];

void input () {
	scanf ("%d %d", &V, &K);
	for (int i = 0; i < 3; ++i) {
		for (int j = 1; j < 3; ++j)
			scanf ("%d", &d[i][j]);
		d[i][3] = V;
	}
}

int code (int a, int b) {
	return a * (V + 1) + b;
}

void fill_t (int T[3][4], int b[3]) {
	static int i, j;
	for (i = 0; i < 3; ++i)
		for (j = 0; j < 4; ++j)
			T[i][j] = d[i][j] - b[i];
}

int vec[MAXN][MAXMOVE];
int vp[MAXN];
bool isfinal[MAXN];
int fin[MAXN];

void remove_final () {
	for (int i = 0; i < MAXN; ++i)
		for (int j = 0; j < vp[i]; ++j)
			if (isfinal[vec[i][j]]) {
				++fin[i];
				vec[i][j] = vec[i][--vp[i]];
			}
}

void build_graph () {
	int i, j, k;
	int T[3][4];
	int b[3], bb[3];
	int toput[24], tpp;
	int ci;
	for (b[0] = 0; b[0] <= V; ++b[0])
		for (b[1] = 0; b[0] + b[1] <= V; ++b[1]) {
			b[2] = V - b[0] - b[1];
			ci = code (b[0], b[1]);
			fill_t (T, b);
			tpp = 0;
			for (i = 0; i < 3; ++i)
				for (j = i ? 0 : 1; j < 3; ++j == i ? ++j : 0)
					for (k = 0; k < 4; ++k) {
						memcpy (bb, b, sizeof (bb));
						if (T[j][0] <= -T[i][k] && -T[i][k] <= T[j][3]) {
							bb[i] += T[i][k];
							bb[j] -= T[i][k];
							toput[tpp++] = code (bb[0], bb[1]);
						}
					}
			std::sort (toput, toput + tpp);
			tpp = std::unique (toput, toput + tpp) - toput;
			isfinal[ci] = b[0] == 1 || b[1] == 1 || b[2] == 1;
			for (i = 0; i < tpp; ++i) {
				if (toput[i] == ci) continue;
				vec[ci][vp[ci]++] = toput[i];
			}
		}

	remove_final ();
}

int res = 0;
bool used[MAXN];

void bf (int el, int d) {
	if (used[el]) return;
	used[el] = 1;
	res += fin[el];
	if (d == K - 1) {used[el] = 0; return;}
	for (int i = 0; i < vp[el]; ++i)
		bf (vec[el][i], d + 1);

	used[el] = 0;
}

int main () {
	input ();
	build_graph ();
	bf (code (V, 0), 0);
	printf ("%d\n", res);

	return 0;
}
