/*
FROM: NOI 2006 round 3 B group
PROB: capital
KEYW: dijkstra with stl heap and push optimizations
*/

#include <cstdio>
#include <cstring>
#include <queue>

const int MAXN = 1 << 14;
const int MAXM = MAXN * 4;

struct el {
	int to;
	int dist;
	int next;
	el () {}
	el (int _to, int _dist, int _next) : to (_to), dist (_dist), next (_next) {}
};

int N, K;
int vec[MAXN];
el buf[MAXM];

unsigned d[MAXN];

int dijkstra () {
	static std::priority_queue <std::pair <int, int> > q;
	std::pair <int, int> c;
	memset (d, -1, sizeof (d));

	d[0] = 0;
	q.push (std::make_pair (0, 0));
	
	int pop_cnt = 0;
	while (!q.empty ()) {
		c = q.top (); q.pop ();

		c.first *= -1;
//		printf ("pop %d %d\n", c.first, c.second);
		if (d[c.second] < (unsigned)c.first) continue;//already popped
		if (c.first > K) return N - pop_cnt;
		++pop_cnt;
		for (int i = vec[c.second]; i != -1; i = buf[i].next) {
			if (d[buf[i].to] > (unsigned)(c.first + buf[i].dist)) {
				d[buf[i].to] = (unsigned)(c.first + buf[i].dist);
				q.push (std::make_pair (-(int)d[buf[i].to], buf[i].to));
			}
		}
	}
	return 0;
}

int main () {
	scanf ("%d%d", &N, &K);

	memset (vec, -1, sizeof (vec));
	int i, j;
	int a, b, d;
	int bp = 0;
	for (;;) {
		scanf ("%d %d %d", &a, &b, &d);
		if (!a && !b && !d) break;
		--a; --b;
		buf[bp] = el (b, d, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, d, vec[b]);
		vec[b] = bp++;
	}
/*
	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (j = vec[i]; j != -1; j = buf[j].next)
			printf (" (%d %d)", buf[j].to, buf[j].dist);
		printf ("\n");
	}
*/
	printf ("%d\n", dijkstra ());

	return 0;
}
