#include <cstdio>
#include <cmath>
#include <utility>
#include <climits>

#define x first
#define y second

const int MAXN = 1 << 11;
const int INF = INT_MAX;
const double EPS = 1e-6;

int N;
std::pair <int, int> pos[MAXN];
int ans[MAXN], ap;
bool used[MAXN];

int sq (int a) {
	return a * a;
}

int dst2 (int id1, int id2) {
	return sq (pos[id1].x - pos[id2].x) + sq (pos[id1].y - pos[id2].y);
}

double dst (int id1, int id2) {
	return hypot (pos[ans[id1]].x - pos[ans[id2]].x, pos[ans[id1]].y - pos[ans[id2]].y);
}

bool ts (int id) {
	return dst (id, id + 2) + dst (id + 1, id + 3) + EPS
		 < dst (id, id + 1) + dst (id + 2, id + 3);
}

bool ts2 (int id) {
	return dst (id, id + 3) + dst (id + 1, id + 4) + EPS
		 < dst (id, id + 1) + dst (id + 3, id + 4);
}

bool tr1 (int id) {
	return dst (id, id + 3) + dst (id + 3, id + 1) + dst (id + 2, id + 4) + EPS
		 < dst (id, id + 1) + dst (id + 2, id + 3) + dst (id + 3, id + 4);
}

bool tr2 (int id) {
	return dst (id, id + 2) + dst (id + 3, id + 1) + dst (id + 1, id + 4) + EPS
		 < dst (id, id + 1) + dst (id + 2, id + 3) + dst (id + 3, id + 4);
}

void s (int id) {
//	printf ("swap %d (%d %d)\n", id, ans[id], ans[id+1]);
	int tmp = ans[id];
	ans[id] = ans[id+1];
	ans[id+1] = tmp;
//	printf ("<<--swap %d (%d %d)\n", id, ans[id], ans[id+1]);
}

void s2 (int id) {
	int tmp = ans[id];
	ans[id] = ans[id+2];
	ans[id+2] = tmp;
}

void rot1 (int id) {
//	printf ("rot1 %d (%d %d %d)\n", id, ans[id], ans[id+1], ans[id+2]);
	int tmp = ans[id];
	ans[id] = ans[id+2];
	ans[id+2] = ans[id+1];
	ans[id+1] = tmp;
}

void rot2 (int id) {
//	printf ("ro2 %d (%d %d %d)\n", id, ans[id], ans[id+1], ans[id+2]);
	int tmp = ans[id];
	ans[id] = ans[id+1];
	ans[id+1] = ans[id+2];
	ans[id+2] = tmp;
}

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 1; i < N; ++i)
		scanf ("%d %d", &pos[i].x, &pos[i].y);

	int cmin, cmini;
	ans[ap++] = 0;
	int last = 0, tmp;
	for (i = 1; i < N; ++i) {
		cmin = INF; cmini = -1;
		for (j = 1; j < N; ++j)
			if (!used[j] && cmin > (tmp = dst2 (last, j))) {
				cmin = tmp;
				cmini = j;
			}

		used[last = cmini] = 1;
		ans[ap++] = last;
	}

	ans[ap] = 0;//the last from our journey
/*
	double sum = 0;
	for (i = 1; i <= ap; ++i)
		sum += dst (i-1, i);
	printf ("THE SUM --- %lf\n", sum);
*/
	for (int K = 0; K < 6; ++K) {
		//try to swap every 2 consecutive (O(N))
		for (i = 2; i < ap; ++i)
			if (ts (i-2)) s (i-1);

		//try to swap every two on positions (a; a +2)
		for (i = 3; i < ap; ++i)
			if (ts2 (i-3)) s2 (i-2);

		//try to rotate every 3 consecutive (O(N))
		for (i = 3; i < ap; ++i) {
			if (tr1 (i-3)) rot1 (i-2);
			if (tr2 (i-3)) rot2 (i-2);
		}

/*		sum = 0;
		for (i = 1; i <= ap; ++i)
			sum += dst (i-1, i);
		printf ("THE SUM --- %lf\n", sum);*/
	}

	printf ("1");
	for (i = 1; i < ap; ++i)
		printf (" %d", ans[i] + 1);
	printf ("\n");

	return 0;
}
