/*
FROM: NOI 2007 k2
PROB: tour
KEYW: tree, divide and conquer
*/

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <ext/numeric>

const int MAXN = 1 << 18;
const int INF = 1 << 29;

struct el {
	int to;
	int cost;
	int next;
	el () {}
	el (int _to, int _cost, int _next) : to (_to), cost (_cost), next (_next) {}
};

struct q_el {
	int to, cost, bad;
	q_el () {}
	q_el (int _to, int _cost, int _bad) : to (_to), cost (_cost), bad (_bad) {}
};

int N, K, B;
int vec[MAXN];
el buf[MAXN * 2];

bool bad[MAXN];
int ans = -INF;
int used[MAXN];

std::vector <std::vector <int> > all_vec;
std::vector <int> *cvec;

int Kx;
void upd_bfs (int v, int first_edge_cost, int u_id) {
//	printf ("upd_bfs %d %d %d\n", v, first_edge_cost, u_id);
	static q_el q[MAXN], c;
	int p3, i, j;
	q[p3 = 0, p3++] = q_el (v, first_edge_cost, bad[v]);
	used[v] = u_id;
	for (i = 0; i < p3; ++i) {
//		printf ("popped %d %d %d\n", q[i].to, q[i].cost, q[i].bad);
		if (q[i].bad <= Kx) {
			if ((int)cvec->size () <= q[i].bad)
				cvec->resize (q[i].bad + 1, -INF);
			cvec->at (q[i].bad) >?= q[i].cost;
		}

		for (j = vec[q[i].to]; j != -1; j = buf[j].next)
			if (used[buf[j].to] != u_id) {
				used[buf[j].to] = u_id;
				q[p3++] = q_el (buf[j].to, buf[j].cost + q[i].cost, q[i].bad + bad[buf[j].to]);
			}
	}
}

void repair_vec (std::vector <int> &x, size_t _start_pos = 1) {
	for (size_t i = _start_pos; i < x.size (); ++i)
		x[i] >?= x[i-1];
}

void upd_ans (const std::vector <int> &n, const std::vector <int> &o) {
	static size_t i;
	if (Kx - o.size () + 1 >= n.size ()) {
//		printf ("update with ends : %d\n", n.back () + o.back ());
		ans >?= n.back () + o.back ();
		return;
	}
	for (i = Kx - o.size () + 1; i < n.size (); ++i) {
//		printf ("norm upd %d(%d) + %d(%lu)\n", n[i], i, o[Kx-i], Kx-i);
		ans >?= n[i] + o[Kx-i];
	}
}

void upd_vec (std::vector <int> &n, const std::vector <int> &o) {
	static size_t i;
	for (i = 0; i < o.size (); ++i)
		n[i] >?= o[i];
	repair_vec (n, o.size ());
}

bool cmp (int a, int b) {return all_vec[a].size () < all_vec[b].size ();}

void _solve (int v) {
//	printf ("_solve %d\n", v);
	static int idx[MAXN];
	static int u_id, i;

	used[v] = ++u_id;
	int kk = 0;
//	if (vec[v] == -1) return;//there are no children
	Kx = K - bad[v];
	for (i = vec[v]; i != -1; i = buf[i].next) {
		++kk;
		all_vec.push_back (std::vector <int> ());
		cvec = &all_vec.back ();
		upd_bfs (buf[i].to, buf[i].cost, u_id);
	}
	__gnu_cxx::iota (idx, idx + kk, 0);
	std::sort (idx, idx + kk, cmp);
/*
	for (size_t i = 0; i < all_vec.size (); ++i) {
		for (size_t j = 0; j < all_vec[idx[i]].size (); ++j)
			printf (" %d", all_vec[idx[i]][j]);
		puts ("");
	}
*/
	repair_vec (all_vec[idx[0]]);
	for (i = 1; i < kk; ++i) {
		repair_vec (all_vec[idx[i]]);
		upd_ans (all_vec[idx[i]], all_vec[idx[i-1]]);
		upd_vec (all_vec[idx[i]], all_vec[idx[i-1]]);
	}

	ans >?= all_vec[idx[kk - 1]].back ();
	all_vec.clear ();
}

int _q[MAXN], _d[MAXN], _p3, _prev[MAXN];
int bfs (int v) {
	static int u_id;
	_d[v] = 0;
	used[v] = --u_id;
	_q[_p3 = 0, _p3++] = v;
	int ans;
	for (int i = 0; i < _p3; ++i) {
		ans = _d[_q[i]];
//		printf ("popped bfs %d(%d)\n", _q[i], _p3);
		for (int j = vec[_q[i]]; j != -1; j = buf[j].next) {
			if (used[buf[j].to] != u_id) {
//				printf ("\tpush bfs %d\n", buf[j].to);
				used[buf[j].to] = u_id;
				_d[buf[j].to] = _d[_q[i]] + 1;
				_prev[buf[j].to] = _q[i];
				_q[_p3++] = buf[j].to;
			}
		}
	}
	return ans;
}

void prnt_graph () {
	for (int i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (int j = vec[i]; j != -1; j = buf[j].next)
			printf (" (%d %d (%d))", buf[j].to, buf[j].cost, j);
		puts ("");
	}
	puts ("----");
}

void solve (int v) {
//	printf ("really solve %d\n", v);
	if (vec[v] == -1) return;
	bfs (v);
//	printf ("solve %d --> %d", v, _q[_p3-1]);
	int diam = bfs (_q[_p3-1]);
	int i, j = _q[_p3-1];
	for (i = 0; i < diam / 2; ++i)
		j = _prev[j];
	int root = j;
//	printf ("(diam %d) %d\n", diam, root);
	_solve (root);
//	printf ("__ _solve %d completed\n", root);
	for (i = vec[root]; i != -1; i = buf[i].next) {
//		printf ("we SHOULD call solve %d sometime\n", buf[i].to);
		if (buf[vec[buf[i].to]].to == root) {
//			printf ("erasing the first edge! (%d)\n", vec[buf[i].to]);
			vec[buf[i].to] = buf[vec[buf[i].to]].next;
//			prnt_graph ();
			goto after_for;
		}
		for (j = vec[buf[i].to]; j != -1; j = buf[j].next)
			if (buf[buf[j].next].to == root) {
//				printf ("erasing edge %d\n", buf[j].next);
//				prnt_graph ();
				buf[j].next = buf[buf[j].next].next;
				goto after_for;
			}
		after_for:;
//		printf ("we call solve (%d)\n", buf[i].to);
		solve (buf[i].to);
	}
}

int main () {
	scanf ("%d %d %d", &N, &K, &B);
	
	int i;
	int a, b, c, bp = 0;
	for (i = 0; i < B; ++i) {
		scanf ("%d", &a);
		bad[--a] = 1;
	}

	memset (vec, -1, sizeof (vec));
	for (i = 1; i < N; ++i) {
		scanf ("%d %d %d", &a, &b, &c);
		--a; --b;
		buf[bp] = el (b, c, vec[a]);
		vec[a] = bp++;
		buf[bp] = el (a, c, vec[b]);
		vec[b] = bp++;
	}
//	prnt_graph ();
	solve (0);

	printf ("%d\n", ans);

	return 0;
}
