#include <cstdio>
#include <cassert>

struct pnt {
	double x;
	double y;
	pnt () {}
	pnt (double _x, double _y) : x (_x), y (_y) {}
	pnt operator + (const pnt &a) {return pnt (x + a.x, y + a.y);}
	pnt operator - (const pnt &a) {return pnt (x - a.x, y - a.y);}
	pnt operator * (double a) {return pnt (x * a, y * a);}
};

double S (const pnt &a, const pnt &b, const pnt &c) {
	return ((b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x)) / 2.;
}

pnt _p, _q;
pnt intersect (const pnt &a, const pnt &b) {
	static double s1, s2, t;
	s1 = S (_p, a, b);
	s2 = S (b, a, _q);
	assert (s1 + s2);
	t = s1 / (s1 + s2);
	return (_q - _p) * t + _p;
}

int C;
pnt beg, prev, crnt, ci;
bool down = 0;
double cs = 0, overalls = 0;
void work (int x, int y) {
//	printf ("word %d %d :", x, y);
	crnt = pnt (x, y);
	if (down && y > C) {//go up
		ci = intersect (prev, crnt);
//		printf ("point %d %d --> go up, inter : %lf %lf", x, y, ci.x, ci.y);
		cs += prev.x * ci.y - prev.y * ci.x;
		cs += ci.x * beg.y - ci.y * beg.x;
//		printf ("<< %lf - %lf || %lf - %lf (%lf %lf) >> __%lf_%lf__%lf_%lf__",\
		prev.x * ci.y, prev.y * ci.x, ci.x * beg.y, ci.y * beg.x,\
		prev.x * ci.y - prev.y * ci.x, ci.x * beg.y - ci.y * beg.x,\
		beg.x, beg.y, ci.x, ci.y);
		down = 0;//we are up now
//		printf ("(added %lf)", cs);
		overalls += cs;
		cs = 0;
	} else if (!down && y <= C) {//go down
		beg = intersect (prev, crnt);
//		printf ("point %d %d --> go down, inter : %lf %lf", x, y, beg.x, beg.y);
		assert (cs == 0);
		cs += beg.x * crnt.y - beg.y * crnt.x;
		down = 1;
	} else if (down) {//stay down
		cs += prev.x * crnt.y - prev.y * crnt.x;
//		printf ("calculating %lf * %lf - %lf * %lf == %lf - %lf == %lf", \
		prev.x, crnt.y, prev.y, crnt.x,\
		prev.x * crnt.y, prev.y * crnt.x,\
		prev.x * crnt.y - prev.y * crnt.x);
	}
	prev = crnt;//no matter we are up or down
//	printf ("\n");
}

int main () {
	int N;
	scanf ("%d %d", &N, &C);
	_p = pnt (-1000001, C);
	_q = pnt ( 1000001, C);


	int x, y;

	scanf ("%d %d", &x, &y);
	prev = pnt (x, C+1);
	work (x, y);
	for (int i = 0; i < N; ++i) {//there are N+1 points
		scanf ("%d %d", &x, &y);
		work (x, y);
	}
	work (x, C+1);//the old x
	printf ("%.4lf\n", overalls / 2.);

	return 0;
}
