#include<cstdio>
#include<vector>

#define MAXN 262144

using namespace std;

int k, res;
vector< pair<int, int> > ans[MAXN];
char bad[MAXN], u[MAXN];

int count(int v)
{
	int size = 1;
	u[v] = 1;
	for(unsigned int i = 0; i < ans[v].size(); i++)
	{
		if(!u[ans[v][i].first])
		{
			u[ans[v][i].first] = 1;
			size += count(ans[v][i].first);
		}
	}
	return size;
}

void dfs(int v, int s, int value)
{
	u[v] = 1;
	if(bad[v]) s++;
	if(s > k) return;
	if(value > res) res = value;
	for(unsigned int i = 0; i < ans[v].size(); i++)
	{
		if(!u[ans[v][i].first])
		{
			u[ans[v][i].first] = 1;
			dfs(ans[v][i].first, s, value + ans[v][i].second);
		}
	}
}

int main()
{
	int n, m, t, l, r, c;
	scanf("%d%d%d", &n, &k, &m);
	for(int i = 0; i < m; i++)
	{
		if(scanf("%d", &t) == -1) printf("Input too short!\n");
		if(t <= 0 || t > n || bad[t - 1]) printf("Out of range or a special vertex repeated!\n");
		bad[t - 1] = 1;
	}
	for(int i = 0; i < n - 1; i++)
	{
		if(scanf("%d %d %d", &l, &r, &c) == -1) printf("Input too short!\n");
		if(l <= 0 || l > n || r <= 0 || r > n) printf("Out of range!\n");
		ans[l - 1].push_back(make_pair(r - 1, c));
		ans[r - 1].push_back(make_pair(l - 1, c));
	}
	if(scanf("%d", &l) != -1) printf("Input too long!\n");
	if(count(0) != n) printf("Not a tree!\n");
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < n; j++) u[j] = 0;
		dfs(i, 0, 0);
		if(i % 1000 == 0) printf("%d\n", i);
	}
	printf("------------------------------\n");
	printf("%d\n", res);
	return 0;
}
