/*
FROM: SPRING 2001 A
PROB: enemy
KEYW: full exhaustion, backtracking
*/

#include <cstdio>
#include <cstdlib>

#include <algorithm>

const int MAXN = 1 << 4;
const int MAXM = 1 << 4;
const int MAX = MAXN * MAXM;

int N, M, K;
int rN;
bool ma3x[MAX][MAX];
int in[MAX];
int pma3x[MAX][MAX][MAX];
int pmc[MAX][MAX];

int tma3x[MAXN][MAXM];

bool cmp (int a, int b) {
	return in[a] < in[b];
}

void prnt () {
	for (int i = 1; i <= N; ++i) {
		printf ("%d", tma3x[i][1] + 1);
		for (int j = 2; j <= M; ++j)
			printf (" %d", tma3x[i][j] + 1);
		printf ("\n");
	}
	exit (0);
}

int used[MAX];
void rec (int x, int y) {
	if (x == N + 1) prnt ();
	int a = tma3x[x-1][y], b = tma3x[x][y-1];

	for (int i = 0; i < pmc[a][b]; ++i)
		if (!used[pma3x[a][b][i]]) {
			used[pma3x[a][b][i]] = 1;
			tma3x[x][y] = pma3x[a][b][i];
			rec (x + (y == M), y % M + 1);
			used[pma3x[a][b][i]] = 0;
	}
}

int main () {
	scanf ("%d %d %d", &N, &M, &K);
	rN = M * N;

	int i, j, k;
	int a, b, c;
	for (i = 0; i < K; ++i) {
		scanf ("%d %d", &a, &b);
		--a;
		for (j = 0; j < b; ++j) {
			scanf ("%d", &c);
			--c;
			ma3x[a][c] = ma3x[c][a] = 1;
			++in[a];
			++in[c];
		}
	}

	for (i = 0; i < rN; ++i)
		for (j = 0; j < rN; ++j)
			ma3x[i][j] = !ma3x[i][j];
	for (i = 0; i < rN; ++i) {ma3x[i][i] = 0; in[i] = rN - in[i];}
	for (i = 0; i < rN; ++i) ma3x[rN][i] = 1;//friend with everyone
	in[rN] = rN;

	for (i = 0; i <= rN; ++i)
		for (j = 0; j <= rN; ++j) {
			for (k = 0; k <= rN; ++k)
				if (ma3x[i][k] && ma3x[j][k]) pma3x[i][j][pmc[i][j]++] = k;
			std::sort (&pma3x[i][j][0], &pma3x[i][j][pmc[i][j]], cmp);
		}

	for (i = 0; i <= N; ++i) ma3x[i][0] = rN;
	for (i = 1; i <= M; ++i) ma3x[0][i] = rN;

	rec (1, 1);
	printf ("0\n");

	return 0;
}
