/*
FROM: SPRING 2002 A
PROB: selo
KEYW: triangulation
*/

#include <cstdio>
#include <cmath>
#include <queue>

const int MAXN = 1 << 10;

struct point {
	int x, y;
	point () {}
	point (int _x, int _y) : x (_x), y (_y) {}
	point (const point &a) : x (a.x), y (a.y) {}
	point& operator -= (const point &a) {x -= a.x; y -= a.y; return *this;}
	point operator - (const point &a) const {point ret (*this); ret -= a; return ret;}
	int operator * (const point &a) const {return x * a.x + y * a.y;}
	int sq () const {return (*this) * (*this);}
	double len () const {return sqrt (x * x + y * y);}
};

struct tri {
	int a, b, c;
	tri () {}
	tri (int _a, int _b, int _c) : a (_a), b (_b), c (_c) {}
};

inline int _S2 (const point &a, const point &b, const point &c) {
	return ((b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x));
}
/*
inline double S (const point &a, const point &b, const point &c) {
	return ((b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x)) / 2.;
}
*/
inline double cos (const point &a, const point &b, const point &c) {
	return (a - c) * (b - c) / ((a - c).len () * (b - c).len ());
}

int N;
point vec[MAXN];
bool used[MAXN][MAXN];
bool ma3x[MAXN][MAXN];

int main () {
	while (scanf ("%d %d", &vec[N].x, &vec[N].y) == 2) ++N;

	int lid = 0;
	int i;
	for (i = 1; i < N; ++i)
		if (vec[i].y < vec[lid].y || vec[i].y == vec[lid].y && vec[i].x > vec[lid].x)
			lid = i;

	int nt = lid ? 0 : 1;
	int tmp;
	for (i = 0; i < N; ++i)
		if (i != lid && i != nt
		 && ((tmp = _S2 (vec[lid], vec[nt], vec[i])) < 0
		 || !tmp && (vec[nt] - vec[lid]).sq () > (vec[i] - vec[lid]).sq ()))
			nt = i;

	vec[N] = point (vec[lid].x, -1);
	std::queue <tri> q;
	q.push (tri (lid, nt, N));
	used[lid][nt] = 1;
	ma3x[lid][nt] = 1;

	tri crnt;
	int ns;
	int bi;
	double bcos, dtmp;
	while (!q.empty ()) {
		crnt = q.front (); q.pop ();
		assert (tmp = _S2 (vec[crnt.a], vec[crnt.b], vec[crnt.c]));
//		printf ("%d %d %d\n", crnt.a + 1, crnt.b + 1, crnt.c + 1);
		ns = tmp > 0 ? 1 : -1;
		bi = -1; bcos = 1e9;
		for (i = 0; i < N; ++i)
			if (_S2 (vec[crnt.a], vec[crnt.b], vec[i]) * ns < 0
			 && (dtmp = cos (vec[crnt.a], vec[crnt.b], vec[i])) < bcos) {
				bi = i;
				bcos = dtmp;
			}

		if (bi == -1) continue;
//		printf ("--%d\n", bi + 1);
		ma3x[crnt.a][bi] = ma3x[crnt.b][bi] = 1;
		if (!used[crnt.a][bi]) {q.push (tri (crnt.a, bi, crnt.b)); used[crnt.a][bi] = 1;}
		if (!used[crnt.b][bi]) {q.push (tri (crnt.b, bi, crnt.a)); used[crnt.b][bi] = 1;}
	}

	for (i = 0; i < N; ++i)
		for (int j = i + 1; j < N; ++j)
			if (ma3x[i][j] || ma3x[j][i])
				printf ("%d %d\n", i + 1, j + 1);

	return 0;
}
