/*
FROM: SPRING 2003 A
PROB: circle
KEYW: index tree lowest bit
*/

#include <cstdio>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 19;

int N, N2;
std::pair <int, int> vec[MAXN * 2];

long long idt[MAXN * 2];

inline int lowest_bit (int a) {return a & -a;}

void add (int pos, int val) {
	while (pos <= N2) {
		idt[pos] += val;
		pos += lowest_bit (pos);
	}
}

long long _srch (int pos) {
	long long res = 0;
	while (pos) {
		res += idt[pos];
		pos -= lowest_bit (pos);
	}
	return res;
}

inline long long srch (int l, int r) {
	return _srch (r) - _srch (l);
}

int main () {
	scanf ("%d", &N);
	N2 = N * 2;
	int i;
	int a, b;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &a, &b);
		vec[i * 2] = std::make_pair (a, b);
		vec[i * 2 + 1] = std::make_pair (b, a);
	}

	std::sort (vec, vec + N * 2);

	long long res = 0;
	for (i = 0; i < N2; ++i)
		if (vec[i].first < vec[i].second)
			add (vec[i].first, 1);
		else {
//			printf ("(%d %d) %Ld\n", vec[i].second, vec[i].first, srch (vec[i].second, vec[i].first));
			res += srch (vec[i].second, vec[i].first);
			add (vec[i].second, -1);
		}

	printf ("%Ld\n", res);

	return 0;
}
