#include <stdio.h>
#include <stdlib.h>


#define MAXN     1100100
#define MAXTRADE 1100100
#define MAXS     1100100

int N, ntrade;
int trade[MAXTRADE][4];
int vi[MAXN];
int ki[MAXN];

int S;
int wl[MAXS];
/* 0-n/a
   1-lose
   2-win
   3-draw
*/
int trade_to_do[MAXS];
int nwa[MAXS];  /* Number of Winning positions After i */
int npt[MAXS];  /* Number of Possible Trades for i */
int que[MAXN];
int iw, ir;



int encode(int *arr);
void decode(int res, int *arr);
int cantrade(int *arr, int itrade, int reverse);
void BFS(void);



int main(void)
{
  int i, j, c;

  /*freopen("1.txt", "rt", stdin);*/
  scanf("%d", &N);
  for (i = 0; i < N; i++) {
    scanf("%d %d", &vi[i], &ki[i]);
  }
  scanf("%d", &ntrade);
  for (i = 0; i < ntrade; i++) {
    scanf("%d %d %d %d", &trade[i][0], &trade[i][1], &trade[i][2], &trade[i][3]);
  }

  S = 1;
  for (i = 0; i < N; i++) {
    S *= vi[i]+1;
  }
  c = encode(ki);

  for (i = 0; i < S; i++) {
    decode(i, ki);
    for (j = 0; j < ntrade; j++) {
      if (cantrade(ki, j, 0) != -1) {
        npt[i]++;
      }
    }
    /*printf(" npt[%d]=%d\n", i, npt[i]);*/
    if (npt[i] == 0) {
      wl[i] = 1;
      que[iw++] = i;
      /*printf(" %d", i);*/
    }
  }
  BFS();
  for (i = 0; i < S; i++) {
    if (wl[i] == 0) {
      wl[i] = 3;
      decode(i, ki);
      for (j = 0; j < ntrade; j++) {
        if (cantrade(ki, j, 0) != -1) {
          trade_to_do[i] = j;
          break;
        }
      }
      /*printf(" %d", i);*/
    }
  }
  
  decode(c, ki);
  if (wl[c] == 1)  {
    printf("2\n");
    fflush(stdout);
  } else {
    printf("1\n");
    fflush(stdout);
    /*printf("my move: %d\n", 1+trade_to_do[c]);*/
    printf("%d\n", 1+trade_to_do[c]);
    fflush(stdout);
    c = cantrade(ki, trade_to_do[c], 0);
    decode(c, ki);
  }
  while (scanf("%d", &i) == 1 && i > 0) {
    c = cantrade(ki, i-1, 0);
    decode(c, ki);
    if (wl[c] == 1) {
      printf("error!\n");
      exit(0);
    }
    /*printf("my move: %d\n", 1+trade_to_do[c]);*/
    printf("%d\n", 1+trade_to_do[c]);
    fflush(stdout);
    c = cantrade(ki, trade_to_do[c], 0);
    decode(c, ki);
    /*printf("  %d\n", c);*/
  }



  return 0;
}




int encode(int *arr)
{
  int i, res = 0;

  for (i = 0; i < N; i++) {
    res *= vi[i]+1;
    res += arr[i];
  }
  return res;
}


void decode(int res, int *arr)
{
  int i;

  for (i = N-1; i >= 0; i--) {
    arr[i] = res%(vi[i]+1);
    res /= vi[i]+1;
  }
}



int cantrade(int *arr, int itrade, int reverse)
{
  int a, ca, b, cb, res;

  a  = trade[itrade][0]-1;
  ca = trade[itrade][1];
  b  = trade[itrade][2]-1;
  cb = trade[itrade][3];
  if (reverse) {
    int t = a;  a = b;  b = t;
    t = ca;  ca = cb;  cb = t;
  }
  if (arr[a]-ca >= 0 && arr[b]+cb <= vi[b]) {
    arr[a] -= ca;  arr[b] += cb;
    res = encode(arr);
    arr[a] += ca;  arr[b] -= cb;
    return res;
  }
  return -1;
}



void BFS(void)
{
  int i, u, v;

  while (ir < iw) {
    u = que[ir++];
    if (wl[u] == 1) {
      decode(u, ki);
      for (i = 0; i < ntrade; i++) {
        v = cantrade(ki, i, 1);
        if (v == -1)  continue;
        if (wl[v] == 0) {
          que[iw++] = v;
          wl[v] = 2;
          trade_to_do[v] = i;
        }
      }
    }
    if (wl[u] == 2) {
      decode(u, ki);
      for (i = 0; i < ntrade; i++) {
        v = cantrade(ki, i, 1);
        if (v == -1)  continue;
        nwa[v]++;
        if (nwa[v] == npt[v] && wl[v] == 0) {
          que[iw++] = v;
          wl[v] = 1;
        }
      }
    }
  }
}
