#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>

using namespace std;

vector <vector <int> > m1;
vector <vector <int> > m2;

int difx [] = {-1, 0, 1, 0};
int dify [] = {0, 1, 0, -1};

int tod (char c) {
	switch (c) {
	case 'U': return 0;
	case 'R': return 1;
	case 'D': return 2;
	case 'L': return 3;
	}
	return -1;
}

class RobotTesting {
	public:
	double estimateCommands(int N, string program) {
		int i, ii, jj;
		int Difx =0, Dify =0;
		m1.resize (N);
		m2.resize (N);
		for (ii = 0; ii < N; ++ii)
			m1[ii].resize (N), m2[ii].resize (N);

		for (i = program.size () - 1; i >= 0; --i) {

			int dir = tod (program[i]);
			Difx += difx[dir]; Dify += dify[dir];

			for (ii = 0; ii < N; ++ii)
				for (jj = 0; jj < N; ++jj) {
					if (	ii + difx[dir] < 0 || ii + difx[dir] >= N ||
						jj + dify[dir] < 0 || jj + dify[dir] >= N) m1[ii][jj] = 1;
					else if (!m2[ii + difx[dir]][jj + dify[dir]])
						m1[ii][jj] = 0;
					else
						m1[ii][jj] = m2[ii + difx[dir]][jj + dify[dir]] + 1;
				}


			m1.swap (m2);
		}

		int lbi, lbj, ubi, ubj, ci, cj;
/*
		for (ii = 0; ii < N; ++ii) {
			for (jj = 0; jj < N; ++jj)
				printf ("%d ", m2[ii][jj]);
			printf ("\n");
		}
*/
		if (Difx > 0) {
			lbi = N-1;
			ubi = -1;
			ci = -1;
		} else {
			lbi = 0;
			ubi = N;
			ci = 1;
		}
		if (Dify > 0) {
			lbj = N-1;
			ubj = -1;
			cj = -1;
		} else {
			lbj = 0;
			ubj = N;
			cj = 1;
		}
//		printf ("%d %d %d  %d %d %d\n", lbi,ubi, ci, lbj, ubj, cj);
		if (Difx == 0 && Dify == 0) goto _next;
		int j;
		for (i = lbi; i != ubi; i += ci)
			for (j = lbj; j != ubj; j += cj) {
				if (!m2[i][j]) {
//					printf ("-%d %d- %d\n", i, j, m2[i + Difx][j + Dify] + program.size ());
					m2[i][j] = m2[i + Difx][j + Dify] + program.size ();
				}
			}


		_next:;
		printf ("%d %d\n", Difx, Dify);
/*
		for (ii = 0; ii < N; ++ii) {
			for (jj = 0; jj < N; ++jj)
				printf ("%d ", m2[ii][jj]);
			printf ("\n");
		}
*/
		long long res = 0;
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j)
				res += m2[i][j] ? m2[i][j] : 50000;
		return (double)res / (N * N);
	}
};
