#include <vector>
#include <string>
#include <cmath>

using namespace std;

const int MAXN = 1 << 6;

int x[MAXN];
int y[MAXN];
int z[MAXN];

double sqr (double a) {
	return a * a;
}

long double _S (long double a, long double b, long double c) {
	return (4 * a * b - sqr (a + b - c));
}

double S (int a, int b, int c) {
	long double len1 =  (sqr (x[a] - x[b]) + sqr (y[a] - y[b]) + sqr (z[a] - z[b]));
	long double len2 =  (sqr (x[a] - x[c]) + sqr (y[a] - y[c]) + sqr (z[a] - z[c]));
	long double len3 =  (sqr (x[c] - x[b]) + sqr (y[c] - y[b]) + sqr (z[c] - z[b]));
	return _S (len1, len2, len3);
}

class FindTriangle {
	public:
	double largestArea (vector <string> points) {
		char col[MAXN];
		int i, j, k;
		int N = points.size ();
		for (i = 0; i < points.size (); ++i) {
			sscanf (points[i].c_str (), "%c %d %d %d", &col[i], &x[i], &y[i], &z[i]);
//			printf ("%c %d %d %d\n", col[i], x[i], y[i], z[i]);
		}
		long double tmp;
		long double best =0;
		for (i = 0; i < N; ++i)
			for (j = i + 1; j < N; ++j)
				for (k = j + 1; k < N; ++k) {
					if (i == j || j == k || k == i) continue;
					if (col[i] == col[j] && col[j] == col[k] || col[i] != col[j] && col[i] != col[k] && col[j] != col[k])
						if (best < (tmp = S (i, j, k))) {
							best = tmp;
//							printf ("%d %d %d --- %.10Lf\n", i, j, k, best);
						}
				}
		best = sqrt (best) / 4;
		printf ("%.10Lf\n", best);
		return best;
	}
};
