#include <cstdio>

const double epsilon = 1e-12;


class SnailRace {
	double can (double mdist) {
		double s1 = Vg * (mdist - mdist * Vs / Vg) / (Vs + Vg);
		double t = (mdist + s1) / Vg;
		double t1 = mdist / Vg;
		double tall = t1 + t * (cnt - 1);
		double fg = t * (cnt - 1) * Vs + mdist;
		return (fg < dist - 1 ? tall : -1);
	}
	public:

	int cnt, dist, Vs, Vg;
	double shortestTime (int _cnt, int _dist, int _Vs, int _Vg) {
		cnt = _cnt, dist = _dist, Vs = _Vs, Vg = _Vg;
		if (Vg <= Vs) return (double)(dist - 1) / Vs;
		double lb = 0, ub = dist, m;
		while (ub - lb > epsilon) {
			m = (lb + ub) / 2.0;
			if (can (m) > 0)
				lb = m;
			else
				ub = m;
		}
		return can (lb);
	}
};
