#include <cstdio>
#include <vector>
#include <string>
#include <sstream>

using namespace std;

const int N = 11;

typedef long long type;

const type UB = 2100000000;

struct Ma3x {
	type a[16][16];
	Ma3x () {memset (a, 0, sizeof (a));}
	Ma3x& operator = (const Ma3x &x) {memcpy (a, x.a, sizeof (a)); return *this;}
	Ma3x sq () const {
		Ma3x res;
		static int i, j, k;
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j)
				for (k = 0; k < N; ++k) {
					res.a[i][j] += a[i][k] * a[k][j];
					if (res.a[i][j] > UB)
						res.a[i][j] = UB;
				}
		return res;
	}

	Ma3x operator * (const Ma3x &x) const {
		static int i, j, k;
		Ma3x res;
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j)
				for (k = 0; k < N; ++k) {
					res.a[i][j] += a[i][k] * x.a[k][j];
					if (res.a[i][j] > UB)
						res.a[i][j] = UB;
				}
		return res;
	}
};
 
Ma3x ma3x;
Ma3x _new;
type init[16];
type res[16];

Ma3x pow (int p) {
	if (p == 0) {
		Ma3x res;
		for (int i = 0; i < N; ++i) res.a[i][i] = 1;
		return res;
	}
	if (p == 1) return ma3x;
	if (p & 1) return pow (p-1) * ma3x;
	else return pow (p / 2).sq ();
}

type mult (int p) {
	_new = pow (p);
	int i, k;
	type sum = 0;
	memset (res, 0, sizeof (res));
	for (i = 0; i < N; ++i) {
		for (k = 0; k < N; ++k) {
//			fprintf (stderr, "pow %d, res[%d] += %Ld * %Ld (%d)\n", p, i, _new.a[i][k], init[k], k);
			res[i] += _new.a[i][k] * init[k];
		}
		if (i) sum += res[i];
	}
	printf ("mult %d ret %Ld\n", p, sum);
	return sum;
}

class ValidPlates {
	public:
	string getPlate(vector <string> P, int _seqno) {
		long long seqno = _seqno;
		--seqno;
		int i, j;
		for (i = 0; i < N; ++i)
			for (j = 0; j < N-1; ++j)
				ma3x.a[i][j] = 1;//possible
		ma3x.a[N-1][N-1] = 1;
		ma3x.a[N-1][0] = 0;//cannot start a number with 0
  
		for (i = 0; i < P.size (); ++i) {
			istringstream in (P[i]);
			int dig;
			while (in >> dig) {
				ma3x.a[dig / 10][dig % 10] = 0;
			}
		}
		/*
		for (i = 0; i < N; ++i) {
			for (j = 0; j < N; ++j)
				printf (" %d", ma3x.a[i][j]);
			printf ("\n");
		}
		*/

		for (i = 0; i < 10; ++i) init[i] = 1;//begin with 0-9 without ' '
//		#warning cautiosus with starting with 0...
/*
		for (j = 0; j < N; ++j) printf ("%5d ", j);
		printf ("\n---------\n");
		for (i = 0; i < 5; ++i) {
			mult (i);
			for (j = 0; j < N; ++j) printf ("%5d ", res[j]); printf ("<--- %d\n", j);
		}
*/
		type l = -1, r = 2000000010, m;
		while (l + 1 < r) {
			m = (l + r) / 2;
			if (mult (m) <= seqno)
				l = m;
			else
				r = m;
//			fprintf (stderr, "mult %Ld:\n", m);
//			for (int ii = 0; ii < N; ++ii) {for (int jj = 0; jj < N; ++jj) fprintf (stderr, "%Ld ", _new.a[ii][jj]); fprintf (stderr, "\n");}
		}
//		printf ("r == %Ld\n", r);
		if (r == 2000000010) return string ("");
		mult (r); seqno -= res[10];
		
		string ret;
		int pid = 10;//space was the first fictional character
		for (i = r; i >= 0; --i) {
			mult (i);
//			for (j = 0; j < N; ++j) printf ("%5Ld ", res[j]); printf ("<--- %d\n", j);
			if (ret.size () == 51) break;
			for (j = 0; j < N; ++j) {
				if (!ma3x.a[pid][j]) continue;
//				printf ("try to put %d - will left %Ld\n", j, seqno - res[j]);
				if ((seqno -= res[j]) < 0) break;
			}
			seqno += res[j];
			pid = j;
			ret += j + '0';
//			printf ("put %c, left %Ld\n", j + '0', seqno);
		}

		return ret.size () == 51 ? ret.substr (0, 47) + "..." : ret;
	};
};
