#include <cstdio>
#include <cassert>
#include <vector>
#include <string>

using namespace std;

const int MAXN = 52;
const int MAXFS = 1 << 17;

typedef unsigned uint;
typedef unsigned long long ull;

int N, M;
int M1, MM1;
uint MM, MMX;
bool fs[MAXFS];
ull dp[MAXN][MAXFS / 2];
char cango[MAXN][MAXFS / 2];

bool match(uint mask, const string &s) {
	int i;
	for (i = 0; i < M; ++i)
		if (s[M-1-i] != '?'
		 && s[M-1-i] - 'A' != (int)((mask >> i) & 1)) break;
	return i == M;
}

ull sum[MAXFS / 2];
void fill_dp() {
	M1 = M-1;
	MM1 = 1 << M1;
	MMX = MM1 - 1;
	uint nm;
	for (uint m = 0; m < MM1; ++m) dp[N][m] = 1;//last
	for (int i = N-1; i >= M1; --i) {
		for (uint m = 0; m < MM1; ++m) {
			nm = m << 1;
			if (!fs[nm]) {
				//printf("%u --> %u --> %u ([%d][%u] %llu)\n", m, nm, nm & MMX, i+1, nm&MMX, dp[i+1][nm & MMX]);
				dp[i][m] += dp[i+1][nm & MMX];
				cango[i][m] |= 1;
			}
			nm |= 1;
			if (!fs[nm]) {
				//printf("%u --> %u --> %u ([%d][%u] %llu)\n", m, nm, nm & MMX, i+1, nm&MMX, dp[i+1][nm & MMX]);
				dp[i][m] += dp[i+1][nm & MMX];
				cango[i][m] |= 2;
			}
			//printf("%d %u -- %llu\n", i, m, dp[i][m]);
		}
	}
	sum[0] = dp[M1][0];
	for (uint m = 1; m < MM1; ++m)
		sum[m] = sum[m-1] + dp[M1][m];
}

string encode(ull x) {
	string res;
	for (int i = N-1; i >= 0; --i)
		res += (x >> i & 1) + 'A';
	return res;
}

ull dojob(ull c) {
	printf("do job %llu\n", c);

	/*
	uint m;
	for (m = 0; m < MM1; ++m) {
		if (dp[M1][m] <= c) {
			c -= dp[M1][m];
		} else
			break;
	}
	if (m == MM1) return -1;
	*/
	if (c >= sum[MM1-1]) return -1;
	uint l = -1, r = MM1, mid, m;
	while (l+1 != r) {
		mid = (l + r) / 2;
		if (sum[mid] < c)
			l = mid;
		else
			r = mid;
	}
	if (r == MM1) return -1;
	m = r;
	if (r) c -= sum[r-1];

	ull res = m, ores;
	printf("start mask = %u\tleft %llu\n", m, c);
	for (int i = M1; i < N; ++i) {
		ores = res;
		res <<= 1;
		//printf("cango[%d][%llu] == %d\n", i, ores & MMX, cango[i][ores & MMX]);
		//printf("examine [%d][%llu] -- %llu\n", i+1, res & MMX, dp[i+1][res & MMX]);
		if (!(cango[i][ores & MMX] & 1) || dp[i+1][res & MMX] <= c) {

			if (cango[i][ores & MMX] & 1)
				c -= dp[i+1][res & MMX];
			res |= 1;
			assert(cango[i][ores & MMX] & 2);
			printf("put 1\tleft %llu\n", c);
		} else {
			assert(cango[i][ores & MMX] & 1);
			printf("put 0\tleft %llu\n", c);
		}
	}
	assert(c == 0);
	return res;
}

class AlienDictionary {
	public:
	vector <string> getWords(int _N, vector <string> _fs, vector <int> wn) {
		N = _N;
		if (_fs.size() == 0) {
			M = 1;
		} else {
			M = _fs[0].size();
		}

		if (M > N) {
			vector<string> res;
			for (int i = 0; i < wn.size(); ++i)
				res.push_back(encode(wn[i]));
			return res;
		}

		MM = 1 << M;
		for (uint i = 0; i < MM; ++i) {
			for (int j = 0; j < (int) _fs.size(); ++j)
				if (match(i, _fs[j])) {
					//printf("forb %d\n", i);
					fs[i] = 1;
					break;
				}
		}

		fill_dp();

		vector<string> res;
		for (int i = 0; i < wn.size(); ++i) {
			ull x = dojob(wn[i]);
			if (x == (ull)-1)
				res.push_back("NO PAGE");
			else
				res.push_back(encode(x));
		}

		return res;
	}
};


#define SZE(A) (sizeof(A)/sizeof(*A))

int main() {
/*
	int N = 5;
	const char *v[] = {"?AA","ABB"};
	int x[] = {4, 12, 0, 6, 9};
*/
	//N = 7;
	//printf("%s\n", encode(13).c_str());
	int N = 4;
	const char *v[] = {"AA"};
	int x[] = {2, 6, 11, 4, 8};

	AlienDictionary ad;
	vector<string> vs = ad.getWords(N, vector<string> (v, v+SZE(v)), vector<int> (x, x + SZE(x)));
	for (vector<string>::iterator it = vs.begin(); it != vs.end(); ++it)
		printf("%s\n", it->c_str());

	return 0;
}
