#include <cstdio>
#include <set>
#include <sstream>
#include <vector>
#include <string>

using namespace std;

const int MAXN = 64;
const int MAXK = 32;

vector<int> dp[MAXK][MAXN];
vector<int> moves[MAXN];

class NimForK {
	public:
	vector <int> winners(int n, int k, vector <string> _moves) {
		for (int i = 0; i < _moves.size(); ++i) {
			int tmp;
			istringstream in (_moves[i]);
			while (in >> tmp) {
				moves[i+1].push_back(tmp);
			}
		}
/*
		for (int i = 0; i <= n; ++i) {
			printf("%d ->", i);
			for (int j = 0; j < moves[i].size(); ++j)
				printf(" %d", moves[i][j]);
			puts("");
		}
*/
		for (int s = 1; s <= n; ++s) {
			for (int p = 0; p < k; ++p) {
				set <int> can_win, all_win;
				for (int m = 0; m < moves[s].size(); ++m) {
					if (moves[s][m] == s) {
						dp[p][s].push_back(p);
//						printf("%d %d -> %d !!\n", p, s, p);
						goto nextp;
					}
					const vector <int> &w = dp[(p+1)%k][s-moves[s][m]];
					if (w.size() == 1 && w[0] == p) {
						dp[p][s].push_back(p);
//						printf("%d %d -> %d !!\n", p, s, p);
						goto nextp;
					}
					int i;
					for (i = 0; i < w.size() && w[i] != p; ++i) ;
					if (i != w.size())
						can_win.insert(w.begin(), w.end());
					all_win.insert(w.begin(), w.end());
				}
				if (!can_win.empty())
					dp[p][s] = vector <int> (can_win.begin(), can_win.end());
				else
					dp[p][s] = vector <int> (all_win.begin(), all_win.end());
/*
				printf("%d %d -->", p, s);
				for (int i = 0; i < dp[p][s].size(); ++i)
					printf(" %d", dp[p][s][i]);
				puts("");
*/
				nextp:;
			}
		}
		for (int i = 0; i < dp[0][n].size(); ++i) ++dp[0][n][i];
		return dp[0][n];
	}
};

int main() {
	int n = 10;
	int k = 3;
	string moves[] = {"", "", "1 2 3", "1 2", "4 5", "1 2 3 5", "2 4", "1 4 7", "4 6 7 9", "2 4 5 8 9"};

	NimForK cl;
	vector<int> res = cl.winners(n, k, vector<string> (moves, moves + sizeof(moves)/sizeof(*moves)));
	for (int i = 0; i < res.size(); ++i)
		printf(" %d", res[i]);
	puts("");

	return 0;
}
