#include <cstdio>
#include <queue>
#include <functional>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

#define x first
#define y second

typedef pair<int, int> pos;

pos tr(pos p) {
	if (p.x < 0) p.x *= -1;
	if (p.y < 0) p.y *= -1;
	if (p.y > p.x) swap(p.x, p.y);
	return p;
}

int dp[4010][4010];

int dx[] = { 1, -1, -2, -2, -1};
int dy[] = {-2, -2, -1,  1,  2};

bool good(pos n, pos o) {
	return n.x * n.x + n.y * n.y < o.x * o.x + o.y * o.y;
}

#define MAXX 4002

class ErrantKnight {
	public:
	string whoWins(vector <int> x, vector <int> y) {
		dp[0][0] = 0;//lose
		dp[1][0] = 0;
		dp[1][1] = 1;
		priority_queue<pair<int, pos>, vector<pair<int, pos> >, greater<pair<int, pos> > > pq;
		for (int i = 2; i <= MAXX; ++i) {
			pq.push(make_pair(i*i, pos(i, 0)));
			pq.push(make_pair(i*i*2, pos(i, i)));
/*			for (int j = 0; j <= i; ++j) {
				pq.push(make_pair(i*i + j*j, pos(i, j)));
			}*/
		}

		while(!pq.empty()) {
			pair<int, pos> pp = pq.top(); pq.pop();
			int i = pp.y.x;
			int j = pp.y.y;
			for (int d = 0; d < 5; ++d) {
				pos old(i, j);
				//printf("start from %d %d(%d)\n", i, j, d);
				for (int t = 1;; ++t) {
					pos n(old.x + dx[d], old.y + dy[d]);
					if (!good(n, old)) break;
					pos nn = tr(n);
					//printf("\tgone %d %d (%d %d)\n", n.x, n.y, nn.x, nn.y);
					if (nn.y == 0 || nn.x == nn.y)
						if (!dp[nn.x][nn.y]) {
							dp[i][j] = 1;
							goto nextpos;
						}
					old = n;
				}
			}
			nextpos:;
		}


/*		for (int i = 0; i <= MAXX; ++i) {
			printf("%2d ->", i);
			for (int j = 0; j <= i; ++j)
				printf(" %d", dp[i][j]);
			puts("");
		}		*/
//		return "";

		int old = 0;
		for (int i = 0; i < 400; ++i)
			if (dp[i][0]) {
				printf("%d %d (%d)\n", i, dp[i][0], i - old);
				old = i;
			}

		string res;
		for (int i = 0; i < x.size(); ++i) {
			pos p1(x[i], y[i]);
			pos p2 = tr(p1);
			if (p2.y == 0 || p2.x == p2.y)
				res.push_back(dp[p2.x][p2.y] ? 'W' : 'B');
			else
				res.push_back('W');
		}
		return res;
	}
};

int main () {
	ErrantKnight ek;
	ek.whoWins(vector<int>(), vector<int>());
	return 0;
}