#include <cstdio>
#include <string>
#include <vector>
#include <string>
#include <utility>

using namespace std;

const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};

char T[64][64];
char nxt[128];
bool con[64][64][4];
bool used[64][64];
string W;

void dfs (int x, int y) {
	used[x][y] = 1;
	for (int i = 0; i < 4; ++i)
		if (con[x][y][i] && !used[x+dx[i]][y+dy[i]])
			dfs (x+dx[i], y+dy[i]);
}

class WordConnect {
	public:
	int numComponents(string _W, vector <string> _T) {
		W = _W;
		int i, j;
		memset (nxt, -1, sizeof (nxt));
		for (i = 0; i < W.size () - 1; ++i) nxt[W[i]] = W[i+1];
		//queue
		pair <int, int> q[64*64];
		int p3 = 0;
		//end queue
		for (i = 0; i < _T.size (); ++i)
			for (j = 0; j < _T[i].size (); ++j)
				T[i+1][j+1] = _T[i][j];
				if (T[i+1][j+1] == W[0]) {
					q[p3++] = make_pair (i+1, j+1);
					used[i+1][j+1] = 1;
				}
		pair <int, int> c;
		for (i = 0; i < p3; ++i) {
			c = q[i];
			for (j = 0; j < 4; ++j) {
				nx = c.first + dx[j];
				ny = c.second + dy[j];
				if (!used[nx][ny] && T[nx][ny] == nxt[T[c.first][c.second]]) {
					used[nx][ny] = 1;
					con[c.first][c.second][j] = 1;
					q[p3++] = make_pair (nx, ny);
				}
			}
		}
		memset (used, 0, sizeof (used));
		for (i = 1; i <= _T.size (); ++i)
			for (j = 1; j <= _T[i].size (); ++j)
				if (!used[i][j])
					dfs (i, j);
	};
};
