/*Class:	WeighingBalls

Method:	init
Parameters:	int, int
Returns:	vector <int>
Method signature:	vector <int> init(int n, int digitalCost)

Method:	next
Parameters:	int
Returns:	vector <int>
Method signature:	vector <int> next(int lastResult)
(be sure your methods are public)
*/

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>

using namespace std;
typedef unsigned uint;

class WeighingBalls {
	uint N;
	vector <int> known;
	int ball_1002_id;
	int la;
	void ans (int res) {
		if (ball_1002_id == -1) {
			known[la] = res;
			if (res == 1002) ball_1002_id = la;
		} else {
			switch (res) {
				case -1: known[la] = 1003; break;
				case  0: known[la] = 1002; break;
				case  1: known[la] = 1001; break;
				default: assert (0);
			}
		}
	}
	vector <int> tmp;
	vector <int> make_vec (int a, int b =-1) {
		vector <int> tmp2 (tmp);
		tmp2[a] = 1;
		la = a;
		if (b != -1) {tmp2[b] = -1; la = b;}
		return tmp2;
	}
	vector <int> solve () {
		static unsigned i;
		if (ball_1002_id == -1) {
			int zcnt = count (known.begin (), known.end (), 0);
			int sid = rand () % zcnt;
			for (i = 0; i < N; ++i)
				if (!known[i]) {
					if (!sid)
						return make_vec (i);
					else
						--sid;
				}
			assert (0);
		}

		for (i = 0; i < N; ++i)
			if (!known[i])
				return make_vec (ball_1002_id, i);

		return known;
	}

	public:
	vector <int> init(int n, int digitalCost) {
		N = n;
		known.resize (n);
		tmp.resize (n);
		ball_1002_id = -1;
		return solve ();
	}
	vector <int> next(int lastResult) {
		ans (lastResult);
		return solve ();
	}
};

int N, DC;
vector <int> v;

void prnt (vector <int> v) {
	for (unsigned i = 0; i < v.size (); ++i) printf ("%5d", v[i]); printf ("\n");
	for (unsigned i = 0; i < v.size (); ++i) printf ("%5d", ::v[i]); printf ("---\n");
	if (v == ::v) {printf ("OK!!\n"); exit (0);}
}

int main () {
	FILE *in = fopen ("input", "r");

	WeighingBalls a;
	fscanf (in, "%d", &N);
	fscanf (in, "%d", &DC);
	v.resize (N);
	for (int i = 0; i < N; ++i) fscanf (in, "%d", &v[i]);
	fclose (in);

	prnt (a.init (N, DC));

	while (1) {
		int ans;
		scanf ("%d", &ans);
		prnt (a.next (ans));
	}
}
