#include <vector>
#include <map>
#include <set>
#include <ext/functional>
#include <ext/numeric>
#include <iostream>
#include <iterator>
#include <sstream>
#include <string>
#include <cctype>
#include <algorithm>

using namespace std;

vector <string> ac;
vector <string> rem;
int brd[5][5];
int _cres;

#define FLUSH_WIN 1
#define _32_WIN 2
#define _3_WIN 3
#define KENTA_WIN 4

char str[] = "TJQKA";

int IDX (char c) {
	if (isdigit (c))
		return c - '2';
	else
		return find (str, str + 5, c) - str + 8;
}

struct char_cmp {
	bool operator () (const char &a, const char &b) {
		return IDX (a) < IDX (b);
	}
};

bool consec (set <char, char_cmp> &x) {
	set <char, char_cmp> :: iterator it1 = x.begin (), it2 = it1;
	++it2;
	while (it2 != x.end ()) {
		if (IDX(*it1) + 1 != IDX(*it2))
			break;
		++it1;
		++it2;
	}
	return it2 == x.end ();
}

int _calc_hand (vector <string> hand) {
	int i;
	set <char, char_cmp> xx;
	map <char, int> xy; map <char, int> :: iterator it;

	bool same_col = 0;

	for (i = 1; i < 5 && hand[i][1] == hand[0][1]; ++i);
	if (i == 5)
		same_col = 1;
	for (i = 0; i < 5; ++i)
		xx.insert (hand[i][0]);
	for (i = 0; i < 5; ++i)
		xy[hand[i][0]]++;


	//probe for RF (100)
	if (isalpha (*xx.begin ()) && xx.size () == 5 && same_col) {
		assert (consec (xx));
		return 100;
	}

	//probe for SF (75)
	if (xx.size () == 5 && same_col && consec (xx))
		return 75;

	//probing for 4K (50)
	if (xx.size () == 2 && xy.begin ()->second == 1 || xy.begin ()->second == 4)
		return 50;

	//probing for flush (XX)
	if (same_col)
		return FLUSH_WIN;

	//probing for 3 + 2 ()
	if (xx.size () == 2)
		return _32_WIN;

	//probing for 3
	for (it = xy.begin (); it != xy.end (); ++it)
		if (it->second == 3)
			return _3_WIN;

	//mrysna kenta
	if (xx.size () == 5 && consec (xx))
		return KENTA_WIN;

	//probing for 2*2 (10)
	if (xx.size () == 3)
		return 10;

	//probing for 2 of a kind (5)
	if (xx.size () == 4)
		return 5;

	return 0;
}

void calc_hand (const vector <int> &idx) {
	int &cres = _cres;
	cres = 0;
	int i, j;
	for (i = 0; i < 5; ++i) {
		vector <string> chand;
		for (j = 0; j < 5; ++j) {
			chand.push_back (brd[i][j] >= 0 ? ac[brd[i][j]] : rem[idx[-brd[i][j]]]);
		}
		cres += _calc_hand (chand);
	}
	for (j = 0; j < 5; ++j) {
		vector <string> chand;
		for (i = 0; i < 5; ++i) {
			chand.push_back (brd[i][j] >= 0 ? ac[brd[i][j]] : rem[idx[-brd[i][j]]]);
		}
		cres += _calc_hand (chand);
	}
}

class PokerSquare {
	public:
	int bestScore(vector <string> board, vector <string> remaining) {
		int i,j;
		rem.push_back ("");
		for (i = 0; i < 5; ++i) {
			istringstream in (board[i]);
			string ccard;
			for (j = 0; j < 5; ++j) {
				in >> ccard;
				if (ccard != "--") {
					ac.push_back (ccard);
					brd[i][j] = ac.size () - 1;
				} else {
					printf ("HERE! %d %d %zu\n", i, j, rem.size ());
					rem.push_back (remaining.back ());
					remaining.pop_back ();
					brd[i][j] = -(int)(rem.size () - 1);
				}
			}
		}
		for (i = 0; i < 5; ++i) {
			for (j = 0; j < 5; ++j)
				printf (" %3d", brd[i][j]);
			puts ("");
		}
//		copy (ac.begin (), ac.end (), ostream_iterator <string> (std::cout, "\n"));
//		copy (rem.begin (), rem.end (), ostream_iterator <string> (std::cout, "\n"));
		vector <int> idx (rem.size ());
		__gnu_cxx::iota (idx.begin (), idx.end (), 0);

		vector <int> bidx;
		int bres = -1;
		do {
			calc_hand (idx);
			if (_cres > bres) {
				bres = _cres;
				bidx = idx;
			}
		} while (next_permutation (idx.begin () + 1, idx.end ()));

/*		vector <string> result;
		for (i = 0; i < N; ++i) {
			string str;
			ostringstream out (str);
			for (j = 0; j < N; ++j) {
				out << ' ' << (brd[i][j] >= 0 ? ac[brd[i][j]] : rem[bidx[-brd[i][j]]]);
			}
			result.push_back (out.str ().substr (1));
		}
*/
		return bres;
	}
};

int main () {
	vector <string> p;
/*	p.push_back ("TS");
	p.push_back ("QS");
	p.push_back ("AS");
	p.push_back ("JS");
	p.push_back ("KS");
*/

	p.push_back ("9T");
	p.push_back ("QT");
	p.push_back ("8S");
	p.push_back ("TT");
	p.push_back ("JT");

/*
	p.push_back ("2T");
	p.push_back ("2S");
	p.push_back ("3T");
	p.push_back ("3T");
	p.push_back ("3T");
*/
	printf ("%d\n", _calc_hand (p));
//	PokerSquare x;
//	x.BestScore ();
	return 0;
}
