/*
FROM: USACO 2001 OPEN GREEN\
PROB: quake
KEYW: binary search on the answer, minimum spanning tree
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 9;
const int MAXM = 1 << 14;
const double epsilon = 1e-6;

int N, M, S;
std::pair <std::pair <int, int>, std::pair <int, int> > data[MAXM];

double _X;
bool cmp (int a, int b) {
	return 	(double)(data[a].second.second - data[b].second.second) * _X < data[b].second.first - data[a].second.first;
}

int _cntr;
bool mst (double val) {
	++_cntr;
	static int idx[MAXN];
	static int a[MAXN], sz[MAXN];

//	printf ("------\nmst %lf\n", val);

	double acm = 0;
	int i;
	for (i = 0; i < N; ++i) {idx[i] = a[i] = i; sz[i] = 1;}

	_X = val;
	std::sort (idx, idx + N, cmp);

	int p, q;
	for (i = 0; i < M; ++i) {
		for (p = data[idx[i]].first.first; a[p] != p; p = a[p]) a[p] = a[a[p]];
		for (q = data[idx[i]].first.second; a[q] != q; q = a[q]) a[q] = a[a[q]];

		if (p == q) continue;
		acm += data[idx[i]].second.first + data[idx[i]].second.second * val;
//		printf ("take (%d) - (%d %d) -- %lf\n", idx[i], data[idx[i]].second.first, data[idx[i]].second.second, data[idx[i]].second.first + data[idx[i]].second.second * val);
		if (sz[p] < sz[q]) {
			a[p] = q;
			sz[q] += sz[p];
		} else {
			a[q] = p;
			sz[p] += sz[q];
		}
	}

//	printf ("__acm == %lf\n", acm);

	return acm <= S;
}

int main () {
	scanf ("%d %d %d", &N, &M, &S);

	int i;
	for (i = 0; i < M; ++i)
		scanf ("%d %d %d %d", &data[i].first.first, &data[i].first.second, &data[i].second.first, &data[i].second.second);

	double l = 0, r = 1e50, m;

	while (r - l > epsilon) {
		m = (l + r) / 2.;
		if (mst (m))
			l = m;
		else
			r = m;
	}

	printf ("%d\n", _cntr);
	printf ("%.4lf\n", r);

	return 0;
}
