/*
FROM: USACO OPEN 2001 FGREEN
PROB: well
KEYW: dynamical programming
*/

#include <cstdio>
#include <algorithm>

const int MAXG = 1 << 7;//100
const int MAXE = 1 << 5;//30

struct garbage {
	int time;
	int H;
	int E;
	garbage () {}
	garbage (int _time, int _H, int _E) : time (_time), H (_H), E (_E) {}
};

int G, D;

garbage vec[MAXG];
int opt[MAXG][MAXE * MAXG + 10 + 1];

int max (int a, int b) {
	return a > b ? a : b;
}

bool cmp (garbage a, garbage b) {
	return a.time < b.time;
}

int main () {
//	FILE *in = fopen ("well.in", "r");
	FILE *in = stdin;
	fscanf (in, "%d %d", &D, &G);

	int i, j;
	int maxE = 0;
	for (i = 0; i < G; ++i) {
		fscanf (in, "%d %d %d", &vec[i].time, &vec[i].E, &vec[i].H);
		maxE = max (maxE, vec[i].E);
	}
	fclose (in);

	vec[G].time = MAXE * MAXG + 20;//to be impossible to wait after the last one

	for (i = 0; i < G; ++i)
		for (j = 0; j <= MAXE * MAXG + 10; ++j)
			opt[i][j] = -1;

	std::sort (vec, vec + G + 1, cmp);

	int survive = 10;//, survive2 =10;

	if (vec[0].time <= 10)
		opt[0][10 - vec[0].time] = 0;//at the beginning

	int ntime;
	for (i = 0; i < G; ++i) {
		ntime = vec[i + 1].time - vec[i].time;
//		printf ("!%d -> %d %d (%d %d %d)\n", i, survive, survive2, vec[i].time, vec[i].E, vec[i].H);
/*
		if (survive < vec[i].time) {i = G; printf ("die %d %d %d!\n", i, survive, vec[i].time);break;} else
			survive += vec[i].E;
*/
		for (j = 0; j <= maxE * i + 10; ++j) {
			if (opt[i][j] == -1) continue;

			if (survive < vec[i].time + vec[i].E + j) {
//				printf ("here?? crnt %d to %d (%d %d %d)\n", survive, vec[i].time + vec[i].E + j, vec[i].time, vec[i].E, j);
				survive = vec[i].time + vec[i].E + j;
			}

			if (vec[i].H + opt[i][j] >= D) goto ext;

			if (ntime <= j) {
				if (opt[i + 1][j - ntime] < opt[i][j] + vec[i].H) {
					opt[i + 1][j - ntime] = opt[i][j] + vec[i].H;
//					printf ("update %d %d from %d %d with %d(put)\n", i + 1, j - ntime, i, j, opt[i][j] + vec[i].H);
				}
//				opt[i + 1][j - ntime] = max (opt[i + 1][j - ntime], opt[i][j] + vec[i].H);
			}

			if (ntime <= j + vec[i].E) {
				if (opt[i + 1][j + vec[i].E - ntime] < opt[i][j]) {
					opt[i + 1][j + vec[i].E - ntime] = opt[i][j];
//					printf ("update %d %d from %d %d with %d(eat)\n", i + 1, j + vec[i].E - ntime, i, j, opt[i][j]);
				}
//				opt[i + 1][j + vec[i].E - ntime] = max (opt[i + 1][j + vec[i].E - ntime], opt[i][j]);
			}
		}
/*
		if (survive2 < vec[i].time) {
			i = G; break;
		} else
			survive2 += vec[i].E;

		if (survive2 != survive) {
			printf ("%d -> %d %d\n", i, survive, survive2);
		}
*/
	}


	ext:;

//	FILE *out = fopen ("well.out", "w");
	FILE *out = stdout;
	fprintf (out, "%d\n", (i != G ? vec[i].time : survive));

	fclose (out);

	return 0;
}
