/*
FROM: USACO 2002 FEBRUARY GREEN
PROB: pasture
KEYW: dynamical programming
*/

#include <cstdio>
#include <cmath>
#include <algorithm>

const int MAXLEN = 800;
const int MAXN = 40;

int N;
int vec[MAXN];
int sum[MAXN + 1];

int boundary;

int opt[MAXLEN][MAXLEN][MAXN];

inline int max3 (int a, int b, int c) {
	return (a > b ? a > c ? a : c : b > c ? b : c);
}

inline int S (int a, int b, int c) {
	long long p = a + b + c;
	return (int)trunc (sqrtl (p * (p - (a << 1)) * (p - (b << 1)) * (p - (c << 1))) * 25.0);
}

int rec (int x, int y, int n) {
	if (opt[x][y][n]) return opt[x][y][n];
	if (x >= boundary || y >= boundary || sum[n] - x - y >= boundary) return opt[x][y][n] = -1;
	if (n == N) return opt[x][y][n] = S (x, y, sum[N] - x - y);
	return opt[x][y][n] = max3 (rec (x + vec[n], y, n + 1), rec (x, y + vec[n], n + 1), rec (x, y, n + 1));
}

int main () {
//	FILE *in = fopen ("pasture.in", "r");
	FILE *in = stdin;
	fscanf (in, "%d", &N);
	for (int i = 0; i < N; ++i)
		fscanf (in, "%d", vec + i);
	fclose (in);

	std::sort (vec, vec + N);
	for (int i = 1; i <= N; ++i)
		sum[i] = sum[i-1] + vec[i-1];

	boundary = sum[N] / 2 + (sum[N] & 1);

	printf ("%d\n", rec (0,0,0));
/*
	int i, j, k;
	int all =0, cnt =0;
	for (i = 0; i < boundary; ++i)
		for (j = 0; j < boundary; ++j)
			for (k = 0; k <= N; ++k) {
				all++;
				cnt += !!opt[i][j][k];
			}

	printf ("%d %d %d\n", cnt, all,  all / cnt);
*/
	return 0;
}
