/*
FROM: USACO 2002 FEBRUARY GREEN
PROB: roads
KEYW: dynamical programming, tele type
NOTE: updated version(Rosti style)
*/

#include <cstdio>
#include <vector>

const int MAXN = 1 << 8;
const int _infinity = 1 << 29;

int N, P;

int opt[MAXN][MAXN];
bool nroot[MAXN];
std::vector <std::vector <int> > vec;

void fill_opt () {
	for (int i = 0; i < N; ++i)
		for (int j = 0; j <= N; ++j)
			opt[i][j] = _infinity;
}

int best = _infinity;

int fopt (int a) {
	if (vec[a].empty ()) {
		opt[a][0] = 0;
		opt[a][1] = 0;
		return 1;
	}
	int acnt = 0;
	int i, j, k;
	for (i = 0; i < (int)vec[a].size (); ++i)
		acnt += fopt (vec[a][i]);

	opt[a][0] = 0;
	opt[a][1] = (int)vec[a].size ();

	++acnt;//include iurselves
	for (i = 0; i < (int)vec[a].size (); ++i)
		for (j = acnt; j > 1; --j)
			for (k = 1; k < j; ++k)
				opt[a][j] <?= opt[a][k] + opt[vec[a][i]][j-k] - 1;

	best <?= opt[a][P] + nroot[a];//if not root we sholud erase the whole subtree with root a (costing 1 more)

	return acnt;
}

int main () {
	scanf ("%d %d", &N, &P);
	vec.resize (N);

	int i;
	int a, b;
	for (i = 0; i < N - 1; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		vec[a].push_back (b);
		nroot[b] = 1;
	}
	if (P == 1 && N == 1) {printf ("0\n"); return 0;}
	if (P == 1) {printf ("1\n"); return 0;}

	fill_opt ();
	for (i = 0; i < N && nroot[i]; ++i);
	fopt (i);//i is the root
	printf ("%d\n", best);

	return 0;
}
