/*
FROM: USACO 2002 FEBRUARY GREEN
PROB: roads
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 8;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int n[MAXN];

int N, P;
int vec[MAXN];
el buf[MAXN];

int root;// ;)

int dfsn (int v) {
	int sum =1;
	for (int i = vec[v]; i != -1; i = buf[i].next)
		sum += dfsn (buf[i].to);
	return n[v] = sum;
}

void update (int *a, int asz, int *b, int bsz) {
//	printf ("update:\n");
//	for (int i = 0; i < asz; ++i) printf (" %d", a[i]); printf ("\n");
//	for (int i = 0; i < bsz; ++i) printf (" %d", b[i]); printf ("\n");

//	printf ("update %d %d\n", asz, bsz);
	for (int i = asz + bsz - 2; i > 1; --i) {
		if (i >= asz) a[i] = MAXN; else ++a[i];
		int lb = (i - (bsz - 1) > 1 ? i - (bsz - 1) : 1);
		int ub = (i - (asz - 1) < 0 ? i + 1 : asz);
//		printf ("%d %d %d\n", i, lb, ub);
		for (int j = lb; j < ub; ++j)
			if (a[i] > a[j] + b[i - j])
				a[i] = a[j] + b[i - j];
	}

//	printf ("got:\n");
//	for (int i = 0; i <= asz + bsz - 2; ++i) printf (" %d", a[i]); printf ("\n");
}

int best = MAXN;

int* dfs (int v) {
//	printf ("dfs %d\n", v);
	int *ret = new int [n[v] + 1];
	if (vec[v] == -1) {
		ret[0] = 1;
		ret[1] = 0;
//		printf ("<-%d\n", v);
		return ret;
	}

	int i;
	int *tmp = dfs (buf[vec[v]].to);
//	printf ("got:\n");
//	for (i = 0; i <= n[buf[vec[v]].to]; ++i) printf (" %d", tmp[i]); printf ("\n");
	for (i = 1; i <= n[buf[vec[v]].to]; ++i)
		ret[i + 1] = tmp[i];
	ret[0] = 1;
	ret[1] = 1;
//	ret[n[buf[vec[v]].to]] = 1;//with 1 cut u can remove the hole sub-tree
	delete [] tmp;//very important :)

	int csum = n[buf[vec[v]].to] + 2;

//	printf ("fst!:");
//	for (i = 0; i < csum; ++i) printf (" %d", ret[i]); printf ("\n");

	for (int j = buf[vec[v]].next; j != -1; j = buf[j].next) {
		tmp = dfs (buf[j].to);
		update (ret, csum, tmp, n[buf[j].to] + 1);
		++ret[1];//to remain 1 only you need to cut one more child
/*
		ret[n[buf[j].to]] = 1;
*/
		csum += n[buf[j].to];

//		printf ("temporary %d --", v);
//		for (int k = 0; k < csum; ++k) printf ("%d ", ret[k]); printf ("\n");

		delete [] tmp;
	}

	if (P < csum && ret[P] + 1 < best) best = ret[P] + 1;
//	printf ("tested %d\n", P < csum ? ret[P] + 1 : -1);

//	for (i = 0; i < csum; ++i) printf (" %d", ret[i]); printf ("\n");

//	printf ("<-%d\n", v);

	return ret;
}

int main () {
//	FILE *in = fopen ("roads.in", "r");
	FILE *in = stdin;
	fscanf (in, "%d %d", &N, &P);

	bool not_root[MAXN] = {0};

	int i;
	int a, b;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < N - 1; ++i) {
		fscanf (in, "%d %d", &a, &b);
		--a, --b;

		buf[i] = el (b, vec[a]);
		vec[a] = i;

		not_root [b] = 1;//the child can not be the root
	}
	fclose (in);

	if (P == N) {
//		printf ("0\n");
//		FILE *out = fopen ("roads.out", "w");
		FILE *out = stdout;
		fprintf (out, "%d\n", 0);//cut nothing
		fclose (out);
		return 0;
	} else if (P == 1) {
//		printf ("1\n");
//		FILE *out = fopen ("roads.out", "w");
		FILE *out = stdout;
		fprintf (out, "%d\n", 1);//cut one leaf
		fclose (out);
		return 0;
	}

	for (root = 0; root < N && not_root[root]; ++root);

	dfsn (root);
//	for (i = 0; i < N; ++i) printf (" %d", n[i]); printf ("\n");

	int *v = dfs (root);
//	FILE *out = fopen ("roads.out", "w");
	FILE *out = stdout;
	fprintf (out, "%d\n", v[P] < best ? v[P] : best);
	fclose (out);
	delete [] v;

	return 0;
}
