/*
FROM: USACO 2002 JANUARY GREEN
PROB: grazeset
KEYW: computational geometry
*/

#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>

const int MAXN = 1 << 14;
const int MAXK = 1 << 10;
const double epsilon = 1e-9;

struct el {
	double rem;
	int next;
	el () {}
	el (double _rem, int _next) : rem (_rem), next (_next) {}
};

int N, K;
int _vec[MAXK];
el _buf[MAXN];

double *ma3x[MAXK];
int mp[MAXK];
int gsz[MAXK];

int min = MAXN, max = 0;

bool cmp (const double &a, const double &b) {
	return a > b;
}

int main () {
//	FILE *in = fopen ("grazeset.in", "r");
	FILE *in = stdin;
	fscanf (in, "%d %d", &N, &K);
	double sec_len = 360.0 / K;

	int i, j;
	double ang, _tmp;
	for (i = 0; i < K; ++i) _vec[i] = -1;
	for (i = 0; i < N; ++i) {
		fscanf (in, "%lf", &ang);
		_tmp = fmod (ang, sec_len);
		_buf[i] = el (fmod (ang, sec_len), _vec[(int)((ang - _tmp) / sec_len)]);
		_vec[(int)((ang - _tmp) / sec_len)] = i;
//		printf ("%d\n", (int)((ang - _tmp) / sec_len));
	}

	double __tmp[MAXN];
	int __tmpp;

	for (i = 0; i < K; ++i) {
		__tmpp =0;
		for (j = _vec[i]; j != -1; j = _buf[j].next)
			__tmp[__tmpp++] = _buf[j].rem;
		std::sort (__tmp, __tmp + __tmpp, cmp);
		ma3x[i] = new double [__tmpp];
		memcpy (ma3x[i], __tmp, sizeof (double) * __tmpp);
		gsz[i] = mp[i] = __tmpp;
		if (__tmpp < min) min = __tmpp;
		if (__tmpp > max) max = __tmpp;
	}

	int best = max - min;
	for (;;) {
		double min = 400.;
		int minis[MAXK];
		int minisp =0;
		for (i = 0; i < K; ++i) {
			if (!mp[i]) continue;

			if (ma3x[i][mp[i] - 1] - min < -epsilon) {// ma3x[][] < min
				min = ma3x[i][mp[i] - 1];
				minisp = 0;
				minis[minisp++] = i;
			} else if (ma3x[i][mp[i] - 1] - min < epsilon)// ma3x[][] == min
				minis[minisp++] = i;
		}
/*
		for (i = 0; i < minisp; ++i)
			printf ("%d ", minis[i]);
		printf ("(%lf)\n", min);
*/
		if (min == 400.0) break;//there are no cows left - so we are finished

		for (i = 0; i < minisp; ++i) {
			int savei = i;
			i = minis[i];
			for (j = mp[i] - 2; j >= 0 && fabs (ma3x[i][j] - min) < epsilon; --j);

			int mvc = (mp[i] - j - 1);
//			printf ("move %d from %d to %d\n", mvc, i, (i + K - 1) % K);
			mp[i] = j + 1;
			gsz[i] -= mvc;
			gsz[(i + K - 1) % K] += mvc;
			i = savei;
		}
		::min = MAXN; ::max = 0;
		for (i = 0; i < K; ++i) {
			if (gsz[i] < ::min) ::min = gsz[i];
			if (gsz[i] > ::max) ::max = gsz[i];
		}
/*
		for (i = 0; i < K; ++i)
			printf (" %d", gsz[i]);
		printf ("\n");

		printf ("%d %d\n", ::min, ::max);
*/
		if (best > ::max - ::min)
			best = ::max - ::min;
	}

//	printf ("%d\n", best);

//	FILE *out = fopen ("grazeset.out", "w");
	FILE *out = stdout;
	fprintf (out, "%d\n", best);
	fclose (out);

/*
	for (i = 0; i < N; ++i) {
		for (j = mp[i] - 1; j >= 0; --j)
			printf ("%lf ", ma3x[i][j]);
		printf ("\n");
	}
*/
	return 0;
}
