/*
FROM: USACO 2002 MARCH GREEN
PROB: happy
KEYW: full exhaustion
*/

#include <cstdio>
#include <cstdlib>
#include <cmath>

const int MAXN = 1 << 6;
const int MAXM = 1 << 6;
const long double epsilon = 1e-12;

int N, M;
int ma3xi[MAXN][MAXM];
long double ma3x[MAXN][MAXM];
long double opt[MAXN][MAXM];

int optz[MAXN][MAXM];//count of zeroes
int optn[MAXN][MAXM];//count of negative numbers

long double bsum = 0;
int bi, bj, bii, bjj;

inline int cntz (int i, int j, int ii, int jj) {
	return optz[ii][jj] - (i ? optz[i - 1][jj] : 0) - (j ? optz[ii][j - 1] : 0) + (i && j ? optz[i - 1][j - 1] : 0);
}

inline int cntn (int i, int j, int ii, int jj) {
	return optn[ii][jj] - (i ? optn[i - 1][jj] : 0) - (j ? optn[ii][j - 1] : 0) + (i && j ? optn[i - 1][j - 1] : 0);
}

inline long double sum (int i, int j, int ii, int jj) {
	return opt[ii][jj] - (i ? opt[i - 1][jj] : 0) - (j ? opt[ii][j - 1] : 0) + (i && j ? opt[i - 1][j - 1] : 0);
}

void _try (int i, int j, int ii, int jj) {
	static long double tmp;
	if (!cntz (i, j, ii, jj) && !(cntn (i, j, ii, jj) & 1) && (tmp = sum (i, j, ii, jj)) - bsum > -epsilon &&
	(tmp - bsum > epsilon || (ii - i + 1) * (jj - j + 1) < (bii - bi + 1) * (bjj - bj + 1))) {
//		printf ("%d %d %d %d %Lf\n", i, j, ii, jj, tmp);
		bsum = tmp;
		bi = i; bj = j;
		bii = ii; bjj = jj;
	}
}

int main () {
	scanf ("%d %d", &N, &M);

	int i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < M; ++j)
			scanf ("%d", &ma3xi[i][j]);

/*
	for (i = 0; i < N; ++i) {
		for (j = 0; j < M; ++j)
			printf (" (%d %d)", optz[i][j], optn[i][j]);
		printf ("\n");
	}
*/
	for (i = 0; i < N; ++i)
		for (j = 0; j < M; ++j)
			ma3x[i][j] = (ma3xi[i][j] ? logl (abs (ma3xi[i][j])) : 0);
/*
	for (i = 0; i < N; ++i) {
		for (j = 0; j < M; ++j)
			printf ("%Lf ", ma3x[i][j]);
		printf ("\n");
	}
*/
/*
	long double a = logl (2000000);//logl (4) + logl (6);
	printf ("%Lf\n", a);
	long double b = logl (1999998);//logl (3) + logl (8);
	printf ("%d %d %.19Lf\n", a == b, fabsl (a - b) < epsilon, fabsl (a - b));
*/

	optz[0][0] = (ma3xi[0][0] == 0);
	optn[0][0] = (ma3xi[0][0] < 0);
	opt[0][0] = ma3x[0][0];

	for (i = 1; i < N; ++i) {
		optz[i][0] = optz[i - 1][0] + (ma3xi[i][0] == 0);
		optn[i][0] = optn[i - 1][0] + (ma3xi[i][0] < 0);
		opt[i][0] = opt[i - 1][0] + ma3x[i][0];
	}
	for (j = 1; j < M; ++j) {
		optz[0][j] = optz[0][j - 1] + (ma3xi[0][j] == 0);
		optn[0][j] = optn[0][j - 1] + (ma3xi[0][j] < 0);
		opt[0][j] = opt[0][j - 1] + ma3x[0][j];
	}

	for (i = 1; i < N; ++i) {
		for (j = 1; j < M; ++j) {
			optz[i][j] = optz[i][j - 1] + optz[i - 1][j] - optz[i - 1][j - 1] + (ma3xi[i][j] == 0);
			optn[i][j] = optn[i][j - 1] + optn[i - 1][j] - optn[i - 1][j - 1] + (ma3xi[i][j] < 0);
			opt[i][j] = opt[i][j - 1] + opt[i - 1][j] - opt[i - 1][j - 1] + ma3x[i][j];
//			printf ("%Lf(%Lf) ", opt[i][j] , ma3x[i][j]);
		}
//		printf ("\n");
	}

	int ii, jj;
	for (j = 0; j < M; ++j)
		for (i = 0; i < N; ++i)
			for (jj = j; jj < M; ++jj)
				for (ii = i; ii < N; ++ii)
					_try (i, j, ii, jj);

	printf ("%d %d %d %d\n", bi + 1, bj + 1, bii + 1, bjj + 1);

	return 0;
}
