/*
FROM: USACO 2002 USOPEN GREEN
PROB: secret
KEYW: second best spanning tree
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 11;//2000
const int MAXM = 1 << 15;//20000

struct el {
	int a, b;
	int len;
	el () {}
	el (int _a, int _b, int _len) : a (_a), b (_b), len (_len) {}
};

int N, M;
el vec[MAXM];
int l[MAXN];
int sz[MAXN];
int lsv[MAXN];
int szsv[MAXN];
int left;
int leftsv;

void save () {
	for (int i = 0; i < N; ++i) {
		lsv[i] = l[i];
		szsv[i] = sz[i];
	}
	leftsv = left;
}

void load () {
	for (int i = 0; i < N; ++i) {
		l[i] = lsv[i];
		sz[i] = szsv[i];
	}
	left = leftsv;
}

int finish (int st) {
	int p, q;
	int sum =0;
	for (int i = st; i < M && left; ++i) {
		for (p = vec[i].a; p != l[p]; p = l[p]) l[p] = l[l[p]];
		for (q = vec[i].b; q != l[q]; q = l[q]) l[q] = l[l[q]];

		if (p == q) continue;

		if (sz[p] < sz[q]) {
			l[p] = q;
			sz[q] += sz[p];
		} else {
			l[q] = p;
			sz[p] += sz[q];
		}

		sum += vec[i].len;
		--left;
	}
	if (left) return 1 << 29;
	return sum;
}

bool cmplen (const el &a, const el &b) {
	return a.len < b.len;
}

int main () {
	scanf ("%d %d", &N, &M);

	int i;
	int a, b, len;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", &a, &b, &len);
		vec[i].a = a - 1;
		vec[i].b = b - 1;
		vec[i].len = len;
	}

	std::sort (vec, vec + M, cmplen);

	left = N - 1;
	int p, q;
	int crntcost = 0;
	int tmp;
	int best = 1 << 30;
	for (i = 0; i < N; ++i) {l[i] = i; sz[i] = 1;}
	for (i = 0; i < M && left; ++i) {
		for (p = vec[i].a; p != l[p]; p = l[p]) l[p] = l[l[p]];
		for (q = vec[i].b; q != l[q]; q = l[q]) l[q] = l[l[q]];

		if (p == q) continue;

		save ();

		if (best > crntcost + (tmp = finish (i + 1)) && !left)
			best = crntcost + tmp;
//		printf ("%d %d %d --- ", vec[i].a, vec[i].b, vec[i].len);
//		printf ("%d\n", crntcost + tmp);
		load ();

		if (sz[p] < sz[q]) {
			l[p] = q;
			sz[q] += sz[p];
		} else {
			l[q] = p;
			sz[p] += sz[q];
		}
		crntcost += vec[i].len;
		--left;
	}
	if (left) printf ("!!\n");
	printf ("%d\n", best);

	return 0;
}
