/*
FROM: USACO 2003 FEBRUARY GREEN
PROB: cowmath
KEYW: gcd, lcm, bfs
*/

#include <cstdio>
#include <vector>
#include <queue>

const int MAXN = 1 << 5;
const int MAXNUM = 1 << 11;

struct el {
	int to;
	int num;
};

int BASE = 1000000000;
const int bN = 1 << 4;

struct big {
	int a[bN];
	big () {for (int i = 0; i < bN; ++i) a[i] = 0;}
	big& operator *= (int b) {
		long long here, pr =0;
		for (int i = 0; i < bN; ++i) {
			here = (long long)a[i] * b + pr;
			pr = here / BASE;
			a[i] = here % BASE;
		}
		return *this;
	}
	void prnt () {
		int i;
		for (i = bN-1; i >= 0 && !a[i]; --i);
		if (i == -1)
			printf ("0");
		else {
			printf ("%d", a[i]);
			for (--i; i >= 0; --i)
				printf ("%09d", a[i]);
		}
	}
};

int N;
std::vector <std::vector <el> > vec;
std::vector <std::vector <int> > ddiv (MAXNUM);
bool used[MAXN][MAXNUM];
int last[MAXNUM];
int pr[MAXNUM], prc;
int pw[MAXNUM];

void mark_used (const el &a) {
//	printf ("marked used %d %d\n", a.to, a.num);
	for (int i = 0; i < (int)ddiv[a.num].size (); ++i) {
//		printf ("%d ", ddiv[a.num][i]);
		used[a.to][ddiv[a.num][i]] = 1;
	}
//	printf ("\n");
}

int _gcd (int a, int b) {
	return b ? _gcd (b, a % b) : a;
}

int gcd (int a, int b) {
	return _gcd (a >? b, a <? b);
}

void find_last (int a) {
	if (last[a]) return;
	for (int i = 0; i < (int)ddiv[a].size (); ++i)
		last[ddiv[a][i]] = 1;//used but not later int the calculation of lcm
	last[a] = 2;//to be used later in the calculation of lcm
}

int main () {
	scanf ("%d", &N);

	int i, j;
	int a;
	vec.resize (N);
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			scanf ("%d", &a);
			if (a) vec[i].push_back ((el) {j, a});
		}

	for (i = 1; i <= 2000; ++i) {
		for (j = 1; j * j < i; ++j)
			if (!(i % j)) {
//				if (i < 20) printf ("push -- %d - %d %d\n", i, j, i / j);
				ddiv[i].push_back (j);
				ddiv[i].push_back (i / j);
			}
		if (j * j == i) {
//			printf ("push -- %d %d\n", i, j);
			ddiv[i].push_back (j);
		}
	}

	for (i = 0; i < MAXNUM; ++i) used[0][i] = 1;//to prevent going to the start again
	std::queue <el> q;
	for (i = 0; i < (int)vec[0].size (); ++i) {
		q.push (vec[0][i]);
		mark_used (vec[0][i]);
	}

	el crnt, gt;
	while (!q.empty ()) {
		crnt = q.front (); q.pop ();
//		printf ("poped %d %d\n", crnt.to, crnt.num);
		if (crnt.to == 1) {
			find_last (crnt.num);
			continue;
		}

		for (i = 0; i < (int)vec[crnt.to].size (); ++i) {
			gt = (el) {vec[crnt.to][i].to, gcd (vec[crnt.to][i].num, crnt.num)};

			if (!used[gt.to][gt.num]) {
				q.push (gt);
				mark_used (gt);
			}
		}
	}
/*
	for (i = 0; i < MAXNUM; ++i)
		if (last[i] == 2)
			printf ("%d ", i);
	printf ("\n");
*/
	for (i = 2; i < MAXNUM; ++i) {
		for (j = 0; j < prc && i % pr[j]; ++j);
		if (j == prc) pr[prc++] = i;
	}

//	for (i = 0; i < prc; ++i) printf ("%d ", pr[i]); printf ("\n"); printf ("prc == %d\n", prc);

	int cpw, savei;
	for (i = 0; i < MAXNUM; i = savei + 1) {
		savei = i;
		if (last[i] != 2) continue;
		for (j = 0; j < prc && pr[j] <= i; ++j) {
			cpw = 0;
			while (!(i % pr[j])) {
//				printf ("%d / %d   %d\n", i, pr[j], i / pr[j]);
				i /= pr[j];
				++cpw;
			}
			pw[j] >?= cpw;
		}
	}
/*
	for (i = 0; i < prc; ++i)
		if (pw[i])
			printf ("%d ^ %d\n", pr[i], pw[i]);
*/
//	pw[0] = 33;

	big res;
	res.a[0] = 1;
	for (i = 0; i < prc; ++i)
		for (j = 0; j < pw[i]; ++j) {
			res *= pr[i];
//			res.prnt (); printf ("\n");
		}

	res.prnt ();
	printf ("\n");
//	printf ("%d %d\n", res.a[1], res.a[0]);

	return 0;
}
