/*
FROM: USACO 2003 FEBRUARY GREEN
PROB: traffic
KEYW: bfs
*/

#include <cstdio>
#include <queue>

const int MAXTL = 1 << 7;
const int MAXSPEED = 1 << 4;
const int MAXPOS = 1 << 7;

struct tl {
	int pos;
	int Tr, Tg;
	int St;//starting time
};

struct el {
	int speed;
	int pos;
};

int L, TL;//length, trafficlights
tl tls[MAXTL];
int trlid[MAXPOS];

bool pass (int id, int time) {
	int t2 = (time - tls[id].St) % (tls[id].Tr + tls[id].Tg);
	return t2 < tls[id].Tg;
}

bool notrl (int l, int r, int time) {
	for (int i = l + 1; i < r; ++i)
		if (trlid[i] != -1 && !pass (i, time)) return 0;
	return 1;
}

int main () {
	scanf ("%d %d\n", &L, &TL);

	int i = 0;
	int pos, tg, tr, tc;
	char _now;
	for (i = 0; i < MAXPOS; ++i) trlid[i] = -1;
	for (i = 0; i < TL; ++i) {
		scanf ("%d %d %d %c %d\n", &pos, &tg, &tr, &_now, &tc);

		trlid[pos] = i;
		if (_now == 'G')
			tls[i] = (tl) {pos, tr, tg, -tc};
		else
			tls[i] = (tl) {pos, tr, tg, -tc - tg};
	}
/*
	int id, time;
	while (scanf ("%d %d", &id, &time), 1)
		printf ("%d\n", pass (id, time));
*/
	bool used[MAXSPEED][MAXPOS];

	std::queue <el> q, q2;
	std::queue <el> *qq = &q, *qq2 = &q2;
	qq->push ((el) {0, 0});
	int time = 0;

	el crnt;
	while (!qq->empty ()) {
		memset (used, 0, sizeof (used));
		while (!qq->empty ()) {
			crnt = qq->front (); qq->pop ();
//			printf ("%d   %d %d\n", time, crnt.speed, crnt.pos);
			if (crnt.pos == L && crnt.speed < 2 && (trlid[L] == -1 || pass (trlid[L], time))) {
				printf ("%d\n", time);
				return 0;
			}//if we are at speed 1 we break
			if (crnt.pos == L && crnt.speed >= 2) continue;//too fast to do anything

			if (trlid[crnt.pos] != -1 && !pass (trlid[crnt.pos], time)) {
				if (crnt.speed < 2)
					if (!used[0][crnt.pos]) {
						used[0][crnt.pos] = 1;
						qq2->push ((el) {0, crnt.pos});
					}
			} else {//no traffic lignt or it is green
				if (crnt.speed > 0) {//try to break
					if (notrl (crnt.pos, crnt.pos + crnt.speed - 1, time))
						if (!used[crnt.speed - 1][crnt.pos + crnt.speed - 1]) {
							used[crnt.speed - 1][crnt.pos + crnt.speed - 1] = 1;
							qq2->push ((el) {crnt.speed - 1, crnt.pos + crnt.speed - 1});
						}
				}
				if (notrl (crnt.pos, crnt.pos + crnt.speed, time))
					if (!used[crnt.speed][crnt.pos + crnt.speed]) {
						used[crnt.speed][crnt.pos + crnt.speed] = 1;
						qq2->push ((el) {crnt.speed, crnt.pos + crnt.speed});
					}
				if (crnt.speed < 10) {//your speed cannot be more than 10
					if (notrl (crnt.pos, crnt.pos + crnt.speed + 1, time))
						if (!used[crnt.speed + 1][crnt.pos + crnt.speed + 1]) {
							used[crnt.speed + 1][crnt.pos + crnt.speed + 1] = 1;
							qq2->push ((el) {crnt.speed + 1, crnt.pos + crnt.speed + 1});
						}
				}
			}
		}

		swap (qq, qq2);
		++time;
	}

	return 0;
}
