/*
FROM: USACO 2003 MARCH GREEN
PROB: twofour
KEYW: dynamical programming with memory optimization
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cstring>

int N, G;

char *****opt;//wow :)

const char FWIN = 0x00;
const char TIE = 0x01;
const char SWIN = 0x02;
const char UNUSED = 0x03;
const char CL_UPPER = 0x0F;
const char CL_LOWER = 0xF0;

int toint (char a) {
	switch (a) {
		case FWIN: return 1;
		case SWIN: return 2;
		case TIE: return 0;
		default: printf ("not 0 1 2(toint)!\n"); assert (0);
	}
}

void assgn (int a, int b, int c, int d, int e, char val) {
	char &tmp = opt[a][b][c][d][e/2];
	if (e & 1) {
		tmp &= CL_UPPER;
		tmp |= val << 4;
	} else {
		tmp &= CL_LOWER;
		tmp |= val;
	}
}

char get (int a, int b, int c, int d, int e) {
	char tmp = opt[a][b][c][d][e/2];
	if (e & 1)
		return tmp >> 4;
	else
		return tmp & CL_UPPER;
}

int N2;
int N2W;
int N22;
int _23N;

char optf (int c0, int c1, int c3, int c4, int fw) {
	int c2 = N - c0 - c1 - c3 - c4;
	char tmp;

	if (c2 == N && fw == c2 - fw)
		return TIE;

	if (fw >= N2)
		return FWIN;

	if (c2 - fw >= N2)
		return SWIN;

	if ((tmp = get (c0, c1, c3, c4, fw)) != UNUSED)
		return tmp;

// 4, 0 -> 1, 3
	if (c0 && c4) {
		tmp = 0x02 - optf (c0-1, c1+1, c3+1, c4-1, c2 - fw);
		if (tmp < get (c0, c1, c3, c4, fw))
			assgn (c0, c1, c3, c4, fw, tmp);
		if (tmp == 0) return tmp;
	}

// 4, 1 -> 3, 2 -> make one 2
	if (c1 && c4) {
		tmp = 0x02 - optf (c0, c1-1, c3+1, c4-1, c2 - fw);
		if (tmp < get (c0, c1, c3, c4, fw))
			assgn (c0, c1, c3, c4, fw, tmp);
		if (tmp == 0) return tmp;
	}

// 4, 2 -> 3, 3 -> remove one opponents 2 (if possible)
	if (c2 && c4 && c2 > fw) {
		tmp = 0x02 - optf (c0, c1, c3+2, c4-1, c2 - fw - 1);
		if (tmp < get (c0, c1, c3, c4, fw))
			assgn (c0, c1, c3, c4, fw, tmp);
		if (tmp == 0) return tmp;
	}

// 3, 0 -> 2, 1 -> make one 2
	if (c0 && c3) {
		tmp = 0x02 - optf (c0-1, c1+1, c3-1, c4, c2 - fw);
		if (tmp < get (c0, c1, c3, c4, fw))
			assgn (c0, c1, c3, c4, fw, tmp);
		if (tmp == 0) return tmp;
	}

// 3, 1 -> 2, 2 -> make two 2
	if (c1 && c3) {
		tmp = 0x02 - optf (c0, c1-1, c3-1, c4, c2 - fw);
		if (tmp < get (c0, c1, c3, c4, fw))
			assgn (c0, c1, c3, c4, fw, tmp);
		if (tmp == 0) return tmp;
	}

// 2, 0 -> 1, 1 -> remove one opponents 2 (if possible)
	if (c0 && c2 && c2 > fw) {
		tmp = 0x02 - optf (c0-1, c1+2, c3, c4, c2 - fw - 1);
		if (tmp < get (c0, c1, c3, c4, fw))
			assgn (c0, c1, c3, c4, fw, tmp);
		if (tmp == 0) return tmp;
	}
//	printf ("%d %d %d %d %d\n", c0, c1, c3, c4, fw);
	assert (get (c0, c1, c3, c4, fw) != UNUSED);

//	printf ("rett %d %d %d %d %d   %d\n", c0, c1, c3, c4, fw, toint (get (c0, c1, c3, c4, fw)));
	return get (c0, c1, c3, c4, fw);
}

void opt_alloc () {
	N2 = N / 2 + 1;
	N2W = N / 2 + (N & 1);
	N22 = N2 / 2 + (N2 & 1);
	_23N = 2 * N / 3 + 1;
	int i, j, k, l, m;
//	printf ("%d %d %d\n", N2, N22, _23N);
	for (opt = new char **** [N2], i = 0; i < N2; ++i)
		for (opt[i] = new char *** [_23N], j = 0; j < _23N; ++j)
			for (opt[i][j] = new char ** [_23N], k = 0; k < _23N; ++k)
				for (opt[i][j][k] = new char * [N2], l = 0; l < N2; ++l)
					for (opt[i][j][k][l] = new char [N22], m = 0; m < N2; ++m)
						assgn (i, j, k, l, m, UNUSED);
}

int main () {
	scanf ("%d %d", &N, &G);
	opt_alloc ();

	int cnt[5];
	int tmp;
	for (int i = 0; i < G; ++i) {
		memset (cnt, 0, sizeof (cnt));
		for (int j = 0; j < N; ++j) {
			scanf ("%d", &tmp);
			++cnt[tmp];
		}
		printf ("%d\n", toint (optf (cnt[0], cnt[1], cnt[3], cnt[4], cnt[2] / 2)));
	}

	return 0;
}
