/*
ID: iskren81
TASK: expand
LANG: C++
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 15;

struct rec {
	int l, d, r, u;
	rec () {}
	rec (int ll, int dd, int rr, int uu) : l (ll), d (dd), r (rr), u (uu) {}
};

int N;
rec data[MAXN];

int lidx[MAXN], didx[MAXN], ridx[MAXN], uidx[MAXN];

bool lcmp (int a, int b) {return data[a].l < data[b].l;}
bool dcmp (int a, int b) {return data[a].d < data[b].d;}
bool rcmp (int a, int b) {return data[a].r < data[b].r;}
bool ucmp (int a, int b) {return data[a].u < data[b].u;}

bool intersect (int a, int b, int aa, int bb) {
	return ((a <= aa && aa <= b) || (a <= bb && bb <= b) || (aa <= a && b <= bb));
}

int lsrch (int a) {
	int l = -1, r = N, m;
	
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (a > data[lidx[m]].l)
			l = m;
		else
			r = m;
	}
	return r;
}

int dsrch (int a) {
	int l = -1, r = N, m;
	
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (a > data[didx[m]].d)
			l = m;
		else
			r = m;
	}
	return r;
}

int rsrch (int a) {
	int l = -1, r = N, m;
	
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (a > data[ridx[m]].r)
			l = m;
		else
			r = m;
	}
	return r;
}

int usrch (int a) {
	int l = -1, r = N, m;
	
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (a > data[uidx[m]].u)
			l = m;
		else
			r = m;
	}
	return r;
}


int main () {
	FILE *in = fopen ("expand.in", "r");
	
	fscanf (in, "%d", &N);
	
	int i;
	for (i = 0; i < N; ++i) {
		fscanf (in, "%d %d %d %d", &data[i].l, &data[i].d, &data[i].r, &data[i].u);
		lidx[i] = i;
		didx[i] = i;
		ridx[i] = i;
		uidx[i] = i;
	}
	fclose (in);

	std::sort (lidx, lidx + N, lcmp);
	std::sort (didx, didx + N, dcmp);
	std::sort (ridx, ridx + N, rcmp);
	std::sort (uidx, uidx + N, ucmp);

	int cntr =0;

	int j;
	for (i = 0; i < N; ++i) {
		for (j = lsrch (data[i].r); j < N && data[lidx[j]].l == data[i].r; ++j)
			if (intersect (data[i].d, data[i].u, data[lidx[j]].d, data[lidx[j]].u))
				break;
		if (j < N && data[lidx[j]].l == data[i].r) {/*printf ("%d %d 0\n", i, j);*/ continue;}
	
		for (j = rsrch (data[i].l); j < N && data[ridx[j]].r == data[i].l; ++j)
			if (intersect (data[i].d, data[i].u, data[ridx[j]].d, data[ridx[j]].u))
				break;
		if (j < N && data[ridx[j]].r == data[i].l) {/*printf ("%d %d 1\n", i, j);*/ continue;}

		for (j = usrch (data[i].d); j < N && data[uidx[j]].u == data[i].d; ++j)
			if (intersect (data[i].l, data[i].r, data[uidx[j]].l, data[uidx[j]].r))
				break;
		if (j < N && data[uidx[j]].u == data[i].d) {/*printf ("%d %d 2\n", i, j);*/ continue;}
	
		for (j = dsrch (data[i].u); j < N && data[didx[j]].d == data[i].u; ++j)
			if (intersect (data[i].l, data[i].r, data[didx[j]].l, data[didx[j]].r))
				break;
		if (j < N && data[didx[j]].d == data[i].u) {/*printf ("%d %d 3\n", i, j);*/ continue;}

		++cntr;//all tests passed correctly
//		printf (" %d", i);
	}
//	printf ("\n");

	FILE *out = fopen ("expand.out", "w");
	fprintf (out, "%d\n", cntr);
	fclose (out);

	return 0;	
}
