/*
ID: iskren81
PROB: asteroid
LANG: C++
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 9;
const int MAXK = 1 << 14;

struct el {
	int to;
	bool c;
	int next;
	el () {}
	el (int tt, bool cc, int nn) :to (tt), c (cc), next (nn) {}
};

int N, K;
int source, sink;
int vec[MAXN * 2];
el buf[MAXK * 2];

bool used[MAXN*2];

int vis[MAXK*2];
int dfs (int a, int p) {
//	printf ("dfs %d %d\n", a, p);
//	getc (stdin);
	if (a == sink) return p;
	if (a == source && p) return 0;
	used[a] = 1;
	int pp;
	for (int k = vec[a]; k != -1; k = buf[k].next)
		if (buf[k].c && !used[buf[k].to]) {
			vis[p] = k;
//			printf ("writed %d\n", k);
			if ((pp = dfs (buf[k].to, p + 1))) {
				used[a] = 0;
				return pp;
			}
		}
	used[a] = 0;
	return 0;
}

int main () {
	FILE *in = fopen ("asteroid.in", "r");
	
	fscanf (in, "%d %d", &N, &K);

	int i;
	for (i = 0; i < N * 2 + 2; ++i) vec[i] = -1;
	int bp = 0;
	int a, b;
	for (i = 0; i < K; ++i) {
		fscanf (in, "%d %d", &a, &b);
		--a, --b;
		b += N;
		buf[bp] = el (b, 1, vec[a]);
		vec[a] = bp++;
		
		buf[bp] = el (a, 0, vec[b]);
		vec[b] = bp++;
	}
	fclose (in);

	source = 2 * N;
	sink = source + 1;
	
	for (i = 0; i < N; ++i) {
		buf[bp] = el (i, 1, vec[source]);
		vec[source] = bp++;

		buf[bp] = el (source, 0, vec[i]);
		vec[i] = bp++;

		buf[bp] = el (sink, 1, vec[i+N]);
		vec[i+N] = bp++;

		buf[bp] = el (i+N, 0, vec[sink]);
		vec[sink] = bp++;
	}

	int p;
	int res = 0;
	while ((p= dfs (source, 0))) {
//		printf ("%d\n", p);
		for (i = 0; i < p; ++i) {
//			printf (" %d", buf[vis[i]].to);
			buf[vis[i]].c = 0;
			buf[vis[i] + (vis[i] & 1 ? -1 : 1)].c = 1;
		}
//		printf ("\n");
		++res;
	}

	FILE *out = fopen ("asteroid.out", "w");
	fprintf (out, "%d\n", res);
	fclose (out);

	return 0;
}
