/*
ID: iskren81
PROB: twalk
LANG: C++
KEYW: dynamical programming
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 5;
const int MAXM = 1 << 5;
const int MAXLEN = 1 << 3;

int N, M;
char ma3x[MAXN][MAXM];
int opt[MAXN][MAXM][MAXLEN];

void clear_opt () {
	for (int i = 1; i <= N; ++i) for (int j = 1; j <= M; ++j) for (int k = 0; k < MAXLEN; ++k) opt[i][j][k] = 0;
}

int main () {
	FILE *in = fopen ("twalk.in", "r");
	FILE *dict = fopen ("dict.txt", "r");

	fscanf (in, "%d %d\n", &N, &M);

	int i, j;
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= M; ++j)
			fscanf (in, "%c", &ma3x[N + 1 - i][j]);
		fscanf (in, "\n");
	}
	fclose (in);

	int k;
	char w[MAXLEN];
	int res =0;
	while (fgets (w, MAXLEN, dict)) {
		clear_opt ();
		for (i = 1; i <= N; ++i)
			for (j = 1; j <= M; ++j) {
				opt[i][j][0] = opt[i-1][j][0] + opt[i][j-1][0] - opt[i-1][j-1][0] + (ma3x[i][j] == *w);
				for (k = 1; w[k] != '\n'; ++k)
					opt[i][j][k] = 		opt[i-1][j][k]   + opt[i][j-1][k]   - opt[i-1][j-1][k] +
					(ma3x[i][j] == w[k] ? 	opt[i-1][j][k-1] + opt[i][j-1][k-1] - opt[i-1][j-1][k-1] : 0);
			}
		res += opt[N][M][k-1];
	}
	
	fclose (dict);

	FILE *out = fopen ("twalk.out", "w");
	fprintf (out, "%d\n", res);
	fclose (out);

	return 0;
}
