/*
FROM: USACO 2006 December Gold
TASK: patterns
LANG: C++
ID: iskren81
KEYW: binary search, hashing
*/

#include <cstdio>
#include <map>

const int MAXN = 20000;
//#warning fix this!!!
const long long BASE = 1000001ll;//10ll;
const long long MOD = 200560490129ll;

int N, K;
int vec[MAXN];

long long powBaseL;

inline long long mymod (long long x) {
	static long long tmp;
	return ((tmp = x % MOD), tmp < 0) ? tmp + MOD : tmp;
}

inline long long next_hash (long long chash, int rem, int add) {
	chash *= BASE;
	chash -= rem * powBaseL;
	chash += add;
	return mymod (chash);
}

bool can (int l) {
	static std::map <long long, int> hash;
	static std::map <long long, int>::const_iterator ii;
	hash = std::map <long long, int> ();
	powBaseL = 1;
	int i;
	for (i = 0; i < l; ++i) {powBaseL *= BASE; powBaseL %= MOD;}
	long long chash = 0;
	for (i = 0; i < l; ++i) {
		chash *= BASE;
		chash += vec[i];
		chash %= MOD;
	}

//	printf ("%Ld\n", chash);
	++hash[chash];

	for (i = l; i < N; ++i) {
		chash = next_hash (chash, vec[i-l], vec[i]);
//		printf ("%Ld\n", chash);
		++hash[chash];
	}

	for (ii = hash.begin (); ii != hash.end () && ii->second < K; ++ii);
//	printf ("__%d__\n", l);

	return ii != hash.end ();
}

int main () {
	FILE *in = fopen ("patterns.in", "r");
	FILE *out = fopen ("patterns.out", "w");
	fscanf (in, "%d %d", &N, &K);

	int i;
	for (i = 0; i < N; ++i)
		fscanf (in, "%d", vec + i);
	fclose (in);

	int l = 0, r = N, m;
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (can (m))
			l = m;
		else
			r = m;
	}

	fprintf (out, "%d\n", l);
	fclose (out);

	return 0;
}
