/*
FROM: USACO 2006 December Gold
TASK: wormhole
LANG: C++
ID: iskren81
KEYW: bfs, ford-belman, negative cycles
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 9;
const int MAXM = 2500;
const int MAXW = 1 << 8;
const int MAXrM = MAXM * 2 + MAXW;
const int INF = 1000000000;

struct edge {
	int fr;
	int to;
	int dist;
	edge () {}
	edge (int _fr, int _to, int _dist) : fr (_fr), to (_to), dist (_dist) {}
};

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N, M, W;
edge edges[MAXrM];

int vec[MAXN];
el buf[MAXM * 2];
/*
int vec_n[MAXN];
el buf_n[MAXW];
*/
int vec_r[MAXN];
el buf_r[MAXW];

bool /*pfs[MAXN],*/ pts[MAXN];

void bfs (int vec2[], el buf2[], bool r[]) {
	static int q[MAXN];
	static int p3, i, j, c;
	p3 = 0;
	q[p3++] = 0;
	r[0] = 1;

	for (i = 0; i < p3; ++i) {
		c = q[i];
		for (j = vec[c]; j != -1; j = buf[j].next)
			if (!r[buf[j].to]) {
				r[buf[j].to] = 1;
				q[p3++] = buf[j].to;
			}
		for (j = vec2[c]; j != -1; j = buf2[j].next)
			if (!r[buf2[j].to]) {
				r[buf2[j].to] = 1;
				q[p3++] = buf2[j].to;
			}
	}
}

int main () {
	freopen ("wormhole.in", "r", stdin);
	freopen ("wormhole.out", "w", stdout);
	int TC;
	for (scanf ("%d", &TC); TC; --TC) {
		scanf ("%d %d %d\n", &N, &M, &W);

		int i, j, bp = 0, ec = 0, bp2 = 0;
		int a, b, c;
		for (i = 0; i < N; ++i) vec[i] = vec_r[i] = -1;
		for (i = 0; i < M; ++i) {
			scanf ("%d %d %d", &a, &b, &c);
			--a; --b;
	
			edges[ec++] = edge (a, b, c);
			edges[ec++] = edge (b, a, c);
	
			buf[bp] = el (b, vec[a]);
			vec[a] = bp++;

			buf[bp] = el (a, vec[b]);
			vec[b] = bp++;
		}

		for (i = 0; i < W; ++i) {
			scanf ("%d %d %d\n", &a, &b, &c);
			--a; --b; c = -c;

			edges[ec++] = edge (a, b, c);
/*
		buf_n[bp] = el (b, vec_n[a]);
		vec_n[a] = bp;
*/
			buf_r[bp2] = el (a, vec_r[b]);
			vec_r[b] = bp2++;
		}
/*
		printf ("read!\n");
		for (i = 0; i < ec; ++i)
			printf ("%d -> %d (%d)\n", edges[i].fr, edges[i].to, edges[i].dist);

		for (i = 0; i < N; ++i) {
			printf ("%d ->", i);
			for (j = vec[i]; j != -1; j = buf[j].next)
				printf (" %d", buf[j].to);
			printf ("\n");
		}
		for (i = 0; i < N; ++i) {
			printf ("%d ->", i);
			for (j = vec_r[i]; j != -1; j = buf_r[j].next)
				printf (" %d", buf_r[j].to);
			printf ("\n");
		}
*/
		memset (pts, 0, sizeof (pts));
		bfs (vec_r, buf_r, pts);

		static int D[MAXN];
		for (i = 0; i < N; ++i) D[i] = INF;
		for (i = 0; i < 2 * N; ++i)
			for (j = 0; j < ec; ++j)
				if (D[edges[j].to] > D[edges[j].fr] + edges[j].dist)
					D[edges[j].to] = D[edges[j].fr] + edges[j].dist;

		for (j = 0; j < ec; ++j)
			if (D[edges[j].to] > D[edges[j].fr] + edges[j].dist)
				if (pts[edges[j].to])
					break;
		printf ("%s\n", j == ec ? "NO" : "YES");
	}
	return 0;
}
