/*
IMPORTANT: the dinitz algorthm was writen from ME a couple of months ago, I just copied it and modyfied it
FROM: USACO 2006 FEBRUARY GOLD
ID: iskren81
PROB: stead
LANG: C++
KEYW: binary search with dinitz flow
*/

#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <limits>

using std::min;

const int MAXN = 1 << 10;//1020 < 1024 so perfect
const int MAXM = MAXN * 20 * 2;//MAXN * MAXN;

//const int MAXFLOW = std::numeric_limits <int>::max ();

struct el {
	int to;
	int rd;
	int next;
	el () {}
	el (int tt, int rr, int nn) : to (tt), rd (rr), next (nn) {}
};

inline int op (int id) {
	return id + (id & 1 ? -1 : 1);
}

int N, B;
int source, sink;

int vec[MAXN];
el buf[MAXM];

int D[MAXN];
bool used[MAXN];

bool bfs () {
	static int i, j, crnt;
	for (i = 0; i < N; ++i) {
		D[i] = -1;
		used[i] = 0;
	}

	int queue[MAXN];
	int p1 =0, p2 =1, p3 =0, lvl =0;
	queue[p3++] = sink;
	D[sink] = lvl++;

	while (p1 != p2) {
		for (i = p1; i < p2; ++i) {
			crnt = queue[i];
//			printf ("pop %d\n", crnt);
			for (j = vec[crnt]; j != -1; j = buf[j].next) {
				if (D[buf[j].to] == -1 && buf[op (j)].rd) {
//					printf ("\t push %d\n", buf[j].to);
					D[buf[j].to] = lvl;
					queue[p3++] = buf[j].to;
				}
			}
		}
		p1 = p2;
		p2 = p3;
		++lvl;
	}
	used[source] = 1;//prevent returning to the source in the dfs
//	printf ("end bfs!\n");
	return D[source] != -1;
}

int vis[MAXN];
int vp;

bool dfs (int v) {
//	printf ("%d\n", v);
	if (v == sink) {
		used[v] = 0;//unuse the sink for further use
		return 1;
	}
	int i;
	for (i = vec[v]; i != -1; i = buf[i].next) {
		if (buf[i].rd < 0) exit (0);
		if (D[buf[i].to] == D[v] - 1 && !used[buf[i].to] && buf[i].rd) {
//			printf ("%d (from %d)\n", buf[i].to, v);
			used[buf[i].to] = 1;
			vis[vp++] = i;//the number of the edge
			if (dfs (buf[i].to))
				return 1;
			--vp;
			used[buf[i].to] = 0;
		}
	}
//	printf ("%d <-\n", v);
	return 0;//didn't find a path to the sink
}

void prntused () {
	for (int i = 0; i < N; ++i)
		printf ("%d ", used[i]);
	printf ("\n");
}

int dinitz () {
	static int i, maxflow; maxflow = 0;
	while (bfs ()) {
		while (vp =0, dfs (source)) {
			++maxflow;
			for (i = 0; i < vp; ++i) {
				--buf[vis[i]].rd;
				++buf[op (vis[i])].rd;
			}
		}
	}
//	printf ("flow == %d\n", maxflow);
	return maxflow;
}

const int MAXn = 1 << 10;
const int MAXb = 1 << 5;
int n, b;//the n & b of the cows
int ord[MAXn][MAXb];
int cap[MAXb];

void input () {
	FILE *in = fopen ("stead.in", "r");
	fscanf (in, "%d %d", &n, &b);

	source = n + b;
	sink = source + 1;
	N = sink + 1;


	int i, j;
	for (i = 0; i < n; ++i)
		for (j = 0; j < b; ++j)
			fscanf (in, "%d", &ord[i][j]), --ord[i][j];
	for (i = 0; i < b; ++i)
		fscanf (in, "%d", cap + i);
}

int cbest;

void output () {
	FILE *out = fopen ("stead.out", "w");
	fprintf (out, "%d\n", cbest);
	fclose (out);
}

void make_graph (int a, int b) {
	int bp =0;
	int i, j;
	for (i = 0; i < N; ++i) vec[i] = -1;

	for (i = 0; i < n; ++i)
		for (j = a; j < b; ++j) {
			buf[bp] = el (n + ord[i][j], 1, vec[i]);
			vec[i] = bp++;

			buf[bp] = el (i, 0, vec[n + ord[i][j]]);
			vec[n + ord[i][j]] = bp++;
		}

	for (i = 0; i < n; ++i) {
		buf[bp] = el (i, 1, vec[source]);
		vec[source] = bp++;

		buf[bp] = el (source, 0, vec[i]);
		vec[i] = bp++;
	}

	for (i = 0; i < ::b; ++i) {
		buf[bp] = el (sink, cap[i], vec[n + i]);
		vec[n + i] = bp++;

		buf[bp] = el (n + i, 0, vec[sink]);
		vec[sink] = bp++;
	}
/*
	printf ("** %d %d\n", a, b);
	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (j = vec[i]; j != -1; j = buf[j].next)
			printf (" (%d %d)", buf[j].to, buf[j].rd);
		printf ("\n");
	}
*/
}

bool bsrch (int a, int b) {
	int l = a, r = b, m;
	make_graph (a, b);
	if (dinitz () < n) return 0;

	while (l + 1 < r) {
		m = (l + r) / 2;
		if (make_graph (a, m), dinitz () == n)
			r = m;
		else
			l = m;
	}

	if (cbest > r - a)
		cbest = r - a;

	return 1;
}

void solve () {
	int i;
	cbest = b;
	for (i = 0; i < b; ++i) {
		if (!bsrch (i, (i + cbest - 1 < b ? i + cbest - 1: b)) && i + cbest > b) break;
		if (cbest == 1)
			return;
	}
}

int main () {
	input ();
	solve ();
	output ();

	return 0;
}
