/*
ID: iskren81
PROB: corral
LANG: C++
KEYW: coordinate compression, binary search
*/

#include <cstdio>
#include <algorithm>
#include <utility>

const int MAXN = 1 << 9;//500
const int MAXCOOR = 1 << 14;

struct point {
	int x, y;
	point () {}
	point (int xx, int yy) : x (xx), y (yy) {}
//		bool operator < (const point &a) {return (x == a.x ? y < a.y : x < a.y);}
};

int N, C;

point vec[MAXN];

int X[MAXN], Xp;
int Y[MAXN], Yp;

int opt[MAXN][MAXN];

int minD = MAXCOOR;

bool cmp (const point &a, const point &b) {
	return (a.x == b.x ? a.y < b.y : a.x < b.x);
}

inline int here (int a, int b) {
	std::pair <point*, point*> pp = std::equal_range (vec, vec + N, point (X[a], Y[b]), cmp);
	return pp.second - pp.first;
}

inline int insq (int a, int b, int aa, int bb) {
//	printf ("\t\tinsq %d %d %d %d == %d\n", a, b, aa, bb, opt[aa][bb] + (a ? opt[a-1][bb] : 0) + (b ? opt[aa][b-1] : 0) - (a || b ? opt[a-1][b-1] : 0));
	return  opt[aa][bb] - (a ? opt[a-1][bb] : 0) - (b ? opt[aa][b-1] : 0) + (a && b ? opt[a-1][b-1] : 0);
}

inline bool doym (int a, int b, int mm) {
//	printf ("\tdoym - %d %d %d\n", a, b, mm);
	int l = b-1, r = Yp, m;// srch = X[mm] - X[a];

	while (l + 1 < r) {
		m = (l + r) / 2;
		if (insq (a, b, mm, m) >= C)
			r = m;
		else
			l = m;
	}

//	printf ("\t%d -> %d %d\n", r, insq (a, b, mm, r), (r != Yp && Y[r] - Y[b] < X[mm] - X[a]));
	return (r != Yp && Y[r] - Y[b] <= X[mm] - X[a]);
}

inline bool doxm (int a, int b, int mm) {
//	printf ("\tdoxm - %d %d %d\n", a, b, mm);

	int l = a-1, r = Xp, m;//, srch = Y[mm] - Y[b];

	while (l + 1 < r) {
		m = (l + r) / 2;
		if (insq (a, b, m, mm) >= C)
			r = m;
		else
			l = m;
	}

//	printf ("\t%d -> %d %d\n", r, insq (a, b, r, mm), (r != Xp && X[r] - X[a] < Y[mm] - Y[b]));
	return (r != Xp && X[r] - X[a] <= Y[mm] - Y[b]);
}

inline void doit (int a, int b) {
//	printf ("doit %d %d\n", a, b);
	int l, r, m;

	l = a - 1, r = Xp;
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (doym (a, b, m))
			r = m;
		else
			l = m;
	}

//	printf ("part1 %d - %d\n", r, X[r] - X[a] + 1);
	if (r != Xp && X[r] - X[a] + 1 < minD)
		minD = X[r] - X[a] + 1;

	l = b - 1, r = Yp;
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (doxm (a, b, m))
			r = m;
		else
			l = m;
	}

//	printf ("part2 %d - %d\n", r, Y[r] - Y[b] + 1);
	if (r != Yp && Y[r] - Y[b] + 1 < minD)
		minD = Y[r] - Y[b] + 1;
}

int main () {
	FILE *in = fopen ("corral.in", "r");
	fscanf (in, "%d %d", &C, &N);

	int i, j;
	for (i = 0; i < N; ++i)
		fscanf (in, "%d %d", &vec[i].x, &vec[i].y);
	fclose (in);

	for (i = 0; i < N; ++i) {
		X[i] = vec[i].x;
		Y[i] = vec[i].y;
	}

	std::sort (vec, vec + N, cmp);
	std::sort (X, X + N);
	std::sort (Y, Y + N);

	Xp = std::unique (X, X + N) - X;
	Yp = std::unique (Y, Y + N) - Y;

	X[Xp] = X[Xp] - 1;
	Y[Yp] = Y[Yp] - 1;

	opt[0][0] = here (0, 0);
	for (i = 1; i < Xp; ++i)
		opt[i][0] = here (i, 0) + opt[i-1][0];

	for (i = 1; i < Yp; ++i)
		opt[0][i] = here (0, i) + opt[0][i-1];

	for (i = 1; i < Xp; ++i) {
		for (j = 1; j < Yp; ++j)
			opt[i][j] = opt[i-1][j] + opt[i][j-1] - opt[i-1][j-1] + here (i, j);
	}

	for (i = 0; i < Xp; ++i)
		for (j = 0; j < Yp; ++j) {
			doit (i, j);
		}

	FILE *out = fopen ("corral.out", "w");
	fprintf (out, "%d\n", minD);
	fclose (out);

	return 0;
}
