/*
ID: iskren81
PROB: corral
LANG: C++
*/

#include <cstdio>
#include <algorithm>
#include <utility>

const int MAXN = 1 << 9;
const int MAXCOOR = 1 << 14;

struct point {
	int x, y;
	point () {}
	point (int xx, int yy) : x (xx), y (yy) {}
	bool operator < (const point &a) const {return (x == a.x ? y < a.y : x < a.x);}
};

int C, N;

point data[MAXN];
int X[MAXN], Xc;
int Y[MAXN], Yc;

int opt[MAXN][MAXN];

int best = MAXCOOR;

int in_rec (int x1, int y1, int x2, int y2) {
//	printf ("\tin_req %d %d %d %d - %d\n", x1, y1, x2, y2, opt[x2][y2] - (x1 ? opt[x1-1][y2] : 0) - (y1 ? opt[y1-1][x2] : 0) + (x1 && y1 ? opt[x1-1][y1-1] : 0));
//	printf ("+%d(%d %d)\t", opt[x2][y2], x2, y2);
//	(y1 ? printf ("-%d(%d %d)\t", opt[x2][y1-1], x2, y1 - 1) : ;);
//	(x1 ? printf ("-%d(%d %d)\t", opt[x1-1][y2], x1-1, y2) : ;);
//	(x1 && y1 ? printf ("+%d(%d %d)\n", opt[x1-1][y1-1], x1-1, y1-1) : ;);
	return opt[x2][y2] - (x1 ? opt[x1-1][y2] : 0) - (y1 ? opt[x2][y1-1] : 0) + (x1 && y1 ? opt[x1-1][y1-1] : 0);
}

bool bsrch1y (int x1, int y1, int x2) {
	int l = y1-1, r = Yc, m;
	int dist = X[x2] - X[x1];
//	printf ("bsrch1y %d %d %d -> %d\n", x1, y1, x2, dist);

	while (l + 1 < r) {
		m = (l + r) / 2;
//		printf ("\t%d -> %d %d\n", m, Y[m], Y[y1]);
		if (dist > Y[m] - Y[y1])
			l = m;
		else
			r = m;
	}
	if (r == Yc || Y[r] - Y[y1] > dist)
		--r;

//	printf ("bsrch1y %d %d %d - %d - %d\n", x1, y1, x2, r, in_rec (x1, y1, x2, r));

	return in_rec (x1, y1, x2, r) >= C;
}

void bsrch0x (int x, int y) {
	int l = x - 1, r = Xc, m;

	while (l + 1 < r) {
		m = (l + r) / 2;
		if (bsrch1y (x, y, m))
			r = m;
		else
			l = m;
	}

	if (r != Xc &&
		best > X[r] - X[x] + 1)
		best = X[r] - X[x] + 1;
}

bool bsrch1x (int x1, int y1, int y2) {
	int l = x1-1, r = Xc, m;
	int dist = Y[y2] - Y[y1];
//	printf ("bsrch1y %d %d %d -> %d\n", x1, y1, x2, dist);

	while (l + 1 < r) {
		m = (l + r) / 2;
//		printf ("\t%d -> %d %d\n", m, Y[m], Y[y1]);
		if (dist > X[m] - X[x1])
			l = m;
		else
			r = m;
	}
	if (r == Xc || X[r] - X[x1] > dist)
		--r;

//	printf ("bsrch1y %d %d %d - %d - %d **%d**(%d)\n", x1, y1, y2, r, in_rec (x1, y1, r, y2), dist, best);

	return in_rec (x1, y1, r, y2) >= C;
}

void bsrch0y (int x, int y) {
	int l = y - 1, r = Yc, m;

	while (l + 1 < r) {
		m = (l + r) / 2;
		if (bsrch1x (x, y, m))
			r = m;
		else
			l = m;
	}
	if (r != Yc &&
		best > Y[r] - Y[y] + 1) {
		best = Y[r] - Y[y] + 1;
	}
}

int here (int x, int y) {
	std::pair <point*, point*> pp = std::equal_range (data, data + N, point (X[x], Y[y]));
	return pp.second - pp.first;
}

int main () {
	FILE *in = fopen ("corral.in", "r");

	fscanf (in, "%d %d", &C, &N);

	int i, j;
	for (i = 0; i < N; ++i) {
		fscanf (in, "%d %d", &data[i].x, &data[i].y);
		X[i] = data[i].x;
		Y[i] = data[i].y;
	}
	fclose (in);

	std::sort (X, X + N);
	std::sort (Y, Y + N);

	Xc = std::unique (X, X + N) - X;
	Yc = std::unique (Y, Y + N) - Y;

	std::sort (data, data + N);

	opt[0][0] = here (0, 0);
	for (i = 1; i < Xc; ++i)
		opt[i][0] = opt[i-1][0] + here (i, 0);
	for (j = 1; j < Yc; ++j)
		opt[0][j] = opt[0][j-1] + here (0, j);
	for (i = 1; i < Xc; ++i)
		for (j = 1; j < Yc; ++j)
			opt[i][j] = opt[i-1][j] + opt[i][j-1] - opt[i-1][j-1] + here (i, j);

	for (i = 0; i < Xc; ++i)
		for (j = 0; j < Yc; ++j) {
			bsrch0x (i, j);
			bsrch0y (i, j);
		}

	FILE *out = fopen ("corral.out", "w");
	fprintf (out, "%d\n", best);
	fclose (out);

	return 0;
}
