/*
ID: iskren81
PROB: rpaths
LANG: C++
*/

#include <cstdio>
#include <utility>

const int MAXN = 1 << 13;//5000(a bit wasteful...)
const int MAXM = 1 << 14;//10000

struct el {
	int to;
	int next;
	int type;//0 -> normal, 1 -> son, 2-> father
	el () {}
	el (int _to, int _next, int _type) : to (_to), next (_next), type (_type) {}
};

struct el2 {
	int to;
	int next;
	el2 () {}
	el2 (int _to, int _next) : to (_to), next (_next) {}
};

int N, M;
int vec[MAXN];
el buf[MAXM * 2];

inline int op (int a) {
	return a + (a & 1 ? -1 : 1);
}

int lowest[MAXN];
int prenum[MAXN];

bool artic[MAXM * 2];

std::pair <int, int> artic_vec [MAXM];
int avp;

int used[MAXN];
int leaf_cnt;

void dfs (int v) {
	static int cN = 0;
//	printf ("dfs - %d(%d)\n", v, cN);

	prenum[v] = cN++;

	lowest[v] = prenum[v];
	for (int i = vec[v]; i != -1; i = buf[i].next) {
		if (buf[i].type) continue;//it is father (cannot be son)
		if (prenum[buf[i].to] == -1) {
			buf[i].type = 1;
			buf[op (i)].type = 2;
			dfs (buf[i].to);

			if (lowest[buf[i].to] > prenum[v]) {
				artic[i] = artic[op (i)] = 1;
				artic_vec[avp++] = std::pair <int, int> (v, buf[i].to);
			}

			if (lowest[v] > lowest[buf[i].to])
				lowest[v] = lowest[buf[i].to];
		} else {
			if (lowest[v] > prenum[buf[i].to])
				lowest[v] = prenum[buf[i].to];
		}
	}
//	printf ("<- %d - %d %d\n", v, prenum[v], lowest[v]);
}

int nG;
int group[MAXN];

void dfs2 (int v, int g) {
	group[v] = g;
	for (int i = vec[v]; i != -1; i = buf[i].next) {
		if (artic[i] || group[buf[i].to] != -1) continue;
//		printf ("%d(%d) -> %d\n", v, g, buf[i].to);
		dfs2 (buf[i].to, g);
	}
}

int vec2[MAXN];
el2 buf2[MAXN];//no more than N artic arcs

void dfs3 (int v) {
//	printf ("dfs3 %d\n", v);
	used[v] = 1;

	int flag = 0;
	for (int i = vec2[v]; i != -1; i = buf2[i].next) {
		if (used[buf2[i].to]) {
//			printf ("try %d -> %d\n", v, buf2[i].to);
			continue;
		}
		++flag;
//		printf ("%d -> %d\n", v, buf2[i].to);
		dfs3 (buf2[i].to);
	}

	if ((v != 0 && flag == 0) || (v == 0 && flag < 2)) {
//		printf ("%d is a leaf!\n", v);
		++leaf_cnt;
	}
}

int main () {
	FILE *in = fopen ("rpaths.in", "r");

	fscanf (in, "%d %d", &N, &M);

	int i;
	int a, b;
	int bp =0;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		fscanf (in, "%d %d", &a, &b);
		--a; --b;

		buf[bp] = el (b, vec[a], 0);
		vec[a] = bp++;

		buf[bp] = el (a, vec[b], 0);
		vec[b] = bp++;
	}
/*
	int j;
	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (j = vec[i]; j != -1; j = buf[j].next)
			printf (" %d", buf[j].to);
		printf ("\n");
	}
*/
	for (i = 0; i < N; ++i) prenum[i] = -1;

	dfs (0);
/*
	for (i = 0; i < bp; ++i)
		if (artic[i])
			printf ("%d ", i);
	printf ("\n");
*/
	for (i = 0; i < N; ++i) group[i] = -1;
	for (i = 0; i < N; ++i)
		if (group[i] == -1)
			dfs2 (i, nG++);
/*
	for (i = 0; i < N; ++i)
		printf ("%d ", group[i]);
	printf ("\n");
*/
	int bp2 =0;
	for (i = 0; i < nG; ++i) vec2[i] = -1;
	for (i = 0; i < avp; ++i) {
//		printf ("adding %d %d\n", artic_vec[i].first, artic_vec[i].second);
		buf2[bp2] = el2 (group[artic_vec[i].first], vec2[group[artic_vec[i].second]]);
		vec2[group[artic_vec[i].second]] = bp2++;

		buf2[bp2] = el2 (group[artic_vec[i].second], vec2[group[artic_vec[i].first]]);
		vec2[group[artic_vec[i].first]] = bp2++;
	}

	int j;
	for (i = 0; i < nG; ++i) {
		printf ("%d ->", i);
		for (j = vec2[i]; j != -1; j = buf2[j].next)
			printf (" %d", buf2[j].to);
		printf ("\n");
	}

	dfs3 (0);

	if (nG == 1) leaf_cnt = 0;

	printf ("%d\n", leaf_cnt);
	FILE *out = fopen ("rpaths.out", "w");
	fprintf (out, "%d\n", (leaf_cnt >> 1) + (leaf_cnt & 1 ? 1 : 0));
	fclose (out);

	return 0;
}
