	/*
FROM: USACO 2006 MARCH GOLD
ID: iskren81
PROB: tselect
KEYW: dynamical programming, tele-type, NEW
LANG: C++
*/

#include <cstdio>
#include <vector>

const int MAXN = 1 << 9;
const int infinity = 1 << 29;

//inline int max (int a, int b) {return a > b ? a : b;}

int N, X;
int g[MAXN];//give
std::vector <std::vector <int> > vec;

int opt[MAXN][MAXN][2];
int cnt[MAXN];

void solve (int a) {
	cnt[a] = 1;
	int i, k, w, tmp;
	for (i = 0; i < (int)vec[a].size (); ++i) {
		solve (vec[a][i]);
		cnt[a] += cnt[vec[a][i]];
	}

	opt[a][0][0] = 0;//take absolutely nothing
	opt[a][0][1] = g[a];

	for (i = 0; i < (int)vec[a].size (); ++i)
		for (k = cnt[a]; k >= 0; --k)
			for (w = 0; w <= k; ++w)
				opt[a][k][0] >?= opt[a][k-w][0] + (opt[vec[a][i]][w][0] >? opt[vec[a][i]][w][1]);

	for (i = 0; i < (int)vec[a].size (); ++i)
		for (k = cnt[a]; k >= 0; --k)
			for (w = 0; w <= k; ++w) {
				opt[a][k][1] >?= opt[a][k-w][1] + opt[vec[a][i]][w][0];
				if (w != k)
					opt[a][k][1] >?= opt[a][k-w-1][1] + opt[vec[a][i]][w][1];
			}
}

int main () {
	freopen ("tselect.in", "r", stdin);
	freopen ("tselect.out", "w", stdout);

	scanf ("%d %d", &N, &X);
	vec.resize (N+1);

	int i, j;
	int a, b;
	for (i = 1; i <= N; ++i) {
		scanf ("%d %d", &a, &b);

		g[i] = a;
		vec[b].push_back (i);
	}
	g[0] = 0;//just in case

	for (i = 0; i < MAXN; ++i)
		for (j = 0; j < MAXN; ++j)
			opt[i][j][0] = opt[i][j][1] = -infinity;

	solve (0);

	for (i = N; i >= 0 && opt[0][i][0] < X; --i);
	printf ("%d\n", i);

	return 0;
}
