/*
FROM: USACO 2006 MARCH GOLD
PROB: tselect
KEYW: back track, heap
ID: iskren81
LANG: C++
*/

#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 1 << 9;

int N;

int m[MAXN];
std::vector <std::vector <int> > vec;

struct el {
	int *use;
	int *nouse;
	int usz, nosz;
	el () {use = new int [MAXN]; nouse = new int [MAXN]; for (int i = 0; i < MAXN; ++i) use[i] = nouse[i] = -1000000000;}
	el (int *_use, int *_nouse, int _usesz, int _nosz) : use (_use), nouse (_nouse), usz (_usesz), nosz (_nosz) {}
};

el upgrade (el a, el b) {
	el res;
	res.use = new int [MAXN];
	res.nouse = new int [MAXN];

	int i, k;
	for (i = 0; i <= a.usz + b.usz; ++i)
		for (k = 0; k <= i; ++i) {
			res.use[i] >?= max ((k ? b.use[k-1] : 0), b.nouse[k]) + a.use [i - k];
			res.nouse[i] >?= max (b.use[k], b.nouse[k]) + a.nouse[i - k];
		}
	res.usz = res.nosz = a.usz + b.usz + 1;
	return res;
}

el dfs (int a) {
	if (vec[a].empty ()) {
		el res;
		res.use[0] = m[a];
		res.usz = 1;

		res.nouse[0] = 0;
		res.nosz = 1;

		return res;
	}

	int i =0;
	el res;
	el tmp = dfs (vec[a][0]);
	res.use[0] = m[0] + tmp.nouse[0];
	res.nouse[0] = max (tmp.use[i], tmp.nouse[i]);
	for (i = 1; i < tmp.usz; ++i) {
		res.use[i] = max (tmp.use[i-1], tmp.nouse[i]) + m[a];
		res.nouse[i] = max (tmp.use[i], tmp.nouse[i]);
	}

	for (i = 1; i < (int)vec[a].size (); ++i)
		res = upgrade (res, dfs (vec[a][i]));

	return res;
}

int main () {
	scanf ("%d", &N);

	int i, a;
	vec.resize (N);
	bool head[MAXN] = {0};
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", m + i, &a);
		--a;

		if (a != -1) vec[a].push_back (i);
		else head[i] = 1;
	}

	std::vector <el> all;
	for (i = 0; i < N; ++i)
		if (head[i])
			all.push_back (dfs (i));

	for (i = 0; i < (int)all.size (); ++i) {
		for (int j = 0; j < all[i].usz; ++j)
			printf ("%d ", all[i].use[j]); printf ("\n");
		for (int j = 0; j < all[i].nosz; ++j)
			printf ("%d ", all[i].nouse[j]); printf ("\n");
	}

	return 0;
}
