/*
FROM: USACO 2006 November Gold
TASK: block
LANG: C++
ID: iskren81
KEYW: second shortest path; dijkstra with stl heap
*/

#include <cstdio>
#include <queue>
#include <utility>
#include <vector>

using std::make_pair;

#define TO second
#define DIST first

const int MAXN = 1 << 13;
const int MAXM = 1 << 17;

struct el {
	int to;
	int dist;
	int next;
	el () {}
	el (int _to, int _dist, int _next) : to (_to), dist (_dist), next (_next) {}
};

int N, M;
int vec[MAXN];
el buf[MAXM << 1];
int d[2][MAXN];

struct CMP {
	bool operator () (const std::pair <int, int> &a, const std::pair <int, int> &b) {
		return a.first != b.first ?
					a.first > b.first :
					a.second < b.second;
	}
};

int dijkstra () {
	static std::priority_queue <std::pair <int, int>, std::vector <std::pair <int, int> >, CMP > q;
	static int i;
	for (i = 0; i < N; ++i) d[0][i] = d[1][i] = -1;
	q.push (make_pair (0, 0));
	std::pair <int, int> crnt;
	while (!q.empty ()) {
		crnt = q.top (); q.pop ();

		if (d[0][crnt.TO] == -1) {
			d[0][crnt.TO] = crnt.DIST;
//			if (crnt.TO == N-1) continue;//cannot continue from the end
		} else if (d[1][crnt.TO] == -1 && d[0][crnt.TO] != crnt.DIST)
			d[1][crnt.TO] = crnt.DIST;
		else continue;
		
//		printf ("%d %d (%d %d)\n", crnt.TO, crnt.DIST, d[0][crnt.TO], d[1][crnt.TO]);

		for (i = vec[crnt.TO]; i != -1; i = buf[i].next) {
			if (d[1][buf[i].to] == -1) {
//				printf ("push %d %d\n", buf[i].to, buf[i].dist + crnt.DIST);
				q.push (make_pair (buf[i].dist + crnt.DIST, buf[i].to));
			}
		}
	}
	return d[1][N-1];
}

int main () {
	FILE *in = fopen ("block.in", "r");
	FILE *out = fopen ("block.out", "w");

	int i;
	fscanf (in, "%d %d", &N, &M);

	int a, b, d, bp = 0;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		fscanf (in, "%d %d %d", &a, &b, &d);

		--a; --b;
		buf[bp] = el (b, d, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, d, vec[b]);
		vec[b] = bp++;
	}
	fclose (in);

	fprintf (out, "%d\n", dijkstra ());
	fclose (out);

	return 0;
}
