/*
FROM: USACO OPEN 2006
PROB: cfair
KEYW: dynamical programming
LANG: C++
ID: iskren81
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 9;

int N;

int T[MAXN];
int ma3x[MAXN][MAXN];
int opt[MAXN];
int idx[MAXN];

bool cmp (int a, int b) {
	return T[a] < T[b];
}

int main () {
	freopen ("cfair.in", "r", stdin);
	freopen ("cfair.out", "w", stdout);

	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i)
		scanf ("%d", T + i);

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			scanf ("%d", &ma3x[i][j]);

	for (i = 0; i < N; ++i) idx[i] = i;
	std::sort (idx, idx + N, cmp);

	for (i = 0; i < N; ++i) if (ma3x[0][i] <= T[i]) opt[i] = 1;

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			if (j == idx[i]) continue;
			if (ma3x[idx[i]][j] + T[idx[i]] <= T[j]) {
				if (opt[j] < opt[idx[i]] + 1) {
					opt[j] = opt[idx[i]] + 1;
//					printf ("update opt[%d] -- %d\n", j, opt[j]);
				}
			}
		}

	int best = 0;
	for (i = 0; i < N; ++i) best >?= opt[i];

	printf ("%d\n", best);

	return 0;
}
