/*
FROM: USACO OPEN 2006
PROB: twohead
KEYW: graph, sort
LANG: C++
ID: iskren81
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 15;
const int MAXM = 1 << 16;

struct edge {
	int f, s;
	bool inv;
};

int N, M;

edge vec[MAXM];
int opt[MAXN];

bool cmp (const edge &a, const edge &b) {
	return a.s < b.s;
}

int f (int a, bool b) {
	return b ? a : -a;
}

int beg = 0;
int grc = 1;

int buf[MAXN];
int bp;

void fff (int i, bool save) {
	if (vec[i].f < beg) return;
	if (opt[vec[i].f]) {
		if (opt[vec[i].s] == f (opt[vec[i].f], vec[i].inv)) {
			++grc;
			beg = vec[i].s;
		} else
			opt[vec[i].s] = -f (opt[vec[i].f], vec[i].inv);
	} else if (opt[vec[i].s]) {
		if (opt[vec[i].f] == f (opt[vec[i].s], vec[i].inv)) {
			++grc;
			beg = vec[i].s;
		} else
			opt[vec[i].f] = -f (opt[vec[i].s], vec[i].inv);
	} else if (save) {
		buf[bp++] = i;
	} else {
		opt[vec[i].f] = 1;
		opt[vec[i].s] = -f (1, vec[i].inv);
	}
}

int main () {
//	freopen ("twohead.in", "r", stdin);
//	freopen ("twohead.out", "w", stdout);

	scanf ("%d %d\n", &N, &M);

	int i;
	int a, b;
	char x, y;
	int vp = 0;
	for (i = 0; i < M; ++i) {
		scanf ("%d %c %d %c\n", &a, &x, &b, &y);
		--a; --b;
		if (a == b) continue;
		vec[vp].f = a <? b;
		vec[vp].s = a >? b;
		vec[vp++].inv = x == y;
	}
	M = vp;

	std::sort (vec, vec + M, cmp);
	for (i = 0; i < M; ++i) printf ("%d %d %d\n", vec[i].f, vec[i].s, vec[i].inv);

	fff (0, 1);
	for (i = 1; i < M; ++i) {
		if (vec[i].s != vec[i-1].s) {
			printf ("i == %d flush!\n", i);
			for (int j = 0; j < bp; ++j)
				fff (buf[j], 0);
			for (int j = 0; j < vec[i].s; ++j) printf ("%d ", opt[j ]); printf ("\n");
			bp = 0;
		}
		fff (i, 1);
	}
	for (int j = 0; j < bp; ++j)
		fff (buf[j], 0);

	printf ("%d\n", grc);
	return 0;
}
