/*
ID: iskren81
LANG: C++

FROM: USACO 2007 FEBRUARY GOLD
PROB: lilypad
KEYW: bfs, dynamical programming
*/

#include <cstdio>
#include <cstring>
#include <vector>

const int MAXN = 1 << 5;
const int MAXM = 1 << 5;
const int MAXP = MAXN * MAXM;

const int dx[] = {-2, -2, -1, 1, 2, 2, 1, -1};
const int dy[] = {-1, 1, 2, 2, 1, -1, -2, -2};

struct pos {
	int a;
	pos () {}
	pos (int x, int y) : a (y << 5 | x) {}
	int X () {return a & 0x1f;}
	int Y () {return (a >> 5) & 0x1f;}
	bool operator == (const pos &x) {return x.a == a;}
	bool operator != (const pos &x) {return x.a != a;}
};

int N, M;
pos _q1[MAXP], _q2[MAXP];
pos *cq = _q1, *nq = _q2, fq[MAXP];
int cqp, nqp, fqp;
int D[MAXN][MAXM];
bool used[MAXN][MAXM];
std::vector <pos> ls[MAXN][MAXM];//lilypad shit

int board[MAXN][MAXM];
long long dp[MAXN][MAXM];
pos S, F;//start, finish

void add_vec (int x, int y, const pos &val) {
	static unsigned i;
	for (i = 0; i < ls[x][y].size () && ls[x][y][i] != val; ++i);
	if (i == ls[x][y].size ()) {
//		printf ("push!\n");
		ls[x][y].push_back (val);
	}
}

void cp_vec (int fx, int fy, int tx, int ty) {
	static unsigned i;
	for (i = 0; i < ls[fx][fy].size (); ++i)
		add_vec (tx, ty, ls[fx][fy][i]);
}

pos q2[MAXN * MAXM];
int q2p;

void bfs2 (int sx, int sy) {
	static int i, k, nx, ny;
	q2[q2p = 0, q2p++] = pos (sx, sy);
	used[sx][sy] = 1;

//	printf ("bfs2 %d %d ---\n", sx, sy);
	for (i = 0; i < q2p; ++i) {
//		printf ("popped %d %d\n", q2[i].X (), q2[i].Y ());
		for (k = 0; k < 8; ++k) {
			nx = q2[i].X() + dx[k];
			ny = q2[i].Y() + dy[k];
			if (nx >= 0 && nx < N
			 && ny >= 0 && ny < M
			 && !used[nx][ny]
			 && board[nx][ny] != 2
			 && board[nx][ny]) {
				used[nx][ny] = 1;
				q2[q2p++] = pos (nx, ny);
			}
		}
	}
	
}

int main () {
	freopen ("lilypad.in", "r", stdin);
	freopen ("lilypad.out", "w", stdout);

	scanf ("%d %d", &N, &M);

	int i, j, k;
	for (i = 0; i < N; ++i)
		for (j = 0; j < M; ++j) {
			scanf ("%d", board[i] + j);
			if (board[i][j] == 3) {//start
				S = pos (i, j);
			} else if (board[i][j] == 4) {//finish
				F = pos (i, j);
			}
		}
//	printf ("%d %d %d %d\n", S.X(), S.Y(), F.X(), F.Y());
	memset (D, -1, sizeof (D));

	//BEGIN bfs
	cq[cqp++] = S;
	D[S.X()][S.Y()] = 0;

	int gox, goy;
	while (cqp) {
		for (i = 0; i < cqp; ++i) {
//			printf ("pop %d %d %d\n", cq[i].X(), cq[i].Y(), D[cq[i].X()][cq[i].Y()]);
			fq[fqp++] = cq[i];
			if (cq[i] == F) goto end_this_shit;
			for (k = 0; k < 8; ++k) {
				gox = cq[i].X () + dx[k];
				goy = cq[i].Y () + dy[k];
				if (gox >= 0 && gox < N
				 && goy >= 0 && goy < M
				 && D[gox][goy] == -1
				 && board[gox][goy] != 2) {
//				 	printf ("\tpush %d %d\n", gox, goy);
					if (board[gox][goy] == 0) {
						D[gox][goy] = D[cq[i].X ()][cq[i].Y ()] + 1;
						nq[nqp++] = pos (gox, goy);
					} else {//step on lilypad
						D[gox][goy] = D[cq[i].X ()][cq[i].Y ()];
						cq[cqp++] = pos (gox, goy);
					}
				}
			}
		}
		std::swap (cq, nq);
		std::swap (cqp, nqp);
		nqp = 0;
	}
	printf ("-1\n"); return 0;
	end_this_shit:;
	//END bfs
	printf ("%d\n", D[F.X()][F.Y()]);

	dp[S.X()][S.Y()] = 1;
	ls[S.X()][S.Y()].push_back (S);
	int cx, cy, ox, oy;
//	int cx2, cy2;
	int ii, beg = 0;
	bool flag = 0;
	fq[fqp++] = pos (N, M); board[N][M] = 0;
	for (i = 1; i < fqp; ++i) {
		cx = fq[i].X();
		cy = fq[i].Y();
//		printf ("pop %d %d\n", cx, cy);
		if (board[cx][cy] && !flag) {//it is the first lilypad
//			printf ("opening!\n");
			flag = 1;
			beg = i;
/*			cx2 = N;
			cy2 = M;
			ls[cx2][cy2].clear ();*/
		} else if (!board[cx][cy] && flag) {//it is first !lilypad
//			printf ("closing!\n");
			flag = 0;
			for (j = beg; j < i; ++j) {
				if (used[fq[j].X ()][fq[j].Y ()]) continue;
				bfs2 (fq[j].X(), fq[j].Y());
				ls[N][M].clear ();
				for (ii = 0; ii < q2p; ++ii)
					cp_vec (q2[ii].X (), q2[ii].Y (),  N, M);
				for (ii = 0; ii < q2p; ++ii)
					ls[q2[ii].X()][q2[ii].Y()] = ls[N][M];
			}
		}
		if (cx == N && cy == M) break;
		for (k = 0; k < 8; ++k) {
			ox = cx + dx[k];
			oy = cy + dy[k];
//			printf ("\ttry %d %d (%d)\n", ox, oy, D[ox][oy] + !board[cx][cy] == D[cx][cy]);
			if (ox >= 0 && ox < N
			 && oy >= 0 && oy < M
			 && D[ox][oy] + !board[cx][cy] == D[cx][cy]) {
//			 	printf ("\tYES!!\n");
				if (board[ox][oy]) {//it is L
					cp_vec (ox, oy, cx, cy);
				} else {
					add_vec (cx, cy, pos (ox, oy));
				}
			}
		}
		if (!board[cx][cy])
			for (k = 0; k < (int)ls[cx][cy].size (); ++k)
				dp[cx][cy] += dp[ls[cx][cy][k].X()][ls[cx][cy][k].Y()];
//		printf ("%d %d --> %Ld\n", cx, cy, dp[cx][cy]);
	}

	for (k = 0; k < (int)ls[N][M].size (); ++k)
		dp[N][M] += dp[ls[N][M][k].X()][ls[N][M][k].Y()];
	printf ("%Ld\n", dp[N][M]);

	return 0;
}
