/*
ID: iskren81
LANG: C++
TASK: lineup

FROM: USACO 2007 March Gold
PROB; lineup
KEYW: hash map
*/

#include <cstdio>
//#include <vector>
#include <cstring>
#include <ext/hash_map>

using namespace __gnu_cxx;
using namespace std;

const int MOD = 1073676287;
const int BASE = 27644437;
const int MAXM = 32;

struct VI {
	int a[MAXM];
	VI () {memset (a, 0, sizeof (a));}
	VI& operator = (const VI &x) {memcpy (a, x.a, sizeof (a)); return *this;}
	int& operator [] (const int i) {return a[i];}
};

//typedef vector <int> VI;

int N, M;
struct myhash {
	size_t operator () (const VI &a) const {
		static int i;
		static unsigned long long res;
		for (i = res = 0; i < M; ++i) {
			res *= BASE;
			res += a.a[i];
			res %= MOD;
		}

		return (size_t)res;
	}
};

struct myeq {
	bool operator () (const VI &a, const VI &b) const {
		static int i;
		for (i = 0; i < M && a.a[i] == b.a[i]; ++i);
		return i == M;
	}
};


hash_map <VI, int, myhash, myeq> htbl (100000);

int main () {
	FILE *in = fopen ("lineup.in", "r");
	FILE *out = fopen ("lineup.out", "w");
//	FILE *in = stdin;
//	FILE *out = stdout;

	fscanf (in, "%d %d", &N, &M);

	int i, j;
	unsigned id;
	bool f;
	hash_map <VI, int, myhash, myeq> :: iterator it;
	VI cvec;
	htbl.insert (make_pair (cvec, -1));
	int best = 0;
	for (i = 0; i < N; ++i) {
		fscanf (in, "%u", &id);
		f = 1;
		for (j = 0; j < M; ++j) {
			if (id & 1) ++cvec[j];
			id >>= 1;
			f &= !!cvec[j];//we want at least one 0
		}

		if (f) {
//			printf ("dec!\n");
			for (j = 0; j < M; ++j)
				--cvec[j];
		}

//		for (j = 0; j < M; ++j) printf (" %d", cvec[j]); puts ("");
		if ((it = htbl.find (cvec)) != htbl.end ())
			best >?= i - it->second;
		else if (i + best < N) {
//			printf ("push %d\n", i);
			htbl.insert (make_pair (cvec, i));
		}
	}

	fprintf (out, "%d\n", best);

	return 0;
}
