/*
ID: iskren81
TASK: ranking
LANG: C++

FROM: USACO 2007 March Gold
PROB: ranking
KEYW: graph, conectivity
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 10;
const int MAXM = 1 << 14;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N, M;
int NN;
int vec[MAXN];
el buf[MAXM];
int out[MAXN];
bool start_from[MAXN];

unsigned db[MAXN][MAXN / 32];

void set (int line, int bit) {
	db[line][bit / 32] |= 1 << (bit & 31);
}

void upd (int to, int fr) {
	for (int i = 0; i < NN; ++i)
		db[to][i] |= db[fr][i];
}

bool ask (int a, int b) {
	return 	((db[a][b >> 5] >> (b & 31)) & 1)
		||  ((db[b][a >> 5] >> (a & 31)) & 1);
}

int main () {
	freopen ("ranking.in", "r", stdin);
	freopen ("ranking.out", "w", stdout);

	scanf ("%d %d", &N, &M);
	NN = N / 32 + 1;

	int a, b;
	memset (vec, -1, sizeof (vec));
	memset (start_from, -1, sizeof (start_from));
	for (int i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		start_from[b] = 0;
		++out[b];
		buf[i] = el (b, vec[a]);
		vec[a] = i;
	}

	static int q[MAXN], p3;
	for (int i = 0; i < N; ++i) if (start_from[i]) q[p3++] = i;
	for (int i = 0; i < p3; ++i) {
		int c = q[i];
		set (c, c);
		for (int j = vec[c]; j != -1; j = buf[j].next) {
			upd (buf[j].to, c);
			if (!(--out[buf[j].to])) q[p3++] = buf[j].to;
		}
	}

	int res = 0;
	for (int i = 0; i < N; ++i)
		for (int j = i + 1; j < N; ++j)
			if (!ask (i, j))
				++res;

	printf ("%d\n", res);

	return 0;
}
