/*
ID: iskren81
TASK: connect
LANG: C++

FROM: USACO OPEN 2007 Gold
PROB: connect
KEYW: mars index tree
*/

#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <algorithm>

const int MAXLEN = 1 << 10;
const int MAXN = 1 << 14;//16 000

struct srch_ret {
	bool can[2][2];
	srch_ret () {can[0][0] = can[0][1] = can[1][0] = can[1][1] = 0;}
	srch_ret (const srch_ret &a) {memcpy (can, a.can, sizeof (can));}
	srch_ret &operator = (const srch_ret &a) {memcpy (can, a.can, sizeof (can)); return *this;}
	srch_ret (bool a00, bool a01, bool a10, bool a11) {can[0][0] = a00, can[0][1] = a01, can[1][0] = a10, can[1][1] = a11;}
};

char line[MAXLEN];
int N;
bool links[MAXN][4];//0 means up, 1 means down, 2 means horizontal

int idt[MAXN][2][2];

int __sc;
srch_ret srch (int c1, int c2, int lc, int rc, int p) {
	++__sc;
//	printf ("srch %d %d [%d %d[ %d\n", c1, c2, lc, rc, p);
//	assert (rc - lc >= 2);
	if (c1 == c2) return srch_ret (1, links[c1][2], links[c1][2], 1);
	if (lc == c1 && rc - 1 == c2)
		return srch_ret (idt[p][0][0], idt[p][0][1], idt[p][1][0], idt[p][1][1]);
//	printf ("%d %d   %d %d -- %d\n", c1, c2, lc, rc, rc - lc);
//	assert (rc - lc > 2);

	int m = (lc + rc) / 2;
	if (c2 < m) {
		return srch (c1, c2, lc, m, p * 2 + 1);
	} else if (c1 >= m) {
		return srch (c1, c2, m, rc, p * 2 + 2);
	} else {
		srch_ret res,
		k1 = srch (c1, m-1, lc, m, p * 2 + 1),
		k2 = srch (m, c2, m, rc, p * 2 + 2);
		res.can[0][0] = k1.can[0][0] && k2.can[0][0] && links[m-1][0]
					 || k1.can[0][1] && k2.can[1][0] && links[m-1][1];
		res.can[0][1] = k1.can[0][0] && k2.can[0][1] && links[m-1][0]
					 || k1.can[0][1] && k2.can[1][1] && links[m-1][1];
		res.can[1][0] = k1.can[1][0] && k2.can[0][0] && links[m-1][0]
					 || k1.can[1][1] && k2.can[1][0] && links[m-1][1];
		res.can[1][1] = k1.can[1][0] && k2.can[0][1] && links[m-1][0]
					 || k1.can[1][1] && k2.can[1][1] && links[m-1][1];
//		printf ("ret[%d,%d[ %d %d %d %d\n", lc, rc, res.can[0][0], res.can[0][1], res.can[1][0], res.can[1][1]);
		return res;
	}
}

int __cc;
void change (int c1, int c2, int lc, int rc, int p) {
	++__cc;
//	printf ("change %d %d [%d %d[ %d\n", c1, c2, lc, rc, p);
	if (rc - lc == 2) {
		c1 = lc;
		c2 = rc - 1;
		idt[p][0][0] = links[c1][0] || links[c1][1] && links[c1][2] && links[c2][2];
		idt[p][0][1] = links[c1][0] && links[c2][2] || links[c1][2] && links[c1][1];
		idt[p][1][0] = links[c1][1] && links[c2][2] || links[c1][0] && links[c1][2];
		idt[p][1][1] = links[c1][1] || links[c1][0] && links[c1][2] && links[c2][2];
//		printf ("<--%d %d %d %d\n", idt[p][0][0], idt[p][0][1], idt[p][1][0], idt[p][1][1]);
		return;
	}

	int m = (lc + rc) / 2;
	if (c2 < m) change (c1, c2, lc, m, p * 2 + 1);
	else if (c1 >= m) change (c1, c2, m, rc, p * 2 + 2);

	idt[p][0][0] = idt[p*2+1][0][0] && idt[p*2+2][0][0] && links[m-1][0]
				|| idt[p*2+1][0][1] && idt[p*2+2][1][0] && links[m-1][1];
	idt[p][0][1] = idt[p*2+1][0][0] && idt[p*2+2][0][1] && links[m-1][0]
				|| idt[p*2+1][0][1] && idt[p*2+2][1][1] && links[m-1][1];
	idt[p][1][0] = idt[p*2+1][1][0] && idt[p*2+2][0][0] && links[m-1][0]
				|| idt[p*2+1][1][1] && idt[p*2+2][1][0] && links[m-1][1];
	idt[p][1][1] = idt[p*2+1][1][0] && idt[p*2+2][0][1] && links[m-1][0]
				|| idt[p*2+1][1][1] && idt[p*2+2][1][1] && links[m-1][1];
//	printf ("<-[%d %d[-%d %d %d %d\n", lc, rc, idt[p][0][0], idt[p][0][1], idt[p][1][0], idt[p][1][1]);
}

void trav (int lc, int rc, int p) {
	if (rc - lc > 2) {
		trav (lc, (lc + rc) / 2, p * 2 + 1);
		trav ((lc + rc) / 2, rc, p * 2 + 2);
	}
	if (rc <= 16) printf ("[%d, %d[  %d %d %d %d\n", lc, rc, idt[p][0][0], idt[p][0][1], idt[p][1][0], idt[p][1][1]);
}

int main () {
	FILE *in = fopen ("connect.in", "r");

	int Q;
	fscanf (in, "%d", &Q);
	int i;
	int r1, r2, c1, c2;
	for (i = 0; i < Q; ++i) {
		fscanf (in, "%d %d %d %d", &r1, &c1, &r2, &c2);
		--r1; --c1; --r2; --c2;
//		printf ("__%d %d %d %d\n", r1, c1, r2, c2);
		assert (r1 == r2 || c1 == c2);
		if (c1 > c2) {std::swap (r1, r2); std::swap (c1, c2);}

		if (c1 == c2) links[c1][2] = 1;
		else links[c1][r1] = 1;
		change (c1, c2, 0, MAXN, 0);
	}
	fclose (in);
//	trav (0, MAXN, 0);

	setlinebuf (stdout);
	for (;;) {
		fgets (line, 1000, stdin);
		if (line[0] == 'E') break;
		sscanf (line + 2, "%d %d %d %d", &r1, &c1, &r2, &c2);
		--r1, --c1, --r2, --c2;
		if (c1 > c2) {std::swap (r1, r2); std::swap (c1, c2);}

		switch (line[0]) {
			case 'O': if (c1 == c2) links[c1][2] = 1; else links[c1][r1] = 1;
//						__cc = 0;
						change (c1, c2, 0, MAXN, 0);
	//					fprintf (stderr, "cc %d\n", __cc);
						break;
			case 'C': if (c1 == c2) links[c1][2] = 0; else links[c1][r1] = 0; change (c1, c2, 0, MAXN, 0); break;
			case 'T':  // __sc = 0;
						srch_ret res = srch (c1, c2, 0, MAXN, 0);
//						fprintf (stderr, "sc %d\n", __sc);
						printf ("%s\n", res.can[r1][r2] ? "Y" : "N");
		}

//		trav (0, MAXN, 0);
	}

	return 0;
}
