/*
TASK:champs
LANG:C++
*/

#include <cstdio>
#include <cassert>

#include <algorithm>

const int MAXN = 1 << 15;
const long double eps = 1e-7;
#define MOD (1ll << 30) /*1 000 000 000ll*/
#define MOD2 (1ll << 60) /*1 000 000 000  000 000 000ll*/

struct el {
	int s;
	int r;
};

struct dr {
	long long a;
	long long b;
};

struct point {
	int x, y;
	point () {}
	point (int _x, int _y) : x (_x), y (_y) {}
};

int N, T;
el data[MAXN];
std::pair <point, point> vec[MAXN];

bool cmp (const el &a, const el &b) {
	return a.r != b.r ?
			a.r < b.r :
			a.s < b.s;
}

long long S (const point &a, const point &b, const point &c) {
	return (long long)(b.x - a.x) * (c.y - a.y) - (long long)(b.y - a.y) * (c.x - a.x);
}

dr makedr (int a, int b) {
	dr res;
	res.a = S (vec[a].first, vec[b].first, vec[b].second);
	res.b = res.a + S (vec[b].first, vec[a].second, vec[b].second);
	if (res.b < 0) {res.a = -res.a; res.b = -res.b;}
	return res;
}

void domul (long long A, long long B, std::pair <long long, long long> &p) {
	static long long a, b;
	a = A % MOD;
	A /= MOD;
	b = B % MOD;
	B /= MOD;

	p.second = a * b;
	p.first = A * B;
	p.second += (a * B % MOD) * MOD;
	p.second += (A * b % MOD) * MOD;
	p.first += a * B / MOD;
	p.first += A * b / MOD;
	p.first += p.second / MOD2;
	p.second %= MOD2;
}

int cmpX (dr a, dr b) {
	if (a.a == 0 && b.a == 0) return 0;
	if (a.a < 0 && b.a >= 0 || a.a <= 0 && b.a > 0) return -1;
	if (a.a > 0 && b.a <= 0 || a.a >= 0 && b.a < 0) return 1;

	static std::pair <long long, long long> mp1, mp2;
	domul (llabs (a.a), b.b, mp1);
	domul (a.b, llabs (b.a), mp2);

	if (a.a > 0) {
		if (mp1 == mp2) return 0;
		if (mp1 < mp2) return -1; else return 1;
	} else {
		if (mp1 == mp2) return 0;
		if (mp1 < mp2) return 1; else return -1;
	}
}

int main () {
//	freopen ("champs.in", "r", stdin);
//	freopen ("champs.out", "w", stdout);

	scanf ("%d %d", &N, &T);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &data[i].s, &data[i].r);

	std::sort (data, data + N, cmp);
	for (i = 0; i < N; ++i) {
		vec[i].first = point (0, data[i].s);
		vec[i].second = point (1, data[i].s + data[i].r);
	}

	int cs = data[0].s, cr = data[0].r, cres = 1, cid = 0;

	for (i = 1; i < N; ++i) {
		if (data[i].s > cs) {
			cs = data[i].s;
			cr = data[i].r;
			cid = i;
			cres = 1;
		} else if (data[i].s == cs) {
			++cres;
			if (cr <= data[i].r) {cr = data[i].r; cid = i;}
		}
	}

	int res = cres;

	int prev = cid;
	dr base; base.a = 0; base.b = 1;
	dr tdr;
	vec[N].first = point (T, 0);
	vec[N].second = point (T, 1);
	dr crnt;
//	int tcmp;
	long double res0, res2, res3;
	for (;;) {
		crnt.a = 1;//infinity
		crnt.b = 0;
		cid = -1;
		for (i = prev + 1; i < N; ++i) {
			tdr = makedr (prev, i);
			res0 = (long double)(tdr.a) / (tdr.b);
			res2 = (long double)(base.a) / (base.b);
//			printf ("%Lf %Lf\n", res0, res2);
//			if (cmpX (base, tdr) < 0) {
			if (res2 < res0) {
				res3 = (long double)(crnt.a) / (crnt.b);
//				tcmp = cmpX (tdr, crnt);
//				if (tcmp < 0) {
				if (res0 + eps < res3) {
					cid = i;
					cr = data[i].r;
					crnt = tdr;
					cres = 1;
//				} else if (tcmp == 0) {//equal
				} else if (res0 < res3 + eps)  {
					++cres;
					if (data[i].r >= cr) {cr = data[i].r; cid = i;}
				}
			}
		}

//		printf ("with %d %d\n", cid, cres);
		if (cid == -1) break;//nothing found
		res3 = (long double)(crnt.a) / (crnt.b);
		dr drx = makedr (cid, N);
		res2 = (long double)(drx.a) / (drx.b);
//		tcmp = cmpX (crnt, makedr (cid, N));
//		if (tcmp > 0) break;//AFTER the end
		if (res3 > res2 + eps) break;
		res += cres; cres = 0;
		base = makedr (cid, prev);
		prev = cid;
	}

	printf ("%d\n", res);

	return 0;
}

/*	long long a, b;
	scanf ("%Ld %Ld", &a, &b);
	std::pair <long long, long long> p;
	domul (a, b, p);
	printf ("%Ld %09Ld\n", p.first, p.second);
*/
