/*
TASK:champs
LANG:C++
*/

#include <cstdio>
#include <cassert>

#include <algorithm>
#include <utility>

const int MAXN = 1 << 15;
const long double eps = 1e-7;
#define MOD (1ll << 30) /*1 000 000 000ll*/
#define MOD2 (1ll << 60) /*1 000 000 000  000 000 000ll*/

struct el {
	int s;
	int r;
};

struct dr {
	long long a;
	long long b;
};

struct point {
	int x, y;
	point () {}
	point (int _x, int _y) : x (_x), y (_y) {}
};

int N, T;
el data[MAXN];
std::pair <point, point> vec[MAXN];

std::pair <double, int> stack[MAXN];

bool cmp (const el &a, const el &b) {
	return a.r != b.r ?
			a.r < b.r :
			a.s > b.s;
}

long long S (const point &a, const point &b, const point &c) {
	return (long long)(b.x - a.x) * (c.y - a.y) - (long long)(b.y - a.y) * (c.x - a.x);
}

double calcX (int a, int b) {
	static double res;
	return (res = S (vec[a].first, vec[b].first, vec[b].second)) / (res +  S (vec[b].first, vec[a].second, vec[b].second));
}
int main () {
//	freopen ("champs.in", "r", stdin);
//	freopen ("champs.out", "w", stdout);
	scanf ("%d %d", &N, &T);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &data[i].s, &data[i].r);

	std::sort (data, data + N, cmp);
	for (i = 0; i < N; ++i) {
		vec[i].first = point (0, data[i].s);
		vec[i].second = point (1, data[i].s + data[i].r);
	}

	int cs = data[0].s, cr = data[0].r, cres = 1, cid = 0;

	for (i = 1; i < N; ++i) {
		if (data[i].s > cs) {
			cs = data[i].s;
			cr = data[i].r;
			cid = i;
			cres = 1;
		} else if (data[i].s == cs) {
			++cres;
			if (cr <= data[i].r) {cr = data[i].r; cid = i;}
		}
	}

	int sp = 0;
	stack[sp++] = std::make_pair (0, 0);
	double nx = -100;
	for (i = 1; i < N; ++i) {
//		printf ("%d %d\n", data[i].s, data[i].r);
		if (data[i].r == data[i-1].r) {
//			printf ("here!\n");
			if (data[i].s == data[i-1].s && stack[sp-1].second == i-1) {
				stack[sp] = std::make_pair (stack[sp-1].first, i), ++sp;
//				printf ("push!\n");
			}
			continue;
		}

		while (sp) {
			nx = calcX (stack[sp-1].second, i);
			if (nx + eps < stack[sp-1].first)
				--sp;
			else
				break;
		}
		if (nx > T + eps) continue;
//		printf ("push %lf %d\n", nx >? 0, i);
		stack[sp++] = std::make_pair (nx >? 0, i);
	}

	printf ("%d\n", sp);

	return 0;
}

/*	long long a, b;
	scanf ("%Ld %Ld", &a, &b);
	std::pair <long long, long long> p;
	domul (a, b, p);
	printf ("%Ld %09Ld\n", p.first, p.second);
*/
