/*
TASK: lexicon
LANG: C++
KEYW: bfs
*/

#include <cstdio>
#include <queue>

const int MAXL = 1 << 11;
const int MAXW = 1 << 10;
const int MAXWLEN = 1 << 5;

struct el {
    int vp, wp, w;
    int len;
    el () {}
    el (int _vp, int _wp, int _w, int _len) : vp (_vp), wp (_wp), w (_w), len (_len) {}
};

int W, L;
char vec[MAXL];
char data[MAXW][MAXWLEN];

std::queue <el> fast;
std::queue <el> slow;
bool used[MAXL];

el pop () {
    static el ret;
    if (fast.empty ()) {
        ret = slow.front ();
        slow.pop ();
    } else {
        ret = fast.front ();
        fast.pop ();
    }
    return ret;
}

void push_all (int vp, int len) {
    for (int i = 0; i < W; ++i)
        fast.push (el (vp, 0, i, len));
}

int bfs () {
    int best_ans = L;
    push_all (0, 0);

    el crnt;
    for (;;) {
        if (fast.empty () && slow.empty ()) {
            break;
//            printf ("EMPTY!\n");
        }
        crnt = pop ();
//        printf ("%d %d %d %d(%s %s)\n", crnt.vp, crnt.w, crnt.wp, crnt.len, data[crnt.w] + crnt.wp, vec + crnt.vp);
        if (!data[crnt.w][crnt.wp]) {
            if (crnt.vp == L) return crnt.len;
            if (!used[crnt.vp]) {
                used[crnt.vp] = 1;
//                printf ("push all!\n");
                push_all (crnt.vp, crnt.len);
                best_ans <?= L - crnt.vp + crnt.len;
            }
        } else {
            if (crnt.vp == L) {
//                printf ("baad\n");
                continue;
            }
            if (data[crnt.w][crnt.wp] == vec[crnt.vp]) {
                fast.push (el (crnt.vp + 1, crnt.wp + 1, crnt.w, crnt.len));
//                printf ("fast!\n");
            } else {
                slow.push (el (crnt.vp + 1, crnt.wp, crnt.w, crnt.len + 1));
//                printf ("slow!\n");
            }
        }
    }

    return best_ans;
}

int main () {
    scanf ("%d %d\n", &W, &L);

    gets (vec);
    for (int i = 0; i < W; ++i)
        gets (data[i]);

    int res = bfs ();
    printf ("%d\n", res);

    return 0;
}

