/*
FROM: USACO section 2.4
ID: iskren81
PROB: camelot
LANG: C++
*/

#include <cstdio>
#include <limits>

const int MAXR = 40;
const int MAXC = 26;
const int MAXH = MAXR * MAXC;

struct pos {
	int r;
	int c;
	pos (int rr =0, int cc =0) : r (rr), c (cc) {}
	pos (const pos &a) : r (a.r), c (a.c) {}

	pos& operator += (const pos &a) {r += a.r; c += a.c; return *this;}
	pos& operator -= (const pos &a) {r -= a.r; c -= a.c; return *this;}

	pos operator + (const pos &a) {pos ret(*this); return (ret += a);}
	pos operator - (const pos &a) {pos ret(*this); return (ret -= a);}
};

/*
int difx[] = {-1, -2, -2, -1, 1, 2,  2,  1};
int dify[] = {-2, -1,  1,  2, 2, 1, -1, -2};
*/

int kdifr [] = {-1, -1, -1, 0, 1, 1,  1,  0};
int kdifc [] = {-1,  0,  1, 1, 1, 0, -1, -1};
int Kmoves = 8;

pos dif[] = {pos (-1, -2), pos (-2, -1), pos (-2, 1), pos (-1, 2), pos (1, 2), pos (2, 1), pos (2, -1), pos (1, -2)};
int Hmoves = 8;

int R, C, Hcnt;

int Kr, Kc;//king row, column
int hpos[MAXH][2];//horse positions
char hdist[MAXR][MAXC][MAXR][MAXC];

bool out_of_board (pos a) {
	return (a.r < 0 || a.r >= R ||
			a.c < 0 || a.c >= C);
}


pos queue[MAXH];
void bfs (int r, int c) {
//	printf ("in bfs %d %d\n", r, c);
	int p1 = 0, p2 = 1, p3 = 0, lvl =1;

	queue[p3++] = pos (r, c);
	hdist[r][c][r][c] = 0;

	int i, j;
	pos crnt;
	while (p1 != p2) {
		for (i = p1; i < p2; ++i) {
			crnt = queue[i];

			for (j = 0; j < Hmoves; ++j) {
				crnt += dif[j];
				if (out_of_board (crnt)) {
					crnt -= dif[j];
					continue;
				}

				if (hdist[r][c][crnt.r][crnt.c] > lvl) {
					hdist[r][c][crnt.r][crnt.c] = lvl;
					queue[p3++] = crnt;
				}

				crnt -= dif[j];
			}
		}

		p1 = p2;
		p2 = p3;
		++lvl;
	}
}

int dif_to_get_king (int h, int gpr, int gpc, int kr, int kc) {
	return	hdist[hpos[h][0]][hpos[h][1]][kr ][kc ] +
			hdist[kr        ][kc        ][gpr][gpc] -
			hdist[hpos[h][0]][hpos[h][1]][gpr][gpc];
}

int main () {
	FILE *in = fopen ("camelot.in", "r");

	char tmpc;
	int tmpi;
	fscanf (in, "%d %d\n", &R, &C);

	int i =0, j, ii, jj;
	while (fscanf (in, "%c %d%c", &tmpc, &tmpi) != EOF) {
//		printf ("%c %d scanned!\n", tmpc, tmpi);
		hpos[i][0] = tmpi - 1;
		hpos[i++][1] = tmpc - 'A';
	}
	fclose (in);

	Kr = hpos[0][0];
	Kc = hpos[0][1];
	hpos[0][0] = hpos[--i][0];
	hpos[0][1] = hpos[i][1];

	Hcnt = i;
/*
	printf ("king - %d %d\n", Kr, Kc);
	for (i = 0; i < Hcnt; ++i)
		printf ("%d %d\t", hpos[i][0], hpos[i][1]);
	printf ("\n");
*/
	for (i = 0; i < R; ++i)
		for (j = 0; j < C; ++j)	{
			for (ii = 0; ii < R; ++ii)
				for (jj = 0; jj < C; ++jj)
					hdist[i][j][ii][jj] = std::numeric_limits<char>::max ();
			bfs (i, j);
		}
/*
	for (i = 0; i < R; ++i)
		for (j = 0; j < C; ++j) {
			for (ii = 0; ii < R; ++ii) {
				for (jj = 0; jj < C; ++jj)
					printf ("%d ", hdist[i][j][ii][jj] + '0');
				printf ("\n");
			}
			printf ("\n");
		}
*/
	int cKr, cKc;
	int ANSWER = std::numeric_limits<int>::max ();
	int min, sum;

	for (i = 0; i < Kmoves; ++i) {
		cKr = Kr + kdifr[i];
		cKc = Kc + kdifc[i];
		if (out_of_board (pos (cKr, cKc))) continue;

		for (ii = 0; ii < R; ++ii)
			for (jj = 0; jj < C; ++jj) {//gathering point
				min = std::numeric_limits<char>::max ();
				sum = 0;
				for (j = 0; j < Hcnt; ++j) {
					sum += hdist[hpos[j][0]][hpos[j][1]][ii][jj];
					min = (min < (dif_to_get_king (j, ii, jj, cKr, cKc)) ?
						   min : (dif_to_get_king (j, ii, jj, cKr, cKc)));
				}
//				printf ("%d ", sum + min);
				if (ANSWER > sum + min)
					ANSWER = sum + min;
			}
	}
	++ANSWER;//the king made 1 move

	cKr = Kr;
	cKc = Kc;
	for (ii = 0; ii < R; ++ii)
		for (jj = 0; jj < C; ++jj) {//gathering point
			min = std::numeric_limits<char>::max ();
			sum = 0;
			for (j = 0; j < Hcnt; ++j) {
				sum += hdist[hpos[j][0]][hpos[j][1]][ii][jj];
				min = (min < (dif_to_get_king (j, ii, jj, cKr, cKc)) ?
					   min : (dif_to_get_king (j, ii, jj, cKr, cKc)));
			}

//			printf ("%d ", sum + min);
			if (ANSWER > sum + min)
				ANSWER = sum + min;
		}

// 	printf ("\n");

	FILE *out = fopen ("camelot.out", "w");
	fprintf (out, "%d\n", ANSWER);
	fclose (out);

	return 0;
}

