/*
ID: iskren81
PROB: friday
LANG: C++
*/

#include <cstdio>

int N;

bool leap (int y) {
	if (y % 4) return 0;
	if (!(y % 100) && y % 400) return 0;
	return 1;
}

int tell_days (int m, int y) {
	switch (m) {
		case 3: return 30;
		case 5: return 30;
		case 8: return 30;
		case 10: return 30;
		default: if (m != 1) return 31;		
	}

	return 28 + leap (y);
}

int main () {
	FILE *in = fopen ("friday.in", "r");
	fscanf (in, "%d", &N);
	fclose (in);

	int occ[7] = {0};
	int cday = 5;
	int i, j;
	for (i = 1900; i < 1900 + N; ++i)
		for (j = 0; j < 12; ++j) {
			++occ[cday];
			cday += tell_days (j, i);
			cday %= 7;
		}

	FILE *out = fopen ("friday.out", "w");
	fprintf (out, "%d %d", occ[5], occ[6]);
	for (i = 0; i < 5; ++i)
		fprintf (out, " %d", occ[i]);
	fprintf (out, "\n");
	fclose (out);

	return 0;
}
