/*
ID: iskren81
PROB: packrec
LANG: C++
*/

#include <cstdio>
#include <algorithm>

const int MAXRECS = 1 << 11;//very rough

struct rec {
	int x;
	int y;
	rec () {}
	rec (int xx, int yy) : x (xx), y (yy) {}
};

bool operator == (const rec &a, const rec &b) {return a.x == b.x && a.y == b.y;}
bool operator < (const rec &a, const rec &b) {return a.x < b.x;}

int max2 (int x, int y) {return (x > y ? x : y);}
int max3 (int x, int y, int z) {return (x > y ? (x > z ? x : z) : (y > z ? y : z));}
int max4 (int x, int y, int z, int t) {return (x > y ? (x > z ? (x > t ? x : t) : (z > t ? z : t)) : (y > z ? (y > t ? y : t) : (z > t ? z : t)));}

rec put1 (rec _1, rec _2, rec _3, rec _4) {
	return rec (_1.x + _2.x + _3.x + _4.x, max4 (_1.y, _2.y, _3.y, _4.y));
}

rec put2 (rec _1, rec _2, rec _3, rec _4) {
	return rec (max2 (_4.x, _1.x + _2.x + _3.x), max3 (_1.y, _2.y, _3.y) + _4.y);
}

rec put3 (rec _1, rec _2, rec _3, rec _4) {
	return rec (max2 (_1.x + _2.x, _4.x) + _3.x, max2 (max2 (_1.y, _2.y) + _4.y, _3.y));
}

rec put4 (rec _1, rec _2, rec _3, rec _4) {
	return rec (max2 (_1.x, _2.x) + _3.x + _4.x, max3 (_1.y + _2.y, _3.y, _4.y));
}

rec put5 (rec _1, rec _2, rec _3, rec _4) {
//	return rec (max2 (_1.x, _2.x) + max2 (_3.x, _4.x), max2 (_1.y + _2.y, _3.y + _4.y));
	rec ret(max2 (_1.x + _3.x, _2.x + _4.x), max2 (_1.y + _2.y, _3.y + _4.y));
	if (_1.x + _4.x > ret.x && _1.y + _4.y > ret.y)
		if (ret.y * (_1.x + _4.x - ret.x) < ret.x * (_1.y + _4.y - ret.y))
			ret.x = _1.x + _4.x; 
		else
			ret.y = _1.y + _4.y;
	
	if (_2.x + _3.x > ret.x && _2.y + _3.y > ret.y)
		if (ret.y * (_2.x + _3.x - ret.x) < ret.x * (_2.y + _3.y - ret.y))
			ret.x = _2.x + _3.x; 
		else
			ret.y = _2.y + _3.y;

	return ret;
}

int minS = 100 * 100;
rec mrecs[MAXRECS];
int mrp;

typedef rec puttype (rec, rec, rec, rec);
puttype *put[] = {&put1, &put2, &put3, &put4, &put5};

void put_all (rec _1, rec _2, rec _3, rec _4) {
//	printf ("(%d, %d) (%d, %d) (%d, %d) (%d, %d)\n", _1.x, _1.y, _2.x, _2.y, _3.x, _3.y, _4.x, _4.y);
	for (int i = 0; i < 5; ++i) {
		rec tmp = put[i] (_1, _2, _3, _4);

//		printf ("(%d, %d)\t", tmp.x, tmp.y);		
		if (tmp.x * tmp.y < minS) {
			minS = tmp.x * tmp.y;
			mrp = 0;
			mrecs[mrp++] = tmp;
		} else if (tmp.x * tmp.y == minS)
			mrecs[mrp++] = tmp;
	}
//	printf ("\n");
}

rec recs[4];

rec inv (rec a) {
	return rec (a.y, a.x);
}

int main () {
	FILE *in = fopen ("packrec.in", "r");

	int i;
	for (i = 0; i < 4; ++i)
		fscanf (in, "%d %d", &recs[i].x, &recs[i].y);
	fclose (in);
	
	int row[] = {0, 1, 2, 3};
	do {
		for (i = 0; i < 16; ++i)
			put_all (
						(i & 1 ? inv(recs[row[0]]) : recs[row[0]]),
						(i & 2 ? inv(recs[row[1]]) : recs[row[1]]),
						(i & 4 ? inv(recs[row[2]]) : recs[row[2]]),
						(i & 8 ? inv(recs[row[3]]) : recs[row[3]])
					);
	} while (std::next_permutation (row, row + 4));
	
//	printf ("minS == %d\n", minS);

	for (i = 0; i < mrp; ++i)
		if (mrecs[i].x > mrecs[i].y)
			mrecs[i] = inv (mrecs[i]);

	std::sort (mrecs, mrecs + mrp);
	mrp = std::unique (mrecs, mrecs + mrp) - mrecs;
	
	FILE *out = fopen ("packrec.out", "w");
	fprintf (out, "%d\n", mrecs[0].x * mrecs[0].y);
	for (i = 0; i < mrp; ++i)
		fprintf (out, "%d %d\n", mrecs[i].x, mrecs[i].y);
	fclose (out);

	return 0;
}
