/*
ID: iskren81
PROB: transform
LANG: C++
KEYW: easy
*/

#include <cstdio>

const int MAXN = 1 << 4;

bool base[MAXN][MAXN];
bool tr1[MAXN][MAXN];
bool tr2[MAXN][MAXN];
bool targ[MAXN][MAXN];

typedef void tr_cor (int, int, int &, int &);
int N;

void tr_cor0 (int x, int y, int &xx, int &yy) {
	xx = y;
	yy = N - 1 - x;
}

void tr_cor1 (int x, int y, int &xx, int &yy) {
	xx = N - 1 - x;
	yy = N - 1 - y;
}

void tr_cor2 (int x, int y, int &xx, int &yy) {
	xx = N-1-y;
	yy = x;
}

void tr_cor3 (int x, int y, int &xx, int &yy) {
	xx = x;
	yy = N-1-y;
}

tr_cor *tr_corX[] = {&tr_cor0, &tr_cor1, &tr_cor2, &tr_cor3};

bool equal1 () {
	for (int i = 0; i < N; ++i)
		for (int j = 0; j < N; ++j)
			if (targ[i][j] != tr1[i][j]) return 0;

	return 1;
}

bool equal2 () {
	for (int i = 0; i < N; ++i)
		for (int j = 0; j < N; ++j)
			if (targ[i][j] != tr2[i][j]) return 0;

	return 1;
}

bool equal3 () {
	for (int i = 0; i < N; ++i)
		for (int j = 0; j < N; ++j)
			if (targ[i][j] != base[i][j]) return 0;

	return 1;
}


int main () {
	FILE *in = fopen ("transform.in", "r");
	fscanf (in, "%d\n", &N);
	
	int i, j;
	char tmp;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j) {
			fscanf (in, "%c", &tmp);
			base[i][j] = (tmp == '-');
		}
		fscanf (in, "\n");
	}
	
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j) {
			fscanf (in, "%c", &tmp);
			targ[i][j] = (tmp == '-');
		}
		fscanf (in, "\n");
	}
	fclose (in);

	FILE *out = fopen ("transform.out", "w");

	int k, ii, jj;
	for (k = 0; k < 4; ++k) {
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j) {
				tr_corX[k] (i, j, ii, jj);
				tr1[ii][jj] = base[i][j];
			}

		if (equal1 ()) {
			fprintf (out, "%d\n", k + 1);
			goto end;
		}
	}
	
	for (k = 0; k < 3; ++k) {
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j) {
				tr_corX[k] (i, j, ii, jj);
				tr2[ii][jj] = tr1[i][j];
			}

		if (equal2 ()) {
			fprintf (out, "5\n");
			goto end;
	}
	}
	
	if (equal3 ()) {
		fprintf (out, "6\n");
		goto end;
	}
	
	
	fprintf (out, "7\n");
	
end:;
	fclose (out);

	return 0;
}
