#include <math.h>
#include <stdio.h>

#define mx 1024
#define in stdin;

FILE*fn;
typedef struct {double x,y;} point;
typedef struct {int a,b;} edge;
point p[mx];

//////////////
edge q[mx * 8];
int qin,qou;

int atq (edge a) {
	q[qin++] = a;
	return 0;
}

edge gfq (void) {
	return q[qou++];
}
//////////////
int ok[mx];
int ss[mx][mx];
double dist[mx][mx];
int q1,q2,q3,c1,c2,c3;

///////////////////////////////////////
double dist2 (point a, point b) {
	return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

point resize (point a, point b, double len) {
	double c1,c2,c3;
	point c;
	c.x=b.x-a.x;
	c.y=b.y-a.y;
	c1=dist2(a,b);
	c.x=c.x/c1*len;
	c.y=c.y/c1*len;
	c.x+=a.x;
	c.y+=a.y;
	return c;
}

point get2 (point a,point b,double ra,double rb) {
	double c1, c2, cosa, sina;
	point p1, p2, p3;
	c1 = dist2 (a, b);
	cosa = (ra * ra + c1 * c1 - rb * rb);
	cosa /= (2.0 * ra * c1);
	sina = sqrt (1.0 - cosa * cosa);
	p1.x = b.x - a.x;
	p1.y = b.y - a.y;

	p2.x = p1.x * cosa - p1.y * sina;
	p2.y = p1.x * sina + p1.y * cosa;

	p2.x += a.x;
	p2.y += a.y;
	p3 = resize (a, p2, ra);

	return p3;
}

double cosa(point a,point b,double ra,double rb) {
	double aa, bb, cc, c1;
	aa = rb;
	bb = ra;
	cc = dist2 (a, b);
	c1 = (cc * cc + bb * bb - aa * aa) / (2.0 * cc * bb);
	return c1;
}

///////////////////////////////
edge e1, e2;
point p1, p2;
int start, c;
double w1,w2,w3,w4;
int main () {
	fn=in;
	fscanf(fn,"%d %d %d",&c,&e1.a,&e1.b);
	e1.a--; e1.b--;
	start=e1.a;
	
	while (1) {
		if (fscanf (fn,"%d %d %lf", &c1, &c2, &w1) != 3) break;
		c1--; c2--;
		ss[c1][c2] = ss[c2][c1]=1;
		dist[c1][c2] = dist[c2][c1]=w1;
	}
	fclose (fn);
	
	p1.x = 0.0;
	p1.y = 0.0;
	p[e1.a] = p1;
	p1.x = dist[e1.a][e1.b];
	p1.y = 0.0;
	p[e1.b] = p1;
	ok[e1.a] = ok[e1.b]=1;
	atq (e1);
	ss[e1.a][e1.b]=0;

	while (qin != qou) {
		e1 = gfq();
		w3 = -19.0;
		c1 = -1;
		for (q1 = 0; q1 < c; q1++)
			if (ss[e1.a][q1] && ss[q1][e1.b]) {
				w2 = cosa(p[e1.a], p[e1.b], dist[e1.a][q1], dist[e1.b][q1]);
				if (w2 > w3) {
					w3 = w2;
					c1 = q1;
				}
			}
		
		if (c1 == -1) continue;
		p1 = get2(p[e1.a], p[e1.b], dist[e1.a][c1], dist[e1.b][c1]);

		if(!ok[c1]) {
			ok[c1] = 1;
			p[c1] = p1;
		}
		
		e2.a = e1.a;
		e2.b = c1;
		atq (e2);
		ss[e2.a][e2.b] = 0;
		e2.a = c1;
		e2.b = e1.b;
		atq (e2);
		ss[e2.a][e2.b] = 0;
	}

	for (q1 = 0; q1 < c; q1++)
		printf ("%.2lf\n", dist2 (p[start], p[q1]));

	return 0;
}
