/*
FROM: WINTER 2006 A
PROB: expres
KEYW: dynamical programming
*/

#include <cstdio>

char digs [12][5][4] =	{
							{
								"111",
								"101",
								"101",
								"101",
								"111"
							}, {
								"001",
								"001",
								"001",
								"001",
								"001"
							}, {
								"111",
								"001",
								"111",
								"100",
								"111"
							}, {
								"111",
								"001",
								"111",
								"001",
								"111"
							}, {
								"101",
								"101",
								"111",
								"001",
								"001"
							}, {
								"111",
								"100",
								"111",
								"001",
								"111"
							}, {
								"111",
								"100",
								"111",
								"101",
								"111"
							}, {
								"111",
								"001",
								"001",
								"001",
								"001"
							}, {
								"111",
								"101",
								"111",
								"101",
								"111"
							}, {
								"111",
								"101",
								"111",
								"001",
								"111"
							}, {
								"000",
								"010",
								"111",
								"010",
								"000"
							}, {
								"000",
								"000",
								"111",
								"000",
								"000"
							}
						};

//********************************/
//********************************/
//********************************/

const int MAXN = 1 << 6;
const int MAXK = 1 << 6;
const int MAXBAL = 1 << 6;//add BASEBAL to negative values
const int BASEBAL = 1 << 5;

char input[5][1 << 8];
char output[5][1 << 8];

int N, K;
int vec1[MAXN];
int vec2[MAXN];

int bal[10][10];
int k[10][10];

void precomp () {
	int ii, jj;
	int j, k;
	for (ii = 0; ii < 10; ++ii)
		for (jj = 0; jj < 10; ++jj)
			for (j = 0; j < 5; ++j)
				for (k = 0; k < 3; ++k)
					if (digs[ii][j][k] != digs[jj][j][k]) {
						::k[ii][jj] += 1;
						bal[ii][jj] += (digs[ii][j][k] == '1' ? 1 : -1);
					}
}

const int neg_infinity = -1000;

int opt[MAXN][MAXBAL][MAXK];
int prev1[MAXN][MAXBAL][MAXK];
int prev2[MAXN][MAXBAL][MAXK];

void fill_ninf () {
	for (int i = 0; i < MAXN; ++i)
		for (int j = 0; j < MAXBAL; ++j)
			for (int k = 0; k < MAXK; ++k)
				opt[i][j][k] = neg_infinity;
}

int main () {
	int i, j, k;

	scanf ("%d %d\n", &N, &K);
	for (i = 0; i < 5; ++i)
		gets (input[i]);

	int ii;
	for (ii = 0; ii < N; ++ii) {
		vec1[ii] = -1;
		for (i = 0; i < 10; ++i) {
			for (j = 0; j < 5; ++j)
				for (k = 0; k < 3; ++k)
					if (input[j][ii * 6 + k] != digs[i][j][k]) goto ext1;

			ext1:;
			if (k == 3) {
				vec1[ii] = i;
				break;
			}
		}
	}

	for (ii = 1; ii < N; ++ii) {
		vec2[ii] = -1;
		for (i = 10; i < 12; ++i) {
			for (j = 0; j < 5; ++j)
				for (k = 0; k < 3; ++k)
					if (input[j][ii * 6 - 3 + k] != digs[i][j][k]) goto ext2;

			ext2:;
			if (k == 3) {
				vec2[ii] = i - 10;
				break;
			}
		}
	}

	precomp ();
	fill_ninf ();

	opt[0][BASEBAL][0] = 0;
	int kkk, bbal;
	for (i = 0; i < N; ++i)
		for (j = BASEBAL - K / 2; j <= BASEBAL + K / 2; ++j)
			for (k = 0; k <= K; ++k) {
				if (opt[i][j][k] == neg_infinity) continue;

				for (int c = 0; c < 10; ++c) {
					if (opt[i + 1][j + bal[vec1[i]][c]][k + ::k[vec1[i]][c]] < opt[i][j][k] + (vec2[i] ? -c : c)) {
						opt[i + 1][j + bal[vec1[i]][c]][k + ::k[vec1[i]][c]] = opt[i][j][k] + (vec2[i] ? -c : c);
						prev1[i + 1][j + bal[vec1[i]][c]][k + ::k[vec1[i]][c]] = c;
						prev2[i + 1][j + bal[vec1[i]][c]][k + ::k[vec1[i]][c]] = 0;
					}
				}

				if (i != 0) {//change sign
					if (vec2[i]) {
						kkk = 2;
						bbal = -2;
					} else {
						kkk = 2;
						bbal = 2;
					}
					for (int c = 0; c < 10; ++c) {
						if (opt[i + 1][j + bbal + bal[vec1[i]][c]][k + kkk + ::k[vec1[i]][c]] < opt[i][j][k] + (vec2[i] ? c : -c))
							opt[i + 1][j + bbal + bal[vec1[i]][c]][k + kkk + ::k[vec1[i]][c]] = opt[i][j][k] + (vec2[i] ? c : -c);
							prev1[i + 1][j + bbal + bal[vec1[i]][c]][k + kkk + ::k[vec1[i]][c]] = c;
							prev2[i + 1][j + bbal + bal[vec1[i]][c]][k + kkk + ::k[vec1[i]][c]] = 1;
					}
				}
			}
	int max = neg_infinity;
	int maxi;

	for (i = 0; i <= K; ++i)
		if (max < opt[N][BASEBAL][i]) {
			max = opt[N][BASEBAL][i];
			maxi = i;
		}

	int ni, nj, nk;
	for (i = N, j = BASEBAL, k = maxi; i > 0; i = ni, j = nj, k = nk) {
		ni = i-1;
		nj = j - bal[vec1[ni]][prev1[i][j][k]] - (prev2[i][j][k] ? vec2[ni] ? -2 : 2 : 0);
		nk = k - ::k[vec1[ni]][prev1[i][j][k]] - (prev2[i][j][k] ? 2 : 0);
		vec1[ni] = prev1[i][j][k];
		vec2[ni] = (prev2[i][j][k] ? !vec2[ni] : vec2[ni]);
	}

	printf ("%d\n", max);
	for (i = 0; i < N; ++i)
		for (j = 0; j < 5; ++j)
			for (k = 0; k < 3; ++k)
				output[j][i * 6 + k] = digs[vec1[i]][j][k];
	for (i = 1; i < N; ++i)
		for (j = 0; j < 5; ++j)
			for (k = 0; k < 3; ++k)
				output[j][i * 6 - 3 + k] = digs[vec2[i] + 10][j][k];

	for (i = 0; i < 5; ++i) {
		output[i][N * 6 - 3] = 0;
		puts (output[i]);
	}

	return 0;
}
