/*
FROM: WINTER 2006 A
PROB: fest
KEYW: full index tree (mars index tree), coordinate compression, binary search
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <utility>
#include <algorithm>

using std::make_pair;

const int MAXI = 1 << 18;//200 000
const int MAXC = 1 << 18;//200 000
const int INFC = 1 << 27;//10 ^ 8 infinitive coordinate 
const long long INF_ANS = 1ll << 62;

struct node {
	int tot;
	long long gl, gr;
	node () {}
	node (int _tot, long long _gl, long long _gr) : tot (_tot), gl (_gl), gr (_gr) {}
};

int X[MAXC], xp;
node idt[MAXC * 2];
int inp_c;
std::pair <int, long long> input[MAXI];

void add (int lb, int rb, int pos, int val, int p) {
//	printf ("add (%d) %d %d\n", p, lb, rb);
	if (lb + 1 == rb) {
		assert (lb == pos);
		idt[p].tot += val;
		assert (!idt[p].gl);
		idt[p].gr = (long long)(idt[p].tot) * (long long)(X[rb] - X[lb]);
//		printf ("%d -!!-> %d %Ld %Ld\n", p, idt[p].tot, idt[p].gl, idt[p].gr);
		return;
	}

	int m = (lb + rb) / 2;
	if (pos < m) add (lb, m, pos, val, p * 2 + 1);
	else add (m, rb, pos, val, p * 2 + 2);

	idt[p].tot = idt[p*2+1].tot + idt[p*2+2].tot;
	idt[p].gl = idt[p*2+1].gl + idt[p*2+2].gl + (long long)(idt[p*2+2].tot) * (long long)(X[m] - X[lb]);
	idt[p].gr = idt[p*2+1].gr + idt[p*2+2].gr + (long long)(idt[p*2+1].tot) * (long long)(X[rb] - X[m]);
//	printf ("%d --> %d %Ld %Ld\n", p, idt[p].tot, idt[p].gl, idt[p].gr);
}


#define GO_RIGHT 	{_tpl += idt[p*2+1].gr + (long long)_tl * (X[m] - X[lb]);\
					 _tl += idt[p*2+1].tot;\
					 srch (m, rb, s, p * 2 + 2, t);}
#define GO_LEFT		{_tpr += idt[p*2+2].gl + (long long)_tr * (X[rb] - X[m]);\
					 _tr += idt[p*2+2].tot;\
					 srch (lb, m, s, p * 2 + 1, t);}
#define FX			(lpp + (long long)(_tl - _tr) * (m - X[lb]))
#define TRY_UPD		{if (llabs (FX - s) < llabs (_ans - s)) {_ans = FX; _ans_id = m;}}

long long _tpl, _tpr;//total pay left, total pay right
int _tl, _tr;//total left (persons), total right (persons)
int _ans_id;
long long _ans;
void _sgsv () {_tpl = _tpr = _tl = _tr = 0;}//set global search variables
void srch (int lb, int rb, long long s, int p, int t) {
//	printf ("srch %d - %d %d - %Ld %Ld %d %d\n", p, lb, rb, _tpl, _tpr, _tl, _tr);
	if (lb + 1 == rb) {
		_tl += idt[p].tot;
		
//		printf ("FIN srch %d - %d %d - %Ld %Ld %d %d\n", p, lb, rb, _tpl, _tpr, _tl, _tr);
		if ((_tr - _tl) * t > 0) {
//			printf ("go away!\n");
			return;
		}
		long long lpp = _tpl + _tpr + (long long)_tr * (X[rb] - X[lb]);
//		printf ("\t%Ld\n", lpp);
		int l = X[lb], r = X[rb], m;
		while (l + 1 < r) {
			m = (l + r) / 2;
//			printf ("\t\tm == %d --> %Ld\n", m, FX);
			if ((FX > s) ^ (t == 1))
				l = m;
			else
				r = m;
		}
//		printf ("\tl,r %d %d\n", l, r);
		m = l; TRY_UPD;
		m = r; TRY_UPD;

		#warning - binary search in [lb, rb[
		return;
	}

	int m = (lb + rb) / 2;
	long long mid_pay = idt[p*2+1].gr + idt[p*2+2].gl
			 + _tpl + _tpr
			 + (long long)_tl * (X[m] - X[lb])
			 + (long long)_tr * (X[rb] - X[m]);
//	long long diff = (long long)(X[m] - X[m-1]) * (idt[p*2+2].tot - idt[p*2+1].tot);

/*	printf (">> %Ld %Ld %Ld --> %Ld\n"\
			"<< %Ld %Ld %Ld --> %Ld\n",\
			 _tpl , idt[p*2+1].gr,	idt[p*2+1].gr + (long long)_tl * (X[m] - X[lb]),\
			_tpl +  idt[p*2+1].gr +	idt[p*2+1].gr + (long long)_tl * (X[m] - X[lb]),\
			_tpr, idt[p*2+2].gl, (long long)_tr * (X[rb] - X[m]),\
			_tpr + idt[p*2+2].gl + (long long)_tr * (X[rb] - X[m]));*/

	if ((idt[p*2+2].tot + _tr - idt[p*2+1].tot - _tl) * t < 0) {//good
		if ((s > mid_pay) ^ (t == 1))
			GO_LEFT
		else
			GO_RIGHT
	} else {//baad
		if (t == 1)
			GO_RIGHT
		else
			GO_LEFT
	}
}

int main () {
	int type, a, b;
	long long s;
	while (scanf ("%d", &type) == 1) {
		if (type == 1) {//add
			scanf ("%d %d", &a, &b);
			input[inp_c++] = make_pair (a, (long long)b);
			X[xp++] = a;
		} else {//search
			scanf ("%Ld", &s);
			input[inp_c++] = make_pair (-1, s);
		}
	}

	X[xp++] = -INFC;
	X[xp++] = INFC;
	std::sort (X, X + xp);
	xp = std::unique (X, X + xp) - X;
	#warning vnimavai s --xp
	--xp;//because the last index will be X[xp] -> one after the end

//	for (int i = 0; i < xp; ++i) printf ("%d ", X[i]); printf ("\n");
	for (int i = 0; i < inp_c; ++i) {
		if (input[i].first != -1) {//add
//			printf ("____ADD____ %ld %d\n", std::lower_bound (X, X + xp, input[i].first) - X, (int)input[i].second);
			add (0, xp, std::lower_bound (X, X + xp, input[i].first) - X, (int)input[i].second, 0);
		} else {//search
//			printf ("___SRCH____ %Ld\n", input[i].second);
			_ans = INF_ANS;
			_sgsv (); srch (0, xp, input[i].second, 0, -1);//search in the left part
			_sgsv (); srch (0, xp, input[i].second, 0,  1);//search in the right part
			printf ("%d %Ld\n", _ans_id, llabs (_ans - input[i].second));
		}
	}

	return 0;
}
