/*
FROM: WINTER 2007 A
PROB: colxor
KEYW: xor, intervals, sweep line
*/

#include <cstdio>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 10;
const int MAXR = 1 << 10;

short N, R;
short coor[MAXN][2];
std::pair <short, short> ends[MAXN * MAXR * 4];
int ep;

int main () {
	scanf ("%hd %hd", &N, &R);
	int Rsq = (int)R * R;

	short i, j;
	for (i = 0; i < N; ++i)
		scanf ("%hd %hd", coor[i], coor[i] + 1);

	short cd = 0;
	for (i = 1; i <= R; ++i) {
		while ((int)cd * cd + (R - i) * (R - i) < Rsq) ++cd;
		for (j = 0; j < N; ++j) {
			ends[ep++] = std::make_pair (coor[j][1] - (R - i) - 1, coor[j][0] - cd);
			ends[ep++] = std::make_pair (coor[j][1] - (R - i) - 1, coor[j][0] + cd);
			ends[ep++] = std::make_pair (coor[j][1] + (R - i)    , coor[j][0] - cd);
			ends[ep++] = std::make_pair (coor[j][1] + (R - i)    , coor[j][0] + cd);
		}
	}

	std::sort (ends, ends + ep);
	int sum = 0;
	for (int ii = 1; ii < ep; ii += 2)
		sum += ends[ii].second - ends[ii-1].second;
	printf ("%d\n", sum);

	return 0;
}
