/*
FROM: 2005 k1
PROB: fuzzy
KEYW: ad-hoc
*/

#include <cstdio>
#include <cassert>
#include <cmath>

const int MAXN = 1 << 13;
const long double epsilon = 1e-9;

int N;
long double vec[MAXN];
long double S;
long double AVR;

int K;
long double t1[MAXN];
long double t2[MAXN];
long double _r[MAXN];


int bK;
long double bV;
long double _br[MAXN];

long double *r = _r, *br = _br;

long double ans[MAXN];

inline int mod (int id) {return id % N;}

inline long double sq (long double a) {return a * a;}

inline void _try (long double V) {
//	int i;
//	long double V = 0;
//	for (i = 0; i < N; ++i) if (r[i] < -epsilon) return;//there is negative ai
//	for (i = 0; i < N; ++i) V += sq (r[i]);
	if (V > bV) {
		bV = V;
		bK = K;
//		for (i = 0; i < N; ++i) br[i] = r[i];
		long double *tmp = r;
		r = br;
		br = tmp;
	}
}

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i) {
		scanf ("%Lf", vec + i);
		S += vec[i];
	}
	AVR = S / N;

	int P;
	long double W;
	long double V;
	int __t;
	for (K = 0; (P = 2 * K + 1) < N; ++K) {
		for (j = 0; j < N; ++j)
			t1[j] = (vec[__t = mod (j * P + K)] - vec[++__t == N ? 0 : __t]) * P;

		t2[0] = t1[0];

		for (j = 1; j < N; ++j)
			t2[j] = t2[j-1] + t1[j];

		assert (fabs (t2[N-1]) < epsilon);
		W = 0;
		for (j = 0; j < N; ++j)
			W += t2[j];

		r[0] = (W + S) / N;
		V = 0;
		for (j = 0; j < N-1; ++j) {
			V += sq (r[j+1] = -t2[j] + r[0]);
			if (r[j+1] < -epsilon) break;
		}
		if (j == N - 1) _try (V);
	}

	printf ("%d\n", bK);
	ans[0] = br[0];
	P = 2 * bK + 1;
	for (j = 1; j < N; ++j)
		ans[mod (j * P)] = br[j];

	printf ("%.3Lf", ans[0]);
	for (i = 1; i < N; ++i) printf (" %.3Lf", ans[i]); printf ("\n");

	return 0;
}
